C***********************************************************************
C
C    Copyright (c) 2015, Lawrence Livermore National Security, LLC.
c                        Produced at the Lawrence Livermore National
C                        Laboratory.
C                        Written by Nicolas Schunck, schunck1@llnl.gov
C
C    LLNL-CODE-470611 All rights reserved.
C
C    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
C                    W. Satula, J.A. Sheikh, A. Staszczak,
C                    M. Stoitsov, P. Toivanen
C    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
C                    P. Olbratowski, P. Powalowski, M. Sadziak,
C                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
C                    M. Zalewski, H. Zdunczuk
C    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
C    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
C
C    This file is part of HFODD.
C
C    HFODD is free software: you can redistribute it and/or modify it
C    under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    HFODD is distributed in the hope that it will be useful, but
C    WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
C
C    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
C    LICENSE
C
C    Our Preamble Notice
C
C      A. This notice is required to be provided under our contract
C         with the U.S. Department of Energy (DOE). This work was
c         produced at the Lawrence Livermore National Laboratory under
c         Contract No. DE-AC52-07NA27344 with the DOE.
C      B. Neither the United States Government nor Lawrence Livermore
C         National Security, LLC nor any of their employees, makes any
c         warranty, express or implied, or assumes any liability or
c         responsibility for the accuracy, completeness, or usefulness
c         of any information, apparatus, product, or process disclosed,
C         or represents that its use would not infringe privately-owned
c         rights.
C      C. Also, reference herein to any specific commercial products,
C         process, or services by trade name, trademark, manufacturer
C         or otherwise does not necessarily constitute or imply its
C         endorsement, recommendation, or favoring by the United States
C         Government or Lawrence Livermore National Security, LLC. The
c         views and opinions of authors expressed herein do not
C         necessarily state or reflect those of the United States
c         Government or Lawrence Livermore National Security, LLC, and
c         shall not be used for advertising or product endorsement
c         purposes.
C
C    The precise terms and conditions for copying, distribution and
C    modification are contained in the file COPYING.
C
C***********************************************************************

C----------------------------------------------------------------------!
C                                                                      !
C                Shell correction code for HFODD                       !
C                                                                      !
C Authors: N. Schunck, ORNL                                            !
C                                                                      !
C This module computes the shell correction based on the s.p. spectrum !
C generated in HFODD.                                                  !
C                                                                      !
C                          First included in official release v249h    !
C                                                                      !
C----------------------------------------------------------------------!

      SUBROUTINE Set_version_hfodd_shell
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(8) = 'hfodd_shell     '
      MODUVE(8) = 6
      MODSET(8) = 8
      !
      END SUBROUTINE Set_version_hfodd_shell
      !
C=======================================================================
C     WSHELL  WSHELL  WSHELL  WSHELL   WSHELL  WSHELL  WSHELL  WSHELL
C=======================================================================
C                                    N. Schunck, ORNL,       2008-2010
C                                    J. Dudek,   Strasbourg,      2000
C=======================================================================
C
      SUBROUTINE HFINPU(IFSHEL,MREVER,IPAHFB,IMFHFB,NDACTU,ESINPP,
     *                  ESINPN,EGAS_P,EGAS_N,OCCU_P,OCCU_N,EFERMP,
     *                                                     EFERMN)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          NSTATE(1:2*NDACTU)
      DIMENSION
     *          ESINPP(1:2*NDACTU),ESINPN(1:2*NDACTU),
     *          EGAS_P(1:2*NDACTU),EGAS_N(1:2*NDACTU),
     *          OCCU_P(1:2*NDACTU),OCCU_N(1:2*NDACTU)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FER_IS/ FERMFN(1:NDBASE,0:NDISOS)
      COMMON
     *       /T_FLAG/ IFTEMP
      COMMON
     *       /GCTEMP/ TEMP_T
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /EQUISO/ ESPEQU(1:NDBASE,0:NDREVE,0:NDISOS),
     *                DELEQU(1:NDBASE,0:NDREVE,0:NDISOS)
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /KIN_SP/ SPGASP(1:2*NDBASE),SPGASN(1:2*NDBASE)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
C
      COMMON
     *       /WSHELL_KRAMER/ KRAMER
      COMMON
     *       /WSHELL_BASSIZ/ LDBASN,LDBASP
C
C=======================================================================
C
C      Interface between HFODD and the shell correction routines.
C      Single-particle energies
C
C      HFODD inputs
C         MREVER ..........: Flag for time-reversal symmetry
C         IPAHFB ..........: Flag for HFB versus HF calculations
C         IFTEMP ..........: Flag for temperature
C         NDACTU ..........: Static size of the s.p. arrays (should be NDBASE)
C         SPENER ..........: HF single-particle energies or HFB canonical
C                            spectrum
C         ESPEQU ..........: HFB equivalent spectrum
C         SPGASP, SPGASN ..: Eigenvalues of the Fermi free gas (proton
C                            and neutrons differ by the contribution
C                            from Coulomb)
C
C      Outputs
C         ESINPP, ESINPN ..: Protons and neutrons single-particle
C                            energies
C         EGAS_P, EGAS_N ..: Eigenvalues of the free gas
C         OCCU_P, OCCU_N ..: Statistical occupation of s.p. states
C         KRAMER ..........: Equivalent of MREVER, contains info on
C                            time-reversal symmetry
C
C      Conventions
C       - MREVER=0: time-reversal symmetry conserved, Kramers degeneracy
C                   applies, only first half of all HF s.p. needed
C       - MREVER=1: time-reversal symmetry broken, no Kramers degeneracy
C                   full eigenvector is needed
C
C=======================================================================
C
      IF (NDBASE.NE.NDACTU) THEN
          WRITE(6,'(''NDBASE = '',I6,'' NDACTU = '',I6)')
     *                NDBASE,NDACTU
          STOP 'NDBASE .NE. NDACTU in HFINPU - WSHELL'
      END IF
C
C      KRAMER=1 for conserved time-reversal symmetry (MREVER=0)
C      KRAMER=0 for  broken   time-reversal symmetry (MREVER=1)
      KRAMER=1-MREVER
C
C      Sizes based on HF spectrum or HFB canonical spectrum
      IF (IPAHFB.EQ.0.OR.(IPAHFB.EQ.1.AND.IMFHFB.EQ.1)) THEN
      LDBASN=NUMBSP(0,0)+MREVER*NUMBSP(1,0)
      LDBASP=NUMBSP(0,1)+MREVER*NUMBSP(1,1)
      END IF
C
C      Sizes based on HFB equivalent spectrum
      IF (IPAHFB.EQ.1.AND.IMFHFB.EQ.0) THEN
          LDBASN=NUMBQP(0,0)+MREVER*NUMBQP(1,0)
          LDBASP=NUMBQP(0,1)+MREVER*NUMBQP(1,1)
      END IF
C
      IF (LDBASN.GT.NDACTU.OR.LDBASP.GT.NDACTU) THEN
          WRITE(6,'(''LDBASN = '',I6,'' LDBASP = '',I6,
     *              '' NDACTU = '',i6)')
     *                LDBASN,LDBASP,NDACTU
          STOP 'NUMBSP VERSUS NDACTU in HFINPU - WSHELL'
      END IF
C
C      Repackaging HF s.p. states into vectors ESINPP and ESINPN
C
      IF (IPAHFB.EQ.1.AND.IMFHFB.EQ.0) THEN
C
          ISTATE=0
          DO IREVER=0,MREVER
             DO I=1,NUMBQP(IREVER,0)
                ISTATE=ISTATE+1
                NSTATE(ISTATE)=ISTATE
                ESINPN(ISTATE)=ESPEQU(I,IREVER,0)
             END DO
          END DO
C
          CALL ORDER1(ESINPN,NSTATE,ISTATE)
C
          DO I=1,ISTATE
             EEQUIV=ESINPN(I)-EFERMN
             OCCU_N(I)=0.5D0*(1.0D0-TANH(EEQUIV/TEMP_T/2.0D0))
          END DO
C
          ISTATE=0
          DO IREVER=0,MREVER
             DO I=1,NUMBQP(IREVER,1)
                ISTATE=ISTATE+1
                NSTATE(ISTATE)=ISTATE
                ESINPP(ISTATE)=ESPEQU(I,IREVER,1)
             END DO
          END DO
C
          CALL ORDER1(ESINPP,NSTATE,ISTATE)
C
          DO I=1,ISTATE
             EEQUIV=ESINPP(I)-EFERMP
             OCCU_P(I)=0.5D0*(1.0D0-TANH(EEQUIV/TEMP_T/2.0D0))
          END DO
C
      END IF
C
      IF (IPAHFB.EQ.0.OR.(IPAHFB.EQ.1.AND.IMFHFB.EQ.1)) THEN
C
      ISTATE=0
      DO IREVER=0,MREVER
         DO I=1,NUMBSP(IREVER,0)
            ISTATE=ISTATE+1
            NSTATE(ISTATE)=ISTATE
            ESINPN(ISTATE)=SPENER(I+IREVER*NUMBSP(0,0),0)
         END DO
      END DO
C
      CALL ORDER1(ESINPN,NSTATE,ISTATE)
C
          DO I=1,ISTATE
             EEQUIV=ESINPN(I)-EFERMN
             OCCU_N(I)=0.5D0*(1.0D0-TANH(EEQUIV/TEMP_T/2.0D0))
          END DO
C
      ISTATE=0
      DO IREVER=0,MREVER
         DO I=1,NUMBSP(IREVER,1)
            ISTATE=ISTATE+1
            NSTATE(ISTATE)=ISTATE
            ESINPP(ISTATE)=SPENER(I+IREVER*NUMBSP(0,1),1)
         END DO
      END DO
C
      CALL ORDER1(ESINPP,NSTATE,ISTATE)
C
          DO I=1,ISTATE
             EEQUIV=ESINPP(I)-EFERMP
             OCCU_P(I)=0.5D0*(1.0D0-TANH(EEQUIV/TEMP_T/2.0D0))
          END DO
C
      END IF
C
C      Repackaging eigenvalues of the free gas into vectors EGAS_P and
C      EGAS_N.
C
      IF (IFSHEL.EQ.2) THEN
C
          ISTATE=0
          DO IREVER=0,MREVER
             DO I=1,NUMBSP(IREVER,0)
                ISTATE=ISTATE+1
                NSTATE(ISTATE)=ISTATE
                EGAS_N(ISTATE)=SPGASN(ISTATE)
             END DO
          END DO
C
          CALL ORDER1(EGAS_N,NSTATE,ISTATE)
C
          ISTATE=0
          DO IREVER=0,MREVER
             DO I=1,NUMBSP(IREVER,1)
                ISTATE=ISTATE+1
                NSTATE(ISTATE)=ISTATE
                EGAS_P(ISTATE)=SPGASP(ISTATE)
             END DO
          END DO
C
          CALL ORDER1(EGAS_P,NSTATE,ISTATE)
C
      END IF
C
C=======================================================================

      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WSHELL(IN_FIX,IZ_FIX,IFSHEL,MREVER,IPAHFB,IMFHFB,
     *                  IZ_LOW,NOSTPZ,IZSTEP,IN_LOW,NOSTPN,INSTEP,
     *                         IZNUCL,INNUCL,LDNUCL,DSHELP,DSHELN,
     *                                       EFERMP,EFERMN,NDACTU)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          ESINPP(1:2*NDACTU),ESINPN(1:2*NDACTU),
     *          EGAS_P(1:2*NDACTU),EGAS_N(1:2*NDACTU),
     *          OCCU_P(1:2*NDACTU),OCCU_N(1:2*NDACTU)
      DIMENSION
     *          ENCUTP(1:NDNUCL),ENCUTN(1:NDNUCL),
     *          NBCUTP(1:NDNUCL),NBCUTN(1:NDNUCL)
      DIMENSION
     *          IZNUCL(1:NDNUCL),INNUCL(1:NDNUCL)
      DIMENSION
     *          DSHELP(1:NDNUCL),DSHELN(1:NDNUCL),
     *          STRUTP(1:NDNUCL),STRUTN(1:NDNUCL)
C
      COMMON
     *       /STRUTI_PARAMS/ GSTRUN,GSTRUP,HOMFAC,EPSRTN
     *       /STRUTI_POLYNO/ NPOLYN
C
      COMMON
     *       /WSHELL_RES_WS/ ESINGP(1:2*NDBASE),
     *                       EGASSP(1:2*NDBASE),
     *                       OCCUPA(1:2*NDBASE)
      COMMON
     *       /WSHELL_BASSIZ/ LDBASN,LDBASP
      COMMON
     *       /WSHELL_DIMENS/ LDBASE
     *       /WSHELL_KRAMER/ KRAMER
      COMMON
     *       /WSHELL_STRUTP/ MPOLYN
C
C=======================================================================
C
C       IZ_FIX,IN_FIX .......: number of protons and neutrons
C       IFSHEL ..............: traditional (=1) or extended (=2) shell
C                              correction
C       MREVER ..............: contains info on time-reversal symmetry
C                              (1: broken, 0: conserved)
C       ISIMPY ..............: contains info on simplex symmetry
C                              (1: conserved, 0: broken)
C       IMFHFB ..............: activates HFB canonical mean-field
C       IZ_LOW,NOSTPZ,IZSTEP : mesh of the proton numbers for which shell
C                              correction will be computed (lower bound,
C                              number of points, stepsize)
C       IN_LOW,NOSTPN,INSTEP : same as above for neutrons
C       IZNUCL,INNUCL,LDNUCL : arrays storing the proton and neutron numbers
C                              on their respective mesh. LDNUCL is the size
C                              of the mesh.
C       DSHELP,DSHELN  ......: arrays (of size NDNUCL) containing proton
C                              and neutron shell correction
C       NDACTU ..............: alias for HFODD static size NDBASE
C
C=======================================================================
C
      CALL CPUTIM('WSHELL',1)
C
C=======================================================================
C
      KRAMER=1
      MPOLYN=NPOLYN
C
C      Converting HFODD inputs into usable arrays
C
      CALL HFINPU(IFSHEL,MREVER,IPAHFB,IMFHFB,NDACTU,ESINPP,ESINPN,
     *                   EGAS_P,EGAS_N,OCCU_P,OCCU_N,EFERMP,EFERMN)
C
C      Setting up a number of numerical parameters
C
      EPSRTN=0.0001D0
C
      A_MASS=REAL(IN_FIX+IZ_FIX,KIND=KIND(1.0))
C
      XLSTRN=0.0D0
      DNSHEL=0.0D0
      ESHARN=0.0D0
      ESMEAN=0.0D0
C
      XLSTRP=0.0D0
      DNSHEP=0.0D0
      ESHARP=0.0D0
      ESMEAP=0.0D0
C
C=======================================================================
C     Beginning the nucleus if-loop within the deformation loop
C=======================================================================
C
      IZ_UPP=IZ_LOW+IZSTEP*(NOSTPZ-1)
      IN_UPP=IN_LOW+INSTEP*(NOSTPN-1)
C
      AMASS0=REAL(IZ_FIX+IN_FIX,KIND=KIND(1.0))
C
C=======================================================================
C        Strutinsky energy at zero spin and zero frequency - NEUTRONS
C=======================================================================
C
C     I_NUCL refers to the nucleus: calculations are performed for a
C     mesh of nuclei between IZ_LOW and IZ_UPP and IN_LOW and IN_UPP
C     with steps of respectively IZSTEP and INSTEP.
C
      I_NUCL=0
C
      ISOSPI=0
      GSTRUT=GSTRUN
      LDBASE=LDBASN
C
      DO IZ_VAR=IZ_LOW,IZ_UPP,IZSTEP
         DO IN_VAR=IN_LOW,IN_UPP,INSTEP
C
            A_MASS=REAL(IZ_VAR+IN_VAR,KIND=KIND(1.0))
C
            I_NUCL=I_NUCL+1
C
            DO I=1,LDBASE
               ESINGP(I)=ESINPN(I)*(A_MASS/AMASS0)**(1.0D0/3.0D0)
               EGASSP(I)=EGAS_N(I)*(A_MASS/AMASS0)**(1.0D0/3.0D0)
               OCCUPA(I)=OCCU_N(I)
            END DO
C
            CALL SHCORR(IZ_VAR,IN_VAR,ISOSPI,HOMFAC,GSTRUT,NPOLYN,
     *                  EPSRTN,XLSTRN,DNSHEL,ESHARN,ESMEAN,ENCUTS,
     *                                              NBCUTS,IFSHEL)
C
            IZNUCL(I_NUCL)=IZ_VAR
            INNUCL(I_NUCL)=IN_VAR
C
            STRUTN(I_NUCL)=DNSHEL
            ENCUTN(I_NUCL)=ENCUTS
            NBCUTN(I_NUCL)=NBCUTS
            DSHELN(I_NUCL)=DNSHEL
C
         END DO
      END DO
C
C=======================================================================
C        Strutinsky energy at zero spin and zero frequency - PROTONS
C=======================================================================
C
      I_NUCL=I_NUCL-NOSTPZ*NOSTPN
C
      ISOSPI=1
      GSTRUT=GSTRUP
      LDBASE=LDBASP
C
      DO IZ_VAR=IZ_LOW,IZ_UPP,IZSTEP
         DO IN_VAR=IN_LOW,IN_UPP,INSTEP
C
            A_MASS=REAL(IZ_VAR+IN_VAR,KIND=KIND(1.0))
            I_NUCL=I_NUCL+1
C
            DO I=1,LDBASE
               ESINGP(I)=ESINPP(I)*(A_MASS/AMASS0)**(1.0D0/3.0D0)
               EGASSP(I)=EGAS_P(I)*(A_MASS/AMASS0)**(1.0D0/3.0D0)
               OCCUPA(I)=OCCU_P(I)
            END DO
C
            CALL SHCORR(IZ_VAR,IN_VAR,ISOSPI,HOMFAC,GSTRUT,NPOLYN,
     *                  EPSRTN,XLSTRP,DPSHEL,ESHARP,ESMEAP,EPCUTS,
     *                                              NBCUTS,IFSHEL)
C
            STRUTP(I_NUCL)=DPSHEL
            ENCUTP(I_NUCL)=EPCUTS
            NBCUTP(I_NUCL)=NBCUTS
            DSHELP(I_NUCL)=DPSHEL
C
         END DO
      END DO
C
      LDNUCL=I_NUCL
C
C=======================================================================
C
      CALL CPUTIM('WSHELL',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE SHCORR(IZ_FIX,IN_FIX,ISOSPI,HOMFAC,GSTRUT,NPOLYN,
     *                  EPSRTN,XLMBAR,D_SHEL,ESHARP,ESMEAR,E_CUTS,
     *                                              NBCUTS,IFSHEL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /T_FLAG/ IFTEMP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /WSHELL_RES_WS/ ESINGP(1:2*NDBASE),
     *                       EGASSP(1:2*NDBASE),
     *                       OCCUPA(1:2*NDBASE)
      COMMON
     *       /WSHELL_STRUTG/ GAMMAS,COEFFM(1:NDSMTH)
      COMMON
     *       /WSHELL_INTSTR/ LIMCUT,N_PART
     *       /WSHELL_DIMENS/ LDBASE
     *       /WSHELL_KRAMER/ KRAMER
C
C=======================================================================
C        Subroutine SHCORR calculates the Strutinsky shell correction
C        to the classical liquid drop model formula.  Comments on the
C        use of the parameters are given in detail in routine  DSHELL
C=======================================================================
C
      A_MASS=REAL(IN_FIX+IZ_FIX,KIND=KIND(1.0))
      HBAR_0=41.0D0/A_MASS**(1.0D0/3.0D0)
C
      IF (ISOSPI.EQ.0) THEN
          N_PART=IN_FIX
      END IF
C
      IF (ISOSPI.EQ.1) THEN
          N_PART=IZ_FIX
      END IF
C
C      Cutting the lowest "LAMBDA+HOMFAC * 41/[A^(1/3)]"  levels;
C      Here the single particle levels are supposed to be doubly
C      degenerate; HOMFAC is of the order of 3.5;
C
                       INUPOL=N_PART/2
      IF (KRAMER.EQ.0) INUPOL=N_PART
C
      E_CUTS=ESINGP(INUPOL)+HOMFAC*HBAR_0   ! HOMFAC is ~ 3.5
C
      LIMCUT=INUPOL-1
      DO WHILE (LIMCUT.LT.LDBASE)
         LIMCUT=LIMCUT+1
         IF (ESINGP(LIMCUT).GT.E_CUTS) EXIT
      END DO
C
      NBCUTS=LIMCUT
C
C      Calculating the Strutinsky shell correction
C
      GAMMAS=GSTRUT*HBAR_0      ! Here GSTRUT is of the order of 1.2
      CALL DSHELL(XLMBAR,EPSRTN,D_SHEL,ESHARP,ESMEAR,NPOLYN,
     *                                               IFSHEL)
C
C      Resetting gammas to its proper value for pairing applications
C
      GAMMAS=GSTRUT*HBAR_0
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE DSHELL(XLMBAR,EPSRTN,D_SHEL,ESHARP,ESMEAR,NPOLYN,
     *                                                     IFSHEL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      EXTERNAL
     *          STRUTN
C
      DIMENSION
     *          HERPOL(0:NDSMTH),DHRPOL(0:NDSMTH)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /T_FLAG/ IFTEMP
      COMMON
     *       /GCTEMP/ TEMP_T
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /WSHELL_RES_WS/ ESINGP(1:2*NDBASE),
     *                       EGASSP(1:2*NDBASE),
     *                       OCCUPA(1:2*NDBASE)
      COMMON
     *       /WSHELL_STRUTG/ GAMMAS,COEFFM(1:NDSMTH)
      COMMON
     *       /WSHELL_INTSTR/ LIMCUT,N_PART
     *       /WSHELL_DIMENS/ LDBASE
     *       /WSHELL_KRAMER/ KRAMER
C
      DATA
     *        ITERNS /  50  /
      DATA
     *        EXPLIM / 30.0 /
C
C=======================================================================
C
C      Subroutine DSHELL calculates Strutinsky shell correction
C
C      M e a n i n g    o f    s o m e    p a r a m e t e r s :
C
C         GAMMAS - Strutinsky's smearing constant ( in MeV ) [~3.5*hw0]
C         NPOLYN - Maximum order of the smoothing polynomial, usually 6
C         LIMCUT - The number of sing. partcl  states in the summations
C
C         XLMBAR - Resulting Strutinsky Fermi energy  in MeV
C         EPSRTN - Precision in the RTNI type algorithm when searching
C                  for the XLMBAR solution
C
C         D_SHEL - The resulting Strutinsky shell correction. Here and
C                  in the following D_SHEL is the same for an even and
C                  for the neighboring odd particle number
C
C         ESHARP - is the usual sum of all the lowest, occupied single
C                  particle energies
C
C         ESMEAR - is the corresponding Strutinsky-smeared version
C
C         ESINGP - are the single particle  (doubly degenerate) levels
C                  in MeV <--> as all the other energy-like quantities
C
C=======================================================================
C
      PINUMB=4.0D0*ATAN(1.0D0)
      SQRTPI=SQRT(PINUMB)
C
      FACTOR=1.0D0
C
      DO I=1,NDSMTH
         COEFFM(I)=0.0D0
      END DO
C
      DO KFACTO=2,NPOLYN,2
         FACTOR=FACTOR*KFACTO/2
         COEFFM(KFACTO)=(-1)**(KFACTO/2)/(2.0**KFACTO)/FACTOR
      END DO
C
      IF (KRAMER.EQ.0) THEN
          XLAMB0=0.5D0*(ESINGP(N_PART)+ESINGP(N_PART+1))
      ELSE
          XLAMB0=0.5D0*(ESINGP(N_PART/2)+ESINGP(N_PART/2+1))
      END IF
C
      CALL NONLIN(XLMBAR,FVALUE,FDERIV,STRUTN,XLAMB0,EPSRTN,
     *                                 NEEDED,ITERNS,IERROR)
C
      ESHARP=0.0D0
      ESMEAR=0.0D0
C
C=======================================================================
C      Contribution to smooth energy from bound states: e*g_bound(e)
C=======================================================================
C
      DO I_PART=1,LIMCUT
C
         UNSTRT=(XLMBAR-ESINGP(I_PART))/GAMMAS
C
         CALL DF_HER(UNSTRT,NPOLYN,HERPOL,DHRPOL,NDSMTH)
C
         EXPUN2=0.0D0
         UNSTR2=UNSTRT*UNSTRT
C
         SUMPOL=0.0D0
         OCCSTR=0.0D0
C
         IF (UNSTR2.LT.EXPLIM) THEN
C
             EXPUN2=EXP(-UNSTR2)
C
             DO MPOLYN=2,NPOLYN,2
C
                SUMPOL=SUMPOL+COEFFM(MPOLYN)
     *                 *(0.5D0*GAMMAS*HERPOL(MPOLYN)
     *                +ESINGP(I_PART)*HERPOL(MPOLYN-1)
     *                 +MPOLYN*GAMMAS*HERPOL(MPOLYN-2))
C
                OCCSTR=OCCSTR+COEFFM(MPOLYN)*HERPOL(MPOLYN-1)
C
             END DO
C
         END IF
C
         ERROFN=ERRORF(UNSTRT)
C
         ENESUM=+0.5D0*ESINGP(I_PART)*(1.0D0+ERROFN)
     *          -0.5D0*GAMMAS/SQRTPI*EXPUN2
     *          -EXPUN2*SUMPOL/SQRTPI
C
         ESMEAR=ESMEAR+ENESUM
C
      END DO
C
C=======================================================================
C      Contribution to smooth energy from continuum states: e*g_bound(e)
C=======================================================================
C
      IF (IFSHEL.EQ.2) THEN
C
          DO I_PART=1,LIMCUT
C
             UNSTRT=(XLMBAR-EGASSP(I_PART))/GAMMAS
C
             CALL DF_HER(UNSTRT,NPOLYN,HERPOL,DHRPOL,NDSMTH)
C
             EXPUN2=0.0D0
             UNSTR2=UNSTRT*UNSTRT
C
             SUMPOL=0.0D0
             OCCSTR=0.0D0
C
             IF (UNSTR2.LT.EXPLIM) THEN
C
                 EXPUN2=EXP(-UNSTR2)
C
                 DO MPOLYN=2,NPOLYN,2
C
                    SUMPOL=SUMPOL+COEFFM(MPOLYN)
     *                     *(0.5D0*GAMMAS*HERPOL(MPOLYN)
     *                    +EGASSP(I_PART)*HERPOL(MPOLYN-1)
     *                     +MPOLYN*GAMMAS*HERPOL(MPOLYN-2))
C
                    OCCSTR=OCCSTR+COEFFM(MPOLYN)*HERPOL(MPOLYN-1)
C
                 END DO
C
             END IF
C
             ERROFN=ERRORF(UNSTRT)
C
             ENESUM=+0.5D0*EGASSP(I_PART)*(1.+ERROFN)
     *              -0.5D0*GAMMAS/SQRTPI*EXPUN2
     *              -EXPUN2*SUMPOL/SQRTPI
C
             ESMEAR=ESMEAR-ENESUM
C
          END DO
C
      END IF
C
C=======================================================================
C      Computation of the actual shell correction: sum of single-
C      particle nergies minus smooth energy
C=======================================================================
C
      IF (KRAMER.EQ.1) THEN
C
          IMODUL=MOD(N_PART,2) ! For odd nuclei
C
C          Sum of single-particle energies up to the Fermi level
          ESHARP=0.0D0
          DO I_PART=1,N_PART/2
             ESHARP=ESHARP+ESINGP(I_PART)
          END DO
C          To obtain the thermal excitation energy
          ETHERM=0.0D0
          DO I_PART=1,LDBASE
             ETHERM=ETHERM+OCCUPA(I_PART)*ESINGP(I_PART)
          END DO
C
C          Doubling of all quantities to account for Kramers degeneracy
          ESHARP=ESHARP+ESHARP
          ESMEAR=ESMEAR+ESMEAR
          ETHERM=ETHERM+ETHERM
C
C          For odd nuclei, the sum of single-particle energies must also
C          contain the poor lonely particle on level N_PART/2+1
          IMODUL=MOD(N_PART,2)
C
          IF (IMODUL.EQ.1) THEN
              ESHARP=ESHARP+ESINGP(N_PART/2+1)
          END IF
C
      ELSE
C
C          Sum of single-particle energies up to the Fermi level
          ESHARP=0.0D0
          DO I_PART=1,N_PART
             ESHARP=ESHARP+ESINGP(I_PART)
          END DO
C          To obtain the thermal excitation energy
          ETHERM=0.0D0
          DO I_PART=1,LDBASE
             ETHERM=ETHERM+OCCUPA(I_PART)*ESINGP(I_PART)
          END DO
C
      END IF
C
C      Shell correction: sum of s.p. energies minus smooth energy plus
C                        thermal excitation energy
      IF (IFTEMP.EQ.0) THEN
          D_SHEL = ESHARP - ESMEAR
      ELSE
          D_SHEL = ETHERM - ESMEAR
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE STRUTN(ENEACT,FUNSTR,DFNSTR,IFSHEL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          HERPOL(0:NDSMTH),DHRPOL(0:NDSMTH)
C
      COMMON
     *       /WSHELL_RES_WS/ ESINGP(1:2*NDBASE),
     *                       EGASSP(1:2*NDBASE),
     *                       OCCUPA(1:2*NDBASE)
      COMMON
     *       /WSHELL_INTSTR/ LIMCUT,N_PART
      COMMON
     *       /WSHELL_STRUTG/ GAMMAS,COEFFM(1:NDSMTH)
     *       /WSHELL_STRUTP/ NPOLYN
      COMMON
     *       /WSHELL_KRAMER/ KRAMER
C
      DATA
     *     EXPLIM / 30.0 /
C
C=======================================================================
C
C      This subroutine calculates an auxiliary function  FUNSTR
C      and its derivative DFNSTR,  to find the Strutinsky Fermi
C      level the latter necessery in order to define Strutinsky
C      smearing function g(e).
C
C      Parameters
C
C         ESINGP - Single particle spectrum with single or double
C                  degeneracy
C         EGASSP - Eigenvalues of the free gas
C         HERPOL - Hermite polynomials for the Strutinsky smearing
C         DHRPOL - ... their derivatives used for the same purpose
C         NPOLYN - The order of smoothing in the Strutinski method
C         LIMCUT - The number of proton  or neutron states  summed
C                  in the  'smeared' version of related summations
C         COEFFM - Auxiliary coefficients (calculated outside)
C
C=======================================================================
C
      PINUMB=4.0D0*ATAN(1.0D0)
      SQRTPI=SQRT(PINUMB)
C
      SUMENE=0.0D0
      SUMDER=0.0D0
C
C      Contribution to level density from bound states
C
      DO N=1,LIMCUT
C
         UNSTRT=(ENEACT-ESINGP(N))/GAMMAS
         UNSTR2=UNSTRT*UNSTRT
C
         EXPUN2=0.0D0
C
         SUMDHE=0.0D0
         SUMPOL=0.0D0
C
         IF (UNSTR2.LT.EXPLIM) THEN
C
             EXPUN2=EXP(-UNSTR2)
C
             CALL DF_HER(UNSTRT,NPOLYN,HERPOL,DHRPOL,NDSMTH)
C
             DO MPOLYN=2,NPOLYN,2
C
                SUMPOL=SUMPOL+COEFFM(MPOLYN)*HERPOL(MPOLYN-1)
                SUMDHE=SUMDHE+COEFFM(MPOLYN)*DHRPOL(MPOLYN-1)
C
             END DO
C
         END IF
C
         ENESUM=+0.5D0*(1.+ERRORF(UNSTRT))-EXPUN2*SUMPOL/SQRTPI
         TEXPUN=EXPUN2*(1.+2.00D0*UNSTRT*SUMPOL-SUMDHE)
C
         SUMENE=SUMENE+ENESUM
         SUMDER=SUMDER+TEXPUN
C
      END DO
C
C      Contribution to level density from continuum states
C
      IF (IFSHEL.EQ.2) THEN
C
          DO N=1,LIMCUT
C
             UNSTRT=(ENEACT-EGASSP(N))/GAMMAS
             UNSTR2=UNSTRT*UNSTRT
C
             EXPUN2=0.0D0
C
             SUMDHE=0.0D0
             SUMPOL=0.0D0
C
             IF (UNSTR2.LT.EXPLIM) THEN
C
                 EXPUN2=EXP(-UNSTR2)
C
                 CALL DF_HER(UNSTRT,NPOLYN,HERPOL,DHRPOL,NDSMTH)
C
                 DO MPOLYN=2,NPOLYN,2
C
                    SUMPOL=SUMPOL+COEFFM(MPOLYN)*HERPOL(MPOLYN-1)
                    SUMDHE=SUMDHE+COEFFM(MPOLYN)*DHRPOL(MPOLYN-1)
C
                 END DO
C
             END IF
C
             ENESUM=+0.5D0*(1.+ERRORF(UNSTRT))-EXPUN2*SUMPOL/SQRTPI
             TEXPUN=EXPUN2*(1.+2.00D0*UNSTRT*SUMPOL-SUMDHE)
C
             SUMENE=SUMENE-ENESUM
             SUMDER=SUMDER-TEXPUN
C
          END DO
C
      END IF
C
      IF (KRAMER.EQ.1) THEN
          SUMENE=SUMENE+SUMENE
          SUMDER=SUMDER+SUMDER
      END IF
C
      FUNSTR=+N_PART-SUMENE
      DFNSTR=-SUMDER/GAMMAS/SQRTPI
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION ERRORF(ARGMNT)
      DATA
     *      A1COEF,A2COEF,A3COEF,A4COEF,A5COEF,A6COEF
     *
     *    /.0705230784D0, .0422820123D0, .0092705272D0,
     *     .0001520143D0, .0002765672D0, .0000430638D0 /
C
C=======================================================================
C        This program calculates the standard error function
C=======================================================================
C
      XAUXIL=ABS(ARGMNT)
      ZAUXIL=(XAUXIL*(A1COEF
     *       +XAUXIL*(A2COEF
     *       +XAUXIL*(A3COEF
     *       +XAUXIL*(A4COEF
     *       +XAUXIL*(A5COEF+XAUXIL*A6COEF)))))+1.0D0)
C
      IF (ABS(ZAUXIL).LT.100.0D0) GO TO 1
C
      ERRABS=1.0D0
C
      GO TO 2
C
   1  ERRABS=1.0D0-1.0D0/ZAUXIL**16
C
   2  CONTINUE
C
      ERRORF=SIGN(REAL(ERRABS,KIND=KIND(1.0)),
     *            REAL(ARGMNT,KIND=KIND(1.0)))
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE NONLIN(X_ROOT,FVALUE,FDERIV,FUNCTN,XFIRST,EPSRTN,
     *                                       NEEDED,ITERNS,IERROR)
      EXTERNAL
     *         FUNCTN
C
C=======================================================================
C
C        This subroutine is known in circles of connessairs under
C        the fantasy name RTNI. It solves a nonlinear equation of
C        the form
C                               FUNCTN(XARGUM) = 0
C        by Newton's method.
C
C=======================================================================
C
C        X_ROOT - On exit: root found of the equation in question
C
C        FVALUE - On exit: Function value at the argument x= root
C        FDERIV - On exit: The coreresponding derivative of FUNCT
C
C        FUNCTN - External subroutine
C
C                          FUNCTN(XARGUM,FUNVAL,FDERIV)
C
C                 It computes the function value FUNVAL, and its
C                 derivative  FDERIV  at  XARGUM
C
C        XFIRST - On entry: an initial guess of  XARGUM
C
C        EPSRTN - If |FUNVAL| < 100 * EPSRTN the iterations stop
C
C        ITERNS - Maximum allowed number  of Newton's iterations
C        NEEDED - The number  of iterations  actually  performed
C
C        IERROR - Resultant error parameter. The possible values
C                 are:
C                      IERROR=0 - solution fouind within
C                                 prescribed accuracy
C                      IERROR=1 - no convergence after  ITERNS
C                                 iterations
C                      IERROR=2 - at some iteration derivative
C                                 FDERIV was equal to 0,  thus
C                                 the next Newton iteration is
C                                 impossible
C
C=======================================================================
C
      IERROR=0
C
C=======================================================================
C        Prepare the first iteration
C=======================================================================
C
      X_ROOT=XFIRST
      SEARCH=X_ROOT
C
      CALL FUNCTN(SEARCH,FVALUE,FDERIV,IFSHEL)
C
      EPS100=100.0D0*EPSRTN
C
C=======================================================================
C        Start iteration loop
C=======================================================================
C
      DO I=1,ITERNS
C
         NEEDED=I
C
         IF (ABS(FVALUE).EQ.0.0) THEN
C
C            Equation was already satisfied by the argument
C
             RETURN
C
         ELSE
C
C            ... equation is not yet satisfied by X
C
             IF (ABS(FDERIV).EQ.0.0) THEN
C
C                Here the next iteration is NOT possible
C                =>>ERROR RETURN in case of zero divisor
C
                 IERROR=2
                 RETURN
C
             ELSE
C
C                ... and here the next iteration is possible
C
                 DXVALU=FVALUE/FDERIV
                 X_ROOT=X_ROOT-DXVALU
                 SEARCH=X_ROOT
C
                 CALL FUNCTN(SEARCH,FVALUE,FDERIV,IFSHEL)
C
C                Test on possibly satisfactory accuracy
C
                 SEARCH=EPSRTN
                 ABSARG=ABS(X_ROOT)
C
                 IF ((ABSARG-1.).GT.0.0) THEN
                     SEARCH=SEARCH*ABSARG
                 END IF
C
                 IF ((ABS(DXVALU)-SEARCH).GT.0.0) THEN
                     GO TO 1
                 ELSE
C
                     IF ((ABS(FVALUE)-EPS100).GT.0.0) THEN
                         GO TO 1
                     ELSE
                         RETURN
                     END IF
                 END IF
             END IF
         END IF
C
    1    CONTINUE
C
      END DO !  End of iteration loop
C
C     No convergence after iterns iteration steps, error return.
C
      IERROR=1
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE DF_HER(ARGHER,NORHER,HERPOL,DHERPO,NDHERM)
      DIMENSION
     *          HERPOL(0:NDHERM),DHERPO(0:NDHERM)
C
C=======================================================================
C
C         DFHERM calculates Hermite polynomials at point X=ARGHER up
C         to N=NORHER-th degree.  It also calculates the derivatives
C         DHERPO of these polynomials
C
C                            DHERPO(I)=2*I*HERPOL(I-1)
C
C=======================================================================
C
      HERPOL(0)=1.0D0
      DHERPO(0)=0.0D0
C
      IF (NORHER.EQ.0) RETURN
C
      HERPOL(1)=ARGHER+ARGHER
      DHERPO(1)=2.0000D0
C
      IF (NORHER.EQ.1) RETURN
C
      DO I=1,NORHER-1
C
         POLYNM=ARGHER*HERPOL(I)-REAL(I,KIND=KIND(1.0))*HERPOL(I-1)
         HERPOL(I+1)=POLYNM+POLYNM
C
         DPOLYN=REAL(I+1,KIND=KIND(1.0))*HERPOL(I)
         DHERPO(I+1)=DPOLYN+DPOLYN
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C

      SUBROUTINE Set_version_hfodd_wigner
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(16) = 'hfodd_wigner   '
      MODUVE(16) = 6
      MODSET(16) = 16
      !
      END SUBROUTINE Set_version_hfodd_wigner
      !
module hfodd_wigner

      SAVE D_WIGN,IWIIMK,BETANG,ISWIGN

      ALLOCATABLE D_WIGN(:,:)
      ALLOCATABLE IWIIMK(:,:,:)
      ALLOCATABLE BETANG(:)
      ALLOCATABLE ISWIGN(:,:)

end module hfodd_wigner
!     CONTAINS
!
!=======================================================================
!         BELOW ARE IMPLEMENTATIONS COPIED FROM THE SUPPLEMENTAL MATERIAL OF
!         https://journals.aps.org/pre/abstract/10.1103/PhysRevE.92.043307
!         A FEW MODIFCATIONS ARE MARKED BY "!JD 190316"
!=======================================================================
!************************************************************************************************************************************************************
!  FUNCTIONS: Wigner's d-matrix
!  Methods: (a) Complex Fourier-series expansion of the d-matrix;
!           (b) the Fourier coefficients are obtained by numerical diagonalizing the angular-momentum operator Jy, using the ZHBEV subroutine of LAPACK.
!
!  update:  (y/m/d) 2015/09/30 by G.R.J
!*************************************************************************************************************************************************************
!
!   [1] The defination of the term X_{m}=<j,m-1|J_{-}|j,m>, where J_{-} is the ladder operator,
!       obeying J_{-}|j,m>=X_{m} |j,m-1>, and {|j,m>} eigenvectors of the angular-momentum operator Jz.
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    function X(j,n)
!JD 190316 vvvv
!       real*8 X,n,j
        real   X,n,j
!JD 190316 ^^^^
          X=dsqrt((j+n)*(j-n+1.d0))
        end

!****************************************************************************************************
!   [2]  The Hermitian matrix of J_{y}
!******************************************************************************************************
        subroutine coeffi(A,Ndim)
!        external X
!JD 190316 vvvv
!       implicit real*8 (a-h,o-z)
!       real*8 jmq
!       COMPLEX*16 A(Ndim,Ndim), im
        implicit real   (a-h,o-z)
        real   jmq
        COMPLEX    A(Ndim,Ndim), im
!JD 190316 ^^^^
        integer Ndim,m
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    im=(0.d0,1.d0)
    jmq=(dble(Ndim)-1.d0)/2.d0
        do i=1,Ndim
                do j=1,Ndim
            A(i,j)=0.d0

           if(i.eq.1.and.Ndim.gt.1) then
                A(i,i+1)=X(jmq,dble(i)-jmq)*im/(2.d0)
            endif
            if(i.eq.Ndim.and.Ndim.gt.1) then
                A(i,i-1)=-X(jmq,-dble(i)+jmq+2)*im/(2.d0)
            endif

               if((i.gt.1).and.(i.lt.Ndim))then
                A(i,i+1)=X(jmq,dble(i)-jmq)*im/(2.d0)
                    A(i,i-1)=-X(jmq,-dble(i)+jmq+2)*im/(2.d0)
               endif
            enddo
    enddo
        return
    end

!**************************************************************************************************************************
!   [3] Calculation of the eigenvalues and the right eigenvectors for the Hermitian matrix J_{y},
!       using ZHBEV subroutine of LAPACK.
!****************************************************************************************************************************
    subroutine eigen(A,Eigenvalue,Eigenvec,Ndim)
    character *1 JOBZ,UPLO
    integer Ndim,KD,LDAB,LDZ,INFO
!JD 190316 vvvv
!   double precision Eigenvalue(Ndim)
!   double precision,allocatable:: RWORK(:)
!   double complex,allocatable:: WORK(:),AB(:,:)
!   double complex Eigenvec(Ndim,Ndim),A(Ndim,Ndim)
    real Eigenvalue(Ndim)
    real,allocatable:: RWORK(:)
    complex,allocatable:: WORK(:),AB(:,:)
    complex Eigenvec(Ndim,Ndim),A(Ndim,Ndim)
!JD 190316 ^^^^
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   JOBZ='V'
   UPLO='U'
   KD=1
   LDAB=KD+1
   LDZ=max(1,Ndim)
   INFO=0
   allocate(AB(LDAB,Ndim),WORK(Ndim),RWORK(max(1,3*Ndim-2)))

   call coeffi(A,Ndim)
        do i=1,Ndim
                  do j=i,Ndim
                   if(max(1,j-kd).le.i) then
            AB(KD+1+i-j,j)=A(i,j)
                   end if
          enddo
        enddo

   call ZHBEV (JOBZ, UPLO, Ndim, KD, AB, LDAB, Eigenvalue, Eigenvec, LDZ, WORK, RWORK,INFO)

   deallocate(RWORK,WORK,AB)

   end


!**************************************************************************************************************************
!   [4] The subroutine to calculate the Wigner-d matrix and its first-order derivative with various mv and nv for a given {j,theta}
!****************************************************************************************************************************
!JD 190316 vvvv
!       subroutine Wigner_dmatrix(jmq,theta,wd_matrix,diffwd_matrix)
        subroutine Wigner_dmatrix(jmq,theta,wd_matrix)
!=======================================================================
      USE hfodd_sizes
!=======================================================================
!JD 190316 ^^^^
        integer Ndim,ixx,iyy,mu
!JD 190316 vvvv
!       real *8 jmq, mvar, nvar,theta, wd, wdderivative, wd_matrix(int(2*jmq+1),int(2*jmq+1)), diffwd_matrix(int(2*jmq+1),int(2*jmq+1))
!       double complex  inum
!       double precision,allocatable :: Evalue(:),Eigenvalue(:)
!       double complex,allocatable :: coeffimatrix(:,:), Eigenvector(:,:)
        real    jmq, mvar, nvar,theta, wd
        dimension wd_matrix(int(2*jmq+1),int(2*jmq+1))
        complex  inum
        real,allocatable :: Evalue(:),Eigenvalue(:)
        complex,allocatable :: coeffimatrix(:,:), Eigenvector(:,:)
!JD 190316 ^^^^
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        inum=(0.d0,1.d0)
    Ndim=int(2.d0*jmq+1.d0)
    allocate(Evalue(Ndim),coeffimatrix(Ndim,Ndim),Eigenvector(Ndim,Ndim),Eigenvalue(Ndim))
    Evalue=0.0d0
    coeffimatrix=0.0d0
    Eigenvector=0.0d0
    Eigenvalue=0.0d0
!    call coeffi(coeffimatrix,Ndim)
     call eigen(coeffimatrix,Eigenvalue,Eigenvector,Ndim)

     do ixx=1,Ndim
           do iyy=1,Ndim

              wd=0.d0
!JD 190316 vvvv
!                 wdderivative=0.d0
!JD 190316 ^^^^

              do mu=1,Ndim
                     if(dble(int(jmq)).eq.jmq) then
                Evalue(mu)=dble(floor(Real(Eigenvalue(mu))+0.5d0))
                         else
                Evalue(mu)=dble(floor(Real(Eigenvalue(mu)))+0.5d0)
                         endif
                wd=wd+exp(-inum*Evalue(mu)*theta)*Eigenvector(ixx,mu)*dconjg(Eigenvector(iyy,mu))
!JD 190316 vvvv
!               wdderivative=wdderivative+(-inum*Evalue(mu))*exp(-inum*Evalue(mu)*theta)*Eigenvector(ixx,mu)*dconjg(Eigenvector(iyy,mu))
!JD 190316 ^^^^
                  enddo

                  wd_matrix(ixx,iyy)=wd
!JD 190316 vvvv
!                 diffwd_matrix(ixx,iyy)=wdderivative
!JD 190316 ^^^^
                end do
         end do

     deallocate(Evalue, coeffimatrix, Eigenvector,Eigenvalue)
        return
    end

 !***********************************************************************
 !
 !    Copyright (c) 2015, Lawrence Livermore National Security, LLC.
 !                        Produced at the Lawrence Livermore National
 !                        Laboratory.
 !                        Written by Nicolas Schunck, schunck1@llnl.gov
 !
 !    LLNL-CODE-470611 All rights reserved.
 !
 !    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
 !                    W. Satula, J.A. Sheikh, A. Staszczak,A
 !                    M. Stoitsov, P. Toivanen
 !    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
 !                    P. Olbratowski, P. Powalowski, M. Sadziak,
 !                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
 !                    M. Zalewski, H. Zdunczuk
 !    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
 !    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
 !
 !    This file is part of HFODD.
 !
 !    HFODD is free software: you can redistribute it and/or modify it
 !    under the terms of the GNU General Public License as published by
 !    the Free Software Foundation, either version 3 of the License, or
 !    (at your option) any later version.
 !
 !    HFODD is distributed in the hope that it will be useful, but
 !    WITHOUT ANY WARRANTY; without even the implied warranty of
 !    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 !    GNU General Public License for more details.
 !
 !    You should have received a copy of the GNU General Public License
 !    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
 !
 !    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
 !    LICENSE
 !
 !    Our Preamble Notice
 !
 !      A. This notice is required to be provided under our contract
 !         with the U.S. Department of Energy (DOE). This work was
 !         produced at the Lawrence Livermore National Laboratory under
 !         Contract No. DE-AC52-07NA27344 with the DOE.
 !      B. Neither the United States Government nor Lawrence Livermore
 !         National Security, LLC nor any of their employees, makes any
 !         warranty, express or implied, or assumes any liability or
 !         responsibility for the accuracy, completeness, or usefulness
 !         of any information, apparatus, product, or process disclosed,
 !         or represents that its use would not infringe privately-owned
 !         rights.
 !      C. Also, reference herein to any specific commercial products,
 !         process, or services by trade name, trademark, manufacturer
 !         or otherwise does not necessarily constitute or imply its
 !         endorsement, recommendation, or favoring by the United States
 !         Government or Lawrence Livermore National Security, LLC. The
 !         views and opinions of authors expressed herein do not
 !         necessarily state or reflect those of the United States
 !         Government or Lawrence Livermore National Security, LLC, and
 !         shall not be used for advertising or product endorsement
 !         purposes.
 !
 !    The precise terms and conditions for copying, distribution and
 !    modification are contained in the file COPYING.
 !
 !***********************************************************************

 !----------------------------------------------------------------------!
 !                                                                      !
 !                MPI Management Environment for HFODD                  !
 !                                                                      !
 ! Authors: N. Schunck, ORNL                                            !
 !                                                                      !
 ! This module is/will be in charge of:                                 !
 !    - defining the list of tasks to be run based on sequential and    !
 !      parallel inputs read in hfodd_mpiio.f90                         !
 !    - managing the load balancing of the tasks                        !
 !                                                                      !
 !                          First included in official release v249e    !
 !                                                                      !
 !----------------------------------------------------------------------!

      SUBROUTINE Set_version_hfodd_mpimanager
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(7) = 'hfodd_mpimanager'
      MODUVE(7) = 6
      MODSET(7) = 7
      !
      END SUBROUTINE Set_version_hfodd_mpimanager
      !
 Module hfodd_mpimanager

   Use hfodd_mpiio

   Implicit None

   ! Public
   Integer :: NOFJOB

   ! Private
   Logical :: filled

   Integer :: debug = 0

   Integer :: numberQ=4,numberQ_restart=4,numberQ_orig=4,       &
              numberConstraints_orig=1,neck_numberPoints_orig=1
   Integer, Allocatable :: IZ_JOB(:),IN_JOB(:),indexQjob(:),indexForce(:),indexTemperature(:), &
                           indexRestartJob(:),indexNeck(:)
   Integer, Allocatable :: indexSizeJob(:),indexStatesJob(:),indexLengthJob(:),idxDeformJob(:),    &
                           basis_size(:),basis_states(:),flex_lambda(:),flex_miu(:),index_file(:), &
                           mapping_qlm(:),mapping_qlm_new(:),mapping_neck(:)
   Integer, Allocatable :: lambdaJob(:,:),miuJob(:,:),lambdaJob_restart(:,:),miuJob_restart(:,:)
   Integer, Allocatable :: table_fichiers(:)

   Real :: neck_step=0.0,neck_step_restart
   Real, Allocatable :: XIZJOB(:),XINJOB(:)
   Real, Allocatable :: flex_qlm(:),basis_freq(:),basis_defo(:), &
                        neck_value(:),neck_value_restart(:)
   Real, Allocatable :: qValueJob(:,:),qValueJob_restart(:,:)

   Character(Len=68), Allocatable :: fichier(:),fichier_tho(:)
   Character(Len=68), Allocatable :: fichier_rec_old(:),fichier_rec_new(:),&
                                     fichier_tho_old(:),fichier_tho_new(:),&
                                     fichier_lic_old(:),fichier_lic_new(:)
   Character(Len=68), Allocatable :: fichier_rec_tmp(:),&
                                     fichier_tho_tmp(:),&
                                     fichier_lic_tmp(:)

 Contains

   !---------------------------------------------------------------------!
   !  Defines default deformation grid for 0<= modeMPI_deformation <=2   !
   !  Outputs: - numberQ, total number of points on the mesh             !
   !           - lambdaJob(:), miuJob(:), qValueJob(:), vectors storing  !
   !             the lambda, miu and q(lambda,miu) values at each point  !
   !             of the mesh                                             !
   !           - numberQ_orig, numberConstraints_orig store the sizes of !
   !             the mesh (total size and number of constraints, resp.)  !
   !             for use when modeMPI_deformation = 2                    !
   !---------------------------------------------------------------------!
   Subroutine define_gridQlm()

     Integer :: iq,nQtotal,nQfactor,ii,lambda,miu,nQ,mpi_rank,mpi_err
     Integer, Allocatable :: nQmodul(:)
     Real, Allocatable :: deltaQ(:)

     Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)

     ! Determine total number of points on the mesh: number of collective
     ! variables 'numberConstraints' times the number of points for each
     numberQ = 1
     Do iq=1,numberConstraints
        numberQ = numberQ*qStepNumber(iq)
     End Do
     If(debug.Ge.1 .And. mpi_rank.Eq.0) &
        Write(6,'("numberQ = ",i10," numberConstraints=",i10)') numberQ,numberConstraints

     ! Storing characteristics of the default mesh for future use (if
     ! modeMPI_deformation = 2)
     numberQ_orig = numberQ
     numberConstraints_orig = numberConstraints

     ! Getting the meshsize for each collective variable
     Allocate(deltaQ(1:numberConstraints),nQmodul(0:numberConstraints))
     Do iq=1,numberConstraints
        If(qstepNumber(iq) > 1 ) Then
            deltaQ(iq) = (qFinValue(iq) - qinitValue(iq)) / Real(qstepNumber(iq) - 1)
        Else
            deltaQ(iq) = 0.0d0
        End If
     End Do

     ! Defining the mesh: lambdaJob(ii,iq), miuJob(ii,iq) and qValueJob(ii,iq) give,
     ! respectively, the value of lambda, miu and q(lambda,miu) at point ii of the
     ! total mesh and for the collective variable iq
     Allocate(qValueJob(1:numberQ,1:numberConstraints))
     Allocate(lambdaJob(1:numberQ,1:numberConstraints),miuJob(1:numberQ,1:numberConstraints))

     nQtotal=1; nQmodul(0)=1; nQfactor=0
     Do iq=1,numberConstraints

        nQ=qStepNumber(iq)
        lambda=Abs(qLambda(iq)); miu=qMiu(iq)
        nQtotal=nQtotal*nQ; nQmodul(iq)=numberQ/nQtotal

        Do ii=1,numberQ
           lambdaJob(ii,iq)=lambda
           miuJob(ii,iq)=miu
           qValueJob(ii,iq)=qinitValue(iq) &
                           + deltaQ(iq) * ((ii-1)/nQmodul(iq) - nQfactor*((ii-1)/nQmodul(iq-1))*nQ)
        End Do

        nQfactor = 1

     End Do

     Deallocate(deltaQ,nQmodul)

   End Subroutine define_gridQlm

   !---------------------------------------------------------------------!
   !  Defines restart deformation grid for modeMPI_deformation = 2, 3    !
   !  Outputs: - numberQ_restart, total number of points on the restart  !
   !             mesh                                                    !
   !           - lambdaJob_restart(:), miuJob_restart(:), and            !
   !             qValueJob_restart(:), vectors storing the lambda, miu   !
   !             and q(lambda,miu) values at each point of the restart   !
   !             mesh                                                    !
   !---------------------------------------------------------------------!
   Subroutine define_gridQlm_new()

     Integer :: iq,nQtotal,nQfactor,ii,lambda,miu,nQ,mpi_rank,mpi_err
     Integer, Allocatable :: nQmodul(:)
     Real, Allocatable :: deltaQ(:)

     Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)

     ! Determine total number of points on the restart mesh
     numberQ_restart = 1
     Do iq=1,numberConstraints_restart
        numberQ_restart = numberQ_restart * qStepNumber_restart(iq)
     End Do
     If(debug.Ge.1 .And. mpi_rank.Eq.0) &
        Write(6,'("numberQ_restart = ",i10," numberConstraints_restart=",i10)') &
                   numberQ_restart,numberConstraints_restart

     ! Getting the meshsize for each collective variable on the restart mesh
     Allocate(deltaQ(1:numberConstraints_restart),nQmodul(0:numberConstraints_restart))
     Do iq=1,numberConstraints_restart
        If(qstepNumber_restart(iq)>1) Then
           deltaQ(iq) = (qFinValue_restart(iq) - qinitValue_restart(iq)) / Real(qstepNumber_restart(iq) - 1)
        Else
           deltaQ(iq) = 0.0D0
        End If
     End Do

     ! Defining the restart mesh, see subroutine define_gridQlm for explanations
     Allocate(qValueJob_restart(1:numberQ_restart,1:numberConstraints_restart))
     Allocate(lambdaJob_restart(1:numberQ_restart,1:numberConstraints_restart),&
              miuJob_restart(1:numberQ_restart,1:numberConstraints_restart))

     nQtotal=1; nQmodul(0)=1; nQfactor=0
     Do iq=1,numberConstraints_restart

        nQ=qStepNumber_restart(iq)
        lambda=Abs(qLambda_restart(iq)); miu=qMiu_restart(iq)
        nQtotal=nQtotal*nQ; nQmodul(iq)=numberQ_restart / nQtotal

        Do ii=1,numberQ_restart
           lambdaJob_restart(ii,iq)=lambda
           miuJob_restart(ii,iq)=miu
           qValueJob_restart(ii,iq)=qinitValue_restart(iq) &
                                   + deltaQ(iq) * ( (ii-1)/nQmodul(iq) - nQfactor*((ii-1)/nQmodul(iq-1))*nQ )
        End Do

        nQfactor = 1

     End Do

     Deallocate(deltaQ,nQmodul)

   End Subroutine define_gridQlm_new

   !---------------------------------------------------------------------!
   !  Defines the deformation path for modeMPI_deformation = 4. The full !
   !  deformation path is stored in the file hfodd_path.d. It is read in !
   !  this routine by processor 0 and broadcast to all processors.       !
   !  Outputs: - numberQ_restart, total number of points in the path     !
   !           - lambdaJob_restart(:), miuJob_restart(:), and            !
   !             qValueJob_restart(:), vectors storing the lambda, miu   !
   !             and q(lambda,miu) values at each point along the path   !
   !---------------------------------------------------------------------!
   Subroutine define_pathQlm_new()

     Integer, Parameter :: ndatin=84
     Integer :: i,lines,iline,number_cons,ierr,mpi_rank,mpi_err
     Character(Len=80) :: filein

     ! Getting the rank of the current process
     Call mpi_comm_rank(MPI_COMM_WORLD, mpi_rank, mpi_err)

     If(mpi_rank.Eq.0) Then

        ! open the file
        filein = "hfodd_path.d"
        Open(ndatin,file=filein,status='old',form='formatted',iostat=ierr)
        If(ierr.Ne.0) Then
           Write(6,'("Error in opening file : ",a80)') filein
           Stop 'Error in define_pathQlm_new - I/O'
        End if

        ! Read the number of constraints used to define a trajectory
        Read(ndatin,*) number_cons, lines
        If(debug.Ge.1) Write(6,'("Number of constraints: ",i10," Number of lines: ",i10)') number_cons,lines
        numberConstraints_restart=number_cons
        numberQ_restart=lines
        ! Read trajectory in N-d space (N=number_cons)
        Allocate(qValueJob_restart(1:numberQ_restart,1:numberConstraints_restart))
        Allocate(lambdaJob_restart(1:numberQ_restart,1:numberConstraints_restart),&
                 miuJob_restart(1:numberQ_restart,1:numberConstraints_restart))
        iline=0
        Do While(iline < lines)
           iline=iline+1
           Read(ndatin,*) (lambdaJob_restart(iline,i),miuJob_restart(iline,i),qValueJob_restart(iline,i),&
                           i=1,number_cons)
        End Do
        ! Close file
        Close(ndatin)

     End If

     ! Broadcast number of constraints and number of lines
     Call MPI_Bcast(numberConstraints_restart,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpi_err)
     Call MPI_Bcast(numberQ_restart,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpi_err)
     ! Allocate space for vectors
     If(mpi_rank.Ne.0) Then
        Allocate(qValueJob_restart(1:numberQ_restart,1:numberConstraints_restart))
        Allocate(lambdaJob_restart(1:numberQ_restart,1:numberConstraints_restart),&
                 miuJob_restart(1:numberQ_restart,1:numberConstraints_restart))
     End If

     ! Broadcast lambda values                                  ,
     Call MPI_Bcast(lambdaJob_restart,numberConstraints_restart*numberQ_restart,MPI_INTEGER,0,&
                                                                                MPI_COMM_WORLD,mpi_err)
     ! Broadcast miu values                                     ,
     Call MPI_Bcast(miuJob_restart,numberConstraints_restart*numberQ_restart,MPI_INTEGER,0,&
                                                                             MPI_COMM_WORLD,mpi_err)
     ! Broadcast qlm values
     Call MPI_Bcast(qValueJob_restart,numberConstraints_restart*numberQ_restart,MPI_DOUBLE_PRECISION,0,&
                                                                                MPI_COMM_WORLD,mpi_err)
     If(debug.Ge.1) Write(6,'("In define_pathQLM_new - mpi_rank = ",i10, &
                            & " has received numberConstraints_restart = ",i10)') &
                          mpi_rank, numberConstraints_restart

   End Subroutine define_pathQlm_new

   !---------------------------------------------------------------------!
   !  Defines default grid for the constraint on the size of the neck QN !
   !  in the case modeMPI_neck >= 1                                      !
   !  Outputs: - neck_value(:), vector storing the values of QN          !
   !           - neck_numberPoints_orig stores the number of QN values   !
   !             for use when modeMPI_neck = 2                           !
   !---------------------------------------------------------------------!
   Subroutine define_gridNeck()

     Integer :: i_neck

     neck_numberPoints_orig = neck_numberPoints

     Allocate(neck_value(1:neck_numberPoints))
     If(neck_numberPoints>1) Then
         neck_step = (neck_finValue - neck_initValue) / Real(neck_numberPoints - 1)
         do i_neck=1,neck_numberPoints
            neck_value(i_neck) = neck_initValue + Real(i_neck - 1)*neck_step
         End do
     else
         neck_value(1) = neck_initValue
     End if

   End Subroutine define_gridNeck

   !---------------------------------------------------------------------!
   !  Defines restart grid for the constraint on the size of the neck QN !
   !  in the case modeMPI_neck = 2                                       !
   !  Outputs: - neck_value_restart(:), vector storing the values of QN  !
   !             on the restart grid                                     !
   !---------------------------------------------------------------------!
   Subroutine define_gridNeck_new()

     Integer :: i_neck

     Allocate(neck_value_restart(1:neck_numberPoints_restart))
     If(neck_numberPoints_restart>1) Then
         neck_step_restart = (neck_finValue_restart - neck_initValue_restart) &
                          / Real(neck_numberPoints_restart - 1)
         do i_neck=1,neck_numberPoints_restart
            neck_value_restart(i_neck) = neck_initValue_restart + Real(i_neck - 1)*neck_step_restart
         End do
     else
         neck_value_restart(1) = neck_initValue_restart
     End if

   End Subroutine define_gridNeck_new

   !---------------------------------------------------------------------!
   !  Defines default deformation grid for modeMPI_deformation >= 3. In  !
   !  this mode, the initial mesh is extracted on-the-fly from a list of !
   !  HFODD record files. As a result, the mesh can be irregular and     !
   !  have different number of constraints from the restart mesh. The    !
   !  reading of the HFODD record files is done in parallel to handle    !
   !  large file sets (and reducing the overhead of reading HFODD binary !
   !  files).                                                            !
   !  ATTENTION: We make the assumption that all files in the list have  !
   !             the same number (=numberConstraints) and type (qLambda, !
   !             qMiu arrays) of constraints. This information is extrac-!
   !             ted from the MULTICONS keyword. It is necessary to spe- !
   !             cify what the constraints are, even though the actual   !
   !             mesh will be discarded for these two modes.             !
   !  Outputs: - numberQ, total number of points on the mesh             !
   !           - lambdaJob(:), miuJob(:), qValueJob(:), vectors storing  !
   !             the lambda, miu and q(lambda,miu) values at each point  !
   !             of the mesh                                             !
   !           - numberQ_orig, numberConstraints_orig store the sizes of !
   !             the mesh (total size and number of constraints, resp.)  !
   !           - neck_numberPoints_orig is set to 1, as this mode is not !
   !             yet compatible with any constraint on the neck.         !
   !---------------------------------------------------------------------!
   Subroutine define_restartPointsQlm(NUMITE,NXHERM,NYHERM,NZHERM,IPCONT,ILCONT,IACONT, &
                                      IMCONT,IRCONT,IRENMA,IRENIN,LIPKIN,LIPKIP,REFERN, &
                                      REFERP,REDELN,REDELP,REFE2N,REFE2P,IFIBLN,INIBLN, &
                                      IFIBLP,INIBLP,NMUMAX,NSIMAX,NMUCON,ISHIFT,IF_THO, &
                                                                                IERROR)

     Integer, INTENT(IN) :: NUMITE,NXHERM,NYHERM,NZHERM,IPCONT,ILCONT,IACONT,IMCONT, &
                            IRCONT,IRENMA,IRENIN,LIPKIN,LIPKIP,IFIBLN,INIBLN,IFIBLP, &
                            INIBLP,NMUMAX,NSIMAX,NMUCON,ISHIFT,IF_THO
     Integer, INTENT(INOUT) :: IERROR
     Real, INTENT(INOUT) :: REFERN,REFERP,REDELN,REDELP,REFE2N,REFE2P

     Logical :: INCREP

     Integer :: mpi_rank,mpi_err,mpi_world,status(MPI_STATUS_SIZE)
     Integer :: NFIREP,tag,counter,numberConstraintsMax,exitstat
     Integer :: number_orig,task,iq,stringLength=68,size_array,mpi_string_68
     Integer, Allocatable :: buf_lambdaJob(:),buf_miuJob(:),l_temp(:,:),m_temp(:,:)

     Character(Len=6) :: string_number
     Character(Len=68) :: FILREP
     Character(Len=150) :: commande

     Real, Allocatable :: buf_qValueJob(:),q_temp(:,:)

     Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)
     Call mpi_comm_size(MPI_COMM_WORLD,mpi_world,mpi_err)

     ! Define MPI type for a character string of length stringLength=68 and commit it
     Call mpi_type_contiguous(stringLength,MPI_CHARACTER,mpi_string_68,mpi_err)
     Call mpi_type_commit(mpi_string_68,mpi_err)

     ! Process 0 reads list of files to use as restart
     If(mpi_rank.Eq.0) Then
        numberQ=1; Call read_fileList()
        If(debug.Ge.1 .And. mpi_rank.Eq.0) Write(6,'("From hfodd_files.d - numberQ = ",i10)') numberQ
     End If

     ! Broadcasting size of collective space, and allocate space for list of filenames (at this
     ! point, only process 0 has done the allocation)
     Call MPI_Bcast(numberQ,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpi_err)
     If(mpi_rank.Ne.0) Then
        Allocate(fichier(1:numberQ),index_file(1:numberQ))
     End If

     Call mpi_barrier(MPI_COMM_WORLD,mpi_err)

     ! Broadcasting list of files
     Call MPI_Bcast(fichier,numberQ,mpi_string_68,0,MPI_COMM_WORLD,mpi_err)
     Call MPI_Bcast(index_file,numberQ,MPI_INTEGER,0,MPI_COMM_WORLD,mpi_err)

     ! Allocate space for THO files if needed. Assume there is a directory ./tho/
     ! with all required files (this is the consequence of being in restart mode)
     If(IF_THO.Ge.1) Then
     	Allocate(fichier_tho(1:numberQ))
     	Do counter=1,numberQ
     	   Write(string_number,'(i6.6)') index_file(counter)
     	   fichier_tho(counter)='./tho/'//string_number//'.hel'
     	End Do
     End If

     ! Make a backup copy of the requested file somewhere else
     Do counter=1,numberQ
        If(Mod(mpi_rank,mpi_world).Eq.Mod(counter-1,mpi_world)) Then
           commande = 'cp '//Trim(fichier(counter))//' .'; exitstat=0
           Call system(commande)
           If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," counter = ",i10," - Executed command: ",a)') &
                                                  mpi_rank,counter,commande
        End If
     End Do

     Call mpi_barrier(MPI_COMM_WORLD,mpi_err)

     ! Reading files and obtaining characteristics of restart jobs. MPI tags are used to synchronize
     ! the order of send and receives
     If(mpi_rank.Eq.0) Then

        Allocate(qValueJob(1:numberQ,1:numberConstraints))
        Allocate(lambdaJob(1:numberQ,1:numberConstraints),miuJob(1:numberQ,1:numberConstraints))
        qValueJob(:,:)=0.0D0; lambdaJob(:,:)=0; miuJob(:,:)=0

        ! Receive the multipole constraints read from each file
        Do task=1,numberQ
           tag=task
           ! Allocate space for current buffers
           Allocate(buf_lambdaJob(numberConstraints),&
                    buf_miuJob(numberConstraints),   &
                    buf_qValueJob(numberConstraints))
           If(debug.Ge.3) Write(6,'("mpi_rank ",i10," has allocated buf_[]")') mpi_rank
           ! Receive local buffers
           tag=  numberQ+task; Call mpi_recv(buf_lambdaJob,numberConstraints,MPI_INTEGER,MPI_ANY_SOURCE,tag, &
                                                                             MPI_COMM_WORLD,status,mpi_err)
           tag=2*numberQ+task; Call mpi_recv(buf_miuJob,numberConstraints,MPI_INTEGER,MPI_ANY_SOURCE,tag, &
                                                                          MPI_COMM_WORLD,status,mpi_err)
           tag=3*numberQ+task; Call mpi_recv(buf_qValueJob,numberConstraints,MPI_DOUBLE_PRECISION,MPI_ANY_SOURCE, &
                                                                         tag,MPI_COMM_WORLD,status,mpi_err)
           If(debug.Ge.3) Write(6,'("mpi_rank ",i10," has received buf_[]")') mpi_rank
           lambdaJob(task,1:numberConstraints)=buf_lambdaJob(1:numberConstraints)
           miuJob(task,1:numberConstraints)=buf_miuJob(1:numberConstraints)
           qValueJob(task,1:numberConstraints)=buf_qValueJob(1:numberConstraints)
           Deallocate(buf_lambdaJob,buf_miuJob,buf_qValueJob)
        End Do

     Else

        Do task=1,numberQ
           If(Mod(mpi_rank,mpi_world).Eq.Mod(task-1,mpi_world)) Then
              tag=task
              FILREP=fichier(task); NFIREP=42; INCREP=.False.
              If(debug.Ge.3) Write(6,'("mpi_rank ",i10,", task ",i10,", index_file = ",i10)') &
                                   mpi_rank,task,index_file(task)
              ! Read each file
              Call read_hfodd(NFIREP,FILREP,NUMITE,NXHERM,NYHERM,NZHERM,IPCONT, &
                              ILCONT,IACONT,IMCONT,IRCONT,IRENMA,IRENIN,LIPKIN, &
                              LIPKIP,REFERN,REFERP,REDELN,REDELP,REFE2N,REFE2P, &
                              IFIBLN,INIBLN,IFIBLP,INIBLP,NMUMAX,NSIMAX,NMUCON, &
                                                                 ISHIFT,IERROR)
              ! Make sure to close file if not done before
              Inquire(unit=NFIREP,opened=INCREP); If(INCREP) Close(NFIREP)
              ! Allocate space for current buffers
              Allocate(buf_lambdaJob(numberConstraints),&
                       buf_miuJob(numberConstraints),   &
                       buf_qValueJob(numberConstraints))
              ! For each constraint iq, flex_lambda(iq) contains the lambda value, flex_miu(iq) the miu
              ! value and flex_qlm(iq) the q(lambda,miu) value
              buf_lambdaJob(:)=flex_lambda(:)
              buf_miuJob(:)=flex_miu(:)
              buf_qValueJob(:)=flex_qlm(:)
              tag=  numberQ+task; Call mpi_send(buf_lambdaJob,numberConstraints,MPI_INTEGER,0,tag, &
                                                                                MPI_COMM_WORLD,mpi_err)
              tag=2*numberQ+task; Call mpi_send(buf_miuJob,numberConstraints,MPI_INTEGER,0,tag, &
                                                                             MPI_COMM_WORLD,mpi_err)
              tag=3*numberQ+task; Call mpi_send(buf_qValueJob,numberConstraints,MPI_DOUBLE_PRECISION,0, &
                                                                            tag,MPI_COMM_WORLD,mpi_err)
              Deallocate(buf_lambdaJob,buf_miuJob,buf_qValueJob)
              If(debug.Ge.3) Write(6,'("mpi_rank ",i10," has sent buf_[]")') mpi_rank
           End If
        End Do

     End If
     If(debug.Ge.3) Write(6,'("mpi_rank = ",i10," has gone over the main loop")') mpi_rank

     If(.Not.Allocated(qValueJob)) Then
        Allocate(qValueJob(1:numberQ,1:numberConstraints))
        Allocate(lambdaJob(1:numberQ,1:numberConstraints),miuJob(1:numberQ,1:numberConstraints))
     End If
     If(debug.Ge.1) Write(6,'("mpi_rank = ",i10," has numberConstraints = ",i10)') &
                               mpi_rank, numberConstraints

     Call mpi_barrier(MPI_COMM_WORLD,mpi_err)

     ! Broadcast the full set of multipole constraints to all. First flatten 2D arrays into large vectors
     size_array=numberQ*numberConstraints
     Allocate(buf_lambdaJob(1:size_array),buf_miuJob(1:size_array),buf_qValueJob(1:size_array))
     If(mpi_rank.Eq.0) Then
        counter = 0
        Do task=1,numberQ
           Do iq=1,numberConstraints
              counter=counter+1
              buf_lambdaJob(counter)=lambdaJob(task,iq)
              buf_miuJob(counter)=miuJob(task,iq)
              buf_qValueJob(counter)=qValueJob(task,iq)
           End Do
        End Do
     Else
        buf_lambdaJob(:)=0; buf_miuJob(:)=0; buf_qValueJob(:)=0.0D0
     End If
     Call MPI_Bcast(buf_lambdaJob,size_array,MPI_INTEGER,0,MPI_COMM_WORLD,mpi_err)
     Call MPI_Bcast(buf_miuJob,size_array,MPI_INTEGER,0,MPI_COMM_WORLD,mpi_err)
     Call MPI_Bcast(buf_qValueJob,size_array,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,mpi_err)
     ! Then reconstruct 2D arrays from broadcast vectors
     counter = 0
     Do task=1,numberQ
        Do iq=1,numberConstraints
           counter=counter+1
           lambdaJob(task,iq)=buf_lambdaJob(counter)
           miuJob(task,iq)=buf_miuJob(counter)
           qValueJob(task,iq)=buf_qValueJob(counter)
        End Do
     End Do
     Deallocate(buf_lambdaJob,buf_miuJob,buf_qValueJob)
     If(debug.Ge.4) Then
        If(mpi_rank.Eq.0) Then
           Do task=1,numberQ
              Write(6,'("File number",i10," is ",a68)') task,fichier(task)
              Do iq=1,numberConstraints
                 Write(6,'("l = ",i4," m = ",i4," qlm = ",f10.5)') &
                       lambdaJob(task,iq),miuJob(task,iq),qValueJob(task,iq)
              End Do
           End Do
         End If
     End If
     ! Set original number of constraints and original number of "grid" points
     numberQ_orig = numberQ
     numberConstraints_orig = numberConstraints
     neck_numberPoints = 1

     ! Releasing derived MPI datatype
     Call mpi_type_free(mpi_string_68,mpi_err)

   End Subroutine define_restartPointsQlm

   !---------------------------------------------------------------------!
   !  Function returning the job number embedded in a HFODD record file  !
   !  name, used when modeMPI_deformation = 3 only                       !
   !---------------------------------------------------------------------!
   Integer Function extract_index(filename)

     Character(Len=68), INTENT(IN) :: filename
     Integer :: i

     If(filename(1:1).Eq.'H') Then
        Read(filename,'("HFODD_",i8.8,".REC")') i
        extract_index = i
     End If

   End Function extract_index

   !---------------------------------------------------------------------!
   !  Subroutine reading the list of files to restart from in the case   !
   !  where modeMPI_deformation = 3. Executed only from proc 0           !
   !  Outputs: - numberQ, total number of points on the mesh             !
   !           - fichier(:), list of files to restart from               !
   !---------------------------------------------------------------------!
   Subroutine read_fileList()

     Integer :: unit,counter
     Character(Len=68) :: filename

     unit=41

     ! First pass through the file to count the number of files: defines the initial "mesh"
     counter=0; filename=''
     Open(unit,FILE='hfodd_files.d',STATUS='UNKNOWN',FORM='FORMATTED')
     Do While(trim(filename) .Ne. 'ALL_DONE' .And. trim(filename) .Ne. 'ALL-DONE')
        Read(unit,*) filename
        counter=counter+1
     End Do
     Close(unit)

     numberQ=counter-1

     ! Second pass to actually read the filename
     filename=''
     Allocate(fichier(1:numberQ),index_file(1:numberQ))
     Open(unit,FILE='hfodd_files.d',STATUS='UNKNOWN',FORM='FORMATTED')
     Do counter=1,numberQ
        Read(unit,*) filename
        index_file(counter)=extract_index(filename)
        fichier(counter)='./restart/'//filename(1:60)
     End Do
     Close(unit)

   End Subroutine read_fileList

   !---------------------------------------------------------------------!
   !  Subroutine mapping the default deformation grid to the restart     !
   !  deformation grid. Only used when modeMPI_deformation = 2. For this !
   !  mapping to function, it is assumed that the restart collective     !
   !  space is equal or larger than the original one: there may be more  !
   !  constraints, but not less; the number of points for the shared     !
   !  collective variable may be different.                              !
   !  Outputs: - ii=mapping_qlm(jj) gives the index ii of the original   !
   !             grid used to restart the calculation on point jj of the !
   !             restart grid                                            !
   !           - numberQ, numberConstraints are overwritten and contain  !
   !             the characteristics of the restart collective space     !
   !           - qValueJob(:), lambdaJob(:) and miuJob(:) are similarly  !
   !             associated with the restart grid                        !
   !  TODO: THE CURRENT METHOD MAY BE TAXING THE OS WHEN THE NEW GRID IS !
   !        LARGER THAN THE OLD ONE. INDEED, THE SAME FILE MAY BE READ   !
   !	    BY MANY DIFFERENT PROCESSES, WHICH IS NOT EFFICIENT.         !
   !---------------------------------------------------------------------!
   Subroutine mapping_gridQlm(IF_THO,LIPKIN,LIPKIP)

     Integer, INTENT(IN) :: IF_THO,LIPKIN,LIPKIP
     Integer :: ii,jj,index_optimal,iq,jq,shift,lambda_restart,miu_restart, &
                lambda,miu,mpi_rank,mpi_err,mpi_world,exitstat,pass_number
     Real :: distance_min,distance,qlm_restart,qlm
     Character(Len=132) :: directory_name
     Character(Len=68) :: fichier_courant,fichier_optimal
     Character(Len=150) :: commande

     Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)
     Call mpi_comm_size(MPI_COMM_WORLD,mpi_world,mpi_err)

     ! Default mapping: all new calculations restart from HFODD_00000001.REC
     Allocate(mapping_qlm(1:numberQ_restart))
     Do jj=1,numberQ_restart
        mapping_qlm(jj)=1
     End Do

     ! Move all restart files into current directory
     If(mpi_rank.Eq.0.And.modeMPI_neck.Ne.2) Then
        commande = 'mv restart restart_old'; exitstat=0
        Call system(commande)
        If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                               mpi_rank,commande
        commande = 'mkdir restart'; exitstat=0
        Call system(commande)
        If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                               mpi_rank,commande
        If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
           commande = 'mv lic lic_old'; exitstat=0
           Call system(commande)
           If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                                  mpi_rank,commande
           commande = 'mkdir lic'; exitstat=0
           Call system(commande)
           If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                                  mpi_rank,commande
        End If
        ! In batch mode, restart files will later be overwritten with record files. We make an
        ! additional copy here
        If(batch_mode.Eq.1) Then
           commande = 'mkdir restart_tmp'; exitstat=0
           Call system(commande)
           If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                                  mpi_rank,commande
           If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
              commande = 'mkdir lic_tmp'; exitstat=0
              Call system(commande)
              If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                                     mpi_rank,commande
           End If
        End If
     End If

     ! Wait here for all processes
     Call mpi_barrier(MPI_COMM_WORLD,mpi_err)

     Allocate(fichier_rec_old(1:numberQ_restart),fichier_rec_new(1:numberQ_restart))
     If(IF_THO.Ge.1) Allocate(fichier_tho_old(1:numberQ_restart),fichier_tho_new(1:numberQ_restart))
     If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Allocate(fichier_lic_old(1:numberQ_restart),fichier_lic_new(1:numberQ_restart))
     If(batch_mode.Eq.1) Then
        Allocate(fichier_rec_tmp(1:numberQ_restart))
        If(IF_THO.Ge.1) Allocate(fichier_tho_tmp(1:numberQ_restart))
        If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Allocate(fichier_lic_tmp(1:numberQ_restart))
     End If

     ! Loop over the new grid
     Do jj=1,numberQ_restart

        index_optimal=1; distance_min=1.D9

        ! Loop over the old grid
        Do ii=1,numberQ

           distance = 0.0D0

           ! Loop over the old constraints
           Do iq=1,numberConstraints

              ! Both old and new constraints were read using linked lists. If Nold is the
              ! number of old constraints and Nnew that of the new constraints, we have
              ! Nnew >= Nold (necessarily) and the shared Nold constraints are stored at
              ! the end of lambdaJob(:), lambdaJob_restart(:), etc. To ge the proper
              ! correspondence, we use the shift below
              shift = iq + (numberConstraints_restart - numberConstraints)
              lambda_restart=lambdaJob_restart(jj,shift)
              miu_restart= miuJob_restart(jj,shift)
              qlm_restart=qValueJob_restart(jj,shift)

              lambda=lambdaJob(ii,iq)
              miu=miuJob(ii,iq)
              qlm=qValueJob(ii,iq)

              ! Measuring the distance between point ii (old) and jj (new)
              ! in terms of multipole moments
              If(lambda.Eq.lambda_restart .And. miu.Eq.miu_restart) Then
                 distance = distance + (qlm - qlm_restart)**2
              End If

           End Do

           ! Looking for the point index_optimal that minimizes the distance
           If(distance.Le.distance_min) Then
              distance_min=distance; index_optimal = ii
           End If

        End Do

        ! mv proper file into restart directory with proper name
        If(modeMPI_neck.Ne.2)Then
           Write(fichier_optimal,'("./restart_old/HFODD_",I8.8,".REC")') index_optimal
           Write(fichier_courant,'("./restart/HFODD_",I8.8,".REC")') jj
           fichier_rec_old(jj)=Trim(fichier_optimal)
           fichier_rec_new(jj)=Trim(fichier_courant)
           If(IF_THO.Ge.1) Then
              Write(fichier_optimal,'("./tho/t",I6.6,".hel")') index_optimal
              Write(fichier_courant,'("./t",I6.6,".hel")') jj
              fichier_tho_old(jj)=Trim(fichier_optimal)
              fichier_tho_new(jj)=Trim(fichier_courant)
           End If
           If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
              Write(fichier_optimal,'("./lic_old/HFODD_",I8.8,".LIC")') index_optimal
              Write(fichier_courant,'("./lic/HFODD_",I8.8,".LIC")') jj
              fichier_lic_old(jj)=Trim(fichier_optimal)
              fichier_lic_new(jj)=Trim(fichier_courant)
           End If
           mapping_qlm(jj)=jj
           ! In batch mode, we need to make an extra copy of all these restart files, since they will
           ! be overwritten later
           If(batch_mode.Eq.1) Then
              Write(fichier_courant,'("./restart_tmp/HFODD_",I8.8,".REC")') jj
              fichier_rec_tmp(jj)=Trim(fichier_courant)
              If(IF_THO.Eq.1) Then
                 Write(fichier_courant,'("./t",I6.6,".hel")') jj
                 fichier_tho_tmp(jj)=Trim(fichier_courant)
              End If
              If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
                 Write(fichier_courant,'("./lic_tmp/HFODD_",I8.8,".LIC")') jj
                 fichier_lic_tmp(jj)=Trim(fichier_courant)
              End If
           End If
        Else
           mapping_qlm(jj)=index_optimal
        End If

        If(mpi_rank.Eq.0.And.debug.Ge.4) Then
           Write(6,'("mpi_rank = ",i10," mapping_qlm - jj = ",i10," index_optimal = ",i10)') &
                     mpi_rank,jj,index_optimal
           Do jq=1,numberConstraints_restart
              Write(6,'("RESTART  - mpi_rank = ",i10," l=",i2,"m=",i2," Qlm=",f10.5)') &
                                    mpi_rank,lambdaJob_restart(jj,jq),                 &
                                                miuJob_restart(jj,jq),                 &
                                             qValueJob_restart(jj,jq)
           End do
           Do iq=1,numberConstraints
              Write(6,'("ORIGINAL - mpi_rank = ",i10," l=",i2,"m=",i2," Qlm=",f10.5)') &
                                    mpi_rank,lambdaJob(index_optimal,iq),              &
                                                miuJob(index_optimal,iq),              &
                                 qValueJob(index_optimal,iq)
           End do
        End If

     End Do

     If(modeMPI_neck.Ne.2) Then

     	! Loop over the new grid
     	Do jj=1,numberQ_restart
     	   If(Mod(mpi_rank,mpi_world).Eq.Mod(jj-1,mpi_world)) Then
     	      commande = 'cp '//fichier_rec_old(jj)//' '//fichier_rec_new(jj); exitstat=0
     	      Call system(commande)
     	      If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
     	                                             mpi_rank,jj,commande
     	      If(IF_THO.Ge.1) Then
     	         commande = 'cp '//fichier_tho_old(jj)//' '//fichier_tho_new(jj); exitstat=0
     	         Call system(commande)
     	         If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
     	                                                mpi_rank,jj,commande
     	      End If
     	      If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
     	         commande = 'cp '//fichier_lic_old(jj)//' '//fichier_lic_new(jj); exitstat=0
     	         Call system(commande)
     	         If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
     	                                                mpi_rank,jj,commande
     	      End If
     	      ! Make extra copy in batch mode
     	      If(batch_mode.Eq.1) Then
                 commande = 'cp '//fichier_rec_old(jj)//' '//fichier_rec_tmp(jj); exitstat=0
                 Call system(commande)
                 If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
                                                       mpi_rank,jj,commande
                 If(IF_THO.Ge.1) Then
                    commande = 'cp '//fichier_tho_old(jj)//' '//fichier_tho_tmp(jj); exitstat=0
                    Call system(commande)
                    If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
                                                          mpi_rank,jj,commande
                 End If
     	         If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
     	            commande = 'cp '//fichier_lic_old(jj)//' '//fichier_lic_tmp(jj); exitstat=0
     	            Call system(commande)
     	            If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
     	                                                   mpi_rank,jj,commande
     	         End If
     	      End If
     	   End If
     	End Do

        ! Wait here for all processes
        Call mpi_barrier(MPI_COMM_WORLD,mpi_err)

        ! Check that all files have truly been copied
        Allocate(table_fichiers(1:numberQ_restart)); table_fichiers(:)=0
        directory_name='restart'

        pass_number=1; filled=.False.
        Do While (.Not.filled)

           If(mpi_rank.Eq.0.And.debug.Ge.2) Write(6,'("Pass=",i5)') pass_number
           Call check_directory(directory_name,numberQ_restart)

           Call fill_holes(numberQ_restart,IF_THO,LIPKIN,LIPKIP)

           pass_number=pass_number+1
           If(pass_number.Gt.4) Exit ! avoid infinite loops

        End Do
        Deallocate(table_fichiers)

        ! Check that all files in restart_tmp/ have truly been copied (batch mode)
        If(batch_mode.Eq.1) Then

           Allocate(table_fichiers(1:numberQ_restart)); table_fichiers(:)=0
           directory_name='restart_tmp'

           pass_number=1; filled=.False.
           Do While (.Not.filled)

              If(mpi_rank.Eq.0.And.debug.Ge.2) Write(6,'("Pass =",i5)') pass_number
              Call check_directory(directory_name,numberQ_restart)

              Call fill_holes(numberQ_restart,IF_THO,LIPKIN,LIPKIP)

              pass_number=pass_number+1
              If(pass_number.Gt.4) Exit ! avoid infinite loops

           End Do
           Deallocate(table_fichiers)

     End If

     End If ! End modeMPI_neck.Ne.2

     Deallocate(fichier_rec_old,fichier_rec_new)
     If(IF_THO.Ge.1) Deallocate(fichier_tho_old,fichier_tho_new)
     If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Deallocate(fichier_lic_old,fichier_lic_new)
     If(batch_mode.Eq.1) Then
        Deallocate(fichier_rec_tmp)
        If(IF_THO.Ge.1) Deallocate(fichier_tho_tmp)
        If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Deallocate(fichier_lic_tmp)
     End If

     Deallocate(qValueJob,lambdaJob,miuJob)

     numberQ=numberQ_restart
     numberConstraints=numberConstraints_restart

     Allocate(qValueJob(1:numberQ,1:numberConstraints))
     Allocate(lambdaJob(1:numberQ,1:numberConstraints),miuJob(1:numberQ,1:numberConstraints))
     qValueJob(:,:)=qValueJob_restart(:,:)
     lambdaJob(:,:)=lambdaJob_restart(:,:); miuJob(:,:)=miuJob_restart(:,:)
     Deallocate(qValueJob_restart,lambdaJob_restart,miuJob_restart)

   End Subroutine mapping_gridQlm

   !---------------------------------------------------------------------!
   !  Subroutine mapping the default deformation grid to the restart     !
   !  deformation grid. Only used when modeMPI_deformation >= 3. In this !
   !  case, the original collective space is arbitrary compared to the   !
   !  restart one: it may have more or fewer collective variables, the   !
   !  mesh can be irregular, etc. This is an option meant to provide     !
   !  flexibility.                                                       !
   !  Outputs: - ii=mapping_qlm_new(jj) gives as before the index ii of  !
   !             the original grid used to restart the calculation on    !
   !             point jj of the restart grid                            !
   !           - numberQ, numberConstraints are overwritten and contain  !
   !             the characteristics of the restart collective space     !
   !           - qValueJob(:), lambdaJob(:) and miuJob(:) are similarly  !
   !             associated with the restart grid                        !
   !---------------------------------------------------------------------!
   Subroutine mapping_gridQlm_new(IF_THO,LIPKIN,LIPKIP)

     Integer, INTENT(IN) :: IF_THO,LIPKIN,LIPKIP
     Integer :: ii,jj,index_optimal,iq,jq,lambda_restart,miu_restart, &
                lambda,miu,active,mpi_rank,mpi_err,mpi_world,exitstat,&
                pass_number
     Real :: distance_min,distance,qlm_restart,qlm
     Character(Len=132) :: directory_name
     Character(Len=68) :: fichier_courant,fichier_optimal
     Character(Len=150) :: commande

     Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)
     Call mpi_comm_size(MPI_COMM_WORLD,mpi_world,mpi_err)

     ! Default mapping: all new calculations restart from HFODD_00000001.REC
     Allocate(mapping_qlm_new(1:numberQ_restart))
     Do jj=1,numberQ_restart
        mapping_qlm_new(jj)=1
     End Do

     ! Move all restart files into current directory
     If(mpi_rank.Eq.0) Then
        commande = 'mv restart restart_old'; exitstat=0
        Call system(commande)
        If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                               mpi_rank,commande
        commande = 'mkdir restart'; exitstat=0
        Call system(commande)
        If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                               mpi_rank,commande
        If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
           commande = 'mv lic lic_old'; exitstat=0
           Call system(commande)
           If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                                  mpi_rank,commande
           commande = 'mkdir lic'; exitstat=0
           Call system(commande)
           If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                                  mpi_rank,commande
        End If
        ! In batch mode, restart files will later be overwritten with record files. We make an
        ! additional copy here
        If(batch_mode.Eq.1) Then
           commande = 'mkdir restart_tmp'; exitstat=0
           Call system(commande)
           If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                                  mpi_rank,commande
           If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
              commande = 'mkdir lic_tmp'; exitstat=0
              Call system(commande)
              If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," executed command: ",a)') &
                                                     mpi_rank,commande
           End If
        End If
     End If

     ! Wait here for all processes
     Call mpi_barrier(MPI_COMM_WORLD,mpi_err)

     ! Allocate filenames
     Allocate(fichier_rec_old(1:numberQ_restart),fichier_rec_new(1:numberQ_restart))
     If(IF_THO.Ge.1) Allocate(fichier_tho_old(1:numberQ_restart),fichier_tho_new(1:numberQ_restart))
     If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Allocate(fichier_lic_old(1:numberQ_restart),fichier_lic_new(1:numberQ_restart))
     If(batch_mode.Eq.1) Then
        Allocate(fichier_rec_tmp(1:numberQ_restart))
        If(IF_THO.Ge.1) Allocate(fichier_tho_tmp(1:numberQ_restart))
        If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Allocate(fichier_lic_tmp(1:numberQ_restart))
     End If

     ! Loop over the new grid
     Do jj=1,numberQ_restart

        index_optimal=1; distance_min=1.D9

        ! Loop over the old grid
        Do ii=1,numberQ

           distance=0.0D0; active=0

           ! Loop over the new collective variables (=constraints)
           Do jq=1,numberConstraints_restart
              lambda_restart=lambdaJob_restart(jj,jq)
              miu_restart=miuJob_restart(jj,jq)
              qlm_restart=qValueJob_restart(jj,jq)
              ! Loop over the old collective variables (=constraints)
              Do iq=1,numberConstraints
                 lambda=lambdaJob(ii,iq)
                 miu=miuJob(ii,iq)
                 qlm=qValueJob(ii,iq)
                 ! Measuring the distance between point ii (old) and jj (new)
                 ! in terms of multipole moments
                 If(lambda.Eq.lambda_restart .And. miu.Eq.miu_restart) Then
                    active=active+1
                    distance = distance + (qlm - qlm_restart)**2
                 End If
              End Do
           End Do

           ! Looking for the point index_optimal that minimizes the distance
           If(distance.Le.distance_min.And.active.Gt.0) Then
              distance_min=distance; index_optimal = ii
           End If

        End Do

        ! move proper file into restart directory with proper name
        Write(fichier_optimal,'("./restart_old/HFODD_",I8.8,".REC")') index_file(index_optimal)
        Write(fichier_courant,'("./restart/HFODD_",I8.8,".REC")') jj
        fichier_rec_old(jj)=Trim(fichier_optimal)
        fichier_rec_new(jj)=Trim(fichier_courant)
        If(IF_THO.Ge.1) Then
           Write(fichier_optimal,'("./tho/t",I6.6,".hel")') index_file(index_optimal)
           Write(fichier_courant,'("./t",I6.6,".hel")') jj
           fichier_tho_old(jj)=Trim(fichier_optimal)
           fichier_tho_new(jj)=Trim(fichier_courant)
        End If
        If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
           Write(fichier_optimal,'("./lic_old/HFODD_",I8.8,".LIC")') index_optimal
           Write(fichier_courant,'("./lic/HFODD_",I8.8,".LIC")') jj
           fichier_lic_old(jj)=Trim(fichier_optimal)
           fichier_lic_new(jj)=Trim(fichier_courant)
        End If
        ! In batch mode, we need to make an extra copy of all these restart files, since they will
        ! be overwritten later
        If(batch_mode.Eq.1) Then
           Write(fichier_courant,'("./restart_tmp/HFODD_",I8.8,".REC")') jj
           fichier_rec_tmp(jj)=Trim(fichier_courant)
           If(IF_THO.Eq.1) Then
              Write(fichier_courant,'("./t",I6.6,".hel")') jj
              fichier_tho_tmp(jj)=Trim(fichier_courant)
           End If
           If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
              Write(fichier_courant,'("./lic_tmp/HFODD_",I8.8,".LIC")') jj
              fichier_lic_tmp(jj)=Trim(fichier_courant)
           End If
        End If
        mapping_qlm_new(jj)=jj

        If(mpi_rank.Eq.0.And.debug.Ge.4) Then
           Write(6,'("mpi_rank = ",i10," mapping_qlm_new - jj = ",i10," index_optimal = ",i10)') &
                     mpi_rank,jj,index_file(index_optimal)
           Do jq=1,numberConstraints_restart
              Write(6,'("RESTART  - mpi_rank = ",i10," l=",i2,"m=",i2," Qlm=",f10.5)') &
                                    mpi_rank,lambdaJob_restart(jj,jq),                 &
                                             miuJob_restart(jj,jq),                    &
                                 qValueJob_restart(jj,jq)
           End do
           Do iq=1,numberConstraints
              Write(6,'("ORIGINAL - mpi_rank = ",i10," l=",i2,"m=",i2," Qlm=",f10.5)') &
                                    mpi_rank,lambdaJob(index_optimal,iq),              &
                                              miuJob(index_optimal,iq),                &
                                 qValueJob(index_optimal,iq)
           End do
        End If

     End Do

     ! Loop over the new grid
     Do jj=1,numberQ_restart
        If(Mod(mpi_rank,mpi_world).Eq.Mod(jj-1,mpi_world)) Then
           commande = 'cp '//fichier_rec_old(jj)//' '//fichier_rec_new(jj); exitstat=0
           Call system(commande)
           If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
                                                 mpi_rank,jj,commande
           If(IF_THO.Ge.1) Then
              commande = 'cp '//fichier_tho_old(jj)//' '//fichier_tho_new(jj); exitstat=0
              Call system(commande)
              If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
                                                    mpi_rank,jj,commande
           End If
     	   If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
     	      commande = 'cp '//fichier_lic_old(jj)//' '//fichier_lic_new(jj); exitstat=0
     	      Call system(commande)
     	      If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
     	                                             mpi_rank,jj,commande
     	   End If
     	   ! Make extra copy in batch mode
     	   If(batch_mode.Eq.1) Then
              commande = 'cp '//fichier_rec_old(jj)//' '//fichier_rec_tmp(jj); exitstat=0
              Call system(commande)
              If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
                                                    mpi_rank,jj,commande
              If(IF_THO.Ge.1) Then
                 commande = 'cp '//fichier_tho_old(jj)//' '//fichier_tho_tmp(jj); exitstat=0
                 Call system(commande)
                 If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
                                                       mpi_rank,jj,commande
              End If
     	      If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
     	         commande = 'cp '//fichier_lic_old(jj)//' '//fichier_lic_tmp(jj); exitstat=0
     	         Call system(commande)
     	         If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
     	                                                mpi_rank,jj,commande
     	      End If
     	   End If
        End If
     End Do

     ! Wait here for all processes
     Call mpi_barrier(MPI_COMM_WORLD,mpi_err)

     ! Check that all files in restart/ have truly been copied
     Allocate(table_fichiers(1:numberQ_restart)); table_fichiers(:)=0
     directory_name='restart'

     pass_number=1; filled=.False.
     Do While (.Not.filled)

        If(mpi_rank.Eq.0.And.debug.Ge.2) Write(6,'("Pass =",i5)') pass_number
        Call check_directory(directory_name,numberQ_restart)

        Call fill_holes(numberQ_restart,IF_THO,LIPKIN,LIPKIP)

        pass_number=pass_number+1
        If(pass_number.Gt.4) Exit ! avoid infinite loops

     End Do
     Deallocate(table_fichiers)

     ! Check that all files in restart_tmp/ have truly been copied (batch mode)
     If(batch_mode.Eq.1) Then

        Allocate(table_fichiers(1:numberQ_restart)); table_fichiers(:)=0
        directory_name='restart_tmp'

        pass_number=1; filled=.False.
        Do While (.Not.filled)

           If(mpi_rank.Eq.0.And.debug.Ge.2) Write(6,'("Pass =",i5)') pass_number
           Call check_directory(directory_name,numberQ_restart)

           Call fill_holes(numberQ_restart,IF_THO,LIPKIN,LIPKIP)

           pass_number=pass_number+1
           If(pass_number.Gt.4) Exit ! avoid infinite loops

        End Do
        Deallocate(table_fichiers)
     End If

     Deallocate(fichier_rec_old,fichier_rec_new)
     If(IF_THO.Ge.1) Deallocate(fichier_tho_old,fichier_tho_new)
     If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Deallocate(fichier_lic_old,fichier_lic_new)
     If(batch_mode.Eq.1) Then
        Deallocate(fichier_rec_tmp)
        If(IF_THO.Ge.1) Deallocate(fichier_tho_tmp)
        If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Deallocate(fichier_lic_tmp)
     End If

     Deallocate(qValueJob,lambdaJob,miuJob)

     numberQ=numberQ_restart
     numberConstraints=numberConstraints_restart
     If(mpi_rank.Eq.0.And.debug.Ge.2) &
        Write(6,'("In mapping_gridQlm_new - numberQ =",i10," numberConstraints = ",i5)') numberQ, numberConstraints

     Allocate(qValueJob(1:numberQ,1:numberConstraints))
     Allocate(lambdaJob(1:numberQ,1:numberConstraints),miuJob(1:numberQ,1:numberConstraints))
     qValueJob(:,:)=qValueJob_restart(:,:)
     lambdaJob(:,:)=lambdaJob_restart(:,:); miuJob(:,:)=miuJob_restart(:,:)
     Deallocate(qValueJob_restart,lambdaJob_restart,miuJob_restart)

   End Subroutine mapping_gridQlm_new

   !---------------------------------------------------------------------!
   !  Subroutine mapping the default neck grid to the restart neck grid. !
   !  Outputs: - ii=mapping_neck(jj) gives the index ii of the file used !
   !             to restart the calculation of point jj on the restart   !
   !             grid.                                                   !
   !           - neck_value(:), neck_numberPoints are overwritten and    !
   !             now correspond to the restart grid                      !
   !---------------------------------------------------------------------!
   Subroutine mapping_gridNeck()

     Integer :: ii,jj,index_optimal
     Real :: qn,qn_restart,distance,distance_min

     ! Default mapping: all new calculations restart from HFODD_00000001.REC
     Allocate(mapping_neck(1:neck_numberPoints_restart))
     Do jj=1,neck_numberPoints_restart
        mapping_neck(jj)=1
     End Do

     Do jj=1,neck_numberPoints_restart

        index_optimal=1; distance_min=1.0D9

        Do ii=1,neck_numberPoints

           qn_restart = neck_value_restart(jj)
           qn = neck_value(ii)

           distance = (qn - qn_restart)**2

           If(distance.Le.distance_min) Then
              distance_min=distance; index_optimal = ii
           End If

        End Do

        mapping_neck(jj)=index_optimal
        If(debug.Ge.1) Write(6,'("mapping_gridNeck - jj = ",i10," index_optimal = ",i10)') &
                                                     jj,index_optimal

     End Do

     neck_numberPoints = neck_numberPoints_restart
     Deallocate(neck_value); Allocate(neck_value(1:neck_numberPoints))
     neck_value(:) = neck_value_restart(:)
     Deallocate(neck_value_restart)

   End Subroutine mapping_gridNeck

   !---------------------------------------------------------------------!
   !  Subroutine defining the tasks                                      !
   !  Possible combinations:                                             !
   !     modeMPI_deformation  1  1  2  2  2  3                           !
   !     modeMPI_neck         0  1  0  1  2  0                           !
   !---------------------------------------------------------------------!
   Subroutine mpi_constructJobList(NUMITE,NXHERM,NYHERM,NZHERM,        &
                                   IPCONT,ILCONT,IACONT,IMCONT,IRCONT, &
                                                        IRENMA,IRENIN, &
                                                        LIPKIN,LIPKIP, &
                                                 REFERN,REFERP,REDELN, &
                                                 REDELP,REFE2N,REFE2P, &
                                          IFIBLN,INIBLN,IFIBLP,INIBLP, &
                                          NMUMAX,NSIMAX,NMUCON,ISHIFT, &
                                                               IF_THO, &
                                                               IERROR)

     Integer, INTENT(IN) :: NUMITE,NXHERM,NYHERM,NZHERM,IPCONT,ILCONT,IACONT, &
                            IMCONT,IRCONT,IRENMA,IRENIN,LIPKIN,LIPKIP,IFIBLN, &
                            INIBLN,IFIBLP,INIBLP,NMUMAX,NSIMAX,NMUCON,ISHIFT, &
                            IF_THO
     Integer, INTENT(INOUT) :: IERROR
     Real, INTENT(INOUT) :: REFERN,REFERP,REDELN,REDELP,REFE2N,REFE2P

     Integer :: mpi_rank, mpi_err
     Integer :: iz,in,iq,nCommon,nGridOrig,indexJob_orig,iCommon,force,temperature,idxNeck, &
                idxDefo,iGrid,indexJob,zNumber,nNumber,i_neck,ii,i_shel,i_stat,i_freq,i_defo
     Integer, Allocatable :: zVector(:),nVector(:),mapping_oldGrid(:,:),indexJobVector_orig(:,:)

     Real :: xzNumber, xnNumber
     Real, Allocatable :: xzVector(:),xnVector(:)

     Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)

     If(debug.Ge.1 .And. mpi_rank .Eq.0) &
        Write(6,'("modeMPI_deformation=",i3," modeMPI_neck=",i3," modeMPI_basis=",i3)') &
                          modeMPI_deformation,modeMPI_neck,modeMPI_basis

     ! Define deformation and neck grids
     If(modeMPI_deformation.Le.2) Then
        Call define_gridQlm()
        If(modeMPI_deformation.Eq.2) Then
           Call define_gridQlm_new()
           Call mapping_gridQlm(IF_THO,LIPKIN,LIPKIP)
        End If
        ! If constraints on the size of the neck are active, we define the grids
        If(modeMPI_neck.Ge.1) Then
           Call define_gridNeck()
           If(modeMPI_neck.Eq.1) Then
              ! Default mapping if no constraint on the size of the neck is requested, neck_numberPoints
              ! is preset to 1 in routine mpi_initializeParallelData() of module hfodd_mpiio.f90
              neck_numberPoints_orig=1
              Allocate(mapping_neck(1:neck_numberPoints))
              Do ii=1,neck_numberPoints
                 mapping_neck(ii)=1
              End Do
           Else
              Call define_gridNeck_new()
              Call mapping_gridNeck()
           End If
     Else
           ! Default mapping if no constraint on the size of the neck is requested, neck_numberPoints
           ! is preset to 1 in routine mpi_initializeParallelData() of module hfodd_mpiio.f90
           neck_numberPoints_orig=1
           Allocate(mapping_neck(1:neck_numberPoints))
           Do ii=1,neck_numberPoints
              mapping_neck(ii)=1
           End Do
        End If
     Else
        Call define_restartPointsQlm(NUMITE,NXHERM,NYHERM,NZHERM,IPCONT,ILCONT,IACONT, &
                                     IMCONT,IRCONT,IRENMA,IRENIN,LIPKIN,LIPKIP,REFERN, &
                                     REFERP,REDELN,REDELP,REFE2N,REFE2P,IFIBLN,INIBLN, &
                                     IFIBLP,INIBLP,NMUMAX,NSIMAX,NMUCON,ISHIFT,IF_THO, &
                                                                               IERROR)
        If(modeMPI_deformation.Eq.3) Call define_gridQlm_new()
        If(modeMPI_deformation.Eq.4) Call define_pathQlm_new()
        Call mapping_gridQlm_new(IF_THO,LIPKIN,LIPKIP)
        ! Default mapping since no constraint on the size of the neck is allowed
        neck_numberPoints_orig=neck_numberPoints
        Allocate(mapping_neck(1:neck_numberPoints))
        Do ii=1,neck_numberPoints
           mapping_neck(ii)=ii
        End Do
     End If

     ! default allocations of mapping arrays: if no restart is required, these mappings simply
     ! provide identity vectors (v(i) = i)
     If(modeMPI_deformation.Le.1) Then
        Allocate(mapping_qlm(1:numberQ))
        Do ii=1,numberQ
           mapping_qlm(ii)=ii
           If(debug.Ge.4 .And. mpi_rank .Eq.0) Write(6,'("ii = ",i10," mapping = ",i10)') ii,mapping_qlm(ii)
        End Do
     End If

     ! Define nucleus grid: integers
     Allocate(zVector(1:proton_stepNumber),nVector(1:neutron_stepNumber))
     Do iz=1,proton_stepNumber
        zVector(iz) = proton_initValue + (iz-1)*proton_stepValue
     End Do
     Do in=1, neutron_stepNumber
        nVector(in) = neutron_initValue + (in-1)*neutron_stepValue
     End Do

     ! Define nucleus grid: float
     If(x_proton_initValue.Gt.0.0D0) Then
        Allocate(xzVector(1:proton_stepNumber))
        Do iz=1,proton_stepNumber
           xzVector(iz) = x_proton_initValue + (iz-1)*x_proton_stepValue
        End Do
     End If
     If(x_neutron_initValue.Gt.0.0D0) Then
        Allocate(xnVector(1:neutron_stepNumber))
        Do in=1, neutron_stepNumber
           xnVector(in) = x_neutron_initValue + (in-1)*x_neutron_stepValue
        End Do
     End If

     ! Default deformation mode
     If(modeMPI_deformation.Ge.1.And.modeMPI_deformation.Le.2) Then

        NOFJOB = proton_stepNumber * neutron_stepNumber * counterForce * numberQ &
               * counterTemperature * neck_numberPoints

        Allocate(IZ_JOB(1:NOFJOB),IN_JOB(1:NOFJOB),indexQjob(1:NOFJOB),indexRestartJob(1:NOFJOB),&
                 indexForce(1:NOFJOB),indexTemperature(1:NOFJOB),indexNeck(1:NOFJOB))
        Allocate(XIZJOB(1:NOFJOB),XINJOB(1:NOFJOB)); XIZJOB(:)=-1.0D0; XINJOB(:)=-1.0D0

        nCommon = proton_stepNumber * neutron_stepNumber * counterForce * counterTemperature
        nGridOrig = numberQ * neck_numberPoints_orig
        Allocate(indexJobVector_orig(1:nGridOrig, 1:nCommon))

        indexJob_orig = 0

        If(debug.Ge.1 .And. mpi_rank .Eq.0) Then
           Write(6,'("Sanity checks:")')
           Write(6,'("proton_stepNumber=",i10," neutron_stepNumber=",i10," numberConstraints=",i10)') &
                      proton_stepNumber,neutron_stepNumber,numberConstraints
           Write(6,'("counterForce=",i10," counterTemperature=",i10," restartTemperature=",i10)') &
                      counterForce,counterTemperature,restartTemperature
           Write(6,'("numberQ=",i10," numberQ_orig=",i10," neck_numberPoints=",i10," neck_numberPoints_orig=",i10)') &
                      numberQ,numberQ_orig,neck_numberPoints,neck_numberPoints_orig
        End If

        If(restartTemperature == 0) Then

           iCommon=0

           Allocate(mapping_oldGrid(1:numberQ,1:neck_numberPoints_orig))

           Do iz=1,proton_stepNumber
              Do in=1,neutron_stepNumber
                 Do force=1,counterForce
                    Do temperature=1,counterTemperature

                       iCommon=iCommon+1; iGrid=0

                       Do idxNeck=1,neck_numberPoints_orig
                          Do idxDefo=1,numberQ

                             iGrid=iGrid+1
                             mapping_oldGrid(idxDefo,idxNeck)=iGrid

                             indexJob_orig=indexJob_orig+1
                             indexJobVector_orig(iGrid,iCommon)=indexJob_orig

                          End Do
                       End Do

                    End Do
                 End Do
              End Do
           End Do

           iCommon=0; indexJob=0

           Do iz=1,proton_stepNumber
              zNumber = zVector(iz)
              If(x_proton_initValue.Gt.0.0D0) xzNumber=xzVector(iz)
              Do in=1,neutron_stepNumber
                 nNumber = nVector(in)
                 If(x_neutron_initValue.Gt.0.0D0) xnNumber=xnVector(in)
                 Do force=1,counterForce

                    iCommon = iCommon + 1

                    Do temperature=1,counterTemperature
                       Do i_neck=1,neck_numberPoints
                          Do ii=1,numberQ

                             indexJob=indexJob+1
                             indexQjob(indexJob)=ii

                             indexForce(indexJob)=force
                             indexTemperature(indexJob)=temperature
                             indexNeck(indexJob)=i_neck

                             IZ_JOB(indexJob)=zNumber
                             IN_JOB(indexJob)=nNumber

                             If(x_proton_initValue.Gt.0.0D0) Then
                                XIZJOB(indexJob)=xzNumber
                             Else
                                XIZJOB(indexJob)=Real(zNumber,Kind=Kind(1.0))
                             End If
                             If(x_neutron_initValue.Gt.0.0D0) Then
                                XINJOB(indexJob)=xnNumber
                             Else
                                XINJOB(indexJob)=Real(nNumber,Kind=Kind(1.0))
                             End If

                             idxDefo=mapping_qlm(ii)
                             idxNeck=mapping_neck(i_neck)
                             iGrid=mapping_oldGrid(idxDefo,idxNeck)

                             indexRestartJob(indexJob)=indexJobVector_orig(iGrid,iCommon)

                             If(debug.Ge.4 .And. mpi_rank .Eq.0) Then
                                Do iq=1,numberConstraints
                                   Write(6,'("Z=",i3," N=",i3," force=",a4," T=",f8.4,   &
                                &            " iq=",i2," l=",i2,                         &
                                &         " m=",i2," Qlm=",f10.5," -- RESTART i=",i6)')  &
                                           zNumber,nNumber,                              &
                                           forceVector(indexForce(indexJob)),            &
                                           temperatureVector(temperature),               &
                                           iq,lambdaJob(indexQjob(indexJob),iq),         &
                                           miuJob(indexQjob(indexJob),iq),               &
                                           qValueJob(indexQjob(indexJob),iq),            &
                                           indexJobVector_orig(iGrid,iCommon)
                                End Do
                             End If

                          End Do
                       End Do
                    End Do

                 End Do
              End Do
           End Do

           Deallocate(indexJobVector_orig,mapping_oldGrid,mapping_qlm,mapping_neck)

        Else

           iCommon = 0

           Allocate(mapping_oldGrid(1:numberQ,1:neck_numberPoints_orig))

           Do iz=1,proton_stepNumber
              Do in=1,neutron_stepNumber
                 Do force=1,counterForce
                    Do temperature=1,counterTemperature

                       iCommon=iCommon+1; iGrid=0

                       Do idxNeck=1,neck_numberPoints_orig
                          Do idxDefo=1,numberQ

                             iGrid=iGrid+1
                             mapping_oldGrid(idxDefo,idxNeck)=iGrid

                             indexJob_orig=indexJob_orig+1
                             indexJobVector_orig(iGrid,iCommon)=indexJob_orig

                          End Do
                       End Do

                    End Do
                 End Do
              End Do
           End Do

           iCommon=0; indexJob=0

           Do iz=1,proton_stepNumber
              zNumber = zVector(iz)
              If(x_proton_initValue.Gt.0.0D0) xzNumber=xzVector(iz)
              Do in=1,neutron_stepNumber
                 nNumber = nVector(in)
                 If(x_neutron_initValue.Gt.0.0D0) xnNumber=xnVector(in)
                 Do force=1,counterForce
                    Do temperature=1,counterTemperature

                       iCommon = iCommon + 1

                       Do i_neck=1,neck_numberPoints
                          Do ii=1,numberQ

                             indexJob=indexJob+1
                             indexQjob(indexJob)=ii

                             indexForce(indexJob)=force
                             indexTemperature(indexJob)=temperature
                             indexNeck(indexJob)=i_neck

                             IZ_JOB(indexJob)=zNumber
                             IN_JOB(indexJob)=nNumber

                             If(x_proton_initValue.Gt.0.0D0) Then
                                XIZJOB(indexJob)=xzNumber
                             Else
                                XIZJOB(indexJob)=Real(zNumber,Kind=Kind(1.0))
                             End If
                             If(x_neutron_initValue.Gt.0.0D0) Then
                                XINJOB(indexJob)=xnNumber
                             Else
                                XINJOB(indexJob)=Real(nNumber,Kind=Kind(1.0))
                             End If

                             idxDefo=mapping_qlm(ii)
                             idxNeck=mapping_neck(i_neck)
                             iGrid=mapping_oldGrid(idxDefo, idxNeck)

                             indexRestartJob(indexJob)=indexJobVector_orig(iGrid, iCommon)

                          End Do
                       End Do
                    End Do
                 End Do
              End Do
           End Do

           Deallocate(indexJobVector_orig,mapping_oldGrid,mapping_qlm,mapping_neck)

         End If

     End If

     If(modeMPI_deformation.Ge.3) Then

        NOFJOB = proton_stepNumber * neutron_stepNumber * counterForce * numberQ &
               * counterTemperature * neck_numberPoints

        Allocate(IZ_JOB(1:NOFJOB),IN_JOB(1:NOFJOB),indexQjob(1:NOFJOB),indexRestartJob(1:NOFJOB),&
                 indexForce(1:NOFJOB),indexTemperature(1:NOFJOB),indexNeck(1:NOFJOB))
        Allocate(XIZJOB(1:NOFJOB),XINJOB(1:NOFJOB)); XIZJOB(:)=-1.0D0; XINJOB(:)=-1.0D0

        nCommon = proton_stepNumber * neutron_stepNumber * counterForce * counterTemperature

        iCommon  = 0; indexJob = 0
        Do iz=1,proton_stepNumber
           zNumber = zVector(iz)
           If(x_proton_initValue.Gt.0.0D0) xzNumber=xzVector(iz)
           Do in=1,neutron_stepNumber
              nNumber = nVector(in)
              If(x_neutron_initValue.Gt.0.0D0) xnNumber=xnVector(in)
              Do force=1,counterForce

                 iCommon = iCommon + 1

                 Do temperature=1,counterTemperature
                    Do i_neck=1,neck_numberPoints
                       Do ii=1,numberQ

                          indexJob=indexJob+1
                          indexQjob(indexJob)=ii

                          indexForce(indexJob)=force
                          indexTemperature(indexJob)=temperature
                          indexNeck(indexJob)=i_neck

                          IZ_JOB(indexJob)=zNumber
                          IN_JOB(indexJob)=nNumber

                          If(x_proton_initValue.Gt.0.0D0) Then
                             XIZJOB(indexJob)=xzNumber
                          Else
                             XIZJOB(indexJob)=Real(zNumber,Kind=Kind(1.0))
                          End If
                          If(x_neutron_initValue.Gt.0.0D0) Then
                             XINJOB(indexJob)=xnNumber
                          Else
                             XINJOB(indexJob)=Real(nNumber,Kind=Kind(1.0))
                          End If

                          indexRestartJob(indexJob)=mapping_qlm_new(ii)

                          If(debug.Ge.4 .And. mpi_rank .Eq.0) Then
                             Do iq=1,numberConstraints
                                Write(6,'("Z=",i3," N=",i3," force=",a4," T=",f8.4,   &
                             &            " iq=",i2," l=",i2,                         &
                             &         " m=",i2," Qlm=",f10.5," -- RESTART i=",i6)')  &
                                        zNumber,nNumber,                              &
                                        forceVector(indexForce(indexJob)),            &
                                        temperatureVector(temperature),               &
                                        iq,lambdaJob(indexQjob(indexJob),iq),         &
                                        miuJob(indexQjob(indexJob),iq),               &
                                        qValueJob(indexQjob(indexJob),iq),            &
                                        ii
                             End Do
                          End If

                       End Do
                    End Do
                 End Do

              End Do
           End Do
        End Do

        Deallocate(mapping_qlm_new,mapping_neck)

     End If

     If(modeMPI_basis==1) Then

        Allocate(basis_size(1:basis_size_stepNumber))
        Allocate(basis_states(1:basis_states_stepNumber))
        Allocate(basis_freq(1:basis_frequency_stepNumber))
        Allocate(basis_defo(1:basis_deform_stepNumber))

        Do i_shel=1,basis_size_stepNumber
           basis_size(i_shel) = basis_size_initValue + (i_shel-1)*basis_size_stepValue
        End do
        Do i_stat=1,basis_states_stepNumber
           basis_states(i_stat) = basis_states_initValue + (i_stat-1)*basis_states_stepValue
        End do
        do i_freq=1,basis_frequency_stepNumber
           basis_freq(i_freq) = basis_frequency_initValue + Real(i_freq-1)*basis_frequency_stepValue
        End do
        do i_defo=1,basis_deform_stepNumber
           basis_defo(i_defo) = basis_deform_initValue + Real(i_defo-1)*basis_deform_stepValue
        End do

        NOFJOB = proton_stepNumber * neutron_stepNumber * numberQ   &
               * basis_frequency_stepNumber * basis_deform_stepNumber  &
               * basis_size_stepNumber * basis_states_stepNumber * counterForce

        Allocate(IZ_JOB(1:NOFJOB),IN_JOB(1:NOFJOB),indexQjob(1:NOFJOB),indexForce(1:NOFJOB),&
                 indexSizeJob(1:NOFJOB),indexStatesJob(1:NOFJOB),indexLengthJob(1:NOFJOB),  &
                 idxDeformJob(1:NOFJOB))
        Allocate(XIZJOB(1:NOFJOB),XINJOB(1:NOFJOB)); XIZJOB(:)=-1.0D0; XINJOB(:)=-1.0D0

        indexJob = 0

        Do iz=1,proton_stepNumber
           zNumber = zVector(iz)
           If(x_proton_initValue.Gt.0.0D0) xzNumber=xzVector(iz)
           Do in=1,neutron_stepNumber
              nNumber = nVector(in)
              If(x_neutron_initValue.Gt.0.0D0) xnNumber=xnVector(in)
              Do force=1,counterForce
                  Do ii=1,numberQ
                     Do i_shel=1,basis_size_stepNumber
                        Do i_stat=1,basis_states_stepNumber
                           Do i_freq=1,basis_frequency_stepNumber
                              Do i_defo=1,basis_deform_stepNumber

                                 indexJob = indexJob + 1

                                 IZ_JOB(indexJob)=zNumber
                                 IN_JOB(indexJob)=nNumber

                                 If(x_proton_initValue.Gt.0.0D0) Then
                                    XIZJOB(indexJob)=xzNumber
                                 Else
                                    XIZJOB(indexJob)=Real(zNumber,Kind=Kind(1.0))
                                 End If
                                 If(x_neutron_initValue.Gt.0.0D0) Then
                                    XINJOB(indexJob)=xnNumber
                                 Else
                                    XINJOB(indexJob)=Real(nNumber,Kind=Kind(1.0))
                                 End If

                                 indexQjob(indexJob)=ii
                                 indexForce(indexJob)=force

                                 indexSizeJob(indexJob)=i_shel
                                 indexStatesJob(indexJob)=i_stat
                                 indexLengthJob(indexJob)=i_freq
                                 idxDeformJob(indexJob)=i_defo

                              End Do
                           End Do
                        End Do
                     End Do
                  End Do
              End Do
           End Do
        End Do

     End If

  End Subroutine mpi_constructJobList

  !---------------------------------------------------------------------!
  !  Subroutine setting local (process-wise) HFODD variables based on   !
  !  existing list of tasks. Routine executed by each process.          !
  !---------------------------------------------------------------------!
  Subroutine mpi_getCurrentData(INDJOB,IN_FIX,IZ_FIX,SKYRME,GOGNAM, &
                                              INSIQN,IPSIQN,IDSIQN, &
                                              INSIQP,IPSIQP,IDSIQP, &
                                       INSIGN,IPSIGN,ISSIGN,IDSIGN, &
                                       INSIGP,IPSIGP,ISSIGP,IDSIGP, &
                                       ICONTI,IPCONT,ILCONT,IFCONT, &
                                                            I_GOGA, &
                                       SLOWEV,SLOWOD,SLOWPA,SLOWLI, &
                                                            IROTAT, &
                                                            NILXYZ, &
                                                            N_EXIT, &
                                                            NOITER, &
                                              FCHOM0,NOSCIL,NLIMIT, &
                                                     LIPKIN,LIPKIP, &
                                       NXHERM,NYHERM,NZHERM,IOPTGS, &
                                              IPAIRI,IPAHFB,IMFHFB, &
                                                            IWRILI, &
                                                            EPSITE, &
                                                            INIROT, &
                                                            IGAMMA, &
                                                            LANODD, &
                                       IFIBLN,INIBLN,IFIBLP,INIBLP, &
                                                            NMUCON, &
                                                            IFSHEL, &
                                                            IF_RPA, &
                                                            INDFIL, &
                                                            TEMP_T)

     Use hfodd_sizes

     Integer :: INDJOB,IN_FIX,IZ_FIX,INSIQN,IPSIQN,IDSIQN,INSIQP,IPSIQP,IDSIQP,&
                INSIGN,IPSIGN,ISSIGN,IDSIGN,INSIGP,IPSIGP,ISSIGP,IDSIGP,ICONTI,&
                IPCONT,ILCONT,IROTAT,NILXYZ,N_EXIT,NOITER,NOSCIL,NLIMIT,LIPKIN,&
                LIPKIP,NXHERM,NYHERM,NZHERM,IOPTGS,IPAIRI,IPAHFB,IMFHFB,IWRILI,&
                IFCONT,INIROT,IGAMMA,LANODD,IFIBLN,INIBLN,IFIBLP,INIBLP,NMUCON,&
                IFSHEL,IF_RPA,INDFIL,I_GOGA

     Integer :: IFLAGQ,IFLALQ,indexQ,ii,LAMBDA,MIU,IFNECK
     Integer :: i_shel,i_stat,i_freq,i_defo,force,temperature,i_neck,is_deformed
     Integer :: mpi_rank,mpi_err

     Character(Len=4) :: SKYRME,GOGNAM

     Real :: SLOWEV,SLOWOD,SLOWPA,SLOWLI,EPSITE,FCHOM0,STIFFQ, &
             QASKED,GALMUQ,QLINEA,Q0NECK,G_NECK,HBMASS,HBMRPA, &
             HBMINP,H_BARC,XMASSP,XMASSN,HBCOE2,HBAROX,HBAROY, &
             HBAROZ,HOMSCA,ALPHAR,TEMP_T,PIARGU,OVALUE,A_MASS, &
             HOMEGA,XINFIX,XIZFIX

     COMMON                                           &
            /FLOPAR/ XIZFIX,XINFIX
     COMMON                                           &
            /NCKVAL/ Q0NECK,G_NECK                    &
            /NCKFLA/ IFNECK
     COMMON                                           &
            /REALPH/ ALPHAR(0:NDLAMB,0:NDLAMB)
     COMMON                                           &
            /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT), &
                     QASKED(0:NDMULT,-NDMULT:NDMULT), &
                     IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
     COMMON                                           &
            /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT), &
                     QLINEA(0:NDMULT,-NDMULT:NDMULT), &
                     IFLALQ(0:NDMULT,-NDMULT:NDMULT)
     COMMON                                           &
            /PLANCK/ HBMASS,HBMRPA,HBMINP
     COMMON                                           &
            /PHYCON/ H_BARC,XMASSP,XMASSN,HBCOE2
     COMMON                                           &
            /BASPAR/ HBAROX,HBAROY,HBAROZ             &
            /SCALNG/ HOMSCA(NDKART,NDTWCE)

     Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)

     ! Set proton, neutron number and Skyrme functional
     IN_FIX=IN_JOB(INDJOB); IZ_FIX=IZ_JOB(INDJOB)
     XINFIX=XINJOB(INDJOB); XIZFIX=XIZJOB(INDJOB)
     If(debug.Ge.1) Write(6,'("In mpi_getCurrentData - mpi_rank = ",i10," XN = ",f20.14," XZ = ",f20.14)') &
                                                       mpi_rank, XINFIX, XIZFIX
     If(I_GOGA.Gt.0) Then
        force=indexForce(INDJOB)
        GOGNAM=forceVector(force)
        SKYRME=GOGNAM
     Else
        force=indexForce(INDJOB)
        SKYRME=forceVector(force)
     End If

     ! Set temperature and index of the restart file (assumed to be in restart/ directory,
     ! and to have the generic form HFODD_XXXXXXXX.REC, where XXXXXXXX is a 8 digit integer
     If(modeMPI_deformation.Ge.1.Or.modeMPI_neck.Ge.1) Then
        temperature=indexTemperature(INDJOB)
        TEMP_T=temperatureVector(temperature)
        INDFIL=indexRestartJob(INDJOB)
        If(debug.Ge.1) Write(6,'("In mpi_getCurrentData - mpi_rank = ",i10," INDFIL = ",i10)') &
                                                          mpi_rank,INDFIL
     End If

     ! Set constraint on the neck, and active it
     If(modeMPI_neck.Ge.1) Then
        IFNECK=2
        i_neck=indexNeck(INDJOB)
        Q0NECK=neck_value(i_neck)
     End If

     ! Set constraints on multipole moments, and activate constraints
     indexQ=indexQjob(INDJOB)
     If(debug.Ge.1) Write(6,'("In mpi_getCurrentData - mpi_rank = ",i10," INDJOB = ",i10," indexQ = ",i10)') &
                                                       mpi_rank,INDJOB,indexQ
     Do ii=1,numberConstraints
        LAMBDA=Abs(lambdaJob(indexQ,ii))
        If(LAMBDA.Ge.NMUCON) NMUCON=LAMBDA
        MIU = miuJob(indexQ, ii)
        QASKED(LAMBDA,MIU) = qValueJob(indexQ, ii)
                                  IFLAGQ(LAMBDA,MIU) = 0
        If(turnConstraintOn.Eq.1) IFLAGQ(LAMBDA,MIU) = 1
                        IFLALQ(LAMBDA,MIU) = 0
        If(IF_RPA.Eq.1) IFLALQ(LAMBDA,MIU) =-1 ! RPA
        STIFFQ(LAMBDA,MIU) = 0.5D0
     End Do

     ! Set characteristics of the basis for this process
     If(modeMPI_basis.Eq.1) Then

        i_shel=indexSizeJob(INDJOB)
        i_stat=indexStatesJob(INDJOB)
        i_freq=indexLengthJob(INDJOB)
        i_defo=idxDeformJob(INDJOB)

        ! Number of shells and number of states
        NOSCIL = basis_size(i_shel)
        NLIMIT = basis_states(i_stat)

        ! Check if the requested configuration is deformed
        is_deformed = 0
        Do lambda=0,NDMULT
           Do miu=0,NDMULT
              If(QASKED(LAMBDA,MIU).Gt.1.D-12) Then
                 If(debug.Ge.4) Write(6,'("LAMBDA = ",i2," MIU = ",i2," QASKED = ",f20.14)') &
                                     LAMBDA,MIU,QASKED(LAMBDA,MIU)
                 is_deformed = 1
              End If
           End Do
        End Do
        ! Set frequency and deformation of the basis
        A_MASS=Real(IZ_FIX+IN_FIX); HOMEGA=41.0D0/A_MASS**(1.0D0/3.0D0)
        OVALUE=basis_freq(i_freq); FCHOM0=OVALUE/HOMEGA
        ALPHAR(2,0)=basis_defo(i_defo)
        If(debug.Ge.1) Write(6,'("NOSCIL=",i4," NLIMIT=",i4," FCHOM0=",f10.5," ALPHAR=",f10.5)') &
                             NOSCIL,NLIMIT,FCHOM0,ALPHAR(2,0)

     End If

   End Subroutine mpi_getCurrentData

   !---------------------------------------------------------------------!
   !  Subroutine that allows to redefine the requested values of the     !
   !  constraints based on the values of Qlm read from disk. This is     !
   !  used in restart mode only to effectively constrain previously free !
   !  collective variables.                                              !
   !  Example: Run 1 - Q20 grid, Q40 unconstrained                       !
   !           Run 2 - Same Q20 grid, new Q40 grid between 0 and 50.     !
   !                   Calling mpi_pathExploration will recenter the Q40 !
   !                   grid around the equilibrium values of Q40 from    !
   !                   Run 1.                                            !
   !---------------------------------------------------------------------!
   Subroutine mpi_pathExploration(IERROR,NMUCON)

     Use hfodd_sizes

     Integer :: IERROR,NMUCON,ITITLE,NFIPRI,IFLAGQ,LAMACT,MIUACT,i,lambda,miu

     Real :: QOLDIE,QSHIFT,STIFFQ,QASKED,QMUL_T,QMUL_P,QMUL_N

     COMMON                                           &
            /CFIPRI/ NFIPRI
     COMMON                                           &
            /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT), &
                     QASKED(0:NDMULT,-NDMULT:NDMULT), &
                     IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
     COMMON                                           &
            /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT), &
                     QMUL_P(0:NDMULT,-NDMULT:NDMULT), &
                     QMUL_T(0:NDMULT,-NDMULT:NDMULT)

     If(modeMPI_deformation.Eq.2.And.optimizePath.Eq.1.And.IERROR.Eq.0) Then

        ! Readjustement only for extra constraints not included in the original run
        Do i=1,numberConstraints
           LAMACT=qLambda_restart(i)
           MIUACT=qMiu_restart(i)
           QOLDIE=QASKED(LAMACT,MIUACT) ! Original value requested
           QSHIFT=QMUL_T(LAMACT,MIUACT) - qinitValue_restart(i) &
                                   -0.5D0*(qFinValue_restart(i) - qinitValue_restart(i))
           QASKED(LAMACT,MIUACT)=QSHIFT+QASKED(LAMACT,MIUACT) ! new value centered on unconstrained result
        End Do

        ! Displaying a message with the new values of the constraints
        Write(NFIPRI,'("*",77X,"*")')
        ITITLE=0
        Do lambda=1,NMUCON
           Do miu=-lambda,lambda
              If(IFLAGQ(lambda,miu).Eq.1) Then
                 If(ITITLE.Eq.0) Then
                     Write(NFIPRI,'(79("*"),/,"*",77X,"*")')
                     Write(NFIPRI,'("*",1X,"UPDATED MULTIPOLE CONSTRAINTS: ",&
                    &     "LAMBDA=",I2,"  MIU=",I2,2X,"MOMENT=",F7.3,12X,"*")') &
                           lambda,miu,QASKED(lambda,miu)
                     ITITLE=1
                 Else
                     Write(NFIPRI,'("*",32X,"LAMBDA=",I2,"  MIU=",I2,2X,"MOMENT=",F7.3,12X,"*")') &
                           lambda,miu,QASKED(lambda,miu)
                 End If
              End If
           End Do
        End Do

     End If

   End Subroutine mpi_pathExploration

   !---------------------------------------------------------------------!
   !  Subroutine reading the HFODD record file. It is a modified version !
   !  of routine RECORD(), where storage of big arrays is made through   !
   !  allocatable Fortran arrays.                                        !
   !---------------------------------------------------------------------!
   Subroutine read_hfodd(NFIREP,FILREP,NUMITE,NXHERM,NYHERM,NZHERM,IPCONT, &
                         ILCONT,IACONT,IMCONT,IRCONT,IRENMA,IRENIN,LIPKIN, &
                         LIPKIP,REFERN,REFERP,REDELN,REDELP,REFE2N,REFE2P, &
                         IFIBLN,INIBLN,IFIBLP,INIBLP,NMUMAX,NSIMAX,NMUCON, &
                                                            ISHIFT,IERROR)

     Use hfodd_sizes

     Integer :: currentVersion, minimalVersion, mpi_rank, mpi_err, iq
     Integer :: IX,IY,IZ,K,L,LDBASE,NFIPRI,IFNECK,IFIRED,LAMBDA,MIU, &
                NFIREP,NUMITE,NXHERM,NYHERM,NZHERM,MDMULT,IPCONT,    &
                ILCONT,IACONT,IMCONT,IRCONT,IRENMA,IRENIN,LIPKIN,    &
                LIPKIP,IFIBLN,INIBLN,IFIBLP,INIBLP,NMUMAX,NSIMAX,    &
                NMUCON,ISHIFT,IERROR,IVERIN,MXHERM,MYHERM,MZHERM,    &
                MMUMAX,MSIMAX,MDBASE,ICHARG,IREVER,KARTEZ,IBASE,ii
     Integer, Allocatable :: IFLALQ(:,:),IFLALS(:,:),IDEBLO(:)

     character(Len=68) :: FILREP

     Real :: REFERN,REFERP,REDELN,REDELP,REFE2N,REFE2P,Q0NECK,G_NECK,DUMMY
     Real, Allocatable :: ANGU_N(:),ANGU_P(:),ANGU_T(:),SPIN_N(:),SPIN_P(:),SPIN_T(:)
     Real, Allocatable :: QMUL_N(:,:),QMUL_P(:,:),QMUL_T(:,:),SMUL_N(:,:),SMUL_P(:,:), &
                          SMUL_T(:,:),GALMUQ(:,:),QLINEA(:,:),GALMUS(:,:),SLINEA(:,:), &
                          RALMUQ(:,:),RALMUS(:,:)
     Real, Allocatable :: FERINI(:),DELINI(:),FE2INI(:),RSHIFT(:),HBMREN(:),ROTREN(:), &
                                      HBMREA(:),ROTREA(:)
     Real, Allocatable :: DLINSN(:),DLINSP(:),DLINST(:),ELINSN(:),ELINSP(:),ELINST(:), &
                          TLINSN(:),TLINSP(:),TLINST(:),ALINLN(:),ALINLP(:),ALINLT(:), &
                          DROTSN(:),DROTSP(:),DROTST(:),EROTSN(:),EROTSP(:),EROTST(:), &
                          TROTSN(:),TROTSP(:),TROTST(:),AROTLN(:),AROTLP(:),AROTLT(:)
     Real, Allocatable :: VN_MAS(:,:,:),VN_CEN(:,:,:),VP_MAS(:,:,:),VP_CEN(:,:,:), &
                          DPRRHO(:,:,:),DNRRHO(:,:,:)
     Real, Allocatable :: VN_KIS(:,:,:,:),VN_SPI(:,:,:,:),VN_CUR(:,:,:,:), &
                          VP_KIS(:,:,:,:),VP_SPI(:,:,:,:),VP_CUR(:,:,:,:)
     Real, Allocatable :: VN_SOR(:,:,:,:,:),VP_SOR(:,:,:,:,:)

     Complex :: C_ZERO
     Complex, Allocatable :: DN_RHO(:,:,:),DN_TAU(:,:,:),DN_LPR(:,:,:),DN_DIV(:,:,:), &
                             DP_RHO(:,:,:),DP_TAU(:,:,:),DP_LPR(:,:,:),DP_DIV(:,:,:),&
                             WN_CEN(:,:,:),WP_CEN(:,:,:),WAVBLO(:,:,:)
     Complex, Allocatable :: DN_SPI(:,:,:,:),DN_KIS(:,:,:,:),DN_GRR(:,:,:,:),DN_LPS(:,:,:,:),&
                             DN_ROS(:,:,:,:),DN_ROC(:,:,:,:),DN_CUR(:,:,:,:),                &
                             DP_SPI(:,:,:,:),DP_KIS(:,:,:,:),DP_GRR(:,:,:,:),DP_LPS(:,:,:,:),&
                             DP_ROS(:,:,:,:),DP_ROC(:,:,:,:),DP_CUR(:,:,:,:)
     Complex, Allocatable :: DN_SCU(:,:,:,:,:),DN_DES(:,:,:,:,:),DP_SCU(:,:,:,:,:),DP_DES(:,:,:,:,:)

     COMMON                 &
            /DIMENS/ LDBASE
     COMMON                 &
            /CFIPRI/ NFIPRI
     COMMON                 &
            /NCKFLA/ IFNECK

     C_ZERO=Cmplx(0.0D0,0.0D0)

     currentVersion = 16; minimalVersion =  4

     Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)

     Open(UNIT=NFIREP,FILE=FILREP,STATUS='OLD',FORM='UNFORMATTED',IOSTAT=IERROR)
     If(IERROR.Ne.0) Then
         Write(NFIPRI,'("read_hfodd() - Error in opening file ",i5)') NFIREP
         Return
     End If

     IFIRED=0

     Read(NFIREP,IOSTAT=IERROR) IVERIN
     If(IERROR.Ne.0) Then
         Write(NFIPRI,'("read_hfodd() - error in reading IVERIN")')
         Return
     End If

     If(.Not.Allocated(WN_CEN)) &
        Allocate(WN_CEN(NDXHRM,NDYHRM,NDZHRM),VN_MAS(NDXHRM,NDYHRM,NDZHRM),VN_CEN(NDXHRM,NDYHRM,NDZHRM),&
                 WP_CEN(NDXHRM,NDYHRM,NDZHRM),VP_MAS(NDXHRM,NDYHRM,NDZHRM),VP_CEN(NDXHRM,NDYHRM,NDZHRM))
     If(.Not.Allocated(VN_KIS)) &
        Allocate(VN_KIS(NDXHRM,NDYHRM,NDZHRM,NDKART),VN_SPI(NDXHRM,NDYHRM,NDZHRM,NDKART),&
                 VN_CUR(NDXHRM,NDYHRM,NDZHRM,NDKART),VP_KIS(NDXHRM,NDYHRM,NDZHRM,NDKART),&
                 VP_SPI(NDXHRM,NDYHRM,NDZHRM,NDKART),VP_CUR(NDXHRM,NDYHRM,NDZHRM,NDKART))
     If(.Not.Allocated(VN_SOR)) &
        Allocate(VN_SOR(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART),VP_SOR(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART))

     If(.Not.Allocated(DN_RHO)) &
        Allocate(DN_RHO(NDXHRM,NDYHRM,NDZHRM),DN_TAU(NDXHRM,NDYHRM,NDZHRM),DN_LPR(NDXHRM,NDYHRM,NDZHRM),&
                 DN_DIV(NDXHRM,NDYHRM,NDZHRM),DP_RHO(NDXHRM,NDYHRM,NDZHRM),DP_TAU(NDXHRM,NDYHRM,NDZHRM),&
                 DP_LPR(NDXHRM,NDYHRM,NDZHRM),DP_DIV(NDXHRM,NDYHRM,NDZHRM))
     If(.Not.Allocated(DN_SPI)) &
        Allocate(DN_SPI(NDXHRM,NDYHRM,NDZHRM,NDKART),DN_KIS(NDXHRM,NDYHRM,NDZHRM,NDKART),&
                 DN_GRR(NDXHRM,NDYHRM,NDZHRM,NDKART),DN_LPS(NDXHRM,NDYHRM,NDZHRM,NDKART),&
                 DN_ROS(NDXHRM,NDYHRM,NDZHRM,NDKART),DN_ROC(NDXHRM,NDYHRM,NDZHRM,NDKART),&
                 DN_CUR(NDXHRM,NDYHRM,NDZHRM,NDKART))
     If(.Not.Allocated(DP_SPI)) &
        Allocate(DP_SPI(NDXHRM,NDYHRM,NDZHRM,NDKART),DP_KIS(NDXHRM,NDYHRM,NDZHRM,NDKART),&
                 DP_GRR(NDXHRM,NDYHRM,NDZHRM,NDKART),DP_LPS(NDXHRM,NDYHRM,NDZHRM,NDKART),&
                 DP_ROS(NDXHRM,NDYHRM,NDZHRM,NDKART),DP_ROC(NDXHRM,NDYHRM,NDZHRM,NDKART),&
                 DP_CUR(NDXHRM,NDYHRM,NDZHRM,NDKART))
     If(.Not.Allocated(DN_SCU)) &
        Allocate(DN_SCU(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART),DN_DES(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART),&
                 DP_SCU(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART),DP_DES(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART))

     If(.Not.Allocated(ANGU_N)) &
        Allocate(ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART),&
                 SPIN_N(1:NDKART),SPIN_P(1:NDKART),SPIN_T(1:NDKART))

     If(.Not.Allocated(QMUL_N)) &
        Allocate(QMUL_N(0:NDMULT,-NDMULT:NDMULT),QMUL_P(0:NDMULT,-NDMULT:NDMULT),QMUL_T(0:NDMULT,-NDMULT:NDMULT),&
                 SMUL_N(0:NDMULT,-NDMULT:NDMULT),SMUL_P(0:NDMULT,-NDMULT:NDMULT),SMUL_T(0:NDMULT,-NDMULT:NDMULT),&
                 GALMUQ(0:NDMULT,-NDMULT:NDMULT),QLINEA(0:NDMULT,-NDMULT:NDMULT),RALMUQ(0:NDMULT,-NDMULT:NDMULT),&
                 GALMUS(0:NDMULT,-NDMULT:NDMULT),SLINEA(0:NDMULT,-NDMULT:NDMULT),RALMUS(0:NDMULT,-NDMULT:NDMULT))
     If(.Not.Allocated(IFLALQ)) &
        Allocate(IFLALQ(0:NDMULT,-NDMULT:NDMULT),IFLALS(0:NDMULT,-NDMULT:NDMULT))

     If(.Not.Allocated(FERINI)) &
        Allocate(FERINI(0:NDISOS),DELINI(0:NDISOS),FE2INI(0:NDISOS),RSHIFT(1:NDKART),&
                 HBMREN(1:NDKART),ROTREN(1:NDKART),HBMREA(1:NDKART),ROTREA(1:NDKART))

     If(.Not.Allocated(DLINSN)) &
        Allocate(DLINSN(0:NDKART),DLINSP(0:NDKART),DLINST(0:NDKART), &
                 ELINSN(0:NDKART),ELINSP(0:NDKART),ELINST(0:NDKART), &
                 TLINSN(0:NDKART),TLINSP(0:NDKART),TLINST(0:NDKART), &
                 ALINLN(0:NDKART),ALINLP(0:NDKART),ALINLT(0:NDKART), &
                 DROTSN(0:NDKART),DROTSP(0:NDKART),DROTST(0:NDKART), &
                 EROTSN(0:NDKART),EROTSP(0:NDKART),EROTST(0:NDKART), &
                 TROTSN(0:NDKART),TROTSP(0:NDKART),TROTST(0:NDKART), &
                 AROTLN(0:NDKART),AROTLP(0:NDKART),AROTLT(0:NDKART))

     If(.Not.Allocated(WAVBLO)) &
        Allocate(WAVBLO(1:2*NDBASE,0:NDISOS,0:NDREVE))
     If(.Not.Allocated(IDEBLO)) &
        Allocate(IDEBLO(0:NDISOS))

     If(IVERIN.Ge.minimalVersion.AND.IVERIN.Le.currentVersion) Then

        Read(NFIREP,IOSTAT=IERROR) NUMITE
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading NUMITE")')
           Return
        End If

        Read(NFIREP,IOSTAT=IERROR) MXHERM,MYHERM,MZHERM
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading MXHERM")')
           Return
        End If

        If(MXHERM.Ne.NXHERM.OR.MYHERM.Ne.NYHERM.OR.MZHERM.Ne.NZHERM) Then
           Write(NFIPRI,'(1X,19("/"),"  WRONG NXHERM,NYHERM,NZHERM:",3I3,2X,19("/"))') MXHERM,MYHERM,MZHERM
           Stop '  WRONG NXHERM,NYHERM,NZHERM IN RECORD'
        End If

        Read(NFIREP,IOSTAT=IERROR) (((VN_MAS(IX,IY,IZ),VN_CEN(IX,IY,IZ),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading VN_MAS")')
           Return
        End If

        Read(NFIREP,IOSTAT=IERROR) ((((VN_KIS(IX,IY,IZ,L),VN_SPI(IX,IY,IZ,L),VN_CUR(IX,IY,IZ,L), &
                                               IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM),L=1,NDKART)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading VN_KIS")')
           Return
        End If

        Read(NFIREP,IOSTAT=IERROR) (((((VN_SOR(IX,IY,IZ,L,K),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM),L=1,NDKART),&
                                                                                                    K=1,NDKART)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading VN_SOR")')
           Return
        End If

        Read(NFIREP,IOSTAT=IERROR) (((VP_MAS(IX,IY,IZ),VP_CEN(IX,IY,IZ),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading VP_MAS")')
           Return
        End If

        Read(NFIREP,IOSTAT=IERROR) ((((VP_KIS(IX,IY,IZ,L),VP_SPI(IX,IY,IZ,L),VP_CUR(IX,IY,IZ,L), &
                                               IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM),L=1,NDKART)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading VP_KIS")')
           Return
        End If

        Read(NFIREP,IOSTAT=IERROR) (((((VP_SOR(IX,IY,IZ,L,K),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM),L=1,NDKART),&
                                                                                                    K=1,NDKART)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading VP_SOR")')
           Return
        End If

        If(IVERIN.Le.6) Then

           If(IVERIN.Gt.5) Then
               Read(NFIREP,IOSTAT=IERROR) (((DNRRHO(IX,IY,IZ),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
               If(IERROR.Ne.0) Then
                   Write(NFIPRI,'("read_hfodd() - Error in reading DNRRHO")')
                   Return
               End If
           Else
               DNRRHO(:,:,:)=0.0D0
           End If

           Read(NFIREP,IOSTAT=IERROR) (((DPRRHO(IX,IY,IZ),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading DPRRHO")')
              Return
           End If
           DN_RHO(:,:,:)=DNRRHO(:,:,:)*cmplx(1.0d0,0.0d0)
           DP_RHO(:,:,:)=DPRRHO(:,:,:)*cmplx(1.0d0,0.0d0)

        Else

           Read(NFIREP,IOSTAT=IERROR) (((DN_RHO(IX,IY,IZ),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading DN_RHO")')
              Return
           End If

           Read(NFIREP,IOSTAT=IERROR)(((DP_RHO(IX,IY,IZ),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading DP_RHO")')
              Return
           End If

        End If

        Read(NFIREP,IOSTAT=IERROR) MMUMAX
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading NMUMAX")')
           Return
        End If

        If(MMUMAX.Lt.NMUMAX) Then

           Write(NFIPRI,'(1X,20("/"),"  WARNING:  TOO FEW MULTIPOLE MOMENTS",1X,20("/"))')
           Write(NFIPRI,'(1X,20("/"),"  FOUND ON THE REPLAY FILE.          ",1X,20("/"))')
           Write(NFIPRI,'(1X,20("/"),"  REQUESTED MAXIMUM  MULTIPOLARITY=",I2,1X,20("/"))') NMUMAX
           Write(NFIPRI,'(1X,20("/"),"  FOUND     MAXIMUM  MULTIPOLARITY=",I2,1X,20("/"))') MMUMAX
           Write(NFIPRI,'(1X,20("/"),"  A CONSTRAINT ON A MISSING MULTIPOLE",1X,20("/"))')
           Write(NFIPRI,'(1X,20("/"),"  WILL BE  INCLUDED  ONLY  AFTER  THE",1X,20("/"))')
           Write(NFIPRI,'(1X,20("/"),"  FIRST DIAGONALIZATION IS  PERFORMED",1X,20("/"))')

           Do LAMBDA=MMUMAX+1,NMUMAX
              Do MIU=-LAMBDA,LAMBDA
                 QMUL_N(LAMBDA,MIU)=0.0D0
                 QMUL_P(LAMBDA,MIU)=0.0D0
                 QMUL_T(LAMBDA,MIU)=0.0D0
              End Do
           End Do

        End If

        Read(NFIREP,IOSTAT=IERROR) ((QMUL_N(LAMBDA,MIU),QMUL_P(LAMBDA,MIU),QMUL_T(LAMBDA,MIU), &
                                                    MIU=-LAMBDA,LAMBDA),LAMBDA=0,MMUMAX)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading QMUL_N")')
           Return
        End If

        Do LAMBDA=0,NSIMAX
           Do MIU=-LAMBDA,LAMBDA
              SMUL_N(LAMBDA,MIU)=0.0D0
              SMUL_P(LAMBDA,MIU)=0.0D0
              SMUL_T(LAMBDA,MIU)=0.0D0
           End Do
        End Do

        If(IVERIN.Gt.4) Then

           Read(NFIREP,IOSTAT=IERROR) MSIMAX
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading MSIMAX")')
              Return
           End If

           If(MSIMAX.Lt.NSIMAX) Then

              Write(NFIPRI,'(1X,20(1H/),"  WARNING:  TOO FEW SURFACE   MOMENTS",1X,20(1H/))')
              Write(NFIPRI,'(1X,20(1H/),"  FOUND ON THE REPLAY FILE.          ",1X,20(1H/))')
              Write(NFIPRI,'(1X,20(1H/),"  REQUESTED MAXIMUM  MULTIPOLARITY=",I2,1X,20(1H/))') NSIMAX
              Write(NFIPRI,'(1X,20(1H/),"  FOUND     MAXIMUM  MULTIPOLARITY=",I2,1X,20(1H/))') MSIMAX
              Write(NFIPRI,'(1X,20(1H/),"  A CONSTRAINT ON A MISSING MULTIPOLE",1X,20(1H/))')
              Write(NFIPRI,'(1X,20(1H/),"  WILL BE  INCLUDED  ONLY  AFTER  THE",1X,20(1H/))')
              Write(NFIPRI,'(1X,20(1H/),"  FIRST DIAGONALIZATION IS  PERFORMED",1X,20(1H/))')

              Do LAMBDA=MSIMAX+1,NSIMAX
                 Do MIU=-LAMBDA,LAMBDA
                    SMUL_N(LAMBDA,MIU)=0.0D0
                    SMUL_P(LAMBDA,MIU)=0.0D0
                    SMUL_T(LAMBDA,MIU)=0.0D0
                 End Do
              End Do

           End If

           Read(NFIREP,IOSTAT=IERROR) ((SMUL_N(LAMBDA,MIU),SMUL_P(LAMBDA,MIU),SMUL_T(LAMBDA,MIU), &
                                              MIU=-LAMBDA,LAMBDA),LAMBDA=0,MSIMAX)
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading SMUL_N")')
              Return
           End If

        End If

        Read(NFIREP,IOSTAT=IERROR) ISHIFT,(RSHIFT(L),L=1,NDKART)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading ISHIFT")')
           Return
        End If

        Read(NFIREP,IOSTAT=IERROR) (ANGU_N(L),ANGU_P(L),ANGU_T(L),SPIN_N(L),SPIN_P(L),SPIN_T(L),L=1,NDKART)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading ANGU_N")')
           Return
        End If

        Read(NFIREP,IOSTAT=IERROR) (((WN_CEN(IX,IY,IZ),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading WN_CEN")')
           Return
        End If

        Read(NFIREP,IOSTAT=IERROR) (((WP_CEN(IX,IY,IZ),IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
        If(IERROR.Ne.0) Then
          Write(NFIPRI,'("read_hfodd() - Error in reading WP_CEN")')
          Return
        End If

        Read(NFIREP,IOSTAT=IERROR) REFERN,REDELN,REFERP,REDELP
        If(IERROR.Ne.0) Then
           Write(NFIPRI,'("read_hfodd() - Error in reading REFERN")')
           Return
        End If

        ! LN lambda_2 (IVERIN=8)
        If(IVERIN.Gt.7) Then
           Read(NFIREP,IOSTAT=IERROR) REFE2N,REFE2P
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading REFE2N")')
              Return
           End If
        Else
           REFE2N=FE2INI(0); REFE2P=FE2INI(1)
           If((LIPKIN.EQ.1.OR.LIPKIP.EQ.1).AND.ILCONT.EQ.1) Then
               Write(NFIPRI,'(1X,13("/")," WARNING: THE LIPKIN-NOGAMI LAMBDA2S HAVE NOT BEEN",1X,13("/"))')
               Write(NFIPRI,'(1X,13("/")," FOUND ON THE  OLD  REPLAY  FILE  VERSION  NO. =",I2,1X,13("/"))') IVERIN
               Write(NFIPRI,'(1X,13("/")," THE  LN  CORRECTIONS CANNOT BE SMOOTHLY CONTINUED",1X,13("/"))')
           End If
        End If

        ! Blocked state wave-function (IVERIN=9)
        IDEBLO(0)=0; IDEBLO(1)=0
        If(IVERIN.Gt.8) Then

           Read(NFIREP,IOSTAT=IERROR) MDBASE,(IDEBLO(ICHARG),ICHARG=0,NDISOS)
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading MDBASE")')
              Return
           End If

           If(MDBASE.Le.NDBASE) Then
              Read(NFIREP,IOSTAT=IERROR) (((WAVBLO(IBASE,ICHARG,IREVER),IBASE=1,MDBASE),ICHARG=0,NDISOS),&
                                                                IREVER=0,NDREVE)
              If(IERROR.Ne.0) Then
                 Write(NFIPRI,'("read_hfodd() - Error in reading WAVBLO")')
                 Return
              End If
           Else
              Read(NFIREP,IOSTAT=IERROR)
              If(IERROR.Ne.0) Then
                 Write(NFIPRI,'("read_hfodd() - Error in reading ...nothing...")')
                 Return
              End If
           End If

           If(((IFIBLN.EQ.1.AND.INIBLN.EQ.0).OR.(IFIBLP.EQ.1.AND.INIBLP.EQ.0)).AND. &
                (MDBASE.Ne.LDBASE.OR.MDBASE.Gt.NDBASE)) Then
                 Write(NFIPRI,'(1X,10("/")," INCOMPATIBLE DIMENSIONS FOUND ON THE RECORD FILE:",1X,10("/"))')
                 Write(NFIPRI,'(1X,10("/")," LDBASE=",I4," MDBASE=",I4," NDBASE=",I4,1X,10("/"))') LDBASE,MDBASE,NDBASE
                 Stop 'MDBASE<>LDBASE OR MDBASE>NDBASE IN RECORD'
           End If

        End If

        If(IVERIN.Ge.10) Then
           Read(NFIREP,IOSTAT=IERROR) (ALINLT(KARTEZ),KARTEZ=0,NDKART)
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading ALINLT")')
              Return
           End If
        Else
           ALINLT(:)=0.0D0
           If(IMCONT.EQ.1) Then
              Write(NFIPRI,'(1X,13(1H/)," WARNING: THE AVERAGE LINEAR MOMENTA HAVE NOT BEEN",1X,13(1H/))')
              Write(NFIPRI,'(1X,13(1H/)," FOUND ON THE  OLD  REPLAY  FILE  VERSION  NO. =",I2,1X,13(1H/))') IVERIN
              Write(NFIPRI,'(1X,13(1H/)," THE EXACT CM CORREC. CANNOT BE SMOOTHLY CONTINUED",1X,13(1H/))')
           End If
        End If

        If(IVERIN.Ge.11) Then
           Read(NFIREP,IOSTAT=IERROR) (AROTLT(KARTEZ),KARTEZ=0,NDKART)
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading AROTLT")')
              Return
           End If
        Else
           AROTLT(:)=0.0D0
           If(IRCONT.Eq.1) Then
              Write(NFIPRI,'(1X,13(1H/)," WARNING: THE AVERAGE ANGULAR MOMENTA HAVE NOT BEEN",1X,13(1H/))')
              Write(NFIPRI,'(1X,13(1H/)," FOUND ON  THE  OLD  REPLAY  FILE  VERSION  NO. =",I2,1X,13(1H/))') IVERIN
              Write(NFIPRI,'(1X,13(1H/)," THE EXACT ROT CORREC. CANNOT BE SMOOTHLY CONTINUED",1X,13(1H/))')
           End If
        End If

        If(IVERIN.Ge.12) Then

           Read(NFIREP,IOSTAT=IERROR) MDMULT
           If(IERROR.Ne.0) Then
              Write(NFIPRI,'("read_hfodd() - Error in reading MDMULT")')
              Return
           End If

           RALMUQ(:,:)=0.0D0; RALMUS(:,:)=0.0D0

           If(MDMULT.Ne.NDMULT) Then

              Write(NFIPRI,'(1X,20(1H/),"  WARNING: NOT ALL LINEAR CONSTRAINTS",1X,20(1H/))')
              Write(NFIPRI,'(1X,20(1H/),"  FOUND ON THE REPLAY FILE.          ",1X,20(1H/))')
              Write(NFIPRI,'(1X,20(1H/),"  REQUESTED MAXIMUM  MULTIPOLARITY=",I2,1X,20(1H/))') NDMULT
              Write(NFIPRI,'(1X,20(1H/),"  FOUND     MAXIMUM  MULTIPOLARITY=",I2,1X,20(1H/))') MDMULT
              Write(NFIPRI,'(1X,20(1H/),"  A CONSTRAINT ON A MISSING MULTIPOLE",1X,20(1H/))')
              Write(NFIPRI,'(1X,20(1H/),"  WILL BE  INCLUDED  ONLY  AFTER  THE",1X,20(1H/))')
              Write(NFIPRI,'(1X,20(1H/),"  FIRST DIAGONALIZATION IS  PERFORMED",1X,20(1H/))')

              RALMUQ(:,:)=QLINEA(:,:); RALMUS(:,:)=SLINEA(:,:)

              Read(NFIREP,IOSTAT=IERROR) ((DUMMY,DUMMY,MIU=-LAMBDA,LAMBDA),LAMBDA=0,MDMULT)
              If(IERROR.Ne.0) Then
                 Write(NFIPRI,'("read_hfodd() - Error in reading DUMMY")')
                 Return
              End If

           Else

               Read(NFIREP,IOSTAT=IERROR) ((RALMUQ(LAMBDA,MIU),RALMUS(LAMBDA,MIU),MIU=-LAMBDA,LAMBDA),&
                                                               LAMBDA=0,MDMULT)
               If(IERROR.Ne.0) Then
                  Write(NFIPRI,'("read_hfodd() - Error in reading RALMUQ")')
                  Return
               End If

               ! If not allocated, allocate; if already allocated, deallocate first and re-allocate (
               ! (enables vayring number of constraints)
               If(Allocated(flex_lambda)) Deallocate(flex_lambda,flex_miu,flex_qlm)
               Allocate(flex_lambda(numberConstraints),flex_miu(numberConstraints),flex_qlm(numberConstraints))
               Do iq=1,numberConstraints
                  lambda = qLambda(iq); miu = qMiu(iq)
                  flex_lambda(iq)=lambda
                  flex_miu(iq)=miu
                  flex_qlm(iq)=QMUL_T(lambda,miu)
               End Do

           End If

        Else

            RALMUQ(:,:)=QLINEA(:,:); RALMUS(:,:)=SLINEA(:,:)

            If(IACONT.EQ.1) Then
               Write(NFIPRI,'(1X,13(1H/)," WARNING: THE LINEAR CONSTRAINTS  H A V E  NOT BEEN",1X,13(1H/))')
               Write(NFIPRI,'(1X,13(1H/)," FOUND ON  THE  OLD  REPLAY  FILE  VERSION  NO. =",I2,1X,13(1H/))') IVERIN
               Write(NFIPRI,'(1X,13(1H/)," THE EXACT AUGM.LAGRA. CANNOT BE SMOOTHLY CONTINUED",1X,13(1H/))')
            End If

        End If

        If(IVERIN.Ge.13) Then

            Read(NFIREP,IOSTAT=IERROR) (HBMREA(KARTEZ),KARTEZ=1,NDKART)
            If(IERROR.Ne.0) Then
               Write(NFIPRI,'("read_hfodd() - Error in reading HBMREA")')
               Return
            End If

            Read(NFIREP,IOSTAT=IERROR) (ROTREA(KARTEZ),KARTEZ=1,NDKART)
            If(IERROR.Ne.0) Then
               Write(NFIPRI,'("read_hfodd() - Error in reading ROTREA")')
               Return
            End If

            If(IMCONT.EQ.1.AND.IRENMA.Ge.1) Then
               HBMREN(:)=HBMREA(:)
            End If

            If(IRCONT.EQ.1.AND.IRENIN.Ge.1) Then
               ROTREN(:)=ROTREA(:)
            End If

        Else

            If(IMCONT.EQ.1.AND.IRENMA.Ge.1) Then
               Write(NFIPRI,'(1X,13(1H/)," WARNING:  THE  RENORMALIZED MASSES  HAVE NOT BEEN",1X,13(1H/))')
               Write(NFIPRI,'(1X,13(1H/)," FOUND ON  THE  OLD  REPLAY FILE  VERSION  NO. =",I2,1X,13(1H/))') IVERIN
               Write(NFIPRI,'(1X,13(1H/)," THE EXACT CM CORREC. CANNOT BE SMOOTHLY CONTINUED",1X,13(1H/))')
            End If

            If(IRCONT.EQ.1.AND.IRENIN.Ge.1) Then
               Write(NFIPRI,'(1X,13(1H/)," WARNING:  THE   RENORMALIZED INERTIA HAVE NOT BEEN",1X,13(1H/))')
               Write(NFIPRI,'(1X,13(1H/)," FOUND  ON  THE  OLD  REPLAY FILE  VERSION  NO. =",I2,1X,13(1H/))') IVERIN
               Write(NFIPRI,'(1X,13(1H/)," THE EXACT ROT CORREC. CANNOT BE SMOOTHLY CONTINUED",1X,13(1H/))')
            End If

        End If

        ! Linear Constraints for the neck (IVERIN=14)
        If(IVERIN.Ge.14) Then
            Read(NFIREP,IOSTAT=IERROR) G_NECK
            If(IERROR.Ne.0) Then
               Write(NFIPRI,'("read_hfodd() - Error in reading MDMULT")')
               Return
            End If
        Else
            G_NECK=0.0D0
            If(IFNECK.Ge.2) Then
               Write(NFIPRI,'(1X,13(1H/)," WARNING : THE  NECK  CONSTRAINTS  H A S  NOT  BEEN",1X,13(1H/))')
               Write(NFIPRI,'(1X,13(1H/)," FOUND ON  THE  OLD  REPLAY  FILE  VERSION  NO. =",I2,1X,13(1H/))') IVERIN
               Write(NFIPRI,'(1X,13(1H/)," THE NECK CONSTRAINT CAN NOT BE  SMOOTHLY CONTINUED",1X,13(1H/))')
            End If
        End If

        IFIRED=1

     End If

     If(IFIRED.EQ.0) Then
        Write(NFIPRI,'(/,1X,10(1H/),"  CANNOT read THE REPLAY FILE VERSION:",I3,2X,10(1H/),/)') IVERIN
        Stop '  WRONG IVERIN IN RECORD'
     End If

     If(IFIBLN.EQ.1.AND.INIBLN.EQ.0.AND.IDEBLO(0).Ne.1) Then
        Write(NFIPRI,'(1X,10(1H/)," NEUTRON SINGLE-PARTICLE WF NOT FOUND ON THE RECORD FILE",1X,10(1H/))')
        Write(NFIPRI,'(1X,10(1H/)," RERUN THE BLOCKING CALCULATION WITH INIBLN=1           ",1X,10(1H/))')
        Stop ' NEUTRON SINGLE-PARTICLE WF NOT FOUND IN RECORD'
     End If

     If(IFIBLP.EQ.1.AND.INIBLP.EQ.0.AND.IDEBLO(1).Ne.1) Then
        Write(NFIPRI,'(1X,10(1H/)," PROTON  SINGLE-PARTICLE WF NOT FOUND ON THE RECORD FILE",1X,10(1H/))')
        Write(NFIPRI,'(1X,10(1H/)," RERUN THE BLOCKING CALCULATION WITH INIBLP=1           ",1X,10(1H/))')
        Stop ' PROTON SINGLE-PARTICLE WF NOT FOUND IN RECORD'
     End If

   End Subroutine read_hfodd

   !---------------------------------------------------------------------!
   !  Subroutine reads lists all the files in 'directory_name', extracts !
   !  all files of the form 'HFODD_XXXXXXXX.REC' (with XXXXXXXX a number)!
   !  and checks that all files with the number between 1 and N are      !
   !  present. It then broadcasts a boolean flag indicating if all files !
   !  are there, and a vector of integers giving the breakdown.          !
   !---------------------------------------------------------------------!
   Subroutine check_directory(directory_name,N)

      Integer, INTENT(IN) :: N
      Character(Len=132), INTENT(IN) :: directory_name

      Integer, Parameter :: ndatin=85
      Integer :: i,exitstat,iocheck,ierr,mpi_rank,mpi_err,numero,count
      Character(Len=80) :: filein
      Character(Len=150) :: commande
      Character(Len=132) :: string

      mpi_rank=0; mpi_err=0

      ! Getting the rank of the current process
      Call mpi_comm_rank(MPI_COMM_WORLD, mpi_rank, mpi_err)

      If(mpi_rank.Eq.0) Then

     	 commande = 'ls '//Trim(directory_name)// ' > toto'; exitstat=0
      	 Call system(commande)
      	 If(debug.Ge.2) Write(6,'("mpi_rank = ",i10," - Executed command: ",a)') &
      	                           mpi_rank,commande

      	 ! open file
      	 Open(ndatin,file='toto',status='old',form='formatted',iostat=ierr)
         If(ierr.Ne.0) Then
            Write(6,'("Error in opening file : toto")')
            Stop 'Error in check_directory - I/O'
         End if

         ! Read file, extract number of file if relevant, and fill table
         iocheck=0
         Do While(iocheck.Eq.0)
            Read(ndatin,*,Iostat=iocheck) string
            numero = 0
            Call get_numero(string,numero)
            If(debug.Ge.2) Write(6,'("numero = ",i10)') numero
            If(numero.Gt.0) table_fichiers(numero)=1
         End Do

      	 Close(ndatin)
      	 If(debug.Ge.1) Write(6,'("Done reading with the file")')

         filled=.True.; count=0
         Do i=1,N
            If(table_fichiers(i).Eq.0) Then
               count=count+1
            End If
         End Do
         If(count.Gt.0) filled=.False.

      	 If(debug.Ge.2) Then
      	    If(filled) Then
               Write(6,'("All files are there")')
            Else
               Write(6,'(i10," files are missing")') count
            End If
         End If

      End If

      ! Broadcast flag telling if array is filled and table of missing files
      Call MPI_Bcast(filled,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpi_err)
      Call MPI_Bcast(table_fichiers,N,MPI_INTEGER,0,MPI_COMM_WORLD,mpi_err)

      ! Wait for all threads
      Call mpi_barrier(MPI_COMM_WORLD,mpi_err)

    End Subroutine check_directory

   !---------------------------------------------------------------------!
   !  Subroutine returns in 'numero' the file number from a string of    !
   !   the form 'HFODD_XXXXXXXX.REC' (with XXXXXXXX the number).         !
   !---------------------------------------------------------------------!
    Subroutine get_numero(string,numero)

      Character(Len=132), INTENT(IN) :: string
      Integer, INTENT(INOUT) :: numero
      Integer :: start
      Character(Len=4) :: dum_4
      Character(Len=6) :: dum_6

      start = Index(string, 'HFODD_', .False.)
      If (start.Ge.0) Then
          Read(string(start:start+18), '(A6,I8.8,A4)') dum_6,numero,dum_4
      End If

    End Subroutine get_numero

   !---------------------------------------------------------------------!
   !  Subroutine copies all files that have not been copied yet.         !
   !---------------------------------------------------------------------!
    Subroutine fill_holes(N,IF_THO,LIPKIN,LIPKIP)

      Integer, INTENT(IN) :: N,IF_THO,LIPKIN,LIPKIP

      Integer :: jj,exitstat,mpi_rank,mpi_world,mpi_err
      Character(Len=150) :: commande

      mpi_rank=0; mpi_world=1; mpi_err=0

      ! Getting the rank of the current process
      Call mpi_comm_rank(MPI_COMM_WORLD, mpi_rank, mpi_err)
      Call mpi_comm_size(MPI_COMM_WORLD, mpi_world,mpi_err)

      Do jj=1,N

      	 If(Mod(mpi_rank,mpi_world).Eq.Mod(jj-1,mpi_world)) Then

            If(table_fichiers(jj).Eq.0) Then

               commande = 'cp '//fichier_rec_old(jj)//' '//fichier_rec_new(jj); exitstat=0
               Call system(commande)
               If(debug.Ge.2) Write(6,'("fill_holes: mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
                                                     mpi_rank,jj,commande
               If(IF_THO.Ge.1) Then
                  commande = 'cp '//fichier_tho_old(jj)//' '//fichier_tho_new(jj); exitstat=0
                  Call system(commande)
                  If(debug.Ge.2) Write(6,'("fill_holes: mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
                                                        mpi_rank,jj,commande
               End If
               If(LIPKIN.Ge.1.Or.LIPKIP.Ge.1) Then
                  commande = 'cp '//fichier_lic_old(jj)//' '//fichier_lic_new(jj); exitstat=0
                  Call system(commande)
                  If(debug.Ge.2) Write(6,'("fill_holes: mpi_rank = ",i10," jj = ",i10," - Executed command: ",a)') &
                                                        mpi_rank,jj,commande
               End If

            End If

         End If

      End Do

      ! Wait for all threads
      Call mpi_barrier(MPI_COMM_WORLD,mpi_err)

   End Subroutine fill_holes

 End Module hfodd_mpimanager

!***********************************************************************
!
!    Copyright (c) 2015, Lawrence Livermore National Security, LLC.
!                        Produced at the Lawrence Livermore National
!                        Laboratory.
!                        Written by Nicolas Schunck, schunck1@llnl.gov
!
!    LLNL-CODE-470611 All rights reserved.
!
!    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
!                    W. Satula, J.A. Sheikh, A. Staszczak,
!                    M. Stoitsov, P. Toivanen
!    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
!                    P. Olbratowski, P. Powalowski, M. Sadziak,
!                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
!                    M. Zalewski, H. Zdunczuk
!    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
!    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
!
!    This file is part of HFODD.
!
!    HFODD is free software: you can redistribute it and/or modify it
!    under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    HFODD is distributed in the hope that it will be useful, but
!    WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
!
!    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
!    LICENSE
!
!    Our Preamble Notice
!
!      A. This notice is required to be provided under our contract
!         with the U.S. Department of Energy (DOE). This work was
!         produced at the Lawrence Livermore National Laboratory under
!         Contract No. DE-AC52-07NA27344 with the DOE.
!      B. Neither the United States Government nor Lawrence Livermore
!         National Security, LLC nor any of their employees, makes any
!         warranty, express or implied, or assumes any liability or
!         responsibility for the accuracy, completeness, or usefulness
!         of any information, apparatus, product, or process disclosed,
!         or represents that its use would not infringe privately-owned
!         rights.
!      C. Also, reference herein to any specific commercial products,
!         process, or services by trade name, trademark, manufacturer
!         or otherwise does not necessarily constitute or imply its
!         endorsement, recommendation, or favoring by the United States
!         Government or Lawrence Livermore National Security, LLC. The
!         views and opinions of authors expressed herein do not
!         necessarily state or reflect those of the United States
!         Government or Lawrence Livermore National Security, LLC, and
!         shall not be used for advertising or product endorsement
!         purposes.
!
!    The precise terms and conditions for copying, distribution and
!    modification are contained in the file COPYING.
!
!***********************************************************************

      SUBROUTINE Set_version_hfodd_fits
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(13) = 'hfodd_fits      '
      MODUVE(13) = 16
      MODSET(13) = 13
      !
      END SUBROUTINE Set_version_hfodd_fits
      !
module hfodd_fits
      contains

      SUBROUTINE FITJAD(JADRO_NAME, DAT_SUFFIX)
      USE HFODD_SIZES
      CHARACTER JADRO_NAME*5
      CHARACTER DAT_SUFFIX*7
      CHARACTER DAT_FILE_NAME*64

      COMMON /CFIREA/ NFIREA
      COMMON /CFIPRI/ NFIPRI

      NFIREA=87
      WRITE (DAT_FILE_NAME, '(''data/'',A5,''-'',A7,''.dat'')') JADRO_NAME, DAT_SUFFIX
      OPEN(NFIREA,FILE=DAT_FILE_NAME,STATUS='UNKNOWN',FORM='FORMATTED')

      NFIPRI=88
      OPEN(NFIPRI,FILE='/dev/null',STATUS='UNKNOWN',FORM='FORMATTED')
      END SUBROUTINE FITJAD

  !=====================================================================
  !
  !     This subroutine calculates
  !=====================================================================

      SUBROUTINE FITINP(PARINP,NUMINP,I_TYPE,N3LORD)
      USE HFODD_SIZES
      INTEGER I_TYPE
      DIMENSION PARINP(NUMINP)
      COMMON /SPMSKY/ SRHO_P,SRHO_M,SRHODP,SRHODM, \
                      SLPR_P,SLPR_M, \
                      STAU_P,STAU_M, \
                      SSCU_P,SSCU_M, \
                      SDIV_P,SDIV_M, \
                      SSPI_P,SSPI_M,SSPIDP,SSPIDM, \
                      SLPS_P,SLPS_M, \
                      SCUR_P,SCUR_M, \
                      SKIS_P,SKIS_M, \
                      SROT_P,SROT_M
      COMMON /REGBIN/ REGBCC(NDREGA,NDFORC),IREREG
      COMMON /REGVIN/ REGVCC(NDREGA,NDFORC)
      COMMON /GOGFOR/ GOGSTR(NDGOGA,NDFORC),GOGWID(NDGOGA),NUGOGA

      ISTYPE=0

      IF (I_TYPE.EQ.1) THEN

          IF (NUMINP.NE.12) STOP ' INCREASE NUMINP 1'

          SRHO_P=SRHO_P*PARINP(1)
          SRHODP=SRHODP*PARINP(2)
          SLPR_P=SLPR_P*PARINP(3)
          STAU_P=STAU_P*PARINP(4)
          SSCU_P=SSCU_P*PARINP(5)
          SDIV_P=SDIV_P*PARINP(6)

          SRHO_M=SRHO_M*PARINP(7)
          SRHODM=SRHODM*PARINP(8)
          SLPR_M=SLPR_M*PARINP(9)
          STAU_M=STAU_M*PARINP(10)
          SSCU_M=SSCU_M*PARINP(11)
          SDIV_M=SDIV_M*PARINP(12)

          ISTYPE=1

      END IF

      IF (I_TYPE.EQ.2) THEN

          IF (NUMINP.NE.IREREG*NDFORC+2) STOP ' INCREASE NUMINP 2'

          IND=0
          DO INREGA=1,IREREG
             DO INFORC=1,NDFORC
                IND=IND+1
                IF (N3LORD.GE.0) THEN
                REGBCC(INREGA,INFORC)=REGBCC(INREGA,INFORC)*PARINP(IND)
                ELSE
                REGVCC(INREGA,INFORC)=REGVCC(INREGA,INFORC)*PARINP(IND)
                END IF
             END DO
          END DO

          SDIV_P=SDIV_P*PARINP(IND+1)
          SDIV_M=SDIV_M*PARINP(IND+2)

          ISTYPE=1

      END IF

      IF (I_TYPE.EQ.3) THEN

          IF (NUMINP.NE.IREREG*NDFORC+1) STOP ' INCREASE NUMINP 3'

          IND=0
          DO INREGA=1,IREREG
             DO INFORC=1,NDFORC
                IND=IND+1
                IF (N3LORD.GE.0) THEN
                REGBCC(INREGA,INFORC)=REGBCC(INREGA,INFORC)*PARINP(IND)
                ELSE
                REGVCC(INREGA,INFORC)=REGVCC(INREGA,INFORC)*PARINP(IND)
                END IF
             END DO
          END DO

          SDIV_P=SDIV_P*PARINP(IND+1)
          SDIV_M=SDIV_M*PARINP(IND+1)

          ISTYPE=1

      END IF

     IF (I_TYPE.EQ.4) THEN

          IF (NUMINP.NE.IREREG*NDFORC+2) STOP ' INCREASE NUMINP 4'

          IND=0
          DO INREGA=1,IREREG
             DO INFORC=1,NDFORC
                IND=IND+1
                IF (N3LORD.GE.0) THEN
                REGBCC(INREGA,INFORC)=REGBCC(INREGA,INFORC)*PARINP(IND)
                ELSE
                REGVCC(INREGA,INFORC)=REGVCC(INREGA,INFORC)*PARINP(IND)
                END IF
             END DO
          END DO

          SDIV_P=SDIV_P*PARINP(IND+1)
          SDIV_M=SDIV_M*PARINP(IND+1)
          SRHODP=SRHODP*PARINP(IND+2)
          SRHODM=SRHODM*PARINP(IND+2)

          ISTYPE=1

      END IF

      IF (I_TYPE.EQ.5) THEN

          IF (NUMINP.NE.8) STOP ' INCREASE NUMINP 5'

          SRHO_P=SRHO_P*PARINP(1)
          SLPR_P=SLPR_P*PARINP(2)
          STAU_P=STAU_P*PARINP(3)

          SRHO_M=SRHO_M*PARINP(4)
          SLPR_M=SLPR_M*PARINP(5)
          STAU_M=STAU_M*PARINP(6)

          SDIV_P=SDIV_P*PARINP(7)
          SDIV_M=SDIV_M*PARINP(7)
          SRHODP=SRHODP*PARINP(8)
          SRHODM=SRHODM*PARINP(8)

          ISTYPE=1

      END IF

      IF (I_TYPE.EQ.6) THEN

          IF (NUMINP.NE.10) STOP ' INCREASE NUMINP 6'

          GOGSTR(1,1)=GOGSTR(1,1)*PARINP(1)
          GOGSTR(1,2)=GOGSTR(1,2)*PARINP(2)
          GOGSTR(1,3)=GOGSTR(1,3)*PARINP(3)
          GOGSTR(1,4)=GOGSTR(1,4)*PARINP(4)

          GOGSTR(2,1)=GOGSTR(2,1)*PARINP(5)
          GOGSTR(2,2)=GOGSTR(2,2)*PARINP(6)
          GOGSTR(2,3)=GOGSTR(2,3)*PARINP(7)
          GOGSTR(2,4)=GOGSTR(2,4)*PARINP(8)

          SDIV_P=SDIV_P*PARINP(9)
          SDIV_M=SDIV_M*PARINP(9)
          SRHODP=SRHODP*PARINP(10)
          SRHODM=SRHODM*PARINP(10)

          ISTYPE=1

      END IF

      IF (I_TYPE.EQ.7) THEN

          IF (NUMINP.NE.9) STOP ' INCREASE NUMINP 1'

          SRHO_P=SRHO_P*PARINP(1)
          SLPR_P=SLPR_P*PARINP(2)
          STAU_P=STAU_P*PARINP(3)
          SSCU_P=SSCU_P*PARINP(4)

          SRHO_M=SRHO_M*PARINP(5)
          SLPR_M=SLPR_M*PARINP(6)
          STAU_M=STAU_M*PARINP(7)
          SSCU_M=SSCU_M*PARINP(8)

          SDIV_P=SDIV_P*PARINP(9)
          SDIV_M=SDIV_M*PARINP(9)

          ISTYPE=1

      END IF

      IF (ISTYPE.EQ.0) STOP ' INCORRECT I_TYPE IN FITINP'

      END SUBROUTINE FITINP


  !=====================================================================
  !
  !     This subroutine calculates
  !=====================================================================

      SUBROUTINE FITOUT(PAROUT,NUMOUT)
      USE HFODD_SIZES
      DIMENSION PAROUT(NUMOUT)
      COMMON \
            /ALLENE/ EKIN_N,EKIN_P,EKIN_T, \
                     EPOT_N,EPOT_P,EPOT_T, \
                     ESUM_N,ESUM_P,ESUM_T, \
                     EPAI_N,EPAI_P,EPAI_T, \
                     EREA_N,EREA_P,EREA_T, \
                     ELIP_N,ELIP_P,ELIP_T, \
     \
                     ECOULD,ECOULE,ECOULT, \
                            ECOULS,ECOULV, \
     \
                     EMULCO,EMUSLO,EMUREA, \
                     ESIFCO,ESISLO,ESIREA, \
                     ESPICO,ESPSLO,ESPREA, \
     \
                     ENREAR,ECORCM,ECOR_R, \
     \
                     EEVEW0,EODDW0,ENE_W0, \
                     ENEVEN,ENEODD,ENESKY, \
                     ESTABN,ETOTSP,ETOTFU
      COMMON  \
             /RMSRAD/ RADI_N(0:NDKART), \
                      RADI_P(0:NDKART), \
                      RADI_T(0:NDKART)
      COMMON  \
             /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),  \
                      QMUL_P(0:NDMULT,-NDMULT:NDMULT),  \
                      QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON /CFIREA/ NFIREA

      IF (NUMOUT.NE.4) STOP ' INCREASE NUMOUT'

      CLOSE(NFIREA)
      PAROUT(1)=ETOTFU
      IF (ABS(ESTABN).LT.0.001) THEN
          PAROUT(2)= 1.
      ELSE
          PAROUT(2)=-1.
      ENDIF
      PAROUT(3)=RADI_P(0)
      PAROUT(4)=QMUL_P(2,0)
      END SUBROUTINE FITOUT

    !====================================================================
end module hfodd_fits

!
!===============================================================================
!     Module for Adiabatic Time-Dependent Hartree-Fock-Bogoliubov (ATDHFB) 
!     and Adiabatic Time-Dependent Hartree-Fock (ATDHF) calculations
!     ATDHF(B) calculation is triggered if IADBAT = 1
!===============================================================================
      SUBROUTINE Set_version_hfodd_adiabatic
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(17) = 'hfodd_adiabatic '
      MODUVE(17) = 22
      MODSET(17) = 17
      !
      END SUBROUTINE Set_version_hfodd_adiabatic


!
!===============================================================================
!     Module containing data from the ground state solver
!===============================================================================
      module hfodd_gs_data
      USE hfodd_sizes
      USE ALLWAV
      USE WAVR_L
      USE MAT_PP
      USE MAT_PM
      USE HE_DEN
      USE VE_FLD
      USE MAD_PP
      USE MAD_PM
      USE WD_FLD
      USE ALLQUZ
      USE SAVQUA
      use MAP_PP
      use MAP_PM
      use PAIDEL
      USE PP_DEN
      USE PD_DEN
      USE PDTDEN

      COMMON                                                            &
     &       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON                                                            &
     &       /SIZOCC/ M_OCCU(1:2*NDSTAT,0:NDISOS),                      &
     &                M_OCVA(1:2*NDSTAT,0:NDISOS)
      COMMON                                                            &
     &       /PROCCU/ V_OCCU(1:4*NDSTAT)
      COMMON                                                            &
     &       /DIMENS/ LDBASE
      COMMON                                                            &
     &       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),                      &
     &                SPOCCU(1:2*NDSTAT,0:NDISOS),                      &
     &                SPALIG(1:2*NDSTAT,0:NDISOS),                      &
     &                SPSPAL(1:2*NDSTAT,0:NDISOS),                      &
     &                SPPARI(1:2*NDSTAT,0:NDISOS),                      &
     &                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON                                                            &
     &       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),               &
     &                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),               &
     &                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),               &
     &                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON                                                            &
     &       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON                                                            &
     &       /CCPSKY/ CRHO_T,CRHO_S,CRHODT,CRHODS,                      &
     &                CLPR_T,CLPR_S,                                    &
     &                CTAU_T,CTAU_S,                                    &
     &                CSCU_T,CSCU_S,                                    &
     &                CDIV_T,CDIV_S,                                    &
     &                CSPI_T,CSPI_S,CSPIDT,CSPIDS,                      &
     &                CLPS_T,CLPS_S,                                    &
     &                CCUR_T,CCUR_S,                                    &
     &                CKIS_T,CKIS_S,                                    &
     &                CROT_T,CROT_S,                                    &
     &                CSCT_T,CSCT_S,                                    &
     &                CKIT_T,CKIT_S,                                    &
     &                CSPT_T,CSPT_S
      COMMON                                                            &
     &       /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN,1:NDTWCE)
      COMMON                                                            &
     &       /CFIPRI/ NFIPRI
      COMMON                                                            &
     &       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),                  &
     &                QMUL_P(0:NDMULT,-NDMULT:NDMULT),                  &
     &                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      ! --- USED FOR TESTING
      COMMON                                                            &
     &       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM,NDTWDD)
      COMMON                                                            &
     &       /SIZSPE/ SPESIZ(1:4*NDBASE)
      COMMON                                                            &
     &       /EIGLIM/ EIGMIN,EIGMAX
      common                                                            &
     &       /pri_flag/ idsi_flag
      ! --- common block added by ATDHF ---
      COMMON                                                            &
     &       /SVOCCU/ SV_OCC(1:4*NDSTAT,NDISOS)
      COMMON                                                            &
     &       /PRSING/ V_SING(1:4*NDSTAT)
      COMMON                                                            &
     &       /SWSING/ I_SING
      COMMON                                                            &
     &       /NPADBC/ NPTOTL(0:NDISOS)

     ! --- ATDHFB --- 
      COMMON                                                            &
     &       /ADBMOD/ IADBMD
      COMMON                                                            &
     &       /ADBEFE/ E_FERMI(0:NDISOS)
      COMMON                                                            &
     &       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)           
      COMMON                                                            &
     &       /QPLEVS/ QPENER(1:4*NDSTAT,0:NDISOS),                      &
     &                QPOCCU(1:4*NDSTAT,0:NDISOS),                      &
     &                QPPARR(1:4*NDSTAT,0:NDISOS),                      &
     &                QPEEQU(1:4*NDSTAT,0:NDISOS),                      &
     &                QPDEQU(1:4*NDSTAT,0:NDISOS),                      &
     &                QPCORR(1:4*NDSTAT,0:NDISOS)
      COMMON                                                            &
     &       /LIMOCC/ NOTOCC(1:2*NDSTAT,0:NDREVE),                      &
     &       /OCCISO/ NOCISO(1:2*NDSTAT,0:NDREVE,0:NDISOS)

      COMMON                                                            &
     &       /DENTOC/ DENSIC(NDXHRM,NDYHRM,NDZHRM),                     &
     &                DENCHC(NDXHRM,NDYHRM,NDZHRM)
      COMPLEX                                                           &
     &          DENSIC,DENCHC,DENSIU
     ! -- ADIABATIC SWITCHES --
      COMMON                                                            &
     &       /ADBRUN/ IABNTE,IABCOL,IABICH,IABMOD,IFAMON
      COMMON                                                            &
     &       /ADBLNM/ IADBLN
      COMMON                                                            &
     &       /ADBPRC/ DABPRS,ETAFAM,XCHIMX
     ! -- FLAGS --
      COMMON /ISWITS/ IGYUSD
     ! -- FILE STRORING THE DENSITY
      COMMON /ADBFLE/ SFIADB, SFJADB
      CHARACTER SFIADB*68, SFJADB*68
      COMMON                                                            &
     &       /QMULTI/ RMUL_N(0:NDMULT,-NDMULT:NDMULT),                  &
     &                RMUL_P(0:NDMULT,-NDMULT:NDMULT),                  &
     &                RMUL_T(0:NDMULT,-NDMULT:NDMULT)
      endmodule hfodd_gs_data

!===============================================================================
! Call HFODD subroutines:
!      DENSHF (ICH = 10), SKFILD (ICH = 1), INTEGH (ICH = 2), TO_COUL (ICH = 3)
!      SKPAIR (ICH = 4),  INTEGD (ICH = 5), GOGENE,GOGPAI,REGENE(ICH = 6)
! Parameters of these subroutines should be pushed into:
! DSIPARAI & DSIPARAR & SIPARAC
!
!      XX20 (ICH = 20) : prepare matrix elements of density operator
!
      subroutine HFODD_SUBS(ICHARG, ICH_IN)
      use hfodd_gs_data

      ! Integer INPUT parameters of HFODD SUBS
      common /DSIPARAI/                                                 &
     &                    ISIMTX,JSIMTY,ISIMTZ,ISIGNY,ISIMPY,ISIQTY,    &
     &                    IPAHFB,MREVER,MIN_QP,IPNMIX,ITPNMX,ITIREP,    &
     &                    IDEVAR,ITERUN,ISYMDE,INIROT,INIINV,INIKAR,    &
     &                    ISAWAV,IKERNE,IMOVAX,ITILAX,ITISAX,NO_ORB,    &
     &                    IROTAT,MPAHFB,IPOTHO,ISCHIF,IOCONT,NMUCON,    &
     &                    NSICON,I_YUKA,I_GOGA,I_REGA,I_SEPA,ITWOLI,    &
     &                    JETACM,KETA_R,ICOUDI,ICOUEX,LIPKIN,LIPKIP,    &
     &                    IF_RPA,ILIPON,ILIPOP,NEWGOG,NEWCOU,           &
     &                    ITWCEN,LTWCEN,LDTWCE,ICOTYP,IDOTHC,INDCOE,    &
     &                    IDEFIN,IDEFIP,IGOGPA,IREGPA,ISEPPA,ICOUPA,    &
     &                    ISREGA,ISREGP,N3LORD,I_SLOW,ISGOGA,ISGOGP,    &
     &                                                IN_FIX,IZ_FIX


     ! Character INPUT parameters of HFODD SUBS
      common /DSIPARAC/ NAMEPN
      CHARACTER NAMEPN*8

      ! Real INPUT parameters of HFODD SUBS
      common /DSIPARAR/                                                 &
     &             AROTLT,ALINLT,PRINIT,XOLDEV,XOLDOD,EFER2N,EFER2P,    &
     &                                  SLOWEV,SLOWPA,DELFIN,DELFIP

      COMMON /QBDIMS/ NCONFX(0:1)

      integer ISTATE, IBASE, ISPIN
      COMPLEX EKECOD, EKECOE, EKESCA, EKEVEC, EKEGOG
      integer IBASEI, IBASEJ
      COMPLEX SU
      integer NCONQB
      integer nich, ich_in, ICH

      ICH = ICH_IN
      ! --- For ATDHFB, density should be calculated in two steps.
      ! --- if IPAHFB = 1, positive ICH means the first step, put zeros to density;
      ! ---                negative ICH means the second step
      if(ich .ge. 0) nich = 1
      if(ich .lt. 0) nich = 2
      ICH = abs(ICH)
      IF(IPAHFB.eq.0 .and. NICH.eq.2) stop 'FATAL ERROR: for no pairing case, USE ICH >= 0'

      ! CHECK whether GOGNY is used
      IGYUSD=ISGOGA

      ! There is a security check in DENSHF, requiring ITPNMX = ICHARG.
      ! Searching string 'ICHARG<>ITPNMX IN DENSHF' in main source file
      ! for further details
      ITPNMX = ICHARG
      
      ! Two center : only one center basis is used
      LTWCEN = 1
      INDCOE = 1

      if(ICHARG .eq. 0) NAMEPN = 'NEUTRONS'
      if(ICHARG .eq. 1) NAMEPN = ' PROTONS'

      ! In SKFILD, no mixure from previous iteration
      XOLDEV = 0.d0
      XOLDOD = 0.d0
      XOLDPA = 0.d0

! --- call DENSHF
      IF (ICH .EQ. 10) THEN
         IF(NICH .eq. 1) CALL ZEDENS(ICHARG)
         CALL DENSHF(ISIMTX,JSIMTY,ISIMTZ,                              &
     &               ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,         &
     &                                    MIN_QP,IPNMIX,ITPNMX,         &
     &                      ITIREP,NAMEPN,PRINIT,IDEVAR,ITERUN,         &
     &               ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE,         &
     &                                           ITWCEN,LTWCEN)
      ENDIF

! --- call SKFILD
      IF (ICH .EQ. 1) THEN
         CALL ZEFILD(0)
         CALL ZEFILD(1)
         CALL SKFILD(XOLDEV,XOLDOD,IPNMIX,ITWCEN,LTWCEN)
      ENDIF

! --- call INTEGH
      IF (ICH .EQ. 2) THEN
         !CALL SPZERO
         CALL INTEGH(IMOVAX,ITILAX,ITISAX,NO_ORB,                       &
     &               IPNMIX,ITPNMX,IROTAT,ICHARG,ISIMPY,                &
     &                      MPAHFB,IPOTHO,ISCHIF,IOCONT,                &
     &                                    NMUCON,NSICON,                &
     &                      I_YUKA,I_GOGA,I_REGA,I_SEPA,                &
     &                             ITWOLI,JETACM,ALINLT,                &
     &                                    KETA_R,AROTLT,                &
     &                                    ICOUDI,ICOUEX,                &
     &                                    LIPKIN,LIPKIP,                &
     &                                    EFER2N,EFER2P,                &
     &                                           IF_RPA,                &
     &                                    ILIPON,ILIPOP,                &
     &                                           NEWGOG,                &
     &                                    LTWCEN,ITWCEN,                &
     &                                           INDCOE)
      ENDIF

! --- calculate Time-odd Coulomb field
      IF (ICH .EQ. 3) THEN
         IF(ICHARG.NE.1) STOP 'error in TO_COUL: Coulomb requires ICHARG = 1'
         IF(ICOUDI.NE.2 .OR. ICOUEX.NE.2) return

         EKECOD=0.d0
         EKECOE=0.d0
         EKESCA=0.d0
         EKEVEC=0.d0
      
         if(IPAHFB.eq.0 .OR. IPAHFB.eq.1) then

            IF (ICOUDI.EQ.2.OR.ICOUEX.EQ.2) THEN
!   
                CALL COUENE(ISIMPY,                 &
     &                      ICOTYP,ICOUDI,ICOUEX,   &
     &                                    IDOTHC,   &
     &                      EKECOD,EKESCA,EKEVEC)
!   
                IF (ICOUEX.EQ.2) EKECOE=EKESCA+EKEVEC
!   
            END IF
   
         endif

      ENDIF

! --- call SKPAIR, calculate pairing fields
      IF (ICH .EQ. 4) THEN

          CALL SKPAIR(XOLDPA,LTWCEN)

      END IF

! --- call INTEGD
      IF (ICH .EQ. 5) THEN

          CALL INTEGD(ITPNMX,ISIMPY,ICHARG,                 &
     &                DELFIN,DELFIP,IDEFIN,IDEFIP,          &
     &                              JETACM,KETA_R,          &
     &                IGOGPA,IREGPA,ISEPPA,ICOUPA,          &
     &                              NEWGOG,NEWCOU,          &
     &                       LTWCEN,ITWCEN,INDCOE)

      END IF

! --- calculate Gogny mean-field & pairing field
! --- call GOGENE, GOGPAI, REGENE
      IF (ICH .EQ. 6) THEN
!
         EKEGOG=0.d0
      
         if(IPAHFB.eq.0 .OR. IPAHFB.eq.1) then

            IF (I_GOGA.GE.1.AND.NEWGOG.EQ.0) THEN
!
                CALL GOGENE(I_SLOW,SLOWEV,ISGOGA,I_GOGA,ISIMPY,EKEGOG)
!
            END IF

            IF ((IGOGPA.EQ.1.OR.IGOGPA.EQ.2).AND.NEWGOG.EQ.0) THEN
!
                CALL GOGPAI(I_SLOW,SLOWPA,ISGOGP,IGOGPA,ISIMPY,IN_FIX,IZ_FIX)
!
            END IF

            IF (I_REGA.GE.1.AND.NEWGOG.EQ.0.OR.                          &
           &    I_GOGA.GE.1.AND.NEWGOG.EQ.1) THEN
!
                CALL REGENE(I_SLOW,SLOWEV,SLOWPA,                        &
           &                I_REGA,IREGPA,ISREGA,ISREGP,                 &
           &                I_GOGA,IGOGPA,ISGOGA,ISGOGP,                 &
           &                N3LORD,ISIMPY,IN_FIX,IZ_FIX,EKEREG,NEWGOG)
!
            END IF   
         endif

      ENDIF


!-- XX20
      IF (ICH .EQ. 20) THEN
         ! ---- calculate matrix elements of density operator ----
         if(IPAHFB.eq.0 .and. .true.) then
            DEN_PP(:,:,:,ICHARG) = 0; DEN_PM(:,:,:,ICHARG) = 0;
            DO IBASEI=1,LDBASE
               DO IBASEJ=1,LDBASE
                  DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
                     SU = V_OCCU(ISTATE)**2*V_SING(ISTATE)
                     DEN_PP(IBASEI,IBASEJ,0,ICHARG) = DEN_PP(IBASEI,IBASEJ,0,ICHARG) &
                    &   + WAVOCC(IBASEI,ISTATE,0)*SU*conjg(WAVOCC(IBASEJ,ISTATE,0))
                     DEN_PP(IBASEI,IBASEJ,1,ICHARG) = DEN_PP(IBASEI,IBASEJ,1,ICHARG) &
                    &   + WAVOCC(IBASEI,ISTATE,1)*SU*conjg(WAVOCC(IBASEJ,ISTATE,1))
                     DEN_PM(IBASEI,IBASEJ,0,ICHARG) = DEN_PM(IBASEI,IBASEJ,0,ICHARG) &
                    &   + WAVOCC(IBASEI,ISTATE,0)*SU*conjg(WAVOCC(IBASEJ,ISTATE,1))
                     DEN_PM(IBASEI,IBASEJ,1,ICHARG) = DEN_PM(IBASEI,IBASEJ,1,ICHARG) &
                    &   + WAVOCC(IBASEI,ISTATE,1)*SU*conjg(WAVOCC(IBASEJ,ISTATE,0))
                  ENDDO
               ENDDO
            ENDDO
         endif
   
         ! ---- calculate matrix elements of density operator and pairing tensor ----
         if(IPAHFB.eq.1 .and. .true.) then
            IF(NICH .eq. 1) THEN
               DEN_PP(:,:,:,ICHARG) = 0; DEN_PM(:,:,:,ICHARG) = 0; 
               CHI_PP(:,:,:,ICHARG) = 0; CHI_PM(:,:,:,ICHARG) = 0;
            ENDIF
            NCONQB = NUMBQP(0,ICHARG) + NUMBQP(1,ICHARG)
            NCONQB = NCONFX(ICHARG)
            DO IBASEI=1,LDBASE
               DO IBASEJ=1,LDBASE
                  DO ISTATE=1,NCONQB
                     SU = V_SING(ISTATE)
                     DEN_PP(IBASEI,IBASEJ,0,ICHARG) = DEN_PP(IBASEI,IBASEJ,0,ICHARG) &
                    &   + BWAQUZ(IBASEI,ISTATE,0)*SU*conjg(BWAQUZ(IBASEJ,ISTATE,0))
                     DEN_PP(IBASEI,IBASEJ,1,ICHARG) = DEN_PP(IBASEI,IBASEJ,1,ICHARG) &
                    &   + BWAQUZ(IBASEI,ISTATE,1)*SU*conjg(BWAQUZ(IBASEJ,ISTATE,1))
                     DEN_PM(IBASEI,IBASEJ,0,ICHARG) = DEN_PM(IBASEI,IBASEJ,0,ICHARG) &
                    &   + BWAQUZ(IBASEI,ISTATE,0)*SU*conjg(BWAQUZ(IBASEJ,ISTATE,1))
                     DEN_PM(IBASEI,IBASEJ,1,ICHARG) = DEN_PM(IBASEI,IBASEJ,1,ICHARG) &
                    &   + BWAQUZ(IBASEI,ISTATE,1)*SU*conjg(BWAQUZ(IBASEJ,ISTATE,0))
         
                     CHI_PP(IBASEI,IBASEJ,0,ICHARG) = CHI_PP(IBASEI,IBASEJ,0,ICHARG) &
                    &   + BWAQUZ(IBASEI,ISTATE,0)*SU*conjg(AWAQUZ(IBASEJ,ISTATE,0))
                     CHI_PP(IBASEI,IBASEJ,1,ICHARG) = CHI_PP(IBASEI,IBASEJ,1,ICHARG) &
                    &   + BWAQUZ(IBASEI,ISTATE,1)*SU*conjg(AWAQUZ(IBASEJ,ISTATE,1))
                     CHI_PM(IBASEI,IBASEJ,0,ICHARG) = CHI_PM(IBASEI,IBASEJ,0,ICHARG) &
                    &   + BWAQUZ(IBASEI,ISTATE,0)*SU*conjg(AWAQUZ(IBASEJ,ISTATE,1))
                     CHI_PM(IBASEI,IBASEJ,1,ICHARG) = CHI_PM(IBASEI,IBASEJ,1,ICHARG) &
                    &   + BWAQUZ(IBASEI,ISTATE,1)*SU*conjg(AWAQUZ(IBASEJ,ISTATE,0))
                  ENDDO
               ENDDO
            ENDDO
         endif

      ENDIF
!-- XX20

      endsubroutine HFODD_SUBS

!===============================================================================
! This subroutine should be called before atdhf_implementation
! It pushes input parameters of HFODD subs used by ATDHF(B) into common block
! DSIPARAI(for integer), DSIPARAR(for real), and DSIPARAC(for character).
!
      subroutine PUSH_DSI_PARA(                                         &
     &                    ISIMTX,JSIMTY,ISIMTZ,ISIGNY,ISIMPY,ISIQTY,    &
     &                    IPAHFB,MREVER,MIN_QP,IPNMIX,ITPNMX,ITIREP,    &
     &                    IDEVAR,ITERUN,ISYMDE,INIROT,INIINV,INIKAR,    &
     &                    ISAWAV,IKERNE,IMOVAX,ITILAX,ITISAX,NO_ORB,    &
     &                    IROTAT,MPAHFB,IPOTHO,ISCHIF,IOCONT,NMUCON,    &
     &                    NSICON,I_YUKA,I_GOGA,I_REGA,I_SEPA,ITWOLI,    &
     &                    JETACM,KETA_R,ICOUDI,ICOUEX,LIPKIN,LIPKIP,    &
     &                    IF_RPA,ILIPON,ILIPOP,NEWGOG,NEWCOU,           &
     &                    ITWCEN,LTWCEN,LDTWCE,ICOTYP,IDOTHC,INDCOE,    &
     &                    IDEFIN,IDEFIP,IGOGPA,IREGPA,ISEPPA,ICOUPA,    &
     &                    ISREGA,ISREGP,N3LORD,I_SLOW,ISGOGA,ISGOGP,    &
     &                                                IN_FIX,IZ_FIX,    &
     &                                                       NAMEPN,    &
     &             AROTLT,ALINLT,PRINIT,XOLDEV,XOLDOD,EFER2N,EFER2P,    &
     &                                  SLOWEV,SLOWPA,DELFIN,DELFIP     )
      
      PARAMETER (NUMB_DSI_PARA_INT = 67, NUMB_DSI_PARA_REAL = 11)
      COMMON /DSIPARAI/ DSI_PARA_INT(NUMB_DSI_PARA_INT)
      COMMON /DSIPARAR/ DSI_PARA_REAL(NUMB_DSI_PARA_REAL)
      common /DSIPARAC/ DSI_PARA_CHAR
      CHARACTER NAMEPN*8, DSI_PARA_CHAR*8
      integer DSI_PARA_INT
      real    DSI_PARA_REAL

      DSI_PARA_INT = (/                                                 &
     &                    ISIMTX,JSIMTY,ISIMTZ,ISIGNY,ISIMPY,ISIQTY,    &
     &                    IPAHFB,MREVER,MIN_QP,IPNMIX,ITPNMX,ITIREP,    &
     &                    IDEVAR,ITERUN,ISYMDE,INIROT,INIINV,INIKAR,    &
     &                    ISAWAV,IKERNE,IMOVAX,ITILAX,ITISAX,NO_ORB,    &
     &                    IROTAT,MPAHFB,IPOTHO,ISCHIF,IOCONT,NMUCON,    &
     &                    NSICON,I_YUKA,I_GOGA,I_REGA,I_SEPA,ITWOLI,    &
     &                    JETACM,KETA_R,ICOUDI,ICOUEX,LIPKIN,LIPKIP,    &
     &                    IF_RPA,ILIPON,ILIPOP,NEWGOG,NEWCOU,           &
     &                    ITWCEN,LTWCEN,LDTWCE,ICOTYP,IDOTHC,INDCOE,    &
     &                    IDEFIN,IDEFIP,IGOGPA,IREGPA,ISEPPA,ICOUPA,    &
     &                    ISREGA,ISREGP,N3LORD,I_SLOW,ISGOGA,ISGOGP,    &
     &                                                IN_FIX,IZ_FIX    /)

      DSI_PARA_REAL = (/AROTLT,ALINLT,PRINIT,XOLDEV,XOLDOD,EFER2N,EFER2P,&
     &                                       SLOWEV,SLOWPA,DELFIN,DELFIP/)

      DSI_PARA_CHAR = NAMEPN

      endsubroutine PUSH_DSI_PARA

MODULE ADBATC
!===============================================================================
! %%- Data for ATDHF calculations
! ## parameters, provided by the main call?
!     -- max_iteration: maximal iterations
!     -- atd_precision: numerical tolerance for ATDHF(B) calculation
!     -- xchi : mixing parameter for ATDHF(B) iterations
!     -- ecut_adb: energy cutoff
!     -- M, N: dimension of particle/hole configurations
!
! ## data blocks
!     # ATDHF
!     -- elp, elh: particle/hole single particle energy
!     -- rho1: time-odd correction of density
!     -- gamma1: time-odd correction of mean field
!     -- rho_derivative: derivative of density with respect to the collective
!                        variables
!     -- eph: difference of particle/hole energy
!     -- S: sigular value of \rho1
!     -- U, V: eigenvector of \rho1
!     -- mass: collective mass
!     -- vec : eigenvector of rho1
!     -- rho1_old: rho1 in previous iteration
! ##
      implicit none

      integer  max_iteration
      real     atd_precision
      real     xchi
      real     ecut_adb
      integer  M, N
      real,    allocatable :: elp(:,:), elh(:,:)
      complex, allocatable :: rho1(:,:,:)
      complex, allocatable :: gamma1(:,:,:)
      complex, allocatable :: rho_derivative(:,:,:)
      real,    allocatable :: eph(:,:,:)
      real,    allocatable :: S(:,:)
      complex, allocatable :: U(:,:,:), V(:,:,:)
      real     mass
      complex, allocatable :: vec(:,:,:)
      complex, allocatable :: rho1_old(:,:,:)

! ##
!     # ATDHFB
!     -- F_MATS: matrix element of i*F
!     -- E_MATS: matrix element of EUV
!     -- D_CORR: matrix element of Z
!     -- H_CORR: matrix element of E1
!     -- D_CORR_old: D_CORR in previous iteration
!     -- NCONQX: length of the above arrays 
!     -- NCONFX: dimension of q.p. space after truncation
! ##
      complex, allocatable :: F_MATS(:,:,:)
      complex, allocatable :: G_MATS(:,:,:)
      complex, allocatable :: E_MATS(:,:,:)
      complex, allocatable :: D_CORR(:,:,:)
      complex, allocatable :: H_CORR(:,:,:)
      complex, allocatable :: D_CORR_old(:,:,:)
      integer  NCONQX, NCONFX
      COMMON /QBDIMS/ NCONFX(0:1)

! ##
!     # Array in which HF(B) density are saved
      complex, allocatable :: DE_SPI_SAV(:,:,:,:,:,:)

      complex, allocatable :: DE_RHO_SAV(:,:,:,:,:)
      complex, allocatable :: DE_TAU_SAV(:,:,:,:,:)
      complex, allocatable :: DE_LPR_SAV(:,:,:,:,:)
      complex, allocatable :: DE_DIV_SAV(:,:,:,:,:)
      !complex, allocatable :: DE_DIJ_SAV(:,:,:,:,:)
      complex, allocatable :: PD_RHO_SAV(:,:,:,:,:)
      complex, allocatable :: PD_TAU_SAV(:,:,:,:,:)
      complex, allocatable :: PD_LPR_SAV(:,:,:,:,:)
      complex, allocatable :: PP_RHO_SAV(:,:,:,:,:)
      complex, allocatable :: PP_TAU_SAV(:,:,:,:,:)
      complex, allocatable :: PP_LPR_SAV(:,:,:,:,:)
      complex, allocatable :: DE_SCU_SAV(:,:,:,:,:,:,:)
      complex, allocatable :: DE_DES_SAV(:,:,:,:,:,:,:)
      complex, allocatable :: PD_SCU_SAV(:,:,:,:,:,:,:)
      complex, allocatable :: PP_SCU_SAV(:,:,:,:,:,:,:)

! --- Auxiliary arrays ...
!     -- NUMBHE: number of hole state
!     -- NUMBPE: number of particle state
!     -- NUMBCS: number of total states under cutoff 'ecut_adb'
      integer  NUMBCS(0:1)
      integer  NUMBHE(0:1), NUMBPE(0:1)
      complex, allocatable :: BAVOCC(:,:,:)

! --- Debug mode flags
      integer IADB_DEBUG
      real    adj_rho, adj_gamma
      integer ifammode
      integer i_svd_on, imat_hh
      integer icol_mod, iset_num
      integer iset_100

!---- FAM coefficient ----
      real fam_eta

!---- Lables for the collective variables
      character*2 axis_str(0:2)

CONTAINS
!===============================================================================
! --- Implementation of adiabatic time-dependent Hartree-Fock-Bogoliubov method
      subroutine atdhfb_implementation
      use hfodd_gs_data
      implicit none

      integer i
      real mass_old, mass_res
      integer ICHARG

! --- Initialization
      call read_input_para
      call atdhfb_data_init(0)

      if(IABICH .lt. 0) return

! --- Cranking approximation
      call IB_mass

! --- Main iteration
      mass_old = -9999

      H_CORR = 0.d0
      call E1_to_Z
      do i = 1, max_iteration
          if(i .gt. 1) then
             D_CORR = xchi*D_CORR + (1-xchi)*D_CORR_old 
          endif
          D_CORR_old = D_CORR
          call Z_to_E1
          call E1_to_Z

          call ATDHFB_mass
          mass_res = mass_old - mass
          if(abs(mass_old - mass) < atd_precision .and. i .gt. 15) exit
          if(IADB_DEBUG .eq. 1 .or. IADB_DEBUG .eq. -1) then 
             write(*,'(a,i4,a,f12.5,a,f12.5,23X,1H*)') &
             &'# iter = ', i, ' mass = ', mass, ' residual ',mass_old - mass
          endif
          mass_old = mass
      enddo
      if(i > max_iteration) then
         write(*,'(a,i4,a,f12.5,11X,1H*)') &
         &'* Calculation terminated after ', i-1, ' steps, residual is ', mass_res
      endif
      

! --- Generating output & clean up
      call atdhfb_output

      endsubroutine atdhfb_implementation

!===============================================================================
! initialization of ATDHFB calculations, allocating and preparing necessary arrays
      subroutine atdhfb_data_init(ich)
      use hfodd_gs_data
      implicit none

      integer ich
      integer INDXMU, INDXNU
      integer NUMBUX, NUMBVX
      integer ICHARG
      integer NCONQB,NDIMUE,NDIMVE
      integer NCONQN,NCONQP

! ---  Set the mass term to 0
      if(ifammode .eq. 0) HBMRPA = 0.d0

! --- Determine the dimension of arrays according to Quasiparticle configuration
      NCONQN = NUMBQP(0,0) + NUMBQP(1,0)
      NCONQP = NUMBQP(0,1) + NUMBQP(1,1)
      NCONQX = max(NCONQN,NCONQP)

      NCONFX(0) = NCONQN
      NCONFX(1) = NCONQP

      if(ich == 0) then
         ! --- allocations
         allocate(E_MATS(NCONQX,NCONQX,0:NDISOS))
         allocate(D_CORR(NCONQX,NCONQX,0:NDISOS), H_CORR(NCONQX,NCONQX,0:NDISOS))
         allocate(F_MATS(NCONQX,NCONQX,0:NDISOS))
         allocate(G_MATS(NCONQX,NCONQX,0:NDISOS))
         allocate(D_CORR_old(NCONQX,NCONQX,0:NDISOS))
         call RS_even_density(0)

         ! --- reset skfild, SKPAIR, remove the effect of linear mixing
         Call HFODD_SUBS(-1,1)
         Call HFODD_SUBS(-1,4)
         ! --- save time-even/odd densities ---
         call RS_even_density(1)

         ! --- Prepare the quasiparticle energy matrix
         E_MATS = 0.d0
         DO ICHARG=0,NDISOS
            NCONQB = NUMBQP(0,ICHARG) + NUMBQP(1,ICHARG)
            NCONQB = NCONFX(ICHARG)
            do INDXMU = 1, NCONQB
               do INDXNU = 1, NCONQB
                  E_MATS(INDXMU,INDXNU,ICHARG) = QPENER(INDXMU,ICHARG) + QPENER(INDXNU,ICHARG)
               enddo
            enddo
         ENDDO

         ! --- calculate the derivative of density
         iset_100 = mod(abs(iset_num),100)
         call calculate_F_MATS
         G_MATS = F_MATS

         if(IABCOL.eq.2 .and. abs(iset_num).gt.99 .and. iset_num .ge. 0) then
            iset_100 = abs(iset_num)/100
            SFIADB = SFJADB
            call calculate_F_MATS
         endif

      endif

      if(ich == 1) then

         ! --- free memory space...
         deallocate(D_CORR, H_CORR, F_MATS, G_MATS, E_MATS, D_CORR_old)
      endif

      endsubroutine atdhfb_data_init

!===============================================================================
! Calculating the collective inertial under cranking approximation
! Wroking in QP spapce
      subroutine IB_mass
      use hfodd_gs_data
      implicit none
      integer i_lambda, i_chi

      !Z = iF/EUV
      H_CORR = 0.d0
      call E1_to_Z
      call ATDHFB_mass

      if(iABCOL .EQ. 1) THEN
          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,  &
     &  1H*,2X,''Inglis-Belyaev MOMENT OF INERTIA ALONG '',        &
     &                                               A2,''AXIS '', &
     &                         ''IS '',F12.5,'' MeV-1'', 8X,1H*,/, &
     &                                             1H*,77X,1H*)')  &
     &    axis_str(iset_num), mass
      endif

      if(iABCOL .EQ. 2 .and. abs(iset_num) .le. 99) THEN
          i_lambda = abs(iset_num)/10

          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,  &
     &               1H*,2X,''IB MOMENT OF INERTIA FOR Q'',I2,     &
     &                                            '' VIBRATION '', &
     &         ''IS '',F12.5,'' [10FM]-'',I1,'' MeV-1'', 6X,1H*,/, &
     &                                             1H*,77X,1H*)')  &
     &    iset_num, mass, 2*i_lambda
      endif

      if(iABCOL .EQ. 2 .and. abs(iset_num) .gt. 99) THEN
          i_lambda = (abs(iset_num)/100)/10
          i_chi = mod(abs(iset_num),100)/10

          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,  &
     &               1H*,2X,''IB MOMENT OF INERTIA FOR Q'',I2,     &
     &         ''-'',I2,                               '' VIB. '', &
     &         ''IS '',F12.5,'' [10FM]-'',I1,'' MeV-1'', 8X,1H*,/, &
     &                                             1H*,77X,1H*)')  &
     &    abs(iset_num)/100, mod(abs(iset_num),100), mass, i_lambda + i_chi
      endif

      endsubroutine IB_mass

!===============================================================================
! update Z with E1
      subroutine E1_to_Z
      use hfodd_gs_data, only : NDISOS, NUMBQP
      implicit none
      integer ICHARG,NCONQB

      ! Z = 1.0/EUV * (iF - E1)
      D_CORR = 0.d0
      DO ICHARG=0,NDISOS
         NCONQB = NUMBQP(0,ICHARG) + NUMBQP(1,ICHARG)
         NCONQB = NCONFX(ICHARG)
         D_CORR(1:NCONQB,1:NCONQB,ICHARG) = 1.d0/E_MATS(1:NCONQB,1:NCONQB,ICHARG) * &
        & (G_MATS(1:NCONQB,1:NCONQB,ICHARG) - H_CORR(1:NCONQB,1:NCONQB,ICHARG))
      ENDDO

      endsubroutine E1_to_Z

!===============================================================================
subroutine ATDHFB_mass
use hfodd_gs_data, only : NDISOS, NUMBQP
implicit none

integer INDXMU,INDXNU
integer ICHARG,NCONQB

complex resu
real    mass_isos(0:NDISOS)

mass = 0.d0
! -- mass = 1/2 i * Re[Tr(F^* Z - F Z^*)] 
!         = - 1/2 Re[Tr(F_MATS^* Z + F_MATS Z^*)], note F_MATS = i*F
DO ICHARG = 0, NDISOS

   NCONQB = NUMBQP(0,ICHARG) + NUMBQP(1,ICHARG)
   NCONQB = NCONFX(ICHARG)

   resu = 0.d0
   do INDXMU = 1, NCONQB
      do INDXNU = 1, NCONQB
         resu = resu + D_CORR(INDXNU,INDXMU,ICHARG) * conjg(F_MATS(INDXMU,INDXNU,ICHARG)) &
              & + conjg(D_CORR(INDXNU,INDXMU,ICHARG)) * F_MATS(INDXMU,INDXNU,ICHARG)
      enddo
   enddo
   mass_isos(ICHARG) = -real(resu)*0.5d0
   mass = mass + mass_isos(ICHARG)

ENDDO

endsubroutine ATDHFB_mass

!===============================================================================
subroutine calculate_F_MATS
! calculating the matrix element of iF
! TDRRHO : [j,\rho_0],   note TDRRHO = i \dot{\rho}
! TDRKAP : (j \kappa_0 + \kappa j^*), note TDRKAP = i \dot{\kappa}
use hfodd_gs_data
implicit none

real    FACTOR
real,   allocatable :: HAUXPP(:,:), HAUXPM(:,:), HAUXMP(:,:), HAUXMM(:,:)
complex,allocatable :: FAUXPP(:,:), FAUXPM(:,:), FAUXMP(:,:), FAUXMM(:,:)
real,   allocatable :: HAUXTT(:,:)
complex,allocatable :: TDRRHO(:,:,:,:,:),TDRKAP(:,:,:,:,:)
integer IBASEI, IBASEJ, IBASEM, ICHARG, INDXMU, INDXNU, NCONQB
complex RESUPP, RESUPM, RESUMP, RESUMM
integer ISTATE,IREVEI,IREVEJ,JREVEI,JREVEJ
complex c_one, czero, cmone, i_unit
complex,allocatable :: RESUXX(:,:)
complex anti_sym
integer i_lambda, i_mu

c_one = (1.d0,0.d0) 
czero = (0.d0,0.d0)
cmone = -c_one
i_unit = (0.d0,1.d0)

if(icol_mod .ne. 1 .and. icol_mod .ne. 2) stop 'Unsupported collective motion'

!rho = B^* B^T; kappa = B^* A^T
DEN_PP = 0; DEN_PM = 0; CHI_PP = 0; CHI_PM = 0;
DO ICHARG=0,NDISOS
   NCONQB = NUMBQP(0,ICHARG) + NUMBQP(1,ICHARG)
   AWAQUZ(:,:,:)=ASVQUA(:,:,:,ICHARG)
   BWAQUZ(:,:,:)=BSVQUA(:,:,:,ICHARG)
   DO IBASEI=1,LDBASE
      DO IBASEJ=1,LDBASE
         DO ISTATE=1,NCONQB
            DEN_PP(IBASEI,IBASEJ,0,ICHARG) = DEN_PP(IBASEI,IBASEJ,0,ICHARG) &
           &   + BWAQUZ(IBASEI,ISTATE,0)*conjg(BWAQUZ(IBASEJ,ISTATE,0))
            DEN_PP(IBASEI,IBASEJ,1,ICHARG) = DEN_PP(IBASEI,IBASEJ,1,ICHARG) &
           &   + BWAQUZ(IBASEI,ISTATE,1)*conjg(BWAQUZ(IBASEJ,ISTATE,1))
            DEN_PM(IBASEI,IBASEJ,0,ICHARG) = DEN_PM(IBASEI,IBASEJ,0,ICHARG) &
           &   + BWAQUZ(IBASEI,ISTATE,0)*conjg(BWAQUZ(IBASEJ,ISTATE,1))
            DEN_PM(IBASEI,IBASEJ,1,ICHARG) = DEN_PM(IBASEI,IBASEJ,1,ICHARG) &
           &   + BWAQUZ(IBASEI,ISTATE,1)*conjg(BWAQUZ(IBASEJ,ISTATE,0))

            CHI_PP(IBASEI,IBASEJ,0,ICHARG) = CHI_PP(IBASEI,IBASEJ,0,ICHARG) &
           &   + BWAQUZ(IBASEI,ISTATE,0)*conjg(AWAQUZ(IBASEJ,ISTATE,0))
            CHI_PP(IBASEI,IBASEJ,1,ICHARG) = CHI_PP(IBASEI,IBASEJ,1,ICHARG) &
           &   + BWAQUZ(IBASEI,ISTATE,1)*conjg(AWAQUZ(IBASEJ,ISTATE,1))
            CHI_PM(IBASEI,IBASEJ,0,ICHARG) = CHI_PM(IBASEI,IBASEJ,0,ICHARG) &
           &   + BWAQUZ(IBASEI,ISTATE,0)*conjg(AWAQUZ(IBASEJ,ISTATE,1))
            CHI_PM(IBASEI,IBASEJ,1,ICHARG) = CHI_PM(IBASEI,IBASEJ,1,ICHARG) &
           &   + BWAQUZ(IBASEI,ISTATE,1)*conjg(AWAQUZ(IBASEJ,ISTATE,0))
         ENDDO
      ENDDO
   ENDDO

   ! -- anti-symmetrize kappa
   DO IBASEI=1,LDBASE
      DO IBASEJ=1,LDBASE
         anti_sym = (CHI_PM(IBASEI,IBASEJ,0,ICHARG) - CHI_PM(IBASEJ,IBASEI,1,ICHARG))/2
         CHI_PM(IBASEI,IBASEJ,0,ICHARG) = + anti_sym
         CHI_PM(IBASEJ,IBASEI,1,ICHARG) = - anti_sym
      ENDDO
   ENDDO

ENDDO ! ICHARG

allocate(TDRRHO(1:NDBASE,1:NDBASE,0:1,0:1,0:NDISOS),TDRKAP(1:NDBASE,1:NDBASE,0:1,0:1,0:NDISOS))

! ####
! -- collective rotation --
if(icol_mod .eq. 1) then
   if(iset_num .ne. 0 .and. iset_num .ne. 1 .and. iset_num .ne. 2) &
   & stop 'Wrong axis for collective rotation ..'
   
   allocate(HAUXPP(1:NDBASE,1:NDBASE),HAUXPM(1:NDBASE,1:NDBASE))
   allocate(HAUXMP(1:NDBASE,1:NDBASE),HAUXMM(1:NDBASE,1:NDBASE))
   allocate(HAUXTT(1:NDBASE,1:NDBASE))
   allocate(FAUXPP(1:NDBASE,1:NDBASE),FAUXPM(1:NDBASE,1:NDBASE))
   allocate(FAUXMP(1:NDBASE,1:NDBASE),FAUXMM(1:NDBASE,1:NDBASE))
   
   ! iset_num: 0 -- JY; 1 -- JZ; 2 -- JX; 
   axis_str(0) = 'Y-'; axis_str(1) = 'Z-'; axis_str(2) = 'X-'
   
   FACTOR = 1.d0
   if(iset_num == 0) then
      ! -- set 0 --
      CALL INT_SY(HAUXTT,FACTOR)
      CALL INT_LY(IPHAPP(0,0,0),HAUXPP,FACTOR)
      CALL INT_LY(IPHAPM(0,0,0),HAUXPM,FACTOR)
      CALL INT_LY(IPHAMP(0,0,0),HAUXMP,FACTOR)
      CALL INT_LY(IPHAMM(0,0,0),HAUXMM,FACTOR)
   
      FAUXPP = HAUXPP*i_unit + HAUXTT
      FAUXPM = HAUXPM*i_unit
      FAUXMP = HAUXMP*i_unit
      FAUXMM = HAUXMM*i_unit - HAUXTT
   
   else if(iset_num == 1) then
      ! -- set 1 --
      CALL INT_SZ(HAUXTT,FACTOR)
      CALL INT_LZ(IPHAPP(0,0,0),HAUXPP,FACTOR)
      CALL INT_LZ(IPHAPM(0,0,0),HAUXPM,FACTOR)
      CALL INT_LZ(IPHAMP(0,0,0),HAUXMP,FACTOR)
      CALL INT_LZ(IPHAMM(0,0,0),HAUXMM,FACTOR)
   
      FAUXPP = HAUXPP*i_unit
      FAUXPM = HAUXPM*i_unit + HAUXTT*i_unit
      FAUXMP = HAUXMP*i_unit - HAUXTT*i_unit
      FAUXMM = HAUXMM*i_unit
   
   else if(iset_num == 2) then
      ! -- set 2 --
      CALL INT_SX(HAUXTT,FACTOR)
      CALL INT_LX(IPHAPP(0,0,0),HAUXPP,FACTOR)
      CALL INT_LX(IPHAPM(0,0,0),HAUXPM,FACTOR)
      CALL INT_LX(IPHAMP(0,0,0),HAUXMP,FACTOR)
      CALL INT_LX(IPHAMM(0,0,0),HAUXMM,FACTOR)
   
      FAUXPP = HAUXPP*i_unit
      FAUXPM = HAUXPM*i_unit + HAUXTT
      FAUXMP = HAUXMP*i_unit + HAUXTT
      FAUXMM = HAUXMM*i_unit
   
   endif ! iset_num

   !----------------------------------------------------------------------
   ! TDRKAP : (j \kappa_0 + \kappa j^*) == <J,K>
   !--- <J,K>++ = J++K++ + J+-K-+ + K++J++ + K+-J+-
   !--- <J,K>+- = J++K+- + J+-K-- + K++J-+ + K+-J--
   !--- <J,K>-+ = J-+K++ + J--K-+ + K-+J++ + K--J+-
   !--- <J,K>-- = J-+K+- + J--K-- + K-+J-+ + K--J--
   DO ICHARG=0,NDISOS
      ! j^y_{at}\kappa^0_{tb}+\kappa^0_{at}j^{y}_{bt}
      DO IBASEI=1,LDBASE
         DO IBASEJ=1,LDBASE
            RESUPP = 0; RESUPM = 0; RESUMP = 0; RESUMM = 0;
            DO IBASEM=1,LDBASE
               RESUPP = RESUPP                                               &
     &                + FAUXPP(IBASEI,IBASEM)*CHI_PP(IBASEM,IBASEJ,0,ICHARG) &
     &                + FAUXPM(IBASEI,IBASEM)*CHI_PM(IBASEM,IBASEJ,1,ICHARG) &
     &                + CHI_PP(IBASEI,IBASEM,0,ICHARG)*FAUXPP(IBASEJ,IBASEM) &
     &                + CHI_PM(IBASEI,IBASEM,0,ICHARG)*FAUXPM(IBASEJ,IBASEM)
               RESUPM = RESUPM                                               &
     &                + FAUXPP(IBASEI,IBASEM)*CHI_PM(IBASEM,IBASEJ,0,ICHARG) &
     &                + FAUXPM(IBASEI,IBASEM)*CHI_PP(IBASEM,IBASEJ,1,ICHARG) &
     &                + CHI_PP(IBASEI,IBASEM,0,ICHARG)*FAUXMP(IBASEJ,IBASEM) &
     &                + CHI_PM(IBASEI,IBASEM,0,ICHARG)*FAUXMM(IBASEJ,IBASEM)
               RESUMP = RESUMP                                               &
     &                + FAUXMP(IBASEI,IBASEM)*CHI_PP(IBASEM,IBASEJ,0,ICHARG) &
     &                + FAUXMM(IBASEI,IBASEM)*CHI_PM(IBASEM,IBASEJ,1,ICHARG) &
     &                + CHI_PM(IBASEI,IBASEM,1,ICHARG)*FAUXPP(IBASEJ,IBASEM) &
     &                + CHI_PP(IBASEI,IBASEM,1,ICHARG)*FAUXPM(IBASEJ,IBASEM)
               RESUMM = RESUMM                                               &
     &                + FAUXMP(IBASEI,IBASEM)*CHI_PM(IBASEM,IBASEJ,0,ICHARG) &
     &                + FAUXMM(IBASEI,IBASEM)*CHI_PP(IBASEM,IBASEJ,1,ICHARG) &
     &                + CHI_PM(IBASEI,IBASEM,1,ICHARG)*FAUXMP(IBASEJ,IBASEM) &
     &                + CHI_PP(IBASEI,IBASEM,1,ICHARG)*FAUXMM(IBASEJ,IBASEM)
            ENDDO
            TDRKAP(IBASEI,IBASEJ,0,0,ICHARG) = RESUPP
            TDRKAP(IBASEI,IBASEJ,0,1,ICHARG) = RESUPM
            TDRKAP(IBASEI,IBASEJ,1,0,ICHARG) = RESUMP
            TDRKAP(IBASEI,IBASEJ,1,1,ICHARG) = RESUMM
         ENDDO
      ENDDO
   
   !----------------------------------------------------------------------
   ! TDRRHO : [j,\rho_0]
   !--- [J,R]++ = J++R++ + J+-R-+ - R++J++ - R+-J-+
   !--- [J,R]+- = J++R+- + J+-R-- - R++J+- - R+-J--
   !--- [J,R]-+ = J-+R++ + J--R-+ - R-+J++ - R--J-+
   !--- [J,R]-- = J-+R+- + J--R-- - R-+J+- - R--J--   
      ! j^y_{at}\rho^0_{tb}-\rho^0_{at}j^y_{tb}: anti-Hermitian
      DO IBASEI=1,LDBASE
         DO IBASEJ=1,LDBASE
            RESUPP = 0; RESUPM = 0; RESUMP = 0; RESUMM = 0;
            DO IBASEM=1,LDBASE
               RESUPP = RESUPP                                               &
     &                + FAUXPP(IBASEI,IBASEM)*DEN_PP(IBASEM,IBASEJ,0,ICHARG) &
     &                + FAUXPM(IBASEI,IBASEM)*DEN_PM(IBASEM,IBASEJ,1,ICHARG) &
     &                - DEN_PP(IBASEI,IBASEM,0,ICHARG)*FAUXPP(IBASEM,IBASEJ) &
     &                - DEN_PM(IBASEI,IBASEM,0,ICHARG)*FAUXMP(IBASEM,IBASEJ)
               RESUPM = RESUPM                                               &
     &                + FAUXPP(IBASEI,IBASEM)*DEN_PM(IBASEM,IBASEJ,0,ICHARG) &
     &                + FAUXPM(IBASEI,IBASEM)*DEN_PP(IBASEM,IBASEJ,1,ICHARG) &
     &                - DEN_PP(IBASEI,IBASEM,0,ICHARG)*FAUXPM(IBASEM,IBASEJ) &
     &                - DEN_PM(IBASEI,IBASEM,0,ICHARG)*FAUXMM(IBASEM,IBASEJ)
               RESUMP = RESUMP                                               &
     &                + FAUXMP(IBASEI,IBASEM)*DEN_PP(IBASEM,IBASEJ,0,ICHARG) &
     &                + FAUXMM(IBASEI,IBASEM)*DEN_PM(IBASEM,IBASEJ,1,ICHARG) &
     &                - DEN_PM(IBASEI,IBASEM,1,ICHARG)*FAUXPP(IBASEM,IBASEJ) &
     &                - DEN_PP(IBASEI,IBASEM,1,ICHARG)*FAUXMP(IBASEM,IBASEJ)
               RESUMM = RESUMM                                               &
     &                + FAUXMP(IBASEI,IBASEM)*DEN_PM(IBASEM,IBASEJ,0,ICHARG) &
     &                + FAUXMM(IBASEI,IBASEM)*DEN_PP(IBASEM,IBASEJ,1,ICHARG) &
     &                - DEN_PM(IBASEI,IBASEM,1,ICHARG)*FAUXPM(IBASEM,IBASEJ) &
     &                - DEN_PP(IBASEI,IBASEM,1,ICHARG)*FAUXMM(IBASEM,IBASEJ)
            ENDDO
            TDRRHO(IBASEI,IBASEJ,0,0,ICHARG) = RESUPP
            TDRRHO(IBASEI,IBASEJ,0,1,ICHARG) = RESUPM
            TDRRHO(IBASEI,IBASEJ,1,0,ICHARG) = RESUMP
            TDRRHO(IBASEI,IBASEJ,1,1,ICHARG) = RESUMM
         ENDDO
      ENDDO
   
   ENDDO ! ICHARG

   
   deallocate(HAUXPP,HAUXPM,HAUXMP,HAUXMM,HAUXTT)
   deallocate(FAUXPP,FAUXPM,FAUXMP,FAUXMM)
endif  ! -- collective rotation --


! ####
! -- collective vibration --
if(icol_mod .eq. 2) then
 
   i_lambda = abs(iset_100)/10
   i_mu = mod(abs(iset_100),10)

   if(iset_num .lt. 0) then
      call RWADBP(0)
      WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/, &
     & 1H*,2X,''DENSITY SAVED FOR ATDHFB CALCULATION'', 39X,1H*,/, &
     &                                             1H*,77X,1H*)')
      return
   endif

   if(iset_num .gt. 0) then
      ! -- save density matrix & pairing tensor at reference deformation --
      TDRRHO(1:NDBASE,1:NDBASE,0,0,0:NDISOS) = DEN_PP(1:NDBASE,1:NDBASE,0,0:NDISOS)
      TDRRHO(1:NDBASE,1:NDBASE,1,1,0:NDISOS) = DEN_PP(1:NDBASE,1:NDBASE,1,0:NDISOS)
      TDRRHO(1:NDBASE,1:NDBASE,0,1,0:NDISOS) = DEN_PM(1:NDBASE,1:NDBASE,0,0:NDISOS)
      TDRRHO(1:NDBASE,1:NDBASE,1,0,0:NDISOS) = DEN_PM(1:NDBASE,1:NDBASE,1,0:NDISOS)

      TDRKAP(1:NDBASE,1:NDBASE,0,0,0:NDISOS) = CHI_PP(1:NDBASE,1:NDBASE,0,0:NDISOS)
      TDRKAP(1:NDBASE,1:NDBASE,1,1,0:NDISOS) = CHI_PP(1:NDBASE,1:NDBASE,1,0:NDISOS)
      TDRKAP(1:NDBASE,1:NDBASE,0,1,0:NDISOS) = CHI_PM(1:NDBASE,1:NDBASE,0,0:NDISOS)
      TDRKAP(1:NDBASE,1:NDBASE,1,0,0:NDISOS) = CHI_PM(1:NDBASE,1:NDBASE,1,0:NDISOS)

      ! -- read density matrix & pairing tensor at induced deformation --
      call RWADBP(1)

      ! -- calculated the numerical difference --
      TDRRHO(1:NDBASE,1:NDBASE,0,0,0:NDISOS) = TDRRHO(1:NDBASE,1:NDBASE,0,0,0:NDISOS) &
                                             & - DEN_PP(1:NDBASE,1:NDBASE,0,0:NDISOS)
      TDRRHO(1:NDBASE,1:NDBASE,1,1,0:NDISOS) = TDRRHO(1:NDBASE,1:NDBASE,1,1,0:NDISOS) &
                                             & - DEN_PP(1:NDBASE,1:NDBASE,1,0:NDISOS)
      TDRRHO(1:NDBASE,1:NDBASE,0,1,0:NDISOS) = TDRRHO(1:NDBASE,1:NDBASE,0,1,0:NDISOS) &
                                             & - DEN_PM(1:NDBASE,1:NDBASE,0,0:NDISOS)
      TDRRHO(1:NDBASE,1:NDBASE,1,0,0:NDISOS) = TDRRHO(1:NDBASE,1:NDBASE,1,0,0:NDISOS) &
                                             & - DEN_PM(1:NDBASE,1:NDBASE,1,0:NDISOS)

      TDRKAP(1:NDBASE,1:NDBASE,0,0,0:NDISOS) = TDRKAP(1:NDBASE,1:NDBASE,0,0,0:NDISOS) &
                                             & - CHI_PP(1:NDBASE,1:NDBASE,0,0:NDISOS)
      TDRKAP(1:NDBASE,1:NDBASE,1,1,0:NDISOS) = TDRKAP(1:NDBASE,1:NDBASE,1,1,0:NDISOS) &
                                             & - CHI_PP(1:NDBASE,1:NDBASE,1,0:NDISOS)
      TDRKAP(1:NDBASE,1:NDBASE,0,1,0:NDISOS) = TDRKAP(1:NDBASE,1:NDBASE,0,1,0:NDISOS) &
                                             & - CHI_PM(1:NDBASE,1:NDBASE,0,0:NDISOS)
      TDRKAP(1:NDBASE,1:NDBASE,1,0,0:NDISOS) = TDRKAP(1:NDBASE,1:NDBASE,1,0,0:NDISOS) &
                                             & - CHI_PM(1:NDBASE,1:NDBASE,1,0:NDISOS)

      ! -- adjust the phase factor --
      TDRRHO = TDRRHO*(0.d0,1.d0)/( QMUL_T(i_lambda,i_mu) - RMUL_T(i_lambda,i_mu) )
      TDRKAP = TDRKAP*(0.d0,1.d0)/( QMUL_T(i_lambda,i_mu) - RMUL_T(i_lambda,i_mu) )      
   endif
   
   WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,  &
   & 1H*,2X,''DENSITY DERIVATIVE IS EVALUATED AT THE FOLLOWING'',&
   &                     '' MULTIPOLE DEFORMATIONS: '',2X,1H*,/, &
   & 1H*,2X,''[R] Q_'',I2,'' ='',F10.4,'' [10FM]^'',I1, 10X,     &
   &        ''[I] Q_'',I2,'' ='',F10.4,'' [10FM]^'',I1, 7X,1H*,/,&
   &                                             1H*,77X,1H*)')  &
   &    abs(iset_100), QMUL_T(i_lambda,i_mu), i_lambda,          &
   &    abs(iset_100), RMUL_T(i_lambda,i_mu), i_lambda

endif ! -- collective vibration --

!------------------------------------------------------------------------
! F = A^{\dagger}\dot{\rho_0}B^* + A^{\dagger}\dot{\kappa_0}A^* 
!   - B^{\dagger}\dot{\kappa}^*_0B^* - B^{\dagger}\dot{\rho}^*_0A^*.
! note: AWAQUZ is A^*; BWAQUZ is B^*
! TDRRHO : Time-derivative of density operator
! TDRKAP : Time-derivative of pairing tensor
!------------------------------------------------------------------------

F_MATS = 0.d0
DO ICHARG=0,NDISOS
   NCONQB = NUMBQP(0,ICHARG) + NUMBQP(1,ICHARG)
   NCONQB = NCONFX(ICHARG)
   AWAQUZ(:,:,:)=ASVQUA(:,:,:,ICHARG)
   BWAQUZ(:,:,:)=BSVQUA(:,:,:,ICHARG)

   allocate(RESUXX(NCONQB,LDBASE))
   do IREVEI = 0,1
      do IREVEJ = 0,1
         ! \kappa^\dagger = -\kappa^*; \rho^T = \rho^*
         ! --- A^{\dagger}\dot{\rho_0}B^* ---
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                                            &
     &              c_one, AWAQUZ(1,1,IREVEI), NDBASE, TDRRHO(1,1,IREVEI,IREVEJ,ICHARG), NDBASE, &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                                            &
     &              c_one, RESUXX, NCONQB, BWAQUZ(1,1,IREVEJ), NDBASE,                           &
     &              c_one, F_MATS(1,1,ICHARG), NCONQX)

        ! --- A^{\dagger}\dot{\kappa_0}A^*
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                                            &
     &              c_one, AWAQUZ(1,1,IREVEI), NDBASE, TDRKAP(1,1,IREVEI,IREVEJ,ICHARG), NDBASE, &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                                            &
     &              c_one, RESUXX, NCONQB, AWAQUZ(1,1,IREVEJ), NDBASE,                           &
     &              c_one, F_MATS(1,1,ICHARG), NCONQX)

        ! --- -B^{\dagger}\dot{\kappa}^*_0B^* = B^{\dagger}\dot{\kappa}^{\dagger}_0B^*
        ! --- Note TDRKAP = i\dot{\kappa}, 
        ! --- therefore, TDRKAP^{\dagger} = -i\dot{\kappa}^{\dagger}.
         if(mod(IREVEI+IREVEJ,2).eq.0) then
            JREVEI = IREVEI; JREVEJ = IREVEJ;
         else
            JREVEI = IREVEJ; JREVEJ = IREVEI;
         endif
         call ZGEMM('T', 'C', NCONQB, LDBASE, LDBASE,                                            &
     &              c_one, BWAQUZ(1,1,IREVEI), NDBASE, TDRKAP(1,1,JREVEI,JREVEJ,ICHARG), NDBASE, &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                                            &
     &              cmone, RESUXX, NCONQB, BWAQUZ(1,1,IREVEJ), NDBASE,                           &
     &              c_one, F_MATS(1,1,ICHARG), NCONQX)

        ! --- -B^{\dagger}\dot{\rho}^*_0A^* = -B^{\dagger}\dot{\rho}^T_0A^*
         if(mod(IREVEI+IREVEJ,2).eq.0) then
            JREVEI = IREVEI; JREVEJ = IREVEJ;
         else
            JREVEI = IREVEJ; JREVEJ = IREVEI;
         endif
         call ZGEMM('T', 'T', NCONQB, LDBASE, LDBASE,                                            &
     &              c_one, BWAQUZ(1,1,IREVEI), NDBASE, TDRRHO(1,1,JREVEI,JREVEJ,ICHARG), NDBASE, &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                                            &
     &              cmone, RESUXX, NCONQB, AWAQUZ(1,1,IREVEJ), NDBASE,                           &
     &              c_one, F_MATS(1,1,ICHARG), NCONQX)
      enddo
   enddo
   deallocate(RESUXX)

ENDDO ! ICHARG


deallocate(TDRRHO,TDRKAP)

endsubroutine calculate_F_MATS


!===============================================================================
subroutine Z_to_E1
use hfodd_gs_data
implicit none

integer ICHARG, ISTEP
integer IBASE, ISTATE, JSTATE, LSTATE

COMPLEX, ALLOCATABLE :: CELMTS(:)
REAL, ALLOCATABLE :: EIGVAL(:)
COMPLEX, ALLOCATABLE :: EWAVEF(:,:)
COMPLEX, ALLOCATABLE :: UWAQUA(:,:,:), VWAQUA(:,:,:)

integer LDACTU, NDACTU, NUMVEC
integer NCONQB
integer INDXMU, INDXNU, IKET, IBRA, NCOUNT
integer IBASEI, IREVEI, IREVER
COMPLEX RESU
!
complex c_one, czero, cmone
complex,allocatable :: RESUXX(:,:)

c_one = (1.d0,0.d0) 
czero = (0.d0,0.d0)
cmone = -c_one

DO ICHARG = 0, NDISOS

   NCONQB = NUMBQP(0,ICHARG) + NUMBQP(1,ICHARG)
   NCONQB = NCONFX(ICHARG)
   NDACTU = 2*NCONQB
   LDACTU = NDACTU
   NUMVEC = NDACTU
   ALLOCATE( CELMTS(1:((NDACTU+1)*NDACTU)/2) )
   ALLOCATE( EIGVAL(1:NDACTU) )
   ALLOCATE( EWAVEF(1:NDACTU,1:NDACTU) )

   ALLOCATE(UWAQUA(NDBASE,NDACTU,0:NDREVE),VWAQUA(NDBASE,NDACTU,0:NDREVE))

   CELMTS = 0.d0

   select case (ifammode)
   case(0)
   ! --- linearalized
      DO INDXMU = 1,NCONQB
         DO INDXNU = 1,NCONQB
            IBRA = INDXMU + NCONQB
            IKET = INDXNU
            NCOUNT=IBRA+((2*NDACTU-IKET)*(IKET-1))/2
            CELMTS(NCOUNT)=-conjg( D_CORR(INDXMU,INDXNU,ICHARG) )
         END DO
      END DO

   case(-1)
   ! --- HFB
      DO INDXMU = 1,NCONQB
            IBRA = INDXMU + NCONQB
            IKET = IBRA
            NCOUNT=IBRA+((2*NDACTU-IKET)*(IKET-1))/2
            CELMTS(NCOUNT)= 1.0d0
      END DO

   case(1)
   ! --- FAM
      DO INDXMU = 1,NCONQB
            IBRA = INDXMU + NCONQB
            IKET = IBRA
            NCOUNT=IBRA+((2*NDACTU-IKET)*(IKET-1))/2
            CELMTS(NCOUNT)= 1.0d0
      END DO
      DO INDXMU = 1,NCONQB
         DO INDXNU = 1,NCONQB
            IBRA = INDXMU + NCONQB
            IKET = INDXNU
            NCOUNT=IBRA+((2*NDACTU-IKET)*(IKET-1))/2
            CELMTS(NCOUNT)=-fam_eta*conjg( D_CORR(INDXMU,INDXNU,ICHARG) )
         END DO
      END DO

   case default
      stop 'unknown runmode ..'
   end select


   CALL DIAMAT(CELMTS,EIGVAL,EWAVEF,LDACTU,NDACTU,NUMVEC)


! -- $ B_{h' i} = \sum_{\mu} \varphi_{\mu h'} A_{\mu i} $
! |A B^*|*|U V^*|
! |B A^*|*|V U^*|

   AWAQUZ(:,:,:)=ASVQUA(:,:,:,ICHARG)
   BWAQUZ(:,:,:)=BSVQUA(:,:,:,ICHARG)
! note AWAQUZ -> A^*, BWAQUZ -> B^*
! U = EWAVEF(1:NCONQB,ISTATE), V = EWAVEF(NCONQB+1:2*NCONQB,ISTATE)
! |\sum_{a} A_{ia}*U_{ab} + B^*_{ia}*V_{ab},    \sum_{a} A_{ia}*V^*_{ab} + B^*_{ia}*U^*_{ab}|
! |\sum_{a} B_{ia}*U_{ab} + A^*_{ia}*V_{ab},    \sum_{a} B_{ia}*V^*_{ab} + A^*_{ia}*U^*_{ab}| 
   DO ISTATE = 1, NCONQB
      DO IBASEI = 1, LDBASE
         DO IREVEI = 0, 1
            ! \sum_{a} A_{ia}*U_{ab} + B^*_{ia}*V_{ab}
            RESU = 0.d0
            DO INDXMU = 1, NCONQB
               RESU = RESU + conjg(AWAQUZ(IBASEI,INDXMU,IREVEI))*EWAVEF(INDXMU,ISTATE) &
                    &      + BWAQUZ(IBASEI,INDXMU,IREVEI)*EWAVEF(INDXMU+NCONQB,ISTATE)
            ENDDO
            UWAQUA(IBASEI,ISTATE,IREVEI) = RESU
            
            ! \sum_{a} B_{ia}*U_{ab} + A^*_{ia}*V_{ab}
            RESU = 0.d0
            DO INDXMU = 1, NCONQB
               RESU = RESU + conjg(BWAQUZ(IBASEI,INDXMU,IREVEI))*EWAVEF(INDXMU,ISTATE) &
                    &      + AWAQUZ(IBASEI,INDXMU,IREVEI)*EWAVEF(INDXMU+NCONQB,ISTATE)
            ENDDO
            VWAQUA(IBASEI,ISTATE,IREVEI) = RESU
   
            ! \sum_{a} A_{ia}*V^*_{ab} + B^*_{ia}*U^*_{ab}
            RESU = 0.d0
            DO INDXMU = 1, NCONQB
               RESU = RESU + conjg(AWAQUZ(IBASEI,INDXMU,IREVEI))*EWAVEF(INDXMU,ISTATE+NCONQB) &
                    &      + BWAQUZ(IBASEI,INDXMU,IREVEI)*EWAVEF(INDXMU+NCONQB,ISTATE+NCONQB)
            ENDDO
            UWAQUA(IBASEI,ISTATE+NCONQB,IREVEI) = RESU
   
            ! \sum_{a} B_{ia}*V^*_{ab} + A^*_{ia}*U^*_{ab}
            RESU = 0.d0
            DO INDXMU = 1, NCONQB
               RESU = RESU + conjg(BWAQUZ(IBASEI,INDXMU,IREVEI))*EWAVEF(INDXMU,ISTATE+NCONQB) &
                    &      + AWAQUZ(IBASEI,INDXMU,IREVEI)*EWAVEF(INDXMU+NCONQB,ISTATE+NCONQB)
            ENDDO
            VWAQUA(IBASEI,ISTATE+NCONQB,IREVEI) = RESU
         ENDDO
      ENDDO
   ENDDO

   call active_I_SING(1)

   DO ISTEP = 1, -1, -2
      AWAQUZ = 0.d0; BWAQUZ = 0.d0
      IF (ISTEP .eq. 1) then ! B -> A'
         AWAQUZ(1:NDBASE,1:NCONQB,0:NDREVE) = VWAQUA(1:NDBASE,1:NCONQB,0:NDREVE)
         BWAQUZ(1:NDBASE,1:NCONQB,0:NDREVE) = UWAQUA(1:NDBASE,1:NCONQB,0:NDREVE)
         V_SING(1:NCONQB) = EIGVAL(1:NCONQB)
      else ! B -> B'
         AWAQUZ(1:NDBASE,1:NCONQB,0:NDREVE) = VWAQUA(1:NDBASE,NCONQB+1:2*NCONQB,0:NDREVE)
         BWAQUZ(1:NDBASE,1:NCONQB,0:NDREVE) = UWAQUA(1:NDBASE,NCONQB+1:2*NCONQB,0:NDREVE)
         V_SING(1:NCONQB) = EIGVAL(NCONQB+1:2*NCONQB)
      ENDIF
      DO IREVER=0,1
         DO ISTATE=1,NUMBQP(IREVER,ICHARG)
            NOTOCC(ISTATE,IREVER) = 0
         ENDDO
      ENDDO
      NOTOCC = 0

      Call HFODD_SUBS(ICHARG,10*ISTEP)
      Call HFODD_SUBS(ICHARG,20*ISTEP)

   ENDDO

   if(ICHARG.eq.1) Call HFODD_SUBS(ICHARG,3)
   
   DEALLOCATE(CELMTS,EIGVAL,EWAVEF)
   DEALLOCATE(UWAQUA,VWAQUA)

ENDDO ! ICHARG

! -- ''Special'' treament to the time-even density  --
! -- will be necessary for density-dependent forces --
!-----------------------------------------------------
call RS_even_density(2)
!-----------------------------------------------------

Call HFODD_SUBS(-1,6)

Call HFODD_SUBS(-1,1)
Call HFODD_SUBS(-1,4)

!E_1 = (A^{\dagger}h-B^{\dagger}\Delta^*)B^* + (A^{\dagger}\Delta-B^{\dagger} h^*)A^*.
DO ICHARG = 0, NDISOS

   Call HFODD_SUBS(ICHARG,2)
   Call HFODD_SUBS(ICHARG,5)

   AWAQUZ(:,:,:)=ASVQUA(:,:,:,ICHARG)
   BWAQUZ(:,:,:)=BSVQUA(:,:,:,ICHARG)

   NCONQB = NUMBQP(0,ICHARG) + NUMBQP(1,ICHARG)
   NCONQB = NCONFX(ICHARG)
   allocate(RESUXX(NCONQB,LDBASE))

   IF(ifammode .eq. -1) then
      DO IBASEI = 1, LDBASE
         BIG_PP(IBASEI,IBASEI,0) = BIG_PP(IBASEI,IBASEI,0) - E_FERMI(ICHARG)
         BIG_PP(IBASEI,IBASEI,1) = BIG_PP(IBASEI,IBASEI,1) - E_FERMI(ICHARG)
      ENDDO
   endif

   if(imat_hh .eq. 0) then
     ! A^{\dagger} h B^*
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,0), NDBASE, BIG_PP(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, BWAQUZ(1,1,0), NDBASE,              &
     &              czero, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,0), NDBASE, BIG_PM(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, BWAQUZ(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,1), NDBASE, BIG_PM(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, BWAQUZ(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,1), NDBASE, BIG_PP(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, BWAQUZ(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)

     ! - B^{\dagger} \Delta^* B^* = B^{\dagger} \Delta^{\dagger} B^*
         call ZGEMM('T', 'C', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,0), NDBASE, HAMIDE(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, BWAQUZ(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'C', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,0), NDBASE, HAMIDE(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, BWAQUZ(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'C', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,1), NDBASE, HAM2DE(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, BWAQUZ(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'C', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,1), NDBASE, HAM2DE(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, BWAQUZ(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)

     ! A^{\dagger} \Delta A^*
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,0), NDBASE, HAMIDE(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, AWAQUZ(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,0), NDBASE, HAM2DE(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, AWAQUZ(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,1), NDBASE, HAMIDE(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, AWAQUZ(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,1), NDBASE, HAM2DE(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, AWAQUZ(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)

     ! -B^{\dagger} h^T A^*
         call ZGEMM('T', 'T', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,0), NDBASE, BIG_PP(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, AWAQUZ(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'T', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,0), NDBASE, BIG_PM(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, AWAQUZ(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'T', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,1), NDBASE, BIG_PM(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, AWAQUZ(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'T', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,1), NDBASE, BIG_PP(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, AWAQUZ(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)

!---------------------------------------------------------------------------------
!  --- reproducing HFB results ---
   else if(imat_hh .eq. 3) then
     ALLOCATE(UWAQUA(1:NDBASE,1:2*NDSTAT,0:NDREVE))
     ALLOCATE(VWAQUA(1:NDBASE,1:2*NDSTAT,0:NDREVE))
     UWAQUA = conjg(AWAQUZ) ! A
     VWAQUA = conjg(BWAQUZ) ! B
     ! A^{\dagger} h A
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,0), NDBASE, BIG_PP(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, UWAQUA(1,1,0), NDBASE,              &
     &              czero, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,0), NDBASE, BIG_PM(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, UWAQUA(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,1), NDBASE, BIG_PM(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, UWAQUA(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,1), NDBASE, BIG_PP(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, UWAQUA(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)

     ! - B^{\dagger} \Delta^* A = B^{\dagger} \Delta^{\dagger} A
         call ZGEMM('T', 'C', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,0), NDBASE, HAMIDE(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, UWAQUA(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'C', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,0), NDBASE, HAMIDE(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, UWAQUA(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'C', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,1), NDBASE, HAM2DE(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, UWAQUA(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'C', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,1), NDBASE, HAM2DE(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, UWAQUA(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)

     ! A^{\dagger} \Delta B
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,0), NDBASE, HAMIDE(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, VWAQUA(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,0), NDBASE, HAM2DE(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, VWAQUA(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,1), NDBASE, HAMIDE(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, VWAQUA(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'N', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, AWAQUZ(1,1,1), NDBASE, HAM2DE(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              c_one, RESUXX, NCONQB, VWAQUA(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)

     ! -B^{\dagger} h^T B
         call ZGEMM('T', 'T', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,0), NDBASE, BIG_PP(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, VWAQUA(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'T', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,0), NDBASE, BIG_PM(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, VWAQUA(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'T', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,1), NDBASE, BIG_PM(1,1,0), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, VWAQUA(1,1,0), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)
         call ZGEMM('T', 'T', NCONQB, LDBASE, LDBASE,                          &
     &              c_one, BWAQUZ(1,1,1), NDBASE, BIG_PP(1,1,1), NDBASE,       &
     &              czero, RESUXX, NCONQB)
         call ZGEMM('N', 'N', NCONQB, NCONQB, LDBASE,                          &
     &              cmone, RESUXX, NCONQB, VWAQUA(1,1,1), NDBASE,              &
     &              c_one, H_CORR(1,1,ICHARG), NCONQX)

     DEALLOCATE(UWAQUA,VWAQUA)

   endif
!---------------------------------------------------------------------------------
   DEALLOCATE(RESUXX)

ENDDO ! ICHARG

if(ifammode .eq. 1) then
   H_CORR = H_CORR/fam_eta
endif

if(ifammode .eq. -1) STOP 'reproducing HFB results ...'

endsubroutine Z_to_E1

!===============================================================================
! --- Implementation of adiabatic time-dependent Hartree-Fock method
      subroutine atdhf_implementation
      use hfodd_gs_data
      implicit none

      integer i
      real mass_old, mass_res
      integer ICHARG

! --- Initialization
      call read_input_para
      call atdhf_data_init(0)

! --- Cranking approximation
      call Inglis_mass

! --- Main iteration
      mass_old = -9999

      gamma1 = 0.d0
      call gamma1_to_rho1
      do i = 1, max_iteration

          if(i .gt. 1) then
             rho1 = xchi*rho1 + (1-xchi)*rho1_old 
          endif
          rho1_old = rho1
          call rho1_to_gamma1
          call gamma1_to_rho1
          call ATDHF_mass
          mass_res = mass_old - mass
          if(abs(mass_old - mass) < atd_precision .and. i .gt. 15) exit
          if(IADB_DEBUG .eq. 1 .or. IADB_DEBUG .eq. -1) then 
             write(*,'(a,i4,a,f12.5,a,f12.5,23X,1H*)') &
             &'# iter = ', i, ' mass = ', mass, ' residual ',mass_old - mass
          endif
          mass_old = mass
      enddo
      if(i > max_iteration) then
         write(*,'(a,i4,a,f12.5,11X,1H*)') &
         &'* Calculation terminated after ', i-1, ' steps, residual is ', mass_res
      endif
      
! --- Generating output & clean up
      call atdhf_output
      call atdhf_data_init(1)

      endsubroutine atdhf_implementation

!===============================================================================
! active the switch I_SING to feed DENSHF with singular values & vectors
      subroutine active_I_SING(ich)
      use hfodd_gs_data
      implicit none

      integer ich
      
      if(ich .eq. 1) then
         V_OCCU = 0.d0
         I_SING = 1
         V_SING = 1.d0
      endif

      if(ich .eq. 0) I_SING = 0

      endsubroutine active_I_SING

!===============================================================================
      subroutine read_input_para
      use hfodd_gs_data, only : NFIPRI,                              &
                              & IABNTE,IABCOL,IABICH,IABMOD,DABPRS,  &
                              & XCHIMX,IFAMON,ETAFAM,IADBLN,         &
                              & IADBMD,SFIADB,SFJADB
      implicit none

      ! ---- ATDHF input -----------------------------------------------------------------------
      IADB_DEBUG = -1    ! 1: Debug mode is activated; -1: only iteration summary is shown 
      adj_rho = 1.d0     ! adjustable parameter multiplying to rho1   (DEBUG)
      adj_gamma= 1.d0    ! adjustable parameter multiplying to gamma1 (DEBUG)
      fam_eta = 1.d-6    ! Finite amplitude difference parameter
      ifammode = 0       ! 1: FAM-ATDHF; 0: linearilized ATDHF; -1: HF iteration
      i_svd_on = 0       ! 1: Singular value decomposition is used
      imat_hh = 0        ! 0: PH-, 1: HH-, 2: PP- matrix elements of Hamiltonian (1,2 for DEBUG)
      ecut_adb = 60.0    ! particle-energy cutoff in ATDHF calculation
      iset_num = 0       ! 0 -- JY; 1 -- JZ; 2 -- JX
      icol_mod = 1       ! 1 -- rotation; 2 -- vibration
      xchi = 0.5d0       ! mixing parameter for ATDHF(B) iteration
      ! --- Setup iteration precision & maximum
      atd_precision = 1.d-6
      max_iteration = 099
      ! ---- ATDHF input -----------------------------------------------------------------------

   ! --- set ATDHF(B) Parameters according to datafile,
   !   DABPRS: precision
   !   XCHIMX: mixing parameter for ATDHF(B) iteration
   !   IABNTE: number of iteration
   !   IABICH: rotating axis
   !   IABCOL: type of collective motion
   !   IABMOD: runmode, 0: admin actived; 1: admin disabled
   !   IFAMON: FAM is used (1) or not (0)
   !   ETAFAM: fam_eta

   ! -- IABMOD is muted..
   IABMOD = 2

   if(IABMOD.eq.1 .or. IABMOD.eq.2) then
      max_iteration = IABNTE
      atd_precision = DABPRS
      xchi = XCHIMX
      icol_mod = IABCOL
      iset_num = IABICH
      !
      ifammode = IFAMON
      fam_eta = ETAFAM
   endif

   if(IABMOD.eq.0) then
! --- read ATDHF input parameters from data file
      read(*,*) ifammode, i_svd_on, imat_hh, IADB_DEBUG
      read(*,*) adj_rho,adj_gamma
      read(*,*) fam_eta
      read(*,*) ecut_adb
      read(*,*) iset_num
      read(*,*) xchi
   endif

   if(icol_mod.eq.2 .and. IABMOD.eq.1) then
      read(*,*) SFIADB
      if(iset_num.gt.99) read(*,*) SFJADB
   endif

! --- Activate linearalized mode of SKFILD & SKPAIR
      IADBMD = 2
      if(ifammode.eq.0) IADBMD = 1

      if(IADBMD.eq.1) IADBLN = 1

! --- compatibility check
      if(ifammode.eq.1 .and. i_svd_on.eq.1) stop 'ifammode = 1 requires i_svd_on = 0'

! --- printing the information of ATDHFB/QFAM calculations
      if(ifammode.eq.1) then
           WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,  &
      &  1H*,2X,''FINITE AMPLITUDE METHOD WILL BE USED:  '',        &
      &                                                 ''ETA = '', &
      &                                            E12.5,18X,1H*,/, &
      &                                             1H*,77X,1H*)')  &
      &  fam_eta
      endif

      if(icol_mod.eq.2) then
           WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,&
      &  1H*,2X,''THE FILE CONTAING THE INDUCED DENSITY'',38X,1H*,/,&
      &                                         1H*,2X,A68,7X,1H*,/,&
      &                                             1H*,77X,1H*)')  &
      &  SFIADB
      endif

      if(icol_mod.eq.2 .and. iset_num.gt.99) then
           WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,&
      &  1H*,2X,''THE FILE CONTAING THE INDUCED DENSITY '',         &
      &         ''IN THE SECOND DIMENSION'',              14X,1H*,/,&
      &                                         1H*,2X,A68,7X,1H*,/,&
      &                                             1H*,77X,1H*)')  &
      &  SFJADB
      endif

      endsubroutine read_input_para

!===============================================================================
! initialization of ATDHF calculations, allocating and preparing necessary arrays
      subroutine atdhf_data_init(ich)
      use hfodd_gs_data
      implicit none

      integer ich
      integer ISTATP, ISTATH
      integer NUMBPX, NUMBHX
      integer ICHARG, ISTATE
      integer NDIMPE,NDIMHE

      idsi_flag = IADB_DEBUG

! --- number of single-particle states
      NUMBCS = NPTOTL

! ---  Set the mass term to 0
      if(ifammode .eq. 0) HBMRPA = 0.d0

! --- Determine the dimension of arrays according to PH configuration
      call phsize(NUMBPX, NUMBHX)
      M = NUMBPX
      N = NUMBHX

      if(ich == 0) then
         ! --- allocations
         allocate(elp(M,0:NDISOS), elh(N,0:NDISOS))
         allocate(rho1(M,N,0:NDISOS), gamma1(M,N,0:NDISOS))
         allocate(S(N,0:NDISOS), U(M,N,0:NDISOS), V(N,N,0:NDISOS))
         allocate(rho_derivative(M,N,0:NDISOS), eph(M,N,0:NDISOS))
         allocate(BAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE))
         allocate(vec(M+N,N,0:NDISOS))
         allocate(rho1_old(M,N,0:NDISOS))
         call RS_even_density(0)

         ! --- reset skfild, remove the effect of linear mixing
         Call HFODD_SUBS(-1,1)
         call RS_even_density(1)

         ! --- extract particle/hole energy
         DO ICHARG=0,NDISOS

            NDIMPE = NUMBPE(ICHARG)
            NDIMHE = NUMBHE(ICHARG)
            elh(1:NDIMHE,ICHARG) = SPENER(1:NDIMHE,ICHARG)
            elp(1:NDIMPE,ICHARG) = SPENER(NDIMHE+1:NDIMHE+NDIMPE,ICHARG)
         ENDDO

         ! --- Prepare the single particle energy difference
         eph = 0.d0
         DO ICHARG=0,NDISOS
            do ISTATP = 1, NUMBPE(ICHARG)
               do ISTATH = 1, NUMBHE(ICHARG)
                  eph(ISTATP,ISTATH,ICHARG) = elp(ISTATP,ICHARG) - elh(ISTATH,ICHARG)
                  if( abs(eph(ISTATP,ISTATH,ICHARG)) .lt. 1.0d-6 ) then
                     print*, 'ICHARG, ISTATP, ISTATH, elp(ISTATP,ICHARG), elh(ISTATH,ICHARG)'
                     print*, ICHARG, ISTATP, ISTATH, elp(ISTATP,ICHARG), elh(ISTATH,ICHARG)
                     stop 'Unsolved Crossing detected in EPH!'
                  endif
               enddo
            enddo
         ENDDO

         ! --- calculate the derivative of density
         call calculate_rho_derivative

      endif

      if(ich == 1) then
         call active_I_SING(0)
         ! --- recover WAVOCC & V_OCCU, and everything ...
         DO ICHARG=0,NDISOS
            WAVOCC = SAVOCC(:,:,:,ICHARG)
            V_OCCU = SV_OCC(:,ICHARG)
            Call HFODD_SUBS(ICHARG,10)
         ENDDO
         Call HFODD_SUBS(-1,1)
         DO ICHARG=0,NDISOS
            Call HFODD_SUBS(ICHARG,2)
         ENDDO

         ! --- free memory space...
         deallocate(rho1, gamma1, rho_derivative, eph, S, U, V)
         deallocate(elp,elh,vec,BAVOCC)
         deallocate(rho1_old)
      endif

      endsubroutine atdhf_data_init

!===============================================================================
! after applying SVD to rho1, fed DENSHF with eigen vector of rho1, extracting
! Gamma1 by calling SKFILD and INTEGH
      subroutine rho1_to_gamma1
      use hfodd_gs_data, only : NDISOS
      implicit none

      integer ICHARG, NDIMPE, NDIMHE

   if(i_svd_on .eq. 1) then
   
      vec = (0.d0, 0.d0)

      DO ICHARG=0,NDISOS
         NDIMPE = NUMBPE(ICHARG)
         NDIMHE = NUMBHE(ICHARG)

         ! Performing singular value decomposition to rho1
         call zcallsvd(NDIMPE,NDIMHE,rho1(1,1,ICHARG),  M,              &
     &                 U(1,1,ICHARG), M, V(1,1,ICHARG), N,              &
     &                 S(1,ICHARG), N)

         ! Preparing eigenvectors of rho1 with positive energy
         vec(1:NDIMPE,1:NDIMHE,ICHARG) = U(1:NDIMPE,1:NDIMHE,ICHARG)
         vec(NDIMPE+1:NDIMPE+NDIMHE,1:NDIMHE,ICHARG) =  &
     &                     CONJG(TRANSPOSE( V(1:NDIMHE,1:NDIMHE,ICHARG) ))


      ENDDO

      ! VEC is devided by the normalization factor 2
      vec = vec/sqrt(2.d0)

   endif
      ! Feeding DENSHF with vec to get the Gamma1
      call fed_DENSHF

      if(ifammode .eq. 1) then
         gamma1 = gamma1/fam_eta
      endif

      endsubroutine rho1_to_gamma1

!===============================================================================
! update rho1 with gamma1
      subroutine gamma1_to_rho1
      use hfodd_gs_data, only : NDISOS
      implicit none
      integer ICHARG, NDIMHE, NDIMPE

      !rho1 = 1.0/eph * (rho_derivative - gamma1)
      rho1 = 0.d0
      DO ICHARG=0,NDISOS
         NDIMHE = NUMBHE(ICHARG)
         NDIMPE = NUMBPE(ICHARG)
         rho1(1:NDIMPE,1:NDIMHE,ICHARG) = 1.d0/eph(1:NDIMPE,1:NDIMHE,ICHARG) * &
        & (rho_derivative(1:NDIMPE,1:NDIMHE,ICHARG) - gamma1(1:NDIMPE,1:NDIMHE,ICHARG))
      ENDDO

      endsubroutine gamma1_to_rho1

!===============================================================================
      subroutine ATDHF_mass
      use hfodd_gs_data, only : NDISOS
      implicit none

      integer ISTATP, ISTATH
      integer ICHARG

      complex resu
      complex resu_half
      real mass_isos(0:NDISOS)

      mass = 0.d0
      ! -- mass = Re[Tr(rho1*rho_derivative)]
      DO ICHARG = 0, NDISOS
         resu = 0.d0
         resu_half = 0.d0
         do ISTATP = 1, NUMBPE(ICHARG)
            do ISTATH = 1, NUMBHE(ICHARG)
               resu = resu + rho1(ISTATP,ISTATH,ICHARG) * conjg(rho_derivative(ISTATP,ISTATH,ICHARG)) &
                    &  + conjg(rho1(ISTATP,ISTATH,ICHARG)) * rho_derivative(ISTATP,ISTATH,ICHARG)
               resu_half = resu_half &
                    &  + rho1(ISTATP,ISTATH,ICHARG) * conjg(rho_derivative(ISTATP,ISTATH,ICHARG))
            enddo
         enddo
         mass_isos(ICHARG) = real(resu)
         mass = mass + mass_isos(ICHARG)

      ENDDO

      endsubroutine ATDHF_mass

!===============================================================================
! calculating matrix elements of rho_derivative in PH space
      subroutine calculate_rho_derivative
      use hfodd_gs_data
      implicit none

      real    FACTOR
      real,   allocatable :: HAUXPP(:,:), HAUXPM(:,:), HAUXMP(:,:), HAUXMM(:,:)
      complex,allocatable :: FAUXPP(:,:), FAUXPM(:,:), FAUXMP(:,:), FAUXMM(:,:)
      real,   allocatable :: HAUXTT(:,:)
      integer IBASEI, IBASEJ, ICHARG, ISTATP, ISTATH
      complex RESUPP, RESUPM, RESUMP, RESUMM
      integer NDIMHE
      real    ppres, pmres, mpres, mmres, ttres
      real    res_max_PP,res_max_PM,res_max_MP,res_max_MM,res_max_TT
      complex J_ISO(0:1), J_TOTAL
      complex i_unit

      allocate(HAUXPP(1:NDBASE,1:NDBASE),HAUXPM(1:NDBASE,1:NDBASE))
      allocate(HAUXMP(1:NDBASE,1:NDBASE),HAUXMM(1:NDBASE,1:NDBASE))
      allocate(HAUXTT(1:NDBASE,1:NDBASE))
      allocate(FAUXPP(1:NDBASE,1:NDBASE),FAUXPM(1:NDBASE,1:NDBASE))
      allocate(FAUXMP(1:NDBASE,1:NDBASE),FAUXMM(1:NDBASE,1:NDBASE))

      ! rho_derivative(ph) = <p|jy|h>

      i_unit = (0.d0,1.d0)

      ! iset_num: 0 -- JY; 1 -- JZ; 2 -- JX; 
      axis_str(0) = 'Y-'; axis_str(1) = 'Z-'; axis_str(2) = 'X-'

   FACTOR = 1.d0
   if(iset_num == 0) then
      ! -- set 0 --
      CALL INT_SY(HAUXTT,FACTOR)
      CALL INT_LY(IPHAPP(0,0,0),HAUXPP,FACTOR)
      CALL INT_LY(IPHAPM(0,0,0),HAUXPM,FACTOR)
      CALL INT_LY(IPHAMP(0,0,0),HAUXMP,FACTOR)
      CALL INT_LY(IPHAMM(0,0,0),HAUXMM,FACTOR)
   
      FAUXPP = HAUXPP*i_unit + HAUXTT
      FAUXPM = HAUXPM*i_unit
      FAUXMP = HAUXMP*i_unit
      FAUXMM = HAUXMM*i_unit - HAUXTT
   
   else if(iset_num == 1) then
      ! -- set 1 --
      CALL INT_SZ(HAUXTT,FACTOR)
      CALL INT_LZ(IPHAPP(0,0,0),HAUXPP,FACTOR)
      CALL INT_LZ(IPHAPM(0,0,0),HAUXPM,FACTOR)
      CALL INT_LZ(IPHAMP(0,0,0),HAUXMP,FACTOR)
      CALL INT_LZ(IPHAMM(0,0,0),HAUXMM,FACTOR)
   
      FAUXPP = HAUXPP*i_unit
      FAUXPM = HAUXPM*i_unit + HAUXTT*i_unit
      FAUXMP = HAUXMP*i_unit - HAUXTT*i_unit
      FAUXMM = HAUXMM*i_unit
   
   else if(iset_num == 2) then
      ! -- set 2 --
      CALL INT_SX(HAUXTT,FACTOR)
      CALL INT_LX(IPHAPP(0,0,0),HAUXPP,FACTOR)
      CALL INT_LX(IPHAPM(0,0,0),HAUXPM,FACTOR)
      CALL INT_LX(IPHAMP(0,0,0),HAUXMP,FACTOR)
      CALL INT_LX(IPHAMM(0,0,0),HAUXMM,FACTOR)
   
      FAUXPP = HAUXPP*i_unit
      FAUXPM = HAUXPM*i_unit + HAUXTT
      FAUXMP = HAUXMP*i_unit + HAUXTT
      FAUXMM = HAUXMM*i_unit
   
   endif ! iset_num

      rho_derivative = 0.d0
      DO ICHARG=0,NDISOS
         WAVOCC = SAVOCC(:,:,:,ICHARG)
         NDIMHE = NUMBHE(ICHARG)
         DO ISTATP = 1, NUMBPE(ICHARG)
            DO ISTATH = 1, NUMBHE(ICHARG)
               RESUPP = 0; RESUPM = 0; RESUMP = 0; RESUMM = 0;
               DO IBASEI=1,LDBASE
                  DO IBASEJ=1,LDBASE
                     RESUPP = RESUPP + conjg( WAVOCC(IBASEI,ISTATP+NDIMHE,0) )   &
     &                               * FAUXPP(IBASEI,IBASEJ)                     &
     &                               * WAVOCC(IBASEJ,ISTATH,0)
                     RESUPM = RESUPM + conjg( WAVOCC(IBASEI,ISTATP+NDIMHE,0) )   &
     &                               * FAUXPM(IBASEI,IBASEJ)                     &
     &                               * WAVOCC(IBASEJ,ISTATH,1)
                     RESUMP = RESUMP + conjg( WAVOCC(IBASEI,ISTATP+NDIMHE,1) )   &
     &                               * FAUXMP(IBASEI,IBASEJ)                     &
     &                               * WAVOCC(IBASEJ,ISTATH,0)
                     RESUMM = RESUMM + conjg( WAVOCC(IBASEI,ISTATP+NDIMHE,1) )   &
     &                               * FAUXMM(IBASEI,IBASEJ)                     &
     &                               * WAVOCC(IBASEJ,ISTATH,1)
                  ENDDO
               ENDDO
               rho_derivative(ISTATP,ISTATH,ICHARG) = RESUPP + RESUPM + RESUMP + RESUMM
            ENDDO
         ENDDO
      ENDDO ! For ICHARG

      deallocate(HAUXPP,HAUXPM,HAUXMP,HAUXMM,HAUXTT)
      deallocate(FAUXPP,FAUXPM,FAUXMP,FAUXMM)
      endsubroutine calculate_rho_derivative

!===============================================================================
! Calculating the collective inertial under cranking approximation
! Wroking in PH spapce
      subroutine Inglis_mass
      use hfodd_gs_data
      implicit none

      !rho1 = rho_derivative/eph
      gamma1 = 0.d0
      call gamma1_to_rho1
      call ATDHF_mass

           WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,  &
      &  1H*,2X,''Inglis Formula MOMENT OF INERTIA ALONG '',        &
      &                                               A2,''AXIS '', &
      &                         ''IS '',F12.5,'' MeV-1'', 8X,1H*,/, &
      &                                             1H*,77X,1H*)')  &
      &    axis_str(iset_num), mass

      endsubroutine Inglis_mass

!===============================================================================
      subroutine atdhf_output
      use hfodd_gs_data
      implicit none

      ! generating output of ATDHF calculations

          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,  &
     &           1H*,2X,''ATDHF MOMENT OF INERTIA ALONG '',        &
     &                                               A2,''AXIS '', &
     &                         ''IS '',F12.5,'' MeV-1'',17X,1H*,/, &
     &                                             1H*,77X,1H*)')  &
     &    axis_str(iset_num), mass
      endsubroutine atdhf_output

!===============================================================================
      subroutine atdhfb_output
      use hfodd_gs_data
      implicit none
      integer i_lambda, i_chi

      ! generating output of ATDHF calculations

      if(iABCOL .EQ. 1) THEN
          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,  &
     &           1H*,2X,''ATDHFB MOMENT OF INERTIA ALONG '',       &
     &                                               A2,''AXIS '', &
     &                         ''IS '',F12.5,'' MeV-1'',16X,1H*,/, &
     &                                             1H*,77X,1H*)')  &
     &    axis_str(iset_num), mass
      endif

      if(iABCOL .EQ. 2 .and. abs(iset_num) .le. 99) THEN
          i_lambda = abs(iset_num)/10

          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,  &
     &           1H*,2X,''ATDHFB MOMENT OF INERTIA FOR Q'',I2,     &
     &                                            '' VIBRATION '', &
     &         ''IS '',F12.5,'' [10FM]-'',I1,'' MeV-1'', 2X,1H*,/, &
     &                                             1H*,77X,1H*)')  &
     &    iset_num, mass, 2*i_lambda
      endif

      if(iABCOL .EQ. 2 .and. abs(iset_num) .gt. 99) THEN
          i_lambda = (abs(iset_num)/100)/10
          i_chi = mod(abs(iset_num),100)/10

          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,  &
     &           1H*,2X,''ATDHFB MOMENT OF INERTIA FOR Q'',I2,     &
     &         ''-'',I2,                               '' VIB. '', &
     &         ''IS '',F12.5,'' [10FM]-'',I1,'' MeV-1'', 4X,1H*,/, &
     &                                             1H*,77X,1H*)')  &
     &    abs(iset_num)/100, mod(abs(iset_num),100), mass, i_lambda + i_chi
      endif
      endsubroutine atdhfb_output

!===============================================================================
! Determining the dimension of particle/hole space ...
!
      subroutine phsize(NUMBPX, NUMBHX)
      use hfodd_gs_data
      implicit none

      integer ICHARG, ISTATE
      integer num_total, iccount, jccount
      integer NUMBPX, NUMBHX

      DO ICHARG=0,NDISOS
         iccount = 0; jccount = 0
         DO ISTATE=1,NUMBCS(ICHARG)
            if(M_OCVA(ISTATE,ICHARG) .eq. 1) iccount = iccount + 1
            IF(SPENER(ISTATE,ICHARG) .gt. ecut_adb) EXIT
            jccount = jccount + 1
         ENDDO
         NUMBCS(ICHARG) = jccount
         NUMBHE(ICHARG) = iccount
         NUMBPE(ICHARG) = NUMBCS(ICHARG) - NUMBHE(ICHARG)
      ENDDO
      
      NUMBHX = max(NUMBHE(0), NUMBHE(1))
      NUMBPX = max(NUMBPE(0), NUMBPE(1))
      endsubroutine phsize

!===============================================================================
! ##  Feed DENSHF with the eigen vector of RHO1,                              ##
! ##  Then, extract matrix elements of mean field from INTEGH                 ##
!-------------------------------------------------------------------------------
      subroutine fed_DENSHF
      use hfodd_gs_data
      implicit none

      integer ISTATE, ISTATH, ISTATP, ISTATV
      complex RESU0,  RESU1,  RESU2,  RESU3
      real    FAC
      integer IBASE,  IBASEI, IBASEJ
      integer ICHARG
      integer NDIMPE, NDIMHE

      complex RESUPP, RESUPM, RESUMP, RESUMM

      complex, allocatable :: RESUXX(:,:)
      complex c_one, czero

      c_one = (1.d0,0.d0) 
      czero = (0.d0,0.d0)

! --- 
!     The positive and negative eigenvalues of RHO1 are put into the array V_OCCU consecutively
!     =>  |-S_1,+S_1|-S_2,+S_2|...|-S_N,+S_N|  
!     In S, only positive parts are stored

!     occupation number of the time-odd density
      S = sqrt(S)

      DO ICHARG=0,NDISOS

      if(i_svd_on .eq. 1) then 

         call active_I_SING(1)
! --- replace V_SING by r_i
         DO ISTATH = 1, NUMBHE(ICHARG)
            V_SING(2*ISTATH - 1) = -1.d0
            V_SING(2*ISTATH    ) = +1.d0
            V_OCCU(2*ISTATH - 1) = S(ISTATH,ICHARG)
            V_OCCU(2*ISTATH    ) = S(ISTATH,ICHARG)
         ENDDO

! --- replacing WAVOCC
         BAVOCC = 0.d0
         WAVOCC = SAVOCC(:,:,:,ICHARG)

         ! -- $ B_{h' i} = \sum_{\mu} \varphi_{\mu h'} A_{\mu i} $
         DO ISTATH = 1, NUMBHE(ICHARG) 
            DO IBASE=1,LDBASE
               RESU0 = 0.d0; RESU1 = 0.d0; RESU2 = 0.d0; RESU3 = 0.d0;
               DO ISTATE=1,NUMBCS(ICHARG)
                  IF(ISTATE .LE. NUMBHE(ICHARG)) THEN
                     FAC = -1.d0
                     ISTATV = ISTATE + NUMBPE(ICHARG)
                  ELSE
                     FAC = +1.d0
                     ISTATV = ISTATE - NUMBHE(ICHARG)
                  ENDIF
                  RESU0 = RESU0 + WAVOCC(IBASE,ISTATE,0) * VEC(ISTATV,ISTATH,ICHARG) * FAC
                  RESU1 = RESU1 + WAVOCC(IBASE,ISTATE,1) * VEC(ISTATV,ISTATH,ICHARG) * FAC
                  RESU2 = RESU2 + WAVOCC(IBASE,ISTATE,0) * VEC(ISTATV,ISTATH,ICHARG)
                  RESU3 = RESU3 + WAVOCC(IBASE,ISTATE,1) * VEC(ISTATV,ISTATH,ICHARG)
               ENDDO
               BAVOCC(IBASE,2*ISTATH - 1,0) = RESU0
               BAVOCC(IBASE,2*ISTATH - 1,1) = RESU1
               BAVOCC(IBASE,2*ISTATH    ,0) = RESU2
               BAVOCC(IBASE,2*ISTATH    ,1) = RESU3
            ENDDO
         ENDDO
         WAVOCC = BAVOCC

      else ! i_svd_on

         call REPLACE_WAVOCC(ICHARG)

      endif ! i_svd_on
         
         Call HFODD_SUBS(ICHARG,10)

         ! calculate time-odd Coulomb field
         if(ICHARG.eq.1) then
            Call HFODD_SUBS(ICHARG,3)
         endif
      ENDDO ! For ICHARG

      call RS_even_density(2)

      Call HFODD_SUBS(-1,1)

! --- extract matrix elements of Gamma1
! -   $ \Gamma_{ph} = sum_{ij}\varphi_{ip}^* \Gamma_{ij} \varphi_{jh} $
      gamma1 = (0.d0,0.d0)
      DO ICHARG = 0, NDISOS

         Call HFODD_SUBS(ICHARG,2)
         
         WAVOCC = SAVOCC(:,:,:,ICHARG)
         NDIMPE = NUMBPE(ICHARG)
         NDIMHE = NUMBHE(ICHARG)
         

      if(imat_hh .eq. 0) then   
         allocate(RESUXX(NDIMPE,LDBASE))
         ! -- WF(+) * GAMMA(++) * WF(+)
         call ZGEMM('C', 'N', NDIMPE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,NDIMHE+1,0), NDBASE, BIG_PP(1,1,0), NDBASE,&
     &              czero, RESUXX, NDIMPE)
         call ZGEMM('N', 'N', NDIMPE, NDIMHE, LDBASE,                          &
     &              c_one, RESUXX, NDIMPE, WAVOCC(1,1,0), NDBASE,              &
     &              czero, gamma1(1,1,ICHARG), M)
         ! -- WF(+) * GAMMA(+-) * WF(-)
         call ZGEMM('C', 'N', NDIMPE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,NDIMHE+1,0), NDBASE, BIG_PM(1,1,0), NDBASE,&
     &              czero, RESUXX, NDIMPE)
         call ZGEMM('N', 'N', NDIMPE, NDIMHE, LDBASE,                          &
     &              c_one, RESUXX, NDIMPE, WAVOCC(1,1,1), NDBASE,              &
     &              c_one, gamma1(1,1,ICHARG), M)
         ! -- WF(-) * GAMMA(-+) * WF(+)
         call ZGEMM('C', 'N', NDIMPE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,NDIMHE+1,1), NDBASE, BIG_PM(1,1,1), NDBASE,&
     &              czero, RESUXX, NDIMPE)
         call ZGEMM('N', 'N', NDIMPE, NDIMHE, LDBASE,                          &
     &              c_one, RESUXX, NDIMPE, WAVOCC(1,1,0), NDBASE,              &
     &              c_one, gamma1(1,1,ICHARG), M)
         ! -- WF(-) * GAMMA(--) * WF(-)
         call ZGEMM('C', 'N', NDIMPE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,NDIMHE+1,1), NDBASE, BIG_PP(1,1,1), NDBASE,&
     &              czero, RESUXX, NDIMPE)
         call ZGEMM('N', 'N', NDIMPE, NDIMHE, LDBASE,                          &
     &              c_one, RESUXX, NDIMPE, WAVOCC(1,1,1), NDBASE,              &
     &              c_one, gamma1(1,1,ICHARG), M)
     !---------- HH ------------
     else if (imat_hh .eq. 1) then
         allocate(RESUXX(NDIMHE,LDBASE))
         ! -- WF(+) * GAMMA(++) * WF(+)
         call ZGEMM('C', 'N', NDIMHE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,1,0), NDBASE, BIG_PP(1,1,0), NDBASE,&
     &              czero, RESUXX, NDIMHE)
         call ZGEMM('N', 'N', NDIMHE, NDIMHE, LDBASE,                          &
     &              c_one, RESUXX, NDIMHE, WAVOCC(1,1,0), NDBASE,              &
     &              czero, gamma1(1,1,ICHARG), M)
         ! -- WF(+) * GAMMA(+-) * WF(-)
         call ZGEMM('C', 'N', NDIMHE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,1,0), NDBASE, BIG_PM(1,1,0), NDBASE,&
     &              czero, RESUXX, NDIMHE)
         call ZGEMM('N', 'N', NDIMHE, NDIMHE, LDBASE,                          &
     &              c_one, RESUXX, NDIMHE, WAVOCC(1,1,1), NDBASE,              &
     &              c_one, gamma1(1,1,ICHARG), M)
         ! -- WF(-) * GAMMA(-+) * WF(+)
         call ZGEMM('C', 'N', NDIMHE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,1,1), NDBASE, BIG_PM(1,1,1), NDBASE,&
     &              czero, RESUXX, NDIMHE)
         call ZGEMM('N', 'N', NDIMHE, NDIMHE, LDBASE,                          &
     &              c_one, RESUXX, NDIMHE, WAVOCC(1,1,0), NDBASE,              &
     &              c_one, gamma1(1,1,ICHARG), M)
         ! -- WF(-) * GAMMA(--) * WF(-)
         call ZGEMM('C', 'N', NDIMHE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,1,1), NDBASE, BIG_PP(1,1,1), NDBASE,&
     &              czero, RESUXX, NDIMHE)
         call ZGEMM('N', 'N', NDIMHE, NDIMHE, LDBASE,                          &
     &              c_one, RESUXX, NDIMHE, WAVOCC(1,1,1), NDBASE,              &
     &              c_one, gamma1(1,1,ICHARG), M)
     !---------- PP ------------
     else if (imat_hh .eq. 2) then
         allocate(RESUXX(NDIMPE,LDBASE))
         ! -- WF(+) * GAMMA(++) * WF(+)
         call ZGEMM('C', 'N', NDIMPE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,NDIMHE+1,0), NDBASE, BIG_PP(1,1,0), NDBASE,&
     &              czero, RESUXX, NDIMPE)
         call ZGEMM('N', 'N', NDIMPE, NDIMPE, LDBASE,                          &
     &              c_one, RESUXX, NDIMPE, WAVOCC(1,NDIMHE+1,0), NDBASE,       &
     &              czero, gamma1(1,1,ICHARG), M)
         ! -- WF(+) * GAMMA(+-) * WF(-)
         call ZGEMM('C', 'N', NDIMPE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,NDIMHE+1,0), NDBASE, BIG_PM(1,1,0), NDBASE,&
     &              czero, RESUXX, NDIMPE)
         call ZGEMM('N', 'N', NDIMPE, NDIMPE, LDBASE,                          &
     &              c_one, RESUXX, NDIMPE, WAVOCC(1,NDIMHE+1,1), NDBASE,       &
     &              c_one, gamma1(1,1,ICHARG), M)
         ! -- WF(-) * GAMMA(-+) * WF(+)
         call ZGEMM('C', 'N', NDIMPE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,NDIMHE+1,1), NDBASE, BIG_PM(1,1,1), NDBASE,&
     &              czero, RESUXX, NDIMPE)
         call ZGEMM('N', 'N', NDIMPE, NDIMPE, LDBASE,                          &
     &              c_one, RESUXX, NDIMPE, WAVOCC(1,NDIMHE+1,0), NDBASE,       &
     &              c_one, gamma1(1,1,ICHARG), M)
         ! -- WF(-) * GAMMA(--) * WF(-)
         call ZGEMM('C', 'N', NDIMPE, LDBASE, LDBASE,                          &
     &              c_one, WAVOCC(1,NDIMHE+1,1), NDBASE, BIG_PP(1,1,1), NDBASE,&
     &              czero, RESUXX, NDIMPE)
         call ZGEMM('N', 'N', NDIMPE, NDIMPE, LDBASE,                          &
     &              c_one, RESUXX, NDIMPE, WAVOCC(1,NDIMHE+1,1), NDBASE,       &
     &              c_one, gamma1(1,1,ICHARG), M)
     endif ! imat_hh
     !---------- PP & HH END ------------
         deallocate(RESUXX)

      ENDDO

      endsubroutine fed_DENSHF
!--------------------------------------------------------------------

!
!===============================================================================
subroutine REPLACE_WAVOCC(ICHARG)
use hfodd_gs_data
implicit none

integer ICHARG
integer ISTATP, ISTATH, ISTATV
integer i,j
integer IBASE, ISTATE

COMPLEX, ALLOCATABLE :: CELMTS(:)
REAL, ALLOCATABLE :: EIGVAL(:)
COMPLEX, ALLOCATABLE :: EWAVEF(:,:)
COMPLEX, ALLOCATABLE :: AA(:,:)

integer LDACTU, NDACTU, NUMVEC
integer NDIMPE, NDIMHE

COMPLEX RESU0, RESU1

   NDIMPE = NUMBPE(ICHARG)
   NDIMHE = NUMBHE(ICHARG)

   NDACTU = NDIMPE + NDIMHE
   LDACTU = NDACTU
   NUMVEC = NDACTU

   ALLOCATE( AA(1:NDACTU,1:NDACTU))
   ALLOCATE( CELMTS(1:((NDACTU+1)*NDACTU)/2) )
   ALLOCATE( EIGVAL(1:NDACTU) )
   ALLOCATE( EWAVEF(1:NDACTU,1:NDACTU) )

   select case (ifammode)
   case (0)
   ! --- for linearalized ATDHF ---
      AA = (0.d0, 0.d0)
      do ISTATP = 1, NDIMPE
         do ISTATH = 1, NDIMHE
            AA(ISTATP,ISTATH + NDIMPE) = rho1(ISTATP,ISTATH,ICHARG)
            AA(ISTATH + NDIMPE,ISTATP) = conjg(rho1(ISTATP,ISTATH,ICHARG))
         enddo
      enddo
   
   case (-1)
   ! --- for HF iteration ---
      AA = (0.d0, 0.d0)
      do ISTATH = 1, NDIMHE
         AA(ISTATH + NDIMPE,ISTATH + NDIMPE) = 1.d0
      enddo

   case (1)
   ! --- for FAM-ATDHF ---
      AA = (0.d0, 0.d0)
      do ISTATH = 1, NDIMHE
         AA(ISTATH + NDIMPE,ISTATH + NDIMPE) = 1.d0
      enddo
      do ISTATP = 1, NDIMPE
         do ISTATH = 1, NDIMHE
            AA(ISTATP,ISTATH + NDIMPE) = AA(ISTATP,ISTATH + NDIMPE) &
                                    &  + fam_eta*rho1(ISTATP,ISTATH,ICHARG)
            AA(ISTATH + NDIMPE,ISTATP) = AA(ISTATH + NDIMPE,ISTATP) &
                                    &  + fam_eta*conjg(rho1(ISTATP,ISTATH,ICHARG))
         enddo
      enddo

   case default
      stop 'unknown runmode ..'
   end select
   ! --------------------------------------------------------------

   DO j = 1, NDACTU
      DO i = j, NDACTU      
         CELMTS(i + (j-1)*(2*NDACTU-j)/2) = AA(i,j)
      ENDDO
   ENDDO

   CALL DIAMAT(CELMTS,EIGVAL,EWAVEF,LDACTU,NDACTU,NUMVEC)


   !---------------------------------------------------------------------!
   ! The eigenstates from DIAMAT are sorted ascendingly.                 !
   ! structure: |-s, -v, ..., 0, ..., 0, ..., V, S|                      !
   !            |   NDIMHE   |---------|  NDIMHE  |                      !
   ! In linearalized ATDHF mode, s = S, v = V, S = V;                    !
   ! In FAM-ATDHF mode, s = S - 1, v = V - 1; (since rho_hh = 1)         !
   ! In ATDHF, only those with nonvanishing eigenvalues are needed.      !
   ! Since in HF iteration, only 2*NDIMHE eigenstates are used, the zero !
   ! eigenstates should be removed like this:                            !
   !---------------------------------------------------------------------!
   EIGVAL(  NDIMHE+1:2*NDIMHE) = EIGVAL(  NDACTU-NDIMHE+1:NDACTU)
   EWAVEF(:,NDIMHE+1:2*NDIMHE) = EWAVEF(:,NDACTU-NDIMHE+1:NDACTU)
   ! For security purpose, 
   EIGVAL(2*NDIMHE+1:NDACTU) = 0.d0
   
   call active_I_SING(1)
   DO ISTATH = 1, 2*NDIMHE
      if(EIGVAL(ISTATH).GE.0) then
         V_OCCU(ISTATH) = sqrt( +EIGVAL(ISTATH) )
         V_SING(ISTATH) = +1.d0
      else
         V_OCCU(ISTATH) = sqrt( -EIGVAL(ISTATH) )
         V_SING(ISTATH) = -1.d0
      endif
   ENDDO

   BAVOCC = 0.d0
   WAVOCC = SAVOCC(:,:,:,ICHARG)

   DO ISTATH = 1, 2*NDIMHE
      DO IBASE=1,LDBASE
         RESU0 = 0.d0; RESU1 = 0.d0;
         DO ISTATE=1,NUMBCS(ICHARG)
            IF(ISTATE .LE. NDIMHE) THEN
               ISTATV = ISTATE + NUMBPE(ICHARG)
            ELSE
               ISTATV = ISTATE - NUMBHE(ICHARG)
            ENDIF

            RESU0 = RESU0 + WAVOCC(IBASE,ISTATE,0) * EWAVEF(ISTATV,ISTATH)
            RESU1 = RESU1 + WAVOCC(IBASE,ISTATE,1) * EWAVEF(ISTATV,ISTATH)
         ENDDO
         BAVOCC(IBASE,ISTATH,0) = RESU0
         BAVOCC(IBASE,ISTATH,1) = RESU1
      ENDDO
   ENDDO

   WAVOCC = BAVOCC
   DEALLOCATE(AA,CELMTS,EIGVAL,EWAVEF)

endsubroutine REPLACE_WAVOCC

!
!===============================================================================
! -- Special treatment to the time-even density
! -- allocate [0], save [1], retrieve [2] time-even densities -- 
! For IADBMD=0, the code performs FAM calculations
! For IADBMD=1, the code linearalizes the field
! For IADBMD=2, the code sets time-even density to HFB values
subroutine RS_even_density(ich)
use hfodd_gs_data
implicit none
integer ich
integer i_rs_level
integer LDPNMX, LDTWDD

i_rs_level = 1
IF(IADBMD.eq.1) i_rs_level = -1
IF(IADBMD.eq.2) i_rs_level = 3
IF(ich == 2 .and. IADBMD == 1 .and. IGYUSD.eq.1) return

! pending to be modified for p-n mixing & two-center basis
LDPNMX=1
LDTWDD=1

if(i_rs_level .eq. 0) return

if(ich == 0) then
   if(i_rs_level .eq. -2) then
      IF(ALLOCATED(DE_RHO)) ALLOCATE(DE_RHO_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PD_RHO)) ALLOCATE(PD_RHO_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
   endif
   if(i_rs_level .eq. -1) then
      IF(ALLOCATED(DE_RHO)) ALLOCATE(DE_RHO_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PD_RHO)) ALLOCATE(PD_RHO_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PP_RHO)) ALLOCATE(PP_RHO_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(DE_SPI)) ALLOCATE(DE_SPI_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:LDPNMX,1:LDTWDD))
   endif
   if(i_rs_level .gt. 0) then
      IF(ALLOCATED(DE_RHO)) ALLOCATE(DE_RHO_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
   endif
   if(i_rs_level .gt. 1) then
      IF(ALLOCATED(DE_TAU)) ALLOCATE(DE_TAU_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(DE_LPR)) ALLOCATE(DE_LPR_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(DE_DIV)) ALLOCATE(DE_DIV_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(DE_SCU)) ALLOCATE(DE_SCU_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1:NDKART,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(DE_DES)) ALLOCATE(DE_DES_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1:NDKART,0:LDPNMX,1:LDTWDD))
   endif
   if(i_rs_level .gt. 2) then
      !IF(ALLOCATED(DE_DIJ)) ALLOCATE(DE_DIJ_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PD_RHO)) ALLOCATE(PD_RHO_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PD_TAU)) ALLOCATE(PD_TAU_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PD_LPR)) ALLOCATE(PD_LPR_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PP_RHO)) ALLOCATE(PP_RHO_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PP_TAU)) ALLOCATE(PP_TAU_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PP_LPR)) ALLOCATE(PP_LPR_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PD_SCU)) ALLOCATE(PD_SCU_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1:NDKART,0:LDPNMX,1:LDTWDD))
      IF(ALLOCATED(PP_SCU)) ALLOCATE(PP_SCU_SAV(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1:NDKART,0:LDPNMX,1:LDTWDD))   
   endif
endif

if(ich == 1) then
   ! -- save time-even density -- 
   if(i_rs_level .eq. -2) then
      IF(ALLOCATED(DE_RHO)) DE_RHO_SAV = DE_RHO
      IF(ALLOCATED(PD_RHO)) PD_RHO_SAV = PD_RHO
   endif
   if(i_rs_level .eq. -1) then
      IF(ALLOCATED(DE_RHO)) DE_RHO_SAV = DE_RHO
      IF(ALLOCATED(PD_RHO)) PD_RHO_SAV = PD_RHO
      IF(ALLOCATED(PP_RHO)) PP_RHO_SAV = PP_RHO
      IF(ALLOCATED(DE_SPI)) DE_SPI_SAV = DE_SPI
   endif
   if(i_rs_level .gt. 0) then
      IF(ALLOCATED(DE_RHO)) DE_RHO_SAV = DE_RHO
   endif
   if(i_rs_level .gt. 1) then
      IF(ALLOCATED(DE_TAU)) DE_TAU_SAV = DE_TAU
      IF(ALLOCATED(DE_LPR)) DE_LPR_SAV = DE_LPR
      IF(ALLOCATED(DE_DIV)) DE_DIV_SAV = DE_DIV
      IF(ALLOCATED(DE_SCU)) DE_SCU_SAV = DE_SCU
      IF(ALLOCATED(DE_DES)) DE_DES_SAV = DE_DES
   endif
   if(i_rs_level .gt. 2) then
      !IF(ALLOCATED(DE_DIJ)) DE_DIJ_SAV = DE_DIJ
      IF(ALLOCATED(PD_RHO)) PD_RHO_SAV = PD_RHO
      IF(ALLOCATED(PD_TAU)) PD_TAU_SAV = PD_TAU
      IF(ALLOCATED(PD_LPR)) PD_LPR_SAV = PD_LPR
      IF(ALLOCATED(PP_RHO)) PP_RHO_SAV = PP_RHO
      IF(ALLOCATED(PP_TAU)) PP_TAU_SAV = PP_TAU
      IF(ALLOCATED(PP_LPR)) PP_LPR_SAV = PP_LPR
      IF(ALLOCATED(PD_SCU)) PD_SCU_SAV = PD_SCU
      IF(ALLOCATED(PP_SCU)) PP_SCU_SAV = PP_SCU
   endif
endif

if(ich == 2) then
   ! -- retrieve time-even density -- 
   if(i_rs_level .eq. -1) then
      IF(ALLOCATED(DE_RHO)) DE_RHO = 0
   endif
   if(i_rs_level .gt. 0) then
      IF(ALLOCATED(DE_RHO)) DE_RHO = DE_RHO_SAV
   endif
   if(i_rs_level .gt. 1) then
      IF(ALLOCATED(DE_TAU)) DE_TAU = DE_TAU_SAV
      IF(ALLOCATED(DE_LPR)) DE_LPR = DE_LPR_SAV
      IF(ALLOCATED(DE_DIV)) DE_DIV = DE_DIV_SAV
      IF(ALLOCATED(DE_SCU)) DE_SCU = DE_SCU_SAV
      IF(ALLOCATED(DE_DES)) DE_DES = DE_DES_SAV
   endif
   if(i_rs_level .gt. 2) then
      !IF(ALLOCATED(DE_DIJ)) DE_DIJ = DE_DIJ_SAV
      IF(ALLOCATED(PD_RHO)) PD_RHO = PD_RHO_SAV
      IF(ALLOCATED(PD_TAU)) PD_TAU = PD_TAU_SAV
      IF(ALLOCATED(PD_LPR)) PD_LPR = PD_LPR_SAV
      IF(ALLOCATED(PP_RHO)) PP_RHO = PP_RHO_SAV
      IF(ALLOCATED(PP_TAU)) PP_TAU = PP_TAU_SAV
      IF(ALLOCATED(PP_LPR)) PP_LPR = PP_LPR_SAV
      IF(ALLOCATED(PD_SCU)) PD_SCU = PD_SCU_SAV
      IF(ALLOCATED(PP_SCU)) PP_SCU = PP_SCU_SAV
   endif
endif

endsubroutine RS_even_density


END MODULE ADBATC

!===============================================================================
! --------------------------------------------------------------------%%--------
! --    Applying SVD to a complex matrix RHO1 (M by N)
! --    RHO1 (M by N) = U(M by N) * diag[S(N)] * V(N by N); note: M >= N
! --------------------------------------------------------------------%%--------
subroutine zcallsvd( M, N, in_A, LDA, U, LDU, V, LDV, S, LDS)
implicit none

INTEGER    LWMAX
PARAMETER  ( LWMAX = 16 )
integer IWORK0(LWMAX)
complex CWORK0(LWMAX)
real RWORK0(LWMAX)

integer M
integer N
integer LDA
integer LDU
integer LDV
integer LDS
complex in_A(LDA,LDV)
complex U(LDU,LDV)
complex V(LDV,LDV)
real S(LDS)
!complex A(LDA,LDV)
complex, allocatable :: A(:,:)

integer NUMRANK
integer, dimension(:), allocatable:: IWORK
integer LIWORK
complex, dimension(:), allocatable:: CWORK
integer LWORK
real, dimension(:), allocatable:: RWORK
integer LRWORK
integer INFO
      
if(LDA .ne. LDU) stop 'Dimension error: LDA /= LDU'
if(LDV .ne. LDS) stop 'Dimension error: LDV /= LDS'
if(LDU .lt. LDV) stop 'LDU should larger than LDV'

! Prevent input matrix from being altered
      allocate( A(LDA,LDV) )
      A = in_A

! Query the optimal workspace.
      LIWORK = -1
      LWORK = -1
      LRWORK = -1
! --------------------------------------------------------------------72--------

      call zgesvdq( 'H',     'P',     'N',     'U',    'A',             &
     &               M,       N,       A,       LDA,                    &
     &               S,       U,       LDU,     V,      LDV,            &
     &               NUMRANK,                                           &
     &               IWORK0,  LIWORK,                                   &
     &               CWORK0,  LWORK,                                    &
     &               RWORK0,  LRWORK,                                   &
     &               INFO )

! --------------------------------------------------------------------72--------

      LIWORK =   IWORK0( 1 )
      LWORK  =   INT( CWORK0( 1 ) )
      LRWORK =   INT( RWORK0( 1 ) )
      allocate( IWORK(LIWORK), CWORK(LWORK), RWORK(LRWORK) )

! Compute SVD.
! --------------------------------------------------------------------72--------

      call zgesvdq( 'H',     'P',     'N',     'U',    'A',             &
     &               M,       N,       A,       LDA,                    &
     &               S,       U,       LDU,     V,      LDV,            &
     &               NUMRANK,                                           &
     &               IWORK,   LIWORK,                                   &
     &               CWORK,   LWORK,                                    &
     &               RWORK,   LRWORK,                                   &
     &               INFO )
! --------------------------------------------------------------------72--------

! -- Clean up --
deallocate( IWORK, CWORK, RWORK)
deallocate( A )

if(INFO /= 0) stop 'Fatal Error in ZCALLSVD' 
endsubroutine

!===============================================================================
! --------------------------------------------------------------------%%--------
! --    READ/WRITE DENSITY MATRIX & MULTIPOLE MOMENTS FROM/TO FILE
! --------------------------------------------------------------------%%--------

SUBROUTINE RWADBP(ICH)
USE hfodd_gs_data
IMPLICIT NONE
INTEGER ICH

INTEGER NFIADB

NFIADB = 9932

SFIADB=TRIM(SFIADB)

IF(ICH .EQ. 0) THEN
   OPEN(NFIADB,FILE=SFIADB,FORM='UNFORMATTED')
   WRITE (NFIADB) QMUL_N, QMUL_P, QMUL_T
   WRITE (NFIADB) DEN_PP(1:LDBASE,1:LDBASE,0:1,0:NDISOS), DEN_PM(1:LDBASE,1:LDBASE,0:1,0:NDISOS)
   WRITE (NFIADB) CHI_PP(1:LDBASE,1:LDBASE,0:1,0:NDISOS), CHI_PM(1:LDBASE,1:LDBASE,0:1,0:NDISOS)
ELSE
   OPEN(NFIADB,FILE=SFIADB,STATUS='OLD',ERR=9,FORM='UNFORMATTED')
   READ  (NFIADB) RMUL_N, RMUL_P, RMUL_T
   READ  (NFIADB) DEN_PP(1:LDBASE,1:LDBASE,0:1,0:NDISOS), DEN_PM(1:LDBASE,1:LDBASE,0:1,0:NDISOS)
   READ  (NFIADB) CHI_PP(1:LDBASE,1:LDBASE,0:1,0:NDISOS), CHI_PM(1:LDBASE,1:LDBASE,0:1,0:NDISOS)
ENDIF

CLOSE(NFIADB)

RETURN

    9 WRITE(*,'(/,1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',              &
     &                                                 2X,26(1H/),/,     &
     &                 1X, 3(1H/),2X,68X,                  2X, 3(1H/),/, &
     &                 1X, 1(1H/),2X,A72,                  2X, 1(1H/),/, &
     &                 1X, 3(1H/),2X,68X,                  2X, 3(1H/),/, &
     &                 1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',         &
     &                                                 2X,26(1H/))')     &
     &             SFIADB

      STOP ' FILE NOT FOUND IN RWADBP'

ENDSUBROUTINE

!--------------------------------------------------------------------------------

 !***********************************************************************
 !
 !    Copyright (c) 2015, Lawrence Livermore National Security, LLC.
 !                        Produced at the Lawrence Livermore National
 !                        Laboratory.
 !                        Written by Nicolas Schunck, schunck1@llnl.gov
 !
 !    LLNL-CODE-470611 All rights reserved.
 !
 !    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
 !                    W. Satula, J.A. Sheikh, A. Staszczak,
 !                    M. Stoitsov, P. Toivanen
 !    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
 !                    P. Olbratowski, P. Powalowski, M. Sadziak,
 !                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
 !                    M. Zalewski, H. Zdunczuk
 !    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
 !    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
 !
 !    This file is part of HFODD.
 !
 !    HFODD is free software: you can redistribute it and/or modify it
 !    under the terms of the GNU General Public License as published by
 !    the Free Software Foundation, either version 3 of the License, or
 !    (at your option) any later version.
 !
 !    HFODD is distributed in the hope that it will be useful, but
 !    WITHOUT ANY WARRANTY; without even the implied warranty of
 !    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 !    GNU General Public License for more details.
 !
 !    You should have received a copy of the GNU General Public License
 !    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
 !
 !    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
 !    LICENSE
 !
 !    Our Preamble Notice
 !
 !      A. This notice is required to be provided under our contract
 !         with the U.S. Department of Energy (DOE). This work was
 !         produced at the Lawrence Livermore National Laboratory under
 !         Contract No. DE-AC52-07NA27344 with the DOE.
 !      B. Neither the United States Government nor Lawrence Livermore
 !         National Security, LLC nor any of their employees, makes any
 !         warranty, express or implied, or assumes any liability or
 !         responsibility for the accuracy, completeness, or usefulness
 !         of any information, apparatus, product, or process disclosed,
 !         or represents that its use would not infringe privately-owned
 !         rights.
 !      C. Also, reference herein to any specific commercial products,
 !         process, or services by trade name, trademark, manufacturer
 !         or otherwise does not necessarily constitute or imply its
 !         endorsement, recommendation, or favoring by the United States
 !         Government or Lawrence Livermore National Security, LLC. The
 !         views and opinions of authors expressed herein do not
 !         necessarily state or reflect those of the United States
 !         Government or Lawrence Livermore National Security, LLC, and
 !         shall not be used for advertising or product endorsement
 !         purposes.
 !
 !    The precise terms and conditions for copying, distribution and
 !    modification are contained in the file COPYING.
 !
 !***********************************************************************

      SUBROUTINE Set_version_hfodd_SLsiz
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(9) = 'hfodd_SLsiz     '
      MODUVE(9) = 4
      MODSET(9) = 9
      !
      END SUBROUTINE Set_version_hfodd_SLsiz
      !
 !----------------------------------------------------------------------!
 !                                                                      !
 !                  HFODD, ScaLAPACK inclusion module                   !
 !                                                                      !
 ! Authors: J.D. McDonnell, N. Schunck, ORNL                            !
 !                                                                      !
 ! This module incorporates ScaLAPACK capabilities into HFODD.          !
 !                                                                      !
 !                          First included in official release v249g    !
 !----------------------------------------------------------------------!

 MODULE hfodd_SLsiz

	COMPLEX, ALLOCATABLE, DIMENSION(:,:), PUBLIC:: Hsub, Evec

	REAL, ALLOCATABLE, DIMENSION(:), PUBLIC:: Eval

	! submatrix stored on the processor (HFB, eigenvectors... eigenvalues),
	! with the local/absolute array's dimensions
	INTEGER, PUBLIC:: larow, lacol, absrow, abscol

	! Array containing the rank of every processor in each group
	! First index: rank wirthin the group, second index: group color
        INTEGER, ALLOCATABLE, DIMENSION(:,:), PUBLIC :: rankTribe

        ! block rows, block cols (local version of MBLOCK, NBLOCK)
	INTEGER, PUBLIC:: MB, NB

	! BLACS context, shape of process gridx2, row/col of processx2,
	! communication subroutine (error) info
	INTEGER, PUBLIC:: ICTXT, NPROW, NPCOL, MYROW, MYCOL, icom_err

	! The ScaLAPACK descriptor for HFB matrix
	INTEGER, DIMENSION(9), PUBLIC:: DESCHFB, DESCEIG

 CONTAINS

        !---------------------------------------------------------------------!
        !    Initialization of the ScaLAPACK environment and processor grid   !
        !---------------------------------------------------------------------!
	SUBROUTINE SL_INIT(inrow, incol, color, tribeRank, numberHFODDproc)

		INTEGER, INTENT(IN) :: inrow, incol, color, tribeRank, numberHFODDproc

                INTEGER, DIMENSION(:,:), ALLOCATABLE :: gridProc

                INTEGER :: i_row, j_col, i_tribe

		ALLOCATE(gridProc(inrow,incol))

		IF ( incol*inrow > numberHFODDproc ) STOP 'Error in SL_INIT'

		! Advanced : the BLACS processor grid is defined within a MPI group of processors.
		! feature    This requires to send to every processor the id of all other processors
		!            part of the same group (done at the beginning of HFODD). By default, a
		!            processor only has access to its own id number, via a call to mpi_comm_rank()
		i_tribe = 0
		DO j_col = 1, incol
		   DO i_row = 1, inrow
		      gridProc(i_row, j_col) = rankTribe(i_tribe, color)
		      i_tribe = i_tribe + 1
		   END DO
		END DO

		CALL BLACS_GET(0, 0, ICTXT)

		CALL BLACS_GRIDMAP(ICTXT, gridProc, inrow, inrow, incol)

		CALL BLACS_GRIDINFO(ICTXT, NPROW, NPCOL, MYROW, MYCOL)

	END SUBROUTINE SL_INIT

        !---------------------------------------------------------------------!
        !    Initialization of the ScaLAPACK context and local matrix sizes   !
        !---------------------------------------------------------------------!
	SUBROUTINE initSL_siz(ar,ac,lr,lc,inMB,inNB)

		INTEGER, INTENT(IN) :: ar, ac, lr, lc, inMB, inNB

		MB = inMB
		NB = inNB

		CALL DESCINIT(DESCHFB, ar, ac, MB, NB, 0, 0, ICTXT, lr, icom_err)
		CALL DESCINIT(DESCEIG, ar, ac, MB, NB, 0, 0, ICTXT, lr, icom_err)

		absrow = ar
		abscol = ac
		larow = lr
		lacol = lc

	END SUBROUTINE initSL_siz

        !---------------------------------------------------------------------!
        !  Parallel diagonalization of a complex Hermitian matrix Ham  using  !
        !  ScaLAPACK routines                                                 !
        !---------------------------------------------------------------------!
	SUBROUTINE diaSL_HFB_siz(Ham,KZHPEV)

	        INTEGER, INTENT(IN) :: KZHPEV
	        COMPLEX, POINTER, DIMENSION(:,:) :: Ham

	        COMPLEX, ALLOCATABLE, DIMENSION(:) :: WORK, RWORK

	        REAL :: realTime

		INTEGER :: LWORK, LRWORK, LIWORK
		INTEGER :: NP0, NQ0
                INTEGER :: IH, JH, IEv, JEv

                INTEGER, DIMENSION(:), ALLOCATABLE :: IWORK

		NP0 = NUMROC(absrow, NB, MYROW, 0, NPROW)
		NQ0 = NUMROC(abscol, NB, MYCOL, 0, NPCOL)

	        ! Definitions of sizes for work arrays

		! Simple driver
		IF (KZHPEV.EQ.1) THEN
	            LRWORK = 2*absrow + 2*absrow - 2
		    LWORK  = (NP0 + NQ0 + NB)*NB + 3*absrow + (absrow**2)
	        END IF

	        ! Divide-and-Conquer driver
		IF (KZHPEV.EQ.4) THEN
		    MP0 = NUMROC(absrow, NB, 0, 0, NPROW)
		    MQ0 = NUMROC(abscol, NB, 0, 0, NPCOL)

	            LRWORK = 1 + 9*absrow + 3*NP0*NQ0
		    LWORK  = (MP0 + MQ0 + NB)*NB + absrow
	        END IF

		IF (.NOT. ALLOCATED(Evec)) ALLOCATE(Evec(larow,lacol))
		IF (.NOT. ALLOCATED(Eval)) ALLOCATE(Eval(abscol))
		IF (.NOT. ALLOCATED(WORK)) ALLOCATE(WORK(LWORK), RWORK(LRWORK))

                IH  = 1
                JH  = 1
                IEv = 1
                JEv = 1

                call cpu_time(realTime)

                ! Diagonalization

		! Simple driver
                IF (KZHPEV.EQ.1) THEN
                    write(*,'(''Call to PZHEEV                  - Time: '',f20.10)') realTime
		    CALL PZHEEV('V', 'L', absrow, Ham, IH, JH, DESCHFB, Eval, Evec, IEv, JEv, &
		                           DESCEIG, WORK, LWORK, RWORK, LRWORK, icom_err)
                    call cpu_time(realTime)
                    write(*,'(''End of PZHEEV                   - Time: '',f20.10)') realTime
		END IF

	        ! Divide-and-Conquer driver
		IF (KZHPEV.EQ.4) THEN
                    write(*,'(''Call to PZHEEVD                 - Time: '',f20.10)') realTime
                    LIWORK=7*absrow + 8*NPCOL + 2
                    ALLOCATE(IWORK(LIWORK))

		    CALL PZHEEVD('V', 'L', absrow, Ham, IH, JH, DESCHFB, Eval, Evec, IEv, JEv, &
		                                DESCEIG, WORK, LWORK, RWORK, LRWORK, IWORK, LIWORK, icom_err)
		    DEALLOCATE(IWORK)
                    call cpu_time(realTime)
                    write(*,'(''End of PZHEEVD                  - Time: '',f20.10)') realTime
		END IF

		IF (ALLOCATED(WORK)) DEALLOCATE(WORK)
		IF (ALLOCATED(RWORK)) DEALLOCATE(RWORK)

	END SUBROUTINE diaSL_HFB_siz

        !---------------------------------------------------------------------!
        !  Reconstruction of the total eigenvectors and eigenvalues by using  !
        !  BLACS communication routines. EWAHFB and EQUHFB are global arrays, !
        !  i.e. identical arrays in all processes, which contain all eigen-   !
        !  vectors and values of the HFB matrix. Evec contains the local part !
        !  of the eigenvectors (local=in one process only), Eval the local    !
        !  part of the eigenvalues.                                           !
        !---------------------------------------------------------------------!
	SUBROUTINE diaSL_collapse_HFB_siz(EWAHFB,EQUHFB,bigs)

                INTEGER, INTENT(IN) :: bigs

                COMPLEX, DIMENSION(1:bigs, 1:bigs) :: EWAHFB
                COMPLEX, DIMENSION(:,:), ALLOCATABLE :: tEv

                REAL, DIMENSION(1:bigs) :: EQUHFB

                INTEGER, DIMENSION(9):: DESC_Ve

                IF (.NOT. ALLOCATED(tEv)) ALLOCATE(tEv(absrow,abscol))
                tEv = CMPLX(0.0d0,0.0d0)

                CALL DESCINIT(DESC_Ve, absrow, abscol, absrow, abscol, 0, 0, ICTXT, absrow, icom_err)

                CALL PZGEMR2D(absrow, abscol, Evec, 1, 1, DESCEIG, tEv, 1, 1, DESC_Ve, ICTXT)

                IF (MYROW .eq. 0 .and. MYCOL .eq. 0) THEN
                   CALL ZGEBS2D(ICTXT, 'A', ' ', absrow, abscol, tEv, absrow)
                ELSE
                   CALL ZGEBR2D(ICTXT, 'A', ' ', absrow, abscol, tEv, absrow, 0, 0)
                ENDIF

                EWAHFB(1:absrow,1:abscol) = tEv
                EQUHFB(1:absrow) = Eval(1:absrow)

                ! Synchronization at the end, just for security
                CALL BLACS_BARRIER( ICTXT, 'A' )

                IF (ALLOCATED(Eval)) DEALLOCATE(Eval)
                IF (ALLOCATED(Evec)) DEALLOCATE(Evec)
                IF (ALLOCATED(tEv))  DEALLOCATE(tEv)

        END SUBROUTINE diaSL_collapse_HFB_siz

        !---------------------------------------------------------------------!
        ! Closing down the ScaLAPACK environment and releasing processor grid !
        !---------------------------------------------------------------------!
	SUBROUTINE closeSL_all()
		CALL BLACS_GRIDEXIT(ICTXT)
		CALL BLACS_EXIT(0)
	END SUBROUTINE closeSL_all

END MODULE hfodd_SLsiz

      SUBROUTINE Set_version_hfodd_lipcorr
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(14) = 'hfodd_lipcorr   '
      MODUVE(14) = 54
      MODSET(14) = 14
      !
      END SUBROUTINE Set_version_hfodd_lipcorr
      !
!=======================================================================
!
MODULE OVRHFB
!
!=======================================================================
!     MODULE COMPUTING THE OVERLAP BETWEEN TWO HFB WAVE FUNCTIONS, BASED
!     ON PFAFFIANS, ACCORDING TO EQS. (7) FOR EVEN SYSTEMS,  OR (19) FOR
!     ODD ONES, OF BERTSCH AND ROBLEDO, PRL 108, 042505 (2012).
!=======================================================================
!     THE RUSSIAN CONVENTION HAS TO BE REMOVED FOR  THE LOWER COMPONENTS
!     OF THE HFB WAVE FUNCTIONS.
!=======================================================================
!     THE ARRAYS AMATRG/BMATRG (AMATLF/BMATLF) ARE THE A AND B  MATRICES
!     FOR THE RIGHT (LEFT) HFB STATE.  FOR AN ODD PARTICLE NUMBER, THESE
!     ARRAYS  CONTAIN ONLY THE  "EVEN" HFB VACUUM ON TOP OF WHICH THE QP
!     EXCITATIONS ARE BUILT. THE BLOCKED QP ARE STORED IN ARRAYS ABLOLF,
!     BBLOLF, ABLORG, BBLORG (q, p, q', p' IN EQ. (19) RESPECTIVELY).
!=======================================================================
!     THE PFAFFIAN IS COMPUTED VIA THE ROUTINE SKPF10 FROM  THE WIMMER'S
!     LIBRARY (ACM TRANS. MATH. SOFTWARE 38, 30 (2012)).
!=======================================================================
!     FROM VERSION 34, THIS MODULE ALSO INCLUDES THE ROUTINE OVRONI THAT
!     COMPUTE THE OVERLAP BETWEEN HFB STATES THROUGH THE ONISHI FORMULA.
!     THE  ONISHI  FORMULA  CONSIDERED INVOLVES A PREFACTOR AS WELL AS A
!     A NORMALIZATION,  IN CONTRAST TO THE EXPRESSION  USUALLY  GIVEN IN
!     THE LITERATURE.  THESE FACTORS COME FROM THE FACT THAT WE COMPUTE
!     IT FROM THE "PFAFFIAN" FORM OF HFB STATES,  AND NOT THEIR THOULESS
!     FORM.
!     THE MODULE ALSO INCLUSES AN EXTRA ROUTINE,  OVRMAT,  COMPUTING THE
!     MATRIX OF OVERLAPS BETWEEN THE QUASIPARTICLE STATES.
!=======================================================================
!     COMMENTS FROM DENSHF:
!     COMPONENTS OF THE SINGLE-PARTICLE (FOR IPAHFB=0) OR  QUASIPARTICLE
!     (FOR IPAHFB>0) WAVE FUNCTIONS  ARE  COLLECTED  IN  THE  SPACE-SPIN
!     REPRESENTATION IN THE "WARIGH" ARRAY. ALL THESE COMPONETS HAVE THE
!     FIRST INDEX SPANNING THE HO BASIS (1:LDBASE) AND THE  THIRD  INDEX
!     SPANNING THE TWO SPIN VALUES (1:NDSPIN). DIFFERENT  COMPONETS  ARE
!     STORED CONSECUTIVELY IN THE SECOND INDEX, WHICH  SPANS  VALUES  OF
!     (1:N*NDSTAT) WITH VALUES OF "N" ADJUSTED TO THE  CURRENT  SYMMETRY
!     CONDITIONS, AND GIVEN BY:
!     N=M   (FOR IPNMIX=0) AND
!     N=2*M (FOR IPNMIX=1), WITH INTEGERS M LISTED BELOW.
!=======================================================================
!     DENOTING THE COMPONENTS BY:
!                   TU=TIME-UP   (SIMPLEX=+i,IREVER=0)
!                   TD=TIME-DOWN (SIMPLEX=-i,IREVER=1)
!                   QU=UPPER HFB COMPONENT  (B*-ARRAYS)
!                   QD=LOWER HFB COMPONENT  (A*-ARRAYS),  WE HAVE:
!     FOR IPAHFB=1, ISIMPY=1, MREVER=0: M=2,(QU&TU,QD&TD)
!     FOR IPAHFB=1, ISIMPY=1, MREVER=1: M=4,(QU&TU,QU&TD,QD&TD,QD&TU)
!     FOR IPAHFB=1, ISIMPY=0, MREVER=1: M=4,(QU&TU,QU&TD,QD&TU,QD&TD)
!=======================================================================
!
USE BLOSAV
USE hfodd_sizes
USE F77_PFAPACK
USE SAVRIG
IMPLICIT NONE
!
CONTAINS
!
!=======================================================================
!=======================================================================
!
SUBROUTINE OVRPFA(LDBASE,LUPPER,IBLOCL,IBLOCR,IDBLOL,IDBLOR,IBLQPL,    &
                  IBLQPR,PREPFA,WALEFT,WARIGH,BTAPLF,OVERLP,ICHARG)
!
INTEGER, INTENT(IN) :: LDBASE,LUPPER,IBLOCR,IBLOCL,IDBLOL,IDBLOR,ICHARG
INTEGER, DIMENSION(0:1,1:NDBLOC), INTENT(IN) :: IBLQPL,IBLQPR
COMPLEX, DIMENSION(2), INTENT(IN) :: PREPFA
COMPLEX, DIMENSION(1:NDBASE,1:4*NDSTAT,0:NDSPIN),                      &
                                         INTENT(IN) :: WALEFT, WARIGH
COMPLEX, DIMENSION(LUPPER+NDBLOC,LUPPER+NDBLOC),                       &
                                         INTENT(IN) :: BTAPLF
!
COMPLEX, DIMENSION(2), INTENT(OUT) :: OVERLP
!
!=======================================================================
!     THIS SUBROUTINE COMPUTES THE OVERLAP BETWEEN HFB STATES.
!
!     BTAPLF AND BTAPRG ARE PRODUCTS B^TA FOR THE LEFT AND RIGHT STATES,
!     RESPECTIVELY.  THEY ENTER  AS  THE DIAGONAL BLOCKS OF THE PFAFFIAN
!     MATRIX. AS THEY DO NOT DEPEND ON THE SYMMETRY TRANSFORMATION, THEY
!     ARE PRE-COMPUTED IN PRPFAF AND FEED THE PRESENT ROUTINE.
!=======================================================================
!
INTEGER :: IALLOC,ISTATE,NUBLOC,MUBLOC,MDBLOL,IBLOPB,IBLOPA,MDBLOR,    &
           LDPFAF,INFOPF,JSTATE
COMPLEX :: C_ZERO,C_UNIT,SIGNPF
INTEGER, DIMENSION(:), ALLOCATABLE :: IPFWRK
REAL,    DIMENSION(:), ALLOCATABLE :: RPFWRK
COMPLEX, DIMENSION(2) :: PFAFFI
COMPLEX, DIMENSION(:), ALLOCATABLE :: PFAWRK
COMPLEX, DIMENSION(:,:), ALLOCATABLE :: BMATLF,BMATRG,BAPRRG,ABLOLF,ABLORG,   &
                                        BBPROD,BLQRPR,BRQLPR,QLQRPR,          &
                                        PFAMAT,BTAPRG,AMATRG,EAMATR,          &
                                        BBLORG,BPPRRG,QPPRRG
!
!=======================================================================
!      INITIALISATION
!=======================================================================
!
C_ZERO=CMPLX(0.0D0,0.0D0)
C_UNIT=CMPLX(1.0D0,0.0D0)
MDBLOL=LUPPER+IDBLOL
MDBLOR=LUPPER+IDBLOR
!
ALLOCATE (BMATLF(1:2*LDBASE,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('BMATLF','OVRPFA')
ALLOCATE (BMATRG(1:2*LDBASE,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('BMATRG','OVRPFA')
ALLOCATE (AMATRG(1:2*LDBASE,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('AMATRG','OVRPFA')
ALLOCATE (EAMATR(1:LUPPER,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('EAMATR','OVRPFA')
ALLOCATE (BAPRRG(1:LUPPER,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('BAPRRG','OVRPFA')
ALLOCATE (BBPROD(1:LUPPER,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('BBPROD','OVRPFA')
ALLOCATE (BTAPRG(1:MDBLOR,1:MDBLOR),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('BTAPRG','OVRPFA')
!
BMATLF(:,:)=C_ZERO
BMATRG(:,:)=C_ZERO
AMATRG(:,:)=C_ZERO
EAMATR(:,:)=C_ZERO
BBPROD(:,:)=C_ZERO
BTAPRG(:,:)=C_ZERO
BAPRRG(:,:)=C_ZERO
!
IF (IBLOCL.EQ.1) THEN
!
    ALLOCATE (ABLOLF(1:IDBLOL,1:2*LDBASE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('ABLOLF','OVRPFA')
    ALLOCATE (BRQLPR(1:LUPPER,1:IDBLOL),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('BRQLPR','OVRPFA')
!
    ABLOLF(:,:)=C_ZERO
    BRQLPR(:,:)=C_ZERO
!
END IF
!
IF (IBLOCR.EQ.1) THEN
!
    ALLOCATE (ABLORG(1:IDBLOR,1:2*LDBASE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('ABLORG','OVRPFA')
    ALLOCATE (BLQRPR(1:LUPPER,1:IDBLOR),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('BLQRPR','OVRPFA')
    ALLOCATE (BBLORG(1:IDBLOR,1:2*LDBASE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('BBLORG','OVRPFA')
    ALLOCATE (BPPRRG(1:LUPPER,1:IDBLOR),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('BPPRRG','OVRPFA')
    ALLOCATE (QPPRRG(1:IDBLOR,1:IDBLOR),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('QPPRRG','OVRPFA')
!
    ABLORG(:,:)=C_ZERO
    BLQRPR(:,:)=C_ZERO
    BBLORG(:,:)=C_ZERO
    BPPRRG(:,:)=C_ZERO
    QPPRRG(:,:)=C_ZERO
!
END IF
!
IF ((IBLOCL.EQ.1).AND.(IBLOCR.EQ.1)) THEN
!
    ALLOCATE (QLQRPR(1:IDBLOL,1:IDBLOR),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('QLQRPR','OVRPFA')
!
    QLQRPR(:,:)=C_ZERO
!
END IF
!
!=======================================================================
!     COLLECTING THE B MATRICES FOR THE LEFT AND RIGHT STATES.
!     FOR A BLOCKED HFB STATE,  THE BLOCKED  QP ARE COLLECTED SEPARATELY
!     IN BBLOLF, ABLOLF, AND THE COMPONENTS ARE FLIPPED BACK IN B AND A.
!=======================================================================
!
DO ISTATE=1,LUPPER
!
    JSTATE=ISTATE+LUPPER
!
    BMATLF(1:LDBASE         ,ISTATE)= CONJG(WALEFT(1:LDBASE,ISTATE,0))
    BMATLF(LDBASE+1:2*LDBASE,ISTATE)= CONJG(WALEFT(1:LDBASE,ISTATE,1))
    BMATRG(1:LDBASE         ,ISTATE)= CONJG(WARIGH(1:LDBASE,ISTATE,0))
    BMATRG(LDBASE+1:2*LDBASE,ISTATE)= CONJG(WARIGH(1:LDBASE,ISTATE,1))
    AMATRG(1:LDBASE         ,ISTATE)= CONJG(WARIGH(1:LDBASE,JSTATE,1))
    AMATRG(LDBASE+1:2*LDBASE,ISTATE)=-CONJG(WARIGH(1:LDBASE,JSTATE,0))
!
END DO
!
IF (IBLOCL.EQ.1) THEN
!
    MUBLOC=0
    DO NUBLOC=1,NDBLOC
       IBLOPB=IBLQPL(0,NUBLOC)
       IBLOPA=IBLQPL(1,NUBLOC)
!
       IF (IBLOPB.GT.0) THEN
           BMATLF(1:LDBASE         ,IBLOPB)= WALEFT(1:LDBASE,IBLOPA,1)
           BMATLF(LDBASE+1:2*LDBASE,IBLOPB)=-WALEFT(1:LDBASE,IBLOPA,0)
!
           MUBLOC=MUBLOC+1
           ABLOLF(MUBLOC,1:LDBASE         )=WALEFT(1:LDBASE,IBLOPB,0)
           ABLOLF(MUBLOC,LDBASE+1:2*LDBASE)=WALEFT(1:LDBASE,IBLOPB,1)
       END IF
!
   END DO
!
END IF
!
IF (IBLOCR.EQ.1) THEN
!
    MUBLOC=0
    DO NUBLOC=1,NDBLOC
       IBLOPB=IBLQPR(0,NUBLOC)
       IBLOPA=IBLQPR(1,NUBLOC)
!
       IF (IBLOPB.GT.0) THEN
           BMATRG(1:LDBASE         ,IBLOPB)= WARIGH(1:LDBASE,IBLOPA,1)
           BMATRG(LDBASE+1:2*LDBASE,IBLOPB)=-WARIGH(1:LDBASE,IBLOPA,0)
           AMATRG(1:LDBASE         ,IBLOPB)= WARIGH(1:LDBASE,IBLOPB,0)
           AMATRG(LDBASE+1:2*LDBASE,IBLOPB)= WARIGH(1:LDBASE,IBLOPB,1)

           MUBLOC=MUBLOC+1
           BBLORG(MUBLOC,1:LDBASE         )= WARIGH(1:LDBASE,IBLOPA,1)
           BBLORG(MUBLOC,LDBASE+1:2*LDBASE)=-WARIGH(1:LDBASE,IBLOPA,0)
           ABLORG(MUBLOC,1:LDBASE         )= WARIGH(1:LDBASE,IBLOPB,0)
           ABLORG(MUBLOC,LDBASE+1:2*LDBASE)= WARIGH(1:LDBASE,IBLOPB,1)
       END IF
!
    END DO
!
    IF(MUBLOC.NE.IDBLOR) STOP 'MUBLOC NE IDBLOR IN PRPFAF'
!
END IF
!
!=======================================================================
!     BUILDING THE PFAFFIAN MATRIX FOR HFB VACUUM
!=======================================================================
!
IF ((IBLOCL.EQ.0).AND.(IBLOCR.EQ.0)) THEN
!
    LDPFAF=2*LUPPER
    ALLOCATE (PFAMAT(1:LDPFAF,1:LDPFAF),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('PFAMAT','OVRPFA')
    PFAMAT(:,:)=C_ZERO
!
!   B^T A (precomputed)
    PFAMAT(1:LUPPER,1:LUPPER)=BTAPLF(1:LUPPER,1:LUPPER)
!
!   B'^+ B
    CALL ZGEMM('C','N',LUPPER,LUPPER,2*LDBASE,C_UNIT,                  &
               BMATRG,2*LDBASE,BMATLF,2*LDBASE,C_ZERO,BBPROD,LUPPER)
    PFAMAT(LUPPER+1:LDPFAF,1:LUPPER)=-BBPROD(1:LUPPER,1:LUPPER)
    PFAMAT(1:LUPPER,LUPPER+1:LDPFAF)= TRANSPOSE(                       &
                                      BBPROD(1:LUPPER,1:LUPPER))
!
!     A^+B^* (computed in PRPFAF before version 43).
!
    CALL ZGEMM('T','N',LUPPER,LUPPER,2*LDBASE,C_UNIT,                  &
             BMATRG,2*LDBASE,AMATRG,2*LDBASE,C_ZERO,BAPRRG,LUPPER)
!
    BTAPRG(1:LUPPER,1:LUPPER)=                                         &
                        TRANSPOSE(CONJG(BAPRRG(1:LUPPER,1:LUPPER)))
!
    BTAPRG=0.5_8*(BTAPRG-TRANSPOSE(BTAPRG))
!
    PFAMAT(LUPPER+1:LDPFAF,LUPPER+1:LDPFAF)=BTAPRG(1:LUPPER,1:LUPPER)
!
!=======================================================================
!     BUILDING THE PFAFFIAN MATRIX FOR STATES WITH (MULTI)QP EXCITATION.
!     NOTE: THE DIMENSION OF THE DIAGONAL BLOCKS AUTOMATICALLY ADJUSTS
!           TO THE CASE SINCE LDBLOX=LUPPER WITOUT BLOCKING (X=L,R).
!=======================================================================
!
ELSE ! IBLOCR=1 AND/OR IBLOCL=1
!
    LDPFAF=MDBLOL+MDBLOR
    ALLOCATE (PFAMAT(1:LDPFAF,1:LDPFAF),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('PFAMAT','OVRPFA')
    PFAMAT(:,:)=C_ZERO
!
!   B^T A / B^T p^+ / -p^* B / q^*p^+ (precomputed)
    PFAMAT(1:MDBLOL,1:MDBLOL)=BTAPLF(1:MDBLOL,1:MDBLOL)
!
!   B'^+ B
    CALL ZGEMM('C','N',LUPPER,LUPPER,2*LDBASE,C_UNIT,                  &
               BMATRG,2*LDBASE,BMATLF,2*LDBASE,C_ZERO,BBPROD,LUPPER)
    PFAMAT(MDBLOL+IDBLOR+1:LDPFAF,1:LUPPER)=-BBPROD(1:LUPPER,1:LUPPER)
    PFAMAT(1:LUPPER,MDBLOL+IDBLOR+1:LDPFAF)=                           &
                                   TRANSPOSE(BBPROD(1:LUPPER,1:LUPPER))
!
!  B^T q'^T
    IF (IBLOCR.EQ.1) THEN
        CALL ZGEMM('T','T',LUPPER,IDBLOR,2*LDBASE,C_UNIT,              &
                   BMATLF,2*LDBASE,ABLORG,IDBLOR,C_ZERO,BLQRPR,LUPPER)
        PFAMAT(1:LUPPER,MDBLOL+1:MDBLOL+IDBLOR)=                       &
                                              BLQRPR(1:LUPPER,1:IDBLOR)
        PFAMAT(MDBLOL+1:MDBLOL+IDBLOR,1:LUPPER)=                       &
                                   -TRANSPOSE(BLQRPR(1:LUPPER,1:IDBLOR))
    END IF
!
!   B'^+ q^+
    IF (IBLOCL.EQ.1) THEN
        CALL ZGEMM('C','C',LUPPER,IDBLOL,2*LDBASE,C_UNIT,              &
                   BMATRG,2*LDBASE,ABLOLF,IDBLOL,C_ZERO,BRQLPR,LUPPER)
        PFAMAT(MDBLOL+IDBLOR+1:LDPFAF,LUPPER+1:MDBLOL)=                &
                                             -BRQLPR(1:LUPPER,1:IDBLOL)
        PFAMAT(LUPPER+1:MDBLOL,MDBLOL+IDBLOR+1:LDPFAF)=                &
                                    TRANSPOSE(BRQLPR(1:LUPPER,1:IDBLOL))
    END IF
!
!   q q'^+
    IF ((IBLOCL.EQ.1).AND.(IBLOCR.EQ.1)) THEN
        CALL ZGEMM('N','C',IDBLOL,IDBLOR,2*LDBASE,C_UNIT,              &
                   ABLOLF,IDBLOL,ABLORG,IDBLOR,C_ZERO,QLQRPR,IDBLOL)
        PFAMAT(LUPPER+1:LUPPER+IDBLOL,MDBLOL+1:MDBLOL+IDBLOR)=         &
                                      CONJG(QLQRPR(1:IDBLOL,1:IDBLOR))
        PFAMAT(MDBLOL+1:MDBLOL+IDBLOR,LUPPER+1:LUPPER+IDBLOL)=         &
                           -TRANSPOSE(CONJG(QLQRPR(1:IDBLOL,1:IDBLOR)))
    END IF
!
!   A'^+ B'^* / p'B'^* / -B'^+p'^T / p'q'^T (precomputed)
    CALL ZGEMM('T','N',LUPPER,LUPPER,2*LDBASE,C_UNIT,                  &
             BMATRG,2*LDBASE,AMATRG,2*LDBASE,C_ZERO,BAPRRG,LUPPER)
!
    BTAPRG(IDBLOR+1:MDBLOR,IDBLOR+1:MDBLOR)=TRANSPOSE(CONJG(           &
                                           BAPRRG(1:LUPPER,1:LUPPER)))
    CALL ZGEMM('T','C',LUPPER,IDBLOR,2*LDBASE,C_UNIT,                  &
               BMATRG,2*LDBASE,BBLORG,IDBLOR,C_ZERO,BPPRRG,LUPPER)
!
    BTAPRG(IDBLOR+1:MDBLOR,1:IDBLOR)=                                  &
                                 -CONJG(BPPRRG(1:LUPPER,1:IDBLOR))
    BTAPRG(1:IDBLOR,IDBLOR+1:MDBLOR)=                                  &
                        TRANSPOSE(CONJG(BPPRRG(1:LUPPER,1:IDBLOR)))

    CALL ZGEMM('N','T',IDBLOR,IDBLOR,2*LDBASE,C_UNIT,                  &
               ABLORG,IDBLOR,BBLORG,IDBLOR,C_ZERO,QPPRRG,IDBLOR)
!
    BTAPRG(1:IDBLOR,1:IDBLOR)=TRANSPOSE(QPPRRG(1:IDBLOR,1:IDBLOR))

    BTAPRG=0.5_8*(BTAPRG-TRANSPOSE(BTAPRG))
!
    PFAMAT(MDBLOL+1:LDPFAF,MDBLOL+1:LDPFAF)= BTAPRG(1:MDBLOR,1:MDBLOR)
!
!   Deallocating
    IF (IBLOCL.EQ.1) DEALLOCATE (ABLOLF,BRQLPR)
!
    IF (IBLOCR.EQ.1) DEALLOCATE (ABLORG,BBLORG,BLQRPR,BPPRRG,QPPRRG)
!
    IF ((IBLOCL.EQ.1).AND.(IBLOCR.EQ.1)) DEALLOCATE (QLQRPR)
!
END IF
!
DEALLOCATE (BMATLF,BMATRG,BBPROD,BTAPRG,AMATRG,EAMATR)
!
!=======================================================================
!     COMPUTING THE NORM/OVERLAP
!=======================================================================
!
LDPFAF=SIZE(PFAMAT,1)
ALLOCATE (IPFWRK(LDPFAF),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('IPFWRK','OVRPFA')
ALLOCATE (PFAWRK(LDPFAF),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('PFAWRK','OVRPFA')
ALLOCATE (RPFWRK(LDPFAF),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('RPFWRK','OVRPFA')
!
CALL SKPF10('U','P',LDPFAF,PFAMAT,LDPFAF,PFAFFI,IPFWRK,PFAWRK,LDPFAF,  &
                    RPFWRK,INFOPF)
!
IF(INFOPF.NE.0) THEN
    WRITE(*,*) 'INFO PFAFFIAN =',INFOPF
    STOP
END IF
!
SIGNPF=(-C_UNIT)**(LUPPER*(LUPPER-1)/2) * (-C_UNIT)**(IDBLOL*(IDBLOL-1)/2)
OVERLP(1)=SIGNPF*PREPFA(1)*PFAFFI(1)
OVERLP(2)=PREPFA(2)+PFAFFI(2)
!
IF (AIMAG(OVERLP(2)).GT.1.0D-9) STOP 'OVERLP(2) CANNOT BE IMAGINARY'
!
DEALLOCATE (PFAMAT,IPFWRK,PFAWRK,RPFWRK)
!
!=======================================================================
!
END SUBROUTINE OVRPFA
!
!=======================================================================
!=======================================================================
!
SUBROUTINE PRPFAF(LDBASE,LUPPER,IBLOCR,IDBLOR,IBLQPR,WARIGH,BTAPLF,    &
                                                            BTAPRG)
!
INTEGER, INTENT(IN) :: LDBASE,LUPPER,IBLOCR,IDBLOR
INTEGER, DIMENSION(0:1,1:NDBLOC), INTENT(IN) :: IBLQPR
COMPLEX, DIMENSION(1:NDBASE,1:4*NDSTAT,0:NDSPIN), INTENT(IN) :: WARIGH
!
COMPLEX, DIMENSION(LUPPER+NDBLOC,LUPPER+NDBLOC),                       &
                                         INTENT(OUT) :: BTAPLF,BTAPRG
!
!=======================================================================
!     PREPARE THE COMPUTATION OF THE OVERLAP BETWEEN HFB STATES  BY PRE-
!     COMPUTING QUANTITIES THAT DO NOT DEPEND ON THE  SYMMETRY OPERATOR.
!     THE ROUTINE COMPUTES B^TA=BTAPLF AND A^+B^*=BTAPRG FOR THE LEFT OR
!     RIGHT STATES, (IDIAGO=1), I.E. THE DIAGONAL BLOCKS OF THE PFAFFIAN
!     MATRIX.
!     THE CASE IDIAGO=0 IS TREATED VIA TWO SEPARATE CALLS OF PRPFAF, THE
!     SECOND ONE WITH WARIGH=WALEFT AND VARIABLE IXXXXR=IXXXXL.
!=======================================================================
!
INTEGER :: IALLOC,ISTATE,JSTATE,NUBLOC,MUBLOC,IBLOPB,IBLOPA,MDBLOR
COMPLEX :: C_ZERO,C_UNIT
COMPLEX, DIMENSION(:,:), ALLOCATABLE :: AMATRG,BMATRG,BAPRRG,ABLORG,   &
                                        BBLORG,BPPRRG,QPPRRG
!
!=======================================================================
!     INITIALISATION
!=======================================================================
!
C_ZERO=CMPLX(0.0D0,0.0D0)
C_UNIT=CMPLX(1.0D0,0.0D0)
BTAPLF(:,:)=C_ZERO
BTAPRG(:,:)=C_ZERO
!
!=======================================================================
!     ALLOCATION
!=======================================================================
!
MDBLOR=LUPPER+IDBLOR
!
ALLOCATE (AMATRG(1:2*LDBASE,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('AMATRG','PRPFAF')
ALLOCATE (BMATRG(1:2*LDBASE,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('BMATRG','PRPFAF')
ALLOCATE (BAPRRG(1:LUPPER,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('BAPRRG','PRPFAF')
!
AMATRG(:,:)=C_ZERO
BMATRG(:,:)=C_ZERO
BAPRRG(:,:)=C_ZERO
!
IF (IBLOCR.EQ.1) THEN
!
    ALLOCATE (ABLORG(1:IDBLOR,1:2*LDBASE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('ABLORG','PRPFAF')
    ALLOCATE (BBLORG(1:IDBLOR,1:2*LDBASE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('BBLORG','PRPFAF')
    ALLOCATE (BPPRRG(1:LUPPER,1:IDBLOR),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('BPPRRG','PRPFAF')
    ALLOCATE (QPPRRG(1:IDBLOR,1:IDBLOR),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('QPPRRG','PRPFAF')
!
    ABLORG(:,:)=C_ZERO
    BBLORG(:,:)=C_ZERO
    BPPRRG(:,:)=C_ZERO
    QPPRRG(:,:)=C_ZERO
!
END IF
!
!=======================================================================
!     COLLECTING THE  B AND A MATRICES FOR THE RIGHT STATE, AND REMOVING
!     THE RUSSIAN CONVENTION.  FOR A BLOCKED HFB STATE,  THE BLOCKED  QP
!     ARE COLLECTED SEPARATELY IN  BBLORG AND ABLORG  AND THE COMPONENTS
!     ARE FLIPPED BACK IN B AND A.
!=======================================================================
!
DO ISTATE=1,LUPPER
    JSTATE=LUPPER+ISTATE
!
    BMATRG(1:LDBASE         ,ISTATE)= CONJG(WARIGH(1:LDBASE,ISTATE,0))
    BMATRG(LDBASE+1:2*LDBASE,ISTATE)= CONJG(WARIGH(1:LDBASE,ISTATE,1))
    AMATRG(1:LDBASE         ,ISTATE)= CONJG(WARIGH(1:LDBASE,JSTATE,1))
    AMATRG(LDBASE+1:2*LDBASE,ISTATE)=-CONJG(WARIGH(1:LDBASE,JSTATE,0))
!
END DO
!
IF (IBLOCR.EQ.1) THEN
!
    MUBLOC=0
    DO NUBLOC=1,NDBLOC
       IBLOPB=IBLQPR(0,NUBLOC)
       IBLOPA=IBLQPR(1,NUBLOC)
!
       IF (IBLOPB.GT.0) THEN
           MUBLOC=MUBLOC+1

           BMATRG(1:LDBASE         ,IBLOPB)= WARIGH(1:LDBASE,IBLOPA,1)
           BMATRG(LDBASE+1:2*LDBASE,IBLOPB)=-WARIGH(1:LDBASE,IBLOPA,0)
           AMATRG(1:LDBASE         ,IBLOPB)= WARIGH(1:LDBASE,IBLOPB,0)
           AMATRG(LDBASE+1:2*LDBASE,IBLOPB)= WARIGH(1:LDBASE,IBLOPB,1)

           BBLORG(MUBLOC,1:LDBASE         )= WARIGH(1:LDBASE,IBLOPA,1)
           BBLORG(MUBLOC,LDBASE+1:2*LDBASE)=-WARIGH(1:LDBASE,IBLOPA,0)
           ABLORG(MUBLOC,1:LDBASE         )= WARIGH(1:LDBASE,IBLOPB,0)
           ABLORG(MUBLOC,LDBASE+1:2*LDBASE)= WARIGH(1:LDBASE,IBLOPB,1)
       END IF
!
    END DO
!
    IF(MUBLOC.NE.IDBLOR) STOP 'MUBLOC NE IDBLOR IN PRPFAF'
!
END IF
!
!=======================================================================
!     THE PRODUCT B^T A IS COMPUTED AND STORED IN BTAPLF.
!=======================================================================
!
CALL ZGEMM('T','N',LUPPER,LUPPER,2*LDBASE,C_UNIT,                      &
           BMATRG,2*LDBASE,AMATRG,2*LDBASE,C_ZERO,BAPRRG,LUPPER)
!
BTAPLF(1:LUPPER,1:LUPPER)=BAPRRG(1:LUPPER,1:LUPPER)
!
!=======================================================================
!     THE EXTRA ROWS AND COLUMNS  ENTERING THE PFAFFIAN  MATRIX  IN THE
!     CASE OF AN EXCITED QP STATE ARE COMPUTED.
!=======================================================================
!
IF (IBLOCR.EQ.1) THEN
!
! B^T p^+
    CALL ZGEMM('T','C',LUPPER,IDBLOR,2*LDBASE,C_UNIT,                  &
               BMATRG,2*LDBASE,BBLORG,IDBLOR,C_ZERO,BPPRRG,LUPPER)
!
    BTAPLF(1:LUPPER,LUPPER+1:MDBLOR)=           BPPRRG(1:LUPPER,1:IDBLOR)
    BTAPLF(LUPPER+1:MDBLOR,1:LUPPER)=-TRANSPOSE(BPPRRG(1:LUPPER,1:IDBLOR))
!
! q^*p^+
    CALL ZGEMM('N','T',IDBLOR,IDBLOR,2*LDBASE,C_UNIT,                  &
               ABLORG,IDBLOR,BBLORG,IDBLOR,C_ZERO,QPPRRG,IDBLOR)
!
    BTAPLF(LUPPER+1:MDBLOR,LUPPER+1:MDBLOR)=                           &
                                       CONJG(QPPRRG(1:IDBLOR,1:IDBLOR))
!
END IF
!
!=======================================================================
!     A^+B^*=BTAPRG, BUILD USING THE RESULTS FOR B^TA=BTAPLF (IDIAGO=1).
!=======================================================================
!
IF (IBLOCR.EQ.0) THEN
!
    BTAPRG(1:LUPPER,1:LUPPER)=                                         &
                        TRANSPOSE(CONJG(BAPRRG(1:LUPPER,1:LUPPER)))
ELSE
    BTAPRG(IDBLOR+1:MDBLOR,IDBLOR+1:MDBLOR)=                           &
                        TRANSPOSE(CONJG(BAPRRG(1:LUPPER,1:LUPPER)))
    BTAPRG(IDBLOR+1:MDBLOR,1:IDBLOR)=                                  &
                                 -CONJG(BPPRRG(1:LUPPER,1:IDBLOR))
    BTAPRG(1:IDBLOR,IDBLOR+1:MDBLOR)=                                  &
                        TRANSPOSE(CONJG(BPPRRG(1:LUPPER,1:IDBLOR)))
    BTAPRG(1:IDBLOR,1:IDBLOR)=TRANSPOSE(QPPRRG(1:IDBLOR,1:IDBLOR))
!
    DEALLOCATE (ABLORG,BBLORG,BPPRRG,QPPRRG)
!
END IF
!
DEALLOCATE (AMATRG,BMATRG,BAPRRG)
!
!=======================================================================
!          ENFORCING THE SKEW-SYMMETRY FOR PRECISION
!=======================================================================
!
BTAPLF=0.5_8*(BTAPLF-TRANSPOSE(BTAPLF))
BTAPRG=0.5_8*(BTAPRG-TRANSPOSE(BTAPRG))
!
!=======================================================================
!
END SUBROUTINE PRPFAF
!
!=======================================================================
!=======================================================================
!
SUBROUTINE OVRONI(LDBASE,LUPPER,PREPFA,DETOVR,WALEFT,WARIGH,OVERLP)
!
INTEGER, INTENT(IN) :: LDBASE,LUPPER
COMPLEX, DIMENSION(2), INTENT(IN) :: DETOVR,PREPFA
COMPLEX, DIMENSION(1:NDBASE,1:4*NDSTAT,0:NDSPIN),                      &
                                         INTENT(IN) :: WALEFT, WARIGH
!
COMPLEX, DIMENSION(2), INTENT(OUT) :: OVERLP
!
!=======================================================================
!     THIS SUBROUTINE COMPUTES THE  OVERLAP BETWEEN HFB STATES USING THE
!     ONISHI FORMULA:
!
!       <WALEFT|WARIGH> = N*S*SQRT(DET[(B')^T B^*])*SQRT(DET(OVRLAP))
!
!     WHERE S = (-1)^(LUPPER*(LUPPER-1)/2)  IS A PHASE FACTOR, AND N THE
!     NORMALIZATION PRECOMPUTED BY CALLING THE SUBROUTINE WITH N = 1 AND
!     STORED IN PREPFA. DET(OVRLAP) IS STORED IN DETOVR.
!=======================================================================
!
INTEGER :: IALLOC,ISTATE,JSTATE,IBASE,ISPIN
REAL    :: RICOND,DPOWER
COMPLEX :: C_ZERO,C_UNIT,UNIT_I,ONIMOD,ONIPHS,SIGNPF
COMPLEX, DIMENSION(2) :: DETWRK,ONIPRE,ONIOVR
INTEGER, DIMENSION(:), ALLOCATABLE :: IAUXPR
COMPLEX, DIMENSION(:), ALLOCATABLE :: AUXDPR
COMPLEX, DIMENSION(:,:), ALLOCATABLE :: ONIMAT
!
!=======================================================================
!      INITIALISATION
!=======================================================================
!
C_ZERO=CMPLX(0.0D0,0.0D0)
C_UNIT=CMPLX(1.0D0,0.0D0)
UNIT_I=CMPLX(1.0D0,1.0D0)
!
ALLOCATE (ONIMAT(1:LUPPER,1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('ONIMAT','OVRONI')
!
ONIMAT(:,:)=C_ZERO
!
ALLOCATE (IAUXPR(1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('IAUXPR','OVRONI')
ALLOCATE (AUXDPR(1:LUPPER),STAT=IALLOC)
IF (IALLOC.NE.0) CALL NOALLO('AUXDPR','OVRONI')
!
!=======================================================================
!      COMPUTING THE PREFACTOR : SQRT(DET[(B')^T B^*])
!=======================================================================
!
DO ISTATE=1,LUPPER
   DO JSTATE=1,LUPPER
!
      DO IBASE=1,LDBASE
         DO ISPIN=0,1
!
            ONIMAT(ISTATE,JSTATE)=ONIMAT(ISTATE,JSTATE)                &
                                 +CONJG(WALEFT(IBASE,ISTATE,ISPIN))    &
                                       *WARIGH(IBASE,JSTATE,ISPIN)
!
         END DO
      END DO
!
   END DO
END DO
!
CALL ZGECO(ONIMAT,LUPPER,LUPPER,IAUXPR,RICOND,AUXDPR)
CALL ZGEDI(ONIMAT,LUPPER,LUPPER,IAUXPR,DETWRK,AUXDPR,10)
!
IF (ABS(RICOND).LT.1.0D-12)                                            &
   WRITE(*,*)  'BE CAREFUL - THE PRE-ONISHI MATRIX MAY BE SINGULAR'
!
!DPOWER=REAL(DETWRK(2))
!IF (ABS(MOD(DPOWER,2.0D0)).GT.1.0D-9) THEN
!    IF (DPOWER.LT.0.0D0) THEN
!       DETWRK(2)=DETWRK(2)+C_UNIT
!       DETWRK(1)=DETWRK(1)*0.1D0
!    ELSE
!       DETWRK(2)=DETWRK(2)-C_UNIT
!       DETWRK(1)=DETWRK(1)*10.0D0
!    END IF
!END IF
!
!ONIPRE(1)=DETWRK(1)
!ONIMOD=ABS(ONIPRE(1))
!ONIPHS=ATAN2(AIMAG(ONIPRE(1)),REAL(ONIPRE(1)))
!ONIPRE(1)=SQRT(ONIMOD)*EXP(UNIT_I*ONIPHS/2.0D0)
!ONIPRE(2)=DETWRK(2)/2.0D0
!
ONIPRE(1)=SQRT(DETWRK(1))
ONIPRE(2)=DETWRK(2)/2.0D0
!
DEALLOCATE (ONIMAT,IAUXPR,AUXDPR)
!
!=======================================================================
!      COMPUTING THE MAIN FACTOR SQRT(DET(OVRLAP)) THE DETERMINANT BEING
!      AN INPUT OF THE ROUTINE
!=======================================================================
!
DETWRK(:)=DETOVR(:)
!
!DPOWER=REAL(DETOVR(2))
!IF (ABS(MOD(DPOWER,2.0D0)).GT.1.0D-9) THEN
!    IF (DPOWER.LT.0.0D0) THEN
!        DETWRK(2)=DETOVR(2)+C_UNIT
!        DETWRK(1)=DETOVR(1)*0.1D0
!    ELSE
!        DETWRK(2)=DETOVR(2)-C_UNIT
!        DETWRK(1)=DETOVR(1)*10.0D0
!    END IF
!END IF
!
!ONIOVR(1)=DETWRK(1)
!ONIMOD=ABS(ONIOVR(1))
!ONIPHS=ATAN2(AIMAG(ONIOVR(1)),REAL(ONIOVR(1)))
!ONIOVR(1)=SQRT(ONIMOD)*EXP(UNIT_I*ONIPHS/2.0D0)
!ONIOVR(2)=DETWRK(2)/2.0D0
ONIOVR(1)=SQRT(DETWRK(1))
ONIOVR(2)=DETWRK(2)/2.0D0
!
!=======================================================================
!      COMPUTING THE NORM/OVERLAP
!=======================================================================
!
!SIGNPF=(-C_UNIT)**(LUPPER*(LUPPER-1)/2)
!
OVERLP(1)=PREPFA(1)*ONIPRE(1)*ONIOVR(1)
OVERLP(2)=PREPFA(2)+ONIPRE(2)+ONIOVR(2)
!
IF (AIMAG(OVERLP(2)).GT.1.0D-9) STOP 'OVERLP(2) CANNOT BE IMAGINARY'
!
END SUBROUTINE OVRONI
!
!=======================================================================
!=======================================================================
!
SUBROUTINE OVRMAT(LDBASE,LUPPER,WALEFT,WARIGH,OVRLAP)
!
INTEGER, INTENT(IN) :: LDBASE,LUPPER
COMPLEX, DIMENSION(1:NDBASE,1:4*NDSTAT,0:NDSPIN),                      &
                                         INTENT(IN) :: WALEFT, WARIGH
!
COMPLEX, DIMENSION(1:4*NDSTAT,1:4*NDSTAT), INTENT(OUT) :: OVRLAP
!
!=======================================================================
!     THIS SUBROUTINE COMPUTES THE MATRIX OF OVERLAPS BETWEEN THE QUASI-
!     PARTICLES OF LEFT AND RIGHT HFB STATES:
!            (A')^T A^* + (B')^T B^*
!=======================================================================
!
INTEGER :: ISTATE,ISTALO,JSTATE,JSTALO,ISPIN,IBASE
!
DO ISTATE=1,LUPPER
   ISTALO=ISTATE+LUPPER
!
   DO JSTATE=1,LUPPER
      JSTALO=JSTATE+LUPPER
!
      DO IBASE=1,LDBASE
         DO ISPIN=0,1
!
            OVRLAP(ISTATE,JSTATE)=OVRLAP(ISTATE,JSTATE)                &
                                 +CONJG(WALEFT(IBASE,ISTATE,ISPIN))    &
                                       *WARIGH(IBASE,JSTATE,ISPIN)     &
                                 +CONJG(WALEFT(IBASE,ISTALO,ISPIN))    &
                                       *WARIGH(IBASE,JSTALO,ISPIN)
!
         END DO
      END DO
!
   END DO
!
END DO
!
END SUBROUTINE OVRMAT
!
!=======================================================================
!=======================================================================
!
END MODULE OVRHFB
!
!=======================================================================
!=======================================================================
!=======================================================================
!=======================================================================
!=======================================================================
!=======================================================================
!
SUBROUTINE INIADD
!
!=======================================================================
!     MANAGE THE ALLOCATION OF THE ARRAYS USED FOR THE BLOCKING.
!=======================================================================
!
USE BLOSAV
USE hfodd_sizes
IMPLICIT NONE
INTEGER::IALLOC
COMPLEX::C_ZERO
!=======================================================================
!ALLOCATE SPACE TO ARRAY
!=======================================================================
!
 IALLOC=0
 C_ZERO=CMPLX(0.0D0,0.0D0)
!
 IF (.NOT.ALLOCATED(BLOLAB)) THEN
    ALLOCATE (BLOLAB(0:NDISOS,1:NDBLOC),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('BLOLAB','INIADD')
    BLOLAB(:,:)%IR=0
    BLOLAB(:,:)%N=0
 END IF
!
 IF (.NOT.ALLOCATED(WLABBR)) THEN
    ALLOCATE (WLABBR(0:NDISOS,1:NDBLOC),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('WLABBR','INIADD')
    WLABBR(:,:)=-1
 END IF
!
 IF (.NOT.ALLOCATED(WLABAR)) THEN
    ALLOCATE (WLABAR(0:NDISOS,1:NDBLOC),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('WLABAR','INIADD')
    WLABAR(:,:)=-1
 END IF

 IF (.NOT.ALLOCATED(WLABBL)) THEN
    ALLOCATE (WLABBL(0:NDISOS,1:NDBLOC),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('WLABBL','INIADD')
    WLABBL(:,:)=-1
 END IF
!
 IF (.NOT.ALLOCATED(WLABAL)) THEN
    ALLOCATE (WLABAL(0:NDISOS,1:NDBLOC),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('WLABAL','INIADD')
    WLABAL(:,:)=-1
 END IF

!
 IF (.NOT.ALLOCATED(LPRODR)) THEN
    ALLOCATE (LPRODR(0:NDISOS),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('LPRODR','INIADD')
    LPRODR(:)=0
 END IF
!
 IF (.NOT.ALLOCATED(LPRODL)) THEN
    ALLOCATE (LPRODL(0:NDISOS),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('LPRODL','INIADD')
    LPRODL(:)=0
 END IF
!
 IF (.NOT.ALLOCATED(LDBLOL)) THEN
    ALLOCATE (LDBLOL(0:NDISOS),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('LDBLOL','INIADD')
    LPRODL(:)=0
 END IF
!
 RETURN
END SUBROUTINE INIADD
!
!
!=======================================================================
!=======================================================================
!=======================================================================
!=======================================================================
!=======================================================================
!=======================================================================
!
MODULE O2AVRG
!
!=======================================================================
!      MODULE COMPUTING <o^2> FOR ONE-BODY OPERATORS O VARIOUS FORMS
!      THE ROUTINES AVRXSD, AVRXSO, EXCXSD, EXCXSO, PAIXSD, PAIXSO ARE
!      USED IN LIPCORR ONLY
!=======================================================================
!
CONTAINS
!=======================================================================
SUBROUTINE AVRXSD(HAUXIL,AOBSLI,AKBSLI,RHO_PP)
!=======================================================================
!Calculate Tr[x.rho], x=[x(0),0;0,x(1)]
!=======================================================================
USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 REAL   ::AOBSLI
 COMPLEX::AKBSLI
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::HAUXIL,RHO_PP
!
! INTEGER::INCX,INCY
! COMPLEX::RES1,RES2,ZDOTU
 INTEGER::IBRA,IKET
!
 INTEGER::LDBASE
 COMPLEX::RESULT,C_ZERO
!=======================================================================
 COMMON /DIMENS/ LDBASE
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
 RESULT=C_ZERO
!
 DO IBRA=1,LDBASE
    DO IKET=1,LDBASE
       RESULT=RESULT+HAUXIL(IBRA,IKET,0)*RHO_PP(IKET,IBRA,0)&
                    +HAUXIL(IBRA,IKET,1)*RHO_PP(IKET,IBRA,1)

    END DO
 END DO
 AOBSLI=REAL(RESULT)
 AKBSLI=RESULT
 !INCX=1; INCY=1
 !RES1=ZDOTU(NDBASE*NDBASE,HAUXIL(:,:,0),INCX,TRANSPOSE(RHO_PP(:,:,0)),INCY)
 !RES2=ZDOTU(NDBASE*NDBASE,HAUXIL(:,:,1),INCX,TRANSPOSE(RHO_PP(:,:,0)),INCY)
 !AOBSLI=REAL(RES1+RES2)
 !AKBSLI=RES1+RES2
!=======================================================================
 RETURN
END SUBROUTINE AVRXSD
!=======================================================================
SUBROUTINE AVRXSO(HAUXIL,AOBSLI,AKBSLI,RHO_PM)
!=======================================================================
! Calculate Tr[x.rho], x=[0,x(0);x(1),0]
!=======================================================================
USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 REAL   ::AOBSLI
 COMPLEX::AKBSLI
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::HAUXIL,RHO_PM
!
! INTEGER::INCX,INCY
! COMPLEX::RES1,RES2,ZDOTU
 INTEGER::IBRA,IKET
 COMPLEX::RESULT,C_ZERO
!
 INTEGER::LDBASE
 COMMON /DIMENS/ LDBASE
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
 RESULT=C_ZERO
!
 DO IBRA=1,LDBASE
    DO IKET=1,LDBASE
       RESULT=RESULT+HAUXIL(IBRA,IKET,0)*RHO_PM(IKET,IBRA,1)&
                    +HAUXIL(IBRA,IKET,1)*RHO_PM(IKET,IBRA,0)
    END DO
 END DO
 AOBSLI=REAL(RESULT)
 AKBSLI=RESULT
 !INCX=1; INCY=1
 !RES1=ZDOTU(NDBASE*NDBASE,HAUXIL(:,:,0),INCX,TRANSPOSE(RHO_PM(:,:,1)),INCY)
 !RES2=ZDOTU(NDBASE*NDBASE,HAUXIL(:,:,1),INCX,TRANSPOSE(RHO_PM(:,:,0)),INCY)
 !AOBSLI=REAL(RES1+RES2)
 !AKBSLI=RES1+RES2
!=======================================================================
 RETURN
END SUBROUTINE AVRXSO
!=======================================================================
SUBROUTINE EXCXSD(IMSIGN,MREVER,ISIMPY,JETKET,EOBSSQ,EKBSSQ,XMAT,RPP,RPM,APP,APM)
!=======================================================================
!Tr[(x.rho)^2], x=[x(0),0;0,x(1)]
!=======================================================================
USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::IMSIGN,MREVER,ISIMPY,JETKET
 REAL   ::EOBSSQ
 COMPLEX::EKBSSQ
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::XMAT,RPP
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE),OPTIONAL::RPM,APP,APM
!
 INTEGER::IREVER
 COMPLEX::C_ZERO,RESULT,C_UNIT,CTWO
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::AUXILI
!
! INTEGER::INCX,INCY
! COMPLEX::RES1,RES2,ZDOTU
 INTEGER::IBRA,IKET
!
 INTEGER::LDBASE
 COMMON /DIMENS/ LDBASE
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
 IF(JETKET.EQ.2) THEN
                    APP(1:NDBASE,1:NDBASE,0:NDREVE)=C_ZERO
    IF(ISIMPY.EQ.0) APM(1:NDBASE,1:NDBASE,0:NDREVE)=C_ZERO
 END IF
!=======================================================================
!X.RHO
!=======================================================================
 C_UNIT=CMPLX(1.0D0,0.0D0)
 DO IREVER=0,MREVER
    AUXILI(:,:,IREVER) = C_ZERO
    CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                       C_UNIT,XMAT(:,:,IREVER),NDBASE, &
                       RPP(:,:,IREVER),NDBASE,C_ZERO,AUXILI(:,:,IREVER),NDBASE)
 END DO
!=======================================================================
!TR[(X.RHO)^2] AND 2(X.RHO.X)_{IJ}
!======================================================================
 RESULT=C_ZERO
! INCX=1; INCY=1
 DO IREVER=0,MREVER
!    RESULT=RESULT+ZDOTU(NDBASE*NDBASE,AUXILI(:,:,IREVER),INCX,TRANSPOSE(AUXILI(:,:,IREVER)),INCY)
    DO IBRA=1,LDBASE
       DO IKET=1,LDBASE
          RESULT=RESULT+AUXILI(IBRA,IKET,IREVER)*AUXILI(IKET,IBRA,IREVER)
       END DO
    END DO
    IF (JETKET.EQ.2) THEN
        CTWO=CMPLX(-2.0D0,0.0D0)
        CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                           CTWO,AUXILI(:,:,IREVER),NDBASE, &
                           XMAT(:,:,IREVER),NDBASE,C_ZERO,APP(:,:,IREVER),NDBASE)
    END IF
 END DO
 !
 IF (MREVER.EQ.0) THEN
    RESULT=RESULT+CONJG(RESULT)*(IMSIGN**2)
    IF(JETKET.EQ.2) APP(:,:,1)=CONJG(APP(:,:,0))*(IMSIGN**2)
 END IF
 !
 EOBSSQ = REAL(RESULT)
 EKBSSQ = RESULT
 !
!=======================================================================
!ADDITIONAL TERMS WHEN SIMPLEX IS NOT CONSERVED
!=======================================================================
 IF (ISIMPY.NE.1) THEN
!=======================================================================
!X.RHO
!=======================================================================
    C_UNIT=CMPLX(1.0D0,0.0D0); AUXILI = C_ZERO
    CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                       C_UNIT,XMAT(:,:,0),NDBASE, &
                       RPM(:,:,0),NDBASE,C_ZERO,AUXILI(:,:,0),NDBASE)
    CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                       C_UNIT,XMAT(:,:,1),NDBASE, &
                       RPM(:,:,1),NDBASE,C_ZERO,AUXILI(:,:,1),NDBASE)
!=======================================================================
!TR[(X.RHO)^2] AND (X.RHO.X)_{IJ}
!=======================================================================
!    INCX=1; INCY=1
!    RESULT=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,0),INCX,TRANSPOSE(AUXILI(:,:,1)),INCY)
    RESULT=C_ZERO
    DO IBRA=1,LDBASE
       DO IKET=1,LDBASE
          RESULT=RESULT+AUXILI(IBRA,IKET,0)*AUXILI(IKET,IBRA,1)
       END DO
    END DO
    IF (JETKET.EQ.2) THEN
        IF (MREVER.EQ.0) STOP ' WRONG MREVER IN EXCXSD'
        CTWO=CMPLX(-2.0D0,0.0D0)
        CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                           CTWO,AUXILI(:,:,0),NDBASE, &
                           XMAT(:,:,1),NDBASE,C_ZERO,APM(:,:,0),NDBASE)
        CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                           CTWO,AUXILI(:,:,1),NDBASE, &
                           XMAT(:,:,0),NDBASE,C_ZERO,APM(:,:,1),NDBASE)
    END IF
    !
    RESULT=2*RESULT
    !
    EOBSSQ = EOBSSQ + REAL(RESULT)
    EKBSSQ = EKBSSQ + RESULT
    !
 END IF
!======================================================================
 RETURN
 END SUBROUTINE EXCXSD
!=======================================================================
SUBROUTINE EXCXSO(IMSIGN,MREVER,ISIMPY,JETKET,EOBSSQ,EKBSSQ,XMAT,RPP,RPM,APP,APM)
!=======================================================================
! Tr[(x.rho)^2], x=[0,x(0);x(1),0]
!=======================================================================
USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::IMSIGN,MREVER,ISIMPY,JETKET
 REAL   ::EOBSSQ
 COMPLEX::EKBSSQ
 COMPLEX::C_ZERO,RESULT,C_UNIT,CTWO
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::XMAT,RPP
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE),OPTIONAL::RPM,APP,APM
!
 INTEGER::IREVER
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::AUXILI
!
! INTEGER::INCX,INCY
! COMPLEX::RES1,RES2,ZDOTU
 INTEGER::IBRA,IKET
!
 INTEGER::LDBASE
 COMMON /DIMENS/ LDBASE
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
  IF(JETKET.EQ.2)THEN
                    APP(1:NDBASE,1:NDBASE,0:NDREVE)=C_ZERO
    IF(ISIMPY.EQ.0) APM(1:NDBASE,1:NDBASE,0:NDREVE)=C_ZERO
 END IF
!=======================================================================
!X.RHO
!=======================================================================
 C_UNIT=CMPLX(1.0D0,0.0D0); AUXILI = C_ZERO
 DO IREVER=0,MREVER
    CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                       C_UNIT,XMAT(:,:,1-IREVER),NDBASE, &
                       RPP(:,:,IREVER),NDBASE,C_ZERO,AUXILI(:,:,IREVER),NDBASE)
 END DO
 IF (MREVER.EQ.0) THEN
    AUXILI(:,:,1)=CONJG(AUXILI(:,:,0))*IMSIGN
 END IF
!=======================================================================
!TR[(X.RHO)^2] AND 2(X.RHO.X)
!=======================================================================
! INCX=1; INCY=1
! RESULT=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,1),INCX,TRANSPOSE(AUXILI(:,:,0)),INCY)
    RESULT=C_ZERO
    DO IBRA=1,LDBASE
       DO IKET=1,LDBASE
          RESULT=RESULT+AUXILI(IBRA,IKET,1)*AUXILI(IKET,IBRA,0)
       END DO
    END DO
 IF (JETKET.EQ.2) THEN
     CTWO=CMPLX(-2.0D0,0.0D0)
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        CTWO,AUXILI(:,:,1),NDBASE, &
                        XMAT(:,:,1),NDBASE,C_ZERO,APP(:,:,0),NDBASE)
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        CTWO,AUXILI(:,:,0),NDBASE, &
                        XMAT(:,:,0),NDBASE,C_ZERO,APP(:,:,1),NDBASE)
 END IF
 !
 EOBSSQ = 2*REAL(RESULT)
 EKBSSQ = 2*RESULT
 !
!=======================================================================
!ADDITIONAL TERMS WHEN SIMPLEX IS NOT CONSERVED
!=======================================================================
 IF (ISIMPY.NE.1) THEN
!=======================================================================
!X.RHO
!=======================================================================
     C_UNIT=CMPLX(1.0D0,0.0D0); AUXILI = C_ZERO
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,1),NDBASE, &
                        RPM(:,:,0),NDBASE,C_ZERO,AUXILI(:,:,0),NDBASE)
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,0),NDBASE, &
                        RPM(:,:,1),NDBASE,C_ZERO,AUXILI(:,:,1),NDBASE)
!=======================================================================
!TR[(X.RHO)^2] AND (X.RHO.X)_{IJ}
!=======================================================================
!     INCX=1; INCY=1
!     RES1=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,0),INCX,TRANSPOSE(AUXILI(:,:,0)),INCY)
!     RES2=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,1),INCX,TRANSPOSE(AUXILI(:,:,1)),INCY)
!     RESULT=RES1+RES2
     RESULT=C_ZERO
     DO IBRA=1,LDBASE
        DO IKET=1,LDBASE
           RESULT=RESULT+AUXILI(IBRA,IKET,0)*AUXILI(IKET,IBRA,0)&
                        +AUXILI(IBRA,IKET,1)*AUXILI(IKET,IBRA,1)
        END DO
     END DO
     IF (JETKET.EQ.2) THEN
         CTWO=CMPLX(-2.0D0,0.0D0)
         CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                            CTWO,AUXILI(:,:,1),NDBASE, &
                            XMAT(:,:,0),NDBASE,C_ZERO,APM(:,:,0),NDBASE)
         CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                            CTWO,AUXILI(:,:,0),NDBASE, &
                            XMAT(:,:,1),NDBASE,C_ZERO,APM(:,:,1),NDBASE)
     END IF
     !
     EOBSSQ = EOBSSQ + REAL(RESULT)
     EKBSSQ = EKBSSQ + RESULT
     !
 END IF
!=======================================================================
 RETURN
END SUBROUTINE EXCXSO
!=======================================================================
SUBROUTINE PAIXSD(MREVER,ISIMPY,JETKET,POBSSQ,PKBSSQ,XMAT,KPM1,KPM2,KPP1,KPP2,PPM,PPP)
!=======================================================================
! Tr[(X.kappa)(X.kappa')*] x=[x(0),0;0,x(1)]
!=======================================================================
USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::MREVER,ISIMPY,JETKET
 REAL   ::POBSSQ
 COMPLEX::PKBSSQ
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::XMAT,KPM1,KPM2
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE),OPTIONAL::KPP1,KPP2,PPM,PPP
!
 INTEGER::IREVER
 COMPLEX::C_ZERO,RESULT,C_UNIT,CTWO
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::AUXILI
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::AUXIL2
!
! INTEGER::INCX,INCY
! COMPLEX::RES1,RES2,ZDOTU
 INTEGER::IBRA,IKET
!
 INTEGER::LDBASE
 COMMON /DIMENS/ LDBASE
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
 IF(JETKET.EQ.2)THEN
                    PPM(1:NDBASE,1:NDBASE,0:NDREVE)=C_ZERO
    IF(ISIMPY.EQ.0) PPP(1:NDBASE,1:NDBASE,0:NDREVE)=C_ZERO
 END IF
!=======================================================================
!X.KAPPA AND X.KAPPA'
!=======================================================================
 C_UNIT=CMPLX(1.0D0,0.0D0); AUXILI = C_ZERO
 CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                    C_UNIT,XMAT(:,:,0),NDBASE, &
                    KPM1(:,:,0),NDBASE,C_ZERO,AUXILI(:,:,0),NDBASE)
 C_UNIT=CMPLX(-1.0D0,0.0D0)
 CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                    C_UNIT,XMAT(:,:,1),NDBASE, &
                    KPM1(:,:,0),NDBASE,C_ZERO,AUXILI(:,:,1),NDBASE)
 C_UNIT=CMPLX(1.0D0,0.0D0); AUXIL2 = C_ZERO
 CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                    C_UNIT,XMAT(:,:,0),NDBASE, &
                    KPM2(:,:,0),NDBASE,C_ZERO,AUXIL2(:,:,0),NDBASE)
 C_UNIT=CMPLX(-1.0D0,0.0D0)
 CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                    C_UNIT,XMAT(:,:,1),NDBASE, &
                    KPM2(:,:,0),NDBASE,C_ZERO,AUXIL2(:,:,1),NDBASE)
!=======================================================================
!TR[(X.KAPPA)(X.KAPPA')*] AND 2[X.KAPPA.X']
!=======================================================================
! INCX=1; INCY=1
! RES1=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,0),INCX,CONJG(TRANSPOSE(AUXIL2(:,:,1))),INCY)
! RES2=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,1),INCX,CONJG(TRANSPOSE(AUXIL2(:,:,0))),INCY)
! RESULT=RES1+RES2
 RESULT=C_ZERO
 DO IBRA=1,LDBASE
    DO IKET=1,LDBASE
       RESULT=RESULT+AUXILI(IBRA,IKET,0)*CONJG(AUXIL2(IKET,IBRA,1))&
                    +AUXILI(IBRA,IKET,1)*CONJG(AUXIL2(IKET,IBRA,0))
    END DO
 END DO
 IF (JETKET.EQ.2) THEN
     CTWO=CMPLX(2.0D0,0.0D0)
     CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                        CTWO,AUXILI(:,:,1),NDBASE, &
                        XMAT(:,:,0),NDBASE,C_ZERO,PPM(:,:,1),NDBASE)
     CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                        CTWO,AUXILI(:,:,0),NDBASE, &
                        XMAT(:,:,1),NDBASE,C_ZERO,PPM(:,:,0),NDBASE)
 END IF
!=======================================================================
!    attention: before version 11 and 278h, the two IREVER components
!               above where exchanged, which did not conform  to  the
!               standard of defining arrays PLINPM and PROTPM.
!               This bug was corrected on 06/12/2016
!=======================================================================
 !
 POBSSQ = -REAL(RESULT)
 PKBSSQ = -RESULT
 !
!=======================================================================
!ADDITIONAL TERMS WHEN SIMPLEX IS NOT CONSERVED
!=======================================================================
 IF (ISIMPY.NE.1) THEN
!=======================================================================
!X.KAPPA
!=======================================================================
     C_UNIT=CMPLX(1.0D0,0.0D0)
     AUXILI = C_ZERO
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,0),NDBASE, &
                        KPP1(:,:,0),NDBASE,C_ZERO,AUXILI(:,:,0),NDBASE)
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,1),NDBASE, &
                        KPP1(:,:,1),NDBASE,C_ZERO,AUXILI(:,:,1),NDBASE)
     AUXIL2 = C_ZERO
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,0),NDBASE, &
                        KPP2(:,:,0),NDBASE,C_ZERO,AUXIL2(:,:,0),NDBASE)
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,1),NDBASE, &
                        KPP2(:,:,1),NDBASE,C_ZERO,AUXIL2(:,:,1),NDBASE)
!=======================================================================
!TR[(X.KAPPA)(X.KAPPA')*] AND 2[X.KAPPA.X]
!=======================================================================
!     INCX=1; INCY=1
!     RES1=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,0),INCX,CONJG(TRANSPOSE(AUXIL2(:,:,0))),INCY)
!     RES2=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,1),INCX,CONJG(TRANSPOSE(AUXIL2(:,:,1))),INCY)
!     RESULT=RES1+RES2
     RESULT=C_ZERO
     DO IBRA=1,LDBASE
        DO IKET=1,LDBASE
           RESULT=RESULT+AUXILI(IBRA,IKET,0)*CONJG(AUXIL2(IKET,IBRA,0))&
                        +AUXILI(IBRA,IKET,1)*CONJG(AUXIL2(IKET,IBRA,1))
        END DO
     END DO
     IF (JETKET.EQ.2) THEN
         CTWO=CMPLX(2.0D0,0.0D0)
         CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                            CTWO,AUXILI(:,:,0),NDBASE, &
                            XMAT(:,:,0),NDBASE,C_ZERO,PPP(:,:,0),NDBASE)
         CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                            CTWO,AUXILI(:,:,1),NDBASE, &
                            XMAT(:,:,1),NDBASE,C_ZERO,PPP(:,:,1),NDBASE)
     END IF
     !
     POBSSQ = POBSSQ - REAL(RESULT)
     PKBSSQ = PKBSSQ - RESULT
     !
 END IF
!=======================================================================
 RETURN
END SUBROUTINE PAIXSD
!=======================================================================
SUBROUTINE PAIXSO(MREVER,ISIMPY,JETKET,POBSSQ,PKBSSQ,XMAT,KPM1,KPM2,KPP1,KPP2,PPM,PPP)
!=======================================================================
! Tr[(X.kappa)(X.kappa')*] x=[0,x(0);x(1),0]
!=======================================================================
USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::MREVER,ISIMPY,JETKET
 REAL   ::POBSSQ
 COMPLEX::PKBSSQ
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::XMAT,KPM1,KPM2
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE),OPTIONAL::KPP1,KPP2,PPM,PPP
!
 INTEGER::IREVER
 COMPLEX::C_ZERO,RESULT,C_UNIT,CTWO
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::AUXILI
 COMPLEX,DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE)::AUXIL2
!
! INTEGER::INCX,INCY
! COMPLEX::RES1,RES2,ZDOTU
 INTEGER::IBRA,IKET
!
 INTEGER::LDBASE
 COMMON /DIMENS/ LDBASE
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
 IF(JETKET.EQ.2)THEN
                    PPM(1:NDBASE,1:NDBASE,0:NDREVE)=C_ZERO
    IF(ISIMPY.EQ.0) PPP(1:NDBASE,1:NDBASE,0:NDREVE)=C_ZERO
 END IF
!=======================================================================
!X.KAPPA AND X.KAPPA'
!=======================================================================
 C_UNIT=CMPLX(1.0D0,0.0D0); AUXILI = C_ZERO
 CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                    C_UNIT,XMAT(:,:,0),NDBASE, &
                    KPM1(:,:,1),NDBASE,C_ZERO,AUXILI(:,:,0),NDBASE)
 C_UNIT=CMPLX(-1.0D0,0.0D0)
 CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                    C_UNIT,XMAT(:,:,1),NDBASE, &
                    KPM1(:,:,1),NDBASE,C_ZERO,AUXILI(:,:,1),NDBASE)
 C_UNIT=CMPLX(1.0D0,0.0D0); AUXIL2 = C_ZERO
 CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                    C_UNIT,XMAT(:,:,0),NDBASE, &
                    KPM2(:,:,1),NDBASE,C_ZERO,AUXIL2(:,:,0),NDBASE)
 C_UNIT=CMPLX(-1.0D0,0.0D0)
 CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                    C_UNIT,XMAT(:,:,1),NDBASE, &
                    KPM2(:,:,1),NDBASE,C_ZERO,AUXIL2(:,:,1),NDBASE)
!=======================================================================
!TR[(X.KAPPA)(X.KAPPA')*] AND 2[X.KAPPA.X']
!=======================================================================
! INCX=1; INCY=1
! RES1=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,0),INCX,CONJG(TRANSPOSE(AUXIL2(:,:,0))),INCY)
! RES2=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,1),INCX,CONJG(TRANSPOSE(AUXIL2(:,:,1))),INCY)
! RESULT=RES1+RES2
 RESULT=C_ZERO
 DO IBRA=1,LDBASE
    DO IKET=1,LDBASE
       RESULT=RESULT+AUXILI(IBRA,IKET,0)*CONJG(AUXIL2(IKET,IBRA,0))&
                    +AUXILI(IBRA,IKET,1)*CONJG(AUXIL2(IKET,IBRA,1))
    END DO
 END DO
 IF (JETKET.EQ.2) THEN
     CTWO=CMPLX(2.0D0,0.0D0)
     CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                        CTWO,AUXILI(:,:,1),NDBASE, &
                        XMAT(:,:,0),NDBASE,C_ZERO,PPM(:,:,1),NDBASE)
     CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                        CTWO,AUXILI(:,:,0),NDBASE, &
                        XMAT(:,:,1),NDBASE,C_ZERO,PPM(:,:,0),NDBASE)
 END IF
!=======================================================================
!    attention: before version 11 and 278h, the two IREVER components
!               above where exchanged, which did not conform  to  the
!               standard of defining arrays PLINPM and PROTPM.
!               This bug was corrected on 06/12/2016
!=======================================================================
 !
 POBSSQ = -REAL(RESULT)
 PKBSSQ = -RESULT
 !
!=======================================================================
!ADDITIONAL TERMS WHEN SIMPLEX IS NOT CONSERVED
!=======================================================================
 IF (ISIMPY.NE.1) THEN
!=======================================================================
!X.KAPPA AND X.KAPPA'
!=======================================================================
     C_UNIT=CMPLX(1.0D0,0.0D0)
     AUXILI = C_ZERO
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,1),NDBASE, &
                        KPP1(:,:,0),NDBASE,C_ZERO,AUXILI(:,:,0),NDBASE)
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,0),NDBASE, &
                        KPP1(:,:,1),NDBASE,C_ZERO,AUXILI(:,:,1),NDBASE)
     AUXIL2 = C_ZERO
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,1),NDBASE, &
                        KPP2(:,:,0),NDBASE,C_ZERO,AUXIL2(:,:,0),NDBASE)
     CALL ZGEMM('N','N',LDBASE,LDBASE,LDBASE, &
                        C_UNIT,XMAT(:,:,0),NDBASE, &
                        KPP2(:,:,1),NDBASE,C_ZERO,AUXIL2(:,:,1),NDBASE)
!=======================================================================
!TR[(X.KAPPA)(X.KAPPA')*] AND 2[X.KAPPA.X]
!=======================================================================
!     INCX=1; INCY=1
!     RES1=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,1),INCX,CONJG(TRANSPOSE(AUXIL2(:,:,0))),INCY)
!     RES2=ZDOTU(NDBASE*NDBASE,AUXILI(:,:,0),INCX,CONJG(TRANSPOSE(AUXIL2(:,:,1))),INCY)
!     RESULT=RES1+RES2
     RESULT=C_ZERO
     DO IBRA=1,LDBASE
        DO IKET=1,LDBASE
           RESULT=RESULT+AUXILI(IBRA,IKET,1)*CONJG(AUXIL2(IKET,IBRA,0))&
                        +AUXILI(IBRA,IKET,0)*CONJG(AUXIL2(IKET,IBRA,1))
        END DO
     END DO
     IF (JETKET.EQ.2) THEN
         CTWO=CMPLX(2.0D0,0.0D0)
         CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                            CTWO,AUXILI(:,:,1),NDBASE, &
                            XMAT(:,:,0),NDBASE,C_ZERO,PPP(:,:,0),NDBASE)
         CALL ZGEMM('N','T',LDBASE,LDBASE,LDBASE, &
                            CTWO,AUXILI(:,:,0),NDBASE, &
                            XMAT(:,:,1),NDBASE,C_ZERO,PPP(:,:,1),NDBASE)
     END IF
     !
     POBSSQ = POBSSQ - REAL(RESULT)
     PKBSSQ = PKBSSQ - RESULT
     !
 END IF
!=======================================================================
 RETURN
END SUBROUTINE PAIXSO
!=======================================================================
END MODULE O2AVRG
!
!=======================================================================
!=======================================================================
!
!
MODULE OFFDIA
!
!=======================================================================
!      MODULE CONTAINING MANY ROUTINES USED IN THE NEXT ROUTINES BELOW
!      AND THAT COMPUTES MASS AND INERTIA RENORMALIZATION
!=======================================================================
!
!routines to calculate transformation matrix, transformed wave function or energy kernal
USE hfodd_sizes
COMPLEX,ALLOCATABLE::VRVAUX(:,:),URUAUX(:,:)
!
CONTAINS
SUBROUTINE WLRMAT(IHFB,LDBASE,LUPPER,WALEFT,WARIGH,OVRV,OVRU)
!CALCULATE OVRLAP MATRIX FROM WL, WR
IMPLICIT NONE
 INTEGER::IHFB,LDBASE,LUPPER
 COMPLEX,DIMENSION(1:NDBASE,1:4*NDSTAT,0:NDSPIN)::WALEFT,WARIGH
 COMPLEX,DIMENSION(1:LUPPER,1:LUPPER)::OVRV
 COMPLEX,DIMENSION(1:LUPPER,1:LUPPER),OPTIONAL::OVRU
!
 COMPLEX::C_ZERO,C_UNIT
!
 C_ZERO=CMPLX(0.0D0,0.0D0)
 C_UNIT=CMPLX(1.0D0,0.0D0)
!
 CALL ZGEMM('C','N',LUPPER,LUPPER,LDBASE,C_UNIT,&
             WALEFT(1:LDBASE,1:LUPPER,0),LDBASE,&
             WARIGH(1:LDBASE,1:LUPPER,0),LDBASE,C_ZERO,OVRV,LUPPER)
!
 CALL ZGEMM('C','N',LUPPER,LUPPER,LDBASE,C_UNIT,&
             WALEFT(1:LDBASE,1:LUPPER,1),LDBASE,&
             WARIGH(1:LDBASE,1:LUPPER,1),LDBASE,C_UNIT,OVRV,LUPPER)
!
 IF(IHFB.GE.1)THEN
    CALL ZGEMM('C','N',LUPPER,LUPPER,LDBASE,C_UNIT,&
                WALEFT(1:LDBASE,1+LUPPER:2*LUPPER,0),LDBASE,&
                WARIGH(1:LDBASE,1+LUPPER:2*LUPPER,0),LDBASE,C_ZERO,OVRU,LUPPER)
!
    CALL ZGEMM('C','N',LUPPER,LUPPER,LDBASE,C_UNIT,&
                WALEFT(1:LDBASE,1+LUPPER:2*LUPPER,1),LDBASE,&
                WARIGH(1:LDBASE,1+LUPPER:2*LUPPER,1),LDBASE,C_UNIT,OVRU,LUPPER)
 ENDIF
!
 RETURN
END SUBROUTINE WLRMAT
!=======================================================================
SUBROUTINE MAT_WR(IHFB,LDBASE,LUPPER,OVRLAP,WARIGH)
IMPLICIT NONE
 INTEGER::IHFB,LDBASE,LUPPER
 COMPLEX,DIMENSION(1:NDBASE,1:4*NDSTAT,0:NDSPIN)::WARIGH
 COMPLEX,DIMENSION(1:LUPPER,1:LUPPER)::OVRLAP
!
 INTEGER::ISPIN
 COMPLEX::C_UNIT,C_ZERO
 COMPLEX,ALLOCATABLE::WARNEW(:,:)
!
 C_ZERO=CMPLX(0.0D0,0.0D0)
 C_UNIT=CMPLX(1.0D0,0.0D0)
 ALLOCATE(WARNEW(1:LDBASE,1:LUPPER))

 DO ISPIN=0,NDSPIN
    CALL ZGEMM('N','N',LDBASE,LUPPER,LUPPER,C_UNIT,&
             WARIGH(1:LDBASE,1:LUPPER,ISPIN),LDBASE,&
             OVRLAP(1:LUPPER,1:LUPPER),      LUPPER,&
             C_ZERO,WARNEW,LDBASE)
    WARIGH(1:LDBASE,1:LUPPER,ISPIN)=WARNEW(1:LDBASE,1:LUPPER)
!
    IF(IHFB.GE.1)THEN
       CALL ZGEMM('N','N',LDBASE,LUPPER,LUPPER,C_UNIT,&
                WARIGH(1:LDBASE,1+LUPPER:2*LUPPER,ISPIN),LDBASE,&
                OVRLAP(1:LUPPER,1       :  LUPPER),      LUPPER,&
                C_ZERO,WARNEW,LDBASE)
       WARIGH(1:LDBASE,1+LUPPER:2*LUPPER,ISPIN)=WARNEW(1:LDBASE,1:LUPPER)
    ENDIF
 ENDDO
 DEALLOCATE(WARNEW)
 RETURN
END SUBROUTINE MAT_WR
!=======================================================================
SUBROUTINE RMATCN(MREVER,ISIMPY,LDBASE,LTIMUP,LUPPER,LTOTAL,INROTA,ICHARG,&
                  RMATRX,RMAINV,WALEFT,WARIGH)
!=======================================================================
! RETURN ROTATION MATRIX FOR UPPER AND LOWER BLOCK IN CANONICAL
! BASIS, THE LATTER WILL BE INVERSED LATER
!=======================================================================
USE CANBAS
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::MREVER,ISIMPY,LDBASE,LTIMUP,LUPPER,LTOTAL,INROTA,ICHARG
 COMPLEX,DIMENSION(1:LUPPER,1:LUPPER)::RMATRX, RMAINV
 COMPLEX,DIMENSION(1:NDBASE,1:4*NDSTAT,0:NDSPIN)::WALEFT,WARIGH
!
 INTEGER:: JSTATE,ISTATE,IREVER,ISPIN,IBASE
 COMPLEX::C_ZERO!,AVRCMB,AVRCMA
!
 INTEGER::NUMBQP
 COMPLEX::PHASPI
 COMMON /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN,1:NDTWCE)
 COMMON /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
!=======================================================================
 CALL CPUTIM('RMATCN',1)
!=======================================================================
 IF(ISIMPY.EQ.0) STOP 'NEED ISIMPY=1 IN RMATCN'
 C_ZERO=CMPLX(0.0D0,0.0D0)
 WALEFT(:,:,:)=C_ZERO
!=======================================================================
 JSTATE=0
 DO IREVER=0,MREVER
    DO ISTATE=1,LTIMUP
       JSTATE=JSTATE+1
       DO ISPIN=0,NDSPIN
!D FOR UPPER BLOCK
          WALEFT(1:LDBASE,JSTATE,ISPIN)=&
          WAVCAN(1:LDBASE,ISTATE,IREVER,ICHARG)*PHASPI(1:LDBASE,IREVER,ISPIN,1)
!D FOR LOWER BLOCK
          WALEFT(1:LDBASE,JSTATE+LUPPER,ISPIN)=(2*ISPIN-1)*&
          CONJG(WAVCAN(1:LDBASE,ISTATE,1-IREVER,ICHARG)*PHASPI(1:LDBASE,1-IREVER,1-ISPIN,1))
       END DO
    END DO
 END DO
! RD
 WARIGH(:,:,:)=WALEFT(:,:,:)
 IF(INROTA.NE.0) CALL ROTWAV(LTOTAL,WARIGH)
! DRD
 RMATRX(:,:)=C_ZERO
 RMAINV(:,:)=C_ZERO
!
 CALL WLRMAT(1,LDBASE,LUPPER,WALEFT,WARIGH,RMATRX,RMAINV)

!(rotated) wavefunction
 JSTATE=0
 DO IREVER=0,MREVER
    DO ISTATE=1,LTIMUP
       JSTATE=JSTATE+1
       DO ISPIN=0,NDSPIN
!
          WALEFT(1:LDBASE,JSTATE,ISPIN)&
         =V_CAN(ISTATE,IREVER,ICHARG)*WALEFT(1:LDBASE,JSTATE,ISPIN)
          WALEFT(1:LDBASE,JSTATE+LUPPER,ISPIN)&
         =U_CAN(ISTATE,1-IREVER,ICHARG)*WALEFT(1:LDBASE,JSTATE+LUPPER,ISPIN)
!
          WARIGH(1:LDBASE,JSTATE,ISPIN)&
         =V_CAN(ISTATE,IREVER,ICHARG)*WARIGH(1:LDBASE,JSTATE,ISPIN)
          WARIGH(1:LDBASE,JSTATE+LUPPER,ISPIN)&
         =U_CAN(ISTATE,1-IREVER,ICHARG)*WARIGH(1:LDBASE,JSTATE+LUPPER,ISPIN)
          END DO
    END DO
 END DO

!=======================================================================
 CALL CPUTIM('RMATCN',0)
!=======================================================================
 RETURN
END SUBROUTINE RMATCN
!=======================================================================
SUBROUTINE VRVMAT(MREVER,ISIMPY,LDBASE,LTIMUP,LUPPER,ICHARG, RMAT_V,RMAT_U,OVRLAP)
!=======================================================================
! calculate V*R_V*V+U*CONJG(TRANSPOSE(R_U))*U matrix in canonical basis.
!=======================================================================
USE CANBAS
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::MREVER,ISIMPY,LDBASE,LUPPER,LTIMUP,INROTA,ICHARG
 COMPLEX,DIMENSION(1:LUPPER,1:LUPPER)::OVRLAP,RMAT_V,RMAT_U
!
 INTEGER::JSTATE,ISTATE,JREVER,IREVER,IBRA,JKET,ISPIN,IBASE
 COMPLEX::C_ZERO,AVRCMP
!
 INTEGER::NUMBQP
 COMPLEX::PHASPI
 COMMON /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN,1:NDTWCE)
 COMMON /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
!=======================================================================
 CALL CPUTIM('VRVMAT',1)
!=======================================================================
 IF(ISIMPY.EQ.0) STOP 'NEED ISIMPY=1 IN VRVMAT'
 C_ZERO=CMPLX(0.0D0,0.0D0)
!=======================================================================
 OVRLAP(:,:)=C_ZERO
! CALCULATE URU+VRV
 DO IREVER=0,MREVER!SIMPLEX BLOCK OF LEFT V,U
    DO JREVER=0,MREVER!SIMPLEX BLOCK OF RIGHT V,U
       DO ISTATE=1,LTIMUP
          DO JSTATE=1,LTIMUP
             IBRA=ISTATE+IREVER*LTIMUP!THE LABEL OF R_U,R_V, IT CAN HAVE OFF DIAGONAL PART SINCE ROTATION CAN BREAK SIMPLEX
             JKET=JSTATE+JREVER*LTIMUP
             AVRCMP=V_CAN(ISTATE,IREVER,ICHARG)*RMAT_V(IBRA,JKET)*V_CAN(JSTATE,JREVER,ICHARG)&
                             +U_CAN(ISTATE,1-IREVER,ICHARG)*CONJG(RMAT_U(JKET,IBRA))*U_CAN(JSTATE,1-JREVER,ICHARG)
             OVRLAP(IBRA,JKET)=AVRCMP
          ENDDO
       ENDDO
    ENDDO
 ENDDO
!=======================================================================
      CALL CPUTIM('VRVMAT',0)
!=======================================================================
 RETURN
END SUBROUTINE VRVMAT
!=======================================================================
SUBROUTINE ROTWLR(MREVER,ISIMPY,ICANON,IDOGOA,IPAHFB,INROTA,IEXTEN,LDBASE,LTIMUP,LUPPER,LTOTAL,ICHARG,OVKERN)
!=======================================================================
!CALCULATE B.OVERLAP^-1,A.OVERLAP^-1 IN ROTATIONAL CASE
!ICANON>1 ONLY WHEN ISIMPY=1
!=======================================================================
USE SAVLEF
USE SAVRIG
USE WAVR_L
!USE PFAFFI, ONLY:NORM_N,VUAUX,LV2AUX,PV2AUX
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::MREVER,ISIMPY,ICANON,IDOGOA,IPAHFB,INROTA,IEXTEN,LDBASE,LTIMUP,LUPPER,LTOTAL,ICHARG
 COMPLEX::OVKERN
!
 INTEGER::IALLOC,ISTATE,JSTATE,KSTATE,ISPIN,IBASE,SIGNS,IFLAG,SIGV2,IFGVI2,LBOLD,LBNEW
 INTEGER::LOCCUD(0:NDREVE)
 INTEGER::IAUXDI(1:2*NDSTAT)
 REAL   ::NOTOCC,RICOND,LOGNORM,PHASE,LOGPF,LOGV2,phav2
 COMPLEX::C_ZERO,C_UNIT,C_I,AVRCMP,CPHASE
 COMPLEX::DETWRK(2),DETRMA(2),AUXDIA(1:2*NDSTAT)
 COMPLEX,DIMENSION(1:2*NDSTAT,1:2*NDSTAT)::VU
 COMPLEX,ALLOCATABLE::OVRLAP(:,:),RMATRX(:,:),RMAINV(:,:),EWAVEF(:,:),WARAUX(:,:)
!
 INTEGER::NFIPRI
 REAL   ::ROTATX,ROTATY,ROTATZ
 COMPLEX::PHASPI
 COMMON /CFIPRI/ NFIPRI
 COMMON /ROTATT/ ROTATX,ROTATY,ROTATZ
 COMMON /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN,1:NDTWCE)
!=======================================================================
 IALLOC=1
!=======================================================================
 ALLOCATE (OVRLAP(1:2*NDSTAT,1:2*NDSTAT),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('OVRLAP','ROTWLR')
!
 IF(ICANON.EQ.2)THEN
    ALLOCATE (RMATRX(1:2*NDSTAT,1:2*NDSTAT),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('RMATRX','ROTWLR')
    ALLOCATE (RMAINV(1:2*NDSTAT,1:2*NDSTAT),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('RMAINV','ROTWLR')
 ENDIF
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
 C_UNIT=CMPLX(1.0D0,0.0D0)
 C_I=CMPLX(0.0D0,1.0D0)
 LOCCUD(:)=LTIMUP
!=======================================================================
!(BRB+ARA) IN HFB CASE
!=======================================================================
 IF(IPAHFB.EQ.1)THEN

    IF(ICANON.LT.2)THEN
!=======================================================================
!PUT WAVE FUNCTION INTO WALEFT AND WARIGH
!=======================================================================
       IF(ICANON.EQ.1)THEN
          CALL CANWAV(MREVER,ISIMPY,WALEFT,ICHARG,LDBASE,LOCCUD)
          WARIGH(:,:,:)=WALEFT(:,:,:)
       ELSE
          WALEFT(:,:,:)=SARIGH(:,:,:,ICHARG,1)
          WARIGH(:,:,:)=SARIGH(:,:,:,ICHARG,1)
       ENDIF
!=======================================================================
!ROTATE WARIGH
!=======================================================================
       IF(INROTA.NE.0) CALL ROTWAV(LTOTAL,WARIGH)
!=======================================================================
!/CALCULATE OVERLAP MATRIX
!=======================================================================
       OVRLAP(:,:)=C_ZERO
       IAUXDI(:)=0
       AUXDIA(:)=0.0D0
!
       ALLOCATE(VRVAUX(1:LUPPER,1:LUPPER))
       ALLOCATE(URUAUX(1:LUPPER,1:LUPPER))
!
       CALL WLRMAT(IPAHFB,LDBASE,LUPPER,WALEFT,WARIGH,VRVAUX,URUAUX)
       OVRLAP(1:LUPPER,1:LUPPER)=VRVAUX(1:LUPPER,1:LUPPER)+URUAUX(1:LUPPER,1:LUPPER)
!
       DEALLOCATE(VRVAUX,URUAUX)
!=======================================================================
! INVERTING THE OVERLAP MATRIX
!=======================================================================
       CALL ZGECO(OVRLAP,2*NDSTAT,LUPPER,IAUXDI,RICOND,AUXDIA)
       CALL ZGEDI(OVRLAP,2*NDSTAT,LUPPER,IAUXDI,DETWRK,AUXDIA,01)
       IF(IDOGOA.NE.0)THEN!GOA NEED THE KERNAL
          IF(MREVER.EQ.0) STOP 'CALCULATE KERNAL WITH PFAFFIAN IN HFB CASE NEED MREVER=1 IN ROTWLR'
          !USE PFAFFIAN METHOD TO CALCULATE THE KERNAL
           IF(INROTA.NE.0)THEN
              STOP 'ROTWLR NEEDS TO BE ADAPTED SINCE LIPCOR VERSION 16'
!              ALLOCATE(VUAUX(1:2*NDSTAT,1:2*NDSTAT,0:NDISOS))
!              CALL NORM_N(0,IPAHFB,LUPPER,LDBASE,WALEFT,WALEFT,VUAUX(:,:,ICHARG),LV2AUX(ICHARG),PV2AUX(ICHARG),OVKERN)
!              CALL NORM_N(1,IPAHFB,LUPPER,LDBASE,WALEFT,WARIGH,VUAUX(:,:,ICHARG),LV2AUX(ICHARG),PV2AUX(ICHARG),OVKERN)
!in hfb case, pfaffian is the overlap; in hf case, determinant of d^+ d is the overlap
!              DEALLOCATE(VUAUX)
           ELSE!the kernal is 1 if there is no rotation
              OVKERN=1.0d0
           ENDIF
       ENDIF
!
       IF (ABS(RICOND).LT.1.0D-12) THEN
          WRITE(NFIPRI,*)'BE CAREFUL - R MATRIX ,MAY BE SINGULAR IN RENINE FOR:'
          WRITE(NFIPRI,*)'INROTA=',INROTA,' RICOND=',RICOND
       END IF
!
    ELSEIF(ICANON.EQ.2)THEN
!=======================================================================
! CONSTRUT R AND R^-1 MATRIX UNDER CANONICAL BASIS
! ALSO CALCULATE WAVE FUNCTION AND ROTATED WAVE FUNCTION
!=======================================================================
       CALL RMATCN(MREVER,ISIMPY,LDBASE,LTIMUP,LUPPER,LTOTAL,INROTA,ICHARG,&
                   RMATRX(1:LUPPER,1:LUPPER),RMAINV(1:LUPPER,1:LUPPER),&
                   WALEFT,WARIGH)
!
       IAUXDI(:)=0
       AUXDIA(:)=0.0D0
       CALL ZGECO(RMAINV,2*NDSTAT,LUPPER,IAUXDI,RICOND,AUXDIA)
       CALL ZGEDI(RMAINV,2*NDSTAT,LUPPER,IAUXDI,DETRMA,AUXDIA,11)
!
       IF (ABS(RICOND).LT.1.0D-12) THEN
          WRITE(NFIPRI,*)'BE CAREFUL - R MATRIX ,MAY BE SINGULAR IN RENINE FOR:'
          WRITE(NFIPRI,*)'INROTA=',INROTA,' RICOND=',RICOND
       END IF
!=======================================================================
!(BRB+AR^-1A) IN HFB CASE
!=======================================================================
       CALL VRVMAT(MREVER,ISIMPY,LDBASE,LTIMUP,LUPPER,ICHARG,&
                   RMATRX(1:LUPPER,1:LUPPER),RMAINV(1:LUPPER,1:LUPPER),&
                   OVRLAP(1:LUPPER,1:LUPPER))
!=======================================================================
! INVERTING THE OVERLAP MATRIX
!=======================================================================
       IAUXDI(:)=0
       AUXDIA(:)=0.0D0
       CALL ZGECO(OVRLAP,2*NDSTAT,LUPPER,IAUXDI,RICOND,AUXDIA)
       CALL ZGEDI(OVRLAP,2*NDSTAT,LUPPER,IAUXDI,DETWRK,AUXDIA,11)
!
       IF (ABS(RICOND).LT.1.0D-12) THEN
          WRITE(NFIPRI,*)'BE CAREFUL - R MATRIX ,MAY BE SINGULAR IN RENINE FOR:'
          WRITE(NFIPRI,*)'INROTA=',INROTA,' RICOND=',RICOND
       END IF
!
       OVKERN=DETWRK(1)*10.0D0**DETWRK(2)*(DETRMA(1)*10.0D0**DETRMA(2))

    ELSE
          STOP 'WRONG ICANO IN RENINE'

    ENDIF
!=======================================================================
!MULTIPLYING THE RIGHT WAVE FUNCTIONS BY THE INVERTED OVERLAP MATRIX
!=======================================================================
    CALL MAT_WR(IPAHFB,LDBASE,LUPPER,OVRLAP(1:LUPPER,1:LUPPER),WARIGH)
 ELSE
!=======================================================================
!CALCULATE B(BRB+ARA)^-1, A(BRB+ARA)^-1 IN HF CASE
!=======================================================================
    WALEFT(:,:,:)=SARIGH(:,:,:,ICHARG,1)
    WARIGH(:,:,:)=SARIGH(:,:,:,ICHARG,1)
    IF(INROTA.NE.0) CALL ROTWAV(LTOTAL,WARIGH)
!
    CALL WLRMAT(IPAHFB,LDBASE,LTOTAL,WALEFT,WARIGH,OVRLAP(1:LTOTAL,1:LTOTAL))
!
!=======================================================================
! INVERTING THE OVERLAP MATRIX
!=======================================================================
    CALL ZGECO(OVRLAP,2*NDSTAT,LTOTAL,IAUXDI,RICOND,AUXDIA)
!
    IF(IDOGOA.GE.1)THEN
       CALL ZGEDI(OVRLAP,2*NDSTAT,LTOTAL,IAUXDI,DETWRK,AUXDIA,11)
       OVKERN=DETWRK(1)*10.0D0**DETWRK(2)
    ELSE
       CALL ZGEDI(OVRLAP,2*NDSTAT,LTOTAL,IAUXDI,DETWRK,AUXDIA,01)
    ENDIF
!
    IF (ABS(RICOND).LT.1.0D-12) THEN
        WRITE(NFIPRI,*) 'BE CAREFULL - OVERLAP MATRIX ,MAY BE SINGULAR IN RENINE FOR:'
        WRITE(NFIPRI,*) 'INROTA=',INROTA,' RICOND=',RICOND
    END IF
!=======================================================================
!MULTIPLYING THE RIGHT WAVE FUNCTIONS BY THE INVERTED OVERLAP MATRIX
!=======================================================================
    CALL MAT_WR(IPAHFB,LDBASE,LTOTAL,OVRLAP(1:LTOTAL,1:LTOTAL),WARIGH)
 END IF ! End IF (IPAHFB.EQ.1)
!=======================================================================
 DEALLOCATE(OVRLAP)
 IF(ICANON.EQ.2)DEALLOCATE(RMATRX,RMAINV)
!=======================================================================
END SUBROUTINE ROTWLR
!=======================================================================
SUBROUTINE LMATCN(MREVER,ISIMPY,LDBASE,LTIMUP,LUPPER,LTOTAL,INSHIF,ICHARG,&
                  LMATRX,LMAINV,WALEFT,WARIGH)
!=======================================================================
! RETURN ROTATION MATRIX FOR UPPER AND LOWER BLOCK IN CANONICAL
! BASIS, THE LATTER WILL BE INVERSED LATER
!=======================================================================
USE CANBAS
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::MREVER,ISIMPY,LDBASE,LTIMUP,LUPPER,LTOTAL,INSHIF,ICHARG
 COMPLEX,DIMENSION(1:LUPPER,1:LUPPER)::LMATRX, LMAINV
 COMPLEX,DIMENSION(1:NDBASE,1:4*NDSTAT,0:NDSPIN)::WALEFT,WARIGH
!
 INTEGER:: JSTATE,ISTATE,IREVER,ISPIN,IBASE
 COMPLEX::C_ZERO,AVRCMB,AVRCMA
!
 INTEGER::NUMBQP
 COMPLEX::PHASPI
 COMMON /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN,1:NDTWCE)
 COMMON /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
!=======================================================================
 CALL CPUTIM('LMATCN',1)
!=======================================================================
 IF(ISIMPY.EQ.0) STOP 'NEED ISIMPY=1 IN LMATCN'
 C_ZERO=CMPLX(0.0D0,0.0D0)
 WALEFT(:,:,:)=C_ZERO
!=======================================================================
 JSTATE=0
 DO IREVER=0,MREVER
    DO ISTATE=1,LTIMUP
       JSTATE=JSTATE+1
       DO ISPIN=0,NDSPIN
!D FOR UPPER BLOCK
          WALEFT(1:LDBASE,JSTATE,ISPIN)=&
          WAVCAN(1:LDBASE,ISTATE,IREVER,ICHARG)*PHASPI(1:LDBASE,IREVER,ISPIN,1)
!D FOR LOWER BLOCK
          WALEFT(1:LDBASE,JSTATE+LUPPER,ISPIN)=(2*ISPIN-1)*&
          CONJG(WAVCAN(1:LDBASE,ISTATE,1-IREVER,ICHARG)*PHASPI(1:LDBASE,1-IREVER,1-ISPIN,1))
       END DO
    END DO
 END DO
! RD
 WARIGH(:,:,:)=WALEFT(:,:,:)
 IF(INSHIF.NE.0) CALL SHIWAV(LTOTAL,WARIGH)
! DRD
 LMATRX(:,:)=C_ZERO
 LMAINV(:,:)=C_ZERO
!
 CALL WLRMAT(1,LDBASE,LUPPER,WALEFT,WARIGH,LMATRX,LMAINV)
!(shifted) wavefunction
 JSTATE=0
 DO IREVER=0,MREVER
    DO ISTATE=1,LTIMUP
       JSTATE=JSTATE+1
       DO ISPIN=0,NDSPIN
!
          WALEFT(1:LDBASE,JSTATE,ISPIN)&
         =V_CAN(ISTATE,IREVER,ICHARG)*WALEFT(1:LDBASE,JSTATE,ISPIN)
          WALEFT(1:LDBASE,JSTATE+LUPPER,ISPIN)&
         =U_CAN(ISTATE,1-IREVER,ICHARG)*WALEFT(1:LDBASE,JSTATE+LUPPER,ISPIN)
!
          WARIGH(1:LDBASE,JSTATE,ISPIN)&
         =V_CAN(ISTATE,IREVER,ICHARG)*WARIGH(1:LDBASE,JSTATE,ISPIN)
          WARIGH(1:LDBASE,JSTATE+LUPPER,ISPIN)&
         =U_CAN(ISTATE,1-IREVER,ICHARG)*WARIGH(1:LDBASE,JSTATE+LUPPER,ISPIN)
          END DO
    END DO
 END DO

!=======================================================================
 CALL CPUTIM('LMATCN',0)
!=======================================================================
 RETURN
END SUBROUTINE LMATCN
!=======================================================================
SUBROUTINE LINWLR(MREVER,ISIMPY,ICANON,IDOGOA,IPAHFB,INSHIF,IEXTEN,LDBASE,LTIMUP,LUPPER,LTOTAL,ICHARG,OVKERN)
!=======================================================================
!CALCULATE B.OVERLAP^-1,A.OVERLAP^-1 IN ROTATIONAL CASE
!ICANON>1 ONLY WHEN ISIMPY=1
!=======================================================================
USE SAVLEF
USE SAVRIG
USE WAVR_L
!USE PFAFFI, ONLY:NORM_N,VUAUX,LV2AUX,PV2AUX
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::MREVER,ISIMPY,ICANON,IDOGOA,IPAHFB,INSHIF,IEXTEN,LDBASE,LTIMUP,LUPPER,LTOTAL,ICHARG
 COMPLEX::OVKERN
!
 INTEGER::IALLOC,ISTATE,JSTATE,KSTATE,ISPIN,IBASE
 INTEGER::LOCCUD(0:NDREVE)
 INTEGER::IAUXDI(1:2*NDSTAT)
 REAL   ::RICOND
 COMPLEX::C_ZERO,C_UNIT,AVRCMP
 COMPLEX::DETWRK(2),DETRMA(2),AUXDIA(1:2*NDSTAT)
 COMPLEX,ALLOCATABLE::OVRLAP(:,:),LMATRX(:,:),LMAINV(:,:),EWAVEF(:,:),WARAUX(:,:)
!
 INTEGER::NFIPRI
 COMMON /CFIPRI/ NFIPRI
!=======================================================================
 IALLOC=1
!=======================================================================
 ALLOCATE (OVRLAP(1:2*NDSTAT,1:2*NDSTAT),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('OVRLAP','LINWLR')
!
 IF(ICANON.EQ.2)THEN
    ALLOCATE (LMATRX(1:2*NDSTAT,1:2*NDSTAT),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('LMATRX','LINWLR')
    ALLOCATE (LMAINV(1:2*NDSTAT,1:2*NDSTAT),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('LMAINV','LINWLR')
 ENDIF
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
 C_UNIT=CMPLX(1.0D0,0.0D0)
 LOCCUD(:)=LTIMUP
!=======================================================================
!(BRB+ARA) IN HFB CASE
!=======================================================================
 IF(IPAHFB.EQ.1)THEN

    IF(ICANON.LT.2)THEN
!=======================================================================
!PUT WAVE FUNCTION INTO WALEFT AND WARIGH
!=======================================================================
       IF(ICANON.EQ.1)THEN
          CALL CANWAV(MREVER,ISIMPY,WALEFT,ICHARG,LDBASE,LOCCUD)
          WARIGH(:,:,:)=WALEFT(:,:,:)
       ELSE
          WALEFT(:,:,:)=SARIGH(:,:,:,ICHARG,1)
          WARIGH(:,:,:)=SARIGH(:,:,:,ICHARG,1)
       ENDIF
!=======================================================================
!ROTATE WARIGH
!=======================================================================
       IF(INSHIF.NE.0) CALL SHIWAV(LTOTAL,WARIGH)
!=======================================================================
!CALCULATE OVERLAP MATRIX
!=======================================================================
       OVRLAP(:,:)=C_ZERO
       IAUXDI(:)=0
       AUXDIA(:)=0.0D0
!
       DO JSTATE=1,LUPPER
          DO ISTATE=1,LUPPER
             AVRCMP=C_ZERO
             DO ISPIN=0,NDSPIN
                DO IBASE=1,LDBASE
                   AVRCMP=AVRCMP&
            +CONJG(WALEFT(IBASE,ISTATE,ISPIN))*WARIGH(IBASE,JSTATE,ISPIN)&
            +CONJG(WALEFT(IBASE,ISTATE+LUPPER,ISPIN))*WARIGH(IBASE,JSTATE+LUPPER,ISPIN)
                END DO
             END DO
             OVRLAP(ISTATE,JSTATE)=AVRCMP
          END DO
       END DO
!=======================================================================
! INVERTING THE OVERLAP MATRIX
!=======================================================================
       CALL ZGECO(OVRLAP,2*NDSTAT,LUPPER,IAUXDI,RICOND,AUXDIA)
       CALL ZGEDI(OVRLAP,2*NDSTAT,LUPPER,IAUXDI,DETWRK,AUXDIA,01)
       IF(IDOGOA.NE.0)THEN!GOA NEED THE KERNAL
          IF(MREVER.EQ.0) STOP 'CALCULATE KERNAL WITH PFAFFIAN IN HFB CASE NEED MREVER=1 IN LINWLR'
          !USE PFAFFIAN METHOD TO CALCULATE THE KERNAL
           IF(INSHIF.NE.0)THEN
              STOP 'ROTWLR NEEDS TO BE ADAPTED SINCE LIPCOR VERSION 16'
!              ALLOCATE(VUAUX(1:2*NDSTAT,1:2*NDSTAT,0:NDISOS))
!              CALL NORM_N(0,IPAHFB,LUPPER,LDBASE,WALEFT,WALEFT,VUAUX(:,:,ICHARG),LV2AUX(ICHARG),PV2AUX(ICHARG),OVKERN)
!              CALL NORM_N(1,IPAHFB,LUPPER,LDBASE,WALEFT,WARIGH,VUAUX(:,:,ICHARG),LV2AUX(ICHARG),PV2AUX(ICHARG),OVKERN)
!in hfb case, pfaffian is the overlap; in hf case, determinant of d^+ d is the overlap
!              DEALLOCATE(VUAUX)
           ELSE
              OVKERN=1.0d0
           ENDIF
       ENDIF
!
       IF (ABS(RICOND).LT.1.0D-12) THEN
          WRITE(NFIPRI,*)'BE CAREFUL - R MATRIX ,MAY BE SINGULAR IN RENINE FOR:'
          WRITE(NFIPRI,*)'INSHIF=',INSHIF,' RICOND=',RICOND
       END IF
!
    ELSEIF(ICANON.EQ.2)THEN
!=======================================================================
! CONSTRUT R AND R^-1 MATRIX UNDER CANONICAL BASIS
! ALSO CALCULATE WAVE FUNCTION AND ROTATED WAVE FUNCTION
!=======================================================================
       CALL LMATCN(MREVER,ISIMPY,LDBASE,LTIMUP,LUPPER,LTOTAL,INSHIF,ICHARG,&
                   LMATRX(1:LUPPER,1:LUPPER),LMAINV(1:LUPPER,1:LUPPER),&
                   WALEFT,WARIGH)
!
       IAUXDI(:)=0
       AUXDIA(:)=0.0D0
       CALL ZGECO(LMAINV,2*NDSTAT,LUPPER,IAUXDI,RICOND,AUXDIA)
       CALL ZGEDI(LMAINV,2*NDSTAT,LUPPER,IAUXDI,DETRMA,AUXDIA,11)
!
       IF (ABS(RICOND).LT.1.0D-12) THEN
          WRITE(NFIPRI,*)'BE CAREFUL - R MATRIX ,MAY BE SINGULAR IN RENINE FOR:'
          WRITE(NFIPRI,*)'INSHIF=',INSHIF,' RICOND=',RICOND
       END IF
!=======================================================================
!(BRB+AR^-1A) IN HFB CASE
!=======================================================================
       CALL VRVMAT(MREVER,ISIMPY,LDBASE,LTIMUP,LUPPER,ICHARG,&
                   LMATRX(1:LUPPER,1:LUPPER),LMAINV(1:LUPPER,1:LUPPER),&
                   OVRLAP(1:LUPPER,1:LUPPER))
! write(*,*)ovrlap(1,1),ovrlap(1,1+ltimup),'ovrlap'
!=======================================================================
! INVERTING THE OVERLAP MATRIX
!=======================================================================
       IAUXDI(:)=0
       AUXDIA(:)=0.0D0
       CALL ZGECO(OVRLAP,2*NDSTAT,LUPPER,IAUXDI,RICOND,AUXDIA)
       CALL ZGEDI(OVRLAP,2*NDSTAT,LUPPER,IAUXDI,DETWRK,AUXDIA,11)
!
       IF (ABS(RICOND).LT.1.0D-12) THEN
          WRITE(NFIPRI,*)'BE CAREFUL - R MATRIX ,MAY BE SINGULAR IN RENINE FOR:'
          WRITE(NFIPRI,*)'INSHIF=',INSHIF,' RICOND=',RICOND
       END IF
!
       OVKERN=DETWRK(1)*10.0D0**DETWRK(2)*(DETRMA(1)*10.0D0**DETRMA(2))
    ELSE
          STOP 'WRONG ICANO IN RENINE'

    ENDIF
!=======================================================================
!MULTIPLYING THE RIGHT WAVE FUNCTIONS BY THE INVERTED OVERLAP MATRIX
!=======================================================================
    ALLOCATE(EWAVEF(1:NDBASE,1:2*NDSTAT))
    ALLOCATE(WARAUX(1:NDBASE,1:2*NDSTAT))
!
    DO ISPIN=0,NDSPIN
       EWAVEF(:,:)=C_ZERO
       WARAUX(:,:)=C_ZERO
!UPPER BLOCK
       DO ISTATE=1,LUPPER
          CALL ZCOPY(NDBASE,WARIGH(1,ISTATE,ISPIN),1,EWAVEF(1,ISTATE),1)
       END DO
       CALL ZGEMM('N','N',LDBASE,LUPPER,LUPPER,&
                   C_UNIT,EWAVEF,NDBASE,OVRLAP,2*NDSTAT,&
                   C_ZERO,WARAUX,NDBASE)
       DO ISTATE=1,LUPPER
          CALL ZCOPY(NDBASE,WARAUX(1,ISTATE),1,WARIGH(1,ISTATE,ISPIN),1)
       END DO
!LOWER BLOCK
       DO ISTATE=1,LUPPER
          CALL ZCOPY(NDBASE,WARIGH(1,ISTATE+LUPPER,ISPIN),1,EWAVEF(1,ISTATE),1)
       END DO
       CALL ZGEMM('N','N',LDBASE,LUPPER,LUPPER,&
                   C_UNIT,EWAVEF,NDBASE,OVRLAP,2*NDSTAT,&
                   C_ZERO,WARAUX,NDBASE)
       DO ISTATE=1,LUPPER
          CALL ZCOPY(NDBASE, WARAUX(1,ISTATE),1,WARIGH(1,ISTATE+LUPPER,ISPIN),1)
       END DO
    END DO
!
    DEALLOCATE(EWAVEF)
    DEALLOCATE(WARAUX)
 ELSE
!=======================================================================
!CALCULATE B(BRB+ARA)^-1, A(BRB+ARA)^-1 IN HF CASE
!=======================================================================
    WALEFT(:,:,:)=SARIGH(:,:,:,ICHARG,1)
    WARIGH(:,:,:)=SARIGH(:,:,:,ICHARG,1)
    IF(INSHIF.NE.0) CALL SHIWAV(LTOTAL,WARIGH)
!
    DO JSTATE=1,LTOTAL
       DO ISTATE=1,LTOTAL
          AVRCMP=C_ZERO
          DO ISPIN=0,NDSPIN
             DO IBASE=1,LDBASE
                AVRCMP=AVRCMP+CONJG(WALEFT(IBASE,ISTATE,ISPIN))*WARIGH(IBASE,JSTATE,ISPIN)
             END DO
          END DO
          OVRLAP(ISTATE,JSTATE)=AVRCMP
       END DO
    END DO
!=======================================================================
! INVERTING THE OVERLAP MATRIX
!=======================================================================
    CALL ZGECO(OVRLAP,2*NDSTAT,LTOTAL,IAUXDI,RICOND,AUXDIA)
    IF(IDOGOA.GE.1)THEN
       CALL ZGEDI(OVRLAP,2*NDSTAT,LTOTAL,IAUXDI,DETWRK,AUXDIA,11)
       OVKERN=DETWRK(1)*10.0D0**DETWRK(2)
    ELSE
       CALL ZGEDI(OVRLAP,2*NDSTAT,LTOTAL,IAUXDI,DETWRK,AUXDIA,01)
    ENDIF
    IF (ABS(RICOND).LT.1.0D-12) THEN
        WRITE(NFIPRI,*) 'BE CAREFULL - OVERLAP MATRIX ,MAY BE SINGULAR IN RENINE FOR:'
        WRITE(NFIPRI,*) 'INSHIF=',INSHIF,' RICOND=',RICOND
    END IF
!=======================================================================
!MULTIPLYING THE RIGHT WAVE FUNCTIONS BY THE INVERTED OVERLAP MATRIX
!=======================================================================
    ALLOCATE (WARAUX(1:2*NDSTAT,0:NDSPIN),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('WARAUX','LINWRL')

    DO JSTATE=1,LDBASE
       DO ISTATE=1,LTOTAL
          DO ISPIN=0,NDSPIN
             WARAUX(ISTATE,ISPIN)=C_ZERO
             DO KSTATE=1,LTOTAL
                WARAUX(ISTATE,ISPIN)=WARAUX(ISTATE,ISPIN)&
          +WARIGH(JSTATE,KSTATE,ISPIN)*OVRLAP(KSTATE,ISTATE)
             END DO
          END DO
       END DO
!
       DO ISTATE=1,LTOTAL
          DO ISPIN=0,NDSPIN
              WARIGH(JSTATE,ISTATE,ISPIN)=WARAUX(ISTATE,ISPIN)
          END DO
       END DO
    END DO
    DEALLOCATE(WARAUX)
 END IF ! End IF (IPAHFB.EQ.1)
!=======================================================================
 DEALLOCATE(OVRLAP)
 IF(ICANON.EQ.2)DEALLOCATE(LMATRX,LMAINV)
!=======================================================================
END SUBROUTINE LINWLR
!=======================================================================
SUBROUTINE H_KERN(ISIMTX,JSIMTY,ISIMTZ,ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,&
                  ICHARG,MIN_QP,IPNMIX,ITIREP,&
                  NAMEPN,PRINIT,IDEVAR,ITERUN,ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE,&
                  ISHIFY,JMULMO,NUMCOU,BOUCOU,IN_FIX,IZ_FIX,&
                  ISKYRM,EKEKIN,EPAIKI,DROTSQ,DKOTSQ,EKECOD,EKECOX,EKESKY)
!=======================================================================
!CALCULATE RHO, KINETIC, PAIRING AND COULOMB ENERGY
!=======================================================================
IMPLICIT NONE
!=======================================================================
 CHARACTER::NAMEPN*8
 LOGICAL::PRINIT
 INTEGER::ISIMTX,JSIMTY,ISIMTZ,ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,&
          ICHARG,MIN_QP,IPNMIX,ITPNMX,ITIREP,&
          IDEVAR,ITERUN,ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE,&
          ISHIFY,JMULMO,NUMCOU,IN_FIX,IZ_FIX,ISKYRM
 REAL   ::BOUCOU,ENEKIN,DROTSQ
 COMPLEX::EKEKIN,DKOTSQ,EPAIKI,EKECOD,EKECOX,EKESKY
!
 INTEGER::LDPNMX
 REAL   ::COMULT,EKIN_N,EKIN_P,EKIN_T,EPOT_N,EPOT_P,EPOT_T,ESUM_N,ESUM_P,ESUM_T,EPAI_N,EPAI_P,EPAI_T,&
          EREA_N,EREA_P,EREA_T,ELIP_N,ELIP_P,ELIP_T,ECOULD,ECOULE,ECOULT,ECOULS,ECOULV, EMULCO,&
          EMUSLO,EMUREA,ESIFCO,ESISLO,ESIREA,ESPICO,ESPSLO,ESPREA,ENREAR,ECORCM,ECOR_R,EEVEW0,&
          EODDW0,ENE_W0,ENEVEN,ENEODD,ENESKY,ESTABN,ETOTSP,ETOTFU
 COMPLEX::QMUT_N,QMUT_P,QMUT_T,QMUL_N,QMUL_P,QMUL_T
 COMMON /QMUTTI/ QMUT_N(0:NDMULT,-NDMULT:NDMULT),QMUT_P(0:NDMULT,-NDMULT:NDMULT),QMUT_T(0:NDMULT,-NDMULT:NDMULT)
 COMMON /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),QMUL_P(0:NDMULT,-NDMULT:NDMULT),QMUL_T(0:NDMULT,-NDMULT:NDMULT)
 COMMON /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
 COMMON /ALLENE/ EKIN_N,EKIN_P,EKIN_T,EPOT_N,EPOT_P,EPOT_T,ESUM_N,ESUM_P,ESUM_T,&
                 EPAI_N,EPAI_P,EPAI_T,EREA_N,EREA_P,EREA_T,ELIP_N,ELIP_P,ELIP_T,&
                 ECOULD,ECOULE,ECOULT,ECOULS,ECOULV,&
                 EMULCO,EMUSLO,EMUREA,ESIFCO,ESISLO,ESIREA,ESPICO,ESPSLO,ESPREA,&
                 ENREAR,ECORCM,ECOR_R,&
                 EEVEW0,EODDW0,ENE_W0,ENEVEN,ENEODD,ENESKY,ESTABN,ETOTSP,ETOTFU
!
 COMPLEX::C_ZERO
!=======================================================================
 ITPNMX=ICHARG
 C_ZERO=CMPLX(0.0D0,0.0D0)
!=======================================================================
!              DENSITY
!=======================================================================
 CALL ZEDENS(ITPNMX)
 CALL DENSHF(ISIMTX,JSIMTY,ISIMTZ,ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,&
             ICHARG,MIN_QP,IPNMIX,ITPNMX,ITIREP,&
             NAMEPN,PRINIT,IDEVAR,ITERUN,ISYMDE,INIROT,INIINV,INIKAR,&
             ISAWAV,IKERNE,1,1)
 IF(MREVER.EQ.0) CALL DBLING(ITPNMX,1)
!=======================================================================
!              KINETIC ENERGY
!=======================================================================
! CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH,1)!CALL BEFORE THIS SUBROUTINE
 CALL EKINET(ENEKIN,DROTSQ,EKEKIN,DKOTSQ,1)
!=======================================================================
!              PAIRING ENERGY
!=======================================================================
 IF (IPAHFB.EQ.1) THEN
    CALL EPAIRI(IN_FIX,IZ_FIX,ITPNMX,EPAIKI)
    IF (MREVER.EQ.0) EPAIKI=EPAIKI*4.0d0
 ELSE
    EPAIKI=C_ZERO
 END IF
!
 IF(ICHARG.EQ.1)THEN
! if(.false.)then
!=======================================================================
!              CALCULATING THE COULOMB ENERGY
!=======================================================================
    CALL MOMETS(ISIMPY,ISIGNY,ISIQTY,QMUL_P,QMUT_P,COMULT,JMULMO,ISHIFY,1)
    CALL COUMAT(NUMCOU,BOUCOU,ISIMPY,IKERNE)
    CALL COULOD(ISIMPY,EKECOD)
    CALL TRUCHD
    CALL COULOE(EKECOX)
 ENDIF
!
 IF(ISKYRM.EQ.1)THEN
!=======================================================================
!              CALCULATING THE SKYRME ENERGY
!=======================================================================
       LDPNMX=1
       CALL TRUTOD(1,1)
       CALL ESKYRM(ENESKY,ENEVEN,ENEODD,&
                   ENREAR,ENE_W0,EEVEW0,EODDW0,EKESKY,LDPNMX,0,1)
 ENDIF
 RETURN
END SUBROUTINE H_KERN
!=======================================================================
END MODULE OFFDIA
!
!=======================================================================
!=======================================================================
!
!
!
!=======================================================================
!      ROUTINES CALLED IN MAIN PROGRAM:
!       - CANWAV: BUILDS ROTATED CANONICAL WAVE FUNCTION
!       - RENINE: CALCULATES THE INERTIA RENORMALIZATION FACTORS
!       - LINAVR: CALCULATES LINEAR MOMENTA
!       - RENMAS: CALCULATES THE MASS RENORMALIZATION FACTORS
!=======================================================================
!
!
!
!=======================================================================
!ROUTINES CALLED IN PROGRAM MAIN
SUBROUTINE CANWAV(MREVER,ISIMPY,WALEFT,ICHARG,LDBASE,LOCCUD)
!=======================================================================
! use u_can, v_can ,wavcan to build A=DU, B=DV
!=======================================================================
USE CANBAS
!=======================================================================
USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 INTEGER::MREVER,ISIMPY,ICHARG,LDBASE,LTIMUP,LUPPER,LSTATE,LTOTAL
 INTEGER::LOCCUD(0:NDREVE)
!
 INTEGER::JSTATE,IREVER,ISTATE,ISPIN
 COMPLEX::C_ZERO
 COMPLEX::WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN)
!
 INTEGER::NUMBQP
 COMPLEX::PHASPI
 COMMON /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN,1:NDTWCE)
 COMMON /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
!=======================================================================
 CALL CPUTIM('CANWAV',1)
!=======================================================================
 IF(ISIMPY.EQ.0) STOP 'NOT IMPLEMENT YET'
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
 WALEFT(:,:,:)=C_ZERO
!=======================================================================
 JSTATE=0
! B
! do istate=1,loccud(0)
! write(*,*)v_can(istate,0,icharg)**2+u_can(istate,1,icharg)**2,&
!           v_can(istate,0,icharg)**2+u_can(istate,0,icharg)**2,istate
! enddo
! stop
! V_CAN(:,1,:)=-V_CAN(:,0,:)
! U_CAN(:,1,:)=U_CAN(:,0,:)
 !WAVCAN(:,:,1,:)=CONJG(WAVCAN(:,:,0,:))
 DO IREVER=0,MREVER
    DO ISTATE=1,LOCCUD(IREVER)
          JSTATE=JSTATE+1
          DO ISPIN=0,NDSPIN
             WALEFT(1:LDBASE,JSTATE,ISPIN)=V_CAN(ISTATE,IREVER,ICHARG)&
           * WAVCAN(1:LDBASE,ISTATE,IREVER,ICHARG)* PHASPI(1:LDBASE,IREVER,ISPIN,1)
          END DO
    END DO
 END DO
! A
 DO IREVER=1,(1-MREVER),-1
     DO ISTATE=1,LOCCUD(IREVER)
          JSTATE=JSTATE+1
          DO ISPIN=0,NDSPIN
             WALEFT(1:LDBASE,JSTATE,ISPIN)=U_CAN(ISTATE,1-IREVER,ICHARG) &
          * (2*ISPIN-1)*CONJG(WAVCAN(1:LDBASE,ISTATE,IREVER,ICHARG)* PHASPI(1:LDBASE,IREVER,1-ISPIN,1))
          END DO
     END DO
 END DO
!=======================================================================
      CALL CPUTIM('CANWAV',0)
!=======================================================================
 RETURN
END SUBROUTINE CANWAV
!=======================================================================
SUBROUTINE ROTAVR(ISIMPY,ISIGNY,ISIQTY,&
                  IPAHFB,ICHARG,KETA_R,IROTAT,MREVER,CORROT,IKERNE,&
                  DROTSQ,EROTSQ,PROTSQ,TROTSQ,AROTLI,PROTLI,PROTKI,&
                  DKOTSQ,EKOTSQ,PKOTSQ,TKOTSQ,AKOTLI,PKOTLI,PKOTKI)
!=======================================================================
USE MAT_PP
USE MAT_PM
USE MAD_PP
USE MAD_PM
USE KAP_PM
USE KAP2PM
USE KAP_PP
USE KAP2PP
USE MAP_PP
USE MAP_PM
USE AROSTO
USE PROSTO
USE O2AVRG
!=======================================================================
USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 LOGICAL::CORROT
 INTEGER::ISIMPY,ISIGNY,ISIQTY,IPAHFB,ICHARG,KETA_R,IROTAT,MREVER,IKERNE
 REAL   ::DROTSQ(0:NDKART),EROTSQ(0:NDKART),PROTSQ(0:NDKART),TROTSQ(0:NDKART),&
          AROTLI(0:NDKART),PROTLI(0:NDKART),PROTKI(0:NDKART)
 COMPLEX::DKOTSQ(0:NDKART),EKOTSQ(0:NDKART),PKOTSQ(0:NDKART),TKOTSQ(0:NDKART),&
          AKOTLI(0:NDKART),PKOTLI(0:NDKART),PKOTKI(0:NDKART)
!
 INTEGER::IALLOC,IBRA,KARTEZ,IMSIGN
 REAL   ::FACTOR
 COMPLEX:: RESULT,C_ZERO,UNIT_I
 REAL   ,ALLOCATABLE:: HAUXIL(:,:)
 COMPLEX,ALLOCATABLE:: HAUXIJ(:,:,:)
 COMPLEX,ALLOCATABLE:: RHO_PP(:,:,:),RHO_PM(:,:,:),KAI_PM(:,:,:),KAI2PM(:,:,:),KAI_PP(:,:,:),KAI2PP(:,:,:)
!
 INTEGER::IPHAPP,IPHAPM,IPHAMP,IPHAMM,LDBASE,ITESTA,ITESTO,NOITER,NUMITE
 COMMON /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),&
                 IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
 COMMON /DIMENS/ LDBASE
 COMMON /ITERTS/ ITESTA,ITESTO,NOITER,NUMITE
!=======================================================================
 CALL CPUTIM('ROTAVR',1)
 IALLOC=0
 !
 C_ZERO=CMPLX(0.0D0,0.0D0)
 UNIT_I=CMPLX(0.0D0,1.0D0)
 FACTOR=1.0D0
!=======================================================================
!allocate space for 2[J.rho.J] and 2[J.kAPPa.J] matrix
!=======================================================================
 IF(KETA_R.EQ.2)THEN
    IF(.NOT.ALLOCATED(AROTPP))THEN
       ALLOCATE(AROTPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('AROTPP','ROTAVR')
    ENDIF
    IF(.NOT.ALLOCATED(PROTPM) .AND. IPAHFB.EQ.1)THEN
       ALLOCATE(PROTPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('PROTPM','ROTAVR')
    ENDIF
!
    IF(ISIMPY.NE.1)THEN
       IF(.NOT.ALLOCATED(AROTPM))THEN
          ALLOCATE(AROTPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AROTPM','ROTAVR')
       ENDIF
       IF(.NOT.ALLOCATED(PROTPP) .AND. IPAHFB.EQ.1)THEN
          ALLOCATE(PROTPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('PROTPP','ROTAVR')
       ENDIF
    ENDIF
 ENDIF
!=======================================================================
!allocate space for rho and kappa in case they are not allocate yet
!=======================================================================
 IF(.NOT.ALLOCATED(BIG_PP)) THEN
    ALLOCATE(BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('BIG_PP','ROTAVR')
 ENDIF
 IF(.NOT.ALLOCATED(DEN_PP)) THEN
    ALLOCATE(DEN_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('DEN_PP','ROTAVR')
 ENDIF
!
 IF(.NOT.ALLOCATED(CHI_PM) .AND. IPAHFB.EQ.1)THEN
    ALLOCATE(CHI_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS), STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('CHI_PM','ROTAVR')
 ENDIF
!
 IF(ISIMPY.NE.1)THEN
    IF(.NOT.ALLOCATED(BIG_PM))THEN
        ALLOCATE (BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
        IF (IALLOC.NE.0) CALL NOALLO('BIG_PM','ROTAVR')
    END IF
    IF(.NOT.ALLOCATED(DEN_PM))THEN
        ALLOCATE (DEN_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),STAT=IALLOC)
        IF (IALLOC.NE.0) CALL NOALLO('DEN_PM','ROTAVR')
    ENDIF
!
    IF (.NOT.ALLOCATED(CHI_PP) .AND. IPAHFB.EQ.1)THEN
       ALLOCATE (CHI_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('CHI_PP','ROTAVR')
    END IF
 ENDIF
!=======================================================================
!allocate work space
!=======================================================================
 ALLOCATE (HAUXIL(1:NDBASE,1:NDBASE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('HAUXIL','ROTAVR')
 ALLOCATE (HAUXIJ(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('HAUXIJ','ROTAVR')
!
 ALLOCATE (RHO_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('RHO_PP','ROTAVR')
!
 IF(ISIMPY.NE.1)THEN
    ALLOCATE (RHO_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('RHO_PM','ROTAVR')
 ENDIF
!
 IF (IPAHFB.EQ.1.AND.KETA_R.GT.0) THEN
    ALLOCATE (KAI_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('KAI_PM','ROTAVR')
    ALLOCATE (KAI2PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('KAI2PM','ROTAVR')
!
    IF(ISIMPY.NE.1)THEN
       ALLOCATE (KAI_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('KAI_PP','ROTAVR')
       ALLOCATE (KAI2PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('KAI2PP','ROTAVR')
    ENDIF
 ENDIF
 IF (KETA_R.NE.2)THEN
     IF(.NOT.ALLOCATED(BIG_PP)) STOP 'BIG_PP NOT ALLOCATED IN ROTAVR'
     IF(.NOT.ALLOCATED(BIG_PM).AND.ISIMPY.NE.1) STOP 'BIG_PM NOT ALLOCATED IN ROTAVR'
     IF(.NOT.ALLOCATED(PAI_PM).AND.IPAHFB.EQ.1.AND.KETA_R.GT.0) STOP 'PAI_PM NOT ALLOCATED IN ROTAVR'
     IF(.NOT.ALLOCATED(PAI2PM).AND.IPAHFB.EQ.1.AND.KETA_R.GT.0.AND.IKERNE.EQ.1) STOP 'PAI2PM NOT ALLOCATED IN ROTAVR'
     IF(.NOT.ALLOCATED(PAI_PP).AND.IPAHFB.EQ.1.AND.KETA_R.GT.0.AND.ISIMPY.NE.1) STOP 'PAI_PP NOT ALLOCATED IN ROTAVR'
     IF(.NOT.ALLOCATED(PAI2PP).AND.IPAHFB.EQ.1.AND.KETA_R.GT.0.AND.ISIMPY.NE.1.AND.IKERNE.EQ.1) STOP 'PAI2PP NOT ALLOCATED IN ROTAVR'
 ENDIF
!=======================================================================
!    ZEROING ARRAYS OF AVERAGE VALUES
!=======================================================================
 DROTSQ(:)=0.0D0
 EROTSQ(:)=0.0D0
 PROTSQ(:)=0.0D0
 TROTSQ(:)=0.0D0
 AROTLI(:)=0.0D0
 PROTLI(:)=0.0D0
 PROTKI(:)=0.0D0
!
 DKOTSQ(:)=C_ZERO
 EKOTSQ(:)=C_ZERO
 PKOTSQ(:)=C_ZERO
 TKOTSQ(:)=C_ZERO
 AKOTLI(:)=C_ZERO
 PKOTLI(:)=C_ZERO
 PKOTKI(:)=C_ZERO
!
 IF(KETA_R.EQ.2)THEN
                    AROTPP(:,:,:,:,ICHARG)=C_ZERO
    IF(ISIMPY.NE.1) AROTPM(:,:,:,:,ICHARG)=C_ZERO
!
    IF(IPAHFB.EQ.1)THEN
                        PROTPM(:,:,:,:,ICHARG)=C_ZERO
       IF (ISIMPY.NE.1) PROTPP(:,:,:,:,ICHARG)=C_ZERO
    ENDIF
 ENDIF
!
                 RHO_PP(:,:,:)=C_ZERO
 IF(ISIMPY.NE.1) RHO_PM(:,:,:)=C_ZERO
 IF (IPAHFB.EQ.1.AND.KETA_R.GT.0) THEN
    KAI_PM(:,:,:)=C_ZERO
    KAI2PM(:,:,:)=C_ZERO
     IF(ISIMPY.NE.1) THEN
        KAI_PP(:,:,:)=C_ZERO
        KAI2PP(:,:,:)=C_ZERO
     ENDIF
 ENDIF
!=======================================================================
!    store rho and kAPPa into matrix
!=======================================================================
 IF (KETA_R.EQ.2) THEN !when calculating matrix element,use mixed rho and kAPPa
    IF(ITESTA.EQ.NUMITE) THEN!initial den, chi at the first iteration
                        DEN_PP(:,:,:,ICHARG)= BIG_PP(:,:,:)
       IF (ISIMPY.NE.1) DEN_PM(:,:,:,ICHARG)= BIG_PM(:,:,:)
       IF (IPAHFB.EQ.1) THEN
                           CHI_PM(:,:,:,ICHARG)=PAI_PM(:,:,:)
          IF (ISIMPY.NE.1) CHI_PP(:,:,:,ICHARG)=PAI_PP(:,:,:)
       ENDIF
    ENDIF
!
                     RHO_PP(:,:,:)=DEN_PP(:,:,:,ICHARG)
    IF (ISIMPY.NE.1) RHO_PM(:,:,:)=DEN_PM(:,:,:,ICHARG)
    IF (IPAHFB.EQ.1) THEN
       KAI_PM(:,:,:)=CHI_PM(:,:,:,ICHARG)
       KAI2PM(:,:,:)=CHI_PM(:,:,:,ICHARG) ! ANALYZE THAT
       IF (ISIMPY.NE.1)THEN
          KAI_PP(:,:,:)=CHI_PP(:,:,:,ICHARG)
          KAI2PP(:,:,:)=CHI_PP(:,:,:,ICHARG)
       ENDIF
    ENDIF
!
 ELSE!when there is no correction or inside RENINE, use rho and kAPPa from DENMAC and PAIMAC
                     RHO_PP(:,:,:)=BIG_PP(:,:,:)
    IF (ISIMPY.NE.1) RHO_PM(:,:,:)=BIG_PM(:,:,:)
    IF (IPAHFB.EQ.1.AND.KETA_R.GT.0) THEN
        KAI_PM(:,:,:)=PAI_PM(:,:,:)
        IF (IKERNE.EQ.1) THEN
            KAI2PM(:,:,:)=PAI2PM(:,:,:)
        ELSE
            KAI2PM(:,:,:)=PAI_PM(:,:,:)
        ENDIF
        IF (ISIMPY.NE.1) THEN
            KAI_PP(:,:,:)=PAI_PP(:,:,:)
            IF (IKERNE.EQ.1) THEN
                KAI2PP(:,:,:)=PAI2PP(:,:,:)
            ELSE
                KAI2PP(:,:,:)=PAI_PP(:,:,:)
            ENDIF
        ENDIF
    ENDIF
 ENDIF
!=======================================================================
!                         X-DIRECTION
!=======================================================================
!
!=======================================================================
![Jx]
!=======================================================================
 CALL INT_LX(IPHAPM(0,0,0),HAUXIL,FACTOR)
 HAUXIJ(1:NDBASE,1:NDBASE,0)= UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
 HAUXIJ(1:NDBASE,1:NDBASE,1)=-UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!
 CALL INT_SX(HAUXIL,FACTOR)
 HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIJ(1:NDBASE,1:NDBASE,0)+HAUXIL(1:NDBASE,1:NDBASE)
 HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIJ(1:NDBASE,1:NDBASE,1)+HAUXIL(1:NDBASE,1:NDBASE)
!=======================================================================
!Tr[Jx.rho]
!=======================================================================
 IF (ISIMPY.NE.1) THEN
! IF (IROTAT.EQ.1 .AND. ISIMPY.NE.1 .AND. ISIQTY.NE.1) THEN
     CALL AVRXSO(HAUXIJ,AROTLI(1),AKOTLI(1),RHO_PM)
 END IF
!
 IF (CORROT) THEN
    IMSIGN=1
!=======================================================================
!Tr[(Jx.rho)^2] and 2[Jx.rho.Jx]
!=======================================================================

    IF(ISIMPY.EQ.1 .AND. KETA_R.NE.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(1),EKOTSQ(1),HAUXIJ,RHO_PP)
    ELSE IF(ISIMPY.EQ.0 .AND. KETA_R.NE.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(1),EKOTSQ(1),HAUXIJ,RHO_PP,RPM=RHO_PM)
    ELSE IF(ISIMPY.EQ.1 .AND.  KETA_R.EQ.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(1),EKOTSQ(1),HAUXIJ,RHO_PP,APP=AROTPP(:,:,1,:,ICHARG))
    ELSE IF(ISIMPY.EQ.0 .AND.  KETA_R.EQ.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(1),EKOTSQ(1),HAUXIJ,RHO_PP,RPM=RHO_PM,&
                   APP=AROTPP(:,:,1,:,ICHARG),APM=AROTPM(:,:,1,:,ICHARG))
    ELSE
       stop 'wrong ISIMPY or KETA_R in rotavr'
    END IF
!=======================================================================
!Tr[(Jx.kAPPa)(Jx.kAPPa')*] and 2[Jx.kAPPa.Jx]
!=======================================================================
    IF (IPAHFB.EQ.1.AND.KETA_R.GT.0) THEN
       IF(ISIMPY.EQ.1 .AND. KETA_R.NE.2)then
          CALL PAIXSO(MREVER,ISIMPY,KETA_R,PROTSQ(1),PKOTSQ(1),HAUXIJ,KAI_PM,KAI2PM)
       ELSE IF(ISIMPY.EQ.0 .AND. KETA_R.NE.2)then
          CALL PAIXSO(MREVER,ISIMPY,KETA_R,PROTSQ(1),PKOTSQ(1),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP)
       ELSE IF(ISIMPY.EQ.1 .AND.  KETA_R.EQ.2)then
          CALL PAIXSO(MREVER,ISIMPY,KETA_R,PROTSQ(1),PKOTSQ(1),HAUXIJ,KAI_PM,KAI2PM,PPM=PROTPM(:,:,1,:,ICHARG))
       ELSE IF(ISIMPY.EQ.0 .AND.  KETA_R.EQ.2)then
          CALL PAIXSO(MREVER,ISIMPY,KETA_R,PROTSQ(1),PKOTSQ(1),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP,&
                      PPM=PROTPM(:,:,1,:,ICHARG),PPP=PROTPP(:,:,1,:,ICHARG))
       ELSE
         stop 'wrong ISIMPY or KETA_R in rotavr'
       END IF
    END IF

!=======================================================================
![Jx^2]=[Lx^2]+2[Lx.Sx]+[Sx^2]
!=======================================================================
    CALL INTLX2(HAUXIL,FACTOR)
    HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIL(1:NDBASE,1:NDBASE)
    HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIL(1:NDBASE,1:NDBASE)
!
    CALL INT_LX(IPHAPP(0,0,1),HAUXIL,FACTOR)
    HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIJ(1:NDBASE,1:NDBASE,0)+UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!
    HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIJ(1:NDBASE,1:NDBASE,1)-UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!
    DO IBRA=1,LDBASE
       HAUXIJ(IBRA,IBRA,0)=HAUXIJ(IBRA,IBRA,0)+CMPLX(0.25D0,0.0D0)
       HAUXIJ(IBRA,IBRA,1)=HAUXIJ(IBRA,IBRA,1)+CMPLX(0.25D0,0.0D0)
    END DO
!=======================================================================
!Tr[Jx^2.rho]
!=======================================================================
    CALL AVRXSD(HAUXIJ,DROTSQ(1),DKOTSQ(1),RHO_PP)
 END IF
!=======================================================================
!                         Z-DIRECTION
!=======================================================================
!
!=======================================================================
![Jz]
!=======================================================================
 CALL INT_LZ(IPHAPM(0,0,0),HAUXIL,FACTOR)
 HAUXIJ(1:NDBASE,1:NDBASE,0)=UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
 HAUXIJ(1:NDBASE,1:NDBASE,1)=-UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!
 CALL INT_SZ(HAUXIL,FACTOR)
 HAUXIJ(1:NDBASE,1:NDBASE,0)= HAUXIJ(1:NDBASE,1:NDBASE,0)+UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
 HAUXIJ(1:NDBASE,1:NDBASE,1)= HAUXIJ(1:NDBASE,1:NDBASE,1)-UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!=======================================================================
!Tr[Jz.rho]
!=======================================================================
 IF (ISIMPY.NE.1) THEN
! IF (IROTAT.EQ.1 .AND. ISIMPY.NE.1 .AND. ISIQTY.NE.1) THEN
     CALL AVRXSO(HAUXIJ,AROTLI(3),AKOTLI(3),RHO_PM)
 END IF
!
 IF (CORROT) THEN
    IMSIGN=1
!=======================================================================
!Tr[(Jz.rho)^2] and 2[Jz.rho.Jz]
!=======================================================================

    IF(ISIMPY.EQ.1 .AND. KETA_R.NE.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(3),EKOTSQ(3),HAUXIJ,RHO_PP)
    ELSE IF(ISIMPY.EQ.0 .AND. KETA_R.NE.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(3),EKOTSQ(3),HAUXIJ,RHO_PP,RPM=RHO_PM)
    ELSE IF(ISIMPY.EQ.1 .AND.  KETA_R.EQ.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(3),EKOTSQ(3),HAUXIJ,RHO_PP,APP=AROTPP(:,:,3,:,ICHARG))
    ELSE IF(ISIMPY.EQ.0 .AND.  KETA_R.EQ.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(3),EKOTSQ(3),HAUXIJ,RHO_PP,RPM=RHO_PM,&
                   APP=AROTPP(:,:,3,:,ICHARG), APM=AROTPM(:,:,3,:,ICHARG))
    ELSE
       stop 'wrong ISIMPY or KETA_R in rotavr'
    END IF
!=======================================================================
!Tr[(Jz.kAPPa)(Jz.kAPPa')*] and 2[Jz.kAPPa.Jz]
!=======================================================================
    IF (IPAHFB.EQ.1.AND.KETA_R.GT.0) THEN
       IF(ISIMPY.EQ.1 .AND. KETA_R.NE.2)then
          CALL PAIXSO(MREVER,ISIMPY,KETA_R,PROTSQ(3),PKOTSQ(3),HAUXIJ,KAI_PM,KAI2PM)
       ELSEIF(ISIMPY.EQ.0 .AND. KETA_R.NE.2)then
          CALL PAIXSO(MREVER,ISIMPY,KETA_R,PROTSQ(3),PKOTSQ(3),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP)
       ELSEIF(ISIMPY.EQ.1 .AND.  KETA_R.EQ.2)then
          CALL PAIXSO(MREVER,ISIMPY,KETA_R,PROTSQ(3),PKOTSQ(3),HAUXIJ,KAI_PM,KAI2PM,PPM=PROTPM(:,:,3,:,ICHARG))
       ELSEIF(ISIMPY.EQ.0 .AND.  KETA_R.EQ.2)then
          CALL PAIXSO(MREVER,ISIMPY,KETA_R,PROTSQ(3),PKOTSQ(3),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP,&
                      PPM=PROTPM(:,:,3,:,ICHARG),PPP=PROTPP(:,:,3,:,ICHARG))
       ELSE
         stop 'wrong ISIMPY or KETA_R in rotavr'
       ENDIF
    END IF
!=======================================================================
![Jz^2]
!=======================================================================
    CALL INTLZ2(HAUXIL,FACTOR)
    HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIL(1:NDBASE,1:NDBASE)
    HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIL(1:NDBASE,1:NDBASE)
!
    CALL INT_LZ(IPHAPP(0,0,3),HAUXIL,FACTOR)
    HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIJ(1:NDBASE,1:NDBASE,0)-HAUXIL(1:NDBASE,1:NDBASE)
    HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIJ(1:NDBASE,1:NDBASE,1)-HAUXIL(1:NDBASE,1:NDBASE)
!
    DO IBRA=1,LDBASE
       HAUXIJ(IBRA,IBRA,0)=HAUXIJ(IBRA,IBRA,0)+CMPLX(0.25D0,0.0D0)
       HAUXIJ(IBRA,IBRA,1)=HAUXIJ(IBRA,IBRA,1)+CMPLX(0.25D0,0.0D0)
    END DO
!=======================================================================
!Tr[(Jz^2.rho]
!=======================================================================
    CALL AVRXSD(HAUXIJ,DROTSQ(3),DKOTSQ(3),RHO_PP)
 END IF
!=======================================================================
!                         Y-DIRECTION
!=======================================================================
!
!=======================================================================
![Jy]
!=======================================================================
 CALL INT_LY(IPHAPP(0,0,0),HAUXIL,FACTOR)
 HAUXIJ(1:NDBASE,1:NDBASE,0)=UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
 HAUXIJ(1:NDBASE,1:NDBASE,1)=UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!
 CALL INT_SY(HAUXIL,FACTOR)
 HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIJ(1:NDBASE,1:NDBASE,0)+HAUXIL(1:NDBASE,1:NDBASE)
 HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIJ(1:NDBASE,1:NDBASE,1)-HAUXIL(1:NDBASE,1:NDBASE)
!=======================================================================
!Tr[Jy.rho]
!=======================================================================
!  IF (IROTAT.EQ.1 .AND. ((ISIMPY.EQ.1 .AND. ISIGNY.NE.1) .OR. (ISIMPY.NE.1 .AND. ISIQTY.NE.1))) THEN
 CALL AVRXSD(HAUXIJ,AROTLI(2),AKOTLI(2),RHO_PP)
!  END IF
!
 IF (CORROT) THEN
    IMSIGN=-1
!=======================================================================
!Tr[(Jy.rho)^2] and 2[Jy.rho.Jy]
!=======================================================================
    IF(ISIMPY.EQ.1 .AND. KETA_R.NE.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(2),EKOTSQ(2),HAUXIJ,RHO_PP)
    ELSEIF(ISIMPY.EQ.0 .AND. KETA_R.NE.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(2),EKOTSQ(2),HAUXIJ,RHO_PP,RPM=RHO_PM)
    ELSEIF(ISIMPY.EQ.1 .AND.  KETA_R.EQ.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(2),EKOTSQ(2),HAUXIJ,RHO_PP,APP=AROTPP(:,:,2,:,ICHARG))
    ELSEIF(ISIMPY.EQ.0 .AND.  KETA_R.EQ.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,KETA_R,EROTSQ(2),EKOTSQ(2),HAUXIJ,RHO_PP,RPM=RHO_PM,&
                   APP=AROTPP(:,:,2,:,ICHARG), APM=AROTPM(:,:,2,:,ICHARG))
    ELSE
       stop 'wrong ISIMPY or KETA_R in rotavr'
    ENDIF
!=======================================================================
!Tr[(Jy.kAPPa)(Jy.kAPPa')*] and 2[Jy.kAPPa.Jy]
!=======================================================================
    IF (IPAHFB.EQ.1.AND.KETA_R.GT.0) THEN
       IF(ISIMPY.EQ.1 .AND. KETA_R.NE.2)then
          CALL PAIXSD(MREVER,ISIMPY,KETA_R,PROTSQ(2),PKOTSQ(2),HAUXIJ,KAI_PM,KAI2PM)
       ELSEIF(ISIMPY.EQ.0 .AND. KETA_R.NE.2)then
          CALL PAIXSD(MREVER,ISIMPY,KETA_R,PROTSQ(2),PKOTSQ(2),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP)
       ELSEIF(ISIMPY.EQ.1 .AND.  KETA_R.EQ.2)then
          CALL PAIXSD(MREVER,ISIMPY,KETA_R,PROTSQ(2),PKOTSQ(2),HAUXIJ,KAI_PM,KAI2PM,PPM=PROTPM(:,:,2,:,ICHARG))
       ELSEIF(ISIMPY.EQ.0 .AND.  KETA_R.EQ.2)then
          CALL PAIXSD(MREVER,ISIMPY,KETA_R,PROTSQ(2),PKOTSQ(2),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP,&
                      PPM=PROTPM(:,:,2,:,ICHARG),PPP=PROTPP(:,:,2,:,ICHARG))
       ELSE
         stop 'wrong ISIMPY or KETA_R in rotavr'
       ENDIF
    END IF
!=======================================================================
![Jy^2]
!=======================================================================
    CALL INTLY2(HAUXIL,FACTOR)
    HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIL(1:NDBASE,1:NDBASE)
    HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIL(1:NDBASE,1:NDBASE)
!
    CALL INT_LY(IPHAPP(0,0,2),HAUXIL,FACTOR)
    HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIJ(1:NDBASE,1:NDBASE,0)+UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)

    HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIJ(1:NDBASE,1:NDBASE,1)-UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!
    DO IBRA=1,LDBASE
       HAUXIJ(IBRA,IBRA,0)=HAUXIJ(IBRA,IBRA,0)+CMPLX(0.25D0,0.0D0)
       HAUXIJ(IBRA,IBRA,1)=HAUXIJ(IBRA,IBRA,1)+CMPLX(0.25D0,0.0D0)
    END DO
!=======================================================================
!Tr[(Jy^2.rho]
!=======================================================================
    CALL AVRXSD(HAUXIJ,DROTSQ(2),DKOTSQ(2),RHO_PP)
 END IF
!
!=======================================================================
!    HERE ALL TERMS ARE COMBINED INTO THE AVERAGE OF THE SQUARE OF
!    THE TOTAL ANGULAR MOMENTUM.
!=======================================================================
 DO KARTEZ=1,NDKART
    TROTSQ(KARTEZ)=DROTSQ(KARTEZ)-EROTSQ(KARTEZ)&
                  +PROTSQ(KARTEZ)&
                  +AROTLI(KARTEZ)**2
    TKOTSQ(KARTEZ)=DKOTSQ(KARTEZ)-EKOTSQ(KARTEZ)&
                  +PKOTSQ(KARTEZ)&
                  +AKOTLI(KARTEZ)**2
 END DO
!
 DO KARTEZ=1,NDKART
    DROTSQ(0)=DROTSQ(0)+DROTSQ(KARTEZ)
    EROTSQ(0)=EROTSQ(0)+EROTSQ(KARTEZ)
    PROTSQ(0)=PROTSQ(0)+PROTSQ(KARTEZ)
    TROTSQ(0)=TROTSQ(0)+TROTSQ(KARTEZ)
    AROTLI(0)=AROTLI(0)+AROTLI(KARTEZ)**2
    PROTLI(0)=PROTLI(0)+PROTLI(KARTEZ)**2
    PROTKI(0)=PROTKI(0)+PROTKI(KARTEZ)**2
!
    DKOTSQ(0)=DKOTSQ(0)+DKOTSQ(KARTEZ)
    EKOTSQ(0)=EKOTSQ(0)+EKOTSQ(KARTEZ)
    PKOTSQ(0)=PKOTSQ(0)+PKOTSQ(KARTEZ)
    TKOTSQ(0)=TKOTSQ(0)+TKOTSQ(KARTEZ)
    AKOTLI(0)=AKOTLI(0)+AKOTLI(KARTEZ)**2
    PKOTLI(0)=PKOTLI(0)+PKOTLI(KARTEZ)**2
    PKOTKI(0)=PKOTKI(0)+PKOTKI(KARTEZ)**2
 END DO
!=======================================================================
!Deallocate work space
!=======================================================================
 DEALLOCATE (HAUXIL)
 DEALLOCATE (HAUXIJ)
 DEALLOCATE (RHO_PP)
 IF(ISIMPY.NE.1) DEALLOCATE (RHO_PM)
 IF(IPAHFB.EQ.1.AND.KETA_R.GT.0) DEALLOCATE (KAI_PM,KAI2PM)
 IF(IPAHFB.EQ.1.AND.KETA_R.GT.0.AND.ISIMPY.NE.1) DEALLOCATE (KAI_PP,KAI2PP)
!=======================================================================
 CALL CPUTIM('ROTAVR',0)
 RETURN
END SUBROUTINE ROTAVR
!=======================================================================
SUBROUTINE RENINE(MIN_QP,IRENIN,IDOGOA,&
                  KSIMTX,JSIMTY,KSIMTZ,KSIGNY,KSIMPY,KSIQTY,&
                         IPAHFB,IROTAT,ITIREP,KREVER,IPNMIX,&
                  IDEVAR,ITERUN,NMUCOU,ISHIFY,NUMCOU,BOUCOU,&
                  ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE,&
                  NOSCIL,NUMETA,NFICOU,FILCOU,ICOULI,ICOULO,&
                         IN_FIX,IZ_FIX,ICANRP,I_SLOW,SLOWRP)
!=======================================================================
 USE SAVLEF
 USE SAVRIG
 USE PD_DEN
 USE WAVR_L
 USE HCOULO
 USE OFFDIA, ONLY:RMATCN,ROTWLR,VRVMAT,H_KERN
!=======================================================================
 USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 CHARACTER::FILCOU*68
 INTEGER::MIN_QP,IRENIN,IDOGOA,&
          KSIMTX,JSIMTY,KSIMTZ,KSIGNY,KSIMPY,KSIQTY,&
                 IPAHFB,IROTAT,ITIREP,KREVER,IPNMIX,&
          IDEVAR,ITERUN,NMUCOU,ISHIFY,NUMCOU,ISYMDE,&
          INIROT,INIINV,INIKAR,ISAWAV,IKERNE,&
          NOSCIL,NUMETA,NFICOU,ICOULI,ICOULO,&
          IN_FIX,IZ_FIX,ICANRP,I_SLOW
 REAL   ::BOUCOU,SLOWRP
!=======================================================================
 CHARACTER::NAMEPN*8,FCOUOF*68,CLAB*10
 LOGICAL::PRINIT,CORROT
 INTEGER::IALLOC,JMULMO,JDKART,ICANON,IEXTEN,IFULLD,INROTA,ICHARG,IDKART,KETA_R,&
          LTIMUP,LUPPER,LTOTAL,LDPNMX,MREVER,ISIMPY,ISIGNY,ISIQTY,INPCOU,I_SUCC,&
          ITRUNC,IDIGTA,IMASKN,IREINE,ISKYRM,ISIMTX,ISIMTZ,NLAB
 REAL   ::TSHIFT,H2PARA,A_PARA,REINER,GOAMAS,BAREKE
 COMPLEX::C_ZERO,C_UNIT,EKESKY,BAREKK
 INTEGER,DIMENSION(0:NDISOS)::LSTEMP,LUTEMP,LTTEMP,LDTEMP
 REAL   ,DIMENSION(0:NDKART)::DROTSQ,EROTSQ,PROTSQ,TROTSQ,AROTLI,PROTLI,PROTKI
 COMPLEX,DIMENSION(0:NDSHIF,1:NDKART,0:NDISOS)::AKKERN
 COMPLEX,DIMENSION(0:NDSHIF,0:NDISOS)::OVKERN,EKKERN,EPKERN,DKKERN
 COMPLEX,DIMENSION(0:NDSHIF)::SKKERN,CDKERN,CXKERN,ETKERN,JTKERN
 COMPLEX,DIMENSION(0:NDKART)::DKOTSQ,EKOTSQ,PKOTSQ,TKOTSQ,AKOTLI,PKOTLI,PKOTKI
 COMPLEX,ALLOCATABLE::COUHPP(:,:),COUHPM(:,:)
!=======================================================================
 INTEGER::LDBASE,LDTOTS,LDSTAT,LDUPPE,LDTIMU,NFIPRI,ITESTA,ITESTO,NOITER,NUMITE
 REAL   ::ALPROT,BETROT,GAMROT,ROTATX,ROTATY,ROTATZ,HBMASS,HBMRPA,HBMINP,ROTREN,&
          GOAREN,GOAREI,ROTRIN
!
 REAL   ::COMULT
 COMPLEX::QMUT_N,QMUT_P,QMUT_T,QMUL_N,QMUL_P,QMUL_T
 REAL   ,DIMENSION(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)::COM_TMP
 COMPLEX,DIMENSION(0:NDMULT,-NDMULT:NDMULT)::QTN_TMP,QTP_TMP,QTT_TMP,QLN_TMP,QLP_TMP,QLT_TMP
!
 COMMON /QMUTTI/ QMUT_N(0:NDMULT,-NDMULT:NDMULT),QMUT_P(0:NDMULT,-NDMULT:NDMULT),QMUT_T(0:NDMULT,-NDMULT:NDMULT)
 COMMON /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),QMUL_P(0:NDMULT,-NDMULT:NDMULT),QMUL_T(0:NDMULT,-NDMULT:NDMULT)
 COMMON /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
!
! REAL   ::COEYLM,QUNITS
! INTEGER::NREYLM,KREYLM,NIMYLM,KIMYLM
! REAL   ,DIMENSION(0:NDMULT,0:NDMULT)::COETMP,QUNTMP
! INTEGER,DIMENSION(0:NDMULT,0:NDMULT)::NRETMP
! INTEGER,DIMENSION(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART)::KRETMP
! INTEGER,DIMENSION(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)::KIMTMP
! INTEGER,DIMENSION(0:NDMULT,1:NDMULT)::NIMTMP
! COMMON /DATYLM/ COEYLM(0:NDMULT,0:NDMULT),NREYLM(0:NDMULT,0:NDMULT),KREYLM(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),&
!                 NIMYLM(0:NDMULT,1:NDMULT),KIMYLM(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
! COMMON /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
!
 COMMON /RANGLE/ ALPROT,BETROT,GAMROT
 COMMON /DIMENS/ LDBASE
 COMMON /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
 COMMON /ROTATT/ ROTATX,ROTATY,ROTATZ
 COMMON /PLANCK/ HBMASS,HBMRPA,HBMINP
 COMMON /RENROT/ ROTREN(NDKART)
 COMMON /RENGOA/ GOAREN(NDKART),GOAREI(NDKART)
 COMMON /CFIPRI/ NFIPRI
 COMMON /ITERTS/ ITESTA,ITESTO,NOITER,NUMITE
 COMMON /RINROT/ ROTRIN(NDKART)
!=======================================================================
 CALL CPUTIM('RENINE',1)
!=======================================================================
 IALLOC=0
 C_ZERO=CMPLX(0.0D0,0.0D0)
 C_UNIT=CMPLX(1.0D0,0.0D0)
!=======================================================================
 IF (.NOT.ALLOCATED(WARIGH)) THEN
     ALLOCATE (WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
     IF (IALLOC.NE.0) CALL NOALLO('WARIGH','RENINE')
     WARIGH(:,:,:)=C_ZERO
 END IF
 IF (.NOT.ALLOCATED(WALEFT)) THEN
     ALLOCATE (WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
     IF (IALLOC.NE.0) CALL NOALLO('WALEFT','RENINE')
     WALEFT(:,:,:)=C_ZERO
 END IF
!=======================================================================
 ALLOCATE (COUHPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('COUHPP','RENINE')
 ALLOCATE (COUHPM(1:NDBASE,1:NDBASE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('COUHPM','RENINE')
!=======================================================================
!
!=======================================================================
!         THIS SUBROUTINE CALCULATES THE INERTIA RENORMALIZATION FACTORS
!=======================================================================
 NAMEPN='DUMMY   '
 PRINIT=.FALSE.
 JMULMO=NMUCOU
 CORROT=.TRUE.
 KETA_R=0
!=======================================================================
!         STORING THE COULOMB MATRIX ELEMENTS AND SO ON.
!         THESE WILL BE RETURNED AFTER THE INERTIA RENORMALIZATION.
!=======================================================================
                  COUHPP(:,:)=HPPCOU(:,:)
 IF (KSIMPY.NE.1) COUHPM(:,:)=HPMCOU(:,:)
!
 COM_TMP=COMULT
 QTN_TMP=QMUT_N
 QTP_TMP=QMUT_P
 QTT_TMP=QMUT_T
 QLN_TMP=QMUL_N
 QLP_TMP=QMUL_P
 QLT_TMP=QMUL_T
! COETMP=COEYLM
! NRETMP=NREYLM
! KRETMP=KREYLM
! NIMTMP=NIMYLM
! KIMTMP=KIMYLM
! QUNTMP=QUNITS

 LSTEMP(:)=LDTOTS(:)
 LUTEMP(:)=LDUPPE(:)
 LTTEMP(:)=LDTIMU(:)
 LDTEMP(:)=LDSTAT(:)
!go to 1
!=======================================================================
!STORE SYMMETRY PARAMETERS,
!THESE VALUES MAY BE CHANGED DEPENDING ON ROTATION AXIS
!=======================================================================
 ISIMPY=KSIMPY
 ISIGNY=KSIGNY
 ISIQTY=KSIQTY
 ISIMTX=KSIMTX
 ISIMTZ=KSIMTZ
 MREVER=KREVER
!
 JDKART = 0
 ICANON = ABS(ICANRP)!calculate under canonical basis
 IFULLD = 0
 IEXTEN = 0!extend mrever=0 wave function to mrever=1
 IF(ICANRP .EQ. -1) IFULLD=1!use full canonical basis when ICANRP=-1
 IF(ABS(ROTATX).GT. 1.0D-8)THEN!WHEN ROTATING ALONG X OR Z AXIX, SYMEMTRY WOULD BE BROKEN
    ISIMPY = 0
    ISIGNY = 0
    ISIMTZ = 0
!
    IF(KREVER.EQ.0)THEN!After rotate along x or z axis ,wave function would have off diagonal part, both simplex block is need.
       IEXTEN=1
    ENDIF
 ENDIF
 IF(ABS(ROTATZ).GT. 1.0D-8)THEN!WHEN ROTATING ALONG X OR Z AXIX, SYMEMTRY WOULD BE BROKEN
    ISIMPY = 0
    ISIGNY = 0
    ISIMTX = 0
!
    IF(KREVER.EQ.0)THEN!After rotate along x or z axis ,wave function would have off diagonal part, both simplex block is need.
       IEXTEN=1
    ENDIF
 ENDIF
 IF(IEXTEN.EQ.1) MREVER=1!use both simpliex block
 IF(IPAHFB.NE.1) ICANON=0!in HF and HFB+canonical case one dosen't need to transform into canonical basis
!=======================================================================
!CHECK INPUT PARAMTER
!=======================================================================
 IF (KREVER.EQ.0 .AND. ICANON.EQ.0 .AND.(ABS(ROTATX) .GT. 1.0d-8 .OR. ABS(ROTATZ) .GT. 1.0d-8))&
    STOP ' ROTATION ALONG X OR Z WITH MREVER=0 IN RENINE'
 IF ((ABS(ROTATX).GT. 1.0d-8).AND.(ABS(ROTATY).GT. 1.0d-8).OR.&
     (ABS(ROTATY).GT. 1.0d-8).AND.(ABS(ROTATZ).GT. 1.0d-8).OR.&
     (ABS(ROTATZ).GT. 1.0d-8).AND.(ABS(ROTATX).GT. 1.0d-8))&
    STOP ' ROTATION ALONG MULTIPLE DIRECTION NOT IMPLEMENTED YET in RENINE'
 IF ((ABS(ROTATX).LE. 1.0d-8).AND.(ABS(ROTATY).LE. 1.0d-8).AND.(ABS(ROTATZ).LE. 1.0d-8))&
    STOP ' NO ROTATION ANGLE DETECTED'
! IF (ICANON.GT.0 .AND. KSIMPY.NE.1) STOP 'ICANON>0 WITH ISIMPY =0 NOT IMPLINENTED YET in RENINE'
! IF (ICANON.EQ.0 .AND. IFULLD.EQ.1) STOP 'ONLY FULL CANONICAL BASIS ARE STORED'
 IF (IRENIN.GT.NDSHIF) STOP ' IRENIN.GT.NDSHIF IN RENINE'
! IF (IEXTEN.EQ.1 .AND. (KREVER.EQ.1 .OR. ICANON.EQ.0)) STOP 'IEXTEN=1 needs KREVER=0 and ICANON>0 in RENINE'
!=======================================================================
!    TREAT COULOMB PART WHEN SYMMETRY IS BROKEN INSIDE THIS ROUTINE
!=======================================================================
 IF(ISIMPY.NE.KSIMPY .OR. ISIGNY.NE.KSIGNY .OR. ISIQTY.NE.KSIQTY )THEN
    CALL MULCOU(ISIMPY,ISIGNY,ISIQTY,NMUCOU)
    FCOUOF=TRIM(FILCOU)//'OFD'
    IF(ITESTA.EQ.NUMITE)THEN!DO CALCULATION ONLY AT THE FIRST ITERATION
      ICOULI=0
      ICOULO=1
      CALL PRECOU(NOSCIL,NUMCOU,NUMETA,BOUCOU,NFICOU,FCOUOF,ICOULI,ICOULO)
    ELSE!READ FROM FILE
      INPCOU=1
      I_SUCC=1
      OPEN(NFICOU,FILE=FCOUOF,STATUS='OLD',FORM='UNFORMATTED')
      CALL RECOUL(NFICOU,INPCOU,I_SUCC,NUMCOU,NUMETA,BOUCOU)
      CLOSE(NFICOU)
    ENDIF
 ENDIF
!=======================================================================
!         HERE BEGIN THE LOOP THE ROTATION ANGLES.
!=======================================================================
 DO INROTA=IRENIN,0,-1
    IF (ABS(ROTATY) .GT. 1.0d-8) THEN
     ALPROT=0.0d0
     BETROT=INROTA*ROTATY
     GAMROT=0.0d0
    ELSEIF (ABS(ROTATX) .GT. 1.0d-8) THEN
     ALPROT=ATAN(1.0d0)*2.0d0
     BETROT=INROTA*ROTATX
     GAMROT=-ALPROT
    ELSE
     ALPROT=0.0d0
     BETROT=0.0d0
     GAMROT=INROTA*ROTATZ
    ENDIF
!
    DO ICHARG=0,NDISOS
       IF(IFULLD.EQ.1)THEN!USE FULL CANONICAL BASIS
          LDTIMU(ICHARG)=LDBASE
          LDUPPE(ICHARG)=LDBASE*(1+MREVER)
          LDSTAT(ICHARG)=LDBASE*(2+MREVER)
          LDTOTS(ICHARG)=LDBASE*2*(1+MREVER)
       ENDIF
!
       IF(IEXTEN.EQ.1)THEN!modify orbits number countings
          LDUPPE(ICHARG)=LDTIMU(ICHARG)*2
          LDSTAT(ICHARG)=LDTIMU(ICHARG)*3
          LDTOTS(ICHARG)=LDTIMU(ICHARG)*4
       ENDIF
!
       LTOTAL=LDTOTS(ICHARG)
       LUPPER=LDUPPE(ICHARG)
       LTIMUP=LDTIMU(ICHARG)
       IF (LTOTAL.GT.4*NDSTAT)STOP ' LTOTAL.GT.4*NDSTAT IN RENINE'
!=======================================================================
!FETCHING THE LEFT WAVE FUNCTIONS FOR THE GIVEN CHARGE
!AND CALCULATE ROTATED RIGHT WAVE FUNCTIONS MULTIPLYING THE INVERTED OVERLAP MATRIX
!USE 'KSIMPY' ,since symmetry in wave function is broken after this routine is called
!USE 'mrever' since both blocks are already stored, by change lduppe and so on, the extension is done
!=======================================================================
       CALL ROTWLR(MREVER,KSIMPY,ICANON,IDOGOA,IPAHFB,INROTA,IEXTEN,&
                   LDBASE,LTIMUP,LUPPER,LTOTAL,ICHARG,OVKERN(INROTA,ICHARG))
!=======================================================================
!        HERE BEGIN CALCULATIONS OF DENSITIES AND OBSERVABLES
!=======================================================================
!=======================================================================
!        RHO MATRIX
!=======================================================================
       CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH,1)
!=======================================================================
!        KAPPA MATRIX
!=======================================================================
       IF (IDOGOA.EQ.0) THEN
          IF (IPAHFB.EQ.1 .AND. CORROT) CALL PAIMAC(ICHARG,ISIMPY,WALEFT,WARIGH,IKERNE)
!=======================================================================
!        TERMS FOR <|J^2|BETA>
!=======================================================================
          CALL ROTAVR(ISIMPY,ISIGNY,ISIQTY,&
                      IPAHFB,ICHARG,KETA_R,IROTAT,MREVER,CORROT,IKERNE,&
                      DROTSQ,EROTSQ,PROTSQ,TROTSQ,AROTLI,PROTLI,PROTKI,&
                      DKOTSQ,EKOTSQ,PKOTSQ,TKOTSQ,AKOTLI,PKOTLI,PKOTKI)
!
          DKKERN(INROTA,ICHARG)=TKOTSQ(JDKART)
          AKKERN(INROTA,1,ICHARG)=AKOTLI(1)
          AKKERN(INROTA,2,ICHARG)=AKOTLI(2)
          AKKERN(INROTA,3,ICHARG)=AKOTLI(3)
      ELSE
          DKKERN(INROTA,ICHARG)=C_ZERO
          AKKERN(INROTA,1,ICHARG)=C_ZERO
          AKKERN(INROTA,2,ICHARG)=C_ZERO
          AKKERN(INROTA,3,ICHARG)=C_ZERO
      END IF
!=======================================================================
!        <|H|BETA>
!=======================================================================
!goto 1
      ISKYRM=ICHARG
      CALL H_KERN(ISIMTX,JSIMTY,ISIMTZ,ISIGNY,ISIMPY,ISIQTY,&
                  IPAHFB,MREVER,ICHARG,MIN_QP,IPNMIX,ITIREP,NAMEPN,&
                  PRINIT,IDEVAR,ITERUN,ISYMDE,INIROT,INIINV,&
                  INIKAR,ISAWAV,IKERNE,ISHIFY,JMULMO,NUMCOU,&
                  BOUCOU,IN_FIX,IZ_FIX,ISKYRM,&
                  EKKERN(INROTA,ICHARG),EPKERN(INROTA,ICHARG),&
                  BAREKE,BAREKK,CDKERN(INROTA),CXKERN(INROTA),SKKERN(INROTA))
!goto 1
    END DO!END ICHARG=0,NDISOS
!goto 1
!=======================================================================
!        SKYREM PART OF <|H|Ri>
!=======================================================================
!       CALL TRUTOD
!       CALL ESKYRM(ENESKY,ENEVEN,ENEODD,&
!                   ENREAR,ENE_W0,EEVEW0,EODDW0,EKESKY,LDPNMX,0,1)
!       SKKERN(INSHIF)=EKESKY
!=======================================================================
!        <|H|BETA> and <|J^2|BETA>
!=======================================================================
    ETKERN(INROTA)=EKKERN(INROTA,0)+EKKERN(INROTA,1)&
                  +EPKERN(INROTA,0)+EPKERN(INROTA,1)&
                  +CDKERN(INROTA)+CXKERN(INROTA)+SKKERN(INROTA)
    JTKERN(INROTA)=DKKERN(INROTA,0) +DKKERN(INROTA,1)&
                +2*AKKERN(INROTA,1,0)*AKKERN(INROTA,1,1)&
                +2*AKKERN(INROTA,2,0)*AKKERN(INROTA,2,1)
!
! write(*,*)abs(etkern(inrota)),abs(jtkern(inrota)),abs(OVKERN(INROTA,0)*OVKERN(INROTA,1)),inrota
! NLAB=INT((ROTATX+ROTATY+ROTATZ)/3.14*50)
! WRITE(CLAB,'(I3)')NLAB
! OPEN(1,FILE='pf'//trim(adjustl(clab))//'.dat')
! write(1,*)etkern(inrota)-(EPKERN(INROTA,0)+EPKERN(INROTA,1)),&
!           EPKERN(INROTA,0)+EPKERN(INROTA,1),OVKERN(INROTA,0)*OVKERN(INROTA,1)
! close(1)
! stop
 END DO!END INROTA=IRENIN,0
!=======================================================================
!        BELOW WE DEFINE THE LIPKIN PARAMETERS, WHICH ARE POSITIVE
!=======================================================================
 IF (IDOGOA.EQ.0) THEN
    REINER=(ETKERN(IRENIN)-ETKERN(0))/(JTKERN(IRENIN)-JTKERN(0))
 ELSE
    TSHIFT=IRENIN**2*(ROTATX**2+ROTATY**2+ROTATZ**2)
!
    H2PARA=-2*   (ETKERN(IRENIN)  -ETKERN(0)       )/TSHIFT
    A_PARA=-2*LOG(OVKERN(IRENIN,0)*OVKERN(IRENIN,1))/TSHIFT
!
    GOAMAS=H2PARA/(2*A_PARA**2)
    IF (MREVER.EQ.0) GOAMAS=GOAMAS/4
! MREVER.EQ.0 with shifting or rotating is not allowed yet
! But this option is still kept inside RENMAS and RENINE.
    REINER=GOAMAS
 END IF
!=======================================================================
!   Only keep a given digital of lipkin parameter to accelate converge
!=======================================================================
 ITRUNC=1
 IDIGTA=8
 IF(ITRUNC.EQ.1)THEN
    IMASKN=10**IDIGTA
    IREINE=REINER*IMASKN
    REINER=IREINE/(IMASKN*1.0d0)
 ENDIF
! IF(REINER.GE.0.1d0) REINER=5.0d-2
! IF(REINER.LE.0.0d0) REINER=0.0d0
!=======================================================================
!        BELOW WE DEFINE THE COEFFICIENTS OF <J^2>, WHICH ARE NEGATIVE
!=======================================================================
 DO IDKART = 1,NDKART
    IF (ROTRIN(IDKART).LE. 0.0d0)THEN
        ROTREN(IDKART)=-ROTRIN(IDKART)
    ELSE
        IF (I_SLOW.NE.1) THEN
            ROTREN(IDKART)=ROTREN(IDKART)*SLOWRP-REINER*(1-SLOWRP)
!           ROTREN(IDKART)=-ROTRIN(IDKART)
        ELSE
            ROTREN(IDKART)=-REINER
        ENDIF
    ENDIF
 ENDDO
!
 GOAREI(1)=-GOAMAS
 GOAREI(2)=-GOAMAS
 GOAREI(3)=-GOAMAS
!=======================================================================
! Rstore quantities temporarily changed inside the routine
!=======================================================================
 LDTOTS(:)=LSTEMP(:)
 LDUPPE(:)=LUTEMP(:)
 LDTIMU(:)=LTTEMP(:)
 LDSTAT(:)=LDTEMP(:)
!
!goto 1
 IF(ISIMPY.NE.KSIMPY .OR. ISIGNY.NE.KSIGNY .OR. ISIQTY.NE.KSIQTY )THEN
    CALL MULCOU(KSIMPY,KSIGNY,KSIQTY,NMUCOU)
    OPEN(NFICOU,FILE=FILCOU,STATUS='OLD',FORM='UNFORMATTED')
    INPCOU=1
    I_SUCC=1
    CALL RECOUL(NFICOU,INPCOU,I_SUCC,NUMCOU,NUMETA,BOUCOU)
    CLOSE(NFICOU)
 ENDIF
! CALL MOMETS(ISIMPY,ISIGNY,ISIQTY,QMUL_P,QMUT_P,COMULT,JMULMO,ISHIFY)
                 HPPCOU(:,:)=COUHPP(:,:)
 IF (ISIMPY.NE.1)HPMCOU(:,:)=COUHPM(:,:)
! COEYLM=COETMP
! NREYLM=NRETMP
! KREYLM=KRETMP
! NIMYLM=NIMTMP
! KIMYLM=KIMTMP
! QUNITS=QUNTMP
 COMULT=COM_TMP
 QMUT_N=QTN_TMP
 QMUT_P=QTP_TMP
 QMUT_T=QTT_TMP
 QMUL_N=QLN_TMP
 QMUL_P=QLP_TMP
 QMUL_T=QLT_TMP
1 continue
!=======================================================================
 CALL CPUTIM('RENINE',0)
 RETURN
 END SUBROUTINE RENINE
!=======================================================================
SUBROUTINE LINAVR(ISIMPY,ISIGNY,ISIQTY,&
                  IPAHFB,ICHARG,JETACM,IROTAT,MREVER,COR_CM,IKERNE,&
                  DLINSQ,ELINSQ,PLINSQ,TLINSQ,ALINLI,PLINLI,PLINKI,&
                  DKINSQ,EKINSQ,PKINSQ,TKINSQ,AKINLI,PKINLI,PKINKI)
!=======================================================================
USE MAT_PP
USE MAT_PM
USE MAD_PP
USE MAD_PM
USE KAP_PM
USE KAP2PM
USE KAP_PP
USE KAP2PP
USE MAP_PP
USE MAP_PM
USE ALISTO
USE PLISTO
USE O2AVRG
! USE OSQUARE
!=======================================================================
USE hfodd_sizes
!=======================================================================
IMPLICIT NONE
!=======================================================================
 LOGICAL::COR_CM
 INTEGER::ISIMPY,ISIGNY,ISIQTY,IPAHFB,ICHARG,JETACM,IROTAT,MREVER,IKERNE
 REAL   ::DLINSQ(0:NDKART),ELINSQ(0:NDKART),PLINSQ(0:NDKART),TLINSQ(0:NDKART),&
          ALINLI(0:NDKART),PLINLI(0:NDKART),PLINKI(0:NDKART)
 COMPLEX::DKINSQ(0:NDKART),EKINSQ(0:NDKART),PKINSQ(0:NDKART),TKINSQ(0:NDKART),&
          AKINLI(0:NDKART),PKINLI(0:NDKART),PKINKI(0:NDKART)
!
 INTEGER::IALLOC,IBRA,KARTEZ,IMSIGN
 REAL   ::FACTOR
 COMPLEX:: RESULT,C_ZERO,UNIT_I
 REAL   ,ALLOCATABLE:: HAUXIL(:,:)
 COMPLEX,ALLOCATABLE:: HAUXIJ(:,:,:)
 COMPLEX,ALLOCATABLE:: RHO_PP(:,:,:),RHO_PM(:,:,:),KAI_PM(:,:,:),KAI2PM(:,:,:),KAI_PP(:,:,:),KAI2PP(:,:,:)
!
 INTEGER::IPHAPP,IPHAPM,IPHAMP,IPHAMM,LDBASE,ITESTA,ITESTO,NOITER,NUMITE
 COMMON /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),&
                 IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
 COMMON /DIMENS/ LDBASE
 COMMON /ITERTS/ ITESTA,ITESTO,NOITER,NUMITE
!=======================================================================
 CALL CPUTIM('LINAVR',1)
 IALLOC=0
 !
 C_ZERO=CMPLX(0.0D0,0.0D0)
 UNIT_I=CMPLX(0.0D0,1.0D0)
 FACTOR=1.0D0
!=======================================================================
!allocate space for 2[J.rho.J] and 2[J.kappa.J] matrix
!=======================================================================
 IF(JETACM.EQ.2)THEN
    IF(.NOT.ALLOCATED(ALINPP))THEN
       ALLOCATE(ALINPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('ALINPP','LINAVR')
    ENDIF
    IF(.NOT.ALLOCATED(PLINPM) .AND. IPAHFB.EQ.1)THEN
       ALLOCATE(PLINPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('PLINPM','LINAVR')
    ENDIF
!
    IF(ISIMPY.NE.1)THEN
       IF(.NOT.ALLOCATED(ALINPM))THEN
          ALLOCATE(ALINPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('ALINPM','LINAVR')
       ENDIF
       IF(.NOT.ALLOCATED(PLINPP) .AND. IPAHFB.EQ.1)THEN
          ALLOCATE(PLINPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('PLINPP','LINAVR')
       ENDIF
    ENDIF
 ENDIF
!=======================================================================
!allocate space for rho and kappa in case they are not allocated yet
!=======================================================================
 IF(.NOT.ALLOCATED(BIG_PP)) THEN
    ALLOCATE(BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('BIG_PP','LINAVR')
 ENDIF
 IF(.NOT.ALLOCATED(DEN_PP)) THEN
    ALLOCATE(DEN_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('DEN_PP','LINAVR')
 ENDIF
!
 IF(.NOT.ALLOCATED(CHI_PM) .AND. IPAHFB.EQ.1)THEN
    ALLOCATE(CHI_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS), STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('CHI_PM','LINAVR')
 ENDIF
!
 IF(ISIMPY.NE.1)THEN
    IF(.NOT.ALLOCATED(BIG_PM))THEN
        ALLOCATE (BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
        IF (IALLOC.NE.0) CALL NOALLO('BIG_PM','LINAVR')
    END IF
    IF(.NOT.ALLOCATED(DEN_PM))THEN
        ALLOCATE (DEN_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),STAT=IALLOC)
        IF (IALLOC.NE.0) CALL NOALLO('DEN_PM','LINAVR')
    ENDIF
!
    IF (.NOT.ALLOCATED(CHI_PP) .AND. IPAHFB.EQ.1)THEN
       ALLOCATE (CHI_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('CHI_PP','LINAVR')
    END IF
 ENDIF
!=======================================================================
!allocate work space
!=======================================================================
 ALLOCATE (HAUXIL(1:NDBASE,1:NDBASE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('HAUXIL','LINAVR')
 ALLOCATE (HAUXIJ(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('HAUXIJ','LINAVR')
!
 ALLOCATE (RHO_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('RHO_PP','LINAVR')
!
 IF(ISIMPY.NE.1)THEN
    ALLOCATE (RHO_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('RHO_PM','LINAVR')
 ENDIF
!
 IF (IPAHFB.EQ.1.AND.JETACM.GT.0) THEN
    ALLOCATE (KAI_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('KAI_PM','LINAVR')
    ALLOCATE (KAI2PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
    IF (IALLOC.NE.0) CALL NOALLO('KAI2PM','LINAVR')
!
    IF(ISIMPY.NE.1)THEN
       ALLOCATE (KAI_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('KAI_PP','LINAVR')
       ALLOCATE (KAI2PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
       IF (IALLOC.NE.0) CALL NOALLO('KAI2PP','LINAVR')
    ENDIF
 ENDIF
 IF (JETACM.NE.2)THEN
     IF(.NOT.ALLOCATED(BIG_PP)) STOP 'BIG_PP NOT ALLOCATED IN LINAVR'
     IF(.NOT.ALLOCATED(BIG_PM).AND.ISIMPY.NE.1) STOP 'BIG_PM NOT ALLOCATED IN LINAVR'
     IF(.NOT.ALLOCATED(PAI_PM).AND.IPAHFB.EQ.1.AND.JETACM.GT.0) STOP 'PAI_PM NOT ALLOCATED IN LINAVR'
     IF(.NOT.ALLOCATED(PAI2PM).AND.IPAHFB.EQ.1.AND.JETACM.GT.0.AND.IKERNE.EQ.1) STOP 'PAI2PM NOT ALLOCATED IN LINAVR'
     IF(.NOT.ALLOCATED(PAI_PP).AND.IPAHFB.EQ.1.AND.JETACM.GT.0.AND.ISIMPY.NE.1) STOP 'PAI_PP NOT ALLOCATED IN LINAVR'
     IF(.NOT.ALLOCATED(PAI2PP).AND.IPAHFB.EQ.1.AND.JETACM.GT.0.AND.ISIMPY.NE.1.AND.IKERNE.EQ.1) STOP 'PAI2PP NOT ALLOCATED IN LINAVR'
 ENDIF
!=======================================================================
!    ZEROING ARRAYS OF AVERAGE VALUES
!=======================================================================
 DLINSQ(:)=0.0D0
 ELINSQ(:)=0.0D0
 PLINSQ(:)=0.0D0
 TLINSQ(:)=0.0D0
 ALINLI(:)=0.0D0
 PLINLI(:)=0.0D0
 PLINKI(:)=0.0D0
!
 DKINSQ(:)=C_ZERO
 EKINSQ(:)=C_ZERO
 PKINSQ(:)=C_ZERO
 TKINSQ(:)=C_ZERO
 AKINLI(:)=C_ZERO
 PKINLI(:)=C_ZERO
 PKINKI(:)=C_ZERO
!
 IF(JETACM.EQ.2)THEN
                    ALINPP(:,:,:,:,ICHARG)=C_ZERO
    IF(ISIMPY.NE.1) ALINPM(:,:,:,:,ICHARG)=C_ZERO
!
    IF(IPAHFB.EQ.1)THEN
                        PLINPM(:,:,:,:,ICHARG)=C_ZERO
       IF (ISIMPY.NE.1) PLINPP(:,:,:,:,ICHARG)=C_ZERO
    ENDIF
 ENDIF
!
                 RHO_PP(:,:,:)=C_ZERO
 IF(ISIMPY.NE.1) RHO_PM(:,:,:)=C_ZERO
 IF (IPAHFB.EQ.1.AND.JETACM.GT.0) THEN
    KAI_PM(:,:,:)=C_ZERO
    KAI2PM(:,:,:)=C_ZERO
     IF(ISIMPY.NE.1) THEN
        KAI_PP(:,:,:)=C_ZERO
        KAI2PP(:,:,:)=C_ZERO
     ENDIF
 ENDIF
!
 IF (JETACM.EQ.2) THEN !when calculating matrix element,use mixed rho and kappa
    IF(ITESTA.EQ.NUMITE) THEN!initial den, chi at the first iteration
                        DEN_PP(:,:,:,ICHARG)= BIG_PP(:,:,:)
       IF (ISIMPY.NE.1) DEN_PM(:,:,:,ICHARG)= BIG_PM(:,:,:)
       IF (IPAHFB.EQ.1) THEN
                           CHI_PM(:,:,:,ICHARG)=PAI_PM(:,:,:)
          IF (ISIMPY.NE.1) CHI_PP(:,:,:,ICHARG)=PAI_PP(:,:,:)
       ENDIF
    ENDIF
!
                     RHO_PP(:,:,:)=DEN_PP(:,:,:,ICHARG)
    IF (ISIMPY.NE.1) RHO_PM(:,:,:)=DEN_PM(:,:,:,ICHARG)
    IF (IPAHFB.EQ.1) THEN
       KAI_PM(:,:,:)=CHI_PM(:,:,:,ICHARG)
       KAI2PM(:,:,:)=CHI_PM(:,:,:,ICHARG) ! ANALYZE THAT
       IF (ISIMPY.NE.1)THEN
          KAI_PP(:,:,:)=CHI_PP(:,:,:,ICHARG)
          KAI2PP(:,:,:)=CHI_PP(:,:,:,ICHARG)
       ENDIF
    ENDIF
!
 ELSE!when there is no correction or inside RENMAS, use rho and kappa from DENMAC and PAIMAC
                     RHO_PP(:,:,:)=BIG_PP(:,:,:)
    IF (ISIMPY.NE.1) RHO_PM(:,:,:)=BIG_PM(:,:,:)
    IF (IPAHFB.EQ.1.AND.JETACM.GT.0) THEN
        KAI_PM(:,:,:)=PAI_PM(:,:,:)
        IF (IKERNE.EQ.1) THEN
            KAI2PM(:,:,:)=PAI2PM(:,:,:)
        ELSE
            KAI2PM(:,:,:)=PAI_PM(:,:,:)
        ENDIF
        IF (ISIMPY.NE.1) THEN
            KAI_PP(:,:,:)=PAI_PP(:,:,:)
            IF (IKERNE.EQ.1) THEN
                KAI2PP(:,:,:)=PAI2PP(:,:,:)
            ELSE
                KAI2PP(:,:,:)=PAI_PP(:,:,:)
            ENDIF
        ENDIF
    ENDIF
 ENDIF
!=======================================================================
!                         X-DIRECTION
!=======================================================================
!
!=======================================================================
![Px]
!=======================================================================
 CALL INT_PX(IPHAPP(0,0,0),HAUXIL,FACTOR)
 HAUXIJ(1:NDBASE,1:NDBASE,0)= UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
 HAUXIJ(1:NDBASE,1:NDBASE,1)= UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!=======================================================================
!Tr[Px.rho]
!=======================================================================
 CALL AVRXSD(HAUXIJ,ALINLI(1),AKINLI(1),RHO_PP)
!
 IF (COR_CM) THEN
    IMSIGN=-1
!=======================================================================
!Tr[(Px.rho)^2] and 2[Px.rho.Px]
!=======================================================================

    IF(ISIMPY.EQ.1 .AND. JETACM.NE.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(1),EKINSQ(1),HAUXIJ,RHO_PP)
    ELSEIF(ISIMPY.EQ.0 .AND. JETACM.NE.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(1),EKINSQ(1),HAUXIJ,RHO_PP,RPM=RHO_PM)
    ELSEIF(ISIMPY.EQ.1 .AND.  JETACM.EQ.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(1),EKINSQ(1),HAUXIJ,RHO_PP,APP=ALINPP(:,:,1,:,ICHARG))
    ELSEIF(ISIMPY.EQ.0 .AND.  JETACM.EQ.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(1),EKINSQ(1),HAUXIJ,RHO_PP,RPM=RHO_PM,&
                   APP=ALINPP(:,:,1,:,ICHARG),APM=ALINPM(:,:,1,:,ICHARG))
    ELSE
       stop 'wrong ISIMPY or JETACM in LINAVR'
    ENDIF
!=======================================================================
!Tr[(Px.kappa)(Px.kappa')*] and 2[Px.kappa.Px]
!=======================================================================
    IF (IPAHFB.EQ.1.AND.JETACM.GT.0) THEN
       IF(ISIMPY.EQ.1 .AND. JETACM.NE.2)then
          CALL PAIXSD(MREVER,ISIMPY,JETACM,PLINSQ(1),PKINSQ(1),HAUXIJ,KAI_PM,KAI2PM)
       ELSEIF(ISIMPY.EQ.0 .AND. JETACM.NE.2)then
          CALL PAIXSD(MREVER,ISIMPY,JETACM,PLINSQ(1),PKINSQ(1),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP)
       ELSEIF(ISIMPY.EQ.1 .AND.  JETACM.EQ.2)then
          CALL PAIXSD(MREVER,ISIMPY,JETACM,PLINSQ(1),PKINSQ(1),HAUXIJ,KAI_PM,KAI2PM,PPM=PLINPM(:,:,1,:,ICHARG))
       ELSEIF(ISIMPY.EQ.0 .AND.  JETACM.EQ.2)then
          CALL PAIXSD(MREVER,ISIMPY,JETACM,PLINSQ(1),PKINSQ(1),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP,&
                      PPM=PLINPM(:,:,1,:,ICHARG),PPP=PLINPP(:,:,1,:,ICHARG))
       ELSE
         stop 'wrong ISIMPY or JETACM in LINAVR'
       ENDIF
    END IF

!=======================================================================
![Px^2]
!=======================================================================
    CALL INTPX2(IPHAPP(0,0,0),HAUXIL,FACTOR)
    HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIL(1:NDBASE,1:NDBASE)
    HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIL(1:NDBASE,1:NDBASE)
!=======================================================================
!Tr[Px^2.rho]
!=======================================================================
    CALL AVRXSD(HAUXIJ,DLINSQ(1),DKINSQ(1),RHO_PP)
 END IF
!=======================================================================
!                         Z-DIRECTION
!=======================================================================
!
!=======================================================================
![Pz]
!=======================================================================
 CALL INT_PZ(IPHAPP(0,0,0),HAUXIL,FACTOR)
 HAUXIJ(1:NDBASE,1:NDBASE,0)=UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
 HAUXIJ(1:NDBASE,1:NDBASE,1)=UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!=======================================================================
!Tr[Pz.rho]
!=======================================================================
 CALL AVRXSD(HAUXIJ,ALINLI(3),AKINLI(3),RHO_PP)
!
 IF (COR_CM) THEN
    IMSIGN=-1
!=======================================================================
!Tr[(Pz.rho)^2] and 2[Pz.rho.Pz]
!=======================================================================

    IF(ISIMPY.EQ.1 .AND. JETACM.NE.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(3),EKINSQ(3),HAUXIJ,RHO_PP)
    ELSEIF(ISIMPY.EQ.0 .AND. JETACM.NE.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(3),EKINSQ(3),HAUXIJ,RHO_PP,RPM=RHO_PM)
    ELSEIF(ISIMPY.EQ.1 .AND.  JETACM.EQ.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(3),EKINSQ(3),HAUXIJ,RHO_PP,APP=ALINPP(:,:,3,:,ICHARG))
    ELSEIF(ISIMPY.EQ.0 .AND.  JETACM.EQ.2)then
       CALL EXCXSD(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(3),EKINSQ(3),HAUXIJ,RHO_PP,RPM=RHO_PM,&
                   APP=ALINPP(:,:,3,:,ICHARG), APM=ALINPM(:,:,3,:,ICHARG))
    ELSE
       stop 'wrong ISIMPY or JETACM in LINAVR'
    ENDIF
!=======================================================================
!Tr[(Pz.kappa)(Pz.kappa')*] and 2[Pz.kappa.Pz]
!=======================================================================
    IF (IPAHFB.EQ.1.AND.JETACM.GT.0) THEN
       IF(ISIMPY.EQ.1 .AND. JETACM.NE.2)then
          CALL PAIXSD(MREVER,ISIMPY,JETACM,PLINSQ(3),PKINSQ(3),HAUXIJ,KAI_PM,KAI2PM)
       ELSEIF(ISIMPY.EQ.0 .AND. JETACM.NE.2)then
          CALL PAIXSD(MREVER,ISIMPY,JETACM,PLINSQ(3),PKINSQ(3),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP)
       ELSEIF(ISIMPY.EQ.1 .AND.  JETACM.EQ.2)then
          CALL PAIXSD(MREVER,ISIMPY,JETACM,PLINSQ(3),PKINSQ(3),HAUXIJ,KAI_PM,KAI2PM,PPM=PLINPM(:,:,3,:,ICHARG))
       ELSEIF(ISIMPY.EQ.0 .AND.  JETACM.EQ.2)then
          CALL PAIXSD(MREVER,ISIMPY,JETACM,PLINSQ(3),PKINSQ(3),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP,&
                      PPM=PLINPM(:,:,3,:,ICHARG),PPP=PLINPP(:,:,3,:,ICHARG))
       ELSE
         stop 'wrong ISIMPY or JETACM in LINAVR'
       ENDIF
    END IF
!=======================================================================
![Pz^2]
!=======================================================================
    CALL INTPZ2(IPHAPP(0,0,0),HAUXIL,FACTOR)
    HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIL(1:NDBASE,1:NDBASE)
    HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIL(1:NDBASE,1:NDBASE)
!=======================================================================
!Tr[(Pz^2.rho]
!=======================================================================
    CALL AVRXSD(HAUXIJ,DLINSQ(3),DKINSQ(3),RHO_PP)
 END IF
!=======================================================================
!                         Y-DIRECTION
!=======================================================================
!
!=======================================================================
![Py]
!=======================================================================
 CALL INT_PY(IPHAPM(0,0,0),HAUXIL,FACTOR)
 HAUXIJ(1:NDBASE,1:NDBASE,0)= UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
 HAUXIJ(1:NDBASE,1:NDBASE,1)=-UNIT_I*HAUXIL(1:NDBASE,1:NDBASE)
!=======================================================================
!Tr[Py.rho]
!=======================================================================
 IF (ISIMPY.NE.1 ) THEN
 CALL AVRXSO(HAUXIJ,ALINLI(2),AKINLI(2),RHO_PM)
  END IF
!
 IF (COR_CM) THEN
    IMSIGN=1
!=======================================================================
!Tr[(Py.rho)^2] and 2[Py.rho.Py]
!=======================================================================
    IF(ISIMPY.EQ.1 .AND. JETACM.NE.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(2),EKINSQ(2),HAUXIJ,RHO_PP)
    ELSEIF(ISIMPY.EQ.0 .AND. JETACM.NE.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(2),EKINSQ(2),HAUXIJ,RHO_PP,RPM=RHO_PM)
    ELSEIF(ISIMPY.EQ.1 .AND.  JETACM.EQ.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(2),EKINSQ(2),HAUXIJ,RHO_PP,APP=ALINPP(:,:,2,:,ICHARG))
    ELSEIF(ISIMPY.EQ.0 .AND.  JETACM.EQ.2)then
       CALL EXCXSO(IMSIGN,MREVER,ISIMPY,JETACM,ELINSQ(2),EKINSQ(2),HAUXIJ,RHO_PP,RPM=RHO_PM,&
                   APP=ALINPP(:,:,2,:,ICHARG), APM=ALINPM(:,:,2,:,ICHARG))
    ELSE
       stop 'wrong ISIMPY or JETACM in LINAVR'
    ENDIF
!=======================================================================
!Tr[(Py.kappa)(Py.kappa')*] and 2[Py.kappa.Py]
!=======================================================================
    IF (IPAHFB.EQ.1.AND.JETACM.GT.0) THEN
       IF(ISIMPY.EQ.1 .AND. JETACM.NE.2)then
          CALL PAIXSO(MREVER,ISIMPY,JETACM,PLINSQ(2),PKINSQ(2),HAUXIJ,KAI_PM,KAI2PM)
       ELSEIF(ISIMPY.EQ.0 .AND. JETACM.NE.2)then
          CALL PAIXSO(MREVER,ISIMPY,JETACM,PLINSQ(2),PKINSQ(2),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP)
       ELSEIF(ISIMPY.EQ.1 .AND.  JETACM.EQ.2)then
          CALL PAIXSO(MREVER,ISIMPY,JETACM,PLINSQ(2),PKINSQ(2),HAUXIJ,KAI_PM,KAI2PM,PPM=PLINPM(:,:,2,:,ICHARG))
       ELSEIF(ISIMPY.EQ.0 .AND.  JETACM.EQ.2)then
          CALL PAIXSO(MREVER,ISIMPY,JETACM,PLINSQ(2),PKINSQ(2),HAUXIJ,KAI_PM,KAI2PM,KPP1=KAI_PP,KPP2=KAI2PP,&
                      PPM=PLINPM(:,:,2,:,ICHARG),PPP=PLINPP(:,:,2,:,ICHARG))
       ELSE
         stop 'wrong ISIMPY or JETACM in LINAVR'
       ENDIF
    END IF
!=======================================================================
![Py^2]
!=======================================================================
    CALL INTPY2(IPHAPP(0,0,0),HAUXIL,FACTOR)
    HAUXIJ(1:NDBASE,1:NDBASE,0)=HAUXIL(1:NDBASE,1:NDBASE)
    HAUXIJ(1:NDBASE,1:NDBASE,1)=HAUXIL(1:NDBASE,1:NDBASE)
!=======================================================================
!Tr[(Py^2.rho]
!=======================================================================
    CALL AVRXSD(HAUXIJ,DLINSQ(2),DKINSQ(2),RHO_PP)
 END IF
!
!=======================================================================
!    HERE ALL TERMS ARE COMBINED INTO THE AVERAGE OF THE SQUARE OF
!    THE TOTAL LINEAR MOMENTUM.
!=======================================================================
 DO KARTEZ=1,NDKART
    TLINSQ(KARTEZ)=DLINSQ(KARTEZ)-ELINSQ(KARTEZ)+PLINSQ(KARTEZ) +ALINLI(KARTEZ)**2
    TKINSQ(KARTEZ)=DKINSQ(KARTEZ)-EKINSQ(KARTEZ)+PKINSQ(KARTEZ) +AKINLI(KARTEZ)**2
 END DO

 DO KARTEZ=1,NDKART
    DLINSQ(0)=DLINSQ(0)+DLINSQ(KARTEZ)
    ELINSQ(0)=ELINSQ(0)+ELINSQ(KARTEZ)
    PLINSQ(0)=PLINSQ(0)+PLINSQ(KARTEZ)
    TLINSQ(0)=TLINSQ(0)+TLINSQ(KARTEZ)
    ALINLI(0)=ALINLI(0)+ALINLI(KARTEZ)**2
    PLINLI(0)=PLINLI(0)+PLINLI(KARTEZ)**2
    PLINKI(0)=PLINKI(0)+PLINKI(KARTEZ)**2
!
    DKINSQ(0)=DKINSQ(0)+DKINSQ(KARTEZ)
    EKINSQ(0)=EKINSQ(0)+EKINSQ(KARTEZ)
    PKINSQ(0)=PKINSQ(0)+PKINSQ(KARTEZ)
    TKINSQ(0)=TKINSQ(0)+TKINSQ(KARTEZ)
    AKINLI(0)=AKINLI(0)+AKINLI(KARTEZ)**2
    PKINLI(0)=PKINLI(0)+PKINLI(KARTEZ)**2
    PKINKI(0)=PKINKI(0)+PKINKI(KARTEZ)**2
 END DO
!=======================================================================
!Deallocate work space
!=======================================================================
 DEALLOCATE (HAUXIL)
 DEALLOCATE (HAUXIJ)
 DEALLOCATE (RHO_PP)
 IF(ISIMPY.NE.1) DEALLOCATE (RHO_PM)
 IF(IPAHFB.EQ.1.AND.JETACM.GT.0) DEALLOCATE (KAI_PM,KAI2PM)
 IF(IPAHFB.EQ.1.AND.JETACM.GT.0.AND.ISIMPY.NE.1) DEALLOCATE (KAI_PP,KAI2PP)
!=======================================================================
 CALL CPUTIM('LINAVR',0)
 RETURN
END SUBROUTINE LINAVR
!=======================================================================
SUBROUTINE RENMAS(MIN_QP,IRENMA,IDOGOA, &
                  KSIMTX,JSIMTY,KSIMTZ,KSIGNY,KSIMPY,KSIQTY,&
                         IPAHFB,IROTAT,ITIREP,KREVER,IPNMIX,&
                  IDEVAR,ITERUN,NMUCOU,ISHIFY,NUMCOU,BOUCOU,&
                  ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE,&
                  NOSCIL,NUMETA,NFICOU,FILCOU,ICOULI,ICOULO,&
                         IN_FIX,IZ_FIX,ICANTP,I_SLOW,SLOWTP)
!=======================================================================
USE SAVLEF
USE SAVRIG
USE PD_DEN
USE WAVR_L
USE HCOULO
USE OFFDIA, ONLY:LMATCN,LINWLR,VRVMAT,H_KERN
!=======================================================================
USE hfodd_sizes
!=======================================================================
 CHARACTER::FILCOU*68
 CHARACTER::NAMEPN*8,FCOUOF*68
 LOGICAL::PRINIT,COR_CM
 COMPLEX::EKESKY,EKEKIN,EKECOD,EKECOX
!=======================================================================
 COMPLEX::C_ZERO,C_UNIT
 COMPLEX::AVRCMP,BUFCMP
 COMPLEX::EPAIKN,EPAIKP,BAREKK
!=======================================================================
 COMPLEX,ALLOCATABLE::COUHPP(:,:),COUHPM(:,:)
!=======================================================================
 INTEGER,DIMENSION(NDKART)::IREMAS
 COMPLEX,DIMENSION(2)::DETWRK
 COMPLEX,DIMENSION(0:NDSHIF,1:NDKART,0:NDISOS)::AKKERN
 COMPLEX,DIMENSION(0:NDSHIF,0:NDISOS)::OVKERN,EKKERN,EPKERN,DKKERN
 COMPLEX,DIMENSION(0:NDSHIF)::SKKERN,CDKERN,CXKERN,ETKERN
 REAL   ,DIMENSION(0:NDKART)::DLINSQ,ELINSQ,PLINSQ,TLINSQ,ALINLI,PLINLI,PLINKI
 COMPLEX,DIMENSION(0:NDKART)::DKINSQ,EKINSQ,PKINSQ,TKINSQ,AKINLI,PKINLI,PKINKI
 COMPLEX,DIMENSION(0:NDSHIF,1:NDKART)::ETKERS,DKKERS,OVKERS
 REAL   ,DIMENSION(NDKART)::REMASS,GOAMAS
!
 COMPLEX::QMUT_N,QMUT_P,QMUT_T,QMUL_N,QMUL_P,QMUL_T
 REAL   ,DIMENSION(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)::COM_TMP
 COMPLEX,DIMENSION(0:NDMULT,-NDMULT:NDMULT)::QTN_TMP,QTP_TMP,QTT_TMP,QLN_TMP,QLP_TMP,QLT_TMP
!
 COMMON /QMUTTI/ QMUT_N(0:NDMULT,-NDMULT:NDMULT),QMUT_P(0:NDMULT,-NDMULT:NDMULT),QMUT_T(0:NDMULT,-NDMULT:NDMULT)
 COMMON /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),QMUL_P(0:NDMULT,-NDMULT:NDMULT),QMUL_T(0:NDMULT,-NDMULT:NDMULT)
 COMMON /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
!
 COMMON /SVECTO/ BSHIFT(NDKART)
 COMMON /DIMENS/ LDBASE
 COMMON /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
 COMMON /DISTAN/ DISTAX,DISTAY,DISTAZ
 COMMON /PLANCK/ HBMASS,HBMRPA,HBMINP
 COMMON /RENORM/ HBMREN(NDKART)
 COMMON /RENGOA/ GOAREN(NDKART),GOAREI(NDKART)
 COMMON /CFIPRI/ NFIPRI
 COMMON /ITERTS/ ITESTA,ITESTO,NOITER,NUMITE
!=======================================================================
 CALL CPUTIM('RENMAS',1)
!=======================================================================
 IALLOC=0
 !IF(MREVER.EQ.0)STOP 'MREVER=0 in RENMAS'
!=======================================================================
 IF (.NOT.ALLOCATED(WARIGH)) THEN
     ALLOCATE (WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
     IF (IALLOC.NE.0) CALL NOALLO('WARIGH','RENMAS')
     WARIGH(:,:,:)=CMPLX(0.0D0,0.0D0)
 END IF
 IF (.NOT.ALLOCATED(WALEFT)) THEN
     ALLOCATE (WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
     IF (IALLOC.NE.0) CALL NOALLO('WALEFT','RENMAS')
     WALEFT(:,:,:)=CMPLX(0.0D0,0.0D0)
 END IF
!=======================================================================
 ALLOCATE (COUHPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('COUHPP','RENMAS')
 ALLOCATE (COUHPM(1:NDBASE,1:NDBASE),STAT=IALLOC)
 IF (IALLOC.NE.0) CALL NOALLO('COUHPM','RENMAS')
!=======================================================================
!         THIS SUBROUTINE CALCULATES THE MASS RENORMALIZATION FACTORS
!=======================================================================
 C_ZERO=CMPLX(0.0D0,0.0D0)
 C_UNIT=CMPLX(1.0D0,0.0D0)
 SIF=1.0D-8
!
 NAMEPN='DUMMY   '
 PRINIT=.FALSE.
 JMULMO=NMUCOU
 COR_CM=.TRUE.
 JETACM=0
!=======================================================================
!         STORING THE COULOMB MATRIX ELEMENTS. THESE WILL BE RETURNED
!         AFTER THE MASS RENORMALIZATION.
!=======================================================================
                  COUHPP(:,:)=HPPCOU(:,:)
 IF (KSIMPY.NE.1) COUHPM(:,:)=HPMCOU(:,:)
 COM_TMP=COMULT
 QTN_TMP=QMUT_N
 QTP_TMP=QMUT_P
 QTT_TMP=QMUT_T
 QLN_TMP=QMUL_N
 QLP_TMP=QMUL_P
 QLT_TMP=QMUL_T
!
 ICANON=ABS(ICANTP)
 IEXTEN=0
!=======================================================================
!STORE SYMMETRY PARAMETERS,
!THESE VALUES MAY BE CHANGED DEPENDING ON SHIFTING DIRECTION
!=======================================================================
 ISIMPY=KSIMPY
 ISIGNY=KSIGNY
 ISIQTY=KSIQTY
 ISIMTX=KSIMTX
 ISIMTZ=KSIMTZ
 MREVER=KREVER
!
 ISIQTY = 0
 IF(ABS(DISTAX).GT. SIF) THEN
    ISIGNY = 0
    ISIMTZ = 0
 ENDIF
!
 IF(ABS(DISTAY).GT. SIF) THEN
    ISIMPY = 0
    ISIMTX = 0
    ISIMTZ = 0
    IF(KREVER.EQ.0) IEXTEN=1!when breaking time reversal, the stored wave function should be modified to include all simplex blocks
 ENDIF
!
 IF(ABS(DISTAZ).GT. SIF) THEN
    ISIGNY = 0
    ISIMTX = 0
 ENDIF
!
 IF(IEXTEN.EQ.1) MREVER=1
 IF(IPAHFB.NE.1) ICANON=0!
!
!=======================================================================
!CHECK INPUT PARAMTER
!=======================================================================
 IF (KREVER.EQ.0 .AND. ICANON.EQ.0 .AND. ABS(DISTAY).GT. 1.0d-8)&
    STOP 'SHIFTING ALONG Y WITH MREVER=0 IN RENMAS'
! IF (ICANON.GT.0 .AND. KSIMPY.NE.1) STOP 'ICANON>0 WITH ISIMPY =0 NOT IMPLINENTED YET in RENMAS'
 IF (IRENMA.GT.NDSHIF) STOP ' IRENMA.GT.NDSHIF IN RENMAS'
! IF (IEXTEN.EQ.1 .AND. (KREVER.EQ.1 .OR. ICANON.EQ.0)) STOP 'IEXTEN=1 needs KREVER=0 and ICANON>0 in RENMAS'
! IF(ICANON.GT.1)STOP 'ICANON>1 in RENMAS'
!=======================================================================
!    TREAT COULOMB PART WHEN SYMMETRY IS BROKEN INSIDE THIS ROUTINE
!=======================================================================
 IF(ISIMPY.NE.KSIMPY .OR. ISIGNY.NE.KSIGNY .OR. ISIQTY.NE.KSIQTY )THEN
    CALL MULCOU(ISIMPY,ISIGNY,ISIQTY,NMUCOU)
    FCOUOF=TRIM(FILCOU)//'OFD'
    IF(ITESTA.EQ.NUMITE)THEN!DO CALCULATION ONLY AT THE FIRST ITERATION
      ICOULI=0
      ICOULO=1
      CALL PRECOU(NOSCIL,NUMCOU,NUMETA,BOUCOU,NFICOU,FCOUOF,ICOULI,ICOULO)
    ELSE!READ FROM FILE
      INPCOU=1
      I_SUCC=1
      OPEN(NFICOU,FILE=FCOUOF,STATUS='OLD',FORM='UNFORMATTED')
      CALL RECOUL(NFICOU,INPCOU,I_SUCC,NUMCOU,NUMETA,BOUCOU)
      CLOSE(NFICOU)
    ENDIF
 ENDIF
!
 ETKERS(:,:)=C_ZERO
 DKKERS(:,:)=C_ZERO
 OVKERS(:,:)=C_ZERO
!=======================================================================
!         HERE BEGIN THE LOOP THE SHIFT VECTORS.
!=======================================================================!
 IF (IRENMA.GT.NDSHIF) STOP ' IRENMA.GT.NDSHIF IN RENMAS'
 MDKART=NDKART!UPPER LIMIT OF DIRECTION LOOP
 DO INSHIF=IRENMA,0,-1!SHIFT DISTANCE
    IF (INSHIF.EQ.0) MDKART=1!WHEN THERE IS NO SHIFT,ONLY DO 1 TIME
    DO KARTEZ=1,MDKART!X,Y,Z DIRECTION
     BSHIFT(:)=0.0d0
     IF (KARTEZ.EQ.1) BSHIFT(1)=INSHIF*DISTAX
     IF (KARTEZ.EQ.2) BSHIFT(2)=INSHIF*DISTAY
     IF (KARTEZ.EQ.3) BSHIFT(3)=INSHIF*DISTAZ
     IF ((INSHIF.EQ.0).OR.(ABS(BSHIFT(KARTEZ)).GT.SIF)) THEN
       DO ICHARG=0,NDISOS
          IF(IEXTEN.EQ.1)THEN
             LDUPPE(ICHARG)=LDTIMU(ICHARG)*2
             LDSTAT(ICHARG)=LDTIMU(ICHARG)*3
             LDTOTS(ICHARG)=LDTIMU(ICHARG)*4
          ENDIF
          LTIMUP=LDTIMU(ICHARG)
          LUPPER=LDUPPE(ICHARG)
          LTOTAL=LDTOTS(ICHARG)
!=======================================================================
!FETCHING THE LEFT WAVE FUNCTIONS FOR THE GIVEN CHARGE
!AND CALCULATE ROTATED RIGHT WAVE FUNCTIONS MULTIPLYING THE INVERTED OVERLAP MATRIX
!USE 'KSIMPY' HERE,SINCE CHANGE IN WAVEFUNCTION HAPPENS AFTER THIS ROUTINE IS CALLED
!USE 'mrever' since both blocks are already stored, by change lduppe and so on, the extension is done
!=======================================================================
          CALL LINWLR(MREVER,KSIMPY,ICANON,IDOGOA,IPAHFB,INSHIF,IEXTEN,&
                      LDBASE,LTIMUP,LUPPER,LTOTAL,ICHARG,OVKERN(INSHIF,ICHARG))
!=======================================================================
!        RHO MATRIX
!=======================================================================
          CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH,1)
!=======================================================================
!        KAPPA MATRIX
!=======================================================================
          IF (IDOGOA.EQ.0) THEN
             IF (IPAHFB.EQ.1 .AND. COR_CM) CALL PAIMAC(ICHARG,ISIMPY,WALEFT,WARIGH,IKERNE)
!=======================================================================
!        TERMS FOR <|J^2|Ri>
!=======================================================================
             CALL LINAVR(ISIMPY,ISIGNY,ISIQTY,&
                         IPAHFB,ICHARG,JETACM,IROTAT,MREVER,COR_CM,IKERNE,&
                         DLINSQ,ELINSQ,PLINSQ,TLINSQ,ALINLI,PLINLI,PLINKI,&
                         DKINSQ,EKINSQ,PKINSQ,TKINSQ,AKINLI,PKINLI,PKINKI)
!
             DKKERN(INSHIF,ICHARG)=TKINSQ(0)
             AKKERN(INSHIF,1,ICHARG)=AKINLI(1)
             AKKERN(INSHIF,2,ICHARG)=AKINLI(2)
             AKKERN(INSHIF,3,ICHARG)=AKINLI(3)
          ELSE
             DKKERN(INSHIF,ICHARG)=C_ZERO
             AKKERN(INSHIF,1,ICHARG)=C_ZERO
             AKKERN(INSHIF,2,ICHARG)=C_ZERO
             AKKERN(INSHIF,3,ICHARG)=C_ZERO
          END IF

!=======================================================================
!        <|H|Ri>
!=======================================================================
          ISKYRM=ICHARG
          CALL H_KERN(ISIMTX,JSIMTY,ISIMTZ,ISIGNY,ISIMPY,ISIQTY,&
                      IPAHFB,MREVER,ICHARG,MIN_QP,IPNMIX,ITIREP,NAMEPN,&
                      PRINIT,IDEVAR,ITERUN,ISYMDE,INIROT,INIINV,&
                      INIKAR,ISAWAV,IKERNE,ISHIFY,JMULMO,NUMCOU,&
                      BOUCOU,IN_FIX,IZ_FIX,ISKYRM,&
                      EKKERN(INSHIF,ICHARG),EPKERN(INSHIF,ICHARG),&
                      BAREKE,BAREKK,CDKERN(INSHIF),CXKERN(INSHIF),SKKERN(INSHIF))
       ENDDO!END ICHARG
!=======================================================================
!        SKYREM PART OF <|H|Ri>
!=======================================================================
!       CALL TRUTOD
!       CALL ESKYRM(ENESKY,ENEVEN,ENEODD,&
!                   ENREAR,ENE_W0,EEVEW0,EODDW0,EKESKY,LDPNMX,0,1)
!       SKKERN(INSHIF)=EKESKY
!=======================================================================
!        <|H|Ri> and <|J^2|Ri>
!=======================================================================
       ETKERS(INSHIF,KARTEZ)=EKKERN(INSHIF,0)+EKKERN(INSHIF,1)&
                            +EPKERN(INSHIF,0)+EPKERN(INSHIF,1)&
                            +CDKERN(INSHIF)+CXKERN(INSHIF)+SKKERN(INSHIF)
       DKKERS(INSHIF,KARTEZ)= DKKERN(INSHIF,0)+DKKERN(INSHIF,1)&
               +2*AKKERN(INSHIF,1,0)*AKKERN(INSHIF,1,1)&
               +2*AKKERN(INSHIF,2,0)*AKKERN(INSHIF,2,1)&
               +2*AKKERN(INSHIF,3,0)*AKKERN(INSHIF,3,1)
       OVKERS(INSHIF,KARTEZ)= OVKERN(INSHIF,0)*OVKERN(INSHIF,1)
!
!     write(*,*)'e',etkers(inshif,kartez),inshif,kartez
!     write(*,*)'p',dkkers(inshif,kartez),inshif,kartez
     ENDIF! IF ((BSHIFT(KARTEZ).NE.0.0D0).OR.(INSHIF.EQ.0))
    ENDDO! End KARTEZ
 END DO ! End INSHIF
!=======================================================================
!        BELOW WE DEFINE THE LIPKIN PARAMETERS, WHICH ARE POSITIVE
!=======================================================================
 REMASS(:)=0.0d0
 GOAMAS(:)=0.0d0
 ABX=ABS(DISTAX)
 ABY=ABS(DISTAY)
 ABZ=ABS(DISTAZ)

 IF(ABX.GT.SIF)THEN!SHIFT ALONG X AXIS EXISTS
!
    IF (IDOGOA.EQ.0) THEN
       REMASS(1)=REAL((ETKERS(IRENMA,1)-ETKERS(0,1))/(DKKERS(IRENMA,1)-DKKERS(0,1)))
    ELSE
       TSHIFT=REAL(IRENMA**2)*DISTAX**2
       H2PARA=-2*REAL(ETKERS(IRENMA,1)-ETKERS(0,1)) /TSHIFT
       A_PARA=-2*LOG(REAL(OVKERS(IRENMA,1)))/TSHIFT
       GOAMAS(1)=H2PARA/(2*A_PARA**2)
!       REMASS(1)=GOAMAS(1)
    END IF
 ENDIF
!
 IF(ABY.GT.SIF)THEN!SHIFT ALONG Y AXIS EXISTS
!
    IF (IDOGOA.EQ.0) THEN
       REMASS(2)=REAL((ETKERS(IRENMA,2)-ETKERS(0,1))/(DKKERS(IRENMA,2)-DKKERS(0,1)))
    ELSE
       TSHIFT=REAL(IRENMA**2)*DISTAY**2
       H2PARA=-2*REAL(ETKERS(IRENMA,2)-ETKERS(0,1)) /TSHIFT
       A_PARA=-2*LOG(REAL(OVKERS(IRENMA,2)))/TSHIFT
       GOAMAS(2)=H2PARA/(2*A_PARA**2)
!       REMASS(2)=GOAMAS(2)
    END IF
 ENDIF
!
 IF(ABZ.GT.SIF)THEN!SHIFT ALONG Y AXIS EXISTS

!
    IF (IDOGOA.EQ.0) THEN
       REMASS(3)=REAL((ETKERS(IRENMA,3)-ETKERS(0,1))/(DKKERS(IRENMA,3)-DKKERS(0,1)))
    ELSE
       TSHIFT=REAL(IRENMA**2)*DISTAZ**2
       H2PARA=-2*REAL(ETKERS(IRENMA,3)-ETKERS(0,1)) /TSHIFT
       A_PARA=-2*LOG(REAL(OVKERS(IRENMA,3)))/TSHIFT
       GOAMAS(3)=H2PARA/(2*A_PARA**2)
!       REMASS(3)=GOAMAS(3)
    END IF
 ENDIF

 IF (MREVER.EQ.0) GOAMAS(:)=GOAMAS(:)/4
! MREVER.EQ.0 with shifting or rotating is not allowed yet
! But this option is still kept inside RENMAS and RENINE.
 IF (IDOGOA.EQ.1) REMASS(:)=GOAMAS(:)
!
 IF(ABX.LT.SIF) THEN!NO SHIFT ALONG X AXIS
    IF(DISTAY.GT.SIF) THEN
       REMASS(1)=REMASS(2)
       GOAMAS(1)=GOAMAS(2)
    ELSE
       REMASS(1)=REMASS(3)
       GOAMAS(1)=GOAMAS(3)
    ENDIF
 ENDIF
!
 IF(ABY.LT.SIF) THEN!NO SHIFT ALONG Y AXIS
    IF(DISTAX.GT.SIF) THEN
       REMASS(2)=REMASS(1)
       GOAMAS(2)=GOAMAS(1)
     ELSE
       REMASS(2)=REMASS(3)
       GOAMAS(2)=GOAMAS(3)
     ENDIF
 ENDIF
!
 IF(ABZ.LT.SIF) THEN!NO SHIFT ALONG Z AXIS
    IF(DISTAX.GT.SIF) THEN
       REMASS(3)=REMASS(1)
       GOAMAS(3)=GOAMAS(1)
     ELSE
       REMASS(3)=REMASS(2)
       GOAMAS(3)=GOAMAS(2)
     ENDIF
 ENDIF
!=======================================================================
!   Only keep a given digital of lipkin parameter to accelate converge
!=======================================================================
 ITRUNC=1
 IDIGTA=8
 IF(ITRUNC.EQ.1)THEN
    IMASK=10**IDIGTA
    IREMAS(:)=NINT(REMASS(:)*IMASK)
    REMASS(:)=IREMAS(:)/(IMASK*1.0d0)
 ENDIF
!
!=======================================================================
!       BELOW WE DEFINE THE COEFFICIENTS OF <P^2>, WHICH ARE NEGATIVE
!=======================================================================
 IF (I_SLOW.NE.1) THEN
     HBMREN(1)=HBMREN(1)*SLOWTP-REMASS(1)*(1-SLOWTP)
     HBMREN(2)=HBMREN(2)*SLOWTP-REMASS(2)*(1-SLOWTP)
     HBMREN(3)=HBMREN(3)*SLOWTP-REMASS(3)*(1-SLOWTP)
 ELSE
     HBMREN(1)=-REMASS(1)
     HBMREN(2)=-REMASS(2)
     HBMREN(3)=-REMASS(3)
 ENDIF
 !
 GOAREN(1)=-GOAMAS(1)
 GOAREN(2)=-GOAMAS(2)
 GOAREN(3)=-GOAMAS(3)
 !write(*,*)'renmas',remass(1),goamas(1)
!=======================================================================
!    RESTORE COULOMB PART WHEN SYMMETRY IS BROKEN INSIDE THIS ROUTINE
!=======================================================================
 IF(ISIMPY.NE.KSIMPY .OR. ISIGNY.NE.KSIGNY .OR. ISIQTY.NE.KSIQTY )THEN
    CALL MULCOU(KSIMPY,KSIGNY,KSIQTY,NMUCOU)
    OPEN(NFICOU,FILE=FILCOU,STATUS='OLD',FORM='UNFORMATTED')
    INPCOU=1
    I_SUCC=1
    CALL RECOUL(NFICOU,INPCOU,I_SUCC,NUMCOU,NUMETA,BOUCOU)
    CLOSE(NFICOU)
 ENDIF
                  HPPCOU(:,:)=COUHPP(:,:)
 IF (ISIMPY.NE.1) HPMCOU(:,:)=COUHPM(:,:)
 COMULT=COM_TMP
 QMUT_N=QTN_TMP
 QMUT_P=QTP_TMP
 QMUT_T=QTT_TMP
 QMUL_N=QLN_TMP
 QMUL_P=QLP_TMP
 QMUL_T=QLT_TMP
!=======================================================================
 CALL CPUTIM('RENMAS',0)
 RETURN
END SUBROUTINE RENMAS
!=======================================================================

      SUBROUTINE Set_version_hfodd_modules
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(2) = 'hfodd_modules   '
      MODUVE(2) = 69
      MODSET(2) = 2
      !
      END SUBROUTINE Set_version_hfodd_modules
      !
C=======================================================================
      MODULE      MURMIX
      SAVE        OMRMIX,EMRMIX,QMRMIX,AMRMIX,WMRMIX,SMRMIX,
     *            DMRMIX,XMRMIX
      COMPLEX     OMRMIX,EMRMIX,QMRMIX,AMRMIX,WMRMIX,SMRMIX,
     *            DMRMIX,XMRMIX
      ALLOCATABLE OMRMIX(:),EMRMIX(:),QMRMIX(:),
     *            AMRMIX(:),WMRMIX(:),SMRMIX(:),
     *            DMRMIX(:),XMRMIX(:)
      SAVE        NMATMI,LMATMI
      ALLOCATABLE NMATMI(:,:,:,:,:,:),LMATMI(:,:,:,:,:,:,:)
      END MODULE  MURMIX
C=======================================================================
      MODULE      HE_DEN
      SAVE        DE_RHO,DE_TAU,DE_LPR,DE_DIV,
     *            DE_SPI,DE_KIS,DE_GRR,DE_LPS,DE_ROS,DE_ROC,DE_CUR,
     *            DE_KIF,DE_SCU,DE_DES
      COMPLEX     DE_RHO,DE_TAU,DE_LPR,DE_DIV,
     *            DE_SPI,DE_KIS,DE_GRR,DE_LPS,DE_ROS,DE_ROC,DE_CUR,
     *            DE_KIF,DE_SCU,DE_DES
      ALLOCATABLE DE_RHO(:,:,:,:,:),DE_TAU(:,:,:,:,:),
     *            DE_LPR(:,:,:,:,:),DE_DIV(:,:,:,:,:)
      ALLOCATABLE DE_SPI(:,:,:,:,:,:),DE_KIS(:,:,:,:,:,:),
     *            DE_GRR(:,:,:,:,:,:),DE_LPS(:,:,:,:,:,:),
     *            DE_ROS(:,:,:,:,:,:),DE_ROC(:,:,:,:,:,:),
     *            DE_CUR(:,:,:,:,:,:),DE_KIF(:,:,:,:,:,:)
      ALLOCATABLE DE_SCU(:,:,:,:,:,:,:),DE_DES(:,:,:,:,:,:,:)
      END MODULE  HE_DEN
C=======================================================================
      MODULE      TRUDEN
      SAVE        REVRHO,REVTAU,REVLPR,REVDIV,
     *            REVKIS,REVGRR,REVLPS,REVROS,REVROC,REVCUR,
     *            REVKIF,REVSCU,REVDES,REVSPI
      COMPLEX     REVRHO,REVTAU,REVLPR,REVDIV,
     *            REVKIS,REVGRR,REVLPS,REVROS,REVROC,REVCUR,
     *            REVKIF,REVSCU,REVDES,REVSPI
      ALLOCATABLE REVRHO(:,:,:,:),REVTAU(:,:,:,:),
     *            REVLPR(:,:,:,:),REVDIV(:,:,:,:)
      ALLOCATABLE REVKIS(:,:,:,:,:),REVSPI(:,:,:,:,:),
     *            REVGRR(:,:,:,:,:),REVLPS(:,:,:,:,:),
     *            REVROS(:,:,:,:,:),REVROC(:,:,:,:,:),
     *            REVCUR(:,:,:,:,:),REVKIF(:,:,:,:,:)
      ALLOCATABLE REVSCU(:,:,:,:,:,:),REVDES(:,:,:,:,:,:)
      END MODULE  TRUDEN
C=======================================================================
      MODULE      TRUINT
      SAVE        DDTRHO,DDTSPI,PDTRHO
      COMPLEX     DDTRHO,DDTSPI,PDTRHO
      ALLOCATABLE DDTRHO(:,:,:,:,:)
      ALLOCATABLE DDTSPI(:,:,:,:,:,:)
      ALLOCATABLE PDTRHO(:,:,:,:,:)
      END MODULE  TRUINT
C=======================================================================
      MODULE      HETDEN
      SAVE        DE_DIJ,DE_DIS
      COMPLEX     DE_DIJ,DE_DIS
      ALLOCATABLE DE_DIJ(:,:,:,:,:)
      ALLOCATABLE DE_DIS(:,:,:,:,:,:)
      END MODULE  HETDEN
C=======================================================================
      MODULE      PD_DEN
      SAVE        PD_RHO,PD_TAU,PD_LPR,PD_GRR,PD_SCU
      COMPLEX     PD_RHO,PD_TAU,PD_LPR,PD_GRR,PD_SCU
      ALLOCATABLE PD_RHO(:,:,:,:,:),
     *            PD_TAU(:,:,:,:,:),
     *            PD_LPR(:,:,:,:,:)
      ALLOCATABLE PD_GRR(:,:,:,:,:,:)
      ALLOCATABLE PD_SCU(:,:,:,:,:,:,:)
      END MODULE  PD_DEN
C=======================================================================
      MODULE      PP_DEN
      SAVE        PP_RHO,PP_TAU,PP_LPR,PP_GRR,PP_SCU
      COMPLEX     PP_RHO,PP_TAU,PP_LPR,PP_GRR,PP_SCU
      ALLOCATABLE PP_RHO(:,:,:,:,:),
     *            PP_TAU(:,:,:,:,:),
     *            PP_LPR(:,:,:,:,:)
      ALLOCATABLE PP_GRR(:,:,:,:,:,:)
      ALLOCATABLE PP_SCU(:,:,:,:,:,:,:)
      END MODULE  PP_DEN
C=======================================================================
      MODULE      PDTDEN
      SAVE        PD_DIS,PP_DIS
      COMPLEX     PD_DIS,PP_DIS
      ALLOCATABLE PD_DIS(:,:,:,:,:,:),PP_DIS(:,:,:,:,:,:)
      END MODULE  PDTDEN
C=======================================================================
      MODULE      VE_FLD
      SAVE        VE_MAS,VE_CEN,VE_SPT,VE_KIS,VE_SPI,VE_CUR,VE_KIT,
     *            VE_SOR
      COMPLEX     VE_MAS,VE_CEN,VE_SPT,VE_KIS,VE_SPI,VE_CUR,VE_KIT,
     *            VE_SOR
      ALLOCATABLE VE_MAS(:,:,:,:,:),VE_CEN(:,:,:,:,:),VE_SPT(:,:,:,:,:),
     *            VE_KIS(:,:,:,:,:,:),VE_SPI(:,:,:,:,:,:),
     *            VE_CUR(:,:,:,:,:,:),VE_KIT(:,:,:,:,:,:),
     *            VE_SOR(:,:,:,:,:,:,:)
      END MODULE  VE_FLD
C=======================================================================
      MODULE      WD_FLD
      SAVE        WD_CEN,WD_TAU,WD_SOR
      COMPLEX     WD_CEN,WD_TAU,WD_SOR
      ALLOCATABLE WD_CEN(:,:,:,:,:),WD_TAU(:,:,:,:,:),
     *            WD_SOR(:,:,:,:,:,:,:)
      END MODULE  WD_FLD
C=======================================================================
      MODULE      BROYIN
      SAVE        BRO_IN
      ALLOCATABLE BRO_IN(:)
      END MODULE  BROYIN
C=======================================================================
      MODULE      BROYOU
      SAVE        BRO_OU
      ALLOCATABLE BRO_OU(:)
      END MODULE  BROYOU
C=======================================================================
      MODULE      BROYIN_NEUTRON
      SAVE        BRONIN
      ALLOCATABLE BRONIN(:)
      END MODULE  BROYIN_NEUTRON
      MODULE      BROYOU_NEUTRON
      SAVE        BRONOU
      ALLOCATABLE BRONOU(:)
      END MODULE  BROYOU_NEUTRON
C=======================================================================
      MODULE      BROYIN_PROTON
      SAVE        BROPIN
      ALLOCATABLE BROPIN(:)
      END MODULE  BROYIN_PROTON
      MODULE      BROYOU_PROTON
      SAVE        BROPOU
      ALLOCATABLE BROPOU(:)
      END MODULE  BROYOU_PROTON
C=======================================================================
      MODULE      MAT_PP
      SAVE        BIG_PP
      COMPLEX     BIG_PP
      ALLOCATABLE BIG_PP(:,:,:)
      END MODULE  MAT_PP
C=======================================================================
      MODULE      MAT_PM
      SAVE        BIG_PM
      COMPLEX     BIG_PM
      ALLOCATABLE BIG_PM(:,:,:)
      END MODULE  MAT_PM
C=======================================================================
      MODULE      MAR_PP
      SAVE        RHO_PP
      COMPLEX     RHO_PP
      ALLOCATABLE RHO_PP(:,:,:)
      END MODULE  MAR_PP
C=======================================================================
      MODULE      MAR_PM
      SAVE        RHO_PM
      COMPLEX     RHO_PM
      ALLOCATABLE RHO_PM(:,:,:)
      END MODULE  MAR_PM
C=======================================================================
      MODULE      KAP_PP
      SAVE        PAI_PP
      COMPLEX     PAI_PP
      ALLOCATABLE PAI_PP(:,:,:)
      END MODULE  KAP_PP
C=======================================================================
      MODULE      KAP_PM
      SAVE        PAI_PM
      COMPLEX     PAI_PM
      ALLOCATABLE PAI_PM(:,:,:)
      END MODULE  KAP_PM
C=======================================================================
      MODULE      KAP2PP
      SAVE        PAI2PP
      COMPLEX     PAI2PP
      ALLOCATABLE PAI2PP(:,:,:)
      END MODULE  KAP2PP
C=======================================================================
      MODULE      KAP2PM
      SAVE        PAI2PM
      COMPLEX     PAI2PM
      ALLOCATABLE PAI2PM(:,:,:)
      END MODULE  KAP2PM
C=======================================================================
      MODULE      MAD_PP
      SAVE        DEN_PP
      COMPLEX     DEN_PP
      ALLOCATABLE DEN_PP(:,:,:,:)
      END MODULE  MAD_PP
C=======================================================================
      MODULE      MAD_PM
      SAVE        DEN_PM
      COMPLEX     DEN_PM
      ALLOCATABLE DEN_PM(:,:,:,:)
      END MODULE  MAD_PM
C=======================================================================
      MODULE      MLI_PP
      SAVE        DLI_PP
      COMPLEX     DLI_PP
      ALLOCATABLE DLI_PP(:,:,:,:)
      END MODULE  MLI_PP
C=======================================================================
      MODULE      MLI_PM
      SAVE        DLI_PM
      COMPLEX     DLI_PM
      ALLOCATABLE DLI_PM(:,:,:,:)
      END MODULE  MLI_PM
C=======================================================================
      MODULE      OVM_PP
      SAVE        OVMAPP
      COMPLEX     OVMAPP
      ALLOCATABLE OVMAPP(:,:,:)
      END MODULE  OVM_PP
C=======================================================================
      MODULE      BIGOVE
      SAVE        BIGNOR
      COMPLEX     BIGNOR
      ALLOCATABLE BIGNOR(:,:)
      END MODULE  BIGOVE
C=======================================================================
      MODULE      BIGFRA
      SAVE        FRAMAT
      COMPLEX     FRAMAT
      ALLOCATABLE FRAMAT(:,:)
      END MODULE  BIGFRA
C=======================================================================
      MODULE      BIGHAM
      SAVE        COMHAM
      COMPLEX     COMHAM
      ALLOCATABLE COMHAM(:,:)
      END MODULE  BIGHAM
C=======================================================================
      MODULE      BIGDEN
      SAVE        BIGTWC
      COMPLEX     BIGTWC
      ALLOCATABLE BIGTWC(:,:)
      END MODULE  BIGDEN
C=======================================================================
      MODULE      TWCOBO
      SAVE        BIGOBO
      COMPLEX     BIGOBO
      ALLOCATABLE BIGOBO(:,:)
      END MODULE  TWCOBO
C=======================================================================
      MODULE      BIGOPP
      SAVE        TWCOPP
      COMPLEX     TWCOPP
      ALLOCATABLE TWCOPP(:,:,:)
      END MODULE  BIGOPP
C=======================================================================
      MODULE      BIGOPM
      SAVE        TWCOPM
      COMPLEX     TWCOPM
      ALLOCATABLE TWCOPM(:,:,:)
      END MODULE  BIGOPM
C=======================================================================
      MODULE      OVM_PM
      SAVE        OVMAPM
      COMPLEX     OVMAPM
      ALLOCATABLE OVMAPM(:,:,:)
      END MODULE  OVM_PM
C=======================================================================
      MODULE      OVMSIM
      SAVE        OVERME
      COMPLEX     OVERME
      ALLOCATABLE OVERME(:,:)
      END MODULE  OVMSIM
C=======================================================================
      MODULE      NOREIG
      SAVE        EWTNOR,EWTAUX
      COMPLEX     EWTNOR,EWTAUX
      ALLOCATABLE EWTNOR(:,:),EWTAUX(:,:)
      END MODULE  NOREIG
C=======================================================================
      MODULE      MAP_PP
      SAVE        CHI_PP
      COMPLEX     CHI_PP
      ALLOCATABLE CHI_PP(:,:,:,:)
      END MODULE  MAP_PP
C=======================================================================
      MODULE      MAP_PM
      SAVE        CHI_PM
      COMPLEX     CHI_PM
      ALLOCATABLE CHI_PM(:,:,:,:)
      END MODULE  MAP_PM
C=======================================================================
      MODULE      MAF_PP
      SAVE        FIL_PP
      COMPLEX     FIL_PP
      ALLOCATABLE FIL_PP(:,:,:,:)
      END MODULE  MAF_PP
C=======================================================================
      MODULE      MAF_PM
      SAVE        FIL_PM
      COMPLEX     FIL_PM
      ALLOCATABLE FIL_PM(:,:,:,:)
      END MODULE  MAF_PM
C=======================================================================
      MODULE      MAPIDE
      SAVE        FIPIDE
      SAVE        FIP2DE
      COMPLEX     FIPIDE
      COMPLEX     FIP2DE
      ALLOCATABLE FIPIDE(:,:,:,:)
      ALLOCATABLE FIP2DE(:,:,:,:)
      END MODULE  MAPIDE
C=======================================================================
      MODULE      MAFTWC
      SAVE        FITWPP,FITWPM,FITWDE
      COMPLEX     FITWPP,FITWPM,FITWDE
      ALLOCATABLE FITWPP(:,:,:,:,:),FITWPM(:,:,:,:,:),FITWDE(:,:,:,:,:)
      END MODULE  MAFTWC
C=======================================================================
      MODULE      HCOULO
      SAVE        HPPCOU
      SAVE        HPMCOU
      COMPLEX     HPPCOU
      COMPLEX     HPMCOU
      ALLOCATABLE HPPCOU(:,:)
      ALLOCATABLE HPMCOU(:,:)
      END MODULE  HCOULO
C=======================================================================
      MODULE      HYUKAW
      SAVE        HPPYUK
      SAVE        HPMYUK
      COMPLEX     HPPYUK
      COMPLEX     HPMYUK
      ALLOCATABLE HPPYUK(:,:,:)
      ALLOCATABLE HPMYUK(:,:,:)
      END MODULE  HYUKAW
C=======================================================================
      MODULE      PAIDEL
      SAVE        HAMIDE
      SAVE        HAM2DE
      COMPLEX     HAMIDE
      COMPLEX     HAM2DE
      ALLOCATABLE HAMIDE(:,:,:)
      ALLOCATABLE HAM2DE(:,:,:)
      END MODULE  PAIDEL
C=======================================================================
      MODULE      SPINOR
      SAVE        WSWAVE
      COMPLEX     WSWAVE
      ALLOCATABLE WSWAVE(:,:,:)
      END MODULE  SPINOR
C=======================================================================
      MODULE      WAVSQU
      SAVE        SQUWAV
      ALLOCATABLE SQUWAV(:,:,:,:)
      END MODULE  WAVSQU
C=======================================================================
      MODULE      WAVR_L
      SAVE        WARIGH
      SAVE        WALEFT
      COMPLEX     WARIGH
      COMPLEX     WALEFT
      ALLOCATABLE WARIGH(:,:,:)
      ALLOCATABLE WALEFT(:,:,:)
      END MODULE  WAVR_L
C=======================================================================
      MODULE      SAVRIG
      SAVE        SARIGH
      COMPLEX     SARIGH
      ALLOCATABLE SARIGH(:,:,:,:,:)
      END MODULE  SAVRIG
C=======================================================================
      MODULE      SAVLEF
      SAVE        SALEFT
      COMPLEX     SALEFT
      ALLOCATABLE SALEFT(:,:,:,:)
      END MODULE  SAVLEF
C=======================================================================
      MODULE      ALLWAV
      SAVE        WAVOCC,SAVOCC
      COMPLEX     WAVOCC,SAVOCC
      ALLOCATABLE WAVOCC(:,:,:),SAVOCC(:,:,:,:)
      END MODULE  ALLWAV
C=======================================================================
      MODULE      CANBAS
c     Canonical wave functions and u- and v- amplitudes
c     WAVCAN(IBASE, ISTATE, IREVER, ICHARG)
c     V_CAN (       ISTATE, IREVER, ICHARG)
c     U_CAN (       ISTATE, IREVER, ICHARG)
c     Where IBASE  = index of basis state
c     ISTATE = index of can.  state
c           IREVER = index of time-reversal block
c           ICHARG = index of charge (n/p) block
      COMPLEX, SAVE, ALLOCATABLE :: WAVCAN(:,:,:,:)
      REAL,    SAVE, ALLOCATABLE :: V_CAN(:,:,:), U_CAN(:,:,:)
      END MODULE  CANBAS
C=======================================================================
      MODULE      PNMWAV
      SAVE        PNMOCC
      COMPLEX     PNMOCC
      ALLOCATABLE PNMOCC(:,:,:)
      END MODULE  PNMWAV
C=======================================================================
      MODULE      TWCWAV
      SAVE        TWCOCC
      COMPLEX     TWCOCC
      ALLOCATABLE TWCOCC(:,:,:,:)
      END MODULE  TWCWAV
C=======================================================================
      MODULE      ALLSIG
      SAVE        EWASIG,SPESVG,LDMEFG
      INTEGER     LDMEFG
      COMPLEX     EWASIG,SPESVG
      ALLOCATABLE EWASIG(:,:,:,:),SPESVG(:,:,:),LDMEFG(:,:)
      END MODULE  ALLSIG
C=======================================================================
      MODULE      ALLSIM
      SAVE        EWASIM,SPESVM,LDMEFM
      INTEGER     LDMEFM
      COMPLEX     EWASIM,SPESVM
      ALLOCATABLE EWASIM(:,:,:),SPESVM(:,:),LDMEFM(:)
      END MODULE  ALLSIM
C=======================================================================
      MODULE      ALLSIQ
      SAVE        EWASIQ,SPESVQ,LDMEFQ
      INTEGER     LDMEFQ
      COMPLEX     EWASIQ,SPESVQ
      ALLOCATABLE EWASIQ(:,:,:),SPESVQ(:,:),LDMEFQ(:)
      END MODULE  ALLSIQ
C=======================================================================
      MODULE      ALLSIZ
      SAVE        EWASIZ
      COMPLEX     EWASIZ
      ALLOCATABLE EWASIZ(:,:)
      END MODULE  ALLSIZ
C=======================================================================
      MODULE      ALLMIZ
      SAVE        EWAMIZ
      COMPLEX     EWAMIZ
      ALLOCATABLE EWAMIZ(:,:)
      END MODULE  ALLMIZ
C=======================================================================
      MODULE      SAVQUA
      SAVE        ASVQUA         ,BSVQUA
      COMPLEX     ASVQUA         ,BSVQUA
      ALLOCATABLE ASVQUA(:,:,:,:),BSVQUA(:,:,:,:)
      END MODULE  SAVQUA
C=======================================================================
      MODULE      ALLQUA
      SAVE        AWAQUA       ,BWAQUA
      COMPLEX     AWAQUA       ,BWAQUA
      ALLOCATABLE AWAQUA(:,:,:),BWAQUA(:,:,:)
      END MODULE  ALLQUA
C=======================================================================
      MODULE      ALLQUZ
      SAVE        AWAQUZ       ,BWAQUZ
      COMPLEX     AWAQUZ       ,BWAQUZ
      ALLOCATABLE AWAQUZ(:,:,:),BWAQUZ(:,:,:)
      END MODULE  ALLQUZ
C=======================================================================
      MODULE      TWCQUZ
      SAVE        AWATWC       ,BWATWC
      COMPLEX     AWATWC       ,BWATWC
      ALLOCATABLE AWATWC(:,:,:),BWATWC(:,:,:)
      END MODULE  TWCQUZ
C=======================================================================
      MODULE      BLOSAV
      SAVE        IPRODD, LPRODR, LPRODL, BLOLAB, LDBLOL
     *            WLABBR, WLABAR, WLABBL, WLABAL
      TYPE        BLAB
      INTEGER     N,IR
      END TYPE
      INTEGER     IPRODD, LPRODR, LPRODL, LDBLOL
      ALLOCATABLE LPRODR(:),LPRODL(:),LDBLOL(:)
      TYPE(BLAB)  BLOLAB
      ALLOCATABLE BLOLAB(:,:)
      INTEGER     WLABBR, WLABAR, WLABBL, WLABAL
      ALLOCATABLE WLABBR(:,:),WLABAR(:,:),WLABBL(:,:),WLABAL(:,:)
      END MODULE  BLOSAV
C=======================================================================
      MODULE      REDMOM
      SAVE        REDQ_P   ,REDM_P     ,REDA_T     ,REDS_P   ,INDRED
      COMPLEX     REDQ_P   ,REDM_P     ,REDA_T     ,REDS_P
      ALLOCATABLE REDQ_P(:),REDM_P(:,:),REDA_T(:,:),REDS_P(:),
     *            INDRED(:,:,:)
      END MODULE  REDMOM
C=======================================================================
      MODULE      REEMOM
      SAVE        REEQ_P   ,REEM_P     ,REEA_T     ,REES_P   ,INDREE
      COMPLEX     REEQ_P   ,REEM_P     ,REEA_T     ,REES_P
      ALLOCATABLE REEQ_P(:),REEM_P(:,:),REEA_T(:,:),REES_P(:),
     *            INDREE(:,:,:)
      END MODULE  REEMOM
C=======================================================================
      MODULE      COUMOM
      SAVE        COUD_P,COUX_P,CEED_P,CEEX_P
      COMPLEX     COUD_P,COUX_P,CEED_P,CEEX_P
      ALLOCATABLE COUD_P(:),COUX_P(:),CEED_P(:),CEEX_P(:)
      END MODULE  COUMOM
C=======================================================================
      MODULE      GAUSTO
      SAVE        GAUFIL
      COMPLEX     GAUFIL
      ALLOCATABLE GAUFIL(:,:,:,:,:)
      SAVE        GAUAVR
      COMPLEX     GAUAVR
      ALLOCATABLE GAUAVR(:,:,:,:,:)
      END MODULE  GAUSTO
C=======================================================================
      MODULE      TBCSTO
      SAVE        TINAVR
      COMPLEX     TINAVR
      ALLOCATABLE TINAVR(:,:,:,:,:,:)
      SAVE        TSAAVR
      COMPLEX     TSAAVR
      ALLOCATABLE TSAAVR(:,:,:,:,:,:,:,:)
      END MODULE  TBCSTO
C=======================================================================
      MODULE      GAUNEW
      SAVE        GENGA0
      COMPLEX     GENGA0
      ALLOCATABLE GENGA0(:,:,:,:,:,:)
      END MODULE  GAUNEW
C=======================================================================
      MODULE      YUKSTO
      SAVE        YUKASV
      COMPLEX     YUKASV
      ALLOCATABLE YUKASV(:,:,:,:)
      END MODULE  YUKSTO
C=======================================================================
      MODULE      GOGSTO
      SAVE        GOGASV
      COMPLEX     GOGASV
      ALLOCATABLE GOGASV(:,:,:,:)
      END MODULE  GOGSTO
C=======================================================================
      MODULE      GOGKAP
      SAVE        GOGCHI
      COMPLEX     GOGCHI
      ALLOCATABLE GOGCHI(:,:,:,:)
      END MODULE  GOGKAP
C=======================================================================
      MODULE      REGSTO
      SAVE        REGASV
      COMPLEX     REGASV
      ALLOCATABLE REGASV(:,:,:,:)
      END MODULE  REGSTO
C=======================================================================
      MODULE      RPASTO
      SAVE        REGPSV
      COMPLEX     REGPSV
      ALLOCATABLE REGPSV(:,:,:,:)
      END MODULE  RPASTO
C=======================================================================
      MODULE      SEPSTO
      SAVE        SEPASV
      COMPLEX     SEPASV
      ALLOCATABLE SEPASV(:,:,:,:)
      END MODULE  SEPSTO
C=======================================================================
      MODULE      SPASTO
      SAVE        SEPPSV
      COMPLEX     SEPPSV
      ALLOCATABLE SEPPSV(:,:,:,:)
      END MODULE  SPASTO
C=======================================================================
      MODULE      FSTSTO
      SAVE        FSTASV
      COMPLEX     FSTASV
      ALLOCATABLE FSTASV(:,:,:,:)
      END MODULE  FSTSTO
C=======================================================================
      MODULE      FPASTO
      SAVE        FSTPSV
      COMPLEX     FSTPSV
      ALLOCATABLE FSTPSV(:,:,:,:)
      END MODULE  FPASTO
C=======================================================================
      MODULE      ALISTO
      SAVE        ALINPP
      SAVE        ALINPM
      COMPLEX     ALINPP
      COMPLEX     ALINPM
      ALLOCATABLE ALINPP(:,:,:,:,:)
      ALLOCATABLE ALINPM(:,:,:,:,:)
      END MODULE  ALISTO
C=======================================================================
      MODULE      PLISTO
      SAVE        PLINPP
      SAVE        PLINPM
      COMPLEX     PLINPP
      COMPLEX     PLINPM
      ALLOCATABLE PLINPP(:,:,:,:,:)
      ALLOCATABLE PLINPM(:,:,:,:,:)
      END MODULE  PLISTO
C=======================================================================
      MODULE      AROSTO
      SAVE        AROTPP
      SAVE        AROTPM
      COMPLEX     AROTPP
      COMPLEX     AROTPM
      ALLOCATABLE AROTPP(:,:,:,:,:)
      ALLOCATABLE AROTPM(:,:,:,:,:)
      END MODULE  AROSTO
C=======================================================================
      MODULE      PROSTO
      SAVE        PROTPP
      SAVE        PROTPM
      COMPLEX     PROTPP
      COMPLEX     PROTPM
      ALLOCATABLE PROTPP(:,:,:,:,:)
      ALLOCATABLE PROTPM(:,:,:,:,:)
      END MODULE  PROSTO
C=======================================================================
      MODULE      COUSTO
      SAVE        COULSV
      COMPLEX     COULSV
      ALLOCATABLE COULSV(:,:,:,:)
      END MODULE  COUSTO
C=======================================================================
      MODULE      CPASTO
      SAVE        COUPSV
      COMPLEX     COUPSV
      ALLOCATABLE COUPSV(:,:,:)
      END MODULE  CPASTO
C=======================================================================
      MODULE      CYLTRA
      SAVE        AUXCYL
      COMPLEX     AUXCYL
      ALLOCATABLE AUXCYL(:,:)
      END MODULE  CYLTRA
C=======================================================================
      MODULE      PNMXPP
      SAVE        PNM_PP
      COMPLEX     PNM_PP
      ALLOCATABLE PNM_PP(:,:,:)
      END MODULE  PNMXPP
C=======================================================================
      MODULE      PNMXPM
      SAVE        PNM_PM
      COMPLEX     PNM_PM
      ALLOCATABLE PNM_PM(:,:,:)
      END MODULE  PNMXPM
C=======================================================================
      MODULE      TWCEPP
      SAVE        TWC_PP
      COMPLEX     TWC_PP
      ALLOCATABLE TWC_PP(:,:,:,:)
      END MODULE  TWCEPP
C=======================================================================
      MODULE      TWCEPM
      SAVE        TWC_PM
      COMPLEX     TWC_PM
      ALLOCATABLE TWC_PM(:,:,:,:)
      END MODULE  TWCEPM
C=======================================================================
      MODULE      TWCDEL
      SAVE        TWDEPP,TWDEPM
      COMPLEX     TWDEPP,TWDEPM
      ALLOCATABLE TWDEPP(:,:,:,:),TWDEPM(:,:,:,:)
      END MODULE  TWCDEL
C=======================================================================
      MODULE      DNMXPP
      SAVE        DNM_PP
      COMPLEX     DNM_PP
      ALLOCATABLE DNM_PP(:,:,:)
      END MODULE  DNMXPP
C=======================================================================
      MODULE      DNMXPM
      SAVE        DNM_PM
      COMPLEX     DNM_PM
      ALLOCATABLE DNM_PM(:,:,:)
      END MODULE  DNMXPM
C=======================================================================
      MODULE      FRAGFL
      SAVE        F_FLAG
      ALLOCATABLE F_FLAG(:,:,:)
      END MODULE  FRAGFL
C=======================================================================
      MODULE      RFACTO
#if(SWITCH_QUAD==1)
      REAL*16
     *            FACTOR,    FACTOE,    FACTOO
#endif
      SAVE        FACTOR,    FACTOE,    FACTOO
      ALLOCATABLE FACTOR(:), FACTOE(:), FACTOO(:)
      END MODULE  RFACTO
C=======================================================================
C=======================================================================
C=======================================================================
C      MODULE      CANWFV    !SIMIMAR AS CANBAS: REMOVE IT in lipnp_2
C     Canonical wave functions and u- and v- amplitudes
C     WAVCAN(IBASE, ISTATE, IREVER, ICHARG)
C     V_CAN (       ISTATE, ICHARG)
C     U_CAN (       ISTATE, ICHARG)
C     Where IBASE  = index of basis state
C           ISTATE = index of can.  state
C           IREVER = index of time-reversal block
C           ICHARG = index of charge (n/p) block
C      SAVE        WAVCAN,          V_CAN,        U_CAN
C      COMPLEX     WAVCAN
C      REAL                         V_CAN,        U_CAN
C      ALLOCATABLE WAVCAN(:,:,:,:), V_CAN(:,:), U_CAN(:,:)
C      END MODULE  CANWFV
C=======================================================================
C=======================================================================
      MODULE      MAD2PP
      SAVE        DEN2PP
      COMPLEX     DEN2PP
      ALLOCATABLE DEN2PP(:,:,:,:)
      END MODULE  MAD2PP
C=======================================================================
C=======================================================================
      MODULE      MAD3PP
      SAVE        DEN3PP
      COMPLEX     DEN3PP
      ALLOCATABLE DEN3PP(:,:,:,:)
      END MODULE  MAD3PP
C=======================================================================
C=======================================================================
      MODULE      MAD4PP
      SAVE        DEN4PP
      COMPLEX     DEN4PP
      ALLOCATABLE DEN4PP(:,:,:,:)
      END MODULE  MAD4PP
C=======================================================================
C=======================================================================
      MODULE      MAD5PP
      SAVE        DEN5PP
      COMPLEX     DEN5PP
      ALLOCATABLE DEN5PP(:,:,:,:)
      END MODULE  MAD5PP
C=======================================================================
      MODULE      DENCON
      SAVE        DCONTI
      COMPLEX     DCONTI
      ALLOCATABLE DCONTI(:,:,:)
      END MODULE  DENCON
C=======================================================================
      MODULE      TXXX_Y
      SAVE
C TER*          ZTER_T,
     *          ZKER_T,ZSKY_T,ZKIN_N,ZKIN_P,ZCOU_D,ZCOU_X,ZPAI_N,ZPAI_P,
     *                               ZPNU00,ZPNU10,ZPNU1P,ZPNU1M,
     *                               ZTZISO,ZT2ISO,ZBZROT,ZB2ROT,
     *                               ZC10_D,ZC1P_D,ZC1M_D,
     *                               ZC10_X,ZC1P_X,ZC1M_X,
     *                               ZC20_D,ZC21PD,ZC21MD,ZC22PD,ZC22MD,
     *                               ZC20_X,ZC21PX,ZC21MX,ZC22PX,ZC22MX,
C TER*          TTER_T,
     *          TKER_T,TSKY_T,TKIN_N,TKIN_P,TCOU_D,TCOU_X,TPAI_N,TPAI_P,
     *                               TPNU00,TPNU10,TPNU1P,TPNU1M,
     *                               TTZISO,TT2ISO,TBZROT,TB2ROT,
     *                               TC10_D,TC1P_D,TC1M_D,
     *                               TC10_X,TC1P_X,TC1M_X,
     *                               TC20_D,TC21PD,TC21MD,TC22PD,TC22MD,
     *                               TC20_X,TC21PX,TC21MX,TC22PX,TC22MX,
C TER*          TTE_TT,
     *          TKE_TT,TSK_TT,TKI_NT,TKI_PT,TCO_DT,TCO_XT,TPA_NT,TPA_PT,
     *                               TPN_00,TPN_10,TPN_1P,TPN_1M,
     *                               TTZ_IS,TT2_IS,TBZ_RO,TB2_RO,
     *                               TC1_D0,TC1_DP,TC1_DM,
     *                               TC1_X0,TC1_XP,TC1_XM,
     *                               TC2_D0,TC21DP,TC21DM,TC22DP,TC22DM,
     *                               TC2_X0,TC21XP,TC21XM,TC22XP,TC22XM
      COMPLEX
C TER*          ZTER_T,
     *          ZKER_T,ZSKY_T,ZKIN_N,ZKIN_P,ZCOU_D,ZCOU_X,ZPAI_N,ZPAI_P,
     *                               ZPNU00,ZPNU10,ZPNU1P,ZPNU1M,
     *                               ZTZISO,ZT2ISO,ZBZROT,ZB2ROT,
     *                               ZC10_D,ZC1P_D,ZC1M_D,
     *                               ZC10_X,ZC1P_X,ZC1M_X,
     *                               ZC20_D,ZC21PD,ZC21MD,ZC22PD,ZC22MD,
     *                               ZC20_X,ZC21PX,ZC21MX,ZC22PX,ZC22MX,
C TER*          TTER_T,
     *          TKER_T,TSKY_T,TKIN_N,TKIN_P,TCOU_D,TCOU_X,TPAI_N,TPAI_P,
     *                               TPNU00,TPNU10,TPNU1P,TPNU1M,
     *                               TTZISO,TT2ISO,TBZROT,TB2ROT,
     *                               TC10_D,TC1P_D,TC1M_D,
     *                               TC10_X,TC1P_X,TC1M_X,
     *                               TC20_D,TC21PD,TC21MD,TC22PD,TC22MD,
     *                               TC20_X,TC21PX,TC21MX,TC22PX,TC22MX,
C TER*          TTE_TT,
     *          TKE_TT,TSK_TT,TKI_NT,TKI_PT,TCO_DT,TCO_XT,TPA_NT,TPA_PT,
     *                               TPN_00,TPN_10,TPN_1P,TPN_1M,
     *                               TTZ_IS,TT2_IS,TBZ_RO,TB2_RO,
     *                               TC1_D0,TC1_DP,TC1_DM,
     *                               TC1_X0,TC1_XP,TC1_XM,
     *                               TC2_D0,TC21DP,TC21DM,TC22DP,TC22DM,
     *                               TC2_X0,TC21XP,TC21XM,TC22XP,TC22XM
      ALLOCATABLE
C TER*          TTER_T(:,:),TTE_TT(:,:,:),ZTER_T(:,:,:,:),
     *          TKER_T(:),TKE_TT(:,:),ZKER_T(:,:,:),
     *          TSKY_T(:),TSK_TT(:,:),ZSKY_T(:,:,:),
     *          TKIN_N(:),TKI_NT(:,:),ZKIN_N(:,:,:),
     *          TKIN_P(:),TKI_PT(:,:),ZKIN_P(:,:,:),
     *          TCOU_D(:),TCO_DT(:,:),ZCOU_D(:,:,:),
     *          TCOU_X(:),TCO_XT(:,:),ZCOU_X(:,:,:),
     *          TPAI_N(:),TPA_NT(:,:),ZPAI_N(:,:,:),
     *          TPAI_P(:),TPA_PT(:,:),ZPAI_P(:,:,:),
     *          TPNU00(:),TPN_00(:,:),ZPNU00(:,:,:),
     *          TPNU10(:),TPN_10(:,:),ZPNU10(:,:,:),
     *          TPNU1P(:),TPN_1P(:,:),ZPNU1P(:,:,:),
     *          TPNU1M(:),TPN_1M(:,:),ZPNU1M(:,:,:),
     *          TTZISO(:),TTZ_IS(:,:),ZTZISO(:,:,:),
     *          TT2ISO(:),TT2_IS(:,:),ZT2ISO(:,:,:),
     *          TBZROT(:),TBZ_RO(:,:),ZBZROT(:,:,:),
     *          TB2ROT(:),TB2_RO(:,:),ZB2ROT(:,:,:),
     *          TC10_D(:),TC1_D0(:,:),ZC10_D(:,:,:),
     *          TC1P_D(:),TC1_DP(:,:),ZC1P_D(:,:,:),
     *          TC1M_D(:),TC1_DM(:,:),ZC1M_D(:,:,:),
     *          TC20_D(:),TC2_D0(:,:),ZC20_D(:,:,:),
     *          TC21PD(:),TC21DP(:,:),ZC21PD(:,:,:),
     *          TC21MD(:),TC21DM(:,:),ZC21MD(:,:,:),
     *          TC22PD(:),TC22DP(:,:),ZC22PD(:,:,:),
     *          TC22MD(:),TC22DM(:,:),ZC22MD(:,:,:),
     *          TC10_X(:),TC1_X0(:,:),ZC10_X(:,:,:),
     *          TC1P_X(:),TC1_XP(:,:),ZC1P_X(:,:,:),
     *          TC1M_X(:),TC1_XM(:,:),ZC1M_X(:,:,:),
     *          TC20_X(:),TC2_X0(:,:),ZC20_X(:,:,:),
     *          TC21PX(:),TC21XP(:,:),ZC21PX(:,:,:),
     *          TC21MX(:),TC21XM(:,:),ZC21MX(:,:,:),
     *          TC22PX(:),TC22XP(:,:),ZC22PX(:,:,:),
     *          TC22MX(:),TC22XM(:,:),ZC22MX(:,:,:)
C
      END MODULE  TXXX_Y
C=======================================================================
      MODULE      HAMMIX
      SAVE
     *            CELMTS,OVEWAV,HAMWAV,HAMMAT,
     *            WAVPRO,WAVLEF,WAV_3D,
     *            OVEPRO,ENEPRO,ENE_3D
      COMPLEX
     *            CELMTS,OVEWAV,HAMWAV,HAMMAT,
     *            WAVPRO,WAVLEF,WAV_3D
      ALLOCATABLE
     *            CELMTS(:),
     *            OVEWAV(:,:),
     *            HAMWAV(:,:),
     *            HAMMAT(:,:),
     *            OVEPRO(:,:,:),
     *            WAVPRO(:,:,:),
     *            WAVLEF(:,:,:),
     *            WAV_3D(:,:,:),
     *            ENEPRO(:,:,:),
     *            ENE_3D(:,:,:)
C
      END MODULE  HAMMIX
C=======================================================================
        module colcoord
        use hfodd_sizes

!       nccmult - "mass parameters" are limited to multipolarity 2,3,4
!       nccall - max number of components, for real multipoles nccall=12
!
        integer, parameter :: nccmult=4, nccall=12

!       added for hf320a, max order of rpa energy moments
        integer, parameter :: ndemom=3

!        icolcoor - array of multipoles used for calculation of Bkj's,
!        read from input
!        numcoor - number of the multipoles
        integer, dimension (1:nccall,1:2) ::  icolcoor
        integer :: numcoor

!        switches, for value=1 mass parameters/ moments of inertia
!        calculations are done
        integer :: imaspar, imominer

!        amominer - moments of inertia (n+p)
!        aparmbg - mass parameters for quadrupole case
!      (beta, gamma variables)
!           calculated if condquad=.true.
!       ggr - collective gyrmagnetic coefficients
        real, dimension (1:3), save ::  amominer, aparmbg, ggr

!       condquad - TRUE if we have quadrupole case (plus some
!           extra requirements)
        logical, save :: condquad

!       amasmat - auxiliary arrays needed for calclations of Bkj
        real, dimension (1:nccall,1:nccall,1:ndemom,0:NDISOS),
     &  save :: amasmat

!       arbkj - Bkj quantities (in a sense mass parameters in
!     the cranking approximation)
        real, dimension (1:nccall,1:nccall), save :: arbkj
C
        end module colcoord

!===================
        module complex_const
        complex, parameter :: c_zero=(0.0,0.0), c_unit=(1.0,0.0),
     &  c_munit=(-1.0,0.0)
        end module complex_const

!===================
        module gyro
!       single-particle gyromagnetic factors
!       values set in PREDEF
        real, dimension (0:1) ::  gl, gs

        data gl(0) /0.d0  /
        data gl(1) /1.d0  /
        data gs(0) /-3.826/
        data gs(1) /5.586 /

        end module gyro

!===================
        module      te_mas
        complex     SPELEM,FOPQPA,FOPQPB
        allocatable SPELEM(:,:)
        allocatable FOPQPA(:,:,:), FOPQPB(:,:,:)
        allocatable OPIMRE(:,:)
        end module  te_mas

 MODULE hfodd_sizes

      IMPLICIT NONE

      !
      !   Principal parameters to be changed depending on the type of calculation
      !
      INTEGER, PARAMETER :: NDMAIN=16   ! Maximum number of HO shells
      INTEGER, PARAMETER :: NDBASE=969  ! Maximum number of HO basis states
      INTEGER, PARAMETER :: NDSTAT=1550 ! Maximum number of HF states without spin
      INTEGER, PARAMETER :: NDXHRM=34, NDYHRM=34, NDZHRM=34 ! Maximum numbers of Gauss-Hermite nodes
      INTEGER, PARAMETER :: NDAKNO=1   ! Maximum numbers of alpha nodes in the Euler AMP angles
      INTEGER, PARAMETER :: NDBKNO=100 ! Maximum numbers of  beta nodes in the Euler AMP angles
      INTEGER, PARAMETER :: NDPROI=100 ! Maximum doubled    spin in AMP
      INTEGER, PARAMETER :: NDATKN=1   ! Maximum numbers of alpha nodes in the Euler ISP angles
      INTEGER, PARAMETER :: NDBTKN=1   ! Maximum numbers of  beta nodes in the Euler ISP angles
      INTEGER, PARAMETER :: NDPROT=1   ! Maximum doubled isospin in ISP
      !
      !   Linear Algebra
      INTEGER, PARAMETER :: I_CRAY=0,IPARAL=0,IPARAT=0
      !
      !   General
      INTEGER, PARAMETER :: NDKART=3
      INTEGER, PARAMETER :: NDPARI=1, NDSIMP=1, NDSIGN=1, NDREVE=1
      INTEGER, PARAMETER :: NDISOS=1, NDSPIN=1, NDRHFB=1
      INTEGER, PARAMETER :: NDPAHO=5
      INTEGER, PARAMETER :: ND04=2, ND08=4, ND12=6, ND16=8, ND32=16, ND64=32, NDMAX=2*ND64
      INTEGER, PARAMETER :: NDENES=43
      !
      !   HO basis: number of states, integration mesh
      INTEGER, PARAMETER :: NDXMAX=NDMAIN, NDYMAX=NDMAIN, NDZMAX=NDMAIN
      INTEGER, PARAMETER :: NDOSCI=NDMAIN, ND0MAX=2*NDOSCI, ND1MAX=NDOSCI+2
      INTEGER, PARAMETER :: ND2MAX=2*NDOSCI+2, NDBTOT=(NDOSCI+1)**3
      INTEGER, PARAMETER :: NDINTE=2*NDOSCI+3, NDINT1=NDOSCI+1, NDINT2=NDOSCI+2
      INTEGER, PARAMETER :: NDPERP=NDMAIN
      INTEGER, PARAMETER :: NDTRAN=((NDMAIN+1)*(NDMAIN+2)*(NDMAIN+3))/6
      INTEGER, PARAMETER :: NDBASD=4*NDBASE
      INTEGER, PARAMETER :: NDBASP=NDBASE/2+MAX(20,NDBASE/12)
      INTEGER, PARAMETER :: NDDATA=2*NDSTAT*(NDISOS+1)
      INTEGER, PARAMETER :: NDHALF=2, NDREIM=2
      INTEGER, PARAMETER :: NDGAUS=MAX(NDXHRM,NDYHRM,NDZHRM)
      !
      !   Densities
      INTEGER, PARAMETER :: NDALLD=4+8*NDKART+2*NDKART*NDKART, NDALLP=1
      ! INTEGER, PARAMETER :: NDALLP=4+NDKART+NDKART*NDKART
      INTEGER, PARAMETER :: NDTYDE=2
      !
      !   Various: multipoles, Coulomb, iterations, binomial coefficients,
      !            functional
      INTEGER, PARAMETER :: NDMULT=9, NDLAMB=9, NDFACT=2*NDLAMB, NDCONS=10
      INTEGER, PARAMETER :: NDMULR=4, NDMULM=(NDMULR+1)**2
      INTEGER, PARAMETER :: NDDERI=2, NDSCAL=1
      INTEGER, PARAMETER :: NDCOUL=80, NDPOLS=25, NDNETA=NDCOUL
      INTEGER, PARAMETER :: ND_COU=20, NDCOTY=7
      INTEGER, PARAMETER :: NDYUKA=6, NDYUTY=2
      INTEGER, PARAMETER :: NDGOGA=2, NDFORC=4, NDREGA=4
      INTEGER, PARAMETER :: NDITER=5000, NDTERM=15
      INTEGER, PARAMETER :: NDSHIF=100, NDSMTH=20
      INTEGER, PARAMETER :: NDBINO=2*NDOSCI
      INTEGER, PARAMETER :: NDFACR=MAX(2*NDOSCI+7,NDGAUS)
      INTEGER, PARAMETER :: NDCOUP=24, NDCOUT=30, NDVIOL=32
      INTEGER, PARAMETER :: NDJMAX=70, NDJMXD=2*NDJMAX
      INTEGER, PARAMETER :: NFIRST=1, NLAST=40000
      INTEGER, PARAMETER :: NDSUBR=100, NDCOLU=4
      INTEGER, PARAMETER :: MV25=150
      INTEGER, PARAMETER :: NDNUCL=1
      INTEGER, PARAMETER :: NDSEAR=10
      INTEGER, PARAMETER :: ND_PRO=140, ND_NEU=250
      !
      !    Projection
      INTEGER, PARAMETER :: NDASAV=(1-IPARAL)*NDAKNO+IPARAL
      ! INTEGER, PARAMETER :: NDPROI=20, NDPROT=20, NDPROD=(NDPROI+1)*(NDPROT+1)
      INTEGER, PARAMETER :: NDPROD=101
      INTEGER, PARAMETER :: NDPROK=(NDPROI/2+1)**2
      INTEGER, PARAMETER :: NDPROM=((NDPROI+1)*(NDPROI+2)*(NDPROI+3))/6
      ! INTEGER, PARAMETER :: NDPROM=2550
      INTEGER, PARAMETER :: NUMCOL=70
      INTEGER, PARAMETER :: NDASAT=(1-IPARAT)*NDATKN+IPARAT
      INTEGER, PARAMETER :: NDISOM=((NDPROT+1)*(NDPROT+2)*(NDPROT+3))/6
      ! INTEGER, PARAMETER :: NDISOM=4
      !=========================================================================
      ! INTEGER, PARAMETER NDREDU BELOW IS EQUAL TO THE MINIMUM NECESSARY VALUE
      !=========================================================================
      ! INTEGER, PARAMETER
      !*          (NDREDU=NDPROK*(NDMULR+1)*NDPROK)
      !=========================================================================
      ! INTEGER, PARAMETER NDREDU BELOW IS EQUAL TO THE MINIMUM SUFFICIENT VALUE
      ! WHICH HAS BEEN OBTAINED BY FITTING THE  VALUES  CALCULATED  FOR
      ! NDMULR=4 WITH A 3RD-ORDER POLYNOMIAL, SEE THE ANALYSIS  IN  THE
      ! FILE HF222K.XLS OF 10/02/06
      !=========================================================================
      INTEGER, PARAMETER :: NDREDU=5*((((NDPROI+2)*NDPROI-5)*NDPROI+32))/2
      !=========================================================================
      !
      INTEGER, PARAMETER :: NDCONF=1,NDKERN=20,NDRZUT=20,ND_EXC=20
      INTEGER, PARAMETER :: NDISOK=(NDPROT+1)**2
      INTEGER, PARAMETER :: NDALIB=13
      INTEGER, PARAMETER :: NDORDE=6
      !
      !=========================================================================
      ! LINES BELOW MUST BE ADDED TO VERSION 5 TO OBTAIN VERSION 7
      !=========================================================================
      !
      INTEGER, PARAMETER :: NDMODU=20
      INTEGER, PARAMETER :: NDSEPA=NDREGA
      INTEGER, PARAMETER :: NDSEGA=10
      INTEGER, PARAMETER :: NDBLOC=2
      INTEGER, PARAMETER :: NDGAUG=21
      INTEGER, PARAMETER :: NDERRO=1000
      INTEGER, PARAMETER :: NDNUME=10
      INTEGER, PARAMETER :: NDANGU=NDBKNO+NDBTKN
      INTEGER, PARAMETER :: NDWIGN=MAX(NDPROI,NDPROT)
      INTEGER, PARAMETER :: NDPROW=NDPROM+NDISOM
      !
      !=========================================================================
      ! END OF LINES THAT MUST BE ADDED TO VERSION 5 TO OBTAIN VERSION 7
      !=========================================================================
      !
      !=========================================================================
      ! LINES BELOW MUST BE ADDED TO VERSION 7 TO OBTAIN VERSION 8
      !=========================================================================
      !
      INTEGER, PARAMETER :: ISWTWC=0
      INTEGER, PARAMETER :: NDTWCE=ISWTWC*2 +(1-ISWTWC)
      INTEGER, PARAMETER :: NDTWBL=ISWTWC*3 +(1-ISWTWC)
      INTEGER, PARAMETER :: NDTWHE=ISWTWC*16+(1-ISWTWC)
      !
      !=========================================================================
      ! LINES BELOW MUST BE ADDED TO VERSION 8 TO OBTAIN VERSION 9
      !=========================================================================
      !
      INTEGER, PARAMETER :: NDTWDD=ISWTWC*22+(1-ISWTWC)
      !
      !=========================================================================
      ! END OF LINES THAT MUST BE ADDED TO VERSION 8 TO OBTAIN VERSION 9
      !=========================================================================
      !
      CONTAINS
      !
      SUBROUTINE Set_version_hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      IF (NDMODU.NE.20) STOP 'CHANGE DIMENSIONS IN COMMON "VERMOD" IN Set_version_hfodd_sizes'
      !
      NAMMOD(1) = 'hfodd_sizes     '
      MODUVE(1) = 9
      MODSET(1) = 1
      !
      END SUBROUTINE Set_version_hfodd_sizes
      !
END MODULE hfodd_sizes

!***********************************************************************
!
!  Written by T. Lesinski 04/2013
!
!***********************************************************************
!
!    Copyright (c) 2015, Lawrence Livermore National Security, LLC.
!                        Produced at the Lawrence Livermore National
!                        Laboratory.
!                        Written by Nicolas Schunck, schunck1@llnl.gov
!
!    LLNL-CODE-470611 All rights reserved.
!
!    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
!                    W. Satula, J.A. Sheikh, A. Staszczak,
!                    M. Stoitsov, P. Toivanen
!    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
!                    P. Olbratowski, P. Powalowski, M. Sadziak,
!                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
!                    M. Zalewski, H. Zdunczuk
!    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
!    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
!
!    This file is part of HFODD.
!
!    HFODD is free software: you can redistribute it and/or modify it
!    under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    HFODD is distributed in the hope that it will be useful, but
!    WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
!
!    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
!    LICENSE
!
!    Our Preamble Notice
!
!      A. This notice is required to be provided under our contract
!         with the U.S. Department of Energy (DOE). This work was
!         produced at the Lawrence Livermore National Laboratory under
!         Contract No. DE-AC52-07NA27344 with the DOE.
!      B. Neither the United States Government nor Lawrence Livermore
!         National Security, LLC nor any of their employees, makes any
!         warranty, express or implied, or assumes any liability or
!         responsibility for the accuracy, completeness, or usefulness
!         of any information, apparatus, product, or process disclosed,
!         or represents that its use would not infringe privately-owned
!         rights.
!      C. Also, reference herein to any specific commercial products,
!         process, or services by trade name, trademark, manufacturer
!         or otherwise does not necessarily constitute or imply its
!         endorsement, recommendation, or favoring by the United States
!         Government or Lawrence Livermore National Security, LLC. The
!         views and opinions of authors expressed herein do not
!         necessarily state or reflect those of the United States
!         Government or Lawrence Livermore National Security, LLC, and
!         shall not be used for advertising or product endorsement
!         purposes.
!
!    The precise terms and conditions for copying, distribution and
!    modification are contained in the file COPYING.
!
!***********************************************************************

      SUBROUTINE Set_version_hfodd_pnp
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(12) = 'hfodd_pnp       '
      MODUVE(12) = 16
      MODSET(12) = 12
      !
      END SUBROUTINE Set_version_hfodd_pnp
      !
module hfodd_pnp
  implicit none

!***********************************************************************

! No globals here

!***********************************************************************

contains

  !=====================================================================
  !
  !     This subroutine calculates the energy after projection on
  !     neutron and proton particle numbers. It uses the canonical
  !     representation (canonical orbitals taken from MODULE CANBAS,
  !     populated by SUBROUTINE CANQUA). Canonical quasiparticles are
  !     built from canonical orbitals and u- and v- factors then passed
  !     to various routines calculating densities and energies.
  !
  !     TODO:
  !      * Final sanity check on the input parameters
  !      * Optimize:
  !        + Do left wf definition once
  !        + Store n/p densities for each value of n/p gauge angle
  !      * PN-projected kernel calculation ?
  !
  !=====================================================================

  SUBROUTINE PNPROJ(IN_FIX,IZ_FIX,NPPNPN,NPPNPP,               &
       &            ISIMTX,JSIMTY,ISIMTZ,ISIGNY,ISIMPY,ISIQTY, &
       &                                        IPAHFB,MREVER, &
       &                                        MIN_QP,IDOTHC, &
       &            IPNMIX,NUMCOU,BOUCOU,ICOTYP,ICOUDI,ICOUEX, &
       &            COUSCA,NAMEPN,PRINIT,IDEVAR,ITERUN,        &
       &            ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,EPNPRJ)
      USE CANBAS ! Canonical orbitals and occupations from CANQUA/Z
      USE WAVR_L ! Left-right wave functions to be passed to DENSHF
      USE HFODD_SIZES

      !-----------------------------------------------------------------

      IMPLICIT NONE

      !-----------------------------------------------------------------
      ! Input

      ! Number of Points for Particle-Number Projection of Neutrons/Protons
      INTEGER, INTENT(IN) :: NPPNPN,NPPNPP

      ! Standard parameters -- see subroutine NAMELI
      INTEGER, INTENT(IN) :: IN_FIX,IZ_FIX
      INTEGER, INTENT(IN) :: ISIMTX,JSIMTY,ISIMTZ
      INTEGER, INTENT(IN) :: ISIGNY,ISIMPY,ISIQTY
      INTEGER, INTENT(IN) :: IPAHFB
      INTEGER, INTENT(IN) :: MREVER
      INTEGER, INTENT(IN) :: IDOTHC
      INTEGER, INTENT(IN) :: MIN_QP
      INTEGER, INTENT(IN) :: IPNMIX
      INTEGER, INTENT(IN) :: NUMCOU,ICOTYP,ICOUDI,ICOUEX
      REAL,    INTENT(IN) :: BOUCOU,COUSCA
      LOGICAL, INTENT(IN) :: PRINIT
      INTEGER, INTENT(IN) :: IDEVAR
      INTEGER, INTENT(IN) :: ITERUN
      INTEGER, INTENT(IN) :: ISYMDE
      INTEGER, INTENT(IN) :: INIROT
      INTEGER, INTENT(IN) :: INIINV
      INTEGER, INTENT(IN) :: INIKAR
      INTEGER, INTENT(IN) :: ISAWAV

      CHARACTER(LEN=8), INTENT(IN) :: NAMEPN

      !-----------------------------------------------------------------
      ! Output: projected energy

      REAL, INTENT(INOUT) :: EPNPRJ

      !=================================================================
      ! Globals

      INTEGER :: LDBASE, LDTOTS, LDSTAT, LDUPPE, LDTIMU, NUMBQP
      COMPLEX :: PHASPI, ECCALL

      COMMON &
           /DIMENS/ LDBASE
      COMMON &
           /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS), &
           &        LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON &
           /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN,1:NDTWCE)
      COMMON &
           /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON &
           /ECCSKY/ ECCALL(NDCOUT)

     !=================================================================

     REAL, PARAMETER :: PI = 4.0D0*ATAN(1.0D0)

     !=================================================================

     INTEGER :: IALLOC, IBASE,  ISTATE, JSTATE, ISPIN,  ICHARG, IN, IP
     INTEGER :: IREVER, INN, IZZ

     REAL    :: THETAN, THETAP, ENEDUM, EKESCA, EKEVEC, XITFAC
     REAL    :: PARTICLENUMBER

     COMPLEX :: ZSHIFN, ZSHIFP, ZSHIFT, CFUPPR, CFLOWR
     COMPLEX :: OVRLAP, EKERNL, EDUMCX
     COMPLEX :: EKEKIN(0:NDISOS), EKESKY, &
          EKESVO, EKESSU, EKESSO, EKESTE, &
          EKECOU, EKECOD, EKECOE, EKEPAI(0:NDISOS)

     COMPLEX, DIMENSION(IN_FIX,IZ_FIX) ::                   &
          EKNITG,EKPITG,ESKITG,EVOITG,ESUITG,ESOITG,ETEITG, &
          ECOITG,ECDITG,ECEITG,                             &
          EPNITG,EPPITG,ENEITG,OVRITG

     COMPLEX, DIMENSION(NDCOUT,IN_FIX,IZ_FIX) :: ECCITG
     COMPLEX, DIMENSION(NDCOUT)               :: ECCALLpnp

     !=================================================================
     ! Time execution
     CALL CPUTIM('PNPROJ',1)


     PRINT '("*",77("*"),"*")'
     PRINT '("*",77x,"*")'
     PRINT '("*",24x,"PROJECTING ON PARTICLE NUMBER",24x,"*")'
     PRINT '("*",77x,"*")'
     PRINT '("*",77("*"),"*")'

     !=================================================================
     ! Prepare arrays for storing shifted wave functions

     IF (.NOT.ALLOCATED(WALEFT)) THEN
        ALLOCATE (WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
        IF (IALLOC.NE.0) CALL NOALLO('WALEFT','PNPROJ')
     END IF
     WALEFT(:,:,:) = 0.0d0

     IF (.NOT.ALLOCATED(WARIGH)) THEN
        ALLOCATE (WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
        IF (IALLOC.NE.0) CALL NOALLO('WARIGH','PNPROJ')
     END IF
     WARIGH(:,:,:) = 0.0d0

     !=================================================================

     ! TODO: Final sanity check on the parameters

     !=================================================================
     ! Get canonical WFs, v^2, uv
     ! ==> We assume CANQUA was called, populating the CANBAS module.

     !-----------------------------------------------------------------
     ! Init arrays for accumulating integrands

      ENEITG(:,:)=0.0d0  ! Total energy
      OVRITG(:,:)=0.0d0  ! Overlap

      EKNITG(:,:)=0.0d0  ! Kinetic n
      EKPITG(:,:)=0.0d0  ! Kinetic p
      ESKITG(:,:)=0.0d0  ! Skyrme total
      ECOITG(:,:)=0.0d0  ! Coulomb total
      ECDITG(:,:)=0.0d0  ! Coulomb direct
      ECEITG(:,:)=0.0d0  ! Coulomb exchange
      EPNITG(:,:)=0.0d0  ! Pairing n
      EPPITG(:,:)=0.0d0  ! Pairing p

      ECCITG(:,:,:)=0.0d0 ! Skyrme, term-by-term

      ! Integral prefactor
      XITFAC = 1.0d0/(NPPNPN*NPPNPP)

      !-----------------------------------------------------------------
      ! Begin loop on gauge-angle integration points

      DO IN = 1, NPPNPN
         DO IP = 1, NPPNPP

            ! Init energy kernel. We'll add up contributions there.
            EKERNL=0.0d0

            ! Gauge angles
            THETAN= (IN-1.0d0) * PI / NPPNPN
            THETAP= (IP-1.0d0) * PI / NPPNPP

            ! Complex shifts
            ZSHIFN=CMPLX(COS(THETAN), SIN(THETAN))
            ZSHIFP=CMPLX(COS(THETAP), SIN(THETAP))

            !...........................................................
            ! Rebuild quasiparticles with U(1) rotation built-in
            ! (we convert from simplex to spin representation on the fly)
            ! then calculate transition densities

            DO ICHARG=0,NDISOS

               ! Shift (z)
               IF ( ICHARG == 0 ) THEN
                  ! Neutrons
                  ZSHIFT = ZSHIFN
               ELSE
                  ! Protons
                  ZSHIFT = ZSHIFP
               END IF

               JSTATE=0 ! Counter for wfs we put in WALEFT/WARIGH

               ! . . . . . . . . . . . . . . . . . . . . . . . . . . . .

               ! First, upper components time+ then time-
               DO IREVER=0,1

                  ! NB: We iterate on both time-reversal blocks since we
                  ! need both for non-diagonal energy kernels (V_n and
                  ! V_(-n) cannot be recovered fom each other for the
                  ! right state because of the additional complex shift
                  ! factor).

                  ! Loop on canonical states
                  DO ISTATE=1,NUMBQP(IREVER,ICHARG)

                     JSTATE=JSTATE+1

                     ! Left wave function
                     DO ISPIN=0,1
                        WALEFT(1:LDBASE,JSTATE,ISPIN) =              &
                             V_CAN(ISTATE,IREVER,ICHARG)             &
                             * WAVCAN(1:LDBASE,ISTATE,IREVER,ICHARG) &
                             * PHASPI(1:LDBASE,IREVER,ISPIN,1)
                     END DO

                     ! Right (shifted and normalized) wave function...
                     CFUPPR = ZSHIFT**2 * V_CAN(ISTATE,IREVER,ICHARG)  &
                          / ( U_CAN(ISTATE,IREVER,ICHARG)**2           &
                          +   (ZSHIFT*V_CAN(ISTATE,IREVER,ICHARG))**2 )

                     DO ISPIN=0,1
                        WARIGH(1:LDBASE,JSTATE,ISPIN) = CFUPPR         &
                             * WAVCAN(1:LDBASE,ISTATE,IREVER,ICHARG)   &
                             * PHASPI(1:LDBASE,IREVER,ISPIN,1)
                     END DO
                  END DO ! ISTATE
                  ! Number of time-up states
                  IF (IREVER==0) LDTIMU(ICHARG) = JSTATE

               END DO ! IREVER
               ! Number of upper HFB wave functions
               LDUPPE(ICHARG) = JSTATE

               ! . . . . . . . . . . . . . . . . . . . . . . . . . . . .

               ! Then, lower components, time- then time+ We
               ! apply time-reversal on the wfs like in DENSHF to
               ! follow the Dobaczewski-Flocard-Treiner
               ! convention
               DO IREVER=1,0,-1

                  DO ISTATE=1,NUMBQP(IREVER,ICHARG)

                     JSTATE=JSTATE+1

                     ! Left wave function
                     DO ISPIN=0,1
                        WALEFT(1:LDBASE,JSTATE,ISPIN) =                &
                             U_CAN(ISTATE,IREVER,ICHARG) * (2*ISPIN-1) &
                             * CONJG(                                  &
                             WAVCAN(1:LDBASE,ISTATE,IREVER,ICHARG)     &
                             * PHASPI(1:LDBASE,IREVER,1-ISPIN,1) )
                     END DO

!                    Right (normalized) wave function

                     CFLOWR = U_CAN(ISTATE,IREVER,ICHARG)              &
                          / ( U_CAN(ISTATE,IREVER,ICHARG)**2           &
                          +   (ZSHIFT*V_CAN(ISTATE,IREVER,ICHARG))**2 )

                     DO ISPIN=0,1
                        WARIGH(1:LDBASE,JSTATE,ISPIN) =           &
                            CFLOWR * (2*ISPIN-1)                  &
                            * CONJG(                              &
                            WAVCAN(1:LDBASE,ISTATE,IREVER,ICHARG) &
                            * PHASPI(1:LDBASE,IREVER,1-ISPIN,1) )
                     END DO

                  END DO        ! ISTATE

                  ! Number of states up to now....
                  IF(IREVER.EQ.1) LDSTAT(ICHARG) = JSTATE

               END DO           ! IREVER
               ! Total number of states
               LDTOTS(ICHARG) = JSTATE

               ! . . . . . . . . . . . . . . . . . . . . . . . . . . . .

               ! Calculating transition density matrix for K.E. computation
               ! (setting MREVER=1, see NB: above, and IPAHFB=1)
               CALL DENMAC(1,ICHARG,ISIMPY,1,WALEFT,WARIGH,1)
               ! Calculating kinetic energy kernel for current isospin
               CALL EKINET(ENEDUM,ENEDUM,EKEKIN(ICHARG),EDUMCX,1)

               ! . . . . . . . . . . . . . . . . . . . . . . . . . . . .

               ! Calculating transition densities for current isospin
               ! (setting IPAHFB=1, MREVER=1,
               ! ITPNMX=ICHARG, ITIREP=0, IKERNE=1)
               CALL ZEDENS(ICHARG) ! Zero densities first
               CALL DENSHF(ISIMTX,JSIMTY,ISIMTZ, &
                    &      ISIGNY,ISIMPY,ISIQTY,1     ,1     ,ICHARG, &
                    &                           MIN_QP,IPNMIX,ICHARG, &
                    &      0     ,NAMEPN,PRINIT,IDEVAR,ITERUN,        &
                    &      ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,1,1)

            END DO ! ICHARG

            !...........................................................
            ! Calculate Coulomb energy kernel with previously calculated
            ! densities

            ! Default value if no Coulomb
            EKECOD = 0.0d0
            EKECOE = 0.0d0

            ! Calculate charge density
            CALL TRUCHD

            ! Direct Coulomb field and energy by solution of Poisson's
            ! equation
            IF (ICOUDI.EQ.1) THEN
               ! (setting IKERNE=1)
               CALL COUMAT(NUMCOU,BOUCOU,ISIMPY,1)
               CALL COULOD(ISIMPY,EKECOD)
            END IF

            ! Slater approximation for Coulomb exchange energy
            IF (ICOUEX.EQ.1) THEN
               CALL COULOE(EKECOE)
            END IF

            ! NB: After exiting the loop on ICHARG, BIG_PP contains the
            ! proton density matrix.
            ! ***
            ! WE RELY ON THAT IN THE CALL TO COUENE !!!
            ! ***

            ! Direct and exact exchange through matrix elements
            ! (Gaussian expansion)
            IF (ICOUDI.EQ.2.OR.ICOUEX.EQ.2) THEN
               CALL COUENE(ISIMPY,               &
                    &      ICOTYP,ICOUDI,ICOUEX, &
                    &      EKECOD,EKESCA,EKEVEC)
               !  Replace previous value if appropriate
               IF (ICOUEX.EQ.2) EKECOE=EKESCA+EKEVEC
            END IF

            ! To match HFBTHO
            EKECOD = CONJG(EKECOD)
            EKECOE = CONJG(EKECOE)

            ! Direct+exchange coulomb energy
            EKECOU=EKECOD + EKECOE*COUSCA

            !...........................................................
            ! Calculate Skyrme energy kernel with previously calculated
            ! densities

            ! Calculate density for density-dependent terms
            CALL TRUTOD(1,1)

            ! Skyrme energy (setting LDPNMX=1)
            CALL ESKYRM(ENEDUM,ENEDUM,ENEDUM,        &
                 &      ENEDUM,ENEDUM,ENEDUM,ENEDUM, &
                 &      EKESKY,1,0,1)
            ! (Components of Skyrme energy now stored in ECCALL)

            ! Same for Pairing energy.
            DO ICHARG=0,NDISOS
               ! (setting ITPNMX=ICHARG)
               CALL EPAIRI(IN_FIX,IZ_FIX,ICHARG,EKEPAI(ICHARG))
            END DO

            ! To match HFBTHO
            EKESKY       = CONJG(EKESKY)
            ECCALLpnp(:) = CONJG(ECCALL(:))
            EKEPAI(:)    = CONJG(EKEPAI(:))

            !...........................................................
            ! Compute overlap between left and right wave functions
            ! (Onishi formula for canonical basis)

            OVRLAP=1.0d0
            DO ICHARG=0,NDISOS

               ! Shift (z)
               IF ( ICHARG .EQ. 0 ) THEN
                  ! Neutrons
                  ZSHIFT = ZSHIFN
               ELSE
                  ! Protons
                  ZSHIFT = ZSHIFP
               END IF

               DO ISTATE=1, NUMBQP(0,ICHARG)
                  OVRLAP=OVRLAP                      &
                       * ( U_CAN(ISTATE,0,ICHARG)**2 &
                       +   (ZSHIFT*V_CAN(ISTATE,0,ICHARG))**2 )
               END DO

            END DO

            !...........................................................
            ! Accumulate contributions

            WRITE(75, '(6es16.8)') THETAN, THETAP, OVRLAP, EKERNL

            EKERNL=EKEKIN(0)+EKEKIN(1)+EKESKY+EKECOU &
                 &    + EKEPAI(0)+EKEPAI(1)

            DO INN=1, IN_FIX
               DO IZZ=1, IZ_FIX
                  ! Components of the energy-integral

                  ! Energy-integral by coupling constants
                  ECCITG(:,INN,IZZ)=ECCITG(:,INN,IZZ)       &
                      + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                      * XITFAC*OVRLAP*ECCALLpnp(:)
                  ! Skyrme-energy integral
                  ESKITG(INN,IZZ)=ESKITG(INN,IZZ)            &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                       * XITFAC*OVRLAP*EKESKY

                  ! Kinetic-energy integrals
                  EKNITG(INN,IZZ)=EKNITG(INN,IZZ)           &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                       * XITFAC*OVRLAP*EKEKIN(0)
                  EKPITG(INN,IZZ)=EKPITG(INN,IZZ)           &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                       * XITFAC*OVRLAP*EKEKIN(1)

                  ! Coulomb-energy integrals
                  ECOITG(INN,IZZ)=ECOITG(INN,IZZ)            &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                       * XITFAC*OVRLAP*EKECOU
                  ECDITG(INN,IZZ)=ECDITG(INN,IZZ)            &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                       * XITFAC*OVRLAP*EKECOD
                  ECEITG(INN,IZZ)=ECEITG(INN,IZZ)            &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                       * XITFAC*OVRLAP*EKECOE

                  ! Pairing-energy integrals
                  EPNITG(INN,IZZ)=EPNITG(INN,IZZ)            &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                       * XITFAC*OVRLAP*EKEPAI(0)
                  EPPITG(INN,IZZ)=EPPITG(INN,IZZ)            &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                       * XITFAC*OVRLAP*EKEPAI(1)

                  ! Energy-integral
                  ENEITG(INN,IZZ)=ENEITG(INN,IZZ)            &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                      * XITFAC*OVRLAP*EKERNL
                  ! Overlap-integral
                  OVRITG(INN,IZZ)=OVRITG(INN,IZZ)            &
                       + ZSHIFN**(-2*INN) * ZSHIFP**(-2*IZZ) &
                       * XITFAC*OVRLAP
               END DO
            END DO

            !...........................................................
            ! Print summary

            PRINT '("*",77x,"*")'
            PRINT '("*  z_n        ",2f12.5,"   z_p        ",2f12.5,"  *")', &
                 ZSHIFN,ZSHIFP
            PRINT '("*  Skyrme   E ",2f12.5,"   n kin. E   ",2f12.5,"  *")', &
                 EKESKY,EKEKIN(0)
            PRINT '("*   volume    ",2f12.5,"   p kin. E   ",2f12.5,"  *")', &
                   ECCALLpnp(1) + ECCALLpnp(2) + ECCALLpnp(3) + ECCALLpnp(4)      &
                 + ECCALLpnp(7) + ECCALLpnp(8), EKEKIN(1)
            PRINT '("*    contact  ",2f12.5,"   Coulomb E  ",2f12.5,"  *")', &
                 ECCALLpnp(1) + ECCALLpnp(2), EKECOU
            PRINT '("*    dens-dep ",2f12.5,"    direct    ",2f12.5,"  *")', &
                 ECCALLpnp(3) + ECCALLpnp(4), EKECOD
            PRINT '("*    eff mass ",2f12.5,"    exchange  ",2f12.5,"  *")', &
                 ECCALLpnp(7) + ECCALLpnp(8), EKECOE
            PRINT '("*   surface   ",2f12.5,"   n pair. E  ",2f12.5,"  *")', &
                 ECCALLpnp(5) + ECCALLpnp(6), EKEPAI(0)
            PRINT '("*   spin-o.   ",2f12.5,"   p pair. E  ",2f12.5,"  *")', &
                 ECCALLpnp(11) + ECCALLpnp(12), EKEPAI(1)
            PRINT '("*   tensor    ",2f12.5,38(" "),"  *")',                          &
                  ECCALLpnp(9) + ECCALLpnp(10)

            PRINT '("* Overlap     ",2f12.5,"  E kernel    ",2f12.5,"  *")',  &
                OVRLAP,   EKERNL

         END DO ! IP
      END DO ! IN

      ! (end loop on gauge-angle integration points)
      !-----------------------------------------------------------------

      ! Projected energy = ratio of integrals

      EPNPRJ = REAL(ENEITG(IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2))

      !     DEBUG DEBUG DEBUG
      !      WRITE(76, '(2a4,8(2x,2a15))')
      !     *           "# N", "Z",
      !     *           "ENEITG", "OVRITG",
      !     *           "EKNITG", "EKPITG",
      !     *           "ESKITG", "ECOITG",
      !     *           "EPNITG", "EPPITG"
      !      DO INN=1,IN_FIX
      !         DO IZZ=1,IZ_FIX
      !            WRITE(76, '(2i4,8(2x,2es15.6))')
      !     *           2*INN, 2*IZZ,
      !     *           ENEITG(INN,IZZ), OVRITG(INN,IZZ),
      !     *           EKNITG(INN,IZZ), EKPITG(INN,IZZ),
      !     *           ESKITG(INN,IZZ), ECOITG(INN,IZZ),
      !     *           EPNITG(INN,IZZ), EPPITG(INN,IZZ)
      !         END DO
      !         WRITE(76, *)
      !      END DO

      !------------------------------------------------------------------
      ! Print final results

      !PRINT '(79("*"))'
      !PRINT *, "* Projected term-by-term Skyrme energies"
      !PRINT '("*  1 ERHO_T = ",(2f13.6))', &
      !    ECCITG( 1,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("*  2 ERHO_S = ",(2f13.6))', &
      !    ECCITG( 2,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("*  3 ERHODT = ",(2f13.6))', &
      !    ECCITG( 3,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("*  4 ERHODS = ",(2f13.6))', &
      !    ECCITG( 4,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("*  5 ELPR_T = ",(2f13.6))', &
      !    ECCITG( 5,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("*  6 ELPR_S = ",(2f13.6))', &
      !    ECCITG( 6,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("*  7 ETAU_T = ",(2f13.6))', &
      !    ECCITG( 7,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("*  8 ETAU_S = ",(2f13.6))', &
      !    ECCITG( 8,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("*  9 ESCU_T = ",(2f13.6))', &
      !    ECCITG( 9,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 10 ESCU_S = ",(2f13.6))', &
      !    ECCITG(10,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 11 EDIV_T = ",(2f13.6))', &
      !    ECCITG(11,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 12 EDIV_S = ",(2f13.6))', &
      !    ECCITG(12,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 13 ESPI_T = ",(2f13.6))', &
      !    ECCITG(13,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 14 ESPI_S = ",(2f13.6))', &
      !    ECCITG(14,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 15 ESPIDT = ",(2f13.6))', &
      !    ECCITG(15,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 16 ESPIDS = ",(2f13.6))', &
      !    ECCITG(16,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 17 ELPS_T = ",(2f13.6))', &
      !    ECCITG(17,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 18 ELPS_S = ",(2f13.6))', &
      !    ECCITG(18,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 19 ECUR_T = ",(2f13.6))', &
      !    ECCITG(19,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 20 ECUR_S = ",(2f13.6))', &
      !    ECCITG(20,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 21 EKIS_T = ",(2f13.6))', &
      !    ECCITG(21,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 22 EKIS_S = ",(2f13.6))', &
      !    ECCITG(22,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 23 EROT_T = ",(2f13.6))', &
      !    ECCITG(23,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)
      !PRINT '("* 24 EROT_S = ",(2f13.6))', &
      !    ECCITG(24,IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/y2)

      PRINT '("*",77x,"*")'
      PRINT '("*",77("*"),"*")'
      PRINT '("*",77x,"*")'
      PRINT '("* E Skyrme     ",f15.6,"  E kinetic, n ",f15.6,18x,"*")', &
          REAL(ESKITG(IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2)), &
           REAL(EKNITG(IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2))

      PRINT '("*  volume      ",f15.6,"  E kinetic, p ",f15.6,18x,"*")', &
           REAL(                            &
           ( ECCITG( 1,IN_FIX/2,IZ_FIX/2) + ECCITG( 2,IN_FIX/2,IZ_FIX/2)  &
           + ECCITG( 3,IN_FIX/2,IZ_FIX/2) + ECCITG( 4,IN_FIX/2,IZ_FIX/2)  &
           + ECCITG( 7,IN_FIX/2,IZ_FIX/2) + ECCITG( 8,IN_FIX/2,IZ_FIX/2)) &
           /OVRITG(IN_FIX/2,IZ_FIX/2)),                                   &
           REAL(EKPITG(IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2))

      PRINT '("*   contact    ",f15.6,"  E Coulomb    ",f15.6,18x,"*")', &
           REAL(                            &
          ( ECCITG( 1,IN_FIX/2,IZ_FIX/2) + ECCITG( 2,IN_FIX/2,IZ_FIX/2))  &
          /OVRITG(IN_FIX/2,IZ_FIX/2)),                                    &
           REAL(ECOITG(IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2))

      PRINT '("*   dens. dep. ",f15.6,"    direct     ",f15.6,18x,"*")', &
           REAL(                            &
          ( ECCITG( 3,IN_FIX/2,IZ_FIX/2) + ECCITG( 4,IN_FIX/2,IZ_FIX/2))  &
          /OVRITG(IN_FIX/2,IZ_FIX/2)),                                    &
           REAL(ECDITG(IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2))

      PRINT '("*  eff. mass   ",f15.6,"    exchange   ",f15.6,18x,"*")', &
           REAL(                            &
          ( ECCITG( 7,IN_FIX/2,IZ_FIX/2) + ECCITG( 8,IN_FIX/2,IZ_FIX/2))  &
          /OVRITG(IN_FIX/2,IZ_FIX/2)),                                   &
           REAL(ECEITG(IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2))

      PRINT '("*  surface     ",f15.6,"  E pairing, n ",f15.6,18x,"*")', &
           REAL(                             &
           ( ECCITG( 5,IN_FIX/2,IZ_FIX/2) + ECCITG( 6,IN_FIX/2,IZ_FIX/2))  &
           /OVRITG(IN_FIX/2,IZ_FIX/2)),                                    &
           REAL(EPNITG(IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2))

      PRINT '("*  spin-o.     ",f15.6,"  E pairing, p ",f15.6,18x,"*")', &
           REAL(                             &
           ( ECCITG(11,IN_FIX/2,IZ_FIX/2) + ECCITG(12,IN_FIX/2,IZ_FIX/2))  &
           /OVRITG(IN_FIX/2,IZ_FIX/2)),                                   &
           REAL(EPPITG(IN_FIX/2,IZ_FIX/2)/OVRITG(IN_FIX/2,IZ_FIX/2))

      PRINT '("*  tensor      ",f15.6,48x,"*")', REAL(                     &
           ( ECCITG( 9,IN_FIX/2,IZ_FIX/2) + ECCITG(10,IN_FIX/2,IZ_FIX/2))  &
           /OVRITG(IN_FIX/2,IZ_FIX/2))
      PRINT '("*",77x,"*")'

      !------------------------------------------------------------------
      ! Norm of mean-field state from overlaps
      PRINT '("* PNP ENERGY                  ",f15.6,33x,"*")', EPNPRJ
      PRINT '("* N overlap                   ",2f15.6,18x,"*")', &
           OVRITG(IN_FIX/2,IZ_FIX/2)
      PRINT '("* Sum PNP overlap components  ",2f15.6,18x,"*")',      &
           SUM(OVRITG((IN_FIX-NPPNPN)/2+1:(IN_FIX-NPPNPN)/2+NPPNPN,   &
           (IZ_FIX-NPPNPP)/2+1:(IZ_FIX-NPPNPP)/2+NPPNPP))
      ! PNP sum rule
      PRINT '("* PNP sum Rule (Skyrme E)     ",2f15.6,18x,"*")',      &
           SUM(ESKITG((IN_FIX-NPPNPN)/2+1:(IN_FIX-NPPNPN)/2+NPPNPN,   &
           (IZ_FIX-NPPNPP)/2+1:(IZ_FIX-NPPNPP)/2+NPPNPP))
      PRINT '("* PNP sum Rule (total E)      ",2f15.6,18x,"*")',     &
           SUM(ENEITG((IN_FIX-NPPNPN)/2+1:(IN_FIX-NPPNPN)/2+NPPNPN,   &
           (IZ_FIX-NPPNPP)/2+1:(IZ_FIX-NPPNPP)/2+NPPNPP))

      PRINT '("*",77x,"*")'
      PRINT '("*",77("*"),"*")'

      !------------------------------------------------------------------
      ! Time execution
      CALL CPUTIM('PNPROJ',0)

    END SUBROUTINE PNPROJ

    !====================================================================

end module hfodd_pnp

!************************************************************************

      subroutine zgedi(a,lda,n,ipvt,det,work,job)
      integer lda,n,ipvt(1),job
      complex*16 a(lda,1),det(2),work(1)
c
c     zgedi computes the determinant and inverse of a matrix
c     using the factors computed by zgeco or zgefa.
c
c     on entry
c
c        a       complex*16(lda, n)
c                the output from zgeco or zgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from zgeco or zgefa.
c
c        work    complex*16(n)
c                work vector.  contents destroyed.
c
c        job     integer
c                = 11   both determinant and inverse.
c                = 01   inverse only.
c                = 10   determinant only.
c
c     on return
c
c        a       inverse of original matrix if requested.
c                otherwise unchanged.
c
c        det     complex*16(2)
c                determinant of original matrix if requested.
c                otherwise not referenced.
c                determinant = det(1) * 10.0**det(2)
c                with  1.0 .le. cabs1(det(1)) .lt. 10.0
c                or  det(1) .eq. 0.0 .
c
c     error condition
c
c        a division by zero will occur if the input factor contains
c        a zero on the diagonal and the inverse is requested.
c        it will not occur if the subroutines are called correctly
c        and if zgeco has set rcond .gt. 0.0 or zgefa has set
c        info .eq. 0 .
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas zaxpy,zscal,zswap
c     fortran dabs,dcmplx,mod
c
c     internal variables
c
      complex*16 t
      double precision ten
      integer i,j,k,kb,kp1,l,nm1
c
      complex*16 zdum
      double precision cabs1
      double precision dreal,dimag
      complex*16 zdumr,zdumi
      dreal(zdumr) = zdumr
      dimag(zdumi) = (0.0d0,-1.0d0)*zdumi
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))
c
c     compute determinant
c
      if (job/10 .eq. 0) go to 70
         det(1) = (1.0d0,0.0d0)
         det(2) = (0.0d0,0.0d0)
         ten = 10.0d0
         do 50 i = 1, n
            if (ipvt(i) .ne. i) det(1) = -det(1)
            det(1) = a(i,i)*det(1)
c        ...exit
            if (cabs1(det(1)) .eq. 0.0d0) go to 60
   10       if (cabs1(det(1)) .ge. 1.0d0) go to 20
               det(1) = dcmplx(ten,0.0d0)*det(1)
               det(2) = det(2) - (1.0d0,0.0d0)
            go to 10
   20       continue
   30       if (cabs1(det(1)) .lt. ten) go to 40
               det(1) = det(1)/dcmplx(ten,0.0d0)
               det(2) = det(2) + (1.0d0,0.0d0)
            go to 30
   40       continue
   50    continue
   60    continue
   70 continue
c
c     compute inverse(u)
c
      if (mod(job,10) .eq. 0) go to 150
         do 100 k = 1, n
            a(k,k) = (1.0d0,0.0d0)/a(k,k)
            t = -a(k,k)
            call zscal(k-1,t,a(1,k),1)
            kp1 = k + 1
            if (n .lt. kp1) go to 90
            do 80 j = kp1, n
               t = a(k,j)
               a(k,j) = (0.0d0,0.0d0)
               call zaxpy(k,t,a(1,k),1,a(1,j),1)
   80       continue
   90       continue
  100    continue
c
c        form inverse(u)*inverse(l)
c
         nm1 = n - 1
         if (nm1 .lt. 1) go to 140
         do 130 kb = 1, nm1
            k = n - kb
            kp1 = k + 1
            do 110 i = kp1, n
               work(i) = a(i,k)
               a(i,k) = (0.0d0,0.0d0)
  110       continue
            do 120 j = kp1, n
               t = work(j)
               call zaxpy(n,t,a(1,j),1,a(1,k),1)
  120       continue
            l = ipvt(k)
            if (l .ne. k) call zswap(n,a(1,k),1,a(1,l),1)
  130    continue
  140    continue
  150 continue
      return
      end
      subroutine zgeco(a,lda,n,ipvt,rcond,z)
      integer lda,n,ipvt(1)
      complex*16 a(lda,1),z(1)
      double precision rcond
c
c     zgeco factors a complex*16 matrix by gaussian elimination
c     and estimates the condition of the matrix.
c
c     if  rcond  is not needed, zgefa is slightly faster.
c     to solve  a*x = b , follow zgeco by zgesl.
c     to compute  inverse(a)*c , follow zgeco by zgesl.
c     to compute  determinant(a) , follow zgeco by zgedi.
c     to compute  inverse(a) , follow zgeco by zgedi.
c
c     on entry
c
c        a       complex*16(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        rcond   double precision
c                an estimate of the reciprocal condition of  a .
c                for the system  a*x = b , relative perturbations
c                in  a  and  b  of size  epsilon  may cause
c                relative perturbations in  x  of size  epsilon/rcond .
c                if  rcond  is so small that the logical expression
c                           1.0 + rcond .eq. 1.0
c                is true, then  a  may be singular to working
c                precision.  in particular,  rcond  is zero  if
c                exact singularity is detected or the estimate
c                underflows.
c
c        z       complex*16(n)
c                a work vector whose contents are usually unimportant.
c                if  a  is close to a singular matrix, then  z  is
c                an approximate null vector in the sense that
c                norm(a*z) = rcond*norm(a)*norm(z) .
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     linpack zgefa
c     blas zaxpy,zdotc,zdscal,dzasum
c     fortran dabs,dmax1,dcmplx,dconjg
c
c     internal variables
c
      complex*16 zdotc,ek,t,wk,wkm
      double precision anorm,s,dzasum,sm,ynorm
      integer info,j,k,kb,kp1,l
c
      complex*16 zdum,zdum1,zdum2,csign1
      double precision cabs1
      double precision dreal,dimag
      complex*16 zdumr,zdumi
      dreal(zdumr) = zdumr
      dimag(zdumi) = (0.0d0,-1.0d0)*zdumi
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))
      csign1(zdum1,zdum2) = cabs1(zdum1)*(zdum2/cabs1(zdum2))
c
c     compute 1-norm of a
c
      anorm = 0.0d0
      do 10 j = 1, n
         anorm = dmax1(anorm,dzasum(n,a(1,j),1))
   10 continue
c
c     factor
c
      call zgefa(a,lda,n,ipvt,info)
c
c     rcond = 1/(norm(a)*(estimate of norm(inverse(a)))) .
c     estimate = norm(z)/norm(y) where  a*z = y  and  ctrans(a)*y = e .
c     ctrans(a)  is the conjugate transpose of a .
c     the components of  e  are chosen to cause maximum local
c     growth in the elements of w  where  ctrans(u)*w = e .
c     the vectors are frequently rescaled to avoid overflow.
c
c     solve ctrans(u)*w = e
c
      ek = (1.0d0,0.0d0)
      do 20 j = 1, n
         z(j) = (0.0d0,0.0d0)
   20 continue
      do 100 k = 1, n
         if (cabs1(z(k)) .ne. 0.0d0) ek = csign1(ek,-z(k))
         if (cabs1(ek-z(k)) .le. cabs1(a(k,k))) go to 30
            s = cabs1(a(k,k))/cabs1(ek-z(k))
            call zdscal(n,s,z,1)
            ek = dcmplx(s,0.0d0)*ek
   30    continue
         wk = ek - z(k)
         wkm = -ek - z(k)
         s = cabs1(wk)
         sm = cabs1(wkm)
         if (cabs1(a(k,k)) .eq. 0.0d0) go to 40
            wk = wk/dconjg(a(k,k))
            wkm = wkm/dconjg(a(k,k))
         go to 50
   40    continue
            wk = (1.0d0,0.0d0)
            wkm = (1.0d0,0.0d0)
   50    continue
         kp1 = k + 1
         if (kp1 .gt. n) go to 90
            do 60 j = kp1, n
               sm = sm + cabs1(z(j)+wkm*dconjg(a(k,j)))
               z(j) = z(j) + wk*dconjg(a(k,j))
               s = s + cabs1(z(j))
   60       continue
            if (s .ge. sm) go to 80
               t = wkm - wk
               wk = wkm
               do 70 j = kp1, n
                  z(j) = z(j) + t*dconjg(a(k,j))
   70          continue
   80       continue
   90    continue
         z(k) = wk
  100 continue
      s = 1.0d0/dzasum(n,z,1)
      call zdscal(n,s,z,1)
c
c     solve ctrans(l)*y = w
c
      do 120 kb = 1, n
         k = n + 1 - kb
         if (k .lt. n) z(k) = z(k) + zdotc(n-k,a(k+1,k),1,z(k+1),1)
         if (cabs1(z(k)) .le. 1.0d0) go to 110
            s = 1.0d0/cabs1(z(k))
            call zdscal(n,s,z,1)
  110    continue
         l = ipvt(k)
         t = z(l)
         z(l) = z(k)
         z(k) = t
  120 continue
      s = 1.0d0/dzasum(n,z,1)
      call zdscal(n,s,z,1)
c
      ynorm = 1.0d0
c
c     solve l*v = y
c
      do 140 k = 1, n
         l = ipvt(k)
         t = z(l)
         z(l) = z(k)
         z(k) = t
         if (k .lt. n) call zaxpy(n-k,t,a(k+1,k),1,z(k+1),1)
         if (cabs1(z(k)) .le. 1.0d0) go to 130
            s = 1.0d0/cabs1(z(k))
            call zdscal(n,s,z,1)
            ynorm = s*ynorm
  130    continue
  140 continue
      s = 1.0d0/dzasum(n,z,1)
      call zdscal(n,s,z,1)
      ynorm = s*ynorm
c
c     solve  u*z = v
c
      do 160 kb = 1, n
         k = n + 1 - kb
         if (cabs1(z(k)) .le. cabs1(a(k,k))) go to 150
            s = cabs1(a(k,k))/cabs1(z(k))
            call zdscal(n,s,z,1)
            ynorm = s*ynorm
  150    continue
         if (cabs1(a(k,k)) .ne. 0.0d0) z(k) = z(k)/a(k,k)
         if (cabs1(a(k,k)) .eq. 0.0d0) z(k) = (1.0d0,0.0d0)
         t = -z(k)
         call zaxpy(k-1,t,a(1,k),1,z(1),1)
  160 continue
c     make znorm = 1.0
      s = 1.0d0/dzasum(n,z,1)
      call zdscal(n,s,z,1)
      ynorm = s*ynorm
c
      if (anorm .ne. 0.0d0) rcond = ynorm/anorm
      if (anorm .eq. 0.0d0) rcond = 0.0d0
      return
      end
      subroutine zgefa(a,lda,n,ipvt,info)
      integer lda,n,ipvt(1),info
      complex*16 a(lda,1)
c
c     zgefa factors a complex*16 matrix by gaussian elimination.
c
c     zgefa is usually called by zgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for zgeco) = (1 + 9/n)*(time for zgefa) .
c
c     on entry
c
c        a       complex*16(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that zgesl or zgedi will divide by zero
c                     if called.  use  rcond  in zgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas zaxpy,zscal,izamax
c     fortran dabs
c
c     internal variables
c
      complex*16 t
      integer izamax,j,k,kp1,l,nm1
c
      complex*16 zdum
      double precision cabs1
      double precision dreal,dimag
      complex*16 zdumr,zdumi
      dreal(zdumr) = zdumr
      dimag(zdumi) = (0.0d0,-1.0d0)*zdumi
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))
c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = izamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (cabs1(a(l,k)) .eq. 0.0d0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -(1.0d0,0.0d0)/a(k,k)
            call zscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call zaxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (cabs1(a(n,n)) .eq. 0.0d0) info = n
      return
      end
      REAL             FUNCTION SLAMCH( CMACH )
*
*  -- LAPACK auxiliary routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      CHARACTER          cmach
*     ..
*
* =====================================================================
*
*     .. Parameters ..
      REAL               one, zero
      parameter( one = 1.0e+0, zero = 0.0e+0 )
*     ..
*     .. Local Scalars ..
      REAL               rnd, eps, sfmin, small, rmach
*     ..
*     .. External Functions ..
      LOGICAL            lsame
      EXTERNAL           lsame
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          digits, epsilon, huge, maxexponent,
     $                   minexponent, radix, tiny
*     ..
*     .. Executable Statements ..
*
*
*     Assume rounding, not chopping. Always.
*
      rnd = one
*
      IF( one.EQ.rnd ) THEN
         eps = epsilon(zero) * 0.5
      ELSE
         eps = epsilon(zero)
      END IF
*
      IF( lsame( cmach, 'E' ) ) THEN
         rmach = eps
      ELSE IF( lsame( cmach, 'S' ) ) THEN
         sfmin = tiny(zero)
         small = one / huge(zero)
         IF( small.GE.sfmin ) THEN
*
*           Use SMALL plus a bit, to avoid the possibility of rounding
*           causing overflow when computing  1/sfmin.
*
            sfmin = small*( one+eps )
         END IF
         rmach = sfmin
      ELSE IF( lsame( cmach, 'B' ) ) THEN
         rmach = radix(zero)
      ELSE IF( lsame( cmach, 'P' ) ) THEN
         rmach = eps * radix(zero)
      ELSE IF( lsame( cmach, 'N' ) ) THEN
         rmach = digits(zero)
      ELSE IF( lsame( cmach, 'R' ) ) THEN
         rmach = rnd
      ELSE IF( lsame( cmach, 'M' ) ) THEN
         rmach = minexponent(zero)
      ELSE IF( lsame( cmach, 'U' ) ) THEN
         rmach = tiny(zero)
      ELSE IF( lsame( cmach, 'L' ) ) THEN
         rmach = maxexponent(zero)
      ELSE IF( lsame( cmach, 'O' ) ) THEN
         rmach = huge(zero)
      ELSE
         rmach = zero
      END IF
*
      slamch = rmach
      RETURN
*
*     End of SLAMCH
*
      END
      SUBROUTINE slarfg( N, ALPHA, X, INCX, TAU )
*
*  -- LAPACK auxiliary routine (version 3.8.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
      REAL               ALPHA, TAU
*     ..
*     .. Array Arguments ..
      REAL               X( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      parameter( one = 1.0e+0, zero = 0.0e+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            J, KNT
      REAL               BETA, RSAFMN, SAFMIN, XNORM
*     ..
*     .. External Functions ..
      REAL               SLAMCH, SLAPY2, SNRM2
      EXTERNAL           slamch, slapy2, snrm2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          abs, sign
*     ..
*     .. External Subroutines ..
      EXTERNAL           sscal
*     ..
*     .. Executable Statements ..
*
      IF( n.LE.1 ) THEN
         tau = zero
         RETURN
      END IF
*
      xnorm = snrm2( n-1, x, incx )
*
      IF( xnorm.EQ.zero ) THEN
*
*        H  =  I
*
         tau = zero
      ELSE
*
*        general case
*
         beta = -sign( slapy2( alpha, xnorm ), alpha )
         safmin = slamch( 'S' ) / slamch( 'E' )
         knt = 0
         IF( abs( beta ).LT.safmin ) THEN
*
*           XNORM, BETA may be inaccurate; scale X and recompute them
*
            rsafmn = one / safmin
   10       CONTINUE
            knt = knt + 1
            CALL sscal( n-1, rsafmn, x, incx )
            beta = beta*rsafmn
            alpha = alpha*rsafmn
            IF( (abs( beta ).LT.safmin) .AND. (knt .LT. 20) )
     $         GO TO 10
*
*           New BETA is at most 1, at least SAFMIN
*
            xnorm = snrm2( n-1, x, incx )
            beta = -sign( slapy2( alpha, xnorm ), alpha )
         END IF
         tau = ( beta-alpha ) / beta
         CALL sscal( n-1, one / ( alpha-beta ), x, incx )
*
*        If ALPHA is subnormal, it may lose relative accuracy
*
         DO 20 j = 1, knt
            beta = beta*safmin
 20      CONTINUE
         alpha = beta
      END IF
* 
      RETURN
* 
      END 
* 
      REAL             FUNCTION SLAPY2( X, Y )
*
*  -- LAPACK auxiliary routine (version 3.7.1) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     June 2017
*
*     .. Scalar Arguments ..
      REAL               x, y
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               zero
      parameter( zero = 0.0e0 )
      REAL               one
      parameter( one = 1.0e0 )
*     ..
*     .. Local Scalars ..
      REAL               w, xabs, yabs, z
      LOGICAL            x_is_nan, y_is_nan
*     ..
*     .. External Functions ..
      LOGICAL            sisnan
      EXTERNAL           sisnan
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          abs, max, min, sqrt
*     ..
*     .. Executable Statements ..
*
*     ..
*     .. Executable Statements ..
*
      x_is_nan = sisnan( x )
      y_is_nan = sisnan( y )
      IF ( x_is_nan ) slapy2 = x
      IF ( y_is_nan ) slapy2 = y
*
      IF ( .NOT.( x_is_nan.OR.y_is_nan ) ) THEN
         xabs = abs( x )
         yabs = abs( y )
         w = max( xabs, yabs )
         z = min( xabs, yabs )
         IF( z.EQ.zero ) THEN
            slapy2 = w
         ELSE
            slapy2 = w*sqrt( one+( z / w )**2 )
         END IF
      END IF
      RETURN
*
*     End of SLAPY2
*
      END
      SUBROUTINE clarfg( N, ALPHA, X, INCX, TAU )
*
*  -- LAPACK auxiliary routine (version 3.8.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
      COMPLEX            ALPHA, TAU
*     ..
*     .. Array Arguments ..
      COMPLEX            X( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      parameter( one = 1.0e+0, zero = 0.0e+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            J, KNT
      REAL               ALPHI, ALPHR, BETA, RSAFMN, SAFMIN, XNORM
*     ..
*     .. External Functions ..
      REAL               SCNRM2, SLAMCH, SLAPY3
      COMPLEX            CLADIV
      EXTERNAL           scnrm2, slamch, slapy3, cladiv
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          abs, aimag, cmplx, real, sign
*     ..
*     .. External Subroutines ..
      EXTERNAL           cscal, csscal
*     ..
*     .. Executable Statements ..
*
      IF( n.LE.0 ) THEN
         tau = zero
         RETURN
      END IF
*
      xnorm = scnrm2( n-1, x, incx )
      alphr = real( alpha )
      alphi = aimag( alpha )
*
      IF( xnorm.EQ.zero .AND. alphi.EQ.zero ) THEN
*
*        H  =  I
*
         tau = zero
      ELSE
*
*        general case
*
         beta = -sign( slapy3( alphr, alphi, xnorm ), alphr )
         safmin = slamch( 'S' ) / slamch( 'E' )
         rsafmn = one / safmin
*
         knt = 0
         IF( abs( beta ).LT.safmin ) THEN
*
*           XNORM, BETA may be inaccurate; scale X and recompute them
*
   10       CONTINUE
            knt = knt + 1
            CALL csscal( n-1, rsafmn, x, incx )
            beta = beta*rsafmn
            alphi = alphi*rsafmn
            alphr = alphr*rsafmn
            IF( (abs( beta ).LT.safmin) .AND. (knt .LT. 20) )
     $         GO TO 10
*
*           New BETA is at most 1, at least SAFMIN
*
            xnorm = scnrm2( n-1, x, incx )
            alpha = cmplx( alphr, alphi )
            beta = -sign( slapy3( alphr, alphi, xnorm ), alphr )
         END IF
         tau = cmplx( ( beta-alphr ) / beta, -alphi / beta )
         alpha = cladiv( cmplx( one ), alpha-beta )
         CALL cscal( n-1, alpha, x, incx )
*
*        If ALPHA is subnormal, it may lose relative accuracy
*
         DO 20 j = 1, knt
            beta = beta*safmin
 20      CONTINUE
         alpha = beta
      END IF
*
      RETURN
*
*     End of CLARFG
*
      END
      SUBROUTINE clacgv( N, X, INCX )
*
*  -- LAPACK auxiliary routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
*     ..
*     .. Array Arguments ..
      COMPLEX            X( * )
*     ..
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IOFF
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          conjg
*     ..
*     .. Executable Statements ..
*
      IF( incx.EQ.1 ) THEN
         DO 10 i = 1, n
            x( i ) = conjg( x( i ) )
   10    CONTINUE
      ELSE
         ioff = 1
         IF( incx.LT.0 )
     $      ioff = 1 - ( n-1 )*incx
         DO 20 i = 1, n
            x( ioff ) = conjg( x( ioff ) )
            ioff = ioff + incx
   20    CONTINUE
      END IF
      RETURN
*
*     End of CLACGV
*
      END

      LOGICAL FUNCTION sisnan( SIN )
*
*  -- LAPACK auxiliary routine (version 3.7.1) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     June 2017
*
*     .. Scalar Arguments ..
      REAL, INTENT(IN) :: sin
*     ..
*
*  =====================================================================
*
*  .. External Functions ..
      LOGICAL slaisnan
      EXTERNAL slaisnan
*  ..
*  .. Executable Statements ..
      sisnan = slaisnan(sin,sin)
      RETURN
      END
      LOGICAL FUNCTION slaisnan( SIN1, SIN2 )
*
*  -- LAPACK auxiliary routine (version 3.7.1) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     June 2017
*
*     .. Scalar Arguments ..
      REAL, INTENT(IN) :: sin1, sin2
*     ..
*
*  =====================================================================
*
*  .. Executable Statements ..
      slaisnan = (sin1.NE.sin2)
      RETURN
      END
      COMPLEX FUNCTION cladiv( X, Y )
*
*  -- LAPACK auxiliary routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      COMPLEX            x, y
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      REAL               zi, zr
*     ..
*     .. External Subroutines ..
      EXTERNAL           sladiv
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          aimag, cmplx, real
*     ..
*     .. Executable Statements ..
*
      CALL sladiv( real( x ), aimag( x ), real( y ), aimag( y ), zr,
     $             zi )
      cladiv = cmplx( zr, zi )
*
      RETURN
*
*     End of CLADIV
*
      END
*
      SUBROUTINE sladiv( A, B, C, D, P, Q )
*
*  -- LAPACK auxiliary routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     January 2013
*
*     .. Scalar Arguments ..
      REAL               A, B, C, D, P, Q
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               BS
      parameter( bs = 2.0e0 )
      REAL               HALF
      parameter( half = 0.5e0 )
      REAL               TWO
      parameter( two = 2.0e0 )
*
*     .. Local Scalars ..
      REAL               AA, BB, CC, DD, AB, CD, S, OV, UN, BE, EPS
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           slamch
*     ..
*     .. External Subroutines ..
      EXTERNAL           sladiv1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          abs, max
*     ..
*     .. Executable Statements ..
*
      aa = a
      bb = b
      cc = c
      dd = d
      ab = max( abs(a), abs(b) )
      cd = max( abs(c), abs(d) )
      s = 1.0e0
 
      ov = slamch( 'Overflow threshold' )
      un = slamch( 'Safe minimum' )
      eps = slamch( 'Epsilon' )
      be = bs / (eps*eps)
 
      IF( ab >= half*ov ) THEN
         aa = half * aa
         bb = half * bb
         s  = two * s
      END IF
      IF( cd >= half*ov ) THEN
         cc = half * cc
         dd = half * dd
         s  = half * s
      END IF
      IF( ab <= un*bs/eps ) THEN
         aa = aa * be
         bb = bb * be
         s  = s / be
      END IF
      IF( cd <= un*bs/eps ) THEN
         cc = cc * be
         dd = dd * be
         s  = s * be
      END IF
      IF( abs( d ).LE.abs( c ) ) THEN
         CALL sladiv1(aa, bb, cc, dd, p, q)
      ELSE
         CALL sladiv1(bb, aa, dd, cc, p, q)
         q = -q
      END IF
      p = p * s
      q = q * s
*
      RETURN
*
*     End of SLADIV
*
      END
      SUBROUTINE sladiv1( A, B, C, D, P, Q )
*
*  -- LAPACK auxiliary routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     January 2013
*
*     .. Scalar Arguments ..
      REAL               A, B, C, D, P, Q
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      parameter( one = 1.0e0 )
*
*     .. Local Scalars ..
      REAL               R, T
*     ..
*     .. External Functions ..
      REAL               SLADIV2
      EXTERNAL           sladiv2
*     ..
*     .. Executable Statements ..
*
      r = d / c
      t = one / (c + d * r)
      p = sladiv2(a, b, c, d, r, t)
      a = -a
      q = sladiv2(b, a, c, d, r, t)
*
      RETURN
*
*     End of SLADIV1
*
      END
 
*> \ingroup realOTHERauxiliary
 
      REAL FUNCTION SLADIV2( A, B, C, D, R, T )
*
*  -- LAPACK auxiliary routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     January 2013
*
*     .. Scalar Arguments ..
      REAL               a, b, c, d, r, t
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               zero
      parameter( zero = 0.0e0 )
*
*     .. Local Scalars ..
      REAL               br
*     ..
*     .. Executable Statements ..
*
      IF( r.NE.zero ) THEN
         br = b * r
         if( br.NE.zero ) THEN
            sladiv2 = (a + br) * t
         ELSE
            sladiv2 = a * t + (b * t) * r
         END IF
      ELSE
         sladiv2 = (a + d * (b / c)) * t
      END IF
*
      RETURN
*
*     End of SLADIV
*
      END
      REAL             FUNCTION SLAPY3( X, Y, Z )
*
*  -- LAPACK auxiliary routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      REAL               x, y, z
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               zero
      parameter( zero = 0.0e0 )
*     ..
*     .. Local Scalars ..
      REAL               w, xabs, yabs, zabs
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          abs, max, sqrt
*     ..
*     .. Executable Statements ..
*
      xabs = abs( x )
      yabs = abs( y )
      zabs = abs( z )
      w = max( xabs, yabs, zabs )
      IF( w.EQ.zero ) THEN
*     W can be zero for max(0,nan,0)
*     adding all three entries together will make sure
*     NaN will not disappear.
         slapy3 =  xabs + yabs + zabs
      ELSE
         slapy3 = w*sqrt( ( xabs / w )**2+( yabs / w )**2+
     $            ( zabs / w )**2 )
      END IF
      RETURN
*
*     End of SLAPY3
*
      END

 !***********************************************************************
 !
 !    Copyright (c) 2015, Lawrence Livermore National Security, LLC.
 !                        Produced at the Lawrence Livermore National
 !                        Laboratory.
 !                        Written by Nicolas Schunck, schunck1@llnl.gov
 !
 !    LLNL-CODE-470611 All rights reserved.
 !
 !    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
 !                    W. Satula, J.A. Sheikh, A. Staszczak,
 !                    M. Stoitsov, P. Toivanen
 !    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
 !                    P. Olbratowski, P. Powalowski, M. Sadziak,
 !                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
 !                    M. Zalewski, H. Zdunczuk
 !    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
 !    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
 !
 !    This file is part of HFODD.
 !
 !    HFODD is free software: you can redistribute it and/or modify it
 !    under the terms of the GNU General Public License as published by
 !    the Free Software Foundation, either version 3 of the License, or
 !    (at your option) any later version.
 !
 !    HFODD is distributed in the hope that it will be useful, but
 !    WITHOUT ANY WARRANTY; without even the implied warranty of
 !    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 !    GNU General Public License for more details.
 !
 !    You should have received a copy of the GNU General Public License
 !    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
 !
 !    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
 !    LICENSE
 !
 !    Our Preamble Notice
 !
 !      A. This notice is required to be provided under our contract
 !         with the U.S. Department of Energy (DOE). This work was
 !         produced at the Lawrence Livermore National Laboratory under
 !         Contract No. DE-AC52-07NA27344 with the DOE.
 !      B. Neither the United States Government nor Lawrence Livermore
 !         National Security, LLC nor any of their employees, makes any
 !         warranty, express or implied, or assumes any liability or
 !         responsibility for the accuracy, completeness, or usefulness
 !         of any information, apparatus, product, or process disclosed,
 !         or represents that its use would not infringe privately-owned
 !         rights.
 !      C. Also, reference herein to any specific commercial products,
 !         process, or services by trade name, trademark, manufacturer
 !         or otherwise does not necessarily constitute or imply its
 !         endorsement, recommendation, or favoring by the United States
 !         Government or Lawrence Livermore National Security, LLC. The
 !         views and opinions of authors expressed herein do not
 !         necessarily state or reflect those of the United States
 !         Government or Lawrence Livermore National Security, LLC, and
 !         shall not be used for advertising or product endorsement
 !         purposes.
 !
 !    The precise terms and conditions for copying, distribution and
 !    modification are contained in the file COPYING.
 !
 !***********************************************************************

 !----------------------------------------------------------------------!
 !                                                                      !
 !                Energy Density Functional for HFODD                   !
 !                                                                      !
 ! Authors: M. Stoitsov, M. Kortelainen, N. Schunck, ORNL               !
 !                                                                      !
 ! This module is/will be in charge of:                                 !
 !    - defining the coupling constants of a given EDF                  !
 !    - converting back/forth from nuclear matter properties to (t,x)   !
 !      to coupling constant representation.                            !
 !                                                                      !
 !                          First included in official release v249m    !
 !                                                                      !
 !----------------------------------------------------------------------!

      SUBROUTINE Set_version_hfodd_functional
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(5) = 'hfodd_functional'
      MODUVE(5) = 5
      MODSET(5) = 5
      !
      END SUBROUTINE Set_version_hfodd_functional
      !
Module hfodd_functional
  Use HFBTHO_utilities
  Use UNEDF
  Implicit None

Contains

   ! returns (t,x) filled out from definition of EDF
   Subroutine paramsFunctional(SKYRME,IETA_J,IETA_W,IETA_M,IETACM,&
                               ISKYRM,HBMASS,T0_EFF,T1_EFF,T2_EFF,&
                               T3_EFF,X0_EFF,X1_EFF,X2_EFF,X3_EFF,&
                               B4_EFF,B4PEFF,te_EFF,to_EFF,POWEFF,&
                                             V0NEFF,V0PEFF,COUSCA)

     Integer(ipr), INTENT(INOUT) :: IETA_J,IETA_W,IETA_M,IETACM,ISKYRM
     Real(pr), INTENT(INOUT) :: HBMASS,T0_EFF,T1_EFF,T2_EFF,T3_EFF, &
                                       X0_EFF,X1_EFF,X2_EFF,X3_EFF, &
                                       B4_EFF,B4PEFF,te_EFF,to_EFF, &
                                       POWEFF,V0NEFF,V0PEFF,COUSCA
     Character(Len=4), INTENT(IN) :: SKYRME
     Character(Len=30) :: fname
     Integer(ipr) :: noForces

     fname    = SKYRME
     noForces = 0

     ! Set coupling constants and nuclear matter properties
     Call read_UNEDF_NAMELIST(fname,noForces)

     ! Computes bulk coupling constants
     Call set_functional_parameters(fname,.True.)

     ! Extract (t,x) parameterization from coupling constants
     Call t_from_C()

     ! Export (t,x) parameterization into HFODD
     T0_EFF = t0_pub
     T1_EFF = t1_pub
     T2_EFF = t2_pub
     T3_EFF = t3_pub

     X0_EFF = x0_pub
     X1_EFF = x1_pub
     X2_EFF = x2_pub
     X3_EFF = x3_pub

     B4_EFF = b4_pub
     B4PEFF = b4p_pub

     te_EFF = te_pub
     to_EFF = to_pub

     POWEFF = sigma

     V0NEFF = CpV0(0)
     V0PEFF = CpV0(1)

     COUSCA = CExPar

     HBMASS = hbzero

                     IETA_J=0
     If(use_j2terms) IETA_J=1

     IETA_M=1
     IETA_W=1
                         IETACM=3
     If(use_cm_cor)      IETACM=0
     If(use_full_cm_cor) IETACM=1

     ISKYRM=1

  End Subroutine paramsFunctional

End Module hfodd_functional

 !***********************************************************************
 !
 !    Copyright (c) 2015, Lawrence Livermore National Security, LLC.
 !                        Produced at the Lawrence Livermore National
 !                        Laboratory.
 !                        Written by Nicolas Schunck, schunck1@llnl.gov
 !
 !    LLNL-CODE-470611 All rights reserved.
 !
 !    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
 !                    W. Satula, J.A. Sheikh, A. Staszczak,
 !                    M. Stoitsov, P. Toivanen
 !    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
 !                    P. Olbratowski, P. Powalowski, M. Sadziak,
 !                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
 !                    M. Zalewski, H. Zdunczuk
 !    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
 !    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
 !
 !    This file is part of HFODD.
 !
 !    HFODD is free software: you can redistribute it and/or modify it
 !    under the terms of the GNU General Public License as published by
 !    the Free Software Foundation, either version 3 of the License, or
 !    (at your option) any later version.
 !
 !    HFODD is distributed in the hope that it will be useful, but
 !    WITHOUT ANY WARRANTY; without even the implied warranty of
 !    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 !    GNU General Public License for more details.
 !
 !    You should have received a copy of the GNU General Public License
 !    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
 !
 !    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
 !    LICENSE
 !
 !    Our Preamble Notice
 !
 !      A. This notice is required to be provided under our contract
 !         with the U.S. Department of Energy (DOE). This work was
 !         produced at the Lawrence Livermore National Laboratory under
 !         Contract No. DE-AC52-07NA27344 with the DOE.
 !      B. Neither the United States Government nor Lawrence Livermore
 !         National Security, LLC nor any of their employees, makes any
 !         warranty, express or implied, or assumes any liability or
 !         responsibility for the accuracy, completeness, or usefulness
 !         of any information, apparatus, product, or process disclosed,
 !         or represents that its use would not infringe privately-owned
 !         rights.
 !      C. Also, reference herein to any specific commercial products,
 !         process, or services by trade name, trademark, manufacturer
 !         or otherwise does not necessarily constitute or imply its
 !         endorsement, recommendation, or favoring by the United States
 !         Government or Lawrence Livermore National Security, LLC. The
 !         views and opinions of authors expressed herein do not
 !         necessarily state or reflect those of the United States
 !         Government or Lawrence Livermore National Security, LLC, and
 !         shall not be used for advertising or product endorsement
 !         purposes.
 !
 !    The precise terms and conditions for copying, distribution and
 !    modification are contained in the file COPYING.
 !
 !***********************************************************************

 !----------------------------------------------------------------------!
 !                                                                      !
 !                MPI I/O Environment for HFODD                         !
 !                                                                      !
 ! Authors: N. Schunck, ORNL                                            !
 !                                                                      !
 ! This module is/will be in charge of:                                 !
 !    - reading sequential and parallel input data from the hfodd.d     !
 !      and hfodd_mpiio.d files                                         !
 !    - broadcasting all input data to all processors                   !
 !    - converting data to the proper variables used in HFODD           !
 !                                                                      !
 !                          First included in official release v249e    !
 !                                                                      !
 !----------------------------------------------------------------------!

      SUBROUTINE Set_version_hfodd_mpiio
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(6) = 'hfodd_mpiio     '
      MODUVE(6) = 6
      MODSET(6) = 6
      !
      END SUBROUTINE Set_version_hfodd_mpiio
      !
 Module linkedLists

    Implicit None

    ! Define derived types Node_int and Node_dbl, which are used
    ! to construct linked list of integers and real numbers

    Type :: Node_int
        Integer           :: value
        Integer           :: numero
        Character(Len=10) :: name
        TYPE(Node_int), pointer  :: next
    End type Node_int

    Type :: Node_dbl
        Real              :: value
        Integer           :: numero
        Character(Len=10) :: name
        TYPE(Node_dbl), pointer  :: next
    End type Node_dbl

    Type :: Node_str
        Character(Len=10) :: value
        Integer           :: numero
        Character(Len=10) :: name
        TYPE(Node_str), pointer  :: next
    End type Node_str

 Contains

    ! A bunch of useful subroutines to manipulate linked lists

    ! Routines dealing with Node_int type
    Recursive Subroutine printEntireList_int(ptr)
       Type(Node_int), pointer :: ptr
       If(associated(ptr%next)) Call printEntireList_int(ptr%next)
       print *, ptr%value, ptr%numero, ptr%name
    End Subroutine printEntireList_int

    Recursive Subroutine freeEntireList_int(ptr)
       Type(Node_int), pointer :: ptr
       If(associated(ptr%next)) Call freeEntireList_int(ptr%next)
       Deallocate(ptr)
    End Subroutine freeEntireList_int

    ! Routines dealing with Node_dbl type
    Recursive Subroutine printEntireList_dbl(ptr)
       Type(Node_dbl), pointer :: ptr
       If(associated(ptr%next)) Call printEntireList_dbl(ptr%next)
       Print *, ptr%value, ptr%numero, ptr%name
    End Subroutine printEntireList_dbl

    Recursive Subroutine freeEntireList_dbl(ptr)
       Type(Node_dbl), pointer :: ptr
       If(associated(ptr%next)) Call freeEntireList_dbl(ptr%next)
       Deallocate(ptr)
    End Subroutine freeEntireList_dbl

    ! Routines dealing with Node_str type
    Recursive Subroutine printEntireList_str(ptr)
       Type(Node_str), pointer :: ptr
       If(associated(ptr%next)) Call printEntireList_str(ptr%next)
       Print *, ptr%value, ptr%numero, ptr%name
    End Subroutine printEntireList_str

    Recursive Subroutine freeEntireList_str(ptr)
       Type(Node_str), pointer :: ptr
       If(associated(ptr%next)) Call freeEntireList_str(ptr%next)
       Deallocate(ptr)
    End Subroutine freeEntireList_str

 End Module linkedLists

 Module hfodd_mpiio

    Use linkedLists

    Implicit None

    Include "mpif.h"

    ! Private
    Integer, PRIVATE :: stringLength = 10
    Integer, PRIVATE :: counterInt, counterDbl, counterStr, counterTot
    Integer, PRIVATE :: counterVector(1:3)
    Integer, Allocatable, PRIVATE :: vectorInt_value(:)
    Real, Allocatable, PRIVATE :: vectorDbl_value(:)
    Character(Len=10), Allocatable, PRIVATE :: vectorStr_value(:)
    Character(Len=10), Allocatable, PRIVATE :: vectorAll_names(:)

    Type(Node_int), pointer :: listeInt
    Type(Node_dbl), pointer :: listeDbl
    Type(Node_str), pointer :: listeStr

    ! Public
    Integer, PUBLIC :: modeMPI_deformation,modeMPI_neck,modeMPI_basis
    Integer, PUBLIC :: numberConstraints,numberConstraints_restart,restartTemperature, &
                       neck_numberPoints,neck_numberPoints_restart,counterForce,       &
                       counterTemperature,batch_mode,number_batch,number_constraint_batch
    Integer, PUBLIC :: neutron_stepNumber,neutron_stepValue,neutron_initValue,                &
                       proton_stepNumber,proton_stepValue,proton_initValue,                   &
                       basis_frequency_stepNumber,basis_deform_stepNumber,                    &
                       basis_size_stepNumber,basis_size_stepValue,basis_size_initValue,       &
                       basis_states_stepNumber,basis_states_stepValue,basis_states_initValue, &
                       turnConstraintOn,optimizePath
    Integer, Allocatable, PUBLIC :: qLambda(:),qMiu(:),qStepNumber(:),qLambda_restart(:),  &
                                    qMiu_restart(:),qStepNumber_restart(:),lambda_batch(:),&
                                    miu_batch(:)

    Real, PUBLIC :: x_neutron_initValue,x_neutron_stepValue, &
                    x_proton_initValue,x_proton_stepValue
    Real, PUBLIC :: basis_frequency_stepValue,basis_frequency_initValue, &
                    basis_deform_stepValue,basis_deform_initValue,       &
                    neck_initValue,neck_finValue,neck_initValue_restart, &
                    neck_finValue_restart
    Real, Allocatable, PUBLIC :: qinitValue(:),qFinValue(:),qinitValue_restart(:), &
                                 qFinValue_restart(:),temperatureVector(:)

    Character(Len=4), Allocatable, PUBLIC :: forceVector(:)

 Contains

    !------------------------------------------------------------------!
    ! This subroutine reads the standard HFODD input file and puts     !
    ! all encountered data into two linked lists of type Node_int      !
    ! (for data of type integer) and Node_dbl (for data of type real). !
    ! These derived types also contain a character string that is      !
    ! used to identify the keyword where this data come from. This     !
    ! will serve for the reconstruction of the original variables.     !
    !------------------------------------------------------------------!

    Subroutine mpi_getSequentialData()

      Integer :: NFIREA

      Integer, Parameter :: NDITER = 5000

      Integer :: ii, jj, counterDef, counterWS, counterColl
      Integer :: mpi_rank, mpi_err, mpi_string_10

      Integer :: ICOTYP, ICOUDI, ICOUEX, I_GOGA, NOITER, IBROYD, N_DUMM, &
                 NO_RUN, NULAST, NUPING, NUCHAO, ISIMPY, ISIGNY, IPARTY, &
                 IROTAT, ISIMTX, ISIMTY, ISIMTZ, IPAIRI, IPAHFB, IPABCS, &
                 IMFHFB, LIPKIN, LIPKIP, IOPTGS, NXHERM, NYHERM, NZHERM, &
                 NOSCIL, NLIMIT, I1LINE, NILXYZ, IREVIE, ICONTI, IPCONT, &
                 IGCONT, IGPCON, ILCONT, IFCONT, IACONT, IFSHEL, NPOLYN, &
                 LAMBDA, ITE_WS, IREAWS, ISTAND, KETA_J, KETA_W, KETACM, &
                 KETA_M, IF_RPA, IF_EDF, IF_THO, IBASIS, IHFPOT, IFRAGM, &
                 L_PUSH, M_PUSH, N_PUSH, DOPUSH, NPLAST, MIU,    NMUCON, &
                 NMUCOU, NMUPRI, NEXBET, IPRIBE, IPRIBL, IWRIFI, INNUMB, &
                 IZNUMB, IGOGPA, ITRMAX, NTHETA, MIN_QP, IDEALL, IDELOC, &
                 IDECON, IF2FIN, IF2FIP

      Real :: A_DUMM, B_DUMM, ENECUT, SLOWEV, SLOWOD, SLOWPA, &
              SLOWLI, EPSITE, EPSPNG, ECUTOF, PRHO_T, PRHOST, &
              PRHO_N, PRHOSN, POWERN, PRHO_P, PRHOSP, POWERP, &
              POWERT, OMEGAY, GSTRUN, GSTRUP, HOMFAC, ALPHAR, &
              STP_WS, CBETHO, TEMP_T, Q_PUSH, FCHOM0, R0PARM, &
              DELTAE, XLOCMX, V2_MIN, FE2FIN, FE2FIP

      Real :: PI, DEGRAD

      Character(Len=10) :: KEYWOR

      Type(Node_int), Pointer :: tempNodeInt, currentNodeInt, previousNodeInt
      Type(Node_dbl), Pointer :: tempNodeDbl, currentNodeDbl, previousNodeDbl
      Type(Node_str), Pointer :: tempNodeStr, currentNodeStr, previousNodeStr

      ! Initialize local variables

      ICOTYP=7
      ICOUDI=1;ICOUEX=1
      I_GOGA=0;IGOGPA=0
      NOITER=10
      IBROYD=1
      N_DUMM=8
      NO_RUN=0
      NULAST=3;NUPING=3;NUCHAO=3
      ISIMPY=1;ISIGNY=1;IPARTY=1
      IROTAT=0
      ISIMTX=-1;ISIMTY=-1;ISIMTZ=-1
      IPAIRI=1;IPAHFB=1
      IPABCS=0
      IMFHFB=0;LIPKIN=0;LIPKIP=0;IF2FIN=0;IF2FIP=0
      IOPTGS=1
      NXHERM=30;NYHERM=30;NZHERM=30
      NOSCIL=12
      NLIMIT=455
      INNUMB=86;IZNUMB=66
      LAMBDA=0; MIU=0
      I1LINE=1
      NILXYZ=3
      IREVIE=0;ICONTI=0;IPCONT=0;IGCONT=0;IGPCON=0;ILCONT=0;IFCONT=0;IACONT=0
      IFSHEL=0;NPOLYN=6
      ITE_WS=10;IREAWS=0
      ISTAND=1;KETA_J=0;KETA_W=1;KETACM=1;KETA_M=0
      IF_RPA=1;IF_EDF=0;IF_THO=0;CBETHO=0.0D0
      IBASIS=0
      IFRAGM=0
      ITRMAX=31;NTHETA=181
      IDEALL=0;IDELOC=0;IDECON=0
      IHFPOT=0
      L_PUSH=1;M_PUSH=0;N_PUSH=0;DOPUSH=0;NPLAST=1
      NMUCON=4;NMUCOU=4;NMUPRI=4
      NEXBET=4;IPRIBE=1;IPRIBL=0
      IWRIFI=0

      A_DUMM=0.0D0; B_DUMM=0.0D0
      ENECUT=800.0D0
      R0PARM=1.2D0
      ALPHAR=0.0D0
      SLOWEV=0.5D0; SLOWOD=0.5D0; SLOWPA=0.5D0; SLOWLI=0.5D0
      EPSITE=1.0D-5;EPSPNG=1.0d-5
      ECUTOF=60.0D0
      PRHO_T=-000.0D0; PRHOST=0.32D0; POWERT=1.0D0
      PRHO_N=-200.0D0; PRHOSN=0.32D0; POWERN=1.0D0
      PRHO_P=-200.0D0; PRHOSP=0.32D0; POWERP=1.0D0
      OMEGAY=0.0D0
      GSTRUN=1.2; GSTRUP=1.2;HOMFAC=3.5D0
      STP_WS=0.01D0
      Q_PUSH=0.00D0
      FCHOM0=1.20D0
      MIN_QP=0;DELTAE=2.50D0;XLOCMX=0.75D0;V2_MIN=0.005D0
      FE2FIN=0.1D0;FE2FIP=0.1D0

      ! Getting the rank of the current process
      Call mpi_comm_rank(MPI_COMM_WORLD, mpi_rank, mpi_err)

      ! Define MPI type for a character string of length stringLength and commit
      Call mpi_type_contiguous(stringLength, MPI_CHARACTER, mpi_string_10, mpi_err)
      Call mpi_type_commit(mpi_string_10, mpi_err)

      NO_RUN = 0

      ! Only the root process reads the data
      If(mpi_rank.Eq.0) Then

         PI=4.0D0*Atan(1.0D0)
         DEGRAD=180.0D0/PI

         counterInt = 0
         counterDbl = 0
         counterStr = 0

         ! Initializing the end of the linked list
         Write(KEYWOR,'(10x)')

         counterInt = counterInt + 1
         Allocate(listeInt)
         listeInt%value  = 0
         listeInt%numero = counterInt
         listeInt%name   = KEYWOR
         NULLIFY(listeInt%next)

         counterDbl = counterDbl + 1
         Allocate(listeDbl)
         listeDbl%value  = 0.0D0
         listeDbl%numero = counterDbl
         listeDbl%name   = KEYWOR
         NULLIFY(listeDbl%next)

         counterStr = counterStr + 1
         Allocate(listeStr)
         listeStr%value  = "INITIALIZE"
         listeStr%numero = counterStr
         listeStr%name   = KEYWOR
         NULLIFY(listeStr%next)

         NFIREA=87
         Open(NFIREA,FILE='hfodd.d',STATUS='UNKNOWN',FORM='FORMATTED')

         ! Main loop over the keyword value
         Do While (trim(KEYWOR) .NE. 'ALL_DONE' .AND. trim(KEYWOR) .NE. 'ALL-DONE')

            Read(NFIREA,'(A10)') KEYWOR

            !==============================!
            !   ITERATIONS CONTROL FLAGS   !
            !==============================!

            ! Number of iterations
            If(trim(KEYWOR).Eq.'ITERATIONS') Then

               Read(NFIREA,*) NOITER

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NOITER
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               If(NOITER.GT.NDITER) STOP 'NOITER.GT.NDITER IN NAMELI'

            End If

            ! Switches on/off the Broyden method
            If(trim(KEYWOR).Eq.'BROYDEN') Then

               Read(NFIREA,*) IBROYD,N_DUMM,A_DUMM,B_DUMM

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IBROYD
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = N_DUMM
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = A_DUMM
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = B_DUMM
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Slow-down parameters for the mean-field
            If(trim(KEYWOR).Eq.'SLOW_DOWN'.OR.trim(KEYWOR).Eq.'SLOW-DOWN') Then

               Read(NFIREA,*) SLOWEV,SLOWOD

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = SLOWEV
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = SLOWOD
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Slow-down parameters for the pairing field
            If(trim(KEYWOR).Eq.'SLOW_PAIR'.OR.trim(KEYWOR).Eq.'SLOW-PAIR') Then

               Read(NFIREA,*) SLOWPA

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = SLOWPA
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Slow-down parameters for the Lipkin-Nogami correction
            If(trim(KEYWOR).Eq.'SLOWLIPKIN') Then

               Read(NFIREA,*) SLOWLI

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = SLOWLI
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Defines the precision of convergence
            If(trim(KEYWOR).Eq.'ITERAT_EPS'.OR.trim(KEYWOR).Eq.'ITERAT-EPS') Then

               Read(NFIREA,*) EPSITE

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = EPSITE
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Defines divergence
            If(trim(KEYWOR).Eq.'MAXANTIOSC') Then

               Read(NFIREA,*) NULAST

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NULAST
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Control ping-pong effects
            If(trim(KEYWOR).Eq.'PING_PONG'.OR.trim(KEYWOR).Eq.'PING-PONG') Then

               Read(NFIREA,*) EPSPNG,NUPING

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NUPING
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = EPSPNG
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Control chaotic divergence
            If(trim(KEYWOR).Eq.'CHAOTIC') Then

               Read(NFIREA,*) NUCHAO

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NUCHAO
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !=====================================!
            !   SPECIFIC FEATURES CONTROL FLAGS   !
            !=====================================!

            ! Definition of the collective space for calculation of collective inertia
            If(trim(KEYWOR).Eq.'COLL_SPACE'.OR.trim(KEYWOR).Eq.'COLL-SPACE') Then

               counterColl = 0
               LAMBDA=-1

               Do While (LAMBDA < 0)

                  Read(NFIREA,*) LAMBDA,MIU

                  counterColl = counterColl + 1

                  counterInt = counterInt + 1
                  Allocate(tempNodeInt)
                  tempNodeInt%value  = ABS(LAMBDA)
                  tempNodeInt%numero = counterInt
                  tempNodeInt%name   = KEYWOR
                  tempNodeInt%next   => listeInt
                  listeInt => tempNodeInt

                  counterInt = counterInt + 1
                  Allocate(tempNodeInt)
                  tempNodeInt%value  = MIU
                  tempNodeInt%numero = counterInt
                  tempNodeInt%name   = KEYWOR
                  tempNodeInt%next   => listeInt
                  listeInt => tempNodeInt

               End Do

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = counterColl
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Type of shell correction
            If(trim(KEYWOR).Eq.'SHELLCORCT') Then

               Read(NFIREA,*) IFSHEL

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IFSHEL
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Shell correction parameters
            If(trim(KEYWOR).Eq.'SHELLPARAM') Then

               Read(NFIREA,*) GSTRUN,GSTRUP,HOMFAC,NPOLYN

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = GSTRUN
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = GSTRUP
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = HOMFAC
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NPOLYN
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Switching to interface with HFBTHO
            If(trim(KEYWOR).Eq.'HFBTHOISON') Then

               Read(NFIREA,*) IF_THO,CBETHO

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IF_THO
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = CBETHO
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Compute mass and charge of fission fragments
            If(trim(KEYWOR).Eq.'MASSFRAGME') Then

               Read(NFIREA,*) IFRAGM

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IFRAGM
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Compute and record densities of the fission fragments
            If(trim(KEYWOR).Eq.'FRAGDENSIT') Then

               Read(NFIREA,*) IDEALL,IDELOC,IDECON

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IDEALL
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IDELOC
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IDECON
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Rotate selected pairs of q.p. wave-functions
            If(trim(KEYWOR).Eq.'QPROTATION') Then

               Read(NFIREA,*) MIN_QP,DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = MIN_QP
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = DELTAE
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = XLOCMX
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = V2_MIN
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ITRMAX
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NTHETA
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !=====================================!
            !      INTERACTIONS CONTROL FLAGS     !
            !=====================================!

            ! Switching to Energy Density Functional formalism
            If(trim(KEYWOR).Eq.'UNEDF_PROJ'.OR.trim(KEYWOR).Eq.'UNEDF-PROJ') Then

               Read(NFIREA,*) IF_EDF

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IF_EDF
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Skyrme force flags
            If(trim(KEYWOR).Eq.'SKYRME_STD'.OR.trim(KEYWOR).Eq.'SKYRME-STD') Then

               Read(NFIREA,*) ISTAND,KETA_J,KETA_W,KETACM,KETA_M

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ISTAND
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = KETA_J
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = KETA_W
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = KETACM
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = KETA_M
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Type of Coulomb potential
            If(trim(KEYWOR).Eq.'COULOMBPAR') Then

               Read(NFIREA,*) ICOTYP,ICOUDI,ICOUEX

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ICOTYP
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ICOUDI
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ICOUEX
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Gogny force
            If(trim(KEYWOR).Eq.'GOGNY') Then

               Read(NFIREA,*) I_GOGA

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = I_GOGA
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !==============================!
            !     PAIRING CONTROL FLAGS    !
            !==============================!

            ! Gogny pairing
            If(trim(KEYWOR).Eq.'GOGNY_PAIR') Then

               Read(NFIREA,*) IGOGPA

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IGOGPA
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Switches on/off pairing
            If(trim(KEYWOR).Eq.'PAIRING') Then

               Read(NFIREA,*) IPAIRI

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IPAIRI
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! HFB pairing
            If(trim(KEYWOR).Eq.'HFB') Then

               Read(NFIREA,*) IPAHFB

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IPAHFB
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Defines the pairing window cut-off
            If(trim(KEYWOR).Eq.'CUTOFF') Then

               Read(NFIREA,*) ECUTOF

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = ECUTOF
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Diagonalizes the mean-field (if HFB)
            If(trim(KEYWOR).Eq.'HFBMEANFLD') Then

               Read(NFIREA,*) IMFHFB

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IMFHFB
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Pairing interaction (neutrons only)
            If(trim(KEYWOR).Eq.'PAIRNINTER') Then

               Read(NFIREA,*) PRHO_N,PRHOSN,POWERN

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = PRHO_N
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = PRHOSN
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = POWERN
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Pairing interaction (protons only)
            If(trim(KEYWOR).Eq.'PAIRPINTER') Then

               Read(NFIREA,*) PRHO_P,PRHOSP,POWERP

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = PRHO_P
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = PRHOSP
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = POWERP
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Pairing interaction
            If(trim(KEYWOR).Eq.'PAIR_INTER') Then

               Read(NFIREA,*) PRHO_T,PRHOST,POWERT

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = PRHO_T
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = PRHOST
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = POWERT
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Lipkin-Nogami correction
            If(trim(KEYWOR).Eq.'LIPKIN') Then

               Read(NFIREA,*) LIPKIN,LIPKIP

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = LIPKIN
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = LIPKIP
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Reading the fixed Lipkin-Nogami lambda2 parameters
            If(trim(KEYWOR).Eq.'FIXLAMB2_N'.OR.trim(KEYWOR).EQ.'FIXLAMB2-N') Then

               Read(NFIREA,*) FE2FIN,IF2FIN

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = FE2FIN
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IF2FIN
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If
            If(trim(KEYWOR).Eq.'FIXLAMB2_P'.OR.trim(KEYWOR).EQ.'FIXLAMB2-P') Then

               Read(NFIREA,*) FE2FIP,IF2FIP

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = FE2FIP
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IF2FIP
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !==============================!
            !     SYMMETRY CONTROL FLAGS   !
            !==============================!

            ! time-reversal
            If(trim(KEYWOR).Eq.'ROTATION') Then

               Read(NFIREA,*) IROTAT

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IROTAT
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! y-simplex
            If(trim(KEYWOR).Eq.'SIMPLEXY') Then

               Read(NFIREA,*) ISIMPY

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ISIMPY
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! y-signature
            If(trim(KEYWOR).Eq.'SIGNATUREY') Then

               Read(NFIREA,*) ISIGNY

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ISIGNY
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! parity
            If(trim(KEYWOR).Eq.'PARITY') Then

               Read(NFIREA,*) IPARTY

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IPARTY
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! All 3 simplexes at once
            If(trim(KEYWOR).Eq.'TSIMPLEX3D') Then

               Read(NFIREA,*) ISIMTX,ISIMTY,ISIMTZ

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ISIMTX
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ISIMTY
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ISIMTZ
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !=====================================!
            !       HO BASIS CONTROL FLAGS        !
            !=====================================!

            ! Automatic adjustment of basis deformation and frequency
            If(trim(KEYWOR).Eq.'BASISAUTOM') Then

               Read(NFIREA,*) IBASIS

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IBASIS
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Flag controling the basis frequency
            If(trim(KEYWOR).Eq.'HOMEGAZERO') Then

               Read(NFIREA,*) FCHOM0

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = FCHOM0
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Size of the HO basis
            If(trim(KEYWOR).Eq.'BASIS_SIZE'.OR.trim(KEYWOR).Eq.'BASIS-SIZE') Then

               Read(NFIREA,*) NOSCIL,NLIMIT,ENECUT

               If(NLIMIT.Eq.0) NLIMIT=((NOSCIL+1)*(NOSCIL+2)*(NOSCIL+3))/6

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NOSCIL
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NLIMIT
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = ENECUT
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Deformation of the HO basis
            If(trim(KEYWOR).Eq.'SURFAC_PAR'.OR.trim(KEYWOR).Eq.'SURFAC-PAR') Then

               Read(NFIREA,*) INNUMB,IZNUMB,R0PARM

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = INNUMB
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IZNUMB
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = R0PARM
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            ! Deformation of the HO basis
            If(trim(KEYWOR).Eq.'SURFAC_DEF'.OR.trim(KEYWOR).Eq.'SURFAC-DEF') Then

               counterDef = 0
               LAMBDA=-1

               Do While (LAMBDA < 0)

                  Read(NFIREA,*) LAMBDA,MIU,ALPHAR

                  counterDef = counterDef + 1

                  counterInt = counterInt + 1
                  Allocate(tempNodeInt)
                  tempNodeInt%value  = ABS(LAMBDA)
                  tempNodeInt%numero = counterInt
                  tempNodeInt%name   = KEYWOR
                  tempNodeInt%next   => listeInt
                  listeInt => tempNodeInt

                  counterInt = counterInt + 1
                  Allocate(tempNodeInt)
                  tempNodeInt%value  = MIU
                  tempNodeInt%numero = counterInt
                  tempNodeInt%name   = KEYWOR
                  tempNodeInt%next   => listeInt
                  listeInt => tempNodeInt

                  counterDbl = counterDbl + 1
                  Allocate(tempNodeDbl)
                  tempNodeDbl%value  = ALPHAR
                  tempNodeDbl%numero = counterDbl
                  tempNodeDbl%name   = KEYWOR
                  tempNodeDbl%next   => listeDbl
                  listeDbl => tempNodeDbl

               End Do

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = counterDef
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Automatic number of Gauss-Hermite points
            If(trim(KEYWOR).Eq.'OPTI_GAUSS'.OR.trim(KEYWOR).Eq.'OPTI-GAUSS') Then

               Read(NFIREA,*) IOPTGS

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IOPTGS
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Number of Gauss-Hermite points
            If(trim(KEYWOR).Eq.'GAUSHERMIT') Then

               Read(NFIREA,*) NXHERM,NYHERM,NZHERM

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NXHERM
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NYHERM
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NZHERM
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !=====================================!
            !   MULTIPOLE MOMENTS CONTROL FLAGS   !
            !=====================================!

            ! Linear constraints based on the RPA matrix
            If(trim(KEYWOR).Eq.'RPA_CONSTR'.OR.trim(KEYWOR).Eq.'RPA-CONSTR') Then

               Read(NFIREA,*) IF_RPA

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IF_RPA
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Flags controlling the number of constraints
            If(trim(KEYWOR).Eq.'MAX_MULTIP'.OR.trim(KEYWOR).Eq.'MAX-MULTIP') Then

               Read(NFIREA,*) NMUCON,NMUCOU,NMUPRI

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NMUCON
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NMUCOU
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NMUPRI
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Deformations of the WS potential used to provide initial solution
            If(trim(KEYWOR).Eq.'DEFORMS_WS'.OR.trim(KEYWOR).Eq.'DEFORMS-WS') Then

               counterWS = 0
               LAMBDA=-1

               Do While (LAMBDA < 0)

                  Read(NFIREA,*) LAMBDA,MIU

                  counterWS = counterWS + 1

                  counterInt = counterInt + 1
                  Allocate(tempNodeInt)
                  tempNodeInt%value  = ABS(LAMBDA)
                  tempNodeInt%numero = counterInt
                  tempNodeInt%name   = KEYWOR
                  tempNodeInt%next   => listeInt
                  listeInt => tempNodeInt

                  counterInt = counterInt + 1
                  Allocate(tempNodeInt)
                  tempNodeInt%value  = MIU
                  tempNodeInt%numero = counterInt
                  tempNodeInt%name   = KEYWOR
                  tempNodeInt%next   => listeInt
                  listeInt => tempNodeInt

               End Do

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = counterWS
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Additional deformations that will be used to optimize
            ! the WS deformation parameters (extra-push)
            If(trim(keywor).Eq.'PUSH_DEFOR'.OR.trim(keywor).Eq.'PUSH-DEFOR') Then

               L_PUSH = -1
               N_PUSH = 0

               Do While ( L_PUSH < 0 )

                  Read(NFIREA,*) L_PUSH, M_PUSH, Q_PUSH

                  N_PUSH = N_PUSH + 1

                  counterInt = counterInt + 1
                  Allocate(tempNodeInt)
                  tempNodeInt%value  = L_PUSH
                  tempNodeInt%numero = counterInt
                  tempNodeInt%name   = keywor
                  tempNodeInt%next   => listeInt
                  listeInt => tempNodeInt

                  counterInt = counterInt + 1
                  Allocate(tempNodeInt)
                  tempNodeInt%value  = M_PUSH
                  tempNodeInt%numero = counterInt
                  tempNodeInt%name   = keywor
                  tempNodeInt%next   => listeInt
                  listeInt => tempNodeInt

                  counterDbl = counterDbl + 1
                  Allocate(tempNodeDbl)
                  tempNodeDbl%value  = Q_PUSH
                  tempNodeDbl%numero = counterDbl
                  tempNodeDbl%name   = keywor
                  tempNodeDbl%next   => listeDbl
                  listeDbl => tempNodeDbl

               End Do

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = N_PUSH
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = keywor
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Number of iterations to keep the extra constraints on
            If(trim(KEYWOR).Eq.'PUSH_ITERS'.OR.trim(KEYWOR).Eq.'PUSH-ITERS') Then

               Read(NFIREA,*) DOPUSH,NPLAST

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = DOPUSH
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NPLAST
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Step of the minimization over WS deformations
            If(trim(KEYWOR).Eq.'STEP_MINIM'.OR.trim(KEYWOR).Eq.'STEP-MINIM') Then

               Read(NFIREA,*) STP_WS,ITE_WS

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = STP_WS
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ITE_WS
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Choosing between a WS or HF-based mean-field
            If(trim(KEYWOR).Eq.'MEAN-FIELD'.OR.trim(KEYWOR).Eq.'MEAN_FIELD') Then

               Read(NFIREA,*) IHFPOT

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IHFPOT
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !=====================================!
            !    ANGULAR MOMENTUM CONTROL FLAGS   !
            !=====================================!

             ! Rotational frequency
            If(trim(KEYWOR).Eq.'OMEGAY') Then

               Read(NFIREA,*) OMEGAY

               counterDbl = counterDbl + 1
               Allocate(tempNodeDbl)
               tempNodeDbl%value  = OMEGAY
               tempNodeDbl%numero = counterDbl
               tempNodeDbl%name   = KEYWOR
               tempNodeDbl%next   => listeDbl
               listeDbl => tempNodeDbl

            End If

            !================================!
            !   OUTPUT FILE CONTROL FLAGS    !
            !================================!

            ! Type of print-out
            If(trim(KEYWOR).Eq.'ONE_LINE'.OR.trim(KEYWOR).Eq.'ONE-LINE') Then

               Read(NFIREA,*) I1LINE

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = I1LINE
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Type of Nilsson label
            If(trim(KEYWOR).Eq.'NILSSONLAB') Then

               Read(NFIREA,*) NILXYZ

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NILXYZ
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Flags controlling the deformations extracted from multipoles
            If(trim(KEYWOR).Eq.'BOHR_BETAS'.OR.trim(KEYWOR).Eq.'BOHR-BETAS') Then

               Read(NFIREA,*) NEXBET,IPRIBE,IPRIBL

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = NEXBET
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IPRIBE
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IPRIBL
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !================================!
            !     I/O FLAGS CONTROL FLAGS    !
            !================================!

            ! Optionally recording ascii file
            If(trim(KEYWOR).Eq.'REVIEW') Then

               Read(NFIREA,*) IREVIE

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IREVIE
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Restart on densities in Gauss-Hermite mesh
            If(trim(KEYWOR).Eq.'FIELD_SAVE'.OR.trim(KEYWOR).Eq.'FIELD-SAVE') Then

               Read(NFIREA,*) IWRIFI

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IWRIFI
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !==================================!
            !    CHECKPOINTING CONTROL FLAGS   !
            !==================================!

            ! Restart on densities in Gauss-Hermite mesh
            If(trim(KEYWOR).Eq.'RESTART') Then

               Read(NFIREA,*) ICONTI

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ICONTI
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Restart on pairing
            If(trim(KEYWOR).Eq.'CONT_PAIRI'.OR.trim(KEYWOR).Eq.'CONT-PAIRI') Then

               Read(NFIREA,*) IPCONT

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IPCONT
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Restart on Lipkin-Nogami
            If(trim(KEYWOR).Eq.'CONTLIPKIN') Then

               Read(NFIREA,*) ILCONT

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = ILCONT
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Restart on HFB mean-fields
            If(trim(KEYWOR).Eq.'CONTFIELDS') Then

               Read(NFIREA,*) IFCONT

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IFCONT
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Restart on linear constraint
            If(trim(KEYWOR).Eq.'CONTAUGMEN') Then

               Read(NFIREA,*) IACONT

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IACONT
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Restart on Gogny mean-field
            If(trim(KEYWOR).Eq.'CONTGOGNY') Then

               Read(NFIREA,*) IGCONT

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IGCONT
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Restart on Gogny pairing-field
            If(trim(KEYWOR).Eq.'CONTGOGPAI') Then

               Read(NFIREA,*) IGPCON

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IGPCON
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            ! Restart on WS binary file
            If(trim(KEYWOR).Eq.'READ_WOODS'.OR.trim(KEYWOR).Eq.'READ-WOODS') Then

               Read(NFIREA,*) IREAWS

               counterInt = counterInt + 1
               Allocate(tempNodeInt)
               tempNodeInt%value  = IREAWS
               tempNodeInt%numero = counterInt
               tempNodeInt%name   = KEYWOR
               tempNodeInt%next   => listeInt
               listeInt => tempNodeInt

            End If

            !===================================!
            !  BACKWARD COMPATIBILTY WITH HFODD !
            !===================================!

            If(trim(KEYWOR).Eq.'EXECUTE') Then

               NO_RUN=NO_RUN+1

            End If

         End Do ! end of main DO WHILE loop

         Close(NFIREA)

         counterVector(1) = counterInt
         counterVector(2) = counterDbl
         counterVector(3) = counterStr

      End If ! myrank.eq.0

      ! Broadcasting all the sizes (of integer, real and string data)
      Call MPI_Bcast(counterVector, 3, MPI_INTEGER, 0, MPI_COMM_WORLD, mpi_err)

      ! Reassigning local variables from broadcast values
      counterInt = counterVector(1)
      counterDbl = counterVector(2)
      counterStr = counterVector(3)

      Allocate(vectorInt_value(1:counterInt))
      Allocate(vectorDbl_value(1:counterDbl))
      Allocate(vectorStr_value(1:counterStr))

      counterTot = counterInt + counterDbl + counterStr
      Allocate(vectorAll_names(1:counterTot))

      ! Only processor 0 can fill out the vectors
      If(mpi_rank.Eq.0) Then

         ! Now that the final size of these vectors is known, we can
         ! allocate an array and broadcast to everyone else


         ! First, vector of integer data, and the relevant keywords

         Allocate(currentNodeInt)

         currentNodeInt => listeInt

         ii = 0

         Do While ( associated(currentNodeInt) )

            ii = ii + 1

            vectorInt_value(ii) = currentNodeInt%value
            vectorAll_names(ii) = currentNodeInt%name

            Allocate(previousNodeInt)

            previousNodeInt => currentNodeInt
            currentNodeInt  => currentNodeInt%next

            Deallocate(previousNodeInt)

         End Do

         ! Second, vector of real data, and the relevant keywords

         Allocate(currentNodeDbl)

         currentNodeDbl => listeDbl

         ii = 0

         Do While ( associated(currentNodeDbl) )

            ii = ii + 1
            jj = ii + counterInt

            vectorDbl_value(ii) = currentNodeDbl%value
            vectorAll_names(jj) = currentNodeDbl%name

            Allocate(previousNodeDbl)

            previousNodeDbl => currentNodeDbl
            currentNodeDbl  => currentNodeDbl%next

            Deallocate(previousNodeDbl)

         End Do

         ! Third: vector of string data, and the relevant keywords

         Allocate(currentNodeStr)

         currentNodeStr => listeStr

         ii = 0

         Do While ( associated(currentNodeStr) )

            ii = ii + 1
            jj = ii + counterInt + counterDbl

            vectorStr_value(ii) = currentNodeStr%value
            vectorAll_names(jj) = currentNodeStr%name

            Allocate(previousNodeStr)

            previousNodeStr => currentNodeStr
            currentNodeStr  => currentNodeStr%next

            Deallocate(previousNodeStr)

         End Do

      End If ! end of proc = 0 if

      ! Broadcasting all data of all types
      Call MPI_Bcast(vectorInt_value, counterInt, MPI_INTEGER, 0, MPI_COMM_WORLD, mpi_err)
      Call MPI_Bcast(vectorDbl_value, counterDbl, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpi_err)
      Call MPI_Bcast(vectorStr_value, counterStr, mpi_string_10, 0, MPI_COMM_WORLD, mpi_err)

      ! Broadcasting all names (keywords needed to reconstruct data locally)
      Call MPI_Bcast(vectorAll_names, counterTot,  mpi_string_10, 0, MPI_COMM_WORLD, mpi_err)

      ! Derived MPI type is not needed anymore, we release it
      Call mpi_type_free(mpi_string_10, mpi_err)

   End Subroutine mpi_getSequentialData

   !-------------------------------------------------------------------!
   ! This subroutine fills out the common blocks and variables that    !
   ! HFODD needs based on the data read in mpi_nameli() and broadcast  !
   ! by it. The subroutine is executed by all processors               !
   !-------------------------------------------------------------------!

   Subroutine mpi_setSequentialData(IOPTGS,NXHERM,NYHERM,NZHERM, &
                                    IPAIRI,IPAHFB,IPABCS,IMFHFB, &
                                                  LIPKIN,LIPKIP, &
                                    FE2FIN,IF2FIN,FE2FIP,IF2FIP, &
                                                  IROTAT,IREVIE, &
                                    ICONTI,IPCONT,IGCONT,IGPCON, &
                                           ILCONT,IFCONT,IACONT, &
                                    NUCHAO,NUPING,EPSPNG,EPSITE, &
                                           ISIMPY,ISIGNY,IPARTY, &
                                           ISIMTX,ISIMTY,ISIMTZ, &
                                                  NOITER,NULAST, &
                                           NOSCIL,NLIMIT,ENECUT, &
                                           ICOTYP,ICOUDI,ICOUEX, &
                                                  I_GOGA,IGOGPA, &
                                                         I1LINE, &
                                    SLOWEV,SLOWOD,SLOWPA,SLOWLI, &
                                                         ECUTOF, &
                                                         NILXYZ, &
                                    IBROYD,N_ITER,BROTRI,ALPHAM, &
                                           PRHO_T,PRHOST,POWERT, &
                                                         OMEGAY, &
                             IFSHEL,MPOLYN,G_STUN,G_STUP,H_OMFA, &
                                    LAMBAS,MIUBAS,BETBAS,NUMDEF, &
                             LAM_WS,MIU_WS,NUM_WS,ITE_WS,STP_WS, &
                             LAMPUS,MIUPUS,NUMPUS,QMOPUS,IFPUSH, &
                                                  NITPUS,IREAWS, &
                             ISTAND,KETA_J,KETA_W,KETACM,KETA_M, &
                                    IF_RPA,IF_EDF,IF_THO,CBETHO, &
                                           IBASIS,IHFPOT,IFRAGM, &
                                           NMUCON,NMUCOU,NMUPRI, &
                                           NEXBET,IPRIBE,IPRIBL, &
                                                         FCHOM0, &
                                           L_COLL,M_COLL,N_COLL, &
                                                         IWRIFI, &
                                           INNUMB,IZNUMB,R0PARM, &
                             DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA, &
                                    MIN_QP,IDEALL,IDELOC,IDECON)

      Integer, intent(inout) :: ICOTYP, ICOUDI, ICOUEX, I_GOGA, IGOGPA, NOITER, IBROYD, &
                                N_ITER, NULAST, NUPING, NUCHAO, ISIMPY, ISIGNY, IPARTY, &
                                IROTAT, ISIMTX, ISIMTY, ISIMTZ, IPAIRI, IPAHFB, IPABCS, &
                                IMFHFB, LIPKIN, LIPKIP, IOPTGS, NXHERM, NYHERM, NZHERM, &
                                NOSCIL, NLIMIT, I1LINE, NILXYZ, IREVIE, ICONTI, IPCONT, &
                                IGCONT, IGPCON, ILCONT, IFCONT, IACONT, IFSHEL, MPOLYN, &
                                NUMDEF, NUM_WS, ITE_WS, IREAWS, ISTAND, KETA_J, KETA_W, &
                                KETACM, KETA_M, IF_RPA, IF_EDF, IF_THO, IBASIS, IHFPOT, &
                                IFRAGM, NUMPUS, IFPUSH, NITPUS, NMUCON, NMUCOU, NMUPRI, &
                                NEXBET, IPRIBE, IPRIBL, N_COLL, IWRIFI, INNUMB, IZNUMB, &
                                ITRMAX, NTHETA, MIN_QP, IDEALL, IDELOC, IDECON, IF2FIN, &
                                                                                IF2FIP

      Real, intent(inout) :: BROTRI, SLOWEV, SLOWOD, SLOWPA, SLOWLI, EPSITE, &
                             EPSPNG, ECUTOF, ENECUT, PRHO_T, PRHOST, POWERT, &
                             OMEGAY, G_STUN, G_STUP, H_OMFA, STP_WS, ALPHAM, &
                             CBETHO, FCHOM0, R0PARM, DELTAE, XLOCMX, V2_MIN, &
                                                             FE2FIN, FE2FIP

      Integer :: ii, jj, N_DUMM, counterDef, counterWS, counterColl, counter_push

      Integer, Dimension(:), pointer :: LAMBAS, MIUBAS, LAM_WS, MIU_WS, LAMPUS, MIUPUS
      Integer, Dimension(:), pointer :: L_COLL, M_COLL

      Real :: B_DUMM, PRHO_N, PRHOSN, PRHODN, POWERN, PRHO_P, PRHOSP, PRHODP, POWERP

      Real, Dimension(:), pointer :: BETBAS, QMOPUS

      Character(Len=4)  :: SKYRME
      Character(Len=10) :: KEYWOR, string_10

      ! common blocks for HFODD

      COMMON  /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN, &
                       PRHO_P,PRHODP,PRHOSP,POWERP

      ! Initialize local variables which are not initialized in PREDEF()

      MPOLYN=6; G_STUN=1.2; G_STUP=1.2; H_OMFA=3.5

      NULLIFY(LAM_WS)
      NULLIFY(MIU_WS)

      NULLIFY(L_COLL)
      NULLIFY(M_COLL)

      NULLIFY(LAMPUS)
      NULLIFY(MIUPUS)
      NULLIFY(QMOPUS)

      NUM_WS=1
      STP_WS=0.01

      NULLIFY(LAMBAS)
      NULLIFY(MIUBAS)

      NULLIFY(BETBAS)

      NUMDEF=1
      NUMPUS=0

      !=================================================!
      !                                                 !
      !   RECONSTRUCTION OF THE INPUT OF TYPE INTEGER   !
      !                                                 !
      !=================================================!

      ii = 1

      Do While ( ii .le. counterInt )

         KEYWOR = vectorAll_names(ii)

         !==============================================!
         !   INTEGER: ITERATIONS CONTROL FLAGS          !
         !==============================================!

         ! Number of iterations
         If(trim(KEYWOR).Eq.'ITERATIONS') Then
             NOITER = vectorInt_value(ii)
         End If

         ! Switches on/off the Broyden method
         If(trim(KEYWOR).Eq.'BROYDEN') Then

               N_DUMM = vectorInt_value(ii)
            If(N_DUMM.GT.0) N_ITER=N_DUMM

            ii = ii +1
            IBROYD = vectorInt_value(ii)

         End If

         ! Defines divergence
         If(trim(KEYWOR).Eq.'MAXANTIOSC') Then
            NULAST = vectorInt_value(ii)
         End If

         ! Control ping-pong effects
         If(trim(KEYWOR).Eq.'PING_PONG'.OR.trim(KEYWOR).Eq.'PING-PONG') Then
            NUPING = vectorInt_value(ii)
         End If

         ! Control chaotic divergence
         If(trim(KEYWOR).Eq.'CHAOTIC') Then
            NUCHAO = vectorInt_value(ii)
         End If

         !==============================================!
         !   INTEGER: SPECIFIC FEATURES CONTROL FLAGS   !
         !==============================================!

         ! Type of shell correction
         If(trim(KEYWOR).Eq.'SHELLCORCT') Then
            IFSHEL = vectorInt_value(ii)
         End If

         ! Number of polynomials for the shell correction
         If(trim(KEYWOR).Eq.'SHELLPARAM') Then
            MPOLYN = vectorInt_value(ii)
         End If

         ! Switching to interface with HFBTHO
         If(trim(KEYWOR).Eq.'HFBTHOISON') Then
            IF_THO = vectorInt_value(ii)
         End If

         ! Compute mass and charge of fission fragments
         If(trim(KEYWOR).Eq.'MASSFRAGME') Then
            IFRAGM = vectorInt_value(ii)
         End If

         ! Compute and record densities of the fission fragments
         If(trim(KEYWOR).Eq.'FRAGDENSIT') Then
            IDECON = vectorInt_value(ii)

            ii = ii + 1
            IDELOC = vectorInt_value(ii)

            ii = ii + 1
            IDEALL = vectorInt_value(ii)
         End If

         ! Rotate selected pairs of q.p. wave-functions
         If(trim(KEYWOR).Eq.'QPROTATION') Then
            NTHETA = vectorInt_value(ii)

            ii = ii + 1
            ITRMAX = vectorInt_value(ii)

            ii = ii + 1
            MIN_QP = vectorInt_value(ii)
         End If

         ! Definition of the collective space used for calculation of the
         ! collective inertia
         If(trim(KEYWOR).Eq.'COLL_SPACE'.OR.trim(KEYWOR).Eq.'COLL-SPACE') Then

            counterColl = vectorInt_value(ii)

            N_COLL = counterColl

            Allocate(L_COLL(1:counterColl))
            Allocate(M_COLL(1:counterColl))

            Do jj = 1, counterColl

               ii = ii + 1
               M_COLL(jj) = vectorInt_value(ii)

               ii = ii + 1
               L_COLL(jj) = vectorInt_value(ii)

            End Do

         End If

         !==============================================!
         !   INTEGER: INTERACTIONS CONTROL FLAGS        !
         !==============================================!

         ! Switching to Energy Density Functional formalism
         If(trim(KEYWOR).Eq.'UNEDF_PROJ'.OR.trim(KEYWOR).Eq.'UNEDF-PROJ') Then
            IF_EDF = vectorInt_value(ii)
         End If

         ! Skyrme force flags
         If(trim(KEYWOR).Eq.'SKYRME_STD'.OR.trim(KEYWOR).Eq.'SKYRME-STD') Then

            KETA_M = vectorInt_value(ii)

            ii = ii + 1
            KETACM = vectorInt_value(ii)

            ii = ii + 1
            KETA_W = vectorInt_value(ii)

            ii = ii + 1
            KETA_J = vectorInt_value(ii)

            ii = ii + 1
            ISTAND = vectorInt_value(ii)

         End If

         ! Type of Coulomb potential
         If(trim(KEYWOR).Eq.'COULOMBPAR') Then

            ICOUEX = vectorInt_value(ii)

            ii = ii + 1
            ICOUDI = vectorInt_value(ii)

            ii = ii + 1
            ICOTYP = vectorInt_value(ii)

         End If

         ! Gogny force
         If(trim(KEYWOR).Eq.'GOGNY') Then
            I_GOGA = vectorInt_value(ii)
         End If

         !==============================================!
         !   INTEGER: PAIRING CONTROL FLAGS             !
         !==============================================!

         ! Gogny pairing
         If(trim(KEYWOR).Eq.'GOGNY_PAIR'.OR.trim(KEYWOR).Eq.'GOGNY-PAIR') Then
            IGOGPA = vectorInt_value(ii)
         End If

         ! Switches on/off pairing
         If(trim(KEYWOR).Eq.'PAIRING') Then
            IPAIRI = vectorInt_value(ii)
         End If

         ! HFB pairing
         If(trim(KEYWOR).Eq.'HFB') Then
            IPAHFB = vectorInt_value(ii)
         End If

         ! BCS pairing
         If(trim(KEYWOR).Eq.'BCS') Then
            IPABCS = vectorInt_value(ii)
         End If

         ! Diagonalizes the mean-field (if HFB)
         If(trim(KEYWOR).Eq.'HFBMEANFLD') Then
            IMFHFB = vectorInt_value(ii)
         End If

         ! Lipkin-Nogami correction
         If(trim(KEYWOR).Eq.'LIPKIN') Then

            LIPKIP = vectorInt_value(ii)

            ii = ii + 1
            LIPKIN = vectorInt_value(ii)

         End If

         ! Reading the fixed Lipkin-Nogami lambda2 parameters
         If(trim(KEYWOR).Eq.'FIXLAMB2_N'.OR.trim(KEYWOR).EQ.'FIXLAMB2-N') Then
            IF2FIN = vectorInt_value(ii)
         End If

         If(trim(KEYWOR).Eq.'FIXLAMB2_P'.OR.trim(KEYWOR).EQ.'FIXLAMB2-P') Then
            IF2FIP = vectorInt_value(ii)
         End If

         !==============================================!
         !   INTEGER: SYMMETRY CONTROL FLAGS            !
         !==============================================!

         ! time-reversal
         If(trim(KEYWOR).Eq.'ROTATION') Then
            IROTAT = vectorInt_value(ii)
         End If

         ! y-simplex
         If(trim(KEYWOR).Eq.'SIMPLEXY') Then
            ISIMPY = vectorInt_value(ii)
         End If

         ! y-signature
         If(trim(KEYWOR).Eq.'SIGNATUREY') Then
            ISIGNY = vectorInt_value(ii)
         End If

         ! parity
         If(trim(KEYWOR).Eq.'PARITY') Then
            IPARTY = vectorInt_value(ii)
         End If

         ! All 3 simplexes at once
         If(trim(KEYWOR).Eq.'TSIMPLEX3D') Then

            ISIMTZ = vectorInt_value(ii)

            ii = ii + 1
            ISIMTY = vectorInt_value(ii)

            ii = ii + 1
            ISIMTX = vectorInt_value(ii)

         End If

         !==============================================!
         !   INTEGER: HO BASIS CONTROL FLAGS            !
         !==============================================!

         ! Automatic adjustment of HO basis parameters
         If(trim(KEYWOR).Eq.'BASISAUTOM') Then
            IBASIS = vectorInt_value(ii)
         End If

         ! Size of the HO basis
         If(trim(KEYWOR).Eq.'BASIS_SIZE'.OR.trim(KEYWOR).Eq.'BASIS-SIZE') Then

            NLIMIT = vectorInt_value(ii)

            ii = ii + 1
            NOSCIL = vectorInt_value(ii)

         End If

         ! Particle numbers of the HO basis
         If(trim(KEYWOR).Eq.'SURFAC_PAR'.OR.trim(KEYWOR).Eq.'SURFAC-PAR') Then

            IZNUMB = vectorInt_value(ii)

            ii = ii + 1
            INNUMB = vectorInt_value(ii)

         End If

         ! Deformation of the HO basis
         If(trim(KEYWOR).Eq.'SURFAC_DEF'.OR.trim(KEYWOR).Eq.'SURFAC-DEF') Then

            counterDef = vectorInt_value(ii)

            NUMDEF = counterDef

            Allocate(LAMBAS(1:counterDef))
            Allocate(MIUBAS(1:counterDef))

            Do jj = 1, counterDef

               ii = ii + 1
               MIUBAS(jj) = vectorInt_value(ii)

               ii = ii + 1
               LAMBAS(jj) = vectorInt_value(ii)

             End Do

         End If

         ! Automatic number of Gauss-Hermite points
         If(trim(KEYWOR).Eq.'OPTI_GAUSS'.OR.trim(KEYWOR).Eq.'OPTI-GAUSS') Then
            IOPTGS = vectorInt_value(ii)
         End If

         ! Number of Gauss-Hermite points
         If(trim(KEYWOR).Eq.'GAUSHERMIT') Then

            NZHERM = vectorInt_value(ii)

            ii = ii + 1
            NYHERM = vectorInt_value(ii)

            ii = ii + 1
            NXHERM = vectorInt_value(ii)

         End If

         !==============================================!
         !   INTEGER: MULTIPOLE MOMENT CONTROL FLAGS    !
         !==============================================!

         If(trim(KEYWOR).Eq.'RPA_CONSTR'.OR.trim(KEYWOR).Eq.'RPA-CONSTR') Then
            IF_RPA = vectorInt_value(ii)
         End If

         ! Number of iterations to keep the extra constraints on
         If(trim(KEYWOR).Eq.'MAX_MULTIP'.OR.trim(KEYWOR).Eq.'MAX-MULTIP') Then

            NMUPRI = vectorInt_value(ii)

            ii = ii + 1
            NMUCOU = vectorInt_value(ii)

            ii = ii + 1
            NMUCON = vectorInt_value(ii)

         End If

         ! Deformations of the WS potential used to provide initial solution
         If(trim(KEYWOR).Eq.'DEFORMS_WS'.OR.trim(KEYWOR).Eq.'DEFORMS-WS') Then

            counterWS = vectorInt_value(ii)

            NUM_WS = counterWS

            Allocate(LAM_WS(1:counterWS))
            Allocate(MIU_WS(1:counterWS))

            Do jj = 1, counterWS

               ii = ii + 1
               MIU_WS(jj) = vectorInt_value(ii)

               ii = ii + 1
               LAM_WS(jj) = vectorInt_value(ii)

            End Do

         End If

         ! Additional deformations that will be used to optimize
         ! the WS deformation parameters (extra-push)
         If(trim(KEYWOR).Eq.'PUSH_DEFOR'.OR.trim(KEYWOR).Eq.'PUSH-DEFOR') Then

            counter_push = vectorInt_value(ii)

            NUMPUS = counter_push

            Allocate(LAMPUS(1:counter_push))
            Allocate(MIUPUS(1:counter_push))

            Do jj = 1, counter_push

               ii = ii + 1
               MIUPUS(jj) = vectorInt_value(ii)

               ii = ii + 1
               LAMPUS(jj) = vectorInt_value(ii)

            End Do

         End If

         ! Number of iterations to keep the extra constraints on
         If(trim(KEYWOR).Eq.'PUSH_ITERS'.OR.trim(KEYWOR).Eq.'PUSH-ITERS') Then

            NITPUS = vectorInt_value(ii)

            ii = ii + 1
            IFPUSH = vectorInt_value(ii)

         End If

         ! Number of iterations of the minimization
         If(trim(KEYWOR).Eq.'STEP_MINIM'.OR.trim(KEYWOR).Eq.'STEP-MINIM') Then
            ITE_WS = vectorInt_value(ii)
         End If

         ! Choosing between a WS or HF-based mean-field
         If(trim(KEYWOR).Eq.'MEAN-FIELD'.OR.trim(KEYWOR).Eq.'MEAN_FIELD') Then
            IHFPOT = vectorInt_value(ii)
         End If

         !==============================================!
         !   INTEGER: OUTPUT FILE CONTROL FLAGS         !
         !==============================================!

         ! Type of print-out
         If(trim(KEYWOR).Eq.'ONE_LINE'.OR.trim(KEYWOR).Eq.'ONE-LINE') Then
            I1LINE = vectorInt_value(ii)
         End If

         ! Type of Nilsson label
         If(trim(KEYWOR).Eq.'NILSSONLAB') Then
            NILXYZ = vectorInt_value(ii)
         End If

         ! Number of iterations to keep the extra constraints on
         If(trim(KEYWOR).Eq.'BOHR_BETAS'.OR.trim(KEYWOR).Eq.'BOHR-BETAS') Then

            IPRIBL = vectorInt_value(ii)

            ii = ii + 1
            IPRIBE = vectorInt_value(ii)

            ii = ii + 1
            NEXBET = vectorInt_value(ii)

         End If

         !==============================================!
         !   INTEGER: I/O FLAGS CONTROL FLAGS           !
         !==============================================!

         ! Optionally recording ascii file
         If(trim(KEYWOR).Eq.'REVIEW') Then
            IREVIE = vectorInt_value(ii)
         End If

         ! Restart on densities in Gauss-Hermite mesh
         If(trim(KEYWOR).Eq.'FIELD_SAVE'.OR.trim(KEYWOR).Eq.'FIELD-SAVE') Then
            IWRIFI = vectorInt_value(ii)
         End If

         !==============================================!
         !   INTEGER: CHECKPOINTING CONTROL FLAGS       !
         !==============================================!

         ! Restart on densities
         If(trim(KEYWOR).Eq.'RESTART') Then
             ICONTI = vectorInt_value(ii)
         End If

         ! Restart on pairing
         If(trim(KEYWOR).Eq.'CONT_PAIRI'.OR.trim(KEYWOR).Eq.'CONT-PAIRI') Then
            IPCONT = vectorInt_value(ii)
         End If

         ! Restart on Lipkin-Nogami
         If(trim(KEYWOR).Eq.'CONTLIPKIN') Then
            ILCONT = vectorInt_value(ii)
         End If

         ! Restart on HFB mean-fields
         If(trim(KEYWOR).Eq.'CONTFIELDS') Then
            IFCONT = vectorInt_value(ii)
         End If

         ! Restart on linear constraint
         If(trim(KEYWOR).Eq.'CONTAUGMEN') Then
            IACONT = vectorInt_value(ii)
         End If

         ! Restart on Gogny mean-field
         If(trim(KEYWOR).Eq.'CONTGOGNY') Then
            IGCONT = vectorInt_value(ii)
         End If

         ! Restart on Gogny pairing-field
         If(trim(KEYWOR).Eq.'CONTGOGPAI') Then
            IGPCON = vectorInt_value(ii)
         End If

         ! Restart on WS binary files
         If(trim(KEYWOR).Eq.'READ_WOODS'.OR.trim(KEYWOR).Eq.'READ-WOODS') Then
            IREAWS = vectorInt_value(ii)
         End If

         ! Go to the next item on the list
         ii = ii + 1

      End Do

      Deallocate(vectorInt_value)

      !==============================================!
      !                                              !
      !   RECONSTRUCTION OF THE INPUT OF TYPE REAL   !
      !                                              !
      !==============================================!

      ii = 1

      Do While ( ii .le. counterDbl )

         KEYWOR = vectorAll_names(ii + counterInt)

         !===========================================!
         !   REAL: ITERATIONS CONTROL FLAGS          !
         !===========================================!

         ! Switches on/off the Broyden method
         If(trim(KEYWOR).Eq.'BROYDEN') Then

               B_DUMM = vectorDbl_value(ii)
            If(B_DUMM.GT.0.0D0) BROTRI=B_DUMM

            ii = ii + 1
            ALPHAM = vectorDbl_value(ii)

         End If

         ! Slow-down parameters for the mean-field
         If(trim(KEYWOR).Eq.'SLOW_DOWN'.OR.trim(KEYWOR).Eq.'SLOW-DOWN') Then

            SLOWOD = vectorDbl_value(ii)

            ii = ii + 1
            SLOWEV = vectorDbl_value(ii)

         End If

         ! Slow-down parameters for the pairing field
         If(trim(KEYWOR).Eq.'SLOW_PAIR'.OR.trim(KEYWOR).Eq.'SLOW-PAIR') Then
            SLOWPA = vectorDbl_value(ii)
         End If

         ! Slow-down parameters for the Lipkin-Nogami correction
         If(trim(KEYWOR).Eq.'SLOWLIPKIN') Then
            SLOWLI = vectorDbl_value(ii)
         End If

         ! Defines the precision of convergence
         If(trim(KEYWOR).Eq.'ITERAT_EPS'.OR.trim(KEYWOR).Eq.'ITERAT-EPS') Then
            EPSITE = vectorDbl_value(ii)
         End If

         ! Control ping-pong effects
         If(trim(KEYWOR).Eq.'PING_PONG'.OR.trim(KEYWOR).Eq.'PING-PONG') Then
            EPSPNG = vectorDbl_value(ii)
         End If

         !===========================================!
         !   REAL: SPECIFIC FEATURES CONTROL FLAGS   !
         !===========================================!

         ! Parameters for the shell correction
         If(trim(KEYWOR).Eq.'SHELLPARAM') Then

            H_OMFA = vectorDbl_value(ii)

            ii = ii + 1
            G_STUP = vectorDbl_value(ii)

            ii = ii + 1
            G_STUN = vectorDbl_value(ii)

         End If

         ! Switching to interface with HFBTHO
         If(trim(KEYWOR).Eq.'HFBTHOISON') Then
            CBETHO = vectorDbl_value(ii)
         End If

         ! Rotate selected pairs of q.p. wave-functions
         If(trim(KEYWOR).Eq.'QPROTATION') Then

            V2_MIN = vectorDbl_value(ii)

            ii = ii + 1
            XLOCMX = vectorDbl_value(ii)

            ii = ii + 1
            DELTAE = vectorDbl_value(ii)

         End If

         !===========================================!
         !   REAL: PAIRING CONTROL FLAGS             !
         !===========================================!

         ! Control chaotic divergence
         If(trim(KEYWOR).Eq.'CUTOFF') Then
            ECUTOF = vectorDbl_value(ii)
         End If

         ! Pairing Interaction
         If(trim(KEYWOR).Eq.'PAIR_INTER'.OR.trim(KEYWOR).Eq.'PAIR-INTER') Then

            POWERT = vectorDbl_value(ii)

            ii = ii + 1
            PRHOST = vectorDbl_value(ii)

            ii = ii + 1
            PRHO_T = vectorDbl_value(ii)

         End If

         ! The fixed Lipkin-Nogami lambda2 parameters
         If(trim(KEYWOR).Eq.'FIXLAMB2_N'.OR.trim(KEYWOR).Eq.'FIXLAMB2-N') Then
            FE2FIN = vectorDbl_value(ii)
         End If

         If(trim(KEYWOR).Eq.'FIXLAMB2_P'.OR.trim(KEYWOR).Eq.'FIXLAMB2-P') Then
            FE2FIP = vectorDbl_value(ii)
         End If

         ! Pairing Interaction (neutrons only)
         If(trim(KEYWOR).Eq.'PAIRNINTER') Then

            POWERN = vectorDbl_value(ii)

            ii = ii + 1
            PRHOSN = vectorDbl_value(ii)

            ii = ii + 1
            PRHO_N = vectorDbl_value(ii)

         End If

         ! Pairing Interaction (protons only)
         If(trim(KEYWOR).Eq.'PAIRPINTER') Then

            POWERP = vectorDbl_value(ii)

            ii = ii + 1
            PRHOSP = vectorDbl_value(ii)

            ii = ii + 1
            PRHO_P = vectorDbl_value(ii)

         End If

         !===========================================!
         !   REAL: HO BASIS CONTROL FLAGS            !
         !===========================================!

         ! Flag controling the basis frequency
         If(trim(KEYWOR).Eq.'HOMEGAZERO') Then
            FCHOM0 = vectorDbl_value(ii)
         End If

         ! Size of the HO basis
         If(trim(KEYWOR).Eq.'BASIS_SIZE'.OR.trim(KEYWOR).Eq.'BASIS-SIZE') Then
            ENECUT = vectorDbl_value(ii)
         End If

         ! Particle numbers of the HO basis
         If(trim(KEYWOR).Eq.'SURFAC_PAR'.OR.trim(KEYWOR).Eq.'SURFAC-PAR') Then
            R0PARM = vectorDbl_value(ii)
         End If

         ! Deformation of the HO basis
         If(trim(KEYWOR).Eq.'SURFAC_DEF'.OR.trim(KEYWOR).Eq.'SURFAC-DEF') Then

            Allocate(BETBAS(1:counterDef))

            Do jj = 1, counterDef

               BETBAS(jj) = vectorDbl_value(ii)

               ii = ii + 1

             End Do

         End If

         !===========================================!
         !   REAL: MULTIPOLE MOMENT CONTROL FLAGS    !
         !===========================================!

         ! Deformations of the WS potential
         If(trim(KEYWOR).Eq.'PUSH_DEFOR'.OR.trim(KEYWOR).Eq.'PUSH-DEFOR') Then

            Allocate(QMOPUS(1:counter_push))

            DO jj = 1, counter_push

               QMOPUS(jj) = vectorDbl_value(ii)
               ii = ii + 1

            End Do
            ii = ii - 1

         End If

         ! Step of the minimization over WS deformations
         If(trim(KEYWOR).Eq.'STEP_MINIM'.OR.trim(KEYWOR).Eq.'STEP-MINIM') Then
            STP_WS = vectorDbl_value(ii)
         End If

         !===========================================!
         !   REAL: ANGULAR MOMENTUM CONTROL FLAGS    !
         !===========================================!

         ! Rotational frequency
         If(trim(KEYWOR).Eq.'OMEGAY') Then
            OMEGAY = vectorDbl_value(ii)
         End If

         ! Go to the next item on the list
         ii = ii + 1

      End Do

      Deallocate(vectorDbl_value)

      !================================================!
      !                                                !
      ! RECONSTRUCTION OF THE INPUT OF TYPE STRING*10  !
      !                                                !
      !================================================!

      ii = 1

      Do While ( ii .le. counterStr )

         KEYWOR = vectorAll_names(ii + counterInt + counterDbl)

         If(trim(KEYWOR).Eq.'SKYRME-SET') Then
            string_10 = vectorStr_value(ii)
            SKYRME = string_10(1:4)
         End If

         ! Go to the next item on the list
         ii = ii + 1

      End Do

      Deallocate(vectorStr_value)

      Deallocate(vectorAll_names)

   End Subroutine mpi_setSequentialData

   !---------------------------------------------------------------!
   ! This SUBROUTINE reads data from input file. These data will   !
   ! then be used to construct a collection of jobs for HFODD.     !
   !---------------------------------------------------------------!

   Subroutine mpi_getParallelData()

      Integer, Parameter :: ndatin = 83

      Character(Len=4) :: SKYRME
      Character(Len=80) :: filein
      Character(Len=10) :: keywor

      Integer :: ii,jj,ierror,numero,mpi_rank,mpi_err,mpi_string_10,mpidef,mpinck,mpibas
      Integer :: lambda,miu,numberQ,iq,lambda_res,miu_res,numberQ_res,iq_res,iq_batch
      Integer :: izstrt,izstep,nstepz,instrt,instep,nstepn,n_mini,n_step,noffre,nofshl, &
                 nofb20,nsmini,nsstep,nofsta,ifcons,ibatch,nbatch,if_opt,iftemp,num_qn, &
                 num_qn_res

      Real :: xzstrt,xzstep,xnstrt,xnstep,o_mini,o_step,b20min,b20stp, &
              qBegin,qFin,qBegin_res,qFin_res,qn_min,qn_max,qn_min_res, &
              qn_max_res,TEMP_T

      Type(Node_int), pointer :: tempNodeInt, currentNodeInt, previousNodeInt
      Type(Node_dbl), pointer :: tempNodeDbl, currentNodeDbl, previousNodeDbl
      Type(Node_str), pointer :: tempNodeStr, currentNodeStr, previousNodeStr

      ! Getting the rank of the current process
      Call mpi_comm_rank(MPI_COMM_WORLD, mpi_rank, mpi_err)

      ! Define MPI type for a character string of length stringLength and commit
      Call mpi_type_contiguous(stringLength, MPI_CHARACTER, mpi_string_10, mpi_err)
      Call mpi_type_commit(mpi_string_10, mpi_err)

      ! Only the root process reads the data
      If(mpi_rank.Eq.0) Then

         filein = "hfodd_mpiio.d"
         Open(ndatin,file=filein,status='old',form='formatted',iostat=ierror)

         If(ierror .NE. 0) Then
            Write(6,'("error in opening file : ",a80)') filein
            write(6,'("error code            : ",i12)') ierror
            Stop 'error in readin - i/o'
         End If

         keywor="Initialize"

         counterInt = 0
         counterDbl = 0
         counterStr = 0

         counterInt = counterInt + 1
         Allocate(listeInt)
         listeInt%value  = 0
         listeInt%numero = counterInt
         listeInt%name   = keywor
         NULLIFY(listeInt%next)

         counterDbl = counterDbl + 1
         Allocate(listeDbl)
         listeDbl%value  = 0.0
         listeDbl%numero = counterDbl
         listeDbl%name   = keywor
         NULLIFY(listeDbl%next)

         counterStr = counterStr + 1
         Allocate(listeStr)
         listeStr%value  = "INITIALIZE"
         listeStr%numero = counterStr
         listeStr%name   = KEYWOR
         NULLIFY(listeStr%next)

         Do While (trim(keywor) .NE. 'END_DATA')

             Read(ndatin, FMT="(A)") keywor

             ! Type of calculation (deformation, deformation with restart,
             ! basis)
             If(trim(keywor) == 'CALCULMODE') Then

                Read(ndatin,*) mpidef, mpibas

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = mpidef
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = mpibas
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Setting up constrained or unconstrained calculations
             If(trim(keywor) == 'CONSTR_DEF'.OR.trim(keywor) == 'CONSTR-DEF') Then

                Read(ndatin,*) ifcons

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = ifcons
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Setting up batch mode for constrained calculations
             If(trim(keywor) == 'BATCH_MODE'.OR.trim(keywor) == 'BATCH-MODE') Then

                Read(ndatin,*) ibatch, nbatch

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = ibatch
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nbatch
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Specifying which multipoles will be 'batched'
             If(trim(keywor) == 'BATCH_SPEC'.OR.trim(keywor) == 'BATCH-SPEC') Then

                lambda = -1
                iq_batch = 0

                Do While ( lambda < 0 )

                   iq_batch = iq_batch + 1

                   Read(ndatin,*) lambda, miu

                   counterInt = counterInt + 1
                   Allocate(tempNodeInt)
                   tempNodeInt%value  = lambda
                   tempNodeInt%numero = counterInt
                   tempNodeInt%name   = keywor
                   tempNodeInt%next   => listeInt
                   listeInt => tempNodeInt

                   counterInt = counterInt + 1
                   Allocate(tempNodeInt)
                   tempNodeInt%value  = miu
                   tempNodeInt%numero = counterInt
                   tempNodeInt%name   = keywor
                   tempNodeInt%next   => listeInt
                   listeInt => tempNodeInt

                End Do

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = iq_batch
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Defining nuclear grid
             If(trim(keywor) == 'ALL_NUCLEI'.OR.trim(keywor) == 'ALL-NUCLEI') Then

                Read(ndatin,*) izstrt, izstep, nstepz, instrt, instep, nstepn

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = izstrt
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = izstep
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nstepz
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = instrt
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = instep
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nstepn
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Defining nuclear grid
             If(trim(keywor) == 'REALNUCLEI') Then

                Read(ndatin,*) xzstrt, xzstep, nstepz, xnstrt, xnstep, nstepn

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = xzstrt
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = xzstep
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nstepz
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = xnstrt
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = xnstep
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nstepn
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Defining default multipole grid
             If(trim(keywor) == 'MULTICONST') Then

                lambda = -1
                iq = 0

                Do While ( lambda < 0 )

                   iq = iq + 1

                   Read(ndatin,*) lambda, miu, qBegin, qFin, numberQ

                   counterInt = counterInt + 1
                   Allocate(tempNodeInt)
                   tempNodeInt%value  = abs(lambda)
                   tempNodeInt%numero = counterInt
                   tempNodeInt%name   = keywor
                   tempNodeInt%next   => listeInt
                   listeInt => tempNodeInt

                   counterInt = counterInt + 1
                   Allocate(tempNodeInt)
                   tempNodeInt%value  = miu
                   tempNodeInt%numero = counterInt
                   tempNodeInt%name   = keywor
                   tempNodeInt%next   => listeInt
                   listeInt => tempNodeInt

                   counterInt = counterInt + 1
                   Allocate(tempNodeInt)
                   tempNodeInt%value  = numberQ
                   tempNodeInt%numero = counterInt
                   tempNodeInt%name   = keywor
                   tempNodeInt%next   => listeInt
                   listeInt => tempNodeInt

                   counterDbl = counterDbl + 1
                   Allocate(tempNodeDbl)
                   tempNodeDbl%value  = qBegin
                   tempNodeDbl%numero = counterDbl
                   tempNodeDbl%name   = keywor
                   tempNodeDbl%next   => listeDbl
                   listeDbl => tempNodeDbl

                   counterDbl = counterDbl + 1
                   Allocate(tempNodeDbl)
                   tempNodeDbl%value  = qFin
                   tempNodeDbl%numero = counterDbl
                   tempNodeDbl%name   = keywor
                   tempNodeDbl%next   => listeDbl
                   listeDbl => tempNodeDbl

                End Do

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = iq
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Defining new multipole grid (active only if mpidef=2). If
             ! active, information under keyword MULTICONST will be used
             ! to identify the restart points
             If(trim(keywor) == 'MULTIRESTA') Then

                lambda_res = -1
                iq_res = 0

                Do While ( lambda_res < 0 )

                   iq_res = iq_res + 1

                   Read(ndatin,*) lambda_res, miu_res, qBegin_res, qFin_res, numberQ_res

                   counterInt = counterInt + 1
                   Allocate(tempNodeInt)
                   tempNodeInt%value  = abs(lambda_res)
                   tempNodeInt%numero = counterInt
                   tempNodeInt%name   = keywor
                   tempNodeInt%next   => listeInt
                   listeInt => tempNodeInt

                   counterInt = counterInt + 1
                   Allocate(tempNodeInt)
                   tempNodeInt%value  = miu_res
                   tempNodeInt%numero = counterInt
                   tempNodeInt%name   = keywor
                   tempNodeInt%next   => listeInt
                   listeInt => tempNodeInt

                   counterInt = counterInt + 1
                   Allocate(tempNodeInt)
                   tempNodeInt%value  = numberQ_res
                   tempNodeInt%numero = counterInt
                   tempNodeInt%name   = keywor
                   tempNodeInt%next   => listeInt
                   listeInt => tempNodeInt

                   counterDbl = counterDbl + 1
                   Allocate(tempNodeDbl)
                   tempNodeDbl%value  = qBegin_res
                   tempNodeDbl%numero = counterDbl
                   tempNodeDbl%name   = keywor
                   tempNodeDbl%next   => listeDbl
                   listeDbl => tempNodeDbl

                   counterDbl = counterDbl + 1
                   Allocate(tempNodeDbl)
                   tempNodeDbl%value  = qFin_res
                   tempNodeDbl%numero = counterDbl
                   tempNodeDbl%name   = keywor
                   tempNodeDbl%next   => listeDbl
                   listeDbl => tempNodeDbl

                End Do

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = iq_res
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Sets constraints on the size of the neck
             If(trim(keywor) == 'CALCULNECK') Then

                Read(ndatin,*) mpinck

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = mpinck
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Defining default grid of neck constraints
             If(trim(keywor) == 'NECK_CONST') Then

                Read(ndatin,*) qn_min, qn_max, num_qn

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = qn_min
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = qn_max
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = num_qn
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Defining new neck grid (active only if mpidef=2). If
             ! active, information under keyword NECK_CONST will be used
             ! to identify the restart points
             If(trim(keywor) == 'NECK_RESTA') Then

                Read(ndatin,*) qn_min_res, qn_max_res, num_qn_res

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = qn_min_res
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = qn_max_res
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = num_qn_res
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Choose to optimize the deformation grid by centering new
             ! multipolarity constraints on the restart equilibrium value
             If(trim(keywor) == 'OPTIM_GRID'.OR.trim(keywor) == 'OPTIM-GRID') Then

                Read(ndatin,*) if_opt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = if_opt
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Skyrme force name
             If(trim(KEYWOR).Eq.'ALL_FORCES'.OR.trim(KEYWOR).Eq.'ALL-FORCES') Then

             	counterForce = 0
             	numero = -1

                Do While (numero < 0)

                   Read(ndatin,*) numero, SKYRME

                   counterForce = counterForce + 1

                   counterStr = counterStr + 1
                   Allocate(tempNodeStr)
                   tempNodeStr%value  = trim(SKYRME)//"      "
                   tempNodeStr%numero = counterStr
                   tempNodeStr%name   = KEYWOR
                   tempNodeStr%next   => listeStr
                   listeStr => tempNodeStr

                End Do

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = counterForce
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = KEYWOR
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Deciding if the restart will operate on a grid of temperatures
             If(trim(keywor) == 'TEMPRESTRT') Then

                Read(ndatin,*) iftemp

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = iftemp
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! Choosing a grid of temperatures (mpidef>0 only)
             If(trim(keywor) == 'TEMPVALUES') Then

             	counterTemperature = 0
             	numero = -1

                Do While (numero < 0)

                   Read(ndatin,*) numero, TEMP_T

                   counterTemperature = counterTemperature + 1

                   counterDbl = counterDbl + 1
                   Allocate(tempNodeDbl)
                   tempNodeDbl%value  = TEMP_T
                   tempNodeDbl%numero = counterDbl
                   tempNodeDbl%name   = KEYWOR
                   tempNodeDbl%next   => listeDbl
                   listeDbl => tempNodeDbl

                End Do

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = counterTemperature
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = KEYWOR
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! For mpibas=1, grid for the basis frequency
             If(trim(keywor) == 'BASIS_FREQ'.OR.trim(keywor) == 'BASIS-FREQ') Then

                Read(ndatin,*) o_mini, o_step, noffre

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = o_mini
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = o_step
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = noffre
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! For mpibas=1, grid for the basis number of shells
             If(trim(keywor) == 'BASIS_NSHL'.OR.trim(keywor) == 'BASIS-NSHL') Then

                Read(ndatin,*) n_mini, n_step, nofshl

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = n_mini
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = n_step
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nofshl
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! For mpibas=1, grid for the basis number of states
             If(trim(keywor) == 'BASIS_NSTA'.OR.trim(keywor) == 'BASIS-NSTA') Then

                Read(ndatin,*) nsmini, nsstep, nofsta

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nsmini
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nsstep
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nofsta
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             ! For mpibas=1, grid for the basis deformation
             If(trim(keywor) == 'BASIS_DEFS'.OR.trim(keywor) == 'BASIS-DEFS') Then

                Read(ndatin,*) b20min, b20stp, nofb20

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = b20min
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterDbl = counterDbl + 1
                Allocate(tempNodeDbl)
                tempNodeDbl%value  = b20stp
                tempNodeDbl%numero = counterDbl
                tempNodeDbl%name   = keywor
                tempNodeDbl%next   => listeDbl
                listeDbl => tempNodeDbl

                counterInt = counterInt + 1
                Allocate(tempNodeInt)
                tempNodeInt%value  = nofb20
                tempNodeInt%numero = counterInt
                tempNodeInt%name   = keywor
                tempNodeInt%next   => listeInt
                listeInt => tempNodeInt

             End If

             If(trim(keywor) == 'END_DATA') Then
                Exit
             End If

          End Do

         Close(ndatin)

          counterVector(1) = counterInt
          counterVector(2) = counterDbl
          counterVector(3) = counterStr

      End If

      ! Broadcasting all sizes of the different types of data
      Call MPI_Bcast(counterVector, 3, MPI_INTEGER, 0, MPI_COMM_WORLD, mpi_err)

      ! Reconstructing the counters locally and allocating local arrays
      counterInt = counterVector(1)
      counterDbl = counterVector(2)
      counterStr = counterVector(3)

      Allocate(vectorInt_value(1:counterInt))
      Allocate(vectorDbl_value(1:counterDbl))
      Allocate(vectorStr_value(1:counterStr))

      ! Allocating a local array for data names
      counterTot = counterInt + counterDbl + counterStr
      Allocate(vectorAll_names(1:counterTot))

      ! Only processor 0 can fill out the vectors
      If(mpi_rank.Eq.0) Then

         ! Now that the final size of these vectors is known, we can
         ! allocate an array and broadcast to everyone else


         ! First, vector of integer data, and the relevant keywords

         Allocate(currentNodeInt)

         currentNodeInt => listeInt

         ii = 0

         Do While ( associated(currentNodeInt) )

            ii = ii + 1

            vectorInt_value(ii) = currentNodeInt%value
            vectorAll_names(ii) = currentNodeInt%name

            Allocate(previousNodeInt)

            previousNodeInt => currentNodeInt
            currentNodeInt  => currentNodeInt%next

            Deallocate(previousNodeInt)

         End Do

         ! Second, vector of real data, and the relevant keywords

         Allocate(currentNodeDbl)

         currentNodeDbl => listeDbl

         ii = 0

         Do While ( associated(currentNodeDbl) )

            ii = ii + 1
            jj = ii + counterInt

            vectorDbl_value(ii) = currentNodeDbl%value
            vectorAll_names(jj) = currentNodeDbl%name

            Allocate(previousNodeDbl)

            previousNodeDbl => currentNodeDbl
            currentNodeDbl  => currentNodeDbl%next

            Deallocate(previousNodeDbl)

         End Do

         ! Third: vector of string data, and the relevant keywords

         Allocate(currentNodeStr)

         currentNodeStr => listeStr

         ii = 0

         Do While ( associated(currentNodeStr) )

            ii = ii + 1
            jj = ii + counterInt + counterDbl

            vectorStr_value(ii) = currentNodeStr%value
            vectorAll_names(jj) = currentNodeStr%name

            Allocate(previousNodeStr)

            previousNodeStr => currentNodeStr
            currentNodeStr  => currentNodeStr%next

            Deallocate(previousNodeStr)

         End Do

      End If ! end of proc = 0 if

      ! Broadcasting all data
      Call MPI_Bcast(vectorInt_value, counterInt, MPI_INTEGER, 0, MPI_COMM_WORLD, mpi_err)
      Call MPI_Bcast(vectorDbl_value, counterDbl, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpi_err)
      Call MPI_Bcast(vectorStr_value, counterStr, mpi_string_10, 0, MPI_COMM_WORLD, mpi_err)

      ! Broadcasting all data names
      Call MPI_Bcast(vectorAll_names, counterTot,  mpi_string_10, 0, MPI_COMM_WORLD, mpi_err)

      ! Releasing derived MPI datatype
      Call mpi_type_free(mpi_string_10, mpi_err)

   End Subroutine mpi_getParallelData

   !-------------------------------------------------------------------!
   ! This subroutine initializes processor-dependent variables used to !
   ! construct the list of jobs. The subroutine is executed by all     !
   ! processors                                                        !
   !-------------------------------------------------------------------!

   Subroutine mpi_initializeParallelData()

      Integer :: iq

      modeMPI_deformation = 1
      modeMPI_neck        = 0
      modeMPI_basis       = 0

      turnConstraintOn        = 1
      optimizePath            = 0
      batch_mode              = 0
      number_batch            = 1
      number_constraint_batch = 1

      counterForce = 1
      Allocate(forceVector(1:counterForce))
      forceVector(:) = 'SKM*'

      Allocate(lambda_batch(1:number_constraint_batch))
      Allocate(   miu_batch(1:number_constraint_batch))
      lambda_batch(:) = 3
      miu_batch(:)    = 0

      proton_initValue  = 66; proton_stepValue  = 2; proton_stepNumber  = 1
      neutron_initValue = 86; neutron_stepValue = 2; neutron_stepNumber = 2

      x_proton_initValue  = -1.0D0; x_proton_stepValue  = 0.1
      x_neutron_initValue = -1.0D0; x_neutron_stepValue = 0.1

      restartTemperature = 0
      counterTemperature = 1
      Allocate(temperatureVector(1:counterTemperature))
      temperatureVector(:) = 0.0D0

      numberConstraints = 1

      Allocate(qStepNumber(1:numberConstraints))
      Allocate(    qLambda(1:numberConstraints))
      Allocate(       qMiu(1:numberConstraints))
      Allocate( qinitValue(1:numberConstraints))
      Allocate(  qFinValue(1:numberConstraints))

      Do iq = 1, numberConstraints
         qStepNumber(iq) = 4
             qLambda(iq) = 2
                qMiu(iq) = 0
          qinitValue(iq) = 10.0D0
           qFinValue(iq) = 10.0D0
      End Do

      numberConstraints_restart = 1

      Allocate(qStepNumber_restart(1:numberConstraints_restart))
      Allocate(    qLambda_restart(1:numberConstraints_restart))
      Allocate(       qMiu_restart(1:numberConstraints_restart))
      Allocate( qinitValue_restart(1:numberConstraints_restart))
      Allocate(  qFinValue_restart(1:numberConstraints_restart))

      Do iq = 1, numberConstraints_restart
         qStepNumber_restart(iq) = 4
             qLambda_restart(iq) = 2
                qMiu_restart(iq) = 0
          qinitValue_restart(iq) = 10.0D0
           qFinValue_restart(iq) = 10.0D0
      End Do

      neck_initValue    = 1.0D0
      neck_finValue     = 1.0D0
      neck_numberPoints = 1

      neck_initValue_restart    = 1.0D0
      neck_finValue_restart     = 1.0D0
      neck_numberPoints_restart = 1

      basis_frequency_initValue  = 8.0D0
      basis_frequency_stepValue  = 0.1D0
      basis_frequency_stepNumber = 1

      basis_size_initValue  = 8
      basis_size_stepValue  = 2
      basis_size_stepNumber = 1

      basis_states_initValue  = 165
      basis_states_stepValue  = 2
      basis_states_stepNumber = 1

      basis_deform_initValue  = 0.0D0
      basis_deform_stepValue  = 0.1D0
      basis_deform_stepNumber = 1

   End Subroutine mpi_initializeParallelData

   !-------------------------------------------------------------------!
   ! This subroutine sets variables that are used to construct the     !
   ! list of jobs. The subroutine is executed by all processors        !
   !-------------------------------------------------------------------!
   Subroutine mpi_setParallelData()

      Integer :: ii,jj,iq,iq_batch

      Character(Len=10) :: KEYWOR, string_10

      !=================================================!
      !                                                 !
      !   RECONSTRUCTION OF THE INPUT OF TYPE INTEGER   !
      !                                                 !
      !=================================================!

      ii = 1

      Do While ( ii .le. counterInt )

         KEYWOR = vectorAll_names(ii)

         If(trim(KEYWOR).Eq.'CALCULMODE') Then

            modeMPI_basis = vectorInt_value(ii)

            ii = ii + 1
            modeMPI_deformation = vectorInt_value(ii)

         End If

         If(trim(KEYWOR).Eq.'CALCULNECK') Then
            modeMPI_neck = vectorInt_value(ii)
         End If

         If(trim(KEYWOR).Eq.'CONSTR_DEF'.OR.trim(KEYWOR).Eq.'CONSTR-DEF') Then
            turnConstraintOn = vectorInt_value(ii)
         End If

         If(trim(KEYWOR).Eq.'BATCH_MODE'.OR.trim(KEYWOR).Eq.'BATCH-MODE') Then

            number_batch = vectorInt_value(ii)

            ii = ii + 1
            batch_mode = vectorInt_value(ii)

            If(batch_mode.Eq.0) number_batch=1

         End If

         If(trim(KEYWOR).Eq.'BATCH_SPEC'.OR.trim(KEYWOR).Eq.'BATCH-SPEC') Then

            number_constraint_batch = vectorInt_value(ii)

            If(Allocated(lambda_batch)) Then
               Deallocate(lambda_batch,miu_batch)
            End If

            Allocate(lambda_batch(1:number_constraint_batch))
            Allocate(   miu_batch(1:number_constraint_batch))

            Do iq_batch = 1, number_constraint_batch

               ii = ii + 1
               miu_batch(iq_batch) = vectorInt_value(ii)

               ii = ii + 1
               lambda_batch(iq_batch) = Abs(vectorInt_value(ii))

             End Do

         End If

         If(trim(KEYWOR).Eq.'ALL_NUCLEI'.OR.trim(KEYWOR).Eq.'ALL-NUCLEI') Then

            neutron_stepNumber = vectorInt_value(ii)

            ii = ii + 1
            neutron_stepValue = vectorInt_value(ii)

            ii = ii + 1
            neutron_initValue = vectorInt_value(ii)

            ii = ii + 1
            proton_stepNumber = vectorInt_value(ii)

            ii = ii + 1
            proton_stepValue = vectorInt_value(ii)

            ii = ii + 1
            proton_initValue = vectorInt_value(ii)

         End If

         If(trim(KEYWOR).Eq.'REALNUCLEI') Then

            neutron_stepNumber = vectorInt_value(ii)

            ii = ii + 1
            proton_stepNumber = vectorInt_value(ii)

         End If

         If(trim(KEYWOR).Eq.'MULTICONST') Then

            numberConstraints = vectorInt_value(ii)

            If(Allocated(qLambda)) Then
               Deallocate(qLambda,qMiu,qStepNumber)
            End If

            Allocate(qLambda(1:numberConstraints))
            Allocate(qMiu(1:numberConstraints))
            Allocate(qStepNumber(1:numberConstraints))

            Do iq = 1, numberConstraints

               ii = ii + 1
               qStepNumber(iq) = vectorInt_value(ii)

               ii = ii + 1
               qMiu(iq) = vectorInt_value(ii)

               ii = ii + 1
               qLambda(iq) = vectorInt_value(ii)

            End Do

         End If

         If(trim(KEYWOR).Eq.'MULTIRESTA') Then

            numberConstraints_restart = vectorInt_value(ii)

            If(Allocated(qLambda_restart)) Then
             	 Deallocate(qLambda_restart,qMiu_restart,qStepNumber_restart)
             End If

             Allocate(    qLambda_restart(1:numberConstraints_restart))
             Allocate(       qMiu_restart(1:numberConstraints_restart))
             Allocate(qStepNumber_restart(1:numberConstraints_restart))

            Do iq = 1, numberConstraints_restart

                ii = ii + 1
                qStepNumber_restart(iq) = vectorInt_value(ii)

                ii = ii + 1
                qMiu_restart(iq) = vectorInt_value(ii)

                ii = ii + 1
                qLambda_restart(iq) = vectorInt_value(ii)

             End Do

         End If

         If(trim(keywor) == 'NECK_CONST') Then
            neck_numberPoints = vectorInt_value(ii)
         End If

         If(trim(keywor) == 'NECK_RESTA') Then
            neck_numberPoints_restart = vectorInt_value(ii)
         End If

         If(trim(KEYWOR).Eq.'OPTIM_GRID'.OR.trim(KEYWOR).Eq.'OPTIM-GRID') Then
            optimizePath = vectorInt_value(ii)
         End If

         If(trim(KEYWOR).Eq.'ALL_FORCES'.OR.trim(KEYWOR).Eq.'ALL-FORCES') Then
            counterForce = vectorInt_value(ii)
         End If

         If(trim(KEYWOR).Eq.'TEMPRESTAR') Then
            restartTemperature = vectorInt_value(ii)
         End If

         If(trim(KEYWOR).Eq.'TEMPVALUES') Then
            counterTemperature = vectorInt_value(ii)
         End If

         If(trim(KEYWOR).Eq.'BASIS_FREQ'.OR.trim(KEYWOR).Eq.'BASIS-FREQ') Then
            basis_frequency_stepNumber = vectorInt_value(ii)
         End If

         If(trim(KEYWOR).Eq.'BASIS_NSHL'.OR.trim(KEYWOR).Eq.'BASIS-NSHL') Then

            basis_size_stepNumber = vectorInt_value(ii)

            ii = ii + 1
            basis_size_stepValue = vectorInt_value(ii)

            ii = ii + 1
            basis_size_initValue = vectorInt_value(ii)

         End If

         If(trim(KEYWOR).Eq.'BASIS_NSTA'.OR.trim(KEYWOR).Eq.'BASIS-NSTA') Then

            basis_states_stepNumber = vectorInt_value(ii)

            ii = ii + 1
            basis_states_stepValue = vectorInt_value(ii)

            ii = ii + 1
            basis_states_initValue = vectorInt_value(ii)

         End If

         If(trim(KEYWOR).Eq.'BASIS_DEFS'.OR.trim(KEYWOR).Eq.'BASIS-DEFS') Then
            basis_deform_stepNumber = vectorInt_value(ii)
         End If


         ! Go to the next item on the list
         ii = ii + 1

      End Do

      Deallocate(vectorInt_value)

      !==============================================!
      !                                              !
      !   RECONSTRUCTION OF THE INPUT OF TYPE REAL   !
      !                                              !
      !==============================================!

      ii = 1

      Do While ( ii .le. counterDbl )

         KEYWOR = vectorAll_names(ii + counterInt)

         If(trim(KEYWOR).Eq.'REALNUCLEI') Then

            x_neutron_stepValue = vectorDbl_value(ii)

            ii = ii + 1
            x_neutron_initValue = vectorDbl_value(ii)

            ii = ii + 1
            x_proton_stepValue = vectorDbl_value(ii)

            ii = ii + 1
            x_proton_initValue = vectorDbl_value(ii)

         End If

         If(trim(KEYWOR).Eq.'MULTICONST') Then

            If(Allocated(qinitValue)) Then
               Deallocate(qinitValue,qFinValue)
            End If

            Allocate(qinitValue(1:numberConstraints))
            Allocate(qFinValue(1:numberConstraints))

            Do iq = 1, numberConstraints

               qFinValue(iq) = vectorDbl_value(ii)
               ii = ii + 1

               qinitValue(iq) = vectorDbl_value(ii)
               ii = ii + 1

            End Do
            ii = ii - 1

         End If

         If(trim(KEYWOR).Eq.'MULTIRESTA') Then

            If(Allocated(qinitValue_restart)) Then
               Deallocate(qinitValue_restart,qFinValue_restart)
            End If

            Allocate(qinitValue_restart(1:numberConstraints_restart))
            Allocate( qFinValue_restart(1:numberConstraints_restart))

            Do iq = 1, numberConstraints_restart

               qFinValue_restart(iq) = vectorDbl_value(ii)
               ii = ii + 1

               qinitValue_restart(iq) = vectorDbl_value(ii)
               ii = ii + 1

            End Do
            ii = ii - 1

         End If

         If(trim(KEYWOR).Eq.'NECK_CONST') Then

            neck_finValue  = vectorDbl_value(ii)

            ii = ii + 1
            neck_initValue = vectorDbl_value(ii)

         End If

         If(trim(KEYWOR).Eq.'NECK_RESTA') Then

            neck_finValue_restart  = vectorDbl_value(ii)

            ii = ii + 1
            neck_initValue_restart = vectorDbl_value(ii)

         End If

         If(trim(KEYWOR).Eq.'TEMPVALUES') Then

            If(Allocated(temperatureVector)) Then
               Deallocate(temperatureVector)
            End If

            Allocate(temperatureVector(1:counterTemperature))

            Do jj=1, counterTemperature
               temperatureVector(jj) = vectorDbl_value(ii+counterTemperature-jj)
            End Do

            ii = ii + counterTemperature - 1

         End If

         If(trim(KEYWOR).Eq.'BASIS_FREQ'.OR.trim(KEYWOR).Eq.'BASIS-FREQ') Then

            basis_frequency_stepValue = vectorDbl_value(ii)

            ii = ii + 1
            basis_frequency_initValue = vectorDbl_value(ii)

         End If

         If(trim(KEYWOR).Eq.'BASIS_DEFS'.OR.trim(KEYWOR).Eq.'BASIS-DEFS') Then

            basis_deform_stepValue = vectorDbl_value(ii)

            ii = ii + 1
            basis_deform_initValue = vectorDbl_value(ii)

         End If


         ! Go to the next item on the list
         ii = ii + 1

      End Do

      Deallocate(vectorDbl_value)

      !================================================!
      !                                                !
      ! RECONSTRUCTION OF THE INPUT OF TYPE STRING*10  !
      !                                                !
      !================================================!

      ii = 1

      Do While ( ii .le. counterStr )

         KEYWOR = vectorAll_names(ii + counterInt + counterDbl)

         If(trim(KEYWOR).Eq.'ALL_FORCES'.OR.trim(KEYWOR).Eq.'ALL-FORCES') Then

            If(Allocated(forceVector)) Then
               Deallocate(forceVector)
            End If

            Allocate(forceVector(1:counterForce))

            Do jj=1, counterForce
               string_10 = vectorStr_value(jj)
               forceVector(jj) = string_10(1:4)
            End Do

         End If

         ! Go to the next item on the list
         ii = ii + counterForce

      End Do

      Deallocate(vectorStr_value)

      Deallocate(vectorAll_names)

   End Subroutine mpi_setParallelData

   !-------------------------------------------------------------------!
   ! This subroutine prints variables that are common to all processes.!
   ! The subroutine is executed by processor 0 only                    !
   !-------------------------------------------------------------------!
   Subroutine mpi_printSequentialData(IOPTGS,NXHERM,NYHERM,NZHERM, &
                                      IPAIRI,IPAHFB,IPABCS,IMFHFB, &
                                                    LIPKIN,LIPKIP, &
                                      FE2FIN,IF2FIN,FE2FIP,IF2FIP, &
                                                    IROTAT,IREVIE, &
                                      ICONTI,IPCONT,IGCONT,IGPCON, &
                                             ILCONT,IFCONT,IACONT, &
                                      NUCHAO,NUPING,EPSPNG,EPSITE, &
                                             ISIMPY,ISIGNY,IPARTY, &
                                             ISIMTX,ISIMTY,ISIMTZ, &
                                                    NOITER,NULAST, &
                                             NOSCIL,NLIMIT,ENECUT, &
                                             ICOTYP,ICOUDI,ICOUEX, &
                                                    I_GOGA,IGOGPA, &
                                                           I1LINE, &
                                      SLOWEV,SLOWOD,SLOWPA,SLOWLI, &
                                                           ECUTOF, &
                                                           NILXYZ, &
                                      IBROYD,N_ITER,BROTRI,ALPHAM, &
                                             PRHO_T,PRHOST,POWERT, &
                                      PRHO_N,PRHOSN,PRHODN,POWERN, &
                                      PRHO_P,PRHOSP,PRHODP,POWERP, &
                                                           OMEGAY, &
                               IFSHEL,NPOLYN,GSTRUN,GSTRUP,HOMFAC, &
                                      LAMBAS,MIUBAS,BETBAS,NUMDEF, &
                               LAM_WS,MIU_WS,NUM_WS,ITE_WS,STP_WS, &
                                             LMXINP,IFPUSH,IREAWS, &
                               ISTAND,KETA_J,KETA_W,KETACM,KETA_M, &
                                      IF_RPA,IF_EDF,IF_THO,CBETHO, &
                                                    IBASIS,IFRAGM, &
                                             NMUCON,NMUCOU,NMUPRI, &
                                             NEXBET,IPRIBE,IPRIBL, &
                                                           FCHOM0, &
                                             IWRIFI,IFTEMP,IFNECK, &
                                             INNUMB,IZNUMB,R0PARM, &
                               DELTAE,XLOCMX,V2_MIN,NTHETA,MIN_QP, &
                                             IDEALL,IDELOC,IDECON, &
                                                       batch_init)

      Integer, intent(inout) :: ICOTYP, ICOUDI, ICOUEX, I_GOGA, IGOGPA, NOITER, IBROYD, &
                                N_ITER, NULAST, NUPING, NUCHAO, ISIMPY, ISIGNY, IPARTY, &
                                IROTAT, ISIMTX, ISIMTY, ISIMTZ, IPAIRI, IPAHFB, IPABCS, &
                                IMFHFB, LIPKIN, LIPKIP, IOPTGS, NXHERM, NYHERM, NZHERM, &
                                NOSCIL, NLIMIT, I1LINE, NILXYZ, IREVIE, ICONTI, IPCONT, &
                                IGCONT, IGPCON, ILCONT, IFCONT, IACONT, IFSHEL, NPOLYN, &
                                NUMDEF, NUM_WS, ITE_WS, IREAWS, ISTAND, KETA_J, KETA_W, &
                                KETACM, KETA_M, IF_RPA, IF_EDF, IF_THO, IBASIS, IFRAGM, &
                                IFPUSH, NMUCON, NMUCOU, NMUPRI, NEXBET, IPRIBE, IPRIBL, &
                                IWRIFI, IFTEMP, IFNECK, LMXINP, INNUMB, IZNUMB, NTHETA, &
                                MIN_QP, IDEALL, IDELOC, IDECON, batch_init,IF2FIN,IF2FIP

      Real, intent(inout) :: BROTRI, SLOWEV, SLOWOD, SLOWPA, SLOWLI, EPSITE, &
                             EPSPNG, ECUTOF, ENECUT, PRHO_T, PRHOST, POWERT, &
                             OMEGAY, GSTRUN, GSTRUP, HOMFAC, STP_WS, ALPHAM, &
                             CBETHO, FCHOM0, PRHO_N, PRHOSN, PRHODN, POWERN, &
                             PRHO_P, PRHOSP, PRHODP, POWERP, R0PARM, DELTAE, &
                             XLOCMX, V2_MIN, FE2FIN, FE2FIP

      Integer :: ii,nfisum,LAMACT,MIUACT
      Integer :: mpi_rank,mpi_err

      Integer, Dimension(:), pointer :: LAMBAS,MIUBAS,LAM_WS,MIU_WS

      Real, Dimension(:), pointer :: BETBAS

      COMMON /OUTPUT/ nfisum

      Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)

      ! Printing out the characteristics of the parallel run
      If(mpi_rank.Eq.0 .And. batch_init.Eq.1) Then

         Write(nfisum,'(/,14X,"/",42("-"),"/")')
         Write(nfisum,'(14X,"/ CHARACTERISTICS OF THE RUN: SERIAL PART  /")')
         Write(nfisum,'(14X,"/",42("-"),"/",/)')

         Write(nfisum,'("/",77("-"),"/",/,"/",77X,"/")')
         Write(nfisum,'("/   Iterations",64X,"/")')
         Write(nfisum,'("/   ----------",64X,"/")')
         Write(nfisum,'("/     IBROYD = ",i1," N_ITER = ",i3," BROTRI = ",f9.3," ALPHAM = ",f7.4,13x, &
        &               "/",/,"/",77X,"/")') IBROYD,N_ITER,BROTRI,ALPHAM
         Write(nfisum,'("/     NOITER = ",i5," NULAST = ",i5," NUCHAO = ",i5," NUPING = ",i5,13X,"/")') &
                          NOITER,NULAST,NUCHAO,NUPING
         Write(nfisum,'("/     SLOWEV = ",f7.4," SLOWOD = ",f7.4," SLOWPA = ",f7.4," SLOWLI = ",f7.4,5x,"/")') &
                          SLOWEV,SLOWOD,SLOWPA,SLOWLI
         Write(nfisum,'("/     EPSPNG = ",e20.12," EPSITE = ",e20.12,13X,"/")') &
                          EPSPNG,EPSITE
         Write(nfisum,'("/",77X,"/")')

         Write(nfisum,'("/   Characteristics of the HO basis",43X,"/")')
         Write(nfisum,'("/   -------------------------------",43X,"/")')
         Write(nfisum,'("/     IBASIS = ",i3," IOPTGS = ",i1,49X,"/")') IBASIS,IOPTGS
         Write(nfisum,'("/     NOSCIL = ",i3," NLIMIT = ",i5," ENECUT = ",f9.3,26X,"/")') &
                          NOSCIL,NLIMIT,ENECUT
         Write(nfisum,'("/     NXHERM = ",i3," NYHERM = ",i3," NZHERM = ",i3,34X,"/")') &
                          NXHERM,NYHERM,NZHERM
         Write(nfisum,'("/     INNUMB = ",i3," IZNUMB = ",i5," R0PARM = ",f9.3,26X,"/")') &
                          INNUMB,IZNUMB,R0PARM
         Write(nfisum,'("/",77X,"/")')

         If(Associated(LAMBAS)) Then
            Write(nfisum,'("/     Deformations of the nuclear surface",37X,"/")')
            Do ii=1,NUMDEF
               LAMACT=Abs(LAMBAS(ii)); MIUACT=MIUBAS(ii)
               Write(nfisum,'("/     l = ",i2," m = ",i2," beta_lm = ",f7.4,41X,"/")') &
                          LAMACT,MIUACT,BETBAS(ii)
            End Do
            Write(nfisum,'("/",77X,"/")')
         End If

         Write(nfisum,'("/   Type of calculation",55X,"/")')
         Write(nfisum,'("/   -------------------",55X,"/")')
         Write(nfisum,'("/     IPAIRI = ",i1," IPAHFB = ",i1," IPABCS =",i2, &
        &                    " IMFHFB = ",i1," LIPKIN = ",i1," LIPKIP = ",i1,7X,"/")') &
                          IPAIRI,IPAHFB,IPABCS,IMFHFB,LIPKIN,LIPKIP
         Write(nfisum,'("/     FE2FIN = ",f9.3," IF2FIN = ",i1," FE2FIP = ",f9.3," IF2FIN =",i1,7X,"/")') &
                               FE2FIN,IF2FIN,FE2FIP,IF2FIP
         Write(nfisum,'("/     ICOUDI = ",i1," ICOUEX = ",i1," I_GOGA = ",i1, &
        &                    " IGOGPA = ",i1," IFTEMP = ",i1," IFSHEL = ",i1,7X,"/")') &
                          ICOUDI,ICOUEX,I_GOGA,IGOGPA,IFTEMP,IFSHEL
         Write(nfisum,'("/     IFRAGM = ",i1," ICOUEX = ",i1,51X,"/")') &
                          IFRAGM,IF_THO
         Write(nfisum,'("/     IF_EDF = ",i1," ISTAND = ",i1," KETA_J = ",i1, &
        &                    " KETA_W = ",i1," KETACM = ",i1," KETA_M = ",i1,7X,"/")') &
                          IF_EDF,ISTAND,KETA_J,KETA_W,KETACM,KETA_M
         Write(nfisum,'("/",77X,"/")')

         Write(nfisum,'("/   Pairing options",59X,"/")')
         Write(nfisum,'("/   ---------------",59X,"/")')
         Write(nfisum,'("/     ECUTOF = ",f9.3,54X,"/")') ECUTOF
         Write(nfisum,'("/     PRHO_T = ",f9.3," PRHOST = ",f9.3," POWERT = ",f9.3,16X,"/")') &
                          PRHO_T,PRHOST,POWERT
         Write(nfisum,'("/     PRHO_N = ",f9.3," PRHOSN = ",f9.3," POWERN = ",f9.3,16X,"/")') &
                          PRHO_N,PRHOSN,POWERN
         Write(nfisum,'("/     PRHO_P = ",f9.3," PRHOSP = ",f9.3," POWERP = ",f9.3,16X,"/")') &
                          PRHO_P,PRHOSP,POWERP
         Write(nfisum,'("/",77X,"/")')

         Write(nfisum,'("/   Constraints",63X,"/")')
         Write(nfisum,'("/   -----------",63X,"/")')
         Write(nfisum,'("/     IF_RPA = ",i2," IFPUSH = ",i2," IFNECK = ",i2,37X,"/")') &
                               IF_RPA,IFPUSH,IFNECK
         Write(nfisum,'("/     NMUCON = ",i2," NMUCOU = ",i2," NMUPRI = ",i2,37X,"/")') &
                          NMUCON,NMUCOU,NMUPRI
         Write(nfisum,'("/     OMEGAY = ",f7.4,56X,"/")') &
                          OMEGAY
         Write(nfisum,'("/",77X,"/")')

         Write(nfisum,'("/   Restart options",59X,"/")')
         Write(nfisum,'("/   ---------------",59X,"/")')
         Write(nfisum,'("/     ICONTI = ",i1," IPCONT = ",i1," IGCONT = ",i1, &
        &                    " IGPCON = ",i1," ILCONT = ",i1," IFCONT = ",i1,7X,"/")') &
                          ICONTI,IPCONT,IGCONT,IGPCON,ILCONT,IFCONT
         Write(nfisum,'("/     IREAWS = ",i1,62X,"/")') IREAWS
         If(IREAWS.Eq.1) Then
            Write(nfisum,'("/     Minimization over deformations",42X,"/")')
            Write(nfisum,'("/        NUMINP = ",i3," ITEINP = ",i3," LMXINP = ",i2," STPINP = ",f7.4,15X,"/")') &
                                     NUM_WS,ITE_WS,LMXINP,STP_WS
            Do ii=1,NUM_WS
               LAMACT=Abs(LAM_WS(ii)); MIUACT=MIU_WS(ii)
               Write(nfisum,'("/     l = ",i2," m = ",i2,59X,"/")') LAMACT,MIUACT
            End Do
         End If
         Write(nfisum,'("/",77X,"/")')

         Write(nfisum,'("/   Symmetry flags",60X,"/")')
         Write(nfisum,'("/   --------------",60X,"/")')
         Write(nfisum,'("/     IROTAT = ",i2," ISIMPY = ",i2," ISIGNY = ",i2," IPARTY = ",i2,25X,"/")') &
                          IROTAT,ISIMPY,ISIGNY,IPARTY
         Write(nfisum,'("/                 ISIMTX = ",i2," ISIMTY = ",i2," ISIMTZ = ",i2,25X,"/")') &
                          ISIMTX,ISIMTY,ISIMTZ
         Write(nfisum,'("/",77X,"/")')

         Write(nfisum,'("/   Various",67X,"/")')
         Write(nfisum,'("/   -------",67X,"/")')
         Write(nfisum,'("/     I1LINE = ",i2," NILXYZ = ",i2," IREVIE = ",i2," IWRIFI = ",i2,25X,"/")') &
                          I1LINE,NILXYZ,IREVIE,IWRIFI
         Write(nfisum,'("/     NEXBET = ",i2," IPRIBE = ",i2," IPRIBL = ",i2,37X,"/")') &
                          NEXBET,IPRIBE,IPRIBL
         If(IFSHEL.Gt.0) then
            Write(nfisum,'("/",77X,"/")')
            Write(nfisum,'("/     NPOLYN = ",i2," HOMFAC = ",f7.4," GSTRUN = ",f7.4," GSTRUP = ",f7.4,10X,"/")') &
                             NPOLYN,HOMFAC,GSTRUN,GSTRUP
         End if
         Write(nfisum,'("/     MIN_QP = ",i2," DELTAE = ",f7.3," XLOCMX = ",f7.5," V2_MIN = ",f7.5,10X,"/")') &
                               MIN_QP,DELTAE,XLOCMX,V2_MIN
         Write(nfisum,'("/     IDEALL = ",i2," IDELOC = ",i2," IDECON = ",i2,37X,"/")') &
                               IDEALL,IDELOC,IDECON
         Write(nfisum,'("/",77X,"/",/,"/",77("-"),"/")')

      End If

      Call mpi_barrier(MPI_COMM_WORLD, mpi_err)

   End Subroutine mpi_printSequentialData

   !-------------------------------------------------------------------!
   ! This subroutine prints variables that are used to construct the   !
   ! list of jobs. The subroutine is executed by processor 0 only      !
   !-------------------------------------------------------------------!
   Subroutine mpi_printParallelData()

      Integer :: ii,nfisum,mpi_rank,mpi_err

      COMMON /OUTPUT/ nfisum

      Call mpi_comm_rank(MPI_COMM_WORLD,mpi_rank,mpi_err)

      ! Printing out the characteristics of the parallel run
      If(mpi_rank.Eq.0) Then

         Write(nfisum,'(/,14X,"/",44("-"),"/")')
         Write(nfisum,'(14X,"/ CHARACTERISTICS OF THE RUN: PARALLEL PART  /")')
         Write(nfisum,'(14X,"/",44("-"),"/",/)')

         Write(nfisum,'("/",77("-"),"/",/,"/",77X,"/")')
         Write(nfisum,'("/   Calculation mode",58X,"/")')
         Write(nfisum,'("/   ----------------",58X,"/")')
         Write(nfisum,'("/     Deformation .: ",i2,55X,"/")') modeMPI_deformation
         Write(nfisum,'("/     Neck ........: ",i2,55X,"/")') modeMPI_neck
         Write(nfisum,'("/     Batch .......: ",i2,55X,"/")') batch_mode
         Write(nfisum,'("/     Batch number : ",i2,55X,"/")') number_batch
         Write(nfisum,'("/     Basis .......: ",i2,55X,"/")') modeMPI_basis
         Write(nfisum,'("/",77X,"/")')

         Write(nfisum,'("/   Nucleus grid",62X,"/")')
         Write(nfisum,'("/   ------------",62X,"/")')
         Write(nfisum,'("/     Particle   Initial    Step   Number of steps",28X,"/")')
         If(neutron_initValue.Gt.0.0D0) Then
            Write(nfisum,'("/      neutron   ",F8.4,"  ",F7.4,"      ",i4,34X,"/")') &
                         x_neutron_initValue, x_neutron_stepValue, neutron_stepNumber
         Else
            Write(nfisum,'("/      neutron     ",i4,"      ",i2,"         ",i4,34X,"/")') &
                         neutron_initValue, neutron_stepValue, neutron_stepNumber
         End If
         If(proton_initValue.Gt.0.0D0) Then
            Write(nfisum,'("/      proton    ",F8.4,"  ",F7.4,"      ",i4,34X,"/")') &
                         x_proton_initValue, x_proton_stepValue, proton_stepNumber
         Else
            Write(nfisum,'("/      proton      ",i4,"      ",i2,"         ",i4,34X,"/")') &
                         proton_initValue, proton_stepValue, proton_stepNumber
         End If
         Write(nfisum,'("/",77X,"/")')

         ! Displaying characteristics of the default deformation grid (regular)
         If(modeMPI_deformation.Eq.1.Or.modeMPI_basis.Eq.1) Then
            Write(nfisum,'("/   Deformation grid",58X,"/")')
            Write(nfisum,'("/   ----------------",58X,"/")')
            Write(nfisum,'("/     Constrained calculations: ",i4,42X,"/")') turnConstraintOn
            Write(nfisum,'("/     Number of constraints ..: ",i4,42X,"/")') numberConstraints
            Write(nfisum,'("/     Constraint #    Lambda   Miu   Initial    Final   Number of steps",7X,"/")')
            Do ii=1,numberConstraints
               Write(nfisum,'("/     ",6X,i2,9X,i2,6X,i2,2X,f8.2,2X,f8.2,6X,i5,14X,"/")') &
                       ii, qLambda(ii), qMiu(ii), qinitValue(ii), qFinValue(ii), qStepNumber(ii)
            End Do
            Write(nfisum,'("/",77X,"/")')
         End If

         ! Displaying characteristics of the initial grid (regular) and restart deformation grid (regular)
         If(modeMPI_deformation.Eq.2) Then
            Write(nfisum,'("/   Original deformation grid",49X,"/")')
            Write(nfisum,'("/   -------------------------",49X,"/")')
            Write(nfisum,'("/     Constrained calculations: ",i4,42X,"/")') turnConstraintOn
            Write(nfisum,'("/     Number of constraints ..: ",i4,42X,"/")') numberConstraints
            Write(nfisum,'("/     Constraint #    Lambda   Miu   Initial    Final   Number of steps",7X,"/")')
            Do ii=1,numberConstraints
               Write(nfisum,'("/     ",6X,i2,9X,i2,6X,i2,2X,f8.2,2X,f8.2,6X,i5,14X,"/")') &
                       ii, qLambda(ii), qMiu(ii), qinitValue(ii), qFinValue(ii), qStepNumber(ii)
            End Do
            Write(nfisum,'("/   New deformation grid",54X,"/")')
            Write(nfisum,'("/   --------------------",54X,"/")')
            Write(nfisum,'("/     Optimize path ..........: ",i4,42X,"/")') optimizePath
            Write(nfisum,'("/     Number of constraints ..: ",i4,42X,"/")') numberConstraints_restart
            Write(nfisum,'("/     Constraint #    Lambda   Miu   Initial    Final   Number of steps",7X,"/")')
            Do ii=1,numberConstraints_restart
               Write(nfisum,'("/     ",6X,i2,9X,i2,6X,i2,2X,f8.2,2X,f8.2,6X,i5,14X,"/")') &
                       ii, qLambda_restart(ii), qMiu_restart(ii), &
                           qinitValue_restart(ii), qFinValue_restart(ii), qStepNumber_restart(ii)
            End Do
            Write(nfisum,'("/",77X,"/")')
         End If

         ! Displaying characteristics of the initial grid (only what constraints were used) and of the
         ! restart grid (regular)
         If(modeMPI_deformation.Eq.3) Then
            Write(nfisum,'("/   Original deformation grid",49X,"/")')
            Write(nfisum,'("/   -------------------------",49X,"/")')
            Write(nfisum,'("/     Number of constraints ..: ",i4,42X,"/")') numberConstraints
            Write(nfisum,'("/     Constraint #    Lambda   Miu",44X,"/")')
            Do ii=1,numberConstraints
               Write(nfisum,'("/     ",6X,i2,9X,i2,6X,i2,45X,"/")') &
                       ii, qLambda(ii), qMiu(ii)
            End Do
            Write(nfisum,'("/   New deformation grid",54X,"/")')
            Write(nfisum,'("/   --------------------",54X,"/")')
            Write(nfisum,'("/     Optimize path ..........: ",i4,42X,"/")') optimizePath
            Write(nfisum,'("/     Number of constraints ..: ",i4,42X,"/")') numberConstraints_restart
            Write(nfisum,'("/     Constraint #    Lambda   Miu   Initial    Final   Number of steps",7X,"/")')
            Do ii=1,numberConstraints_restart
               Write(nfisum,'("/     ",6X,i2,9X,i2,6X,i2,2X,f8.2,2X,f8.2,6X,i5,14X,"/")') &
                       ii, qLambda_restart(ii), qMiu_restart(ii), &
                           qinitValue_restart(ii), qFinValue_restart(ii), qStepNumber_restart(ii)
            End Do
            write(nfisum,'("/",77X,"/")')
         End If

         ! Displaying characteristics of the origina deformation grid (grid). New calculation will not
         ! yield a regular grid but an irregular path defined by what is in the file hfodd_path.d
         If(modeMPI_deformation.Eq.4) Then
            Write(nfisum,'("/   Original deformation grid",49X,"/")')
            Write(nfisum,'("/   -------------------------",49X,"/")')
            Write(nfisum,'("/     Number of constraints ..: ",i4,42X,"/")') numberConstraints
            Write(nfisum,'("/     Constraint #    Lambda   Miu",44X,"/")')
            Do ii=1,numberConstraints
               Write(nfisum,'("/     ",6X,i2,9X,i2,6X,i2,45X,"/")') &
                       ii, qLambda(ii), qMiu(ii)
            End Do
            write(nfisum,'("/",77X,"/")')
         End If

      	 ! Displaying characteristics of the default neck grid
         If(modeMPI_neck.Eq.1) Then
            Write(nfisum,'("/   Neck grid",65X,"/")')
            Write(nfisum,'("/   ---------",65X,"/")')
            Write(nfisum,'("/     ",29X,f8.4,2X,f8.4,6X,i5,14X,"/")') &
                          neck_initValue, neck_finValue, neck_numberPoints
            Write(nfisum,'("/",77X,"/")')
         End If

      	 ! Displaying characteristics of the initial and restart neck grid
         If(modeMPI_neck.Eq.2) Then
            Write(nfisum,'("/   Original neck grid",56X,"/")')
            Write(nfisum,'("/   ------------------",56X,"/")')
            Write(nfisum,'("/     ",29X,f8.4,2X,f8.4,6X,i5,14X,"/")') &
                             neck_initValue, neck_finValue, neck_numberPoints
            Write(nfisum,'("/   New neck grid",61X,"/")')
            Write(nfisum,'("/   -------------",61X,"/")')
            Write(nfisum,'("/     ",29X,f8.4,2X,f8.4,6X,i5,14X,"/")') &
                          neck_initValue_restart, neck_finValue_restart, neck_numberPoints_restart
            Write(nfisum,'("/",77X,"/")')
         End If

         Write(nfisum,'("/   Forces",68X,"/")')
         Write(nfisum,'("/   ------",68X,"/")')
         Do ii=1,counterForce
            Write(nfisum,'("/     ",A4,68X,"/")') forceVector(ii)
         End Do
         write(nfisum,'("/",77X,"/")')

      	 If(restartTemperature.Eq.1) Then
            Write(nfisum,'("/   Temperature Grid  (restart is based on the exact same grid)",14X,"/")')
         Else
            Write(nfisum,'("/   Temperature Grid  (restart is based on T=0 calculations)",18X,"/")')
         End If
         Write(nfisum,'("/   ----------------",58X,"/")')
         Do ii=1,counterTemperature
            Write(nfisum,'("/        ",F6.3,63X,"/")') temperatureVector(ii)
         End do
         Write(nfisum,'("/",77X,"/")')

      	 ! Displaying characteristics of the basis grid
         If(modeMPI_basis.Eq.1) Then
            Write(nfisum,'("/   Basis grid",64X,"/")')
            Write(nfisum,'("/   ----------",64X,"/")')
            Write(nfisum,'("/        Type        Initial    Step   Number of steps",24X,"/")')
            Write(nfisum,'("/       Shells        ",i2,"        ",i2,"          ",i2,32X,"/")') &
                      basis_size_initValue,basis_size_stepValue,basis_size_stepNumber
            Write(nfisum,'("/       States        ",i4,"      ",i4,"        ",i2,32X,"/")') &
                      basis_states_initValue,basis_states_stepValue,basis_states_stepNumber
            Write(nfisum,'("/     HO frequency  ",f6.3,"    ",f6.3,"        ",i2,32X,"/")') &
                      basis_frequency_initValue,basis_frequency_stepValue,basis_frequency_stepNumber
            Write(nfisum,'("/    HO deformation ",f6.3,"    ",f6.3,"        ",i2,32X,"/")') &
                      basis_deform_initValue,basis_deform_stepValue,basis_deform_stepNumber
            Write(nfisum,'("/",77X,"/")')
         End If

         Write(nfisum,'("/",77("-"),"/")')

      End If

      Call mpi_barrier(MPI_COMM_WORLD, mpi_err)

   End Subroutine mpi_printParallelData

 End Module hfodd_mpiio

 !***********************************************************************
 !
 !    Copyright (c) 2015, Lawrence Livermore National Security, LLC.
 !                        Produced at the Lawrence Livermore National
 !                        Laboratory.
 !                        Written by Nicolas Schunck, schunck1@llnl.gov
 !
 !    LLNL-CODE-470611 All rights reserved.
 !
 !    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
 !                    W. Satula, J.A. Sheikh, A. Staszczak,
 !                    M. Stoitsov, P. Toivanen
 !    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
 !                    P. Olbratowski, P. Powalowski, M. Sadziak,
 !                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
 !                    M. Zalewski, H. Zdunczuk
 !    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
 !    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
 !
 !    This file is part of HFODD.
 !
 !    HFODD is free software: you can redistribute it and/or modify it
 !    under the terms of the GNU General Public License as published by
 !    the Free Software Foundation, either version 3 of the License, or
 !    (at your option) any later version.
 !
 !    HFODD is distributed in the hope that it will be useful, but
 !    WITHOUT ANY WARRANTY; without even the implied warranty of
 !    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 !    GNU General Public License for more details.
 !
 !    You should have received a copy of the GNU General Public License
 !    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
 !
 !    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
 !    LICENSE
 !
 !    Our Preamble Notice
 !
 !      A. This notice is required to be provided under our contract
 !         with the U.S. Department of Energy (DOE). This work was
 !         produced at the Lawrence Livermore National Laboratory under
 !         Contract No. DE-AC52-07NA27344 with the DOE.
 !      B. Neither the United States Government nor Lawrence Livermore
 !         National Security, LLC nor any of their employees, makes any
 !         warranty, express or implied, or assumes any liability or
 !         responsibility for the accuracy, completeness, or usefulness
 !         of any information, apparatus, product, or process disclosed,
 !         or represents that its use would not infringe privately-owned
 !         rights.
 !      C. Also, reference herein to any specific commercial products,
 !         process, or services by trade name, trademark, manufacturer
 !         or otherwise does not necessarily constitute or imply its
 !         endorsement, recommendation, or favoring by the United States
 !         Government or Lawrence Livermore National Security, LLC. The
 !         views and opinions of authors expressed herein do not
 !         necessarily state or reflect those of the United States
 !         Government or Lawrence Livermore National Security, LLC, and
 !         shall not be used for advertising or product endorsement
 !         purposes.
 !
 !    The precise terms and conditions for copying, distribution and
 !    modification are contained in the file COPYING.
 !
 !***********************************************************************
      SUBROUTINE Set_version_hfodd_pairs
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(11) = 'hfodd_pairs    '
      MODUVE(11) = 2
      MODSET(11) = 11
      !
      END SUBROUTINE Set_version_hfodd_pairs
      !
 !----------------------------------------------------------------------!
 !                                                                      !
 !   Module defining various derived types related to pairs, lists of   !
 !   pairs and lists of lists of pairs, as well as the routines needed  !
 !   to manipulate these objects.                                       !
 !                                                                      !
 !----------------------------------------------------------------------!

 Module pair_definition

     Implicit None

     Integer, Parameter, Public :: iprec=Kind(1), prec=Kind(1.0) ! precision

     ! New type for pair of indexes
     Type :: Pair
         Integer(iprec) :: mu
         Integer(iprec) :: nu
     End Type Pair

     ! New type for list of pairs
     Type :: PairSet
         Type(Pair), Dimension(:), pointer :: pair_vector
     End Type PairSet

     ! New type for list of set of pairs
     Type :: ListePairSet
         Integer, Dimension(:), pointer :: size_tiling
         Type(PairSet), Dimension(:), pointer :: liste
     End Type ListePairSet

 Contains

     !---------------------------------------------------------------------!
     !  This subroutine sorts a vector EL(1:N) by ascending order and      !
     !  returns the vector of indices in KL(1:N)                           !
     !---------------------------------------------------------------------!
     Subroutine sort_vector(EL,KL,N)

       Integer(iprec), INTENT(IN) :: N
       Integer(iprec), Dimension(1:N), INTENT(INOUT) :: KL
       Real(prec), Dimension(1:N), INTENT(INOUT) :: EL

       Integer(iprec) :: i,j,IEQUAL,IFILLL
       Integer(iprec), Allocatable :: KM(:),KWHER(:),KFROM(:)
       Real(prec), Allocatable :: EM(:)

       Allocate(KM(1:N),KWHER(1:N),KFROM(1:N))
       Allocate(EM(1:N))

       ! Rewriting input arrays to auxiliary ones
       KWHER(1:N)=1
       EM(1:N)=EL(1:N)
       KM(1:N)=KL(1:N)

       ! How many elements are smaller than the i-th one? In other words
       ! where should it go with respect to the offset position 1?
       Do J=1,N
          Do I=1,N
             If(EM(j).Lt.EM(i)) KWHER(i)=KWHER(i)+1
          End Do
       End Do

       ! Now we only have to resolve the case of identical elements
       ! From where the i-th element should come?
       KFROM(1:N)=0
       Do i=1,N
          KFROM(KWHER(i))=i
       End Do

       ! If some elements are equal there will be unfilled places
       ! in the KFROM array: Fill them up now.

     1 Continue

       Do i=1,N
          If(KFROM(i).Eq.0) Then
             IEQUAL=i-1
             IFILLL=i-1
             GO TO 2
          End IF
       End Do

       GO TO 3

     2 Do i=1,N

          If(KWHER(i).Eq.IEQUAL) Then
             KFROM(IFILLL)=i
             IFILLL=IFILLL+1
          End If

       End Do

       GO TO 1

     3 Continue

       ! Finally we may rewrite the input arrays in the right order
       Do i=1,N
          EL(i)=EM(KFROM(i))
          KL(i)=KM(KFROM(i))
       End Do

     End Subroutine sort_vector

     !---------------------------------------------------------------------!
     !  This subroutine sorts a vector EL(1:N) by ascending order and      !
     !  returns the vector of indices in KL(1:N)                           !
     !---------------------------------------------------------------------!
     Subroutine isort_vector(EL,KL,N)

       Integer(iprec), INTENT(IN) :: N
       Integer(iprec), Dimension(1:N), INTENT(INOUT) :: KL
       Integer(iprec), Dimension(1:N), INTENT(INOUT) :: EL

       Integer(iprec) :: i,j,IEQUAL,IFILLL
       Integer(iprec), Allocatable :: KM(:),KWHER(:),KFROM(:)
       Integer(iprec), Allocatable :: EM(:)

       Allocate(KM(1:N),KWHER(1:N),KFROM(1:N))
       Allocate(EM(1:N))

       ! Rewriting input arrays to auxiliary ones
       KWHER(1:N)=1
       EM(1:N)=EL(1:N)
       KM(1:N)=KL(1:N)

       ! How many elements are smaller than the i-th one? In other words
       ! where should it go with respect to the offset position 1?
       Do J=1,N
          Do I=1,N
             If(EM(j).Lt.EM(i)) KWHER(i)=KWHER(i)+1
          End Do
       End Do

       ! Now we only have to resolve the case of identical elements
       ! From where the i-th element should come?
       KFROM(1:N)=0
       Do i=1,N
          KFROM(KWHER(i))=i
       End Do

       ! If some elements are equal there will be unfilled places
       ! in the KFROM array: Fill them up now.

     1 Continue

       Do i=1,N
          If(KFROM(i).Eq.0) Then
             IEQUAL=i-1
             IFILLL=i-1
             GO TO 2
          End IF
       End Do

       GO TO 3

     2 Do i=1,N

          If(KWHER(i).Eq.IEQUAL) Then
             KFROM(IFILLL)=i
             IFILLL=IFILLL+1
          End If

       End Do

       GO TO 1

     3 Continue

       ! Finally we may rewrite the input arrays in the right order
       Do i=1,N
          EL(i)=EM(KFROM(i))
          KL(i)=KM(KFROM(i))
       End Do

     End Subroutine isort_vector

     !------------------------------------------!
     ! ROUTINES FOR MANIPULATING LISTS OF PAIRS !
     !------------------------------------------!

     ! Creates a new list of pairs 'new_pair_vector' of size 'N' with all pair
     ! indices initialized to 0
     Subroutine PairSet_new(N, new_pair_vector)

       Integer(iprec), INTENT(IN) :: N
       Type(PairSet), INTENT(INOUT) :: new_pair_vector
       Type(Pair) :: pair_null

       Nullify(new_pair_vector%pair_vector)

       pair_null%mu = 0
       pair_null%nu = 0

       Allocate(new_pair_vector%pair_vector(N))
       new_pair_vector%pair_vector(:) = pair_null

     End Subroutine PairSet_new

     ! Print the members of the list of pairs 'new_pair_vector' of size 'N'
     Subroutine PairSet_print(N, new_pair_vector)

       Integer(iprec), INTENT(IN) :: N
       Type(PairSet), INTENT(In) :: new_pair_vector
       Integer(iprec) :: i

       Do i=1,N
          Write(6,'(i4," - (",i4,",",i4,")")') i,new_pair_vector%pair_vector(i)%mu,&
                                                 new_pair_vector%pair_vector(i)%nu
       End Do

     End Subroutine PairSet_print

     ! Computes the actual size of the list of pairs 'new_pair_vector' of
     ! original size 'N'
     Integer(iprec) Function PairSet_size(N, new_pair_vector)

       Integer(iprec), INTENT(IN) :: N
       Type(PairSet), INTENT(INOUT) :: new_pair_vector
       Integer(iprec) :: i,count

       count=0
       Do i=1,N
          If(new_pair_vector%pair_vector(i)%mu.Ne.0.And.new_pair_vector%pair_vector(i)%nu.Ne.0) count=count+1
       End Do
       PairSet_size=count

     End Function PairSet_size

     ! Sorts the list of pairs 'new_pair_vector' of size 'N' by ascending order
     ! over the first then second index of the pair
     Subroutine PairSet_sort(N, new_pair_vector)

       Integer(iprec), INTENT(IN) :: N
       Type(PairSet), INTENT(INOUT) :: new_pair_vector
       Integer(iprec) :: i,j,count
       Integer(iprec), Allocatable :: vec_mu(:),vec_nu(:),buf_nu(:),save_nu(:)
       Integer(iprec), Allocatable :: table1(:), table2(:)

       Allocate(vec_mu(1:N),vec_nu(1:N))
       Allocate(table1(1:N),save_nu(1:N))
       Do i=1,N
          vec_mu(i)=new_pair_vector%pair_vector(i)%mu
          vec_nu(i)=new_pair_vector%pair_vector(i)%nu
          table1(i)=i
       End Do
       ! Sort first index by ascending order
       Call isort_vector(vec_mu,table1,N)
       Do i=1,N
          save_nu(i)=vec_nu(table1(i))
       End Do

       Allocate(table2(1:N),buf_nu(1:N))
       i=0; count=0
       Do While (i < N-1 )
          i=i+1
          If(vec_mu(i).Eq.vec_mu(i+1)) Then
             count=count+1
             buf_nu(count)=save_nu(i)
             table2(count)=count
          Else
             count=count+1
             buf_nu(count)=save_nu(i)
             table2(count)=count
             Call isort_vector(buf_nu,table2,count)
             Do j=1,count
                vec_nu(i-count+j)=buf_nu(j)
             End Do
             count=0
          End If
       End Do

       Do i=1,N
          new_pair_vector%pair_vector(i)%mu=vec_mu(i)
          new_pair_vector%pair_vector(i)%nu=vec_nu(i)
       End Do

       Deallocate(vec_mu,vec_nu,buf_nu,save_nu,table1,table2)

     End Subroutine PairSet_sort

     ! Remove all pairs with members equal to either 'mu' or 'nu' in a list
     ! 'new_pair_vector' of size 'N'. The size of the resulting list is decreased
     ! automatically, so that N(output) <= N(input)
     Subroutine PairSet_remove(N, new_pair_vector, mu, nu)

       Integer(iprec), INTENT(IN) :: mu, nu
       Integer(iprec), INTENT(INOUT) :: N
       Type(PairSet), INTENT(INOUT) :: new_pair_vector
       Type(PairSet) :: buffer
       Integer(iprec) :: i,count

       ! If current pointer to the list is not associated, the list is already
       ! empty, we return
       If(.not.associated(new_pair_vector%pair_vector).Or.N.Eq.0) Then
          N=0
          Return
       End if

       count=0
       Do i=1,N
          If(new_pair_vector%pair_vector(i)%mu.Ne.mu .And. new_pair_vector%pair_vector(i)%nu.Ne.nu .And. &
             new_pair_vector%pair_vector(i)%mu.Ne.nu .And. new_pair_vector%pair_vector(i)%nu.Ne.mu) &
          count=count+1
       End do

       ! If the list is not empty after removing the necessary members, we
       ! proceed
       If(count>0) Then
       	 ! Create a temporary new list with the proper size
          Call PairSet_new(count, buffer)
          ! Copy relevant members of original list into temporary new list
          count=0
          Do i=1,N
             If(new_pair_vector%pair_vector(i)%mu.Ne.mu .And. new_pair_vector%pair_vector(i)%nu.Ne.nu .And. &
                new_pair_vector%pair_vector(i)%mu.Ne.nu .And. new_pair_vector%pair_vector(i)%nu.Ne.mu) Then
                count=count+1
                buffer%pair_vector(count)%mu=new_pair_vector%pair_vector(i)%mu
                buffer%pair_vector(count)%nu=new_pair_vector%pair_vector(i)%nu
             End If
          End do
          ! Delete original list
          Call PairSet_del(new_pair_vector)
          ! Update the size of the new list
          N=count
          ! If the new list is not empty, we copy the temporary list into the
          ! new list
          If(N>0) Then
             Call PairSet_new(N, new_pair_vector)
             Do i=1,N
                new_pair_vector%pair_vector(i)%mu = buffer%pair_vector(i)%mu
                new_pair_vector%pair_vector(i)%nu = buffer%pair_vector(i)%nu
             End Do
             Call PairSet_del(buffer)
          Else
             ! If the new list is empty, we update the size
             N=0
          End If
       Else
          ! If the new list is empty, we update the size
          N=0
       End If

     End Subroutine PairSet_remove

     ! Test whether a list of pairs 'new_pair_vector_1' of length 'N1' is the
     ! same as the list of pairs 'new_pair_vector_2' of length 'N2' (lists are
     ! unordered)
     Logical Function PairSet_equal(N1, new_pair_vector_1, N2, new_pair_vector_2)

       Integer(iprec), INTENT(IN) :: N1,N2
       Type(PairSet), INTENT(IN) :: new_pair_vector_1,new_pair_vector_2
       Integer(iprec) :: i,j,sum,m,n
       Integer(iprec), Allocatable :: mu1(:),nu1(:),mu2(:),nu2(:)

       PairSet_equal = .False.

       If(N1.Ne.N2) Return

       Allocate(mu1(1:N1),nu1(1:N1),mu2(1:N1),nu2(1:N1))
       Do i=1,N1
          mu1(i)=new_pair_vector_1%pair_vector(i)%mu
          nu1(i)=new_pair_vector_1%pair_vector(i)%nu
          mu2(i)=new_pair_vector_2%pair_vector(i)%mu
          nu2(i)=new_pair_vector_2%pair_vector(i)%nu
       End Do

       sum=0
       Do i=1,N1
          m=mu1(i); n=nu1(i)
          Do j=1,N1
             If(mu2(j).Eq.m.And.nu2(j).Eq.n) Then
                sum=sum+1
                Exit
             End If
          End Do
       End Do
       Deallocate(mu1,nu1,mu2,nu2)
       If(sum.eq.N1) PairSet_equal = .True.

     End Function PairSet_equal

     ! Removes list of pairs 'new_pair_vector' by deallocating the space and
     ! nullifying the pointer
     Subroutine PairSet_del(new_pair_vector)

       Type(PairSet), INTENT(INOUT) :: new_pair_vector

       Deallocate(new_pair_vector%pair_vector)
       Nullify(new_pair_vector%pair_vector)

     End Subroutine PairSet_del

     !---------------------------------------------------!
     ! ROUTINES FOR MANIPULATING LISTS OF LISTS OF PAIRS !
     !---------------------------------------------------!

     ! Create a new list 'new_liste' of 'M' lists, each of size 'N'
     Subroutine ListePairSet_new(M, N, new_liste)

       Integer(iprec), INTENT(IN) :: M,N
       Type(ListePairSet), INTENT(INOUT) :: new_liste
       Integer(iprec) :: i

       Nullify(new_liste%liste)
       Allocate(new_liste%liste(M),new_liste%size_tiling(M))
       Do i=1,M
          new_liste%size_tiling(i)=N
          Call PairSet_new(N, new_liste%liste(i))
       End Do

     End Subroutine ListePairSet_new

     ! Add a pair 'new_pair' to a list of lists 'new_liste' at the position
     ! 'pair_index' of list number 'tiling_number'
     Subroutine ListePairSet_add_to_tilings(new_pair, new_liste, tiling_number, pair_index)

       Integer(iprec), INTENT(IN) :: tiling_number,pair_index
       Type(ListePairSet), INTENT(INOUT) :: new_liste
       Type(Pair), INTENT(IN) :: new_pair

       new_liste%liste(tiling_number)%pair_vector(pair_index) = new_pair

     End Subroutine ListePairSet_add_to_tilings

     ! Test whether a pair 'new_pair' is anywhere in the list number
     ! 'tiling_number' (of size 'N') of the list of list 'new_liste'
     Logical Function ListePairSet_find_pair(N, new_pair, new_liste, tiling_number)

       Integer(iprec), INTENT(IN) :: N,tiling_number
       Type(ListePairSet), INTENT(IN) :: new_liste
       Type(Pair), INTENT(IN) :: new_pair
       Integer(iprec) :: i,mu0,nu0
       Integer(iprec), Allocatable :: mu(:),nu(:)

       ListePairSet_find_pair = .False.

       Allocate(mu(1:N),nu(1:N))
       Do i=1,N
          mu(i)=new_liste%liste(tiling_number)%pair_vector(i)%mu
          nu(i)=new_liste%liste(tiling_number)%pair_vector(i)%nu
       End Do
       mu0=new_pair%mu; nu0=new_pair%nu

       Do i=1,N
          If((mu0.Eq.mu(i).And.nu0.Eq.nu(i)).Or.(nu0.Eq.mu(i).And.mu0.Eq.nu(i))) Then
              ListePairSet_find_pair = .True.
              Exit
          End If
       End do
       Deallocate(mu,nu)

     End Function ListePairSet_find_pair

     ! Print the list (of size 'M') of lists of pairs (of size 'N' each)
     ! 'new_liste'
     Subroutine ListePairSet_print(M, new_liste)

       Integer(iprec), INTENT(IN) :: M
       Type(ListePairSet), INTENT(INOUT) :: new_liste
       Integer(iprec) :: i,Nact

       Do i=1,M
          Nact = new_liste%size_tiling(i)
          Write(6,'("Tiling number ",i10," of size ",i10)') i,Nact
          Call PairSet_print(Nact, new_liste%liste(i))
       End Do

     End Subroutine ListePairSet_print

     ! Remove a list of 'M' list of pairs 'new_liste'
     Subroutine ListePairSet_del(M, new_liste)

       Integer(iprec), INTENT(IN) :: M
       Type(ListePairSet), INTENT(INOUT) :: new_liste
       Integer(iprec) :: i

       Do i=1,M
          Call PairSet_del(new_liste%liste(i))
       End Do
       Nullify(new_liste%liste)
       Nullify(new_liste%size_tiling)

     End Subroutine ListePairSet_del

 End Module pair_definition

 !------------------------------------------------------------------------------!
 !                                                                              !
 !   Module defining various derived types related to pairs, lists of pairs     !
 !   and lists of lists of pairs, as well as the routines needed to manipulate  !
 !   these objects.                                                             !
 !                                                                              !
 !------------------------------------------------------------------------------!

 Module tilings_utilities

     Use pair_definition

     Implicit None

     Logical :: debug_pair = .False.

 Contains

     !--------------------------------------------------------------------------!
     !  This subroutine takes as input a list 'tilings' of 'M' lists of pairs   !
     !  of N' elements and remove all duplicates. It returns the new list in    !
     !  the variable 'tilings_unique'.                                          !
     !--------------------------------------------------------------------------!
     Subroutine tilings_remove_duplicates(N, M, different, tilings, tilings_unique)

       Integer(iprec), INTENT(INOUT) :: N,M,different
       Type(ListePairSet), INTENT(INOUT) :: tilings,tilings_unique

       Integer(iprec) :: i,j,equals,unique,Nact
       Integer(iprec), Allocatable :: duplicate(:)

       Type(PairSet) :: new_pair_vector_1,new_pair_vector_2

       ! Counting the number of duplicate tilings
       Allocate(duplicate(1:M)); duplicate(:)=0

       Call PairSet_new(N, new_pair_vector_1)
       Call PairSet_new(N, new_pair_vector_2)

       equals=0
       Do i=1,M
          new_pair_vector_1 = tilings%liste(i)
          Do j=i+1,M
             new_pair_vector_2 = tilings%liste(j)
             If(PairSet_equal(N, new_pair_vector_1, N, new_pair_vector_2).And.duplicate(j).Eq.0) Then
                duplicate(j)=1
                equals=equals+1
                Exit
             End If
          End Do
       End Do
       If(debug_pair) Then
          Write(6,'("In tilings_remove_duplicates() - Total number of tilings: ",i12)') M
          Write(6,'("In tilings_remove_duplicates() - Number of equal tilings: ",i12)') equals
       End If

       ! Retaining only the unique mappings
       unique = M - equals

       Call ListePairSet_new(unique, N, tilings_unique)

       different=0
       Do i=1,M
          If(duplicate(i).eq.0) Then
             different=different+1
             Nact = PairSet_size(N, tilings%liste(i))
             tilings_unique%liste(different)%pair_vector = tilings%liste(i)%pair_vector
             tilings_unique%size_tiling(different) = Nact
          End If
       End Do

       ! Cleanly deallocating space
       Nullify(new_pair_vector_1%pair_vector)

       Deallocate(duplicate)

     End Subroutine tilings_remove_duplicates

     !--------------------------------------------------------------------------!
     !  This subroutine creates a list of list of pairs 'mapping' based on the  !
     !  list of pairs 'new_pair_vector' of size 'N'                             !
     !--------------------------------------------------------------------------!
     Subroutine tilings_find_all(N, M, tilings, new_pair_vector)

        Integer(iprec), INTENT(INOUT) :: N, M
        Type(PairSet), INTENT(INOUT) :: new_pair_vector
        Type(ListePairSet), INTENT(INOUT) :: tilings

        Logical :: duplicates
        Integer(iprec) :: i,j,k,q,tiling_number,mu,nu,Ncur,Norig,pair_index,Nact,a,b,Nmax
        Integer(iprec), Allocatable :: vec1_mu(:),vec1_nu(:),vec_mu(:),vec_nu(:),itaken(:)
        Type(Pair) :: p

        tiling_number=0; Norig=N

        Allocate(vec_mu(Norig),vec_nu(Norig))
        Nmax=0 ! Maximum integer in the list
        Do q=1,Norig
           vec_mu(q) = new_pair_vector%pair_vector(q)%mu
           vec_nu(q) = new_pair_vector%pair_vector(q)%nu
           If(vec_mu(q).Ge.Nmax) Nmax=vec_mu(q)
           If(vec_nu(q).Ge.Nmax) Nmax=vec_nu(q)
        End Do

        Do i=1,Norig

           ! Reset original list of pairs
           Call PairSet_del(new_pair_vector)
           Call PairSet_new(Norig, new_pair_vector)
           Do q=1,Norig
              new_pair_vector%pair_vector(q)%mu = vec_mu(q)
              new_pair_vector%pair_vector(q)%nu = vec_nu(q)
           End Do

           ! Consider pair number i in the list
           p=new_pair_vector%pair_vector(i)
           mu=p%mu; nu=p%nu

           ! This will define a new tiling: we increment the tiling index and
           ! reset the pair index within this tiling
           tiling_number=tiling_number+1
           pair_index=1

           ! Add current pair to the new tiling
           Call ListePairSet_add_to_tilings(p, tilings, tiling_number, pair_index)

           ! Remove all indices involved in current pair from current list
           Ncur=Norig
           Call PairSet_remove(Ncur, new_pair_vector, mu, nu)

           ! Save resulting list of pairs
           Allocate(vec1_mu(Ncur),vec1_nu(Ncur))
           Do q=1,Ncur
              vec1_mu(q)=new_pair_vector%pair_vector(q)%mu
              vec1_nu(q)=new_pair_vector%pair_vector(q)%nu
           End Do

           ! Check if there are duplicates in the new list, i.e. indices that
           ! are repeated in more than one pair. Ex.: In [(2,3),(2,4),(5,7)],
           ! index 2 is repeated in 2 different pairs: there are duplicates.
           Allocate(itaken(1:Nmax)); itaken(:)=0
           duplicates = .False.
           Do j=1,Ncur
              a=new_pair_vector%pair_vector(j)%mu
              b=new_pair_vector%pair_vector(j)%nu
              itaken(a)=itaken(a)+1
              itaken(b)=itaken(b)+1
              if(itaken(a).Gt.1.or.itaken(b).gt.1) duplicates = .True.
           End Do
           Deallocate(itaken)

           ! The presence of duplicates means that there are more than one
           ! possible tiling associated with the current list: we will scan the
           ! list to identify all such tilings
           If(duplicates) Then
              Nact=Ncur
           Else
              Nact=1
           End If

           j=1
           Do While (j<=Nact)

              ! Move to position j of current list
              k=j; N=Ncur

              ! We identify all unique pairs in the current list, eliminating
              ! them as we proceed
              Do While (k<=N)

                 ! Take pair at position j (k=j at the beginning of this loop)
                 a=new_pair_vector%pair_vector(k)%mu
                 b=new_pair_vector%pair_vector(k)%nu

                 ! If the current pair is not already in the current tiling, we
                 ! add it to it and remove the corresponding indices from the
                 ! list
                 If(.Not.ListePairSet_find_pair(N,new_pair_vector%pair_vector(k),tilings,tiling_number)) Then
                    pair_index=pair_index+1
                    Call ListePairSet_add_to_tilings(new_pair_vector%pair_vector(k), tilings, tiling_number, pair_index)
                    Call PairSet_remove(N, new_pair_vector, a, b)
                 Else
                 ! If the current pair has already been included, we move to the
                 ! next element of the list
                    k=k+1
                 End If

              End Do
              tilings%size_tiling(tiling_number) = pair_index

              ! We restore the list (which has been emptied just before) with
              ! its original content
              Call PairSet_del(new_pair_vector)
              Call PairSet_new(Ncur, new_pair_vector)
              Do q=1,Ncur
                 new_pair_vector%pair_vector(q)%mu = vec1_mu(q)
                 new_pair_vector%pair_vector(q)%nu = vec1_nu(q)
              End Do

              ! Go one step further down the list
              j=j+1

              ! If there are duplicates, we will try to find the next tiling: we
              ! increment the tiling index and reset the pair index
              If(duplicates.and.j<=Nact) Then
                 tiling_number=tiling_number+1
                 pair_index=1
                 Call ListePairSet_add_to_tilings(p, tilings, tiling_number, pair_index)
              End If

           End Do ! end j

           Deallocate(vec1_mu,vec1_nu)

        End Do ! end i

        Deallocate(vec_mu,vec_nu)

        N = Norig
        M = tiling_number

     End Subroutine tilings_find_all

 End Module tilings_utilities

 !***********************************************************************
 !
 !    Copyright (c) 2015, Lawrence Livermore National Security, LLC.
 !                        Produced at the Lawrence Livermore National
 !                        Laboratory.
 !                        Written by Nicolas Schunck, schunck1@llnl.gov
 !
 !    LLNL-CODE-470611 All rights reserved.
 !
 !    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
 !                    W. Satula, J.A. Sheikh, A. Staszczak,
 !                    M. Stoitsov, P. Toivanen
 !    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
 !                    P. Olbratowski, P. Powalowski, M. Sadziak,
 !                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
 !                    M. Zalewski, H. Zdunczuk
 !    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
 !    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
 !
 !    This file is part of HFODD.
 !
 !    HFODD is free software: you can redistribute it and/or modify it
 !    under the terms of the GNU General Public License as published by
 !    the Free Software Foundation, either version 3 of the License, or
 !    (at your option) any later version.
 !
 !    HFODD is distributed in the hope that it will be useful, but
 !    WITHOUT ANY WARRANTY; without even the implied warranty of
 !    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 !    GNU General Public License for more details.
 !
 !    You should have received a copy of the GNU General Public License
 !    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
 !
 !    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
 !    LICENSE
 !
 !    Our Preamble Notice
 !
 !      A. This notice is required to be provided under our contract
 !         with the U.S. Department of Energy (DOE). This work was
 !         produced at the Lawrence Livermore National Laboratory under
 !         Contract No. DE-AC52-07NA27344 with the DOE.
 !      B. Neither the United States Government nor Lawrence Livermore
 !         National Security, LLC nor any of their employees, makes any
 !         warranty, express or implied, or assumes any liability or
 !         responsibility for the accuracy, completeness, or usefulness
 !         of any information, apparatus, product, or process disclosed,
 !         or represents that its use would not infringe privately-owned
 !         rights.
 !      C. Also, reference herein to any specific commercial products,
 !         process, or services by trade name, trademark, manufacturer
 !         or otherwise does not necessarily constitute or imply its
 !         endorsement, recommendation, or favoring by the United States
 !         Government or Lawrence Livermore National Security, LLC. The
 !         views and opinions of authors expressed herein do not
 !         necessarily state or reflect those of the United States
 !         Government or Lawrence Livermore National Security, LLC, and
 !         shall not be used for advertising or product endorsement
 !         purposes.
 !
 !    The precise terms and conditions for copying, distribution and
 !    modification are contained in the file COPYING.
 !
 !***********************************************************************

 !----------------------------------------------------------------------!
 !                                                                      !
 !                HFBTHO interface for HFODD                            !
 !                                                                      !
 ! Authors: N., Schunck, ORNL, LLNL                                     !
 !                                                                      !
 ! This module reads the binary file produced by HFBTHO and passes the  !
 ! matrices of the p.h. and p.p. fields to HFODD (main code). Basis     !
 ! transformations (from cylindrical to cartesian coordinates, simplex  !
 ! basis) are performed in the main HFODD. 	                        !
 !                                                                      !
 !                          First included in official release v249k    !
 !                          Last modification: April 30, 2012           !
 !                                                                      !
 !----------------------------------------------------------------------!

      SUBROUTINE Set_version_hfodd_interface
      !
      USE hfodd_sizes
      !
      CHARACTER NAMMOD*16
      INTEGER   MODUVE,MODSET
      !
      COMMON /VERMOD/ NAMMOD(NDMODU),MODUVE(NDMODU),MODSET(NDMODU)
      !
      NAMMOD(4) = 'hfodd_interface '
      MODUVE(4) = 5
      MODSET(4) = 4
      !
      END SUBROUTINE Set_version_hfodd_interface
      !
 Module hfodd_interface

   Implicit None

   Integer, Parameter :: inik=Kind(1), dnik=Kind(1.0)

   ! PUBLIC VARIABLES (PASSED TO/FROM, AND USED IN HFODD)
   Integer(inik), PUBLIC :: NmxTHO,NsizeHFBTHO,NsizeHFODD,maxLambda,ntx_tho,nnm_tho,nt_tho
   Integer(inik), PUBLIC :: nhhdim_tho,nhhdim2_tho,nhhdim3_tho,nhhdim4_tho
   Integer(inik), Allocatable, PUBLIC :: id_tho(:),nl_tho(:),ns_tho(:),Sigma2(:)
   Integer(inik), Allocatable, PUBLIC :: Nm_tho(:),nz_tho(:),nr_tho(:),ml_tho(:)
   Integer(inik), Allocatable, PUBLIC :: Nm_odd(:),nz_odd(:),nr_odd(:),ml_odd(:)
   Integer(inik), Allocatable, PUBLIC :: validate_HFBTHO(:,:,:,:),index_HFBTHO(:,:,:,:,:),index_HFODD(:,:,:,:,:)
   !
   Real(dnik), Allocatable, PUBLIC :: xmultLag(:),brin_tho(:)
   !
   Complex(dnik), Allocatable, PUBLIC :: HF_PHN(:, :, :, :),HF_PHP(:, :, :, :),HF_PPN(:, :, :, :),HF_PPP(:, :, :, :)
   !
   Real(dnik), Allocatable, PUBLIC :: THOPHN(:, :),THOPHP(:, :),THOPPN(:, :),THOPPP(:, :)

   ! PRIVATE VARIABLES
   Real(dnik) :: zero = 0.0_dnik, one=1.0_dnik, two = 2.0_dnik, half = 0.5_dnik
   Integer(inik), PRIVATE :: nbx_tho,nzx_tho,nrx_tho,nlx_tho,ndx_tho,nb_tho,nom_tho
   Integer(inik), Allocatable, PRIVATE :: npar_tho(:),ia_tho(:),ikb_tho(:),ipb_tho(:)

 Contains
   !==========================================================================================================
   !
   !==========================================================================================================
   Subroutine ReadHFBTHO(EFERMN,EFERMP,EFER2N,EFER2P,DELTAN,DELTAP,&
                         PRHO_N,PRHODN,PRHOSN,POWERN,PRHO_P,PRHODP,&
                         PRHOSP,POWERP,BETTHO,N00THO,NLIMIT,FILTHO,&
                         B0_THO,BZ_THO,BP_THO)
      ! Inputs/outputs
      Character(12) :: FILTHO
      Integer :: N00THO,NLIMIT
      Real(dnik) :: EFERMN,EFERMP,EFER2N,EFER2P,DELTAN,DELTAP
      Real(dnik) :: PRHO_N,PRHODN,PRHOSN,POWERN,PRHO_P,PRHODP,PRHOSP,POWERP
      Real(dnik) :: BETTHO,B0_THO,BZ_THO,BP_THO
      ! From HFBTHO
      Integer(inik) :: it,bloall1,kindhfb,itass,iqqmax,ilst1,l,ierr,counter
      Integer(inik) :: npr11,npr1,ngh1,ngl1,n001,nb1,nt1
      Integer(inik) :: i,ibasis,ibro,ib,nd,n1,n2,n1n2,n2n1,N_rz
      Integer(inik) :: nb,nbx,ntx,ndx,nqx,nb2x,nhhdim,nhhdim2,nhhdim3,nhhdim4
      Integer(inik) :: npr(2)      ! number of neutrons (1) protons (2)
      Integer(inik) :: lwin = 41   ! number of the unformated input unit
      Character(2)  :: nucname     ! name of the nucleus
      Character(30) :: welfile     ! name of the file e.g. 's070_050.hel'
      Real(dnik) :: b0,bz,bp,beta0,bet,v0(2),v1,dalf,pwi,amas,pi
      Real(dnik) :: si,etot,xmix,varmas,skass,tz(2)
      Real(dnik) :: decay,rmm3,amm3,bmm3,cmm3
      Real(dnik) :: varmasnz(2),pjmassnz(2),ass(2)
      Real(dnik) :: rms(3),ept(3),del(2),ala(2),ala2(2),alast(2)
      Real(dnik), Allocatable :: brin(:)
      Integer(inik) :: iblocking,bloall; Parameter(bloall = 200)
      Integer(inik), Dimension(0:bloall,2) :: bloblo,blo123=0,blok1k2=0
      Real(dnik),    Dimension(0:bloall,2) :: bloqpdif
      Integer(inik), Dimension(3) :: keyblo
      Integer(inik), Dimension(2) :: blocross,blomax,blo123d,blok1k2d,blocanon
      ! Local variables
      Logical :: file_exists,file_opened
      Integer(inik), Allocatable :: id(:),Omega2(:),Parity(:)
      Integer(inik) :: N, nr, nz, ml, ms, mj, lambda_max, mpi_rank, mpi_err
      Integer(inik) :: IndexBra, IndexKet, IndexStart
      Integer(inik) :: Indexx, Nperpe, i_spin, j_spin, icount, j, ms_actual, i2
      !---------------------------------------------------------------------!
      !  This subroutine reads .hel files generated by HFBTHO. Basically,   !
      !  it is a variation of subroutine inout() of HFBTHO. Differences are !
      !  that a number of variables are passed in the header of the routine !
      !  and overwrite previous HFODD definitions.                          !
      !---------------------------------------------------------------------!
      welfile=TRIM(FILTHO)
      file_exists=.False.; inquire(file=welfile, exist=file_exists); ierr=0
      If(file_exists) Then
         file_opened=.False.; inquire(unit=lwin, opened=file_opened)
         If(file_opened) Then
            Close(lwin)
         Else
         End If
         Open(lwin,file=welfile,status='old',form='unformatted',IOSTAT=ierr)
         If(ierr.NE.0) Then
            Write(6,'("The file ",a30," could not be opened!")') welfile
            Stop 'welfile could not be opened!'
         End If
      Else
         Stop 'welfile does not exist!'
      End If
      !---------------------------------------------------------------------
      ! open and read input file 'welfile' if exists
      !---------------------------------------------------------------------
      Read(lwin,Err=100,End=100)  npr11,npr1,ngh1,ngl1,n001,nb1,nt1
      Read(lwin,Err=100,End=100)  b0,bz,bp,beta0,si,etot,rms,bet,xmix,v0,v1,dalf,pwi,del,ept, &
                                  ala,ala2,alast,tz,varmas,varmasNZ,pjmassNZ,ass,skass
      Read(lwin,Err=100,End=100)  ntx,nb,nhhdim
      NLIMIT=ntx; nbx=nb; nhhdim2=2*nhhdim; nhhdim3=3*nhhdim; nhhdim4=4*nhhdim
      Read(lwin,Err=100,End=100) lambda_max; maxLambda=lambda_max
      !
      Allocate(xmultLag(maxLambda)); Allocate(id(nb),brin(nhhdim4+maxLambda))
      !
      Read(lwin,Err=100,End=100) xmultLag
      Read(lwin,Err=100,End=100) id
      Read(lwin,Err=100,End=100) brin
      !---------------------------------------------------------------------
      ! First batch of variable assignment
      !---------------------------------------------------------------------
      BETTHO=beta0; B0_THO=b0; BZ_THO=bz; BP_THO=bp
      ! pairing forces
      PRHO_N=v0(1); PRHODN=zero; PRHOSN=0.32d0; POWERN=one
      PRHO_P=v0(2); PRHODP=zero; PRHOSP=0.32d0; POWERP=one
      ! pairing properties
      EFERMN=ala(1); EFERMP=ala(2); EFER2N=ala2(1); EFER2P=ala2(2); DELTAN=del(1); DELTAP=del(2)
      ! Sizes
      ndx=MaxVal(id); nqx=ndx*ndx; nb2x=nbx+nbx
      !
      ! Array allocations
      If(Allocated(Omega2)) Deallocate(Omega2,Parity); Allocate(Omega2(ntx),Parity(ntx))
      If(Allocated(Nm_tho)) Deallocate(Nm_tho,nz_tho,nr_tho)
      Allocate(Nm_tho(ntx),nz_tho(ntx),nr_tho(ntx),ml_tho(ntx),Sigma2(ntx))
      If(Allocated(THOPHN)) Deallocate(THOPHN,THOPHP,THOPPN,THOPPP)
      Allocate(THOPHN(1:ntx,1:ntx)); THOPHN = zero; Allocate(THOPHP(1:ntx,1:ntx)); THOPHP = zero
      Allocate(THOPPN(1:ntx,1:ntx)); THOPPN = zero; Allocate(THOPPP(1:ntx,1:ntx)); THOPPP = zero
      !---------------------------------------------------------------------
      ! Quantum Number: {nr, nz, Lambda, Omega}
      !
      ! N = 2nr + Lambda + nz
      ! Omega = Lambda + Sigma
      !
      ! Restrictions: - Omega > 0 only
      !               - ms = +/- 1 (both spin projections)
      !---------------------------------------------------------------------
      ibasis=0; ibro=0; IndexStart = 1; NmxTHO=-1; counter = 0
      Do ib=1,NB
         ND=id(ib); i=ibro
         Do N1=1,ND
            ibasis=ibasis+1; IndexBra = ibasis
            ! read and assign quantum numbers for HO basis
            Read(lwin,Err=100,End=100) Omega2(ibasis), Parity(ibasis), Nm_tho(ibasis), &
                                       nz_tho(ibasis), ml_tho(ibasis)
            If (Nm_tho(ibasis).GT. NmxTHO) NmxTHO=Nm_tho(ibasis)
            nr_tho(ibasis) = (Nm_tho(ibasis) - nz_tho(ibasis) - ml_tho(ibasis))/2
            Sigma2(ibasis) =  Omega2(ibasis) - 2*ml_tho(ibasis)
            Do N2=1,N1
               IndexKet = IndexStart + N2 - 1
               i=i+1; n1n2 = n1+(n2-1)*nd; n2n1 = n2+(n1-1)*nd
               ! Assign mean-field and pairing fields for protons and neutrons
               THOPHN(IndexBra,IndexKet) = brin(i)
               THOPHP(IndexBra,IndexKet) = brin(i+nhhdim)
               THOPPN(IndexBra,IndexKet) = brin(i+nhhdim2)
               THOPPP(IndexBra,IndexKet) = brin(i+nhhdim3)
               ! Both fields are symmetric
               THOPHN(IndexKet,IndexBra) = brin(i)
               THOPHP(IndexKet,IndexBra) = brin(i+nhhdim)
               THOPPN(IndexKet,IndexBra) = brin(i+nhhdim2)
               THOPPP(IndexKet,IndexBra) = brin(i+nhhdim3)
            End Do !N2
         End Do !N1
         ibro=i
         !  Starting index of the current block
         IndexStart = IndexStart + ND
      End Do !IB
      !---------------------------------------------------------------------
      ! Test compatibility of sizes
      !---------------------------------------------------------------------
      NsizeHFBTHO = ibasis
      ! If the basis is oblate, numbers of quanta in the x- and y-direction in HFODD
      ! must be updated
      If(beta0 .Le. 0.0d0) N00THO=NmxTHO
      If(NsizeHFBTHO .Ne. ntx) THEN
         Write(6,'(''NsizeHFBTHO = '',i6,'' ntx = '',i6)') NsizeHFBTHO, ntx
         Stop 'Error (3) in HFBTHO_HFBODD'
      End If
      !---------------------------------------------------------------------
      ! Read and set blocking quantities
      !---------------------------------------------------------------------
      Read(lwin,Err=100,End=100)  bloall1
      Read(lwin,Err=100,End=100)  bloblo,blo123,blok1k2,blomax,bloqpdif
      If(npr11.Eq.2*(npr11/2).And.npr1.Eq.2*(npr1/2)) blomax=0
      If(bloall1.Ne.bloall) go to 100
      !---------------------------------------------------------------------
      ! Close file
      !---------------------------------------------------------------------
      Close(lwin)
      Go To 200
      !---------------------------------------------------------------------
      ! If file is corrupted, arrive here, and close file
      !---------------------------------------------------------------------
100   Continue
      Close(lwin)
      Write(6,'("The file ",a30," is corrupted, missing, or wrong!")') welfile
      Write(6,'("STARTING FROM SCRATCH WITH ININ=IABS(ININ)!")')
      If(Allocated(xmultLag)) Deallocate(xmultLag)
      If(Allocated(id))       Deallocate(id)
      If(Allocated(brin))     Deallocate(brin)
      If(Allocated(Omega2))   Deallocate(Omega2)
      If(Allocated(Parity))   Deallocate(Parity)
      Return
      !---------------------------------------------------------------------
      ! If file is OK, arrive here, deallocate and exit
      !---------------------------------------------------------------------
200   Continue
      Deallocate(id,brin); Deallocate(Omega2,Parity)
      !
   End Subroutine ReadHFBTHO
   !==========================================================================================================
   !
   !==========================================================================================================
   Subroutine FromHFBTHO(NDTRAN,NDSPIN)
      Integer :: NDTRAN,NDSPIN
      Integer(inik) :: N, nr, nr_hfbtho, nz, ml, ml_hfbtho, ms, i, AllocateStatus = 0
      Integer(inik) :: IndexBra_HFODD, IndexKet_HFODD, IndexBra_HFBTHO, IndexKet_HFBTHO
      Integer(inik) :: Nm_bra, nz_bra, nr_bra, la_bra, Nm_ket, nz_ket, nr_ket, la_ket, ms_bra, ms_ket
      Integer(inik) :: Indexx, Nperpe, counter
      !--------------------------------------------------------------------!
      !  This subroutine defines the HFB matrix in cylindrical coordinates !
      !  according to HFODD ordering convention, taking as input the HFB   !
      !  matrix read in ReadHFBTHO(). Since HFBTHO conserves time-reversal !
      !  symmetry while HFODD does not, cylindrical quantum numbers Lambda !
      !  and nrho can take different values in the two codes: States with  !
      !  -|Lambda| and +|Lambda| are degenerate in HFBTHO, and at restart  !
      !  they will also be degenerate in HFODD. Later in the iterations,   !
      !  time-reversal symmetry may be broken. The routine can handle      !
      !  deformed, or stretched, bases, provided the deformation is along  !
      !  the z-axis (only possible convention in HFBTHO).                  !
      !--------------------------------------------------------------------!
      !--------------------------------------------------------------------------
      ! Setting the correspondence between HFBTHO quantum numbers and global index
      !            N = 2*nr + nz + Lambda, Lambda = ml, Omega  = mj
      !               ms = 0 <=> SPIN DOWN ms = -1  (mj = ml + ms)
      !               ms = 1 <=> SPIN UP   ms = +1  (mj = ml + ms)
      !    HFB-THO ........: 0 <= nr <= Nperpe/2, 0 <= Lambda <= +Nperpe, step 1
      !    Quantum Number .: {N, nr, nz, Lambda}
      !    Restrictions ...: - All Omega
      !                   - NO spin projection at this time
      !--------------------------------------------------------------------------
      Allocate(index_HFBTHO(0:NmxTHO,0:NmxTHO,0:NmxTHO,0:NmxTHO,0:NDSPIN)); index_HFBTHO=0
      If(Allocated(validate_HFBTHO)) Deallocate(validate_HFBTHO)
      Allocate(validate_HFBTHO(0:NmxTHO,0:NmxTHO,0:NmxTHO,0:NmxTHO)); validate_HFBTHO=0
      Do i = 1, NsizeHFBTHO
         N  = Nm_tho(i)
         nz = nz_tho(i)
         nr = nr_tho(i)
         ml = ml_tho(i)
         ms = (Sigma2(i)+1)/2
         index_HFBTHO(N, nz, nr, ml, ms) = i
         validate_HFBTHO(N, nz, nr, ml) = 1
      End Do
      !--------------------------------------------------------------------------
      ! Setting the correspondence between HFODD quantum numbers and global index
      !            N = 2*nr + nz + Lambda, Lambda = ml, Omega  = mj
      !               ms = 0 <=> SPIN DOWN ms = -1  (mj = ml + ms)
      !               ms = 1 <=> SPIN UP   ms = +1  (mj = ml + ms)
      !    HFODD ..........: 0 <= nr <= Nperpe,  -Nperpe <= Lambda <= +Nperpe, step 2
      !    Quantum Number .: {N, nr, nz, Lambda}
      !    Restrictions ...: - All Omega
      !                      - NO spin projection at this time
      !--------------------------------------------------------------------------
      ! Computing the size of the HFODD matrices
      Indexx = 0
      Do N = 0, NmxTHO
         Do nz = 0, NmxTHO
            Nperpe = N - nz
            Do nr = 0, Nperpe
                                    nr_hfbtho = nr
               If(nr .GT. Nperpe/2) nr_hfbtho = Nperpe - nr
               ml_hfbtho = Abs(Nperpe - 2*nr)
               ! selecting only those states which have been effectively used in HFBTHO
               If(validate_HFBTHO(N, nz, nr_hfbtho, ml_hfbtho) .Eq. 1) Then
                  Indexx = Indexx + 1
               End If
            End Do
         End Do
      End Do
      NsizeHFODD = Indexx
      ! Allocating memory for HFODD vectors of cylindrical quantum numbers
      Allocate(Nm_odd(1:NsizeHFODD),nz_odd(1:NsizeHFODD),nr_odd(1:NsizeHFODD),ml_odd(1:NsizeHFODD))
      ! Defining cylindrical quantum numbers according to HFODD convention
      Indexx = 0
      Do N = 0, NmxTHO
         Do nz = 0, NmxTHO
            Nperpe = N - nz
            Do nr = 0, Nperpe
               ml = Nperpe - 2*nr
                                    nr_hfbtho = nr
               If(nr .Gt. Nperpe/2) nr_hfbtho = Nperpe - nr
               ml_hfbtho = Abs(ml)
               If(validate_HFBTHO(N, nz, nr_hfbtho, ml_hfbtho) .Eq. 1) Then
                  Indexx = Indexx + 1
                  Nm_odd(Indexx) = N
                  nz_odd(Indexx) = nz
                  nr_odd(Indexx) = nr
                  ml_odd(Indexx) = ml
               End If
            End Do
         End Do
      End Do
      !--------------------------------------------------------------------------
      ! Allocating memory for the HFB matrix (mean-field: HF_PHN, HF_PHP,
      ! pairing: HF_PPN, HF_PPP) coming from HFBTHO
      !--------------------------------------------------------------------------
      Allocate(HF_PHN(1:NDTRAN,1:NDTRAN,0:NDSPIN,0:NDSPIN),STAT=AllocateStatus)
      If(AllocateStatus /= 0) Then
          Write(6,'("Error in Allocating HF_PHN")')
          Stop 'Error in Allocating HF_PHN - Routine FromHFBTHO in hfodd_interface.f90'
      End If
      HF_PHN = Cmplx(zero,zero)
      Do ms_ket = 0, 1
         Do ms_bra = 0, 1
            !
            Do IndexKet_HFODD = 1, NsizeHFODD
               Nm_ket = Nm_odd(IndexKet_HFODD)
               nz_ket = nz_odd(IndexKet_HFODD)
               Nperpe = Nm_ket - nz_ket
               nr_ket = nr_odd(IndexKet_HFODD)
               la_ket = ml_odd(IndexKet_HFODD)
               ! reset nr_ket to HFBTHO convention
               If(nr_ket .GT. Nperpe/2) Then
                  nr_ket =  Nperpe - nr_ket
                  ms = 1 - ms_ket
               Else
                  ms = ms_ket
               End If
               If(la_ket .EQ. 0 .AND. ms .EQ. 0) Then
                  IndexKet_HFBTHO = index_HFBTHO(Nm_ket, nz_ket, nr_ket, Abs(la_ket), 1)
               Else
                  IndexKet_HFBTHO = index_HFBTHO(Nm_ket, nz_ket, nr_ket, Abs(la_ket), ms)
               End If
               !
               Do IndexBra_HFODD = 1, NsizeHFODD
                  Nm_bra = Nm_odd(IndexBra_HFODD)
                  nz_bra = nz_odd(IndexBra_HFODD)
                  Nperpe = Nm_bra - nz_bra
                  nr_bra = nr_odd(IndexBra_HFODD)
                  la_bra = ml_odd(IndexBra_HFODD)
                  ! reset nr_bra to HFBTHO convention
                  If(nr_bra .GT. Nperpe/2) Then
                     nr_bra =  Nperpe - nr_bra
                     ms = 1 - ms_bra
                  Else
                     ms = ms_bra
                  End If
                  If(la_bra .EQ. 0 .AND. ms .EQ. 0) Then
                     IndexBra_HFBTHO = index_HFBTHO(Nm_bra, nz_bra, nr_bra, Abs(la_bra), 1)
                  Else
                     IndexBra_HFBTHO = index_HFBTHO(Nm_bra, nz_bra, nr_bra, Abs(la_bra), ms)
                  End If
                  !
                  If(IndexBra_HFBTHO .GT. 0 .And. IndexKet_HFBTHO .GT. 0) Then
                     HF_PHN(IndexBra_HFODD, IndexKet_HFODD, ms_bra, ms_ket) = Cmplx(THOPHN(IndexBra_HFBTHO, IndexKet_HFBTHO),0.0_dnik)
                 End If
                  !
               End Do
            End Do
            !
         End Do
      End Do
      Deallocate(THOPHN)
      !--------------------------------------------------------------------------
      ! Transfering the matrix elements of the HFB matrix from HFBTHO to HFODD
      ! This implies: - different ordering of quantum numbers, i.e. different
      !                 index <-> q.n. convention
      !               - different cylindrical quantum numbers: Lambda >= 0 in
      !                 HFBTHO
      !--------------------------------------------------------------------------
      Allocate(HF_PHP(1:NDTRAN,1:NDTRAN,0:NDSPIN,0:NDSPIN),STAT=AllocateStatus)
      If(AllocateStatus /= 0) Then
          Write(6,'("Error in Allocating HF_PHP")')
          Stop 'Error in Allocating HF_PHP - Routine FromHFBTHO in hfodd_interface.f90'
      End If
      HF_PHP = Cmplx(zero,zero)
      Do ms_ket = 0, 1
         Do ms_bra = 0, 1
            !
            Do IndexKet_HFODD = 1, NsizeHFODD
               Nm_ket = Nm_odd(IndexKet_HFODD)
               nz_ket = nz_odd(IndexKet_HFODD)
               Nperpe = Nm_ket - nz_ket
               nr_ket = nr_odd(IndexKet_HFODD)
               la_ket = ml_odd(IndexKet_HFODD)
               ! reset nr_ket to HFBTHO convention
               If(nr_ket .GT. Nperpe/2) Then
                  nr_ket =  Nperpe - nr_ket
                  ms = 1 - ms_ket
               Else
                  ms = ms_ket
               End If
               If(la_ket .EQ. 0 .AND. ms .EQ. 0) Then
                  IndexKet_HFBTHO = index_HFBTHO(Nm_ket, nz_ket, nr_ket, Abs(la_ket), 1)
               Else
                  IndexKet_HFBTHO = index_HFBTHO(Nm_ket, nz_ket, nr_ket, Abs(la_ket), ms)
               End If
               !
               Do IndexBra_HFODD = 1, NsizeHFODD
                  Nm_bra = Nm_odd(IndexBra_HFODD)
                  nz_bra = nz_odd(IndexBra_HFODD)
                  Nperpe = Nm_bra - nz_bra
                  nr_bra = nr_odd(IndexBra_HFODD)
                  la_bra = ml_odd(IndexBra_HFODD)
                  ! reset nr_bra to HFBTHO convention
                  If(nr_bra .GT. Nperpe/2) Then
                     nr_bra =  Nperpe - nr_bra
                     ms = 1 - ms_bra
                  Else
                     ms = ms_bra
                  End If
                  If(la_bra .EQ. 0 .AND. ms .EQ. 0) Then
                     IndexBra_HFBTHO = index_HFBTHO(Nm_bra, nz_bra, nr_bra, Abs(la_bra), 1)
                  Else
                     IndexBra_HFBTHO = index_HFBTHO(Nm_bra, nz_bra, nr_bra, Abs(la_bra), ms)
                  End If
                  !
                  If(IndexBra_HFBTHO .GT. 0 .And. IndexKet_HFBTHO .GT. 0) Then
                     HF_PHP(IndexBra_HFODD, IndexKet_HFODD, ms_bra, ms_ket) = Cmplx(THOPHP(IndexBra_HFBTHO, IndexKet_HFBTHO),0.0_dnik)
                 End If
                  !
               End Do
            End Do
            !
         End Do
      End Do
      Deallocate(THOPHP)
      !--------------------------------------------------------------------------
      ! Transfering the matrix elements of the HFB matrix from HFBTHO to HFODD
      ! This implies: - different ordering of quantum numbers, i.e. different
      !                 index <-> q.n. convention
      !               - different cylindrical quantum numbers: Lambda >= 0 in
      !                 HFBTHO
      !--------------------------------------------------------------------------
      Allocate(HF_PPN(1:NDTRAN,1:NDTRAN,0:NDSPIN,0:NDSPIN),STAT=AllocateStatus)
      If(AllocateStatus /= 0) Then
          Write(6,'("Error in Allocating HF_PPN")')
          Stop 'Error in Allocating HF_PPN - Routine FromHFBTHO in hfodd_interface.f90'
      End If
      HF_PPN = Cmplx(zero,zero)
      Do ms_ket = 0, 1
         Do ms_bra = 0, 1
            !
            Do IndexKet_HFODD = 1, NsizeHFODD
               Nm_ket = Nm_odd(IndexKet_HFODD)
               nz_ket = nz_odd(IndexKet_HFODD)
               Nperpe = Nm_ket - nz_ket
               nr_ket = nr_odd(IndexKet_HFODD)
               la_ket = ml_odd(IndexKet_HFODD)
               ! reset nr_ket to HFBTHO convention
               If(nr_ket .GT. Nperpe/2) Then
                  nr_ket =  Nperpe - nr_ket
                  ms = 1 - ms_ket
               Else
                  ms = ms_ket
               End If
               If(la_ket .EQ. 0 .AND. ms .EQ. 0) Then
                  IndexKet_HFBTHO = index_HFBTHO(Nm_ket, nz_ket, nr_ket, Abs(la_ket), 1)
               Else
                  IndexKet_HFBTHO = index_HFBTHO(Nm_ket, nz_ket, nr_ket, Abs(la_ket), ms)
               End If
               !
               Do IndexBra_HFODD = 1, NsizeHFODD
                  Nm_bra = Nm_odd(IndexBra_HFODD)
                  nz_bra = nz_odd(IndexBra_HFODD)
                  Nperpe = Nm_bra - nz_bra
                  nr_bra = nr_odd(IndexBra_HFODD)
                  la_bra = ml_odd(IndexBra_HFODD)
                  ! reset nr_bra to HFBTHO convention
                  If(nr_bra .GT. Nperpe/2) Then
                     nr_bra =  Nperpe - nr_bra
                     ms = 1 - ms_bra
                  Else
                     ms = ms_bra
                  End If
                  If(la_bra .EQ. 0 .AND. ms .EQ. 0) Then
                     IndexBra_HFBTHO = index_HFBTHO(Nm_bra, nz_bra, nr_bra, Abs(la_bra), 1)
                  Else
                     IndexBra_HFBTHO = index_HFBTHO(Nm_bra, nz_bra, nr_bra, Abs(la_bra), ms)
                  End If
                  !
                  If(IndexBra_HFBTHO .GT. 0 .And. IndexKet_HFBTHO .GT. 0) Then
                     HF_PPN(IndexBra_HFODD, IndexKet_HFODD, ms_bra, ms_ket) = Cmplx(THOPPN(IndexBra_HFBTHO, IndexKet_HFBTHO),0.0_dnik)
                 End If
                  !
               End Do
            End Do
            !
         End Do
      End Do
      Deallocate(THOPPN)
      !--------------------------------------------------------------------------
      ! Transfering the matrix elements of the HFB matrix from HFBTHO to HFODD
      ! This implies: - different ordering of quantum numbers, i.e. different
      !                 index <-> q.n. convention
      !               - different cylindrical quantum numbers: Lambda >= 0 in
      !                 HFBTHO
      !--------------------------------------------------------------------------
      Allocate(HF_PPP(1:NDTRAN,1:NDTRAN,0:NDSPIN,0:NDSPIN),STAT=AllocateStatus)
      If(AllocateStatus /= 0) Then
          Write(6,'("Error in Allocating HF_PPP")')
          Stop 'Error in Allocating HF_PPP - Routine FromHFBTHO in hfodd_interface.f90'
      End If
      HF_PPP = Cmplx(zero,zero)
      Do ms_ket = 0, 1
         Do ms_bra = 0, 1
            !
            Do IndexKet_HFODD = 1, NsizeHFODD
               Nm_ket = Nm_odd(IndexKet_HFODD)
               nz_ket = nz_odd(IndexKet_HFODD)
               Nperpe = Nm_ket - nz_ket
               nr_ket = nr_odd(IndexKet_HFODD)
               la_ket = ml_odd(IndexKet_HFODD)
               ! reset nr_ket to HFBTHO convention
               If(nr_ket .GT. Nperpe/2) Then
                  nr_ket =  Nperpe - nr_ket
                  ms = 1 - ms_ket
               Else
                  ms = ms_ket
               End If
               If(la_ket .EQ. 0 .AND. ms .EQ. 0) Then
                  IndexKet_HFBTHO = index_HFBTHO(Nm_ket, nz_ket, nr_ket, Abs(la_ket), 1)
               Else
                  IndexKet_HFBTHO = index_HFBTHO(Nm_ket, nz_ket, nr_ket, Abs(la_ket), ms)
               End If
               !
               Do IndexBra_HFODD = 1, NsizeHFODD
                  Nm_bra = Nm_odd(IndexBra_HFODD)
                  nz_bra = nz_odd(IndexBra_HFODD)
                  Nperpe = Nm_bra - nz_bra
                  nr_bra = nr_odd(IndexBra_HFODD)
                  la_bra = ml_odd(IndexBra_HFODD)
                  ! reset nr_bra to HFBTHO convention
                  If(nr_bra .GT. Nperpe/2) Then
                     nr_bra =  Nperpe - nr_bra
                     ms = 1 - ms_bra
                  Else
                     ms = ms_bra
                  End If
                  If(la_bra .EQ. 0 .AND. ms .EQ. 0) Then
                     IndexBra_HFBTHO = index_HFBTHO(Nm_bra, nz_bra, nr_bra, Abs(la_bra), 1)
                  Else
                     IndexBra_HFBTHO = index_HFBTHO(Nm_bra, nz_bra, nr_bra, Abs(la_bra), ms)
                  End If
                  !
                  If(IndexBra_HFBTHO .GT. 0 .And. IndexKet_HFBTHO .GT. 0) Then
                     HF_PPP(IndexBra_HFODD, IndexKet_HFODD, ms_bra, ms_ket) = Cmplx(THOPPP(IndexBra_HFBTHO, IndexKet_HFBTHO),0.0_dnik)
                 End If
                  !
               End Do
            End Do
            !
         End Do
      End Do
      !--------------------------------------------------------------------------
      ! Deallocations
      !--------------------------------------------------------------------------
      Deallocate(index_HFBTHO)
      Deallocate(THOPPP)
      Deallocate(Nm_odd,nr_odd,nz_odd,ml_odd)
      Deallocate(Nm_tho,nr_tho,nz_tho,ml_tho,Sigma2)
   End Subroutine FromHFBTHO
   !==========================================================================================================
   !
   !==========================================================================================================
   Subroutine Basis_THO(N_UNIT,NDTRAN,NDSPIN,NOSCIL,BP_THO,BZ_THO,HPERPE,HPARAL,Parity,EBASECUT,hbzero)
      ! Inputs with type defined in HFODD
      Logical :: Parity
      Integer :: N_UNIT,NDTRAN,NDSPIN,NOSCIL
      Real(dnik) :: BP_THO,BZ_THO,HPERPE,HPARAL,EBASECUT,hbzero
      ! Local with type defined in module (in practice, it will be the
      ! same Real(dnik))
      Real(dnik) :: hbz,hbp,bz,bp,ee
      Integer(inik) :: nze,nre,ib,ilauf,jlauf,k,la,le,ip,ir,iz,il,is,nn,nd,IBX,n1,n2,iw, &
                       n00,n00max,ierror_flag,nlm,nzm,nrn,nqp,nuv,counter
      !--------------------------------------------------------------------!
      ! This subroutine defines the basis needed by HFBTHO based on input  !
      ! data from HFODD. It is needed to perform the inverse tranformation !
      ! HFODD -> HFBTHO and enable restarts with HFBTHO from HFODD record  !
      ! files.
      !--------------------------------------------------------------------!
      n00=NOSCIL; n00max=50; bp=BP_THO; bz=BZ_THO
      !-------------------------------------------------------------------------------
      ! Determine total number of K-blocks nbx, actual total number of states ntx
      !-------------------------------------------------------------------------------
      !hbz=two*hbzero/bz**2; hbp=two*hbzero/bp**2;
      hbz=HPARAL; hbp=HPERPE
      nze=n00; nre=n00max/2; ib=0; ilauf=0; nzm=0; nlm=0; nqp=0; nuv=0
      nom_tho=0; nzx_tho=0; nrx_tho=0; nlx_tho=0; nnm_tho=0
      ! loop over k-quantum number
      Do k=1,n00max+1
         la=k-1; le=min0(n00max,k)
         ! loop over parity
         If(.Not.Parity) jlauf=ilauf !Nop
         Do ip=1,2
            If(Parity) jlauf=ilauf !Yesp
            Do ir=0,nre
               Do iz=0,nze
                  Do il=la,le
                     Do is=+1,-1,-2
                        If (iz+2*ir+il.Gt.n00max)    Cycle
                        If (il+(is+1)/2.Ne.k)        Cycle
                        If (Mod(iz+il,2).Ne.ip-1)    Cycle
                        ee=hbz*(Real(iz)+half)+hbp*(two*Real(ir)+Real(il)+one)
                        If(ee.Lt.EBASECUT) Then
                           ilauf=ilauf+1
                           nzx_tho=Max(nzx_tho,iz);    nrx_tho=Max(nrx_tho,ir); nlx_tho=Max(nlx_tho,il)
                           nom_tho=Max(nom_tho,2*k-1); nnm_tho=Max(nnm_tho,iz+2*ir+il)
                        End If
                     End Do
                  End Do
               End Do
            End Do
            If(Parity) Then                !Yesp
               If (ilauf.Gt.jlauf) Then
                  ib=ib+1
                  nd=ilauf-jlauf
                  ndx_tho=Max(ndx_tho,nd)
                  nqp=nqp+nd; nuv=nuv+nd*nd
               End If
            End If
         End Do
         If(.Not.Parity) Then              !Nop
            If(ilauf.Gt.jlauf) Then
               ib=ib+1
               nd=ilauf-jlauf
               ndx_tho=Max(ndx_tho,nd)
               nqp=nqp+nd; nuv=nuv+nd*nd
            End If
         End If
      End Do
      nbx_tho=ib; ntx_tho=ilauf
      !-----------------------------------------------
      ! loop over k-quantum number
      !-----------------------------------------------
      Allocate(nz_tho(ntx_tho),nr_tho(ntx_tho),nl_tho(ntx_tho),ns_tho(ntx_tho),id_tho(nbx_tho),Nm_tho(ntx_tho))
      Allocate(npar_tho(ntx_tho),ia_tho(nbx_tho),ikb_tho(nbx_tho),ipb_tho(nbx_tho))
      ierror_flag=0; ib=0; ilauf=0
      Do k=1,n00max+1
         la=k-1; le=min0(n00max,k)
         ! loop over parity
         If(.Not.Parity) jlauf=ilauf !Nop
         Do ip=1,2
            If(Parity) jlauf=ilauf   !Yesp
            Do ir=0,nre
               Do iz=0,nze
                  Do il=la,le
                     Do is=+1,-1,-2
                        If(iz+2*ir+il.Gt.n00max) Cycle
                        If(il+(is+1)/2.Ne.k)     Cycle
                        If(Mod(iz+il,2).Ne.ip-1) Cycle
                        ee=hbz*(Real(iz)+half)+hbp*(two*Real(ir)+Real(il)+one)
                        If(ee.Lt.EBASECUT) Then
                           ilauf=ilauf+1
                           If (ilauf.Gt.ntx_tho) Then
                              ierror_flag=ierror_flag+1
                              !ierror_info(ierror_flag)='STOP: in base: ntx too small'
                              STOP 'in base: ntx too small'
                              Return
                           End If
                           nz_tho(ilauf)=iz; nr_tho(ilauf)=ir; nl_tho(ilauf)=il
                           ns_tho(ilauf)=is; npar_tho(ilauf)=ip
                           nn =iz+2*ir+il; Nm_tho(ilauf)=nn
                        End If
                     End Do
                  End Do
               End Do
            End Do
            !-----------------------------------------------
            ! Block memory
            !-----------------------------------------------
            If(Parity) Then                !Yesp
               If (ilauf.Gt.jlauf) Then
                  ib=ib+1
                  ia_tho(ib)=jlauf; id_tho(ib)=ilauf-jlauf
                  ikb_tho(ib)=k; ipb_tho(ib)=ip
               End If
               If(id_tho(ib).Eq.0) Then
                  ierror_flag=ierror_flag+1
                  !ierror_info(ierror_flag)='STOP: in base Block Memory(1)'
                  Stop 'in base Block Memory(1)'
                  Return
               End If
            End If
         End Do ! end of ip
         !-----------------------------------------------
         ! Block memory
         !-----------------------------------------------
         If(.Not.Parity) Then               !Nop
            If (ilauf.Gt.jlauf) Then
               ib=ib+1
               ia_tho(ib)=jlauf; id_tho(ib)=ilauf-jlauf
               nn = nz_tho(ilauf)+2*nr_tho(ilauf)+nl_tho(ilauf); ip = 2 - Mod(nn,2)
               ikb_tho(ib)=k; ipb_tho(ib)=ip
            End If
            If(id_tho(ib).Eq.0) Then
               ierror_flag=ierror_flag+1
               !ierror_info(ierror_flag)='STOP: in base Block Memory(2)'
               Return
            End If
         End If
      End Do ! end k
      nb_tho=ib;  nt_tho=ilauf
      !-----------------------------------------------
      ! broyden/linear mixing (storage)
      !-----------------------------------------------
      nhhdim_tho=0
      Do ib=1,nb_tho
         nd=id_tho(ib)
         Do n1=1,nd
            Do n2=1,n1
               nhhdim_tho=nhhdim_tho+1
            End Do
         End Do
      End Do
      nhhdim2_tho=2*nhhdim_tho; nhhdim3_tho=3*nhhdim_tho; nhhdim4_tho=4*nhhdim_tho
      !-----------------------------------------------
      ! print statistics
      !-----------------------------------------------
      Write(N_UNIT,'(a)')    '  Comparison with bookkeeping spherical basis:'
      Write(N_UNIT,'(a,i4)') '  maximal number of shells n00 ...: ',n00
      Write(N_UNIT,'(a,i4)') '  number of blocks: nb ...........: ',nb_tho
      Write(N_UNIT,'(a,i4)') '  number of levels: nt ...........: ',nt_tho
      Write(N_UNIT,'(a,i4)') '  maximal 2*omega : nom ..........: ',nom_tho
      Write(N_UNIT,'(a,i4)') '  maximal nz:       nzm ..........: ',nzx_tho
      Write(N_UNIT,'(a,i4)') '  maximal nr:       nrm ..........: ',nrx_tho
      Write(N_UNIT,'(a,i4)') '  maximal ml:       nlm ..........: ',nlx_tho
      Write(N_UNIT,'(a,i4)') '  2 x biggest block dim. .........: ',ndx_tho
      Write(N_UNIT,'(a,i6)') '  Nonzero elements of HH .........: ',nhhdim_tho
      Write(N_UNIT,'(a,i6)') '  Number Broyden elements ........: ',nhhdim4_tho
      Write(N_UNIT,'(a)')
      If(nzx_tho.Ge.n00max.Or.(nom_tho-1)/2.Eq.n00max) Then
         Write(*,*) 'nzm=',nzx_tho,'  (nom-1)/2=',(nom_tho-1)/2,'  n00max=',n00max
         ierror_flag=ierror_flag+1
         !ierror_info(ierror_flag)='STOP: Please increase n00max to have correct basis'
      End If
      Deallocate(npar_tho,ia_tho,ikb_tho,ipb_tho)
      !
   End Subroutine Basis_THO
   !==========================================================================================================
   !
   !==========================================================================================================
   Subroutine ToHFBTHO(NDTRAN,NDSPIN,NOSCIL,LDBASE,NOFCNS)
      ! Inputs with type defined in HFODD
      Integer :: NDTRAN,NDSPIN,NOSCIL,LDBASE,NOFCNS
      ! Local with type defined in module (in practice, it will be the
      ! same Real(dnik))
      Integer(inik) :: N, nr, nr_hfbtho, nz, ml, ml_hfbtho, ms, i, AllocateStatus = 0
      Integer(inik) :: ib,n1,n2,nd,ibro,ibasis,indexStart
      Integer(inik) :: IndexBra_HFODD, IndexKet_HFODD, IndexBra_HFBTHO, IndexKet_HFBTHO
      Integer(inik) :: Nm_bra, nz_bra, nr_bra, la_bra, Nm_ket, nz_ket, nr_ket, la_ket, ms_bra, ms_ket
      Integer(inik) :: Indexx, Nperpe,counter
      !--------------------------------------------------------------------!
      !  This subroutine defines the HFB matrix in cylindrical coordinates !
      !  according to HFBTHO ordering convention, taking as input the HFB  !
      !  matrix read in ReadHFBTHO(). Since HFBTHO conserves time-reversal !
      !  symmetry while HFODD does not, cylindrical quantum numbers Lambda !
      !  and nrho can take different values in the two codes: States with  !
      !  -|Lambda| and +|Lambda| are degenerate in HFBTHO, and at restart  !
      !  they will also be degenerate in HFODD. Later in the iterations,   !
      !  time-reversal symmetry may be broken. The routine can handle      !
      !  deformed, or stretched, bases, provided the deformation is along  !
      !  the z-axis (only possible convention in HFBTHO).                  !
      !--------------------------------------------------------------------!
      NsizeHFODD=LDBASE
      !--------------------------------------------------------------------------
      ! Setting the correspondence between HFODD quantum numbers and global index
      !            N = 2*nr + nz + Lambda, Lambda = ml, Omega  = mj
      !               ms = 0 <=> SPIN DOWN ms = -1  (mj = ml + ms)
      !               ms = 1 <=> SPIN UP   ms = +1  (mj = ml + ms)
      !    HFODD ..........: 0 <= nr <= Nperpe,  -Nperpe <= Lambda <= +Nperpe, step 2
      !    Quantum Number .: {N, nr, nz, Lambda}
      !    Restrictions ...: - All Omega
      !                      - NO spin projection at this time
      !--------------------------------------------------------------------------
      ! Allocating memory for HFODD vectors of cylindrical quantum numbers
      If(.NOT. Allocated(index_HFODD)) Allocate(index_HFODD(0:nnm_tho,0:nnm_tho,0:nnm_tho,0:nnm_tho,0:1))
      index_HFODD = 0
      ! Defining cylindrical quantum numbers according to HFODD convention
      Do ms_ket = 0, 1
         Indexx = 0
         Do N = 0, nnm_tho
            Do nz = 0, nnm_tho
               Nperpe = N - nz
               Do nr_ket = 0, Nperpe
                  !
                  If(nr_ket .GT. Nperpe/2) Then
                     nr = Nperpe - nr_ket
                     ms = ms_ket
                  Else
                     nr = nr_ket
                     ms = ms_ket
                  End If
                  ml = Nperpe - 2*nr
                  !
                  If(validate_HFBTHO(N, nz, nr, iabs(ml)).Eq.1) Then
                     Indexx = Indexx + 1
                     If(ml .EQ. 0 .AND. ms .EQ. 0) Then
                        index_HFODD(N, nz, nr, iabs(ml), 1) = Indexx
                     Else
                        index_HFODD(N, nz, nr, iabs(ml), ms) = Indexx
                     End If
                  End If
                  !
               End Do
            End Do
         End Do
      End Do
      !--------------------------------------------------------------------------
      ! Allocating memory for the HFB matrix (mean-field: THOPHN, THOPHP,
      ! pairing: THOPPN, THOPPP) coming from HFBTHO
      !--------------------------------------------------------------------------
      Allocate(THOPHN(1:ntx_tho,1:ntx_tho)); THOPHN=zero
      Allocate(THOPHP(1:ntx_tho,1:ntx_tho)); THOPHP=zero
      Allocate(THOPPN(1:ntx_tho,1:ntx_tho)); THOPPN=zero
      Allocate(THOPPP(1:ntx_tho,1:ntx_tho)); THOPPP=zero
      !--------------------------------------------------------------------------
      ! Transfering the matrix elements of the HFB matrix from HFODD to HFBTHO
      ! This implies: - different ordering of quantum numbers, i.e. different
      !                 index <-> q.n. convention
      !               - different cylindrical quantum numbers: Lambda >= 0 in
      !                 HFBTHO
      !--------------------------------------------------------------------------
      Do IndexKet_HFBTHO = 1, NsizeHFBTHO
         !
         Nm_ket = Nm_tho(IndexKet_HFBTHO)
         nz_ket = nz_tho(IndexKet_HFBTHO)
         nr_ket = nr_tho(IndexKet_HFBTHO)
         la_ket = nl_tho(IndexKet_HFBTHO)
         ms_ket = (1+ns_tho(IndexKet_HFBTHO))/2
         !
         IndexKet_HFODD = index_HFODD(Nm_ket, nz_ket, nr_ket, la_ket, ms_ket)
         !
         Do IndexBra_HFBTHO = 1, NsizeHFBTHO
            !
            Nm_bra = Nm_tho(IndexBra_HFBTHO)
            nz_bra = nz_tho(IndexBra_HFBTHO)
            nr_bra = nr_tho(IndexBra_HFBTHO)
            la_bra = nl_tho(IndexBra_HFBTHO)
            ms_bra = (1+ns_tho(IndexBra_HFBTHO))/2
            !
            IndexBra_HFODD = index_HFODD(Nm_bra, nz_bra, nr_bra, la_bra, ms_bra)
            !
            If(IndexBra_HFODD .GT. 0 .And. IndexKet_HFODD .GT. 0) Then
               THOPHN(IndexBra_HFBTHO, IndexKet_HFBTHO) = Real(HF_PHN(IndexBra_HFODD, IndexKet_HFODD, ms_bra, ms_ket))
               THOPHP(IndexBra_HFBTHO, IndexKet_HFBTHO) = Real(HF_PHP(IndexBra_HFODD, IndexKet_HFODD, ms_bra, ms_ket))
               THOPPN(IndexBra_HFBTHO, IndexKet_HFBTHO) = Real(HF_PPN(IndexBra_HFODD, IndexKet_HFODD, ms_bra, ms_ket))
               THOPPP(IndexBra_HFBTHO, IndexKet_HFBTHO) = Real(HF_PPP(IndexBra_HFODD, IndexKet_HFODD, ms_bra, ms_ket))
            End If
            !
         End Do
      End Do
      Deallocate(HF_PHN,HF_PHP,HF_PPN,HF_PPP)
      !--------------------------------------------------------------------------
      ! Fill out brin_tho vector
      !--------------------------------------------------------------------------
      If(.NOT. Allocated(brin_tho)) Allocate(brin_tho(1:nhhdim4_tho+8))
      ibasis=0; ibro=0; IndexStart = 1
      Do ib=1,nb_tho
         nd=id_tho(ib); i=ibro
         Do n1=1,nd
            ibasis=ibasis+1; IndexBra_HFBTHO = ibasis
            Do n2=1,n1
               IndexKet_HFBTHO = IndexStart + n2 - 1; i=i+1
               ! Assign mean-field and pairing fields for protons and neutrons
               brin_tho(i)             = THOPHN(IndexBra_HFBTHO,IndexKet_HFBTHO)
               brin_tho(i+nhhdim_tho)  = THOPHP(IndexBra_HFBTHO,IndexKet_HFBTHO)
               brin_tho(i+nhhdim2_tho) = THOPPN(IndexBra_HFBTHO,IndexKet_HFBTHO)
               brin_tho(i+nhhdim3_tho) = THOPPP(IndexBra_HFBTHO,IndexKet_HFBTHO)
            End Do !N2
         End Do !N1
         ibro=i
         IndexStart = IndexStart + nd
      End Do !IB
      Deallocate(THOPHN,THOPHP,THOPPN,THOPPP)
      !--------------------------------------------------------------------------
      ! Deallocations
      !--------------------------------------------------------------------------
      Deallocate(index_HFODD)
      ! Exit
   End Subroutine ToHFBTHO
   !=======================================================================
   !
   !=======================================================================
   Subroutine WriteHFBTHO(unit_tho,file_tho,n_tho,z_tho,NOSCIL,REFERN,REFERP, &
                         REDELN,REDELP,REFE2N,REFE2P,PRHO_N,PRHO_P,BZ_THO,BP_THO, &
                         beta0_THO,multLag)
      Implicit None
      ! From HFODD
      Integer :: unit_tho,z_tho,n_tho,NOSCIL
      Real(dnik) :: REFERN,REFERP,REDELN,REDELP,REFE2N,REFE2P,PRHO_N,PRHO_P,BZ_THO,BP_THO,beta0_THO
      Real(dnik) :: multLag(8)
      Character(12) :: file_tho
      ! Local
      Integer(inik)  :: l,n1,n2,nd,ib,nza,nra,nla,nsa,nlansa,ibasis,lambdaMax=8
      Integer(inik)  :: bloall; Parameter(bloall=200)
      Integer(inik)  :: bloblo(0:bloall,2),blo123(0:bloall,2),blok1k2(0:bloall,2),blomax(2)
      Real(dnik)     :: bloqpdif(0:bloall,2)
      Integer(inik)  :: npr1,npr11,ngh1,ngl1,n001,nt1,ntx1,nb1,nhhdim1
      Real(dnik)     :: b0,bz,bp,beta0,si,etot,rms(3),bet,xmix,CpV0(2),CpV1(2),pwi, &
                        del(2),ept(3),ala(2),ala2(2),alast(2),tz(2),varmas,   &
                        varmasNZ(2),pjmassNZ(2),ass(2),skass
      !---------------------------------------------------------------------
      ! Open 'FILTHO' file
      !---------------------------------------------------------------------
      Open(unit_tho,file=file_tho,status='unknown',form='unformatted')
      !---------------------------------------------------------------------
      ! Set everything to default value
      !---------------------------------------------------------------------
      npr11=n_tho; npr1=z_tho; ngh1=0; ngl1=0; n001=NOSCIL
      b0=zero; bz=BZ_THO; bp=BP_THO; beta0=beta0_THO; beta0=beta0_THO; si=one; etot=zero; rms=zero; bet=zero; xmix=0.3
      CpV0(1)=PRHO_N; CpV0(2)=PRHO_N; CpV1=(/0.5, 0.5/)
      pwi=2.0; del(1)=REDELN; del(2)=REDELP; ept=zero
      ala(1)=REFERN; ala(2)=REFERP; ala2(1)=REFE2N; ala2(2)=REFE2P; alast(1)=REFERN; alast(2)=REFERP
      tz=zero; varmas=zero;varmasNZ=zero; pjmassNZ=zero; ass=zero; skass=zero
      Do l=1,8
         brin_tho(nhhdim4_tho+l)=multLag(l)
      End Do
      !---------------------------------------------------------------------
      ! Write matrix elements to 'FILTHO' file
      !---------------------------------------------------------------------
      Write(unit_tho) npr11,npr1,ngh1,ngl1,n001,nbx_tho,ntx_tho
      Write(unit_tho) b0,bz,bp,beta0,si,etot,rms,bet,xmix,CpV0,CpV1,pwi,del,ept,  &
                      ala,ala2,alast,tz,varmas,varmasNZ,pjmassNZ,ass,skass
      Write(unit_tho) ntx_tho,nb_tho,nhhdim_tho
      Write(unit_tho) lambdaMax
      Write(unit_tho) multLag
      Write(unit_tho) id_tho
      Write(unit_tho) brin_tho
      ibasis=0
      Do ib=1,nb_tho
         nd=id_tho(ib)
         Do n1=1,nd
            ibasis=ibasis+1
            nla=nl_tho(ibasis); nra=nr_tho(ibasis); nza=nz_tho(ibasis); nsa=ns_tho(ibasis)
            nlansa=(-1)**(nza+nla)
            Write(unit_tho) 2*nla+nsa,nlansa,nza+2*nra+nla,nza,nla
         End Do
      End Do
      !---------------------------------------------------------------------
      ! blocking: sort blocking candidates first
      !---------------------------------------------------------------------
      bloblo=0; blo123=0; blok1k2=0; bloqpdif=0.0_dnik; blomax=0
      Write(unit_tho) bloall
      Write(unit_tho) bloblo,blo123,blok1k2,blomax,bloqpdif
      !---------------------------------------------------------------------
      ! Close 'FILTHO' file
      !---------------------------------------------------------------------
      Close(unit_tho)
      !--------------------------------------------------------------------------
      ! Deallocations
      !--------------------------------------------------------------------------
      Deallocate(id_tho,brin_tho)
      Deallocate(Nm_tho,nz_tho,nr_tho,nl_tho,ns_tho)
   End Subroutine WriteHFBTHO

 End Module hfodd_interface
